//last 4 digit
angularApp.filter('accountNumberYefi', function () {
    return function (input) {
        if (input && input != null && input != undefined) {
            var output;
            if (input.length > 4) {
                output = input.substring(input.length - 4);
                return output;
            } else {
                return input;
            }
        }
        else {
            return "";
        }
    }
});

//only '21-04-2023 11:21:56 AM' convert '23 Jan 2023, 11:01pm'
angularApp.filter('dateWithTime', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + date.substring(10);

            var newDate = new Date(newDate1);
            newDate = $filter('date')(newDate, 'dd MMM yyyy, hh:mm');

        }
        return newDate;
    }
});

//only '21-04-2023 11:21:56 AM' convert 'January 2023'
angularApp.filter('monthYear', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + date.substring(10);

            var newDate = new Date(newDate1);
            newDate = $filter('date')(newDate, 'MMMM yyyy');

        }
        return newDate;
    }
});


//only '21-04-2023 11:21:56 AM' convert 'January 2023'
angularApp.filter('monthYear', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + date.substring(10);

            var newDate = new Date(newDate1);
            newDate = $filter('date')(newDate, 'MMMM yyyy');

        }
        return newDate;
    }
});

//only AM and PM
angularApp.filter('AMPM', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + date.substring(10);

            var newDate = new Date(newDate1);
            newDate = $filter('date')(newDate, 'a');
            return newDate.toLowerCase();
        }

    }
});

//'Mar 28, 2023 6:11:49 PM' convert '23 Jan 2023, 11:01pm'
angularApp.filter('dateWithTimePre', function ($filter) {
    return function (date) {

        if (date) {
            var newDate = new Date(date);
            newDate = $filter('date')(newDate, 'dd MMM yyyy, hh:mm');

            var newDate1 = new Date(date);
            newDate1 = $filter('date')(newDate1, 'a');

            return newDate + newDate1.toLowerCase();
        }

    }
});

//only '2023-04-24 11:55:54 PM' convert '23 Jan 2023, 11:01pm'
angularApp.filter('dateWithTimeYrFirst', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate = startDate.split('-')[1] + '/' + startDate.split('-')[2] + '/' + startDate.split('-')[0] + date.substring(10);

            var newDate1 = new Date(newDate);
            newDate1 = $filter('date')(newDate1, 'dd MMM yyyy, hh:mm');

            var newDate2 = new Date(newDate);
            newDate2 = $filter('date')(newDate2, 'a');

        }
        return newDate1 + newDate2.toLowerCase();
    }
});

//only '21-04-2023 11:21:56 AM' convert '23 Jan 2023'
angularApp.filter('dateTransaction', function ($filter) {
    return function (date) {

        if (date) {
            var startDate = date.substring(0, 10);
            var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + date.substring(10);

            var newDate = new Date(newDate1);
            newDate = $filter('date')(newDate, 'dd MMM yyyy');

        }
        return newDate;
    }
});

angularApp.filter('capitalize', function () {
    return function (input) {
        if (input) {
            return input.replace(/\w\S*/g, function (txt) {
                return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
            });
        }

    }
});

//capitalize words
angularApp.filter('titleCase', function ($filter) {
    return function (input) {

        if (typeof input !== "string") {
            return input;
        }

        return (!!input) ? input.split(' ').map(function (wrd) {
            return wrd.charAt(0).toUpperCase() + wrd.substr(1).toLowerCase();
        }).join(' ') : '';

    }
});

//capitalize first letter in a string
angularApp.filter('sentenceCase', function ($filter) {
    return function (input) {

        if (typeof input !== "string") {
            return input;
        }

        return (angular.isString(input) && input.length > 0) ?
            input.charAt(0).toUpperCase() + input.substr(1).toLowerCase() : input;

    }
});

// minlength by including 0 prior
angularApp.filter('minLength', function ($filter) {
    return function (input, len) {

        input = input.toString();
        if (input.length >= len) return input;
        else return ("000000" + input).slice(-len);

    }
});