angularApp.service('APICUtils',
	function ($q, utilityService, ConnectivityMonitorUtils, constantConfig, encryptionService, loggedInUserService, $ionicPopup, cryptoService,  $rootScope, $filter) {

		var APICUtils = this;
		APICUtils.secretId = "";
		APICUtils.isAppTimedOut = false;
		APICUtils.isSessionExpired = false;
		APICUtils.URL_START_POINT = "https://yfei.sbiyono.sbi/yfei/prod/";
		APICUtils.METHOD = { "POST": "post", "GET": "get", "PUT": "put" };
        APICUtils.latestAndroidAppVersion = "";
		APICUtils.latestIOSAppVersion = "";
		APICUtils.yfeiClickStream = false;
		APICUtils.isUserLoggedIn = false;
        APICUtils.latitude = "";
		APICUtils.longitude = "";

		APICUtils.authScope = "yfei_api";
       

	
		APICUtils.postData = function (url, payLoad, isLoader, tokenRecieved) {
			var q = $q.defer();
			var isEncryptEnabled = true;
			APICUtils.callAPICResource(url, payLoad, isLoader, APICUtils.METHOD.POST, isEncryptEnabled, tokenRecieved).then(
				function (response) {
					
					q.resolve(response);
				},
				function (error) {
					
					q.reject(error);
				}
			);
			return q.promise;

		}

		APICUtils.getData = function (url, payLoad, isLoader) {
			var q = $q.defer();
			var isEncryptEnabled = false;
			APICUtils.callAPICResource(url, payLoad, isLoader, APICUtils.METHOD.GET, isEncryptEnabled).then(
				function (response) {
					
					q.resolve(response);
				},
				function (error) {
					
					q.reject(error);
				}
			);
			return q.promise;

		}

		//when json object data already encrypted
		APICUtils.postDataWithOutEncryption = function (url, payLoad, isLoader, tokenRecieved) {
			var q = $q.defer();
			var isEncryptEnabled = false;
			APICUtils.callAPICResource(url, payLoad, isLoader, APICUtils.METHOD.POST, isEncryptEnabled, tokenRecieved).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		}

			/**
			 *  Actual adapter resources are called using the below method
			 */
		APICUtils.callAPICResource = function (url, payLoad, isLoader, requestType, isEncryptEnabled, tokenRecieved, timeOutInMilliSeconds) {
			var sessionTimeout = '';

			sessionTimeout = constantConfig.SBITIMEOUT;

			var q = $q.defer();
			if (!utilityService.lastTimeStamp) {
				utilityService.lastTimeStamp = new Date();
			} else {
				var diff = Math.ceil(((new Date()) - utilityService.lastTimeStamp) / 60000);
				if (diff > sessionTimeout) {
					if (!APICUtils.isAppTimedOut) {
						APICUtils.isAppTimedOut = true;
						setTimeout(function () {
							reloadApp(constantConfig.apic.SESSION_TIMEOUT);
							return false;
						}, 300);


					}
				}
				utilityService.lastTimeStamp = new Date();
			}

			//Check spinner to be displayed or not
			if (isLoader) {
				utilityService.showSpinner();
			}

			//Check network connectivity 
			if (ConnectivityMonitorUtils.isOffline()) {
				q.reject({ "responseMessage": "Unable to connect to Internet. Please check your connectivity." });
				return q.promise;
			}
            var requestPayload = {};
			if (isEncryptEnabled) {
				
			    if(APICUtils.secretId){
					
				   if(url.includes("authorize") || url.includes("token")){
					  
					    requestPayload = payLoad; 
				   } 
				   else{
					   
                       requestPayload.reqParam = APICUtils.secretId + encryptionService.getAES256EncryptedData(JSON.stringify(payLoad));
				   }
				 
				  
				}
				else{
					
                    requestPayload = payLoad;
				}
				//
			} else {				
				requestPayload = payLoad; //uncomment later when encryption starts		
			}
			

		     
			var timestamp = $filter('date')(new Date(), 'dd MM yyyy HH:mm:ss:sss');
			var options = {};
			//setting headers
			var headerObj ={};
			
			headerObj = {
				"reqTimeStamp": timestamp, "mfpAppVersion": loggedInUserService.vesionNumber,
				"os": loggedInUserService.deviceOs, "osVersion": loggedInUserService.deviceVersion, "model": loggedInUserService.deviceModel,
				"appVersionDisplay": loggedInUserService.vesionNumber, "appVersionCode": (loggedInUserService.versionCode).toString(),
				"appStoreId": loggedInUserService.packageName, "lat" : (APICUtils.latitude).toString(), "long" : (APICUtils.longitude).toString()
			};
			 
			let tokenUrl = url.includes("token");
			if(tokenUrl){
			  headerObj.client_id = APICUtils.clientID;
			  
			  cordova.plugin.http.setHeader('Content-Type', 'application/x-www-form-urlencoded');
			  cordova.plugin.http.setDataSerializer("urlencoded");
		
			}
			else {
			
				
				 cordova.plugin.http.setHeader('Accept', 'application/json');
				 cordova.plugin.http.setHeader('Content-Type', 'application/json');		
				 if(tokenRecieved){ //if user logged in and received the token then handle
					  cordova.plugin.http.setHeader('Authorization', 'Bearer ' + loggedInUserService.accessToken);	
				 }
				  cordova.plugin.http.setDataSerializer("json");
			}
			
			
			options = {
					method: requestType,
					headers: headerObj
			}
           
			if (requestType == "post") {
				options.data = requestPayload; //uncomment later when encryption starts			
			}

			
            
			cordova.plugin.http.sendRequest(APICUtils.URL_START_POINT +url, options, function (response) {
				// prints 200
			
				
			
				if (isLoader) {
					utilityService.hideSpinner();
				}
				 
				if(url.includes("authorize") ||  url.includes("token")){ //right now not getting encrypted response for code also

				
						q.resolve(response.data);
				
				}
				else{
			   
				var res = JSON.parse(response.data);
                
				if(res.resParam){
			     var resObject = res.resParam;
                 var responseText; //uncomment later
					if (isEncryptEnabled) {
						
							responseText = utilityService.isJSON(resObject) ?  JSON.parse(resObject.replace(/{{/g, "")) :  JSON.parse(encryptionService.getAES256DecryptedData(resObject).replace(/{{/g, ""));
					} else {
							responseText =  JSON.parse(resObject.replace(/{{/g, ""));
					}
				}
				

				if (responseText && responseText.responseCode && responseText.responseCode == '0000') { //uncomment later
					q.resolve(responseText);
				} else {
					q.reject(responseText);
				}	
				}
				
			}, function (response) {
				console.log(response);
				if (isLoader) {
					utilityService.hideSpinner();
				}
				
				q.reject({ "responseMessage": getExceptionMessage(response) });
			},
			function (error) {
				if (isLoader) {
					utilityService.hideSpinner();
				}
				
				q.reject(error);
			}
			);
			return q.promise;
		}
		//needs to handle reload app 

		function reloadApp(message) {
			
			
			/*Condition not to show popup if session is expired and reloads automatically as suggested */
			if (message == constantConfig.apic.SESSION_TIMEOUT || message == constantConfig.adapter.SESSION_INACTIVITY) {
				APICUtils.logoutCustomer();
			}else {
				var reloadPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
					scope: '',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							reloadPopup.close();
							APICUtils.logoutCustomer();
						}
					}],
				});
			}
		}

		document.addEventListener("resume", onResume, false);

		function onResume() {
			var sessionTimeout = '';	
			sessionTimeout = constantConfig.SBITIMEOUT;			
			if (!utilityService.lastTimeStamp) {
				utilityService.lastTimeStamp = new Date();
			} else {
				var diff = Math.ceil(((new Date()) - utilityService.lastTimeStamp) / 60000);
				if (diff > sessionTimeout) {
					if (!APICUtils.isAppTimedOut) {
						APICUtils.isAppTimedOut = true;
						reloadApp(constantConfig.apic.SESSION_TIMEOUT);
						return false;
					}
				}
			}
		}

		APICUtils.logoutCustomer = function () {
			
			if (APICUtils.isUserLoggedIn) {
				APICUtils.clearSessionId();
				APICUtils.userLogout().then(
					function (data) {
					console.log(data);
					},
					function (error) {
						console.log(error.responseMessage);
					}
				);
			}
			else {
				window.location = $rootScope.initialLocation;
			}
		}
		APICUtils.clearSessionId = function () {
			APICUtils.secretId = "";
			window.location = $rootScope.initialLocation;
		}

		APICUtils.userLogout = function () {
			var q = $q.defer();
			APICUtils.postData("v1/apic/logout", {}, true, true).then(function (response) {
				
				q.resolve(response);
			},
				function (error) {
					
					q.reject(error);
				});
			return q.promise;
		};

		function getExceptionMessage(errorRes) {
			
			var messageToBedisplayed = "";
			var errorLog = "";
			if(isJsonString(errorRes.error))
			{
				 errorLog = JSON.parse(errorRes.error);}
			else{
				errorLog = errorRes.error;
			}
			
			
			
			//apic error messages
			if (errorLog.httpCode) {
				if (errorLog.httpCode == "503") //apic service offline down
				{
					messageToBedisplayed = "A503 - " + errorLog.httpMessage;
				}
				else {
					messageToBedisplayed = errorLog.httpMessage;
				}
			}		
			else if (errorRes.status == 500) {
				messageToBedisplayed = "A500 - " + constantConfig.apic.TECHNICAL_ERROR;
			} else if (errorRes.status === 404) {
				messageToBedisplayed = "A404 -" + constantConfig.apic.TECHNICAL_ERROR;
			} else if (errorRes.status == "-4" || errorRes.status == "-1" || errorRes.status == -1) {
				messageToBedisplayed = constantConfig.apic.REQUEST_TIMEOUT;
			}
			else if(errorLog.responseMessage)
			{
				if (errorLog.responseCode == "0400") {
                    APICUtils.secretId = "";
                    ionic.Platform.exitApp();
					return;
				}
				else {
				messageToBedisplayed = errorLog.responseMessage;
				}
			}
		    else {
				messageToBedisplayed = constantConfig.apic.TECHNICAL_ERROR;
			}

			return messageToBedisplayed.toString();
		}
		var isJsonString = function (str) {
			try {
				JSON.parse(str);
			} catch (e) {
				return false;
			}
			return true;
		}
		return APICUtils;
	});