'use strict';

//The angular app is initialized from here
var angularApp = angular.module('app', ['ngSanitize', 'pascalprecht.translate', 'ionic', 'ngAnimate', 'ui.router', 'ngCordova', 'rzModule', 'ionic-datepicker', 'ion-floating-menu', 'angularjs-dropdown-multiselect', 'ionic-toast', 'angular.filter', 'utf8-base64', 'nzToggle','ionic-pullup','ionic-monthpicker','ngDraggable',  'ion-digit-keyboard','morphCarousel','ui.bootstrap']);

angularApp.init = function () {
	angular.bootstrap(document, ['app']);
};

angularApp.config(function (ionicDatePickerProvider) {
	var datePickerObj = {
		inputDate: new Date(),
		titleLabel: 'Select a Date',
		setLabel: 'OK',
		closeLabel: 'Back',
		mondayFirst: false,
		weeksList: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
		monthsList: ["JANUARY", "FEBRUARY", "MARCH", "APRIL", "MAY", "JUNE", "JULY", "AUGUST", "SEPTEMBER", "OCTOBER", "NOVEMBER", "DECEMBER"],
		templateType: 'popup',
		showTodayButton: false,
		dateFormat: 'dd MMM yyyy',
		closeOnSelect: false,
		disableWeekdays: []
	};
	ionicDatePickerProvider.configDatePicker(datePickerObj);
});
angularApp.run(function ($ionicPlatform, $state, $rootScope, $ionicPopup, AdapterUtils, utilityService, internetBankingService, loggedInUserService, keyGuardService, ConnectivityMonitorUtils, constantConfig,$translate,agriMandiService,mPinLoginService,ompOffersService,homeScreenService, irctcService, ompMerchantsService, clickStreamService,getAccountDetailsService,cryptoService) {

		// Start of landing first time check wifi Unsecured WIFI CR:

		var continueWithoutCheckingWIFI = false;
		
		var isSwitchToAppSetting = false;
		function locationDeny() {
			$ionicPopup.alert({
				template: '<div class="alertSysmbol"><img class="approvedIconPosition1" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="popupTextBottomPadding1"><div class="textAlignCenter"><span translate="ALERT_USER_FOR_APP_LOCATION_PERMISSION"></span></div></div></div>', //template,
				cssClass: 'wifi-alert-popup virtualCCSelectBtns',
				buttons: [
					{
						text: "Exit",
						type: 'button-negative',
						onTap: function () {
							saveAuditLogs("location_deny_exit");
							setTimeout(function () {
								navigator.app.exitApp();
							}, 200)
						}
					},
					{
						text: "Go to Permission Setting",
						type: 'button-positive',
						onTap: function () {
							cordova.plugins.diagnostic.switchToSettings(function (success) {
								// console.log("Successfully switched to Settings app" + success);
								isSwitchToAppSetting = true;
								callOnOnlineLanding();
							}, function (error) {
								console.error("The following error occurred: " + error);
							});
						}
					},
					{
						text: "Continue Without Checking WIFI security",
						type: 'button-negative',
						onTap: function () {
							saveAuditLogs("continue_without_checking_wifi_security");
							continueWithoutCheckingWIFI = true;
						}
					}
				],
			});
		}
		
		function appLocation() {
			var permissions = cordova.plugins.permissions;
			permissions.checkPermission(permissions.ACCESS_FINE_LOCATION, function (status) {
				// console.log(status);
				if (!status.hasPermission) {
					permissions.requestPermission(permissions.ACCESS_FINE_LOCATION, function (status) {
						// console.log(status);
						if (!status.hasPermission) {
							// console.log("!status.hasPermission");
							locationDeny();
						} else {
							callOnOnlineLanding();
						}
					}, function (error) {
						console.log("error", error);
					});
				} else {
					// console.log("OnOnline being called from appLocation");
					callOnOnlineLanding();
				}
			}, function (error) {
				console.log("error", error);
			});
		}

		

		$rootScope.checkLocationPermission = function () {
			console.log("check location permission");
			var type = navigator.connection.type;
			// console.log("type>>", type);
			// console.log("platform>>", utilityService.isAndroidPlatform());
			if (utilityService.isAndroidPlatform()) {
				window.WifiWizard.startScan(function (success, err) {
					console.log("success<-->err", success, err);
				});
				if (type === Connection.WIFI) { appLocation(); }
				else { callOnOnlineLanding(); }
			}
		}
		
		function checkLocationPermission() {
			var type = navigator.connection.type;
			// console.log("type>>", type);
			// console.log("platform>>", utilityService.isAndroidPlatform());
			if (utilityService.isAndroidPlatform()) {
				window.WifiWizard.startScan(function (success, err) {
					console.log("success<-->err", success, err);
				});
				if (type === Connection.WIFI) { appLocation(); }
				else { callOnOnlineLanding(); }
			}
		}
		
		function callOnOnlineLanding() {
			if (isSwitchToAppSetting) { isSwitchToAppSetting = false; appLocation(); }
			else {
				// console.log("In function")
				var type = navigator.connection.type;
				// console.log("type>>", type);
				window.WifiWizard.startScan(function (success, err) {
					console.log("success<-->err", success, err);
				});
				if (type === Connection.WIFI) {
					cordova.plugins.locationAccuracy.canRequest(function (canRequest) {
						// console.log("canRequest>>>", canRequest);
						requestLocationLandingNotMandatory();
					}, function (error) {
						// console.log("errrrr>>>", error);
						cordova.plugins.locationAccuracy.canRequest(function (canRequest) {
							console.log("canRequest>>>", canRequest);
						});
					});
				}
				else {
					console.log("in cellular");
				}
			}
		
		}
		
		function requestLocationLandingNotMandatory() {
			cordova.plugins.locationAccuracy.request(function (success) {
				// console.log("sucess>>", success);
				window.WifiWizard.getScanResults(function (scanResults, err) {
					// console.log("scanResults>>", scanResults);
					if (scanResults) {
						function getSSID() {
							function ssidHandler(s) {
								var ssid = s;
								ssid = ssid.replace(/['"]+/g, "");
								var data = scanResults.filter((res) => res.SSID.includes(ssid));
								if (data.length > 0) {
									var auth = data[0].capabilities;
									auth = auth.replace(/[[\]]/g, " ");
									auth = auth.replace(/[- )(]/g, " ");
									if (auth.includes("WPA")) {
										console.log("wifi is secure");
									}
									else {
										console.log("wifi is not secure");
										$ionicPopup.alert({
											templateUrl: 'common/directives/templates/unsecuredwifi_popup.html',
											cssClass: 'wifi-alert-popup virtualCCSelectBtns',
											buttons: [
												{
													text: "NO",
													type: 'button-positive',
													onTap: function () {
														saveAuditLogs("unsecure_exit");
														setTimeout(function () {
															navigator.app.exitApp();
														}, 200)
													}
												},
												{
													text: "YES",
													type: 'button-negative',
													onTap: function () {
														saveAuditLogs("unsecure_continue");
													}
												}
											],
										});
									}
								}
							}
							function fail(e) {
								console.log("e>>>", e);
							}
							window.WifiWizard.getCurrentSSID(ssidHandler, fail);
						}
						getSSID();
					}
				});
			}, function (error) {
				$ionicPopup.alert({
					templateUrl: 'common/directives/templates/checkwifipermission_popup.html',
					cssClass: 'wifi-alert-popup virtualCCSelectBtns',
					buttons: [
						{
							text: "Exit",
							type: 'button-negative',
							onTap: function () {
								saveAuditLogs("location_permission_exit");
								setTimeout(function () {
									navigator.app.exitApp();
								}, 200)
							}
						},
						{
							text: "Continue to check WIFI Security",
							type: 'button-positive',
							onTap: function () {
								saveAuditLogs("location_permission_proceed");
								callOnOnlineLanding();
							}
						},
						{
							text: "Continue without checking WIFI security",
							type: 'button-negative',
							onTap: function () {
								continueWithoutCheckingWIFI = true;
								saveAuditLogs("location_permission_continue_without_checking");
							}
						}
					],
				});
			}, cordova.plugins.locationAccuracy.REQUEST_PRIORITY_HIGH_ACCURACY);
		}
		// End of landing first time check wifi Unsecured WIFI CR.
		
		
		// Start of app.js wifi Unsecured WIFI CR:
		
		var appState = false;
		var networkChanged = false;
		var isPopupOpen = false;
		document.addEventListener("pause", function () {
			appState = true;
		}, false)
		
		document.addEventListener("resume", function () {
			appState = false;
			if (networkChanged === true) {
				callOnOnline();
			}
		}, false)
		
		document.addEventListener("online", function () {
			networkChanged = false;
			$rootScope.$apply(function () {
				if (utilityService.isAndroidPlatform()) {
					var type = navigator.connection.type;
					window.WifiWizard.startScan(function (success, err) {
						console.log("success<-->err", success, err);
					});
					if (type === Connection.WIFI) {
						networkChanged = true;
					}
					if (appState === false) {
						callOnOnline();
					}
				}
			})
		}, false);
		
		function callOnOnline() {
			// console.log("continueWithoutCheckingWIFIAPPJS", continueWithoutCheckingWIFI);
			if (continueWithoutCheckingWIFI === false) {
				networkChanged = false;
				var type = navigator.connection.type;
				// console.log("type>>", type);
				window.WifiWizard.startScan(function (success, err) {
					console.log("success<-->err", success, err);
				});
				if (type === Connection.WIFI) {
					cordova.plugins.locationAccuracy.canRequest(function (canRequest) {
						// console.log("canRequest>>>", canRequest);
						requestLocationNotMandatory();
					});
				}
			}
		}
		
		function requestLocationNotMandatory() {
			cordova.plugins.locationAccuracy.request(function (success) {
				// console.log("sucess>>", success);
				// console.log("location_granted");
				window.WifiWizard.getScanResults(function (scanResults, err) {
					// console.log("scanResults>>>", scanResults);
					if (scanResults) {
						function getSSID() {
							function ssidHandler(s) {
								var ssid = s;
								ssid = ssid.replace(/['"]+/g, "");
								var data = scanResults.filter((res) => res.SSID.includes(ssid));
								if (data.length > 0) {
									var auth = data[0].capabilities;
									auth = auth.replace(/[[\]]/g, " ");
									auth = auth.replace(/[- )(]/g, " ");
									if (auth.includes("WPA")) {
										console.log("wifi is secure");
									}
									else {
										console.log("wifi is not secure");
										if (isPopupOpen === false) {
											isPopupOpen = true;
											$ionicPopup.alert({
												templateUrl: 'common/directives/templates/unsecuredwifi_popup.html',
												cssClass: 'wifi-alert-popup virtualCCSelectBtns',
												buttons: [
													{
														text: "NO",
														type: 'button-positive',
														onTap: function () {
															isPopupOpen = false;
															saveAuditLogs("unsecure_exit");
															if (loggedInUserService.isLoggedInDetails.isLoggedIn) {
																setTimeout(function () {
																	loggedInUserService.logoutUser(true);
																}, 200)
															}
															else {
																setTimeout(function () {
																	navigator.app.exitApp();
																}, 200)
															}
														}
													},
													{
														text: "YES",
														type: 'button-negative',
														onTap: function () {
															isPopupOpen = false;
															saveAuditLogs("unsecure_continue");
														}
													}
												],
											});
										}
									}
								}
							}
							function fail(e) {
								console.log("e>>>", e);
							}
							window.WifiWizard.getCurrentSSID(ssidHandler, fail);
						}
						getSSID();
					}
				});
			}, function (error) {
				if (error.code !== -1) {
					// console.log("location_denied");
					$ionicPopup.alert({
						templateUrl: 'common/directives/templates/checkwifipermission_popup.html',
						cssClass: 'wifi-alert-popup virtualCCSelectBtns',
						buttons: [
							{
								text: "Exit",
								type: 'button-negative',
								onTap: function () {
									saveAuditLogs("location_permission_exit");
									if (loggedInUserService.isLoggedInDetails.isLoggedIn) {
										setTimeout(function () {
											loggedInUserService.logoutUser(true);
										}, 200)
									}
									else {
										setTimeout(function () {
											navigator.app.exitApp();
										}, 200)
									}
								}
							},
							{
								text: "Continue to check WIFI Security",
								type: 'button-positive',
								onTap: function () {
									saveAuditLogs("location_permission_proceed");
									callOnOnline();
								}
							},
							{
								text: "Continue without checking WIFI security",
								type: 'button-negative',
								onTap: function () {
									continueWithoutCheckingWIFI = true;
									saveAuditLogs("location_permission_continue_without_checking");
								}
							}
						],
					});
				}
			}, cordova.plugins.locationAccuracy.REQUEST_PRIORITY_HIGH_ACCURACY);
		}
		
		function saveAuditLogs(action) {
			var payload = {};
		
			if (getAccountDetailsService.accountOverviewData.customerInformation !== undefined) {
				var cif = getAccountDetailsService.accountOverviewData.customerInformation.cif;
				payload = {
					journeyName: "UnsecuredWIFI",
					auditText: device.uuid + "," + action + "," + (new Date()).toString() + "," + cif
				}
		
				var hashedkey = (cryptoService.getSHA512EncryptedData(payload.journeyName + payload.auditText + "/auditReq")).toString();
				payload.validateReq = hashedkey;
				// console.log("payloadApp>>>>", payload);
				AdapterUtils.postData("adapters/CommonAdapter/saveAuditLogsUnsecuredWifiP", payload, false).then(function (response) {
					console.log('audit logs saved');
				}, function (error) {
					console.log('audit logs not saved');
					if (error && error.responseCode === '0400') {
						console.log('audit logs not saved error');
					}
				});
			}
			else {
				var cif = ' ';
		
				payload = {
					journeyName: "UnsecuredWIFI",
					auditText: device.uuid + "," + action + "," + (new Date()).toString() + "," + cif
				}
		
				var hashedkey = (cryptoService.getSHA512EncryptedData(payload.journeyName + payload.auditText + "/auditReq")).toString();
				payload.validateReq = hashedkey;
				// console.log("payloadApp>>>>", payload);
				AdapterUtils.postData("adapters/CommonAdapter/saveAuditLogsUnsecuredWifi", payload, false).then(function (response) {
					console.log('audit logs saved');
				}, function (error) {
					console.log('audit logs not saved');
					if (error && error.responseCode === '0400') {
						console.log('audit logs not saved error');
					}
				});
			}
		
		}
		// End of app.js wifi Unsecured WIFI CR.
	

	if(ionic.Platform.isIPad()){
		var viewport = document.querySelector("meta[name=viewport]");
		viewport.setAttribute('content', 'user-scalable=no, initial-scale=0.85, maximum-scale=1, minimum-scale=0.85, width=device-width');
	}
	var that = this;
	// Android back button handling
	$rootScope.initialLocation = window.location.href;

	$rootScope.$on('$stateChangeStart', 
	function(event, toState, toParams, fromState, fromParams){
	    if(toParams.agri)
	    {
	    	$translate.use(agriMandiService.selectLanguage);
	    }
	    else
	    {
	    	$translate.use('en');
	    }
	});

	$ionicPlatform.registerBackButtonAction(function () {
		var backPopup = $ionicPopup.show({
			title: null,
			cssClass: 'my-custom-popup',
			template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="EXIT_APP"></div>',
			scope: that,
			buttons: [{
				text: 'YES',
				type: 'button-assertive',
				onTap: function () {
					loggedInUserService.exitApplication();
				}
			},
			{
				text: 'NO',
				type: 'button-assertive',
				onTap: function () {
					backPopup.close();
				}
			}],
		});

	}, 100);

	var db=null;
	if (utilityService.isAndroidPlatform()) {
		db = window.sqlitePlugin.openDatabase({
											  name: 'my.db',
											  location:'default',
											  });
		
		} else {
		db = window.sqlitePlugin.openDatabase({name: 'my.db', iosDatabaseLocation: 'Library'});
	}
	
	/* Push notification initialization */
	var initiliazePush = function () {
		// Push notification handling in case app is not opened from notification, assuming app will initialize completely in 4 seconds, 
		// giving notification receiver enough time to handle incoming data otherwise.
		setTimeout(function () {
			localStorage.setItem('showNotification', 'false')
		}, 4000);
		irctcService.pushNotificationData = '';
		try {
			$rootScope.appIsRunning = false;
			MFPPush.initialize(
				function (successResponse) {
					WL.Logger.debug("Successfully intialized");
					MFPPush.registerNotificationsCallback($rootScope.notificationReceived);
					$state.go('menu.landingPage');
				}, function (failureResponse) {
					WL.Logger.debug("Failed to initialize");
					$state.go('menu.landingPage');
				});
		}
		catch (err) {
			console.log(err);
		}

	
}

	function formatDate(date) {
		var d = new Date(date),
			month = '' + (d.getMonth() + 1),
			day = '' + d.getDate(),
			year = d.getFullYear();
		if (month.length < 2) month = '0' + month;
		if (day.length < 2) day = '0' + day;
		return [year, month, day].join('-');
	}

	function redirectToOfferPage(){
		ompOffersService.fromPush=true;
		ompOffersService.notificationRecieved=true;
		if(ompOffersService.fromPush)
		{
			ompOffersService.fromPush=false;
			if(mPinLoginService.isLoggedIn === true){
				ompOffersService.notificationRecieved=false;
			}
			else{
				homeScreenService.menuOption="ompOffers";
				if (homeScreenService.dummymenuCheck == true) {
					$state.go('menu.menudummy');
				}
				else {
					$state.go('menu.ompOffers');
				}
			}
		} 
			else{
			$state.go('menu.landingPage');
			}
	}
	function redirectToIRCTCPage(payload) {
		irctcService.pushNotificationData = payload;
		ompOffersService.irctcNotificationRecieved = true;
		ompOffersService.fromPush = false;
		const showNotification = localStorage.getItem('showNotification');
		console.log('Do we show notifcation: ' + showNotification);
		if (mPinLoginService.isLoggedIn === true) {
			utilityService.hideSpinner();
			ompOffersService.irctcNotificationRecieved = false;
		}
		else {
			homeScreenService.menuOption = "irctcNotification";
			utilityService.hideSpinner();
			if (payload.isTargeted) {
				irctcService.selTab = "Y";

			}
		}

	}

	function initDatabase(data) {
		utilityService.showSpinner();
		ompMerchantsService.CTAPushData = {};
		ompMerchantsService.CTAPush = false;
		if (data && "string" == typeof (data.payload)) {
			data.payload = JSON.parse(data.payload);
		}
		if (data.payload.pushType === "CTA") {   // check for CTA Push Notification 
			if (utilityService.isAndroidPlatform()) {
				if ($rootScope.appIsRunning && AdapterUtils.secretData != "") {
					utilityService.hideSpinner();
					return;
				} else {
					if ($rootScope.appIsRunning && AdapterUtils.secretData != "" && mPinLoginService.isLoggedIn) {
						utilityService.hideSpinner();
						return;
					}
				}
			}
			if (data.payload.redirectionType == "MERCHANT") {
				if (data.payload.login == "true") {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CTA_PUSH_POST_LOGIN_" + data.payload.redirectionType + "_" + data.payload.affiliateId));
				} else {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CTA_PUSH_PRE_LOGIN_" + data.payload.redirectionType + "_" + data.payload.affiliateId));
				}
			} else {
				if (data.payload.login == "true") {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CTA_PUSH_POST_LOGIN_" + data.payload.redirectionType + "_" + data.payload.categoryCode));
				} else {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CTA_PUSH_PRE_LOGIN_" + data.payload.redirectionType + "_" + data.payload.categoryCode));
				}
			}
			loggedInUserService.productClicked = "";
			ompMerchantsService.CTAPush = true;
			if (data.payload.login == "true") {
				ompMerchantsService.isPushLoginFlagEnabled = true;
			} else {
				ompMerchantsService.isPushLoginFlagEnabled = false;
			}
			ompMerchantsService.CTAPushData = data.payload;  // capture push payload data
			utilityService.hideSpinner(); 
            $state.go('menu.landingPage');
		} else if (data.payload && (data.payload.fromStn != undefined && data.payload.fromStn != null && data.payload.fromStn != "")) {
			setTimeout(function () {
				redirectToIRCTCPage(data.payload);
			}, 1000);
		} else {
			db.transaction(function (transaction) {
				transaction.executeSql('CREATE TABLE IF NOT EXISTS OfferTable (headerTxt, logoUrl,headerDetails,expiryDate date,redirectUrl,tnc,nid,buttonTxt,promoCode,publishDate,categoryCode,categoryTitle)', [], function () {
					utilityService.hideSpinner();
					var payloadDataFormat = data.payload;
					var payloadData = JSON.parse(JSON.stringify(payloadDataFormat).replace(/\\/g, ""));
					var currentDate = formatDate(new Date());
					if (payloadData.isTargeted) {
						if (payloadData.expiryDate < currentDate) {
							ompOffersService.isOfferExpired = true;
							redirectToOfferPage();
						}
						else {
							utilityService.showSpinner();
							db.transaction(function (transaction) {
								transaction.executeSql('INSERT INTO OfferTable VALUES (?,?,?,?,?,?,?,?,?,?,?,?)', [payloadData.headerTxt, payloadData.logoUrl, payloadData.headerDetails, payloadData.expiryDate, payloadData.redirectUrl, payloadData.tnc, payloadData.nid, payloadData.buttonTxt, payloadData.promoCode, payloadData.publishDate, payloadData.categoryCode, payloadData.categoryTitle], function () {
									utilityService.hideSpinner();
									redirectToOfferPage();
								});
							}, function (error) {
								utilityService.hideSpinner();
							});
						}
					}
					else if (payloadData.isTargeted === false) {
						if (payloadData.expiryDate < currentDate) {
							ompOffersService.isOfferExpired = true;
						}
						redirectToOfferPage();
					}
				});
			}, function (error) {
				utilityService.hideSpinner();
			});
		}
		// Push notification handling in case notification is not IRCTC
		setTimeout(function () {
			localStorage.setItem('showNotification', 'false');
		}, 2000);
	}

	$rootScope.notificationReceived = function (data) {
		utilityService.showSpinner();
		homeScreenService.dummymenuCheck = true;
		utilityService.hideSpinner();
		initDatabase(data);
	}

	initiliazePush();
	ompMerchantsService.isPushLoginFlagEnabled = false;
    ompMerchantsService.CTAPush = false;
	/*End Push notification initialization */

	cordova.plugins.Keyboard.disableScroll(true);
	if (device.platform != "windows") {
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
	}
});