'use strict';

angularApp.controller('redirectionalDisclamerCtrl', [
    "$state",
    "$scope",
    "ompMerchantsService",
     "$window",
    "$ionicHistory",
    "utilityService",
    "mPinLoginService",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "$ionicPopup",
    "$ionicSlideBoxDelegate",
    "homeScreenService",
    "$ionicScrollDelegate",
    "irctcService",
    "paclService",
    "homeLoanService", "loggedInUserService", "cryptoService", "$translate", "$timeout", "$anchorScroll", "$location",
    "quickPayService", "$ionicPopover", "internetBankingService", "ConnectivityMonitorUtils", "constantConfig", "$rootScope", "$ionicPlatform","registerWithSimService","ompOffersService",
    function ($state,
        $scope,
        ompMerchantsService,
        $window,
        $ionicHistory,
        utilityService,
        mPinLoginService,
        clickStreamService,
        $ionicSideMenuDelegate,
        $ionicPopup, $ionicSlideBoxDelegate, homeScreenService, $ionicScrollDelegate, irctcService, paclService, homeLoanService, loggedInUserService, cryptoService, $translate, $timeout, $anchorScroll, $location,
        quickPayService, $ionicPopover, internetBankingService, ConnectivityMonitorUtils, constantConfig, $rootScope, $ionicPlatform,registerWithSimService, ompOffersService) {
        var isWebviewLoadingCanceled = false;
        var redirectionDisclaimerVm = this;
        $scope.selectBoxOpened = true;
        $scope.showDisclaimerError=false;
        //authUser
        redirectionDisclaimerVm.keystoreValue = loggedInUserService.keystoreValue;
        redirectionDisclaimerVm.mpinErrorMsgFlag = false;
        redirectionDisclaimerVm.isLoginBtnClicked = false;
        ompMerchantsService.redirectUrlModif = false;
        ompMerchantsService.pseudoId = "";
        redirectionDisclaimerVm.userAuthPopoverTemplate = quickPayService.userAuthPopoverTemplateOmp("", "redirectionDisclaimerVm");
        $scope.popover = $ionicPopover.fromTemplate(redirectionDisclaimerVm.userAuthPopoverTemplate, {
            scope: $scope
        });

        function initPage() {
            $translate(['YQP_USERNAME', 'YQP_PASSWORD']).then(function (translations) {
                redirectionDisclaimerVm.usernameTxt = translations['YQP_USERNAME'];
                redirectionDisclaimerVm.passwordTxt = translations['YQP_PASSWORD'];
            });
            redirectionDisclaimerVm.isImageAvl = false;
            redirectionDisclaimerVm.toggle.checked = false;
            redirectionDisclaimerVm.isFingerprintAvl = quickPayService.isFingerprintAviFlag;
            redirectionDisclaimerVm.isMpinSet = loggedInUserService.mpinConsent;
            $scope.passLenLimitReached = false;
            if (!redirectionDisclaimerVm.isMpinSet) {
                redirectionDisclaimerVm.toggle.checked = true;
            }
            if (quickPayService.customerInfo != '')
                redirectionDisclaimerVm.accountList = quickPayService.customerInfo.accounts;
            quickPayService.isFingerprintAvailable().then(function (response) {
                redirectionDisclaimerVm.isFingerprintAvl = response.responseMessage;
            }, function (error) {
                console.log(error);
            });
            redirectionDisclaimerVm.bio_text = "";
            if (quickPayService.isBiometricType == 'face') {
                redirectionDisclaimerVm.bio_text = "Face ID";
            } else {
                redirectionDisclaimerVm.bio_text = "Touch ID";
            }
            $translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG'], { FIELD_1: redirectionDisclaimerVm.bio_text }).then(function (translations) {
                redirectionDisclaimerVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                redirectionDisclaimerVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                redirectionDisclaimerVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
            if (!redirectionDisclaimerVm.isImageAvl) {
                var full_name = localStorage.getItem("customername");
                if (full_name != "" && full_name !== null) {
                    var name_array = full_name.split(" ");
                    var first_initial = name_array[0].charAt(0);
                    var last_initial = name_array[name_array.length - 1].charAt(0);
                    redirectionDisclaimerVm.customerNameInitials = first_initial + last_initial;
                    redirectionDisclaimerVm.customerFirstName = full_name;
                }
                else {
                    redirectionDisclaimerVm.customerNameInitials = "";
                    redirectionDisclaimerVm.customerFirstName = "";
                }
            }
        }

        $scope.openPopover = function ($event) {
            redirectionDisclaimerVm.authFailure = false;
            $scope.popover.show($event);
            redirectionDisclaimerVm.isFingerprintAvl = false;
            redirectionDisclaimerVm.isFingerprintAvlDevice = false;
            quickPayService.isFingerprintAvailable().then(function (response) {
                redirectionDisclaimerVm.isFingerprintAvlDevice = true;
                var fingerprintToken = "";
                cordova.plugins.SecureKeyStore.get(function (res) {
                    fingerprintToken = res;
                    if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                        redirectionDisclaimerVm.isFingerprintAvl = false;
                    } else {
                        redirectionDisclaimerVm.isFingerprintAvl = true;
                        //to auto populate fingerprint option
                        redirectionDisclaimerVm.checkBiometric();
                    }
                }, function (error) {
                    console.log(error);
                }, loggedInUserService.deviceInfo);
            }, function (error) {
                    console.log(error);
            });
        };
        $scope.closePopover = function ($event) {
            $scope.popover.hide();
        };

        $scope.$on('$destroy', function () {
            $scope.popover.hide();
            $scope.popover.remove();
        });

        $scope.clearMpin = function () {
            for (var iterate = 0; iterate <= 5; iterate++) {
                $scope.doErase();
            }
        }

        redirectionDisclaimerVm.popoverBbackdrop = function () {
            var backDrop = document.getElementsByClassName("popover-backdrop");
            if (backDrop && backDrop[0]) {
                backDrop[0].setAttribute("style", "background-color: rgba(0, 0, 0, 0.7) !important;");
            }
        }

        redirectionDisclaimerVm.toggle = function () {
            $scope.hideKeyboard();
            if (redirectionDisclaimerVm.toggle.checked) {
                var userAuthModalICId = document.getElementById("userAuthModalICId");
                if (userAuthModalICId) {
                    userAuthModalICId.setAttribute("style", "bottom:0px !important;");
                }
            }
        }

        redirectionDisclaimerVm.checkBiometric = function () {
            if (quickPayService.isFingerprintAviFlag && !redirectionDisclaimerVm.authfailure) {
                var encryptConfig = {
                    clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                    clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                    disableBackup: true,
                };
                Fingerprint.show(encryptConfig, successCallback, errorCallback);
            }
        }

        function successCallback(result) {
                //call service to Auth
                authByBiometric();
        }

        function errorCallback(error) {
            console.log(error);
        }

        function authByBiometric() {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (redirectionDisclaimerVm.isSimChanged || redirectionDisclaimerVm.simList == undefined || redirectionDisclaimerVm.simList.length == 0)) {
                if (redirectionDisclaimerVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (redirectionDisclaimerVm.simList == undefined || redirectionDisclaimerVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var hasedSimInfo = "";
            if(utilityService.isAndroidPlatform()){
                hasedSimInfo = redirectionDisclaimerVm.hasedSimInfo ? redirectionDisclaimerVm.hasedSimInfo : "";
            }
            var params = { 'type': 'biometric', 'source': 'omp', "simId": hasedSimInfo.toString() };
            //call service to retrieve token at adapter
            quickPayService.userAuthentication(params).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOSUCCESS"));
                afterUserAuthSuccess(data);
            }, function (error) {
                redirectionDisclaimerVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYBIOFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    redirectionDisclaimerVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
                }
            });
        }

        redirectionDisclaimerVm.loginWithMpin = function () {
            if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (redirectionDisclaimerVm.isSimChanged || redirectionDisclaimerVm.simList == undefined || redirectionDisclaimerVm.simList.length == 0)) {
                if (redirectionDisclaimerVm.isSimChanged)
                    registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
                else if (redirectionDisclaimerVm.simList == undefined || redirectionDisclaimerVm.simList.length == 0)
                    utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                return;
            }
            var newMpin = redirectionDisclaimerVm.first.trim() +
                redirectionDisclaimerVm.second.trim() +
                redirectionDisclaimerVm.third.trim() +
                redirectionDisclaimerVm.fourth.trim() +
                redirectionDisclaimerVm.fifth.trim() +
                redirectionDisclaimerVm.sixth.trim();
            if (newMpin.length == 6) {
                if (ConnectivityMonitorUtils.isOffline()) {
                    redirectionDisclaimerVm.emptyValues();
                    $scope.clearMpin();
                    /*login flow improvement*/
                    var inputElement = document.getElementById('InputTxt1');
                    inputElement.disabled = false;
                    utilityService.offlineAlert();
                    return;
                }
                var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = redirectionDisclaimerVm.hasedSimInfo ? redirectionDisclaimerVm.hasedSimInfo : "";
				}
                var requestParams = {
                    "mPinNumber": newMpin,
                    "type": "mpin",
                    "source": "omp",
                    "simId": hasedSimInfo.toString(),
                    "simSubId" : redirectionDisclaimerVm.simSubscriptionId
                };
                quickPayService.userAuthentication(requestParams).then(function (data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINSUCCESS"));
                    $scope.hideKeyboard();
                    afterUserAuthSuccess(data);
                    redirectionDisclaimerVm.emptyValues();
                    $scope.passLenLimitReached = false;
                    $scope.clearMpin();
                }, function (error) {
                    $scope.passLenLimitReached = false;
                    redirectionDisclaimerVm.emptyValues();
                    $scope.clearMpin();
                    redirectionDisclaimerVm.enabledThisInput(1);
                    redirectionDisclaimerVm.authFailure = true;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYMPINFAIL"));
                    if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                        redirectionDisclaimerVm.authFailure = false;
                        utilityService.showForcePasswordPopup(error.responseMessage, "");
                    } else {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
                    }
                });
            } else {
                redirectionDisclaimerVm.emptyValues();
                $scope.clearMpin();
                redirectionDisclaimerVm.enabledThisInput(1);
                redirectionDisclaimerVm.authFailure = true;
                quickPayService.showAuthFailurePopup('error', 'Please Enter 6 digit valid MPIN', '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
            }
        };

        redirectionDisclaimerVm.changeInput = function ($event, index) {
            cordova.plugins.Keyboard.close();
            /*login flow improvements*/
            if (loggedInUserService.isServerConnected) {
                redirectionDisclaimerVm.loginWithMpin();
            }
        }

        redirectionDisclaimerVm.enabledThisInput = function (index) {
            try {
                redirectionDisclaimerVm.mpinErrorMsgFlag = false;
                for (var i = 1; i <= 6; i++) {
                    var inputElement = document.getElementById('InputTxt' + i);
                    if (index == i) {
                        inputElement.disabled = false;
                        inputElement.style = "border-bottom:1px solid #0095da !important;"
                    } else {
                        inputElement.disabled = true;
                        inputElement.style = "border-bottom:1px solid #bcbebf !important;"
                    }
                }
            } catch (err) { console.log(err); }
        }

        redirectionDisclaimerVm.authenticate = function () {
            redirectionDisclaimerVm.userLoginErrorFlag = false;
            redirectionDisclaimerVm.isLoginBtnClicked = true;
            if (redirectionDisclaimerVm.userName && redirectionDisclaimerVm.pswd) {
                redirectionDisclaimerVm.isLoginBtnClicked = false;
                utilityService.showSpinner();
                internetBankingService.getServiceIdAndKey().then(function (data) {
                    loggedInUserService.keyIdINB = data.keyId;
                    loggedInUserService.serviceIdINB = data.serviceId;
                    loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(redirectionDisclaimerVm.userName, redirectionDisclaimerVm.pswd);
                    utilityService.hideSpinner();
                    redirectionDisclaimerVm.userloginStart();
                }, function (error) {
                    redirectionDisclaimerVm.userName = '';
                    redirectionDisclaimerVm.pswd = '';
                    utilityService.hideSpinner();
                    redirectionDisclaimerVm.authFailure = true;
                    if (error.responseMessage) {
                        quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
                    } else {
                        quickPayService.showAuthFailurePopup('error', constantConfig.adapter.CANNOT_PROCESS_NOW, '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
                    }
                });
            }
        }

        redirectionDisclaimerVm.userloginStart = function () {
            var hasedSimInfo = "";
            if (utilityService.isAndroidPlatform()) {
                hasedSimInfo = redirectionDisclaimerVm.hasedSimInfo ? redirectionDisclaimerVm.hasedSimInfo : "";
            }
            var requestParams = {
                "userName": redirectionDisclaimerVm.userName,
                "sha512Password": loggedInUserService.finalSHA512Val,
                "type": "username",
                "source": "omp",
                "simId": hasedSimInfo.toString()
            };
            quickPayService.userAuthentication(requestParams).then(function (data) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMESUCCESS"));
                $scope.hideKeyboard();
                redirectionDisclaimerVm.userName = "";
                redirectionDisclaimerVm.pswd = "";
                afterUserAuthSuccess(data);
            }, function (error) {
                redirectionDisclaimerVm.authFailure = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OMP_MERC_AUTHBYUSERNAMEFAIL"));
                if (error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
                    redirectionDisclaimerVm.authFailure = false;
                    utilityService.showForcePasswordPopup(error.responseMessage, "");
                } else {
                    quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { redirectionDisclaimerVm.authFailure = false; });
                }
            });
        }

        function afterUserAuthSuccess(data) {
            if (data) {
                quickPayService.customerInfo = data;
                quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
                quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
                quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
                quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
                localStorage.setItem('customerImageId', quickPayService.customerInfo.customerInformation.imageUrl);
                ompMerchantsService.redirectUrlModif = true;
                ompMerchantsService.pseudoId = data.lotusId;
                redirectionDisclaimerVm.Continue();
            }
        }

        /*Custom Keypad for MPIN*/
        $scope.pswd = '';
        $scope.canErase = false;
        $scope.pinDotVisible = {};
        $scope.success = null;
        $scope.keyboardVisible = false;
        $scope.pinArray = [];
        $scope.keyboardSettings = {
            // settings here
            action: function (number) {
                var pass;
                if ($scope.pswd.length < 6) {
                    $scope.pswd += number;
                    $scope.pinArray.push(number);
                    $scope.pinDotVisible[$scope.pswd.length] = true;
                    $scope.canErase = true;
                    $scope.success = null;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        redirectionDisclaimerVm.first = pass[0];
                        redirectionDisclaimerVm.second = pass[1];
                        redirectionDisclaimerVm.third = pass[2];
                        redirectionDisclaimerVm.fourth = pass[3];
                        redirectionDisclaimerVm.fifth = pass[4];
                        redirectionDisclaimerVm.sixth = pass[5];
                    } catch (err) { console.log(err); }
                }
                if ($scope.pswd && $scope.pswd.length === 6 && !$scope.passLenLimitReached) {
                    $scope.passLenLimitReached = true;
                    var e = {};
                    $scope.newMpin = $scope.pswd;
                    pass = $scope.pswd;
                    pass = pass.split("");
                    try {
                        redirectionDisclaimerVm.first = pass[0];
                        redirectionDisclaimerVm.second = pass[1];
                        redirectionDisclaimerVm.third = pass[2];
                        redirectionDisclaimerVm.fourth = pass[3];
                        redirectionDisclaimerVm.fifth = pass[4];
                        redirectionDisclaimerVm.sixth = pass[5];
                        e = {};
                        e.srcElement = {};
                        e.srcElement.value = 2;
                        redirectionDisclaimerVm.changeInput(e, 6);
                    } catch (err) { console.log(err); }
                }
            },
            // Clear
            leftButton: {
                html: '<i class="icon ion-backspace"></i>',
                action: function () {
                    $scope.doErase();
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '20px'
                }
            },
            // Submit login
            rightButton: {
                html: '<i class="icon ion-eye"></i> <i class="icon ion-eye-disabled login-eye-btn" ></i>',
                action: function () {
                    var elementHide;
                    var elementShow;
                    if ($scope.isPassVisible) {
                        elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye")[0];
                        elementShow.classList.remove("login-eye-btn");
                        $scope.isPassVisible = false;
                    } else {
                        $scope.isPassVisible = true;
                        elementHide = document.getElementsByClassName("ion-eye")[0];
                        elementHide.classList.add("login-eye-btn");
                        elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
                        elementShow.classList.remove("login-eye-btn");
                    }
                },
                style: {
                    bgColor: '#fff',
                    activeBgColor: '#dfdfdf',
                    borderColor: '#dfdfdf',
                    fontSize: '30px'
                }
            }
        }

        $scope.doErase = function () {
            $scope.pinDotVisible[$scope.pswd.length] = false;
            $scope.pswd = $scope.pswd.slice(0, -1);
            if ($scope.pswd.length == 0) $scope.canErase = false;
            try {
                var pass = $scope.pswd;
                pass = pass.split("");
                redirectionDisclaimerVm.first = pass[0] ? pass[0] : "";
                redirectionDisclaimerVm.second = pass[1] ? pass[1] : "";
                redirectionDisclaimerVm.third = pass[2] ? pass[2] : "";
                redirectionDisclaimerVm.fourth = pass[3] ? pass[3] : "";
                redirectionDisclaimerVm.fifth = pass[4] ? pass[4] : "";
                redirectionDisclaimerVm.sixth = pass[5] ? pass[5] : "";
            } catch (err) { console.log(err); }
        }

        $scope.rightAction = function () {
            pinDotVisible[0] = false;
            pinDotVisible[1] = false;
            pinDotVisible[2] = false;
            pinDotVisible[3] = false;
            pinDotVisible[4] = false;
            pinDotVisible[5] = false;
        }

        $scope.showKeyboard = function () {
            $scope.keyboardVisible = true;
        }

        $rootScope.hidekeypad = function ($event) {
            switch ($event.target.className) {
                case "mpin1 activated":
                // code block
                case "digit-keyboard-key":
                // code block
                case "digit-keyboard-key-action ng-binding":
                // code block
                case "icon ion-record":
                // code block
                case "digit-keyboard-key activated":
                // code block
                case "icon ion-backspace":
                // code block
                case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                // code block
                case "mpin1 ng-binding":
                // code block
                case "icon ion-eye-disabled login-eye-btn":
                // code block
                case "icon ion-eye login-eye-btn":
                // code block
                case "digit-keyboard-key-number":
                    // code block
                    if (!$scope.keyboardVisible) {
                        $scope.showKeyboard();
                    }
                    break;
                default:
                    // code block
                    if ($scope.keyboardVisible) {
                        $scope.hideKeyboard();
                    }
                    break;
            }
        }

        $scope.hideKeyboard = function () {
            $scope.keyboardVisible = false;
        }
        /*End of Custom Keypad for MPIN*/
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
            navigator.splashscreen.hide();
            $rootScope.checkLocationPermission();
        });

        redirectionDisclaimerVm.emptyValues = function () {
            redirectionDisclaimerVm.first = '';
            redirectionDisclaimerVm.second = '';
            redirectionDisclaimerVm.third = '';
            redirectionDisclaimerVm.fourth = '';
            redirectionDisclaimerVm.fifth = '';
            redirectionDisclaimerVm.sixth = '';
        }
        //authUser end



        redirectionDisclaimerVm.goBack = function () {
            $ionicHistory.goBack(-1);
        };
        $scope.hamBack = function () {
            ompMerchantsService.ompSearchHistory="";
        };

        redirectionDisclaimerVm.openDiscliamer = function () {
            var elem = document.querySelector(".popup-open");
            if (elem) {
                return false;
            }
            redirectionDisclaimerVm.disclaimerPopup = $ionicPopup.show({
                templateUrl: "pages/OMP/merchantList/redirectionPopupContent.html",
                title: '<h3 class="popup-title>Disclaimer</h3><img src="img/OMP/close_btn.PNG" class="close_disclaimer_btn" alt="close_btn"/>',
                scope: $scope,
                cssClass: 'redirectionalDisclaimerPopup'
            });
        }
        redirectionDisclaimerVm.closeDisclaimer = function () {
            redirectionDisclaimerVm.disclaimerPopup.close();
        }


        redirectionDisclaimerVm.Continue = function () {
            clickStreamService.clickStreamData = "websiteId," + redirectionDisclaimerVm.merchantData.affiliateId;
            isWebviewLoadingCanceled = false;
            if (redirectionDisclaimerVm.disclaimerPopup) {
                redirectionDisclaimerVm.disclaimerPopup.close();
            }

            redirectionDisclaimerVm.loadPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                templateUrl: "pages/OMP/merchantList/discliamerLoading.html",
                scope: $scope
            })
            var mobileRedirectKey='';
            if($scope.shopNOrderPre){
                mobileRedirectKey= cryptoService.getSHA512EncryptedData(redirectionDisclaimerVm.merchantData.mobileRedirectUrl).toString();
            }else{
                mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + redirectionDisclaimerVm.merchantData.mobileRedirectUrl).toString();
            }
            
            var saveLeadObj = {
                "leadId": "",
                "websiteId": redirectionDisclaimerVm.merchantData.websiteId,
                "affiliateId": redirectionDisclaimerVm.merchantData.affiliateId,
                "request": {
                    "ompCcustToken": "",
                    "loggedIn": "",
                    "channel": "",
                    "segId": "",
                    "ompTokenId": "",
                    "merchantSku": "",
                    "prdPrice": "",
                    "wishlistSkus": "",
                    "ompDisValue": "",
                    "ompDisPct": "",
                    "ompDisType": "",
                    "isLoggedIn": mPinLoginService.isLoggedIn
                },
                "leadParam": redirectionDisclaimerVm.merchantData.leadParam,
                "segmentParam": redirectionDisclaimerVm.merchantData.segmentParam,
                "affiliateIdParam": redirectionDisclaimerVm.merchantData.affiliateIdParam,
                "mobileRedirectUrl": redirectionDisclaimerVm.merchantData.mobileRedirectUrl,
                "mobileRedirectKey": mobileRedirectKey,
                "shopNOrder": $scope.shopNOrderPreHash,
                "psudoIdEnble": ompMerchantsService.psudoIdEnble
            }
            ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
                const hRespCheck = data.data.resourceParameter;
                if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(data.data.mobileUrl).toString()){
                redirectionDisclaimerVm.saveLeadData = data;
                redirectionDisclaimerVm.loadPopup.close();
                if (isWebviewLoadingCanceled == true) {
                    return "";
                }
                isWebviewLoadingCanceled = true;
                if (mPinLoginService.isLoggedIn || $scope.shopNOrderPre) {
                    var tempUrl = new URL(data.data.mobileUrl);
                    if(ompMerchantsService.psudoIdEnble && ompMerchantsService.redirectUrlModif){
                        data.data.mobileUrl = data.data.mobileUrl.replaceAll("PSEUDO_CODE", ompMerchantsService.pseudoId ? ompMerchantsService.pseudoId : ''); 
                        var tempUrl = new URL(data.data.mobileUrl);
                        data.data.mobileUrl = tempUrl;
                        ompMerchantsService.redirectUrlModif = false;
                        ompMerchantsService.psudoIdEnble = false;
                    }
                    if (redirectionDisclaimerVm.merchantData.merchantCode == "ubr") {
                        if (utilityService.isAndroidPlatform()) {
                            appAvailability.check('com.ubercab',
                                function () {
                                    var url = data.data.mobileUrl;
                                    ompMerchantsService.inChromeBrowser(url);
                                },
                                function () {
                                    var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                    ompMerchantsService.inChromeBrowser(url);
                                });
                        } else {
                            appAvailability.check('uber://', function () {
                                var url = data.data.mobileUrl;
                                ompMerchantsService.inChromeBrowser(url);
                            }, function () {
                                var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                ompMerchantsService.inChromeBrowser(url);
                            });
                        }
                        return true;
                    } else if (redirectionDisclaimerVm.merchantData.browserType === 'inApp') {

                        ompMerchantsService.inAppBrowser(data.data.mobileUrl, redirectionDisclaimerVm.merchantData);
                    } else if (redirectionDisclaimerVm.merchantData.browserType === 'default') {

                        ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                    }

                    $ionicHistory.goBack(-1);
                }
                } else {
                        redirectionDisclaimerVm.loadPopup.close();
						utilityService.showErrorMessage("Invalid request");
					}
            }, function (error) {
                redirectionDisclaimerVm.loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        redirectionDisclaimerVm.tapCancel = function () {
            redirectionDisclaimerVm.loadPopup.close();
            //$state.go('menu.redirectionDiscliamer');
        };

        redirectionDisclaimerVm.slideChanged = function (index) {
            var classSlider = '.sliderOpac' + index;
            var elem = document.querySelector(classSlider);
            var nextElemnt = elem.nextElementSibling;
            elem.classList.remove('opacSlider');
            if (nextElemnt) {
                elem.nextElementSibling.classList.add('opacSlider');
            }
        }
        redirectionDisclaimerVm.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        redirectionDisclaimerVm.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };

        $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
            redirectionDisclaimerVm.slider = data.slider;
            //first slide loads here
            redirectionDisclaimerVm.activeIndex = data.slider.activeIndex;
            console.log(redirectionDisclaimerVm.activeIndex); //will return 0
        });

        $scope.$on("$ionicSlides.slideChangeStart", function (event, data) {
            redirectionDisclaimerVm.activeIndex = data.slider.activeIndex;
            console.log(redirectionDisclaimerVm.activeIndex); //will return the current index of your slide
        });
    
    redirectionDisclaimerVm.scrollToPage=function(){
        if(redirectionDisclaimerVm.showBrandSection){
            var removeClass= document.getElementById('showBrandSection');
            removeClass.classList.remove('ng-hide');
            redirectionDisclaimerVm.showBrandSection = false;
        }
       
    }
    $scope.checkboxChangeEvent=function(){
        if(redirectionDisclaimerVm.agreeCheckBox){
            $scope.showDisclaimerError=false;
        }
    }

    $scope.authenticateUser = function ($event) {
        $scope.showDisclaimerError = false;
        if (!redirectionDisclaimerVm.agreeCheckBox) {
            $scope.showDisclaimerError = true;
            return false;
        }
        if (redirectionDisclaimerVm.authenticateUser) {
            //check for merchant pseudo flag value
            if (redirectionDisclaimerVm.merchantData.psudoIdEnble && !mPinLoginService.isLoggedIn) {
                ompMerchantsService.psudoIdEnble = true;
                ompMerchantsService.redirectUrlModif = true;
                redirectionDisclaimerVm.emptyValues();
                $scope.clearMpin();
                $scope.openPopover($event);
                //dynamically adding background colour
                redirectionDisclaimerVm.popoverBbackdrop();
            }
        } else {
            redirectionDisclaimerVm.Continue();
        }
    }

    $scope.$on('$ionicView.afterEnter', function () {
        $timeout(function () {
            // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll("#"+ $location.hash('offerDiv'))
            if (utilityService.isAndroidPlatform()) {
                var offerDivHtml = document.getElementById('offerDiv');
                offerDivHtml.scrollIntoView(true);
            }else {
                if(redirectionDisclaimerVm.merchantData.offerPoints.length > 0) {
                    redirectionDisclaimerVm.showBrandSection = true;
                }
            }
        }, 2000);
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
            if (topBar) {
                topBar[2].classList.add('discliamerContent');
            }
    });

        // In case if merchant site is redirected in chrome tab option then popover-open css need to be removed on app resume
        $ionicPlatform.on('resume', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
        })

        $scope.$on('$ionicView.beforeEnter', function () {
            //authUser
            redirectionDisclaimerVm.simSubscriptionId = ompOffersService.simSubscriptionIdForOmpPreLogin;
            redirectionDisclaimerVm.hasedSimInfo = ompOffersService.hasedSimInfoForOmpPreLogin;
            redirectionDisclaimerVm.authFailure = false;
            redirectionDisclaimerVm.isUserAuthQuickPay = false;
            redirectionDisclaimerVm.isSimChanged = ompOffersService.isSimChangedForOmpPreLogin;
            redirectionDisclaimerVm.simList = ompOffersService.simListForOmpPreLogin;
            //Check device is locked or not, depend on that go to User ID tab as default
            redirectionDisclaimerVm.keyguardValue = internetBankingService.checkKeyguardValue;
            redirectionDisclaimerVm.authenticateUser = ompMerchantsService.authOnDisclaimer;
            //authUser end
            /** YONO splash */
            $scope.shopNOrderPre="";
            $scope.shopNOrderPreHash="";
            if(loggedInUserService.shopNOrderPre){
                $scope.shopNOrderPre=loggedInUserService.shopNOrderPre;
                $scope.shopNOrderPreHash=$scope.shopNOrderPre ? cryptoService.getSHA512EncryptedData($scope.shopNOrderPre).toString() : '';
            }
            /** YONO splash */
            if (utilityService.isIOSPlatform()) {
                $scope.isAndroidPlatform = false;
            } else {
                $scope.isAndroidPlatform = true;
            }
            redirectionDisclaimerVm.showBrandSection = false;
            if (homeScreenService.ishamburgerMenuShop) {
                redirectionDisclaimerVm.isHamCheck = true;
                redirectionDisclaimerVm.isBackCheck = true;
            } else {
                redirectionDisclaimerVm.isHamCheck = false;
                redirectionDisclaimerVm.isBackCheck = false;
            }
             redirectionDisclaimerVm.merchantData = ompMerchantsService.listName;
             var footerHeight = document.querySelector(".disclaimerFooter").offsetHeight;
             var screenHeight= $window.innerHeight;
             var contentHeight= (screenHeight) - (footerHeight) -  (44);

             document.getElementById("redirectionContent").style.height = (contentHeight + 10)+"px";                

            redirectionDisclaimerVm.disclaimerConatent = decodeURIComponent(redirectionDisclaimerVm.merchantData.disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
             $timeout(function(){
                var offerDivheight= document.getElementById('offerList').offsetHeight;
                var disclaimerFooterHght= document.getElementById('disclaimerFooter').offsetHeight;
                document.getElementById("offersContainer").style.height=offerDivheight+disclaimerFooterHght+"px";

            },500);
        });
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            var topBar = document.querySelectorAll('.app-header');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
            if (topBar) {
                topBar[2].classList.remove('discliamerContent');
            }
        });
    }
]);
