'use strict';

angularApp.controller('createQRCodeController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$ionicPopup",
    "$ionicPopover",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        $ionicPopup,
        $ionicPopover) {

        var createQRVm = this;
        createQRVm.upiQrCode = null;
        $scope.$on('$ionicView.beforeEnter', function () {
            createQRVm.profileName = yfeiUPIService.createQr.vpaName;
            createQRVm.primaryVPAId = yfeiUPIService.createQr.virtualAddress;
            createQRVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
         
	      

            var qrData;
            if (createQRVm.dashboardSelItem == "Request Money") {
                createQRVm.amount = yfeiUPIService.createQr.amount;
                if (yfeiUPIService.createQr.note) {
                    createQRVm.note = yfeiUPIService.createQr.note;
                } else {
                    createQRVm.note = "";
                }
                qrData = "upi://pay?pa=" + createQRVm.primaryVPAId + "&pn=" + createQRVm.profileName + "&am=" + createQRVm.amount + "&tn=" + createQRVm.note;
            }
            else {
                qrData = "upi://pay?pa=" + createQRVm.primaryVPAId + "&pn=" + createQRVm.profileName + "&am=" + "";

            }

            if (!createQRVm.upiQrCode) {

                createQRVm.upiQrCode = yfeiUPIService.generateQrCode(qrData);
                createQRVm.upiQrCode.append(document.getElementById("upiCanvasQrcode"));
            }
            else {
                createQRVm.upiQrCode.update({
                    data: qrData,
                });
            }


        });

        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('popover-open');
            }
        });

        createQRVm.copyVpa = function (vpaId, $event) {
            var copyElement = document.createElement("textarea");
            copyElement.style.position = 'fixed';
            copyElement.style.opacity = '0';
            copyElement.textContent = decodeURI(vpaId);
            var body = document.getElementsByTagName('body')[0];
            body.appendChild(copyElement);
            copyElement.select();
            document.execCommand('copy');
            body.removeChild(copyElement);

            var vpaMsg = "Copied: " + vpaId;

            var template = '<ion-popover-view class="tooltiptext-yefi tooltiptext-yefi-popupInfo  roboto-regular tooltiptext-yefi-pos fs-yfei-14 yefi-color-00">' + '<ion-content>' +
                '<div class="">' + vpaMsg + '</div>' + '</ion-content>' + '</ion-popover-view>';

            $scope.popover = $ionicPopover.fromTemplate(template, {
                scope: $scope
            });
            $scope.popover.show($event);
            setTimeout(function () {
                $scope.popover.hide();
            }, 500);

        }


        createQRVm.shareQrCode = function (share) {
            var blobQrObj = "";
            createQRVm.upiQrCode.getRawData('png').then(function (result) {
                blobQrObj = result;
                var reader = new window.FileReader();
                reader.onloadend = function () {
                    if (device.platform.toLowerCase() == 'ios') {
                        var myBaseString = reader.result;
                        var block = myBaseString.split(";");

                        var myBase64 = block[1].split(",")[1];

                        var successCallback = function (data) {
                            console.log(data);
                        }
                        var failureCallback = function (error) {
                            yfeiUPIService.showUpiAlert("error", error);


                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    }
                    else {
                        var contentType = "image/png";
                        var folderpath = cordova.file.externalRootDirectory;
                        var filename = "UPI ID - " + createQRVm.primaryVPAId + " - " + yfeiUPIService.getTimeStamp() +  ".png";
                        createQRVm.savebase64AsImageFile(folderpath, filename, blobQrObj, contentType, share);
                    }

                };
                reader.readAsDataURL(blobQrObj);
            });
        }

        createQRVm.savebase64AsImageFile = function (folderpath, filename, content, contentType, share) {

            var DataBlob = content;
            if (device.version == 10) {
                folderpath = cordova.file.externalDataDirectory;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    createQRVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            createQRVm.downloadOrShare(share);
                        }, function () {
                            yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            }
            else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        createQRVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                createQRVm.downloadOrShare(share);
                            }, function () {
                                yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                });
            }
        }
        createQRVm.downloadOrShare = function (share) {
            if (share) {
                var options = {
                    message: 'QR code - ', // not supported on some apps (i.e. Facebook, Instagram)
                    subject: 'YONO QR Code : ' + createQRVm.primaryVPAId, // Subject. for email
                    files: [createQRVm.popupFolderpath], // an array of filenames either locally or remotely
                    url: createQRVm.primaryVPAId,
                    chooserTitle: 'Share YONO QR code' // Android only, you can override the default share sheet title
                };

                var onSuccess = function (result) {
                    console.log(result);
                };
                var onError = function (msg) {
                    yfeiUPIService.showUpiAlert("error", msg);
                }
                window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
            } else if (!share) {
                createQRVm.fileStoredAlert = $ionicPopup.show({
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>QR Code downloaded successfully</span></div></div></div>',
                    title: '',
                    cssClass: 'bhim-alert-popup',
                    scope: $scope,
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            createQRVm.fileStoredAlert.close();
                        }
                    }]
                });
            }
        }


        createQRVm.goBack = function () {
            if (createQRVm.dashboardSelItem == "Request Money") {
                $state.go("menu.reqMoneyWithoutUPI");
            }
            else {
                $state.go("menu.dashboard");
            }

        }

        createQRVm.goToDashboard = function () {
            $state.go("menu.dashboard");
        }
        return this;
    }



]);
