'use strict';

angularApp.controller('dashboardController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$ionicPopup",
    "newToSbiService",
    "ionicToast",
    "APICUtils",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $ionicPopup,
        newToSbiService,
        ionicToast,
        APICUtils
    ) {

        var dashboardVM = this;
        dashboardVM.showFlag = true;
        dashboardVM.limitCount = 8;
        dashboardVM.custName = "";
        $scope.$on('$ionicView.beforeEnter', function () {
            if (localStorage.getItem("customerName")) {
                dashboardVM.custName = localStorage.getItem("customerName");
            } else {
                dashboardVM.custName = "";
            }
            dashboardVM.getProfile();

            yfeiUPIService.navigateUrl = "";
            yfeiUPIService.addBankFlag = "";
            dashboardVM.init();
        });

        dashboardVM.init = function () {
            dashboardVM.frequntlyList = [{ name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }, { name: "Kiran Jadhav" }]
            dashboardVM.colorCode = yfeiUPIService.colorCode;
            dashboardVM.paymentRequest = [{ amt: 20000, trans: "Unpaid" }, { amt: 40000, trans: "Unpaid" }, { amt: 40000, trans: "Unpaid" }];
            dashboardVM.getBannerData();
        }

        dashboardVM.imagesData = ['img/PCMS/achiever-card.svg', 'img/PCMS/achiever-card.svg', 'img/PCMS/achiever-card.svg'];

        dashboardVM.backgroundImage = function (images) {
            return { 'background-image': 'url(' + images + ')' }
        }

        dashboardVM.goToProfile = function () {
            $state.go('menu.profileLanding');
        }

        dashboardVM.getBannerData = function () {
            dashboardVM.bannerData = [{
                offerImgMobile: "img/yfei/Banners-05.png",
                navigation: ""
            }];
        }

        dashboardVM.bannerClick = function (event) {
            if (event == "videokYC") {
                yfeiUPIService.yfeiNavigation = "dashboard";
                var requestParams = {};
                newToSbiService.getInstaPlusDetailFn(requestParams).then(function (response) {
                    newToSbiService.getInstaPlusDetail = response.data.getINSTAPlusDeatail;
                    $state.go('menu.openDsaWithoutVisit');
                }, function (error) {
                    yfeiUPIService.showUpiAlert("error", error.responseMessage);
                });
            }
            if (event == "carLoan") {
                yfeiUPIService.yfeiNavigation = "dashboard";
                $state.go('menu.clNTBExploreCarLoan');
            }
        }

        dashboardVM.getProfile = function () {
            if (yfeiUPIService.payerProfileDtls && yfeiUPIService.payerProfileDtls != null && yfeiUPIService.payerProfileDtls != undefined) {
                var getProfileServiceResponse = yfeiUPIService.payerProfileDtls;
                dashboardVM.profileName = getProfileServiceResponse.userInfo.name;
                dashboardVM.vpaList = getProfileServiceResponse.vpaAccountDetails;
                for (var k = 0; k < dashboardVM.vpaList.length; k++) {
                    if (dashboardVM.vpaList[k].defVPAStatus) {
                        dashboardVM.selectedVpa = dashboardVM.vpaList[k];
                        dashboardVM.accounts = dashboardVM.selectedVpa.accountInfo;
                        dashboardVM.primaryVPAId = dashboardVM.selectedVpa.virtualAddress;
                        for (var l = 0; l < dashboardVM.vpaList[k].accountInfo.length; l++) {
                            if (dashboardVM.vpaList[k].accountInfo[l].preferredFlag == 'T') {
                                dashboardVM.accountDtl = dashboardVM.vpaList[k].accountInfo[l];
                            }
                        }
                    }
                }
                dashboardVM.collectRequests();
            } else {
                var json = JSON.stringify({
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag
                });
                utilityService.showSpinner();
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                    utilityService.hideSpinner();
                    var getProfileResponse = JSON.parse(data);
                    if (getProfileResponse.status == "S") {
                        yfeiUPIService.payerProfileDtls = getProfileResponse;
                        dashboardVM.profileName = getProfileResponse.userInfo.name;
                        dashboardVM.vpaList = getProfileResponse.vpaAccountDetails;
                        for (var i = 0; i < dashboardVM.vpaList.length; i++) {
                            if (dashboardVM.vpaList[i].defVPAStatus) {
                                dashboardVM.selectedVpa = dashboardVM.vpaList[i];
                                dashboardVM.accounts = dashboardVM.selectedVpa.accountInfo;
                                dashboardVM.primaryVPAId = dashboardVM.selectedVpa.virtualAddress;
                                for (var j = 0; j < dashboardVM.vpaList[i].accountInfo.length; j++) {
                                    if (dashboardVM.vpaList[i].accountInfo[j].preferredFlag == 'T') {
                                        dashboardVM.accountDtl = dashboardVM.vpaList[i].accountInfo[j];
                                    }
                                }
                            }
                        }
                    } else {
                        yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                    }
                    if (yfeiUPIService.openRequestPaymentPopupFlag) {
                        dashboardVM.collectRequestsPopup('dashboard');
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
        }
        dashboardVM.showOption = function () {
            dashboardVM.showFlag = !dashboardVM.showFlag;
            dashboardVM.limitCount = dashboardVM.showFlag ? 8 : 10
        }

        dashboardVM.paymentRequestMore = function () {
            $state.go("menu.paymentRequest");
        }

        //Scan the QR Code
        dashboardVM.scanQrCode = function () {
            if (device.platform.toLowerCase() == 'android') {
                yfeiUPIService.getNativeData("scanqrcode", {}).then(function (data) {
                    var barcodeData = data.scanResult;

                    yfeiUPIService.getQRCode(barcodeData).then(function (res) {
                        if (res.validStatus == 0) {
                            if (res.isQRValid && res.virtualPaymentAddress) {
                                yfeiUPIService.payeeDetails = {
                                    payeeType: "QR",
                                    requestType: 'qr_pay',
                                    accountNo: "",
                                    ifsc: "",
                                    name: res.merchantName || "",
                                    vpa: res.virtualPaymentAddress || "",
                                    amount: res.transactionAmount || "",
                                    remark: res.remark || "",
                                    nickName: "",
                                    phoneNumber: "",
                                    savePayee: false,
                                    currencyCode: res.transactionCurrencyCode || "",
                                    ref_id: res.referenceId || "",
                                    merchantCatCode: res.merchantCategoryCode || "",
                                    minAmount: res.minimumAmount || "",
                                    ref_url: res.urlReference || "",
                                    tid: res.terminalId || "",
                                    pageName: "Scan and Pay",
                                    payType: ""
                                }
                                yfeiUPIService.dashTransactionSelection = "Scan and Pay";
                                $state.go('menu.scanAndPay');
                            } else {
                                showQRCodeAlert("error", "Invalid QR");
                            }
                        } else {
                            dashboardVM.goToBhimUpiPayment(barcodeData);
                        }
                    }, function (error) {
                        showQRCodeAlert("error", yfeiUPIService.commonErrorMsg);
                    });
                }, function () {
                    showQRCodeAlert("error", yfeiUPIService.commonErrorMsg);
                });
            } else {
                yfeiUPIService.getNativeData("scanqrcode", {}).then(function (data) {
                    var barcodeData = data;

                    if (barcodeData.indexOf("upi://pay?") !== 0) {
                        yfeiUPIService.getQRCode(barcodeData).then(function (res) {
                            if (res.validStatus == 0) {
                                if (res.isQRValid) {
                                    showQRCodeAlert("success", "Valid QR");
                                } else {
                                    showQRCodeAlert("error", "Invalid QR");
                                }
                            } else {
                                dashboardVM.goToBhimUpiPayment(barcodeData);
                            }
                        }, function () {
                            showQRCodeAlert("error", yfeiUPIService.commonErrorMsg);
                        });
                    } else {
                        dashboardVM.goToBhimUpiPayment(barcodeData);
                    }
                }, function () {
                    showQRCodeAlert("error", yfeiUPIService.commonErrorMsg);
                });
            }
        };

        function showQRCodeAlert(errorType, message) {
            var defaultMessage = message;
            var imageType = 'img/FT/BhimUpi/alertSymbol.svg';
            errorType = errorType.toLowerCase();
            switch (message) {
                case -1: message = constantConfig.upiConstant.minusOne;
                    break;

                case -2: message = constantConfig.upiConstant.minusTwo;
                    break;

                case -3: message = constantConfig.upiConstant.minusThree;
                    break;

                case -4: message = constantConfig.upiConstant.minusFour;
                    break;

                case -5: message = constantConfig.upiConstant.minusFive;
                    break;

                case -6: message = constantConfig.upiConstant.minusSix;
                    break;

                case -7: message = constantConfig.upiConstant.minusSeven;
                    break;

                default: message = defaultMessage;
            }

            if (message.indexOf("U00") !== -1) {
                var isUserLoggedIn = localStorage.getItem('isSetMpin');
                var onTapgo = isUserLoggedIn == "true" ? "menu.yfeiLogin" : "menu.preRegistrationSelection";
            }

            if (errorType == 'error') {
                imageType = 'img/FT/BhimUpi/errorSymbol.svg';
            } else if (errorType == 'success') {
                imageType = 'img/FT/BhimUpi/successSymbol.svg';
            }
            var popup = $ionicPopup.show({
                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                    + message + '</span></div></div></div>',
                cssClass: 'bhim-alert-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (errorType == 'error') {
                            dashboardVM.scanQrCode();
                        } else if (onTapgo) {
                            $state.go(onTapgo);
                        } else {
                            popup.close();
                        }
                    }
                }]
            });
        }

        dashboardVM.goToBhimUpiPayment = function (barcodeData) {
            try {
                dashboardVM.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
                if (dashboardVM.isBarcodeScanned) {
                    dashboardVM.amount = "";
                    dashboardVM.remark = "";
                    dashboardVM.currencyCode = "";
                    dashboardVM.ref_id = "";
                    dashboardVM.merchantCatCode = "";
                    dashboardVM.minAmount = "";
                    dashboardVM.ref_url = "";
                    dashboardVM.tid = "";
                    if (dashboardVM.getParameterByName('am', barcodeData)) {
                        dashboardVM.requestType = "scanAndPayAmount";
                    } else {
                        dashboardVM.requestType = "scanAndPay";
                    }

                    dashboardVM.payeeVpa = dashboardVM.getParameterByName('pa', barcodeData);
                    dashboardVM.scannedImage = "img/FT/PayQRCode.svg";
                    if (dashboardVM.getParameterByName('am', barcodeData))
                        dashboardVM.amount = Number(dashboardVM.getParameterByName('am', barcodeData));
                    if (dashboardVM.getParameterByName('tn', barcodeData))
                        dashboardVM.remark = dashboardVM.getParameterByName('tn', barcodeData);
                    if (dashboardVM.getParameterByName('cu', barcodeData))
                        dashboardVM.currencyCode = dashboardVM.getParameterByName('cu', barcodeData);
                    if (dashboardVM.getParameterByName('tr', barcodeData))
                        dashboardVM.ref_id = dashboardVM.getParameterByName('tr', barcodeData);
                    if (dashboardVM.getParameterByName('mc', barcodeData))
                        dashboardVM.merchantCatCode = dashboardVM.getParameterByName('mc', barcodeData);
                    if (dashboardVM.getParameterByName('mam', barcodeData))
                        dashboardVM.minAmount = dashboardVM.getParameterByName('mam', barcodeData);
                    if (dashboardVM.getParameterByName('url', barcodeData))
                        dashboardVM.ref_url = dashboardVM.getParameterByName('url', barcodeData);
                    if (dashboardVM.getParameterByName('tid', barcodeData))
                        dashboardVM.tid = dashboardVM.getParameterByName('tid', barcodeData);
                    dashboardVM.checkVpaAvailability();
                } else {
                    dashboardVM.scannedImage = "img/FT/PayQRCode.svg";
                }
            } catch (e) { }
        }

        dashboardVM.getParameterByName = function (name, url) {
            if (!url) url = window.location.href;
            name = name.replace(/[\[\]]/g, "\\$&");
            var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return '';
            if (name == 'am') {
                if (results[2].search("E") !== -1 || results[2].search("e") !== -1) {
                    return results[2];
                }
            }
            return decodeURIComponent(results[2].replace(/\+/g, " "));
        }

        dashboardVM.checkVpaAvailability = function () {
            if (!dashboardVM.payeeVpa) {
                showQRCodeAlert("error", "Invalid QR");
                return false;
            }
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": dashboardVM.payeeVpa.toString()
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                utilityService.hideSpinner();
                var checkVpaResponse = JSON.parse(data);
                if (checkVpaResponse.status == 'VN') {
                    showQRCodeAlert("error", "Invalid QR code. Please scan valid QR code.");
                } else if (checkVpaResponse.status == 'VE') {
                    yfeiUPIService.payeeDetails = {
                        payeeType: "QR",
                        requestType: 'qr_pay',
                        accountNo: "",
                        ifsc: "",
                        name: checkVpaResponse.payeeType.name || "",
                        vpa: checkVpaResponse.payeeType.virtualAddress || "",
                        amount: dashboardVM.amount || "",
                        remark: dashboardVM.remark || "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        currencyCode: dashboardVM.currencyCode || "",
                        ref_id: dashboardVM.ref_id || "",
                        merchantCatCode: dashboardVM.merchantCatCode || "",
                        minAmount: dashboardVM.minAmount || "",
                        ref_url: dashboardVM.ref_url || "",
                        tid: dashboardVM.tid || "",
                        pageName: "Scan and Pay",
                        payType: dashboardVM.requestType
                    }
                    yfeiUPIService.dashTransactionSelection = "Scan and Pay";
                    $state.go('menu.scanAndPay');
                } else {
                    showQRCodeAlert("error", "Invalid QR");
                }
            }, function (msg) {
                utilityService.hideSpinner();
                showQRCodeAlert("error", msg);
            });
        }

        dashboardVM.getTransactionHistory = function () {
            yfeiUPIService.transactionHistory = ""
            dashboardVM.transactionHistory('TRANS')
        }

        dashboardVM.transactionHistory = function (event) {
            dashboardVM.FilterFrequntlyPay = [];
            if (event == 'TRANS') {
                utilityService.showSpinner();
            }

            if (yfeiUPIService.transactionHistory && yfeiUPIService.transactionHistory != null && yfeiUPIService.transactionHistory != undefined) {
                var transServiceHistory = yfeiUPIService.transactionHistory;
                if (transServiceHistory != null && transServiceHistory.length > 0) {
                    dashboardVM.frequntlyPay = transServiceHistory.filter(function (el) {
                        return el.drCrFlag == "D" && el.txnStatus == 'SUCCESS';
                    });
                    dashboardVM.recentTransBank = transServiceHistory.filter(function (el) {
                        if (el.drCrFlag == "D" && el.txnStatus == 'SUCCESS' && (typeof el.addressType === 'string' ? el.addressType.trim() : '') == 'AC') {
                            return true;
                        }
                    });
                }
                if (dashboardVM.frequntlyPay && dashboardVM.frequntlyPay.length > 0) {
                    dashboardVM.FilterFrequntlyPay = dashboardVM.removeDuplicateElement(dashboardVM.frequntlyPay);
                }
                yfeiUPIService.frequntlyPay = dashboardVM.FilterFrequntlyPay;
                if (dashboardVM.recentTransBank && dashboardVM.recentTransBank.length > 0) {
                    dashboardVM.FilterRecentTransPay = dashboardVM.removeDuplicateElement(dashboardVM.recentTransBank);
                }
                yfeiUPIService.recentlyTransPay = dashboardVM.FilterRecentTransPay;
            } else {
                var json = JSON.stringify({
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getTransactionHistoryList, json).then(function (data) {
                    utilityService.hideSpinner();
                    var transHistory = JSON.parse(data);
                    if (transHistory.status == 'S') {
                        yfeiUPIService.transactionHistory = transHistory.transDetails;
                        if (transHistory.transDetails != null && transHistory.transDetails.length > 0) {
                            dashboardVM.frequntlyPay = transHistory.transDetails.filter(function (el) {
                                return el.drCrFlag == "D" && el.txnStatus == 'SUCCESS';
                            });
                            dashboardVM.recentTransBank = transHistory.transDetails.filter(function (el) {
                                if (el.drCrFlag == "D" && el.txnStatus == 'SUCCESS' && (typeof el.addressType === 'string' ? el.addressType.trim() : '') == "AC") {
                                    return true;
                                }
                            });
                        }
                        if (dashboardVM.frequntlyPay && dashboardVM.frequntlyPay.length > 0) {
                            dashboardVM.FilterFrequntlyPay = dashboardVM.removeDuplicateElement(dashboardVM.frequntlyPay);
                        }
                        yfeiUPIService.frequntlyPay = dashboardVM.FilterFrequntlyPay;

                        if (dashboardVM.recentTransBank && dashboardVM.recentTransBank.length > 0) {
                            dashboardVM.FilterRecentTransPay = dashboardVM.removeDuplicateElement(dashboardVM.recentTransBank);
                        }
                        yfeiUPIService.recentlyTransPay = dashboardVM.FilterRecentTransPay;

                        if (event == 'TRANS') {
                            yfeiUPIService.raiseComplaint = 'TransScreen';
                            $state.go('menu.yfeiTransactionHistory');
                        }
                    } else {
                        yfeiUPIService.showUpiAlert("error", transHistory.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }

        }

        dashboardVM.removeDuplicateElement = function (arr) {
            var res = [];
            var count = {};
            arr.filter(function (el) {
                count[el.payeeVirtualAddress] = (count[el.payeeVirtualAddress] || 0) + 1;
                if (count[el.payeeVirtualAddress] < 2) {
                    res.push(el);
                }
            });
            return res;
        }


        dashboardVM.upiIdPayment = function () {
            yfeiUPIService.dashTransactionSelection = "Pay via UPI ID";
            yfeiUPIService.freshPaymentThroughUPI = true;
            $state.go('menu.payUpi');
        }

        dashboardVM.reqMoneyPopUp = function () {
            dashboardVM.reqMonPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/YFEI/requestMoney/requestMoneyPopUp.html",
                scope: $scope
            });
        }

        dashboardVM.closePopUp = function () {
            dashboardVM.reqMonPopup.close();
        }

        dashboardVM.reqMoneyWithUPI = function () {
            yfeiUPIService.dashTransactionSelection = "Request Money";
            dashboardVM.reqMonPopup.close();
            dashboardVM.checkContactPermission('requestMoney');
        }

        dashboardVM.reqMoneyWithoutUPI = function () {
            yfeiUPIService.dashTransactionSelection = "Request Money";
            dashboardVM.reqMonPopup.close();
            $state.go('menu.reqMoneyWithoutUPI');
        }

        var permissions = cordova.plugins.permissions;
        dashboardVM.checkContactPermission = function (event) {
            permissions.checkPermission(permissions.READ_CONTACTS, function (status) {
                if (!status.hasPermission) {
                    permissions.requestPermission(permissions.READ_CONTACTS, function (status) {
                        if (!status.hasPermission) {
                            //Permission has been denied
                            ionicToast.show("Permission for contact has been denied", "bottom", false, 2000);
                        } else {
                            dashboardVM.payToContact(event);
                        }
                    }, function (error) {
                        ionicToast.show("Permission for contact has been denied", "bottom", false, 2000);
                    });
                } else {
                    dashboardVM.payToContact(event);
                }
            }, function (error) {
                ionicToast.show("Permission for contact has been denied", "bottom", false, 2000);
            });
        }

        dashboardVM.payToContact = function (event) {
            function onSuccess(contacts) {
                utilityService.hideSpinner();
                var newArray = contacts.filter(function (element) {
                    if (element.phoneNumbers != undefined) {
                        element.ids = element.phoneNumbers[0].id;
                        element.pref = element.phoneNumbers[0].pref;
                        element.type = element.phoneNumbers[0].type;
                        element.value = element.phoneNumbers[0].value.split(" ").join("");
                        return element
                    }
                });
                yfeiUPIService.allContacts = newArray.sort(function (a, b) {
                    var textA = a.displayName;
                    var textB = b.displayName;

                    if(textA < textB){
                        return -1
                    } else if (textA > textB){
                        return 1
                    } else {
                        return 0
                    }
                })
                if (event == 'requestMoney') {
                    yfeiUPIService.dashTransactionSelection = "Request Money";
                    $state.go('menu.payUpi');
                } else {
                    yfeiUPIService.dashTransactionSelection = "Pay to Contacts";
                    $state.go('menu.payToContact');
                }
            }

            function onError(contactError) {
                utilityService.hideSpinner();
                if (!utilityService.isAndroidPlatform() && contactError.code == 20) {
                    ionicToast.show("Permission for contact has been denied", "bottom", false, 2000);
                }
            }
            // find all contacts with 'Bob' in any name field
            utilityService.showSpinner();
            var options = new ContactFindOptions();
            options.filter = "";
            options.multiple = true;
            options.desiredFields = [navigator.contacts.fieldType.id, navigator.contacts.fieldType.displayName, navigator.contacts.fieldType.phoneNumbers];
            options.hasPhoneNumber = true;
            var fields = [navigator.contacts.fieldType.displayName, navigator.contacts.fieldType.phoneNumbers];
            navigator.contacts.find(fields, onSuccess, onError, options);
        }

        dashboardVM.verifyUpi = function (frequnt) {
            if (!frequnt.payeeVirtualAddress) {
                utilityService.showUpiAlert("alert", "Please Enter beneficiary UPI ID");
                return false;
            }
            if (frequnt.addressType && frequnt.addressType.trim() == 'AC') {
                yfeiUPIService.addressType = "AC";
                yfeiUPIService.payeeDetails = {
                    payeeType: "VPA",
                    requestType: 'pay',
                    accountNo: frequnt.payeeAccountNo,
                    ifsc: "",
                    name: frequnt.payeeName || "",
                    vpa: frequnt.payeeVirtualAddress || "",
                    amount: "",
                    remark: "",
                    nickName: "",
                    phoneNumber: "",
                    savePayee: false,
                    pageName: "Pay to Bank Account",
                    payType: "frequentlyPay",
                    bank: frequnt.payeeBankCode
                }
            } else {
                yfeiUPIService.addressType = "";
                yfeiUPIService.payeeDetails = {
                    payeeType: "VPA",
                    requestType: 'pay',
                    accountNo: "",
                    ifsc: "",
                    name: frequnt.payeeName || "",
                    vpa: frequnt.payeeVirtualAddress || "",
                    amount: "",
                    remark: "",
                    nickName: "",
                    phoneNumber: "",
                    savePayee: false,
                    pageName: "Pay via UPI ID",
                    payType: "frequentlyPay"
                }
            }
            yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            yfeiUPIService.navigationFromDashboard = true;
            $state.go('menu.payUpi');
        }

        dashboardVM.viewAccBalance = function () {
            yfeiUPIService.selectedAccountDtls = dashboardVM.accountDtl;
            yfeiUPIService.pageName = 'Dashboard';
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "virtualAddress": dashboardVM.primaryVPAId,
                "accountId": dashboardVM.accountDtl.accId
            });
            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onBalanceEnquiry, json).then(function (data) {
                utilityService.hideSpinner();
                var checkBalanceRes = JSON.parse(data).apiResp;
                if (checkBalanceRes.status == 'S') {
                    yfeiUPIService.balanceDetails = checkBalanceRes.accountInfo;
                    $state.go("menu.checkBalance");
                } else {
                    yfeiUPIService.showUpiAlert("error", checkBalanceRes.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                if (msg != -101){
                    yfeiUPIService.showUpiAlert("error", msg);
                }
            });
        }

        dashboardVM.generateQrImage = function (virtualAddress) {
            yfeiUPIService.dashTransactionSelection = "UPI ID";
            yfeiUPIService.createQr = {
                virtualAddress: virtualAddress,
                vpaName: dashboardVM.custName
            }
            $state.go("menu.createQRCode");
        }

        dashboardVM.collectRequestsPopup = function (event) {
            utilityService.showSpinner();
            dashboardVM.collectRequestsList = [];
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getcollectList, json).then(function (data) {
                var collectRequestsResp = JSON.parse(data);
                utilityService.hideSpinner();
                if (collectRequestsResp.status == 'S') {
                    dashboardVM.collectRequestsList = collectRequestsResp.collectList;
                    yfeiUPIService.collectRequestsList = collectRequestsResp.collectList;
                    if (dashboardVM.collectRequestsList && dashboardVM.collectRequestsList.length > 0) {
                        dashboardVM.paymentRequestView(dashboardVM.collectRequestsList[0]);
                        yfeiUPIService.openRequestPaymentPopupFlag = false;
                    }
                } else {
                    yfeiUPIService.showUpiAlert("error", collectRequestsResp.statusDesc);
                }
                dashboardVM.transactionHistory(event)
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        dashboardVM.collectRequests = function () {
            dashboardVM.collectRequestsList = [];
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getcollectList, json).then(function (data) {
                var collectRequestsResp = JSON.parse(data);
                if (collectRequestsResp.status == 'S') {
                    dashboardVM.collectRequestsList = collectRequestsResp.collectList;
                    yfeiUPIService.collectRequestsList = collectRequestsResp.collectList;
                } else {
                    yfeiUPIService.showUpiAlert("error", collectRequestsResp.statusDesc);
                }
                dashboardVM.transactionHistory()
            }, function (msg) {
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        dashboardVM.paymentRequestAll = function () {
            $state.go("menu.paymentRequest");
        }

        dashboardVM.paymentRequestView = function (payRequest) {
            dashboardVM.payRequest = payRequest;
            dashboardVM.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark ',
                templateUrl: "pages/YFEI/home/paymentRequestPopup.html",
                scope: $scope
            });
        }

        dashboardVM.paymentRequestViewAll = function (payRequest) {
            yfeiUPIService.collectRequests = payRequest;
            yfeiUPIService.dashTransactionSelection = "Payment Request";
            $state.go("menu.paymentRequestForm");
        }

        dashboardVM.paymentRequestPay = function (payRequest) {
            dashboardVM.myPopup.close();
            yfeiUPIService.collectRequests = payRequest;
            yfeiUPIService.dashTransactionSelection = "Payment Request";
            $state.go("menu.paymentRequestForm");
        }

        dashboardVM.paymentRequestDecline = function (payRequest) {
            dashboardVM.myPopup.close();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "approvalStatus": "R",
                "expiryTime": 0,
                "npciTranId": payRequest.txnId,
                "payerType": {
                    "accountId": "1234",
                    "virtualAddress": "sbi"
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "upiTransRefNo": payRequest.upiTrnRefNo
            });
            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function (data) {
                utilityService.hideSpinner();
                var collectApproveResp = JSON.parse(data).apiResp;
                if (collectApproveResp.status == 'R') {
                    yfeiUPIService.showUpiAlert("success", collectApproveResp.statusDesc);
                    dashboardVM.collectRequests();
                } else {
                    yfeiUPIService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showBhimUpiAlert("error", msg);
            });
        }

        dashboardVM.paymentRequestLater = function () {
            dashboardVM.myPopup.close();
        }

        dashboardVM.payToBank = function () {
            yfeiUPIService.navigateUrl = 'payToBank';
            $state.go('menu.addBankList');
        }

        dashboardVM.logout = function () {
            dashboardVM.logoutPopUp = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/YFEI/home/logoutPopUp.html",
                scope: $scope
            });
        }

        dashboardVM.cancel = function () {
            dashboardVM.logoutPopUp.close();
        }

        dashboardVM.logoutYfei = function () {
            dashboardVM.logoutPopUp.close();
            yfeiUPIService.userLogout().then(
                function (data) {
                    console.log(data);
                    dashboardVM.exitApplication();
                    
                },
                function (error) {
                    dashboardVM.exitApplication();
                }
            );
        }

        dashboardVM.exitApplication = function () {
            APICUtils.secretId = "";
            if (utilityService.isAndroidPlatform()) {
                ionic.Platform.exitApp();
            } else {
                $state.go("menu.yfeiLogin");
            }         
            
        };
       

        dashboardVM.navigateHomeLoan = function (pageName) {
            yfeiUPIService.yfeiNavigation = pageName;
            $state.go('menu.hlNTBExploreHomeLoan');
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }

        dashboardVM.navigateCarLoan = function (pageName) {
            yfeiUPIService.yfeiNavigation = pageName;
            $state.go('menu.clNTBExploreCarLoan');
        }

        dashboardVM.openSavingsAccount = function (pageName) {
            yfeiUPIService.yfeiNavigation = pageName;
            $state.go("menu.newToSbiLanding");
        }

        return this;
    }



]);
