'use strict';

angularApp.controller('paymentRequestFormController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig
    ) {

        var paymentReqFormVm = this;
        $scope.$on('$ionicView.beforeEnter', function () {
            paymentReqFormVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
            paymentReqFormVm.collectRequests = yfeiUPIService.collectRequests;
            if (localStorage.getItem("customerName")) {
                paymentReqFormVm.collectRequests.payerName = localStorage.getItem("customerName");
            } else {
                paymentReqFormVm.collectRequests.payerName = "";
            }
        });
        paymentReqFormVm.goBack = function () {
            if (paymentReqFormVm.dashboardSelItem == 'Payment Request') {
                $state.go("menu.paymentRequest");
            } else if (paymentReqFormVm.dashboardSelItem == 'Frequently Paid' || paymentReqFormVm.dashboardSelItem == 'Pay via UPI ID') {
                $state.go("menu.payUpi");
            } else {
                $state.go("menu.dashboard");
            }

        }

        paymentReqFormVm.decline = function () {
            utilityService.showSpinner();
            if(yfeiUPIService.collectRequestsList && (!paymentReqFormVm.collectRequests.txnId || !paymentReqFormVm.collectRequests.upiTrnRefNo)){
                for(var i = 0; i < yfeiUPIService.collectRequestsList.length; i++){
                    if(yfeiUPIService.collectRequestsList[i].custRefNo == paymentReqFormVm.collectRequests.custRefNo && yfeiUPIService.collectRequestsList[i].txnAmount == paymentReqFormVm.collectRequests.txnAmount){
                        paymentReqFormVm.collectRequests.txnId = yfeiUPIService.collectRequestsList[i].txnId
                        paymentReqFormVm.collectRequests.upiTrnRefNo = yfeiUPIService.collectRequestsList[i].upiTrnRefNo
                    }
                }

            }
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "approvalStatus": "R",
                "expiryTime": 0,
                "npciTranId": paymentReqFormVm.collectRequests.txnId,
                "payerType": {
                    "accountId": "1234",
                    "virtualAddress": "sbi"
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "upiTransRefNo": paymentReqFormVm.collectRequests.upiTrnRefNo
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onCollectApprove, json).then(function (data) {
                var collectApproveResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
                if (collectApproveResp.status == 'R') {
                    yfeiUPIService.transactionHistory = "";
                    yfeiUPIService.showUpiAlert("success", collectApproveResp.statusDesc, "menu.dashboard");
                } else {
                    yfeiUPIService.showBhimUpiAlert("error", collectApproveResp.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showBhimUpiAlert("error", msg);
            });
        }

        paymentReqFormVm.pay = function () {
            yfeiUPIService.payeeDetails = {
                payeeType: "VPA",
                requestType: 'pay',
                accountNo: "",
                ifsc: "",
                name: paymentReqFormVm.collectRequests.payeeName,
                vpa: paymentReqFormVm.collectRequests.payeeVa,
                amount: paymentReqFormVm.collectRequests.txnAmount,
                remark: paymentReqFormVm.collectRequests.txnNote,
                nickName: "",
                phoneNumber: "",
                savePayee: false,
                pageName: "Payment Request",
                payType: "paymentRequest"
            }

            if (paymentReqFormVm.dashboardSelItem == 'Payment Request') {
                yfeiUPIService.dashTransactionSelection = "Payment Request";
            } else {
                yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            }
            $state.go('menu.scanAndPay');
        }

        return this;
    }



]);
