'use strict';
angularApp.controller('yfeiLoginController',
    ["$scope",
        "$rootScope",
        "$ionicScrollDelegate", "$ionicSideMenuDelegate", "loggedInUserService", "utilityService", "ConnectivityMonitorUtils", "yfeiUPIService", "cryptoService", "$state",
        "encryptionService",
        "AdapterUtils", "clickStreamService", "constantConfig", "$ionicPopup", "APICUtils", "$filter", "$q",
        function (
            $scope,
            $rootScope,
            $ionicScrollDelegate, $ionicSideMenuDelegate, loggedInUserService, utilityService, ConnectivityMonitorUtils, yfeiUPIService, cryptoService, $state, encryptionService, AdapterUtils, clickStreamService, constantConfig, $ionicPopup, APICUtils, $filter, $q) {


            var yfeiLoginVM = this;
            yfeiLoginVM.securityCheckName = "YFEIAuthSecurityCheck";
            yfeiLoginVM.isChallenged = false;
            yfeiLoginVM.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(yfeiLoginVM.securityCheckName);
            yfeiLoginVM.mPinAuthChallengeHandler.securityCheckName = yfeiLoginVM.securityCheckName;
            $scope.err = '';
            yfeiLoginVM.mpinErrorMsg = "";
            yfeiLoginVM.mpinErrorMsgFlag = false;
            yfeiUPIService.yfeiNavigation = "";
            yfeiLoginVM.customerName = "";
            yfeiLoginVM.openSavingsAccount = function (pageName) {
                yfeiUPIService.yfeiNavigation = pageName;
                $state.go("menu.newToSbiLanding");
            }

            yfeiLoginVM.navigateHomeLoan = function (pageName) {
                yfeiUPIService.yfeiNavigation = pageName;
                $state.go('menu.hlNTBExploreHomeLoan');
                if (!$scope.$$phase)
                    $scope.$apply();
            }

            yfeiLoginVM.navigateCarLoan = function (pageName) {
                yfeiUPIService.yfeiNavigation = pageName;
                $state.go('menu.clNTBExploreCarLoan');
            }

          
            yfeiLoginVM.navigateContactUs = function (pageName) {
                yfeiUPIService.yfeiNavigation = pageName;
                $state.go('menu.yfeiContactUs');
            }

            $scope.$on('$ionicView.loaded', function () {
                $ionicSideMenuDelegate.canDragContent(false);
                navigator.splashscreen.hide();
                yfeiLoginVM.setDefaultLoginOptions();
                yfeiLoginVM.customerName = localStorage.getItem("customerName");
		yfeiLoginVM.checkVersionIntegrity();
                if (!APICUtils.secretId) {
                    yfeiLoginVM.initiate();
                }
                else{
                    checkAppUpdate();  
                }
            });

            function checkAppUpdate () {
                if (APICUtils.appOutdateFlag) {
                    var message = $filter('limitTo')(APICUtils.appOutdateMessage, 180);
                    var exitAppButton = utilityService.isAndroidPlatform() ? '<button class="btn exitBtn" ng-click="yfeiLoginVM.exitForUpdateApp()">Exit</button>' : '';
                    yfeiLoginVM.appUpdatePopup = $ionicPopup.show({
                        template: '<div class="popup-body"><div class="appUpdateContainer"><img class="appUpdateLogo" src="img/OMP/appUpdate.svg" alt="App update Logo"/></div><div class="appUpdateHeading">App Update Available</div><div class="appUpdateInfo">' + message + '</div><button class="btn updateAppBtn marginBottom4" ng-click="yfeiLoginVM.updateToStore()">Update</button>' + exitAppButton + '</div></p>',
                        title: '',
                        scope: $scope,
                        cssClass: 'app-update-popup'
                    });
                    var elem = angular.element(document.querySelector(".backdrop"));
                    if (elem) {
                        elem.addClass('app-update-backdrop');
                    }
                }
            }
           
            yfeiLoginVM.exitForUpdateApp = function () {
                ionic.Platform.exitApp();
                navigator.app.exitApp();
            };
    
            yfeiLoginVM.updateToStore = function () {
                utilityService.upgradeApp();
            };

            $scope.showKeyboard = function () {
                $scope.keyboardVisible = true;
                $ionicScrollDelegate.$getByHandle('mainScroll').resize();
            }

            yfeiLoginVM.closeDeviceLockPopup = function () {
                yfeiLoginVM.deviceLockPopup.close();
            }

            yfeiLoginVM.initiate = function () {
                var appVersion = WL.StaticAppProps.APP_VERSION ? WL.StaticAppProps.APP_VERSION : '';
                var payload = {};
                if (appVersion) {
                    payload.appCode = cryptoService.getSHA512EncryptedData(appVersion).toString();
                }
                payload.keys = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
                payload.irf = yfeiUPIService.deviceRegistered ? 'true' : 'false';
                payload.irv = cryptoService.getSHA512EncryptedData(payload.irf).toString();
                payload.deviceid = cryptoService.encryptRSAWithPublicKey(device.uuid, cryptoService.rsaPublicKey);
                payload.gethDid = cryptoService.getSHA512EncryptedData(device.uuid).toString();
                yfeiUPIService.initiate(payload).then(
                    function (data) {
                        var responseObj = data;
                        APICUtils.secretId = responseObj.data.sid;
                        yfeiUPIService.keyId = responseObj.data.mkid;
                        loggedInUserService.upiPermissionKey = responseObj.data.upiPermissionVal;
                        APICUtils.clientID =  encryptionService.getAES256DecryptedData(responseObj.data.clientId);
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        APICUtils.appOutdateFlag = responseObj.data.appOutdateFlag === "true" ? true : false;
                        APICUtils.appOutdateMessage = responseObj.data.appOutdateMessage;
                        if (responseObj.data.appOutdateFlag) {
                            checkAppUpdate();
                        }
                    },
                    function (error) {
                        if (error.responseMessage) {
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                        else {
                            utilityService.showErrorMessage("Technical error occured");
                        }

                    }
                );
            }

            $scope.password = '';
            $scope.canErase = false;
            $scope.pinDotVisible = {};
            $scope.success = null;
            $scope.keyboardVisible = false;

            $scope.pinArray = [];
            $scope.keyboardSettings = {
                // settings here
                action: function (number) {
                    if ($scope.password.length < 6) {
                        yfeiLoginVM.mpinErrorMsgFlag = false;
                        $scope.password += number;
                        $scope.pinArray.push(number);
                        $scope.pinDotVisible[$scope.password.length] = true;
                        $scope.canErase = true;
                        $scope.success = null;
                        var pass = $scope.password;
                        pass = pass.split("");
                        try {
                            yfeiLoginVM.first = pass[0];
                            yfeiLoginVM.second = pass[1];
                            yfeiLoginVM.third = pass[2];
                            yfeiLoginVM.fourth = pass[3];
                            yfeiLoginVM.fifth = pass[4];
                            yfeiLoginVM.sixth = pass[5];
                        } catch (err) { }
                    }

                    if ($scope.password && $scope.password.length === 6) {
                        var e = {};
                        $scope.newMpin = $scope.password;
                        var passEq = $scope.password;
                        passEq = passEq.split("");
                        try {
                            yfeiLoginVM.first = passEq[0];
                            yfeiLoginVM.second = passEq[1];
                            yfeiLoginVM.third = passEq[2];
                            yfeiLoginVM.fourth = passEq[3];
                            yfeiLoginVM.fifth = passEq[4];
                            yfeiLoginVM.sixth = passEq[5];
                        } catch (err) { }
                        e.srcElement = {};
                        e.srcElement.value = 2;
                        yfeiLoginVM.changeInput(e, 6);
                    }

                },
                // Clear
                leftButton: {
                    html: '<i class="icon ion-backspace"></i>',
                    action: function () {
                        $scope.doErase();
                    },
                    style: {
                        bgColor: '#fff',
                        activeBgColor: '#dfdfdf',
                        borderColor: '#dfdfdf',
                        fontSize: '20px'
                    }
                },
                // Submit login
                rightButton: {
                    html: '<i class="icon ion-eye"></i>	<i class="icon ion-eye-disabled login-eye-btn" ></i>',
                    action: function () {
                        if ($scope.isPassVisible) {
                            var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
                            elementHide.classList.add("login-eye-btn");
                            var elementShow = document.getElementsByClassName("ion-eye")[0];
                            elementShow.classList.remove("login-eye-btn");

                            $scope.isPassVisible = false;
                        } else {
                            $scope.isPassVisible = true;
                            var elementHideT = document.getElementsByClassName("ion-eye")[0];
                            elementHideT.classList.add("login-eye-btn");
                            var elementShowT = document.getElementsByClassName("ion-eye-disabled")[0];
                            elementShowT.classList.remove("login-eye-btn");
                        }
                    },
                    style: {
                        bgColor: '#fff',
                        activeBgColor: '#dfdfdf',
                        borderColor: '#dfdfdf',
                        fontSize: '30px'
                    }
                }
            }
            $scope.eraseMpin = function () {
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
            }
            $scope.doErase = function () {
                $scope.pinDotVisible[$scope.password.length] = false;
                $scope.password = $scope.password.slice(0, -1);
                if ($scope.password.length == 0) $scope.canErase = false;
                try {
                    var pass = $scope.password;
                    pass = pass.split("");
                    yfeiLoginVM.first = pass[0] ? pass[0] : "";
                    yfeiLoginVM.second = pass[1] ? pass[1] : "";
                    yfeiLoginVM.third = pass[2] ? pass[2] : "";
                    yfeiLoginVM.fourth = pass[3] ? pass[3] : "";
                    yfeiLoginVM.fifth = pass[4] ? pass[4] : "";
                    yfeiLoginVM.sixth = pass[5] ? pass[5] : "";
                } catch (err) { }
            }

            yfeiLoginVM.changeInput = function ($event, index) {
                cordova.plugins.Keyboard.close();

                $rootScope.hidekeypad($event);
                    yfeiLoginVM.loginWithMpin();

            }

            function clearMpin() {
                yfeiLoginVM.first = '';
                yfeiLoginVM.second = '';
                yfeiLoginVM.third = '';
                yfeiLoginVM.fourth = '';
                yfeiLoginVM.fifth = '';
                yfeiLoginVM.sixth = '';
            }

            $scope.eraseMpin = function () {
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
                $scope.doErase();
            }
            yfeiLoginVM.forgotLogin = function () {
                yfeiLoginVM.forgotMpinPopUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/YFEI/login/yfeiForgotMpinPopup.html",
                    scope: $scope
                });
            }

            yfeiLoginVM.deReigsterDevice = function () {
                yfeiLoginVM.forgotMpinPopUp.close();
                yfeiUPIService.fileStorageRemove();
              
                readSimcardInfo(true);
            }

            yfeiLoginVM.cancelPopUp = function () {
                yfeiLoginVM.forgotMpinPopUp.close();
            }

            yfeiLoginVM.loginWithMpin = function () {

                var newMpin = yfeiLoginVM.first.trim() +
                    yfeiLoginVM.second.trim() +
                    yfeiLoginVM.third.trim() +
                    yfeiLoginVM.fourth.trim() +
                    yfeiLoginVM.fifth.trim() +
                    yfeiLoginVM.sixth.trim();

                if (newMpin.length == 6) {
                    if (ConnectivityMonitorUtils.isOffline()) {
                        eraseMpinData();

                        utilityService.offlineAlert();
                        return;
                    }
                
                // this code is done for ISD fix
                if (/(.)\1\1/.test(newMpin.toString())) {
                    eraseMpinData();
                    yfeiLoginVM.mpinErrorMsg = "Invalid MPIN";
                    return;
                }

                for (var i = 0; i < 4; i++) {
                    if (newMpin[i + 1] == parseInt(newMpin[i]) + 1) {
                        if (newMpin[i + 2] == parseInt(newMpin[i + 1]) + 1) {
                            eraseMpinData();
                            yfeiLoginVM.mpinErrorMsg = "Invalid MPIN";
                            
                            return;
                        }
                    }
                }

                for (var j = 0; j < 4; j++) {
                    if (newMpin[j] == parseInt(newMpin[j + 1]) + 1) {
                        if (newMpin[j + 1] == parseInt(newMpin[j + 2]) + 1) {
                            eraseMpinData();
                            yfeiLoginVM.mpinErrorMsg = "Invalid MPIN";
                            return;
                        }
                    }
                }
                // this code is done for ISD fix - end
                    
                    yfeiLoginVM.yfeiLoginWithMPin(newMpin);

                } else {

                    eraseMpinData();
                    yfeiLoginVM.mpinErrorMsg = "Invalid MPIN";
                }
            };

           yfeiLoginVM.yfeiLoginWithMPin = function (UserMpin) {
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_START"));
                var authPayload = {};
                authPayload.deviceid = device.uuid;
               
                if (yfeiLoginVM.isBiometricLogin) {
                    yfeiUPIService.finalSHA512Val = yfeiUPIService.generateBiometricSHA512Val(yfeiLoginVM.fingerprintToken);
                  
                    authPayload.data = APICUtils.secretId + "^Bio" + yfeiUPIService.finalSHA512Val;
                }
                else {
                    var simId = localStorage.getItem("simSubscriptionId");
                    if (utilityService.isAndroidPlatform()) {
                        yfeiUPIService.finalSHA512Val = yfeiUPIService.generateMPINSHA512ValWithSim(UserMpin, simId);
                    }
                    else {
                        yfeiUPIService.finalSHA512Val = yfeiUPIService.generateMPINSHA512Val(UserMpin);
                    }
                   
                    authPayload.data = APICUtils.secretId + "^" + yfeiUPIService.finalSHA512Val;
                }

                utilityService.showSpinner();

                yfeiUPIService.yfeiLoginAuthorize(authPayload).then(
                    function (data) {
                        var codeData = data;
                        var splitUrls = codeData.split("=");
                        let splittedUrl1 = splitUrls[0];
                        let splittedUrl2 = splitUrls[1];
                        var jsonObj = {};
                        if (splittedUrl1 == "code") {
                           
                            var reqObj = { "requestKey": "readStatus" };
                            yfeiUPIService.getAuthError(reqObj).then(
                                function (data) {
                                    utilityService.hideSpinner();
                                    if (data.scrId) {
                                        APICUtils.clientSecret = encryptionService.getAES256DecryptedData(data.scrId);
                                        jsonObj.code = splittedUrl2;
                                        jsonObj.client_id = APICUtils.clientID; //clent id
                                        jsonObj.client_secret = APICUtils.clientSecret;
                                        jsonObj.grant_type = "authorization_code";
                                        jsonObj.scope = APICUtils.authScope;

                                        utilityService.accessRestricted = "";
                                        utilityService.hideSpinner();

                                        yfeiUPIService.getAuthToken(jsonObj).then(
                                            function (data) {
                                                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_SUCCESS"));
                                                yfeiLoginVM.checkDeviceCall();
                                                var tokenResponse = JSON.parse(data);
                                                loggedInUserService.accessToken = tokenResponse.access_token;
                                                APICUtils.isUserLoggedIn = true;
                                            }, function (error) {
                                                yfeiLoginVM.isBiometricLogin = false;
                                                if (error.responseMessage) {
                                                    utilityService.showErrorMessage(error.responseMessage);
                                                }
                                                else {
                                                    utilityService.showErrorMessage("Technical error occured");
                                                }
                                            });
                                    }
                                    else {
                                        eraseMpinData();   
                                        yfeiLoginVM.isBiometricLogin = false;  
                                        utilityService.showErrorMessage("Technical error occured");
                                    }
    
                                }, function (error) {                                  
                                    yfeiLoginVM.isBiometricLogin = false;                             
                                    utilityService.hideSpinner();                                   
                                    eraseMpinData();                               
                                    if (error.responseCode) {
                                            utilityService.showErrorMessage(error.responseMessage);
                                        }
                                    
                                    else {
                                        utilityService.showErrorMessage("Technical error occured");
                                    }
    
                                });
    
                           
                        }
                        else {
                             eraseMpinData();
                            utilityService.accessRestricted = "";
                            yfeiLoginVM.mpinErrorMsgFlag = true;
                            yfeiLoginVM.mpinErrorMsg = "";
                            yfeiLoginVM.isBiometricLogin = false;
                            utilityService.showErrorMessage("Technical error occured");
                        }

                    },
                    function (error) {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_FAILURE"));
                        eraseMpinData();
                        utilityService.accessRestricted = "";
                        yfeiLoginVM.mpinErrorMsgFlag = true;
                        yfeiLoginVM.isBiometricLogin = false;
                        var reqObj = { "requestKey": "readStatus" };
                        yfeiUPIService.getAuthError(reqObj).then(
                            function (data) {
                                utilityService.hideSpinner();
                            }, function (error) {
                                utilityService.hideSpinner();
                                if (error.responseCode) {
                                    if (error.responseCode == "A100" || error.responseCode == "A200") //A200 for bioauth and A100 for mpin
                                    {
                                        yfeiLoginVM.mpinErrorMsg = error.responseMessage;
                                    }
                                    else if (error.responseCode == "A110" || error.responseCode == "DM101") {
                                        yfeiUPIService.fileStorageRemove();
                                        yfeiLoginVM.mpinErrorMsg = "";
                                        yfeiUPIService.threeAttemptWrongFlag = "ThreeWrongAttempt";
					  APICUtils.secretId = "";
                                        yfeiUPIService.showUpiAlert("alert", error.responseMessage, "menu.preRegistrationSelection","Continue");
                                    }
                                    else {
                                        yfeiLoginVM.mpinErrorMsg = error.responseMessage;
                                    }
                                }
                                else {
                                    yfeiLoginVM.mpinErrorMsg = "Technical error occured";
                                }

                            });

                    });
            }
            yfeiLoginVM.checkDeviceCall = function () {
                utilityService.showSpinner();
                if (!localStorage.getItem("yfeiAppGenId")) {
                    yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (data) {
                        if (device.platform.toLowerCase() == 'android') {
                            yfeiUPIService.yfeiAppGenId = data.appGenId;
                        } else {
                            yfeiUPIService.yfeiAppGenId = data;
                        }
                        yfeiLoginVM.redirectToUPIFlow();
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                        eraseMpinData();

                    });
                } else {
                    yfeiUPIService.getNativeData("setAppGenId", localStorage.getItem("yfeiAppGenId")).then(function (data) {
                        yfeiLoginVM.redirectToUPIFlow();
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                        eraseMpinData();

                    });
                }
            }
            yfeiLoginVM.redirectToUPIFlow = function () {
                if (device.platform.toLowerCase() == 'android') {
                    utilityService.showSpinner();
                    var json = JSON.stringify({});
                    yfeiUPIService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
                        if (data.permission === 'Allowed') {
                            readSimcardInfo();
                        } else {
                            utilityService.hideSpinner();
                            yfeiUPIService.showUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                            eraseMpinData();

                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                        eraseMpinData();

                    });
                }
                else { //for ios
                    readSimcardInfo();
                }

            }
            //for android check device
            yfeiLoginVM.redirectToAndroidUPIJourney = function (isDeregister) {
                /*Sim card Info fetching - Start*/
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "smsSent": false
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                    $rootScope.yfeiCheckDeviceInfo = JSON.parse(data);
                    if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
                        if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN') {
                            yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (resp) {
                                utilityService.hideSpinner();
                                yfeiUPIService.appGenId = resp.appGenId;
                                $state.go('menu.yfeiSimSelection');
                            }, function (msg) {
                                utilityService.hideSpinner();
                                yfeiUPIService.showUpiAlert("error", msg);
                                eraseMpinData();

                            });
                        } else if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') {
                            utilityService.hideSpinner();
                            if ($rootScope.yfeiCheckDeviceInfo.re_verify && $rootScope.yfeiCheckDeviceInfo.re_verify == 'Y') {
                                yfeiUPIService.showUpiAlert("alert", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                                eraseMpinData();

                            } else {
                                if (isDeregister) {
                                    yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (resp) {
                                        utilityService.hideSpinner();
                                        yfeiUPIService.appGenId = resp.appGenId;
                                        $state.go('menu.yfeiSimSelection');
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        yfeiUPIService.showUpiAlert("error", msg);
                                        $state.go('menu.yfeiSimSelection');
        
                                    });
                                }
                                else {
                                    yfeiUPIService.openRequestPaymentPopupFlag = true;
                                    $state.go('menu.dashboard');
                                }
                               
                            }
                        } else if (($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') || ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN')) {
                            utilityService.hideSpinner();
                            yfeiUPIService.fileStorageRemove();
                            yfeiUPIService.showUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.preRegistrationSelection");
                        }
                    } else {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                        eraseMpinData();

                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                    eraseMpinData();

                });
            };

            function eraseMpinData() {
                clearMpin();
                $scope.eraseMpin();
                yfeiLoginVM.mpinErrorMsgFlag = true;
                yfeiLoginVM.mpinErrorMsg ="";
            }

            function readSimcardInfo(isDeregister) {
                /*Sim card Info fetching - Start*/
                function simInfosuccessCallback(result) {
                    if (result !== undefined && result != null && result != '') {
                        if (utilityService.isIOSPlatform()) {
                            if (result.countryCode === '' || result.mnc === '' || result.mcc === '' || result.carrierName === '' || result.carrierName === 'No service') {
                                yfeiUPIService.fileStorageRemove();
                                yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg, "menu.preRegistrationSelection");
                            } else {
                                yfeiUPIService.simCardInfo = result;
                                yfeiLoginVM.redirectToiOSUPIJourney(isDeregister);

                            }
                        }
                        else {
                            if (result.cards && result.cards.length > 0) {
                                yfeiUPIService.simCardInfo = result;
                                yfeiLoginVM.redirectToAndroidUPIJourney(isDeregister);
                            }
                            else {
                                utilityService.hideSpinner();
                                eraseMpinData();
                                yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg);
                            }

                        }
                    }
                    else {
                        utilityService.hideSpinner();
                        eraseMpinData();
                        yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg);
                    }

                }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallback(error) {
                    utilityService.hideSpinner();
                    utilityService.showExitAlertPopup("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
                }
                if (utilityService.isIOSPlatform()) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                }
                else hasReadPermission();

                /*Sim card Info fetching - End*/
            }



            yfeiLoginVM.redirectToiOSUPIJourney = function (isDeregister) {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "pspId": constantConfig.upiConstant.pspId,
                    "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
                });
                yfeiUPIService.getNativeData("initializeIOSsdk", json).then(function (res) {
                    if (res !== "S") {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", res);
                        return false;
                    }
                    utilityService.showSpinner();
                    var jsonCheck = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "updateFlag": constantConfig.upiConstant.updateFlag,
                        "smsSent": "false"
                    });
                    yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, jsonCheck).then(function (data) {
                        $rootScope.yfeiCheckDeviceInfo = JSON.parse(data);
                        if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
                            if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN') {
                                yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (resp) {
                                    utilityService.hideSpinner();
                                    yfeiUPIService.appGenId = resp;
                                    $state.go('menu.yfeiSimSelection');
                                }, function (msg) {
                                    utilityService.hideSpinner();
                                    yfeiUPIService.showUpiAlert("error", msg);
                                    eraseMpinData();

                                });
                            } else if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') {
                                utilityService.hideSpinner();
                                if ($rootScope.yfeiCheckDeviceInfo.re_verify && $rootScope.yfeiCheckDeviceInfo.re_verify == 'Y') {
                                    yfeiUPIService.showUpiAlert("alert", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                                    eraseMpinData();
                                } else {
                                    if(isDeregister)
                                    {
                                        yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (resp) {
                                            utilityService.hideSpinner();
                                            yfeiUPIService.appGenId = resp;
                                            $state.go('menu.yfeiSimSelection');
                                        }, function (msg) {
                                            $state.go('menu.yfeiSimSelection');
                                            utilityService.hideSpinner();
                                             console.log(msg);
                                          
                                            eraseMpinData();
        
                                        });
                                        
                                    }
                                    else{
                                    yfeiUPIService.openRequestPaymentPopupFlag = true;
                                    $state.go('menu.dashboard');
                                    }
                                    

                                }
                            } else if (($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') || ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN')) {
                                utilityService.hideSpinner();
                                yfeiUPIService.fileStorageRemove();
                                yfeiUPIService.showUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.preRegistrationSelection");
                            }
                        } else {
                            utilityService.hideSpinner();
                            yfeiUPIService.showUpiAlert("error", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                        eraseMpinData();

                    });
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                    eraseMpinData();

                });
            }

            yfeiLoginVM.serverConnectErrorPopup = function (errorMsg) {
                if (yfeiLoginVM.MPINLoginFlag) {
                    eraseMpinData();
                }
                else {
                    yfeiLoginVM.userName = "";
                    yfeiLoginVM.password = "";
                }
                utilityService.hideSpinner();
                if (errorMsg == null || errorMsg == "" || errorMsg == '') {
                    utilityService.showErrorMessage($scope.err);
                }
                else {
                    utilityService.showErrorMessage(errorMsg);
                }
            };
            $rootScope.hidekeypad = function ($event) {
                switch ($event) {
                    case "mpin1 activated":
                    // code block

                    case "mpin1":
                    // code block

                    case "digit-keyboard-key":
                    // code block

                    case "digit-keyboard-key-action ng-binding":
                    // code block

                    case "icon ion-record":
                    // code block

                    case "digit-keyboard-key activated":
                    // code block

                    case "icon ion-backspace":
                    // code block

                    case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
                    // code block

                    case "mpin1 ng-binding":
                    // code block

                    case "icon ion-eye-disabled login-eye-btn":
                    // code block

                    case "icon ion-eye login-eye-btn":
                    // code block

                    case "digit-keyboard-key-number":
                    // code block
                    default:
                        // code block
                        if ($scope.keyboardVisible) {
                            $scope.hideKeyboard();
                        }
                        break;
                }
            }

            $scope.hideKeyboard = function () {
                $scope.keyboardVisible = false;
            }

            yfeiLoginVM.checkVersionIntegrity = function () {
                if (APICUtils.latestAndroidAppVersion && APICUtils.latestIOSAppVersion) {
                    var latestAndroidAppVersion_components = APICUtils.latestAndroidAppVersion.split(".");
                    var latestIOSAppVersion_components = APICUtils.latestIOSAppVersion.split(".");
                    var appVersion_components = loggedInUserService.vesionNumber.split(".");
                    if (!localStorage.getItem('ignoredYFEIVersion')) {
                        localStorage.setItem('ignoredYFEIVersion', "0.0.0");
                    }
                    yfeiLoginVM.ignoredVersion = localStorage.getItem('ignoredYFEIVersion');
                    var ignoredVersion_components = yfeiLoginVM.ignoredVersion.split(".");
                    var lenAndroid = Math.min(latestAndroidAppVersion_components.length, appVersion_components.length);
                    var lenIOS = Math.min(latestIOSAppVersion_components.length, appVersion_components.length);

                    if (ionic.Platform.isAndroid()) {

                        for (var i = 0; i < lenAndroid; i++) {
                            if (parseInt(latestAndroidAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestAndroidAppVersion_components[i]) > parseInt(appVersion_components[i])) {

                                yfeiLoginVM.appUpdatePopup = $ionicPopup.show({
                                    template: '<p><center>Update for app is available. Current version is ' + loggedInUserService.vesionNumber + '. Latest Version is ' + APICUtils.latestAndroidAppVersion + '. Please Update</p>',
                                    title: '',
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text: 'Update',
                                        type: 'button-assertive',
                                        onTap: function () {

                                            cordova.plugins.market.open('com.sbi.lotusintouch');
                                        }
                                    },

                                    {
                                        text: 'Later',
                                        type: 'button-assertive',
                                        onTap: function () {

                                            localStorage.setItem('ignoredYFEIVersion', APICUtils.latestAndroidAppVersion);
                                        
                                        }
                                    }],

                                });

                                break;
                            }
                          


                        }

                    }
                    if (ionic.Platform.isIOS()) {

                        for (var i = 0; i < lenIOS; i++) {

                            if (parseInt(latestIOSAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestIOSAppVersion_components[i]) > parseInt(appVersion_components[i])) {
                                yfeiLoginVM.appUpdatePopup = $ionicPopup.show({
                                    template: '<p><center>Update for app is available. Current version is ' + loggedInUserService.vesionNumber + '. Latest Version is ' + APICUtils.latestIOSAppVersion + '. Please Update</p>',
                                    title: '',
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text: 'Update',
                                        type: 'button-assertive',
                                        onTap: function () {

                                            cordova.plugins.market.open('id1231393474');
                                        }
                                    },

                                    {
                                        text: 'Later',
                                        type: 'button-assertive',
                                        onTap: function () {

                                            localStorage.setItem('ignoredYFEIVersion', APICUtils.latestIOSAppVersion);
                                          
                                        }
                                    }],

                                });
                                break;
                            }


                        }

                    }

                }
              
            }
            yfeiLoginVM.setDefaultLoginOptions = function () {
                yfeiLoginVM.isBiometricSet = localStorage.getItem("isYfeiBiometricSet");
                if (yfeiLoginVM.isBiometricSet == undefined || yfeiLoginVM.isBiometricSet == "false") {
                    yfeiLoginVM.isBiometricSet = false;
                }
                else {
                    yfeiLoginVM.isBiometricSet = true;
                    yfeiUPIService.isFingerprintAvailable().then(function (response) {
                        yfeiLoginVM.isFingerprintAvl = response.responseMessage;
                        if (yfeiUPIService.isBiometricType == 'face') {
                            yfeiLoginVM.bio_text = "Face ID";
                            yfeiLoginVM.checBioMetric();
                        }
                        else if (yfeiUPIService.isBiometricType == 'finger' || yfeiUPIService.isBiometricType == 'biometric') {
                            yfeiLoginVM.bio_text = "Touch ID";
                            yfeiLoginVM.checBioMetric();
                        } else {
                            yfeiLoginVM.bio_text = "";
                        }

                    });
                }
            }

            yfeiLoginVM.checBioMetric = function () {
                var q = $q.defer();
                if (yfeiLoginVM.isFingerprintAvl) {
                    cordova.plugins.SecureKeyStore.get(function (res) {
                        yfeiLoginVM.fingerprintToken = res;
                        if (yfeiLoginVM.fingerprintToken == null || yfeiLoginVM.fingerprintToken == undefined || yfeiLoginVM.fingerprintToken == "") {
                            q.reject({ "responseMessage": "Fingerprint not found" });
                        }
                        else {
                            yfeiLoginVM.verifyBiometric();
                        }
                    }, function (error) {
                        q.reject({ "responseMessage": "Fingerprint not found" });
                    }, loggedInUserService.deviceInfo);

                }

            }

            yfeiLoginVM.verifyBiometric = function () {
                if (yfeiLoginVM.isFingerprintAvl) {
                    var encryptConfig = {
                        clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                        clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                        disableBackup: true,
                    };
                    Fingerprint.show(encryptConfig, successCallback, errorCallback);
                }
            }

            function successCallback(result) {
                yfeiLoginVM.isBiometricLogin = true;
                yfeiLoginVM.yfeiLoginWithMPin("");
            }
            function errorCallback(error) {
                yfeiLoginVM.isBiometricLogin = false;
            }


        }
    ]);