'use strict';
angularApp.controller('payToBankController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "validationService",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        validationService
    ) {

        var payToBankVM = this;
        payToBankVM.bankNameFlag = false;
        payToBankVM.proceedFlag = false;
        payToBankVM.verifyFlag = false;
        payToBankVM.accountAvailableFlag = false;
        payToBankVM.ifscFlag = false;
        payToBankVM.reEnterAccountFlag = false;
        payToBankVM.limitCount = 4;
        payToBankVM.showFlag = true;
        payToBankVM.recentlyPay = [];
        payToBankVM.proceedDisableFlag = true;
        payToBankVM.showDetailBlock = false;
        payToBankVM.SplitbankName = "";
        payToBankVM.SplitBranch = "";
        payToBankVM.SplitCity = "";
        $scope.$on('$ionicView.beforeEnter', function () {
            payToBankVM.bankData = yfeiUPIService.bankData;
            if (payToBankVM.bankData) {
                payToBankVM.bankNameFlag = true;
                payToBankVM.accountNumber = payToBankVM.bankData.accountNumber ? payToBankVM.bankData.accountNumber : ""
            }
            payToBankVM.recentlyPay = yfeiUPIService.recentlyTransPay;
            payToBankVM.colorCode = yfeiUPIService.colorCode;
            if (yfeiUPIService.withIFSC) {
                payToBankVM.openWithIfsc();
            }

        });


        payToBankVM.goBack = function () {
            if (payToBankVM.ifscFlag) {
                payToBankVM.ifscFlag = false;
            } else {
                $state.go('menu.dashboard');
            }
        }

        payToBankVM.bankList = function () {
            yfeiUPIService.navigateUrl = 'payToBank';
            $state.go('menu.addBankList');
        }

        payToBankVM.showOption = function () {
            payToBankVM.showFlag = !payToBankVM.showFlag;
            payToBankVM.limitCount = payToBankVM.showFlag ? 4 : 8
        }

        payToBankVM.verifyAccount = function (recent) {
            yfeiUPIService.payeeDetails = {
                payeeType: "VPA",
                requestType: 'pay',
                accountNo: recent.payeeAccountNo,
                ifsc: "",
                name: recent.payeeName || "",
                vpa: recent.payeeVirtualAddress || "",
                amount: "",
                remark: "",
                nickName: "",
                phoneNumber: "",
                savePayee: false,
                pageName: "Pay to Bank Account",
                payType: "Pay to Bank Account",
                bank: recent.payeeBankCode
            }

            yfeiUPIService.addressType = "AC";
            yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            $state.go('menu.payUpi');
        }

        payToBankVM.filterIFSC = function () {
            var ifsc = payToBankVM.bankData.bankCode;
            if (ifsc.length == 4) {
                return ifsc + '0000001';
            } else if (ifsc.length == 11) {
                return ifsc;
            } else {
                return "";
            }
        }

        payToBankVM.verify = function () {
            if (!payToBankVM.accountNumber) {
                yfeiUPIService.showUpiAlert("alert", "Please Enter account number");
                return;
            }
            var selectedIfsc = payToBankVM.filterIFSC();
            payToBankVM.virtualAddress = payToBankVM.accountNumber + "@" + selectedIfsc + ".ifsc.npci";
            payToBankVM.verifyUpiIdStatus = '';
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payToBankVM.virtualAddress
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                utilityService.hideSpinner();
                var checkVpaResponse = JSON.parse(data);
                payToBankVM.vpaDetails = checkVpaResponse;
                if (checkVpaResponse.status == 'VE') {
                    yfeiUPIService.payeeDetails = {
                        payeeType: "VPA",
                        requestType: 'pay',
                        accountNo: payToBankVM.accountNumber,
                        ifsc: "",
                        name: checkVpaResponse.payeeType.name || "",
                        vpa: checkVpaResponse.payeeType.virtualAddress || "",
                        amount: "",
                        remark: "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        pageName: "Pay to Bank Account",
                        payType: "Pay to Bank Account",
                        bank: payToBankVM.bankData.bankName
                    }
                    yfeiUPIService.dashTransactionSelection = "Pay to Bank Account";
                    yfeiUPIService.bankData.accountNumber = payToBankVM.accountNumber
                    $state.go('menu.scanAndPay');

                } else if (checkVpaResponse.status == 'VN') {
                    utilityService.hideSpinner();
                    payToBankVM.openWithIfsc();
                }
                else {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", checkVpaResponse.statusDesc);
                    payToBankVM.openWithIfsc();
                }
            }, function (msg) {
                yfeiUPIService.showUpiAlert("error", msg);
                payToBankVM.openWithIfsc();
            });
        }

        payToBankVM.openWithIfsc = function () {
            payToBankVM.verifyFlag = true;
            payToBankVM.proceedFlag = true;
            payToBankVM.accountAvailableFlag = true;
        }

        payToBankVM.checkAccount = function () {
            if (payToBankVM.accountNumber == payToBankVM.reAccountNumber) {
                payToBankVM.reEnterAccountFlag = false;
            }
            if (payToBankVM.reAccountNumber && (payToBankVM.accountNumber != payToBankVM.reAccountNumber)) {
                payToBankVM.reEnterAccountFlag = true;
            }
        }

        payToBankVM.reAccountNumberCheck = function () {
            payToBankVM.showDetailBlock = false;
            payToBankVM.reEnterAccountFlag = false;
            if (payToBankVM.accountNumber != payToBankVM.reAccountNumber) {
                payToBankVM.reEnterAccountFlag = true;
            }

            if (payToBankVM.ifsc) {
                payToBankVM.validateIfsc();
            }

            if((payToBankVM.accountNumber != payToBankVM.reAccountNumber) || 
                payToBankVM.recipientName == undefined || payToBankVM.recipientName == "" || 
                payToBankVM.ifsc == undefined || payToBankVM.ifsc == "" || !payToBankVM.isValidIfscFormat) {
                payToBankVM.proceedDisableFlag = true;
            }
            else {
                payToBankVM.proceedDisableFlag = false;
            }
        }

        payToBankVM.validateIfsc = function () {
            if (!utilityService.isEmpty(payToBankVM.ifsc)) {
                payToBankVM.isValidIfscFormat = validationService.isValidIFSC(payToBankVM.ifsc);
            }
        }

        payToBankVM.ifscSearch = function () {
            payToBankVM.searchText="";
            payToBankVM.allIfscList=[];
            payToBankVM.ifscFlag = true;
        }

        payToBankVM.checkString = function (value) {
            if(value){
            var obj = {
                'searchBy': value
            };
            yfeiUPIService.searchIFSC(obj).then(function (data) {
                payToBankVM.allIfscList = data.bankList
                },function () {
                    yfeiUPIService.showUpiAlert("error", yfeiUPIService.commonErrorMsg);
                });
            }
        }

        payToBankVM.locationIfsc = function (selectedIfsc) {            
            payToBankVM.ifsc = selectedIfsc.ifsc;
            payToBankVM.ifscFlag = false;
            payToBankVM.reAccountNumberCheck();            
            getbankDetail(selectedIfsc);
        }
        function getbankDetail(selectedIfsc){
            payToBankVM.showDetailBlock = true;
            payToBankVM.SplitbankName = selectedIfsc.bank;
            payToBankVM.SplitBranch = selectedIfsc.branch;
            payToBankVM.SplitCity = selectedIfsc.city;  
        }

        payToBankVM.proceedPayment = function () {

            if (!payToBankVM.ifsc || !payToBankVM.accountNumber) {
                yfeiUPIService.showUpiAlert("alert", "Please Enter all details");
                return;
            }
            if (payToBankVM.accountNumber != payToBankVM.reAccountNumber) {
                payToBankVM.reEnterAccountFlag = true;
                return;
            }
            payToBankVM.virtualAddress = payToBankVM.accountNumber + "@" + payToBankVM.ifsc + ".ifsc.npci";
            payToBankVM.verifyUpiIdStatus = '';
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payToBankVM.virtualAddress
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                utilityService.hideSpinner();
                var checkVpaResponse = JSON.parse(data);
                payToBankVM.vpaDetails = checkVpaResponse;
                if (checkVpaResponse.status == 'VN') {
                    yfeiUPIService.payeeDetails = {
                        payeeType: "AC",
                        requestType: 'pay',
                        accountNo: payToBankVM.accountNumber,
                        ifsc: payToBankVM.ifsc,
                        name: payToBankVM.recipientName,
                        vpa: checkVpaResponse.payeeType.virtualAddress || "",
                        vpaType: "AC",
                        amount: "",
                        remark: "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        pageName: "Pay to Bank Account",
                        payType: "Pay to Bank Account",
                        bank: payToBankVM.bankData.bankName
                    }
                    yfeiUPIService.dashTransactionSelection = "Pay to Bank Account";
                    yfeiUPIService.bankData.accountNumber = payToBankVM.accountNumber
                    $state.go('menu.scanAndPay');

                } else if (checkVpaResponse.status == "VE") {
                    yfeiUPIService.payeeDetails = {
                        payeeType: "VPA",
                        requestType: 'pay',
                        accountNo: payToBankVM.accountNumber,
                        ifsc: "",
                        name: checkVpaResponse.payeeType.name || "",
                        vpa: checkVpaResponse.payeeType.virtualAddress || "",
                        amount: "",
                        remark: "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        pageName: "Pay to Bank Account",
                        payType: "Pay to Bank Account",
                        bank: payToBankVM.bankData.bankName
                    }
                    yfeiUPIService.dashTransactionSelection = "Pay to Bank Account";
                    yfeiUPIService.bankData.accountNumber = payToBankVM.accountNumber
                    $state.go('menu.scanAndPay');
                } else {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", checkVpaResponse.statusDesc);
                }
            }, function (msg) {
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }


        return this;
    }
]);
