'use strict';

angularApp.controller('payToContactController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$filter",
    "$ionicScrollDelegate",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        $filter,
        $ionicScrollDelegate
    ) {

        var payContactVm = this;
        payContactVm.footerFlag = false;
        payContactVm.checkUpiSymbol = function (value) {
            payContactVm.checkSpecialFlag = false;
            payContactVm.checkNumberFlag = false;
            if (/(?=.*[@])/.test(value)) {
                payContactVm.checkSpecialFlag = true;
                payContactVm.upiStringArray = value.split("@");
                payContactVm.filterString = payContactVm.upiStringArray[1];
            }

            if (payContactVm.isNumeric(value) && (value.length >= 8 && value.length <= 10)) {
                payContactVm.checkNumberFlag = true;
            }


        }

        payContactVm.isNumeric = function (value) {
            return /^-?\d+$/.test(value);
        }

        payContactVm.checkString = function (value) {
            payContactVm.searchString = "";
            payContactVm.searchNumber = "";
            if (payContactVm.isNumeric(value)) {
                payContactVm.searchNumber = value;
                if (payContactVm.searchNumber.length == 10) {
                    var input = document.querySelector("#contactInput");
                    input.blur();
                    payContactVm.contactNumber({ "value": payContactVm.searchNumber });
                }
            } else {
                payContactVm.searchString = value;
            }
        }

        payContactVm.paymentConfirm = function () {
            payContactVm.footerFlag = true;
        }

        payContactVm.paymentRequestView = function (request) {
            yfeiUPIService.dashTransactionSelection = "Pay to Contacts";
            var data = {
                "txnAmount": request.txnAmount,
                "payeeVa": request.payeeVirtualAddress,
                "custRefNo": request.custRefNo,
                "expDate": 'May 26, 2023 6:37:42 PM',
                "collectExpTime": "",
                "notificationIcon": 0,
                "payeeName": request.payeeName,
                "pyAccNo": "NA",
                "txnNote": request.txnNote,
                "reqDate": 'May 26, 2023 6:37:42 PM',
                "payerVa": request.payerVirtualAddress,
                "txnId": "",
                "upiTrnRefNo": ""
            }
            yfeiUPIService.collectRequests = data;
            $state.go("menu.paymentRequestForm");
        }

        payContactVm.paymentHistory = function (payment) {
            yfeiUPIService.transactionDtls = payment;
            yfeiUPIService.raiseComplaint = "Pay to Contacts";
            if (payment.txnStatus == 'PENDING' && payment.drCrFlag == 'D' && payment.txnType == 'COLLECT') {
                payContactVm.paymentRequestView(payment);
            } else {
                $state.go('menu.transactionHistDetails');
            }
            payContactVm.footerFlag = false;
        }

        payContactVm.goBack = function () {
            if(payContactVm.footerFlag){
                payContactVm.searchNumber="";
                payContactVm.searchString ="";
                payContactVm.searchUPIText="";
                payContactVm.contactListFlag = true;
                payContactVm.footerFlag = false;
            }else{
                $state.go("menu.dashboard");
            }
        }

        payContactVm.goToHome = function () {
            $state.go("menu.dashboard");
        }

        payContactVm.contactNumber = function (contact) {
            payContactVm.contactDetails = {};

            var number = contact.value.split(" ").join("");
            if (number.length > 10) {
                payContactVm.newSetNumber = number.substring(number.length - 10);
            } else {
                payContactVm.newSetNumber = number;
            }

            if (!payContactVm.isNumeric(payContactVm.newSetNumber)) {
                utilityService.showUpiAlert("alert", "Please select contact number");
                return
            }
            payContactVm.mapperNumnber = payContactVm.newSetNumber + "" + "@mapper.npci";
            var json = {};
            json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payContactVm.mapperNumnber
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });

            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                utilityService.hideSpinner();
                payContactVm.mapperResponse = JSON.parse(data);
                if (payContactVm.mapperResponse.status == 'VE') {
                    payContactVm.footerFlag = true;
                    payContactVm.transactionChatHistory(payContactVm.mapperResponse.payeeType.merchantInfo.fvaddr);
                    payContactVm.contactDetails = {
                        payeeName: payContactVm.mapperResponse.payeeType.name,
                        payeeValue: payContactVm.mapperResponse.payeeType.merchantInfo.fvaddr
                    }
                    yfeiUPIService.mapperResponse = payContactVm.mapperResponse;
                    yfeiUPIService.payeeDetails = {
                        payeeType: "MAPPER",
                        requestType: 'pay',
                        accountNo: "",
                        ifsc: "",
                        name: payContactVm.mapperResponse.payeeType.name || "",
                        vpa: payContactVm.mapperResponse.payeeType.merchantInfo.fvaddr || "",
                        amount: "",
                        remark: "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        cmid: payContactVm.mapperResponse.payeeType.merchantInfo.cmid,
                        pageName: "Pay To Contact",
                        payType: ""
                    }
                    payContactVm.contactListFlag = false;
                    payContactVm.getProfile();
                } else {
                    yfeiUPIService.showUpiAlert("alert", payContactVm.mapperResponse.statusDesc);
                }

            }, function (msg) {
                utilityService.hideSpinner();
                if (msg != -101) {
                    yfeiUPIService.showUpiAlert("error", msg);
                }
            });

        }

        payContactVm.transactionChatHistory = function (virtualAddress) {
            payContactVm.chatData = [];
            if (yfeiUPIService.transactionHistory) {
                payContactVm.chatData = yfeiUPIService.transactionHistory.filter(function (el) {
                    return el.payerVirtualAddress == virtualAddress || el.payeeVirtualAddress == virtualAddress;
                });
                payContactVm.chatData.filter(function (el) {
                    payContactVm.filterDate = $filter('dateTransaction')(el.trnDate);
                    el.filterDate = payContactVm.filterDate;
                });
                payContactVm.chatData.sort(function (a, b) {
                    var startDate = a.trnDate.substring(0, 10);
                    var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + a.trnDate.substring(10);
                    var dateA = new Date(newDate1);

                    var endDate = b.trnDate.substring(0, 10);
                    var newDate2 = endDate.split('-')[1] + '/' + endDate.split('-')[0] + '/' + endDate.split('-')[2] + b.trnDate.substring(10);
                    var dateB = new Date(newDate2);
                    return dateA - dateB;
                });

                payContactVm.chatData.reverse();
            }
            if(payContactVm.chatData.length > 1){
                var handle = $ionicScrollDelegate.$getByHandle('scrollBottom');
                handle.scrollBottom();
            }

        }

        payContactVm.getProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    yfeiUPIService.payerProfileDtls = getProfileResponse;

                } else {
                    yfeiUPIService.showUpiAlert("alert", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        };


        payContactVm.verifyUpi = function (frequnt) {
            if (!frequnt.payeeVirtualAddress) {
                utilityService.showUpiAlert("alert", "Please Enter beneficiary UPI ID");
                return false;
            }
            if (frequnt.addressType && frequnt.addressType.trim() == 'AC') {
                yfeiUPIService.addressType = "AC";
                yfeiUPIService.payeeDetails = {
                    payeeType: "VPA",
                    requestType: 'pay',
                    accountNo: frequnt.payeeAccountNo,
                    ifsc: "",
                    name: frequnt.payeeName || "",
                    vpa: frequnt.payeeVirtualAddress || "",
                    amount: "",
                    remark: "",
                    nickName: "",
                    phoneNumber: "",
                    savePayee: false,
                    pageName: "Pay to Bank Account",
                    payType: "frequentlyPay",
                    bank: frequnt.payeeBankCode
                }
            } else {
                yfeiUPIService.addressType = "";
                yfeiUPIService.payeeDetails = {
                    payeeType: "VPA",
                    requestType: 'pay',
                    accountNo: "",
                    ifsc: "",
                    name: frequnt.payeeName || "",
                    vpa: frequnt.payeeVirtualAddress || "",
                    amount: "",
                    remark: "",
                    nickName: "",
                    phoneNumber: "",
                    savePayee: false,
                    pageName: "Pay via UPI ID",
                    payType: "frequentlyPay"
                }
            }
            yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            yfeiUPIService.navigationFromDashboard = true;
            $state.go('menu.payUpi');
        }

        payContactVm.pay = function () {
            yfeiUPIService.dashTransactionSelection = "Pay to Contacts";
            $state.go('menu.scanAndPay');
        }

        payContactVm.requestMoney = function () {
            yfeiUPIService.dashTransactionSelection = "Request Money";
            $state.go('menu.scanAndPay');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            payContactVm.contactListFlag = true;
            payContactVm.colorCode = yfeiUPIService.colorCode;
            payContactVm.allContacts = yfeiUPIService.allContacts;
            payContactVm.limitCount = 4;
            payContactVm.FilterFrequntlyPay = yfeiUPIService.frequntlyPay;
            payContactVm.footerFlag = false;
            payContactVm.payeeDetails = yfeiUPIService.payeeDetails;
            payContactVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
        });

        return this;
    }



]);
