'use strict';

angularApp.controller('payUpiController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$filter",
    "$ionicScrollDelegate",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $filter,
        $ionicScrollDelegate
    ) {

        var payUpiVm = this;

        payUpiVm.verifyFlag = false;
        payUpiVm.checkSpecialFlag = false;
        payUpiVm.checkNumberFlag = false;
        payUpiVm.checkVirtualFlag = false;
        payUpiVm.checkVirtualErroFlag = false;
        payUpiVm.footerFlag = false;
        payUpiVm.upiList = [{ type: "@sbi" }, { type: "@axis" }, { type: "@icici" }, { type: "@kotak" }, { type: "@bob" }, { type: "@ybl" }, { type: "@axl" }, { type: "@bpl" }];

        payUpiVm.checkUpiSymbol = function (value) {
            payUpiVm.checkSpecialFlag = false;
            payUpiVm.checkNumberFlag = false;
            payUpiVm.verifyFlag = false;
            if (/(?=.*[@])/.test(value)) {
                payUpiVm.checkSpecialFlag = true;
                payUpiVm.upiStringArray = value.split("@");
                payUpiVm.filterString = payUpiVm.upiStringArray[1];
            }

            payUpiVm.searchString = "";
            payUpiVm.searchNumber = "";
            if (payUpiVm.isNumeric(value) && (value.length >= 8 && value.length <= 10)) {
                payUpiVm.checkNumberFlag = true;
                payUpiVm.searchNumber = value;
            } else {
                payUpiVm.searchString = value;
            }

            if (payUpiVm.checkVirtualErroFlag) {
                payUpiVm.checkVirtualErroFlag = false;
            }

            if (payUpiVm.checkVirtualFlag) {
                payUpiVm.checkVirtualFlag = false;
                payUpiVm.chatData = [];
            }
        }

        payUpiVm.isNumeric = function (value) {
            return /^-?\d+$/.test(value);
        }

        payUpiVm.paymentSuggestUpi = function (value) {
            payUpiVm.searchUPIText = payUpiVm.upiStringArray[0] + "" + value;
            payUpiVm.verifyUpi();
        }

        payUpiVm.verifyUpi = function () {
            payUpiVm.checkVirtualFlag = false;
            payUpiVm.checkVirtualErroFlag = false;
            payUpiVm.verifyUpiIdStatus = "";
            if (!payUpiVm.searchUPIText) {
                yfeiUPIService.showUpiAlert("alert", "Please Enter beneficiary UPI ID");
                return false;
            }

            if (payUpiVm.checkNumberFlag) {
                payUpiVm.contactNumber(payUpiVm.searchUPIText);
                return;
            }

            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payUpiVm.searchUPIText.toString()
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            payUpiVm.vpaDetails = {};
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                var checkVpaResponse = JSON.parse(data);
                if (checkVpaResponse.status == 'VE') {
                    payUpiVm.transactionChatHistory(checkVpaResponse.payeeType.virtualAddress);
                    payUpiVm.vpaDetails = {
                        payeeName: checkVpaResponse.payeeType.name,
                        payeeValue: checkVpaResponse.payeeType.virtualAddress
                    }
                    payUpiVm.verifyFlag = true;
                    payUpiVm.checkVirtualFlag = true;
                    payUpiVm.checkSpecialFlag = false;
                    payUpiVm.footerFlag = false;
                    if (payUpiVm.dashboardSelItem == "Pay via UPI ID") {
                        yfeiUPIService.payeeDetails = {
                            payeeType: "VPA",
                            requestType: 'pay',
                            accountNo: "",
                            ifsc: "",
                            name: checkVpaResponse.payeeType.name || "",
                            vpa: checkVpaResponse.payeeType.virtualAddress || "",
                            amount: "",
                            remark: "",
                            nickName: "",
                            phoneNumber: "",
                            savePayee: false,
                            pageName: "Pay via UPI ID",
                            payType: "frequentlyPay"
                        }
                    } else if (payUpiVm.dashboardSelItem == "Request Money") {
                        yfeiUPIService.payeeDetails = {
                            payeeType: "VPA",
                            requestType: 'pay',
                            accountNo: "",
                            ifsc: "",
                            name: checkVpaResponse.payeeType.name || "",
                            vpa: checkVpaResponse.payeeType.virtualAddress || "",
                            amount: "",
                            remark: "",
                            nickName: "",
                            phoneNumber: "",
                            savePayee: false,
                            pageName: "Request Money",
                            payType: "frequentlyPay"
                        }
                    }
                    payUpiVm.getProfile();
                } else {
                    utilityService.hideSpinner();
                    payUpiVm.verifyFlag = false;
                    payUpiVm.checkVirtualFlag = false;
                    payUpiVm.checkSpecialFlag = false;
                    payUpiVm.verifyUpiIdStatus = checkVpaResponse.statusDesc;
                    payUpiVm.checkVirtualErroFlag = true;
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }


        payUpiVm.contactNumber = function (contact) {
            var number = contact.split(" ").join("");
            if (number.length > 10) {
                payUpiVm.newSetNumber = number.substring(number.length - 10);
            } else {
                payUpiVm.newSetNumber = number;
            }

            if (!payUpiVm.isNumeric(payUpiVm.newSetNumber.split(" ").join(""))) {
                yfeiUPIService.showUpiAlert("alert", "Please select contact number");
                return
            }
            payUpiVm.mapperNumnber = payUpiVm.newSetNumber.split(" ").join("") + "" + "@mapper.npci";
            var json = {};
            json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                    "virtualAddress": payUpiVm.mapperNumnber
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
            payUpiVm.vpaDetails = {};
            utilityService.showSpinner();
            yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                utilityService.hideSpinner();
                payUpiVm.mapperResponse = JSON.parse(data);
                if (payUpiVm.mapperResponse.status == 'VE') {
                    payUpiVm.transactionChatHistory(payUpiVm.mapperResponse.payeeType.merchantInfo.fvaddr);
                    payUpiVm.vpaDetails = {
                        payeeName: payUpiVm.mapperResponse.payeeType.name,
                        payeeValue: payUpiVm.mapperResponse.payeeType.merchantInfo.fvaddr
                    }
                    yfeiUPIService.mapperResponse = payUpiVm.mapperResponse;
                    yfeiUPIService.payeeDetails = {
                        payeeType: "MAPPER",
                        requestType: 'pay',
                        accountNo: "",
                        ifsc: "",
                        name: payUpiVm.mapperResponse.payeeType.name || "",
                        vpa: payUpiVm.mapperResponse.payeeType.merchantInfo.fvaddr || "",
                        amount: "",
                        remark: "",
                        nickName: "",
                        phoneNumber: "",
                        savePayee: false,
                        cmid: payUpiVm.mapperResponse.payeeType.merchantInfo.cmid,
                        pageName: "Request Money",
                        payType: "frequentlyPay"
                    }
                    payUpiVm.verifyFlag = true;
                    payUpiVm.checkVirtualFlag = true;
                    payUpiVm.checkSpecialFlag = false;
                    payUpiVm.footerFlag = false;
                    payUpiVm.getProfile();
                } else {
                    utilityService.hideSpinner();
                    payUpiVm.verifyFlag = false;
                    payUpiVm.checkVirtualFlag = false;
                    payUpiVm.checkSpecialFlag = false;
                    payUpiVm.verifyUpiIdStatus = payUpiVm.mapperResponse.statusDesc;
                    payUpiVm.checkVirtualErroFlag = true;
                }
            }, function (msg) {
                utilityService.hideSpinner();
                if (msg != -101)
                    yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        payUpiVm.transactionChatHistory = function (virtualAddress) {
            payUpiVm.chatData = [];
            if (yfeiUPIService.transactionHistory) {
                payUpiVm.chatData = yfeiUPIService.transactionHistory.filter(function (el) {
                    return el.payerVirtualAddress == virtualAddress || el.payeeVirtualAddress == virtualAddress;
                });
                payUpiVm.chatData.filter(function (el) {
                    payUpiVm.filterDate = $filter('dateTransaction')(el.trnDate);
                    el.filterDate = payUpiVm.filterDate;
                });
                payUpiVm.chatData.sort(function (a, b) {
                    var startDate = a.trnDate.substring(0, 10);
                    var newDate1 = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + a.trnDate.substring(10);
                    var dateA = new Date(newDate1);

                    var endDate = b.trnDate.substring(0, 10);
                    var newDate2 = endDate.split('-')[1] + '/' + endDate.split('-')[0] + '/' + endDate.split('-')[2] + b.trnDate.substring(10);
                    var dateB = new Date(newDate2);
                    return dateA - dateB;
                });

                payUpiVm.chatData.reverse();

            }
        }

        payUpiVm.getProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    yfeiUPIService.payerProfileDtls = getProfileResponse;

                } else {
                    yfeiUPIService.showUpiAlert("alert", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        };

        payUpiVm.pay = function () {
            if (payUpiVm.frequentlyFlag) {
                yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            } else {
                yfeiUPIService.dashTransactionSelection = "Pay via UPI ID";
            }
            $state.go('menu.scanAndPay');
        }

        payUpiVm.requestMoney = function () {
            yfeiUPIService.dashTransactionSelection = "Request Money";
            $state.go('menu.scanAndPay');
        }

        payUpiVm.paymentConfirm = function () {
            payUpiVm.footerFlag = true;
            payUpiVm.searchFlag = false;
            var handle = $ionicScrollDelegate.$getByHandle('scrollBottom');
            handle.scrollBottom();
        }

        payUpiVm.paymentHistory = function (payment) {
            yfeiUPIService.transactionDtls = payment;
            if (payUpiVm.frequentlyFlag) {
                yfeiUPIService.raiseComplaint = "Frequently Paid";
            } else {
                yfeiUPIService.raiseComplaint = "Pay via UPI ID";
            }
            if (payment.txnStatus == 'PENDING' && payment.drCrFlag == 'D' && payment.txnType == 'COLLECT') {
                payUpiVm.paymentRequestView(payment);
            } else {
                yfeiUPIService.chatHistoryTransition = true;
                $state.go('menu.transactionHistDetails');
            }
        }

        payUpiVm.paymentRequestView = function (request) {
            if (payUpiVm.frequentlyFlag) {
                yfeiUPIService.dashTransactionSelection = "Frequently Paid";
            } else {
                yfeiUPIService.dashTransactionSelection = "Pay via UPI ID";
            }

            if (yfeiUPIService.collectRequestsList) {
                for (var i = 0; i < yfeiUPIService.collectRequestsList.length; i++) {
                    if (yfeiUPIService.collectRequestsList[i].custRefNo == request.custRefNo && yfeiUPIService.collectRequestsList[i].txnAmount == request.txnAmount) {
                        request.expDate = yfeiUPIService.collectRequestsList[i].expDate
                        request.reqDate = yfeiUPIService.collectRequestsList[i].reqDate
                        request.txnId = yfeiUPIService.collectRequestsList[i].txnId
                        request.upiTrnRefNo = yfeiUPIService.collectRequestsList[i].upiTrnRefNo
                    }
                }

            }

            var data = {
                "txnAmount": request.txnAmount,
                "payeeVa": request.payeeVirtualAddress,
                "custRefNo": request.custRefNo,
                "expDate": request.expDate,
                "collectExpTime": "",
                "notificationIcon": 0,
                "payeeName": request.payeeName,
                "pyAccNo": "NA",
                "txnNote": request.txnNote,
                "reqDate": request.reqDate,
                "payerVa": request.payerVirtualAddress,
                "txnId": request.txnId,
                "upiTrnRefNo": request.upiTrnRefNo
            }
            yfeiUPIService.collectRequests = data;
            $state.go("menu.paymentRequestForm");
        }

        payUpiVm.goBack = function () {
            if (payUpiVm.footerFlag && !payUpiVm.searchFlag) {
                payUpiVm.verifyFlag = false;
                payUpiVm.checkSpecialFlag = false;
                payUpiVm.checkNumberFlag = false;
                payUpiVm.checkVirtualFlag = false;
                payUpiVm.checkVirtualErroFlag = false;
                payUpiVm.footerFlag = false;
                payUpiVm.verifyUpiIdStatus = "";
                payUpiVm.frequentlyFlag = false;
                payUpiVm.searchFlag = true;
                payUpiVm.searchUPIText = "";
                var handle = $ionicScrollDelegate.$getByHandle('scrollBottom');
                handle.scrollTop();
                if (yfeiUPIService.navigationFromDashboard) {
                    yfeiUPIService.navigationFromDashboard = false;
                    payUpiVm.goToHome();
                }

                if (yfeiUPIService.dashTransactionSelection == "Request Money") {
                    payUpiVm.searchString = undefined;
                }
            } else {
                $state.go("menu.dashboard");
            }
        }

        payUpiVm.goToHome = function () {
            $state.go("menu.dashboard");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            payUpiVm.verifyUpiIdStatus = "";
            payUpiVm.addressType = yfeiUPIService.addressType;
            payUpiVm.frequentlyFlag = false;
            payUpiVm.footerFlag = false;
            payUpiVm.searchFlag = true;
            payUpiVm.freshPaymentThroughUPI = yfeiUPIService.freshPaymentThroughUPI ? yfeiUPIService.freshPaymentThroughUPI : false;
            payUpiVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
            payUpiVm.payeeDetails = yfeiUPIService.payeeDetails;
            if (payUpiVm.dashboardSelItem == "Frequently Paid" || (payUpiVm.dashboardSelItem == "Pay via UPI ID" && (!payUpiVm.freshPaymentThroughUPI || yfeiUPIService.chatHistoryTransition))) {
                payUpiVm.frequentlyFlag = true;
                payUpiVm.transactionChatHistory(payUpiVm.payeeDetails.vpa);
                yfeiUPIService.freshPaymentThroughUPI = false;
                payUpiVm.vpaDetails = {
                    payeeName: payUpiVm.payeeDetails.name,
                    payeeValue: payUpiVm.payeeDetails.vpa
                };
                payUpiVm.checkVirtualFlag = true;
                payUpiVm.footerFlag = true;
                payUpiVm.searchFlag = false;
                yfeiUPIService.chatHistoryTransition = false;

                if (payUpiVm.dashboardSelItem == "Frequently Paid") {
                    var handle = $ionicScrollDelegate.$getByHandle('scrollBottom');
                    handle.scrollBottom();
                }
            }
            payUpiVm.contactListFlag = true;
            payUpiVm.colorCode = yfeiUPIService.colorCode;
            payUpiVm.allContacts = yfeiUPIService.allContacts;
        });
        $scope.$on('$ionicView.afterLeave', function () {
            yfeiUPIService.addressType = "";
        });
        return this;
    }
]);
