'use strict';
angularApp.controller('accountListController',
    ["$scope",
        "yfeiUPIService", "$state", "utilityService", "constantConfig",
        function (
            $scope, yfeiUPIService, $state, utilityService, constantConfig
        ) {

            var addAccountListVm = this;
            $scope.$on('$ionicView.beforeEnter', function () {
                addAccountListVm.accountList = yfeiUPIService.accountListData;

            });

            addAccountListVm.goBack = function () {
                $state.go('menu.addBankList');
            }

            addAccountListVm.addAccount = function (account) {
                utilityService.showSpinner();
                var json = {
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27),
                        "pspRespRefNo": yfeiUPIService.pspRespRefNoForAddAcc
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": account.accId ? account.accId : "-1",
                        "virtualAddress": yfeiUPIService.vpaForSetPin
                    }
                };
                
                yfeiUPIService.getNativeData(constantConfig.upiConstant.onSubmitNewAccount, JSON.stringify(json)).then(function (data) {
                    var accObj = JSON.parse(data);
                    utilityService.hideSpinner();
                    if (accObj.status == 'S') {
                        addAccountListVm.linkAccountId = accObj.aeps_link_account_id;
 
                        if ((yfeiUPIService.addBankFlag == "addBankFromProfile" || yfeiUPIService.addBankFlag == "addBankPaymentTime" ||yfeiUPIService.addBankFlag == "addBankGenQRCodeTime") && account.mpinFlag == "N") {
                            yfeiUPIService.selectedAccountDtls = account;
                            yfeiUPIService.selectedAccountDtls.linkAccountId = accObj.aeps_link_account_id;
                            yfeiUPIService.navigatedSetPinFrom = "addAccount";
                            yfeiUPIService.reloadProfileDtls = true
                            $state.go('menu.setUPIPin');
                        } else if ((yfeiUPIService.addBankFlag == "addBankPaymentTime" || yfeiUPIService.addBankFlag == "addBankGenQRCodeTime") && account.mpinFlag == "Y") {
                            addAccountListVm.getProfile();
                        } else {
                            yfeiUPIService.addBankDetails = { "bankName": account.vpaBankName, "accountNumber": account.maskedAccountNumber };
                            $state.go('menu.addBankSuccess');
                        }
                    } else {
                        yfeiUPIService.showUpiAlert("error", accObj.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }


            addAccountListVm.getProfile = function () {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                    utilityService.hideSpinner();
                    var getProfileResponse = JSON.parse(data);
                    if (getProfileResponse.status == "S") {
                        yfeiUPIService.payerProfileDtls = getProfileResponse;
                        addAccountListVm.vpaList = getProfileResponse.vpaAccountDetails;
                        for (var i = 0; i < addAccountListVm.vpaList.length; i++) {
                            for (var j = 0; j < addAccountListVm.vpaList[i].accountInfo.length; j++) {
                                if (addAccountListVm.vpaList[i].accountInfo[j].accId == addAccountListVm.linkAccountId) {
                                    yfeiUPIService.accDetails = addAccountListVm.vpaList[i].accountInfo[j];
                                }
                            }
                        }
                        if (yfeiUPIService.addBankFlag == "addBankPaymentTime") {
                            $state.go('menu.scanAndPay');
                        } else {
                            $state.go('menu.reqMoneyWithoutUPI');
                        }
                        yfeiUPIService.addBankFlag = "";
                    } else {
                        yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }

        }
    ]);