'use strict';
angularApp.controller('bankListingController',
    ["$scope",
        "yfeiUPIService", "$state", "validationService", "utilityService", "constantConfig", "$ionicPopup", "$http", "$timeout",
        function (
            $scope, yfeiUPIService, $state, validationService, utilityService, constantConfig, $ionicPopup, $http, $timeout
        ) {

            var bankListingVm = this;
            $scope.$on('$ionicView.beforeEnter', function () {
                bankListingVm.bankListPanel = true;
                bankListingVm.accountsLoadedTimer = false;
                if (yfeiUPIService.bankList) {
                    bankListingVm.getBankList();
                }
                $http.get('pages/YFEI/registration/popularBank.json')
                    .success(function (data) {
                        bankListingVm.popularBankList = data.popularBankList;
                    })
                    .error(function (err) {
                        console.log(err);
                    });
                if (yfeiUPIService.navigateUrl == 'payToBank') {
                    bankListingVm.pageName = 'YFEI_PAY_TO_BANK';
                } else {
                    bankListingVm.pageName = 'YFEI_ADD_BANK_ACCOUNT';
                }

            });


            bankListingVm.getBankList = function () {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
                    utilityService.hideSpinner();
                    bankListingVm.banklistResponse = JSON.parse(data);
                    if (bankListingVm.banklistResponse.status == 'S') {
                        bankListingVm.bankList = bankListingVm.banklistResponse.bankMasterList;
                        yfeiUPIService.bankList = bankListingVm.bankList;
                        yfeiUPIService.accountDtlAgainstBank = [];

                    } else {
                        yfeiUPIService.showUpiAlert("error", "Currently system is facing some technical challanges for fetching the bank list. Please try after sometime.");
                    }
                }, function (msg) {
                    bankListingVm.searchText = "";
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            };


            bankListingVm.goBack = function () {
                if (yfeiUPIService.navigateUrl == 'payToBank') {
                    $state.go("menu.dashboard");
                    yfeiUPIService.navigateUrl = "";
                } else if (yfeiUPIService.addBankFlag == "addBankPaymentTime") {
                    $state.go('menu.scanAndPay');
                } else if (yfeiUPIService.addBankFlag == "addBankGenQRCodeTime") {
                    $state.go('menu.reqMoneyWithoutUPI');
                } else if (bankListingVm.bankListPanel) {
                    $state.go('menu.profileLanding');
                }
            }
            bankListingVm.goBackToList = function () {
                yfeiUPIService.navigateUrl = "";
                bankListingVm.accountsLoadedTimer = false;
                utilityService.showSpinner();
                $timeout(function () {
                    bankListingVm.bankListPanel = true;
                    utilityService.hideSpinner();
                }, 1000);
            }


            bankListingVm.selectBank = function (bank) {
                if (yfeiUPIService.navigateUrl == 'payToBank' && !yfeiUPIService.addBankFlag) {
                    if (bank.bankCode.length != 4 && bank.bankCode.length != 11) {
                        yfeiUPIService.withIFSC = true;
                    }
                    $state.go('menu.payToBank');
                    yfeiUPIService.bankData = bank;
                    return;
                }

                bankListingVm.bankListPanel = false;
                utilityService.showSpinner();
                $timeout(function () {
                    bankListingVm.accountsLoadedTimer = true;
                    utilityService.hideSpinner();
                }, 1000);


                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": bank.bankCode,
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_A, //Added request type as per the action taken after getAccountList
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": "",//Sudhir Bhujbal", //Here need to add logged in user name
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": yfeiUPIService.vpaForSetPin //By default send mob no.--- $rootScope.checkDeviceInfo.deviceInfo.mobileNo
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getaccountListAPI, json).then(function (data) {
                    var accObj = JSON.parse(data);
                    if (accObj.status == 'S') {
                        bankListingVm.accountsLoadedTimer = false;
                        bankListingVm.bankListPanel = false;
                        for (var i = 0; i < accObj.accountList.length; i++) {
                            var bankCode = accObj.accountList[i].bankCode;
                            for (var j = 0; j < yfeiUPIService.bankList.length; j++) {
                                var exiBankCode = yfeiUPIService.bankList[j].bankCode;
                                if (exiBankCode == bankCode) {
                                    accObj.accountList[i].vpaBankName = yfeiUPIService.bankList[j].bankName;
                                    break;
                                }
                            }

                        }
                        yfeiUPIService.accountListData = accObj.accountList;
                        yfeiUPIService.pspRespRefNoForAddAcc = accObj.requestInfo.pspRespRefNo;
                        $state.go('menu.addBankAccountList');

                    } else {
                        bankListingVm.searchText = ""
                        bankListingVm.bankList = yfeiUPIService.bankList;
                        bankListingVm.bankListPanel = true;
                        bankListingVm.accountsLoadedTimer = false;
                        yfeiUPIService.showUpiAlert("alert", accObj.statusDesc);
                    }
                }, function (msg) {
                    bankListingVm.searchText = "";
                    bankListingVm.bankList = yfeiUPIService.bankList;
                    bankListingVm.bankListPanel = true;
                    bankListingVm.accountsLoadedTimer = false;
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }




        }
    ]);