'use strict';
angularApp.controller('changeLoginMpinController',
	["$timeout",
		"$state",
		"$location",
		"$scope",
		"$rootScope",
		"$ionicPopup",
		"utilityService",
		"changeMpinService",
		"$ionicSideMenuDelegate", "yfeiUPIService", "cryptoService", "encryptionService", "loggedInUserService",
		function (
			$timeout,
			$state,
			$location,
			$scope,
			$rootScope,
			$ionicPopup,
			utilityService,
			changeMpinService,
			$ionicSideMenuDelegate, yfeiUPIService, cryptoService, encryptionService, loggedInUserService
		) {

			var changeLoginMpinVm = this;
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
				changeLoginMpinVm.isiOSFlag = false;
				if (utilityService.isIOSPlatform()) {
					changeLoginMpinVm.isiOSFlag = true;
				}
				initPage();
			});


			//private methods section start
			function initPage() {

				changeLoginMpinVm.disableConfirm = true;

			}
			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				changeLoginMpinVm.resetMpinFields();
				$ionicSideMenuDelegate.canDragContent(true);
				//any cleanup needs to be done here: executes everytime when page is left
			});
			changeLoginMpinVm.changeMpinSubmit = function (formName) {
				if (formName.$valid) {
					var oldMpin = changeLoginMpinVm.curMpin1 + changeLoginMpinVm.curMpin2 + changeLoginMpinVm.curMpin3 + changeLoginMpinVm.curMpin4 + changeLoginMpinVm.curMpin5 + changeLoginMpinVm.curMpin6;
					var newMpin = changeLoginMpinVm.newMpin1 + changeLoginMpinVm.newMpin2 + changeLoginMpinVm.newMpin3 + changeLoginMpinVm.newMpin4 + changeLoginMpinVm.newMpin5 + changeLoginMpinVm.newMpin6;
					var confirmMpin = changeLoginMpinVm.reMpin1 + changeLoginMpinVm.reMpin2 + changeLoginMpinVm.reMpin3 + changeLoginMpinVm.reMpin4 + changeLoginMpinVm.reMpin5 + changeLoginMpinVm.reMpin6;

					var mpinCondition = changeLoginMpinVm.checkMPINConditions(oldMpin, newMpin, confirmMpin);
					if (mpinCondition == "success") {
						yfeiUPIService.simId = localStorage.getItem("simSubscriptionId");

						var dataForHashing = oldMpin + loggedInUserService.deviceInfo;
						var dataForHashingConfirmMpin = confirmMpin + loggedInUserService.deviceInfo;
						var aesMpinOldMpin, aesNewMpin;
						if (utilityService.isAndroidPlatform()) {
							dataForHashing = dataForHashing + yfeiUPIService.simId;
							dataForHashingConfirmMpin = dataForHashingConfirmMpin + yfeiUPIService.simId;
							aesMpinOldMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
							aesNewMpin = cryptoService.getSHA512EncryptedData(dataForHashingConfirmMpin);

						}
						else {
							aesMpinOldMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
							aesNewMpin = cryptoService.getSHA512EncryptedData(dataForHashingConfirmMpin);
						}

						var reqPath = {
							"currentMpin": aesMpinOldMpin.toString(),
							"newMpin": aesNewMpin.toString()
						};

						yfeiUPIService.changeLoginMpin(reqPath).then(function (data) {
							//navigate to success
							yfeiUPIService.headerTitle = "Change Login MPIN";
							yfeiUPIService.proSuccessMessage = "You have changed your MPIN successfully";
							$state.go('menu.removeAccSuccess');
						}, function (error) {
							if (error.responseMessage) {
							changeLoginMpinVm.setMpinErrorMsg=error.responseMessage
							}
							else{
								changeLoginMpinVm.setMpinErrorMsg="Technical error occured"
							}
							changeLoginMpinVm.resetMpinFields();

						});
					} else {
			
						changeLoginMpinVm.setMpinErrorMsg=mpinCondition
						changeLoginMpinVm.resetMpinFields();
					}
				}
			};
			changeLoginMpinVm.resetMpinFields = function () {
				changeLoginMpinVm.curMpin1 = '';
				changeLoginMpinVm.curMpin2 = '';
				changeLoginMpinVm.curMpin3 = '';
				changeLoginMpinVm.curMpin4 = '';
				changeLoginMpinVm.curMpin5 = '';
				changeLoginMpinVm.curMpin6 = '';
				changeLoginMpinVm.newMpin1 = '';
				changeLoginMpinVm.newMpin2 = '';
				changeLoginMpinVm.newMpin3 = '';
				changeLoginMpinVm.newMpin4 = '';
				changeLoginMpinVm.newMpin5 = '';
				changeLoginMpinVm.newMpin6 = '';
				changeLoginMpinVm.reMpin1 = '';
				changeLoginMpinVm.reMpin2 = '';
				changeLoginMpinVm.reMpin3 = '';
				changeLoginMpinVm.reMpin4 = '';
				changeLoginMpinVm.reMpin5 = '';
				changeLoginMpinVm.reMpin6 = '';
			};

			changeLoginMpinVm.checkMPINConditions = function (oldMpin, newMpin, confirmMpin) {
				if (oldMpin === newMpin) {
					return 'Old MPIN and New MPIN should not be same';
				}
				if ((newMpin.toString()).length !== 6) {
					return 'New MPIN cannot be less than 6 digits';
				}
				if (newMpin !== confirmMpin) {
					return 'New MPIN and confirm MPIN should be same';
				}
				if (/(.)\1\1/.test(newMpin.toString())) {
					return 'Three consecutive numbers should not be same';
				}
				for (var i = 0; i < 4; i++) {
					if (newMpin[i + 1] == parseInt(newMpin[i]) + 1) {
						if (newMpin[i + 2] == parseInt(newMpin[i + 1]) + 1) {
							return 'Three consecutive numbers should not be in sequence';
						}
					}
				}
				for (var j = 0; j < 4; j++) {
					if (newMpin[j] == parseInt(newMpin[j + 1]) + 1) {
						if (newMpin[j + 1] == parseInt(newMpin[j + 2]) + 1) {
							return 'Three consecutive numbers should not be in sequence';
						}
					}
				}

				var validArrSet = [newMpin[0], newMpin[1], newMpin[2], newMpin[3], newMpin[4], newMpin[5]];
				var newArr = [];
				for (var k = 0; k < validArrSet.length; k++) {
					if (newArr.indexOf(validArrSet[k]) == -1) {
						newArr.push(validArrSet[k]);
					}
				}
				if (newArr.length < 3) {
					return 'Please use 3 unqiue numbers to set MPIN.';
				}
				return "success";
			};

			changeLoginMpinVm.isValid = function (formName) {
				if (formName.$valid)
					changeLoginMpinVm.disableConfirm = false;
				else changeLoginMpinVm.disableConfirm = true;
			}
			changeLoginMpinVm.goBack = function () {
				$state.go('menu.profileLanding');
			}

		}


	]);
