'use strict';
angularApp.controller('helpSupportController',
    ["$scope", "$ionicPopup",
        "yfeiUPIService", "$state", "utilityService", "constantConfig",
        function (
            $scope, $ionicPopup, yfeiUPIService, $state, utilityService, constantConfig
        ) {

            var helpSupportControllerVm = this;
            helpSupportControllerVm.raiseComplaint = function () {
                yfeiUPIService.raiseComplaint = "raiseComplaint";
                helpSupportControllerVm.getTransactionHistoryList();
            }

            helpSupportControllerVm.previousComplaint = function () {

                utilityService.showSpinner();
                var json = JSON.stringify({
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "requestType": "A"
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getDisputeList, json).then(function (data) {
                    var disputedRequestsResp = JSON.parse(data);
                    utilityService.hideSpinner();
                    if (disputedRequestsResp.status == 'S') {
                        if (disputedRequestsResp.listofCustDispute && disputedRequestsResp.listofCustDispute.length > 0) {
                            yfeiUPIService.previousComplaints = disputedRequestsResp.listofCustDispute;
                            $state.go('menu.previousComplaints');
                        } else {
                            helpSupportControllerVm.noRaisedComplaintPopUpFn();
                        }
                    } else {
                        yfeiUPIService.showUpiAlert("error", disputedRequestsResp.statusDesc);

                    }
                }, function (msg) {

                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });


            }

            helpSupportControllerVm.contactUs = function () {
                $state.go('menu.yfeiContactUs');
            }

            helpSupportControllerVm.goBack = function () {
                $state.go('menu.profileLanding');
            }

            helpSupportControllerVm.getTransactionHistoryList = function () {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getTransactionHistoryList, json).then(function (data) {
                    var transHistory = JSON.parse(data);
                    utilityService.hideSpinner();
                    if (transHistory.status == 'S') {
                        yfeiUPIService.transactionHistory = transHistory.transDetails;

                        $state.go('menu.yfeiTransactionHistory');
                    } else {
                        yfeiUPIService.showUpiAlert("error", transHistory.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }


            helpSupportControllerVm.noRaisedComplaintPopUpFn = function () {
                helpSupportControllerVm.noRaisedComplaintPopUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/YFEI/profile/helpSupport/noRaisedComplaintPopUp.html",
                    scope: $scope
                });
            }


            helpSupportControllerVm.cancelPopUp = function () {
                helpSupportControllerVm.noRaisedComplaintPopUp.close();
            }
        }
    ]);