'use strict';
angularApp.controller('createVpaIdController',
    ["$scope",
        "yfeiUPIService", "$state", "validationService", "utilityService", "constantConfig", "$ionicPopup", "$timeout",
        function (
            $scope, yfeiUPIService, $state, validationService, utilityService, constantConfig, $ionicPopup, $timeout
        ) {

            var createVpaVM = this;
            $scope.$on('$ionicView.beforeEnter', function () {
                createVpaVM.enteredVpa = "";
                createVpaVM.sbi = "@sbi";
                createVpaVM.isEnteredIdAvailable = 'initial';
                createVpaVM.vpaSuggestionList = yfeiUPIService.accountsDetails.accountObj.vpaSuggestionList;
                createVpaVM.accountList = yfeiUPIService.accountsDetails.accountList;
                if (yfeiUPIService.accountsDetails.accountList.length > 0) {
                    createVpaVM.defaultAccountList = yfeiUPIService.accountsDetails.accountList[0];
                }

                createVpaVM.isVpaSuccess = false;
                createVpaVM.checkVpa = false;

            });

            createVpaVM.upiHandelCheck = function () {
                if (createVpaVM.isEnteredIdAvailable == 'success') {
                    createVpaVM.isEnteredIdAvailable = 'initial';
                    createVpaVM.checkVpa = false;
                }

                createVpaVM.filterVpaSuggestList = createVpaVM.vpaSuggestionList.filter(function (el) {
                    return el == createVpaVM.enteredVpa + "@sbi";
                });

                if (createVpaVM.filterVpaSuggestList.length <= 0) {
                    createVpaVM.isEnteredIdAvailable = 'initial';
                    createVpaVM.checkVpa = false;
                }

            }

            createVpaVM.checkVpaAvailability = function () {
                if (createVpaVM.enteredVpa.indexOf("@") == -1) {
                    if (!validationService.isValidVPA(createVpaVM.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                        yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                        utilityService.hideSpinner();
                        return false;
                    }
                } else {
                    if (!validationService.isValidVPA(createVpaVM.enteredVpa)) {
                        yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                        utilityService.hideSpinner();
                        return false;
                    }
                }

                if (createVpaVM.enteredVpa) {

                    var json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "payeeType": {
                            "virtualAddress": createVpaVM.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                        },
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "vAReqType": "R"
                    });
                    yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                        utilityService.hideSpinner();
                        if (JSON.parse(data).status === 'VN') {
                            createVpaVM.isEnteredIdAvailable = 'success';
                        } else if (JSON.parse(data).status === 'VE') {
                            createVpaVM.isEnteredIdAvailable = 'error';
                        } else if (JSON.parse(data).status === 'VKE') {
                            createVpaVM.isEnteredIdAvailable = 'error';
                        } else {
                            yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                    });
                }
            };

            createVpaVM.goToBack = function () {
                $state.go('menu.manageUPI');
            }

            createVpaVM.goToProfile = function () {
                yfeiUPIService.payerProfileDtls = "";
                $state.go('menu.profileLanding');
            }
            createVpaVM.addBankAccount = function () {
                createVpaVM.showAllAcc.close();
                $state.go('menu.addBankList');
            }

            createVpaVM.selectSuggestedVpa = function (sugesstedVpa) {
                createVpaVM.enteredVpa = sugesstedVpa.split("@")[0];
                createVpaVM.isEnteredIdAvailable = 'initial';
                utilityService.showSpinner();
                $timeout(function () {
                    createVpaVM.checkVpaAvailability();
                }, 500);

            }
            createVpaVM.showAllAccounts = function () {
                createVpaVM.showAccountListPopUp();
            }

            createVpaVM.selectedBankAccount = function (account) {
                createVpaVM.selectBank = account.accId;
                createVpaVM.defaultAccountList = account;
            }

            createVpaVM.nextButton = function () {
                createVpaVM.showAllAcc.close();
            }

            createVpaVM.showAccountListPopUp = function () {
                createVpaVM.selectBank = createVpaVM.defaultAccountList.accId;
                createVpaVM.showAllAcc = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth100 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark pop-align-end',
                    templateUrl: "pages/YFEI/profile/manageUpi/accListPopup.html",
                    scope: $scope
                });
            }


            createVpaVM.closeAccountList = function () {
                createVpaVM.showAllAcc.close();
            }


            createVpaVM.createNewUpiId = function () {

                if (createVpaVM.enteredVpa.indexOf("@") == -1) {
                    if (!validationService.isValidVPA(createVpaVM.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                        yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                        return false;
                    }
                } else {
                    if (!validationService.isValidVPA(createVpaVM.enteredVpa)) {
                        yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                        return false;
                    }
                }

                createVpaVM.selectedBankAccFromDD = [];
                for (var i = 0; i < yfeiUPIService.payerProfileDtls.vpaAccountDetails.length; i++) {
                    for (var j = 0; j < yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo.length; j++) {
                        if (yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j].accId == createVpaVM.defaultAccountList.accId) {
                            createVpaVM.selectedBankAccFromDD.push(yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j]);
                        }
                    }
                }

                utilityService.showSpinner();
                createVpaVM.selectedBankAccFromDD[0].preferredFlag = 'T';
                createVpaVM.selectedBankAccFromDD[0].checkedAccount = true;
                var json = JSON.stringify({
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "accountList": [createVpaVM.selectedBankAccFromDD[0]],
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": createVpaVM.defaultAccountList.accId,
                        "virtualAddress": createVpaVM.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.onCreateNewVPA, json).then(function (data) {
                    utilityService.hideSpinner();
                    if (JSON.parse(data).status === "S") {
                        createVpaVM.registeredUpiId = createVpaVM.enteredVpa.split("@")[0].toLowerCase() + "@sbi";
                        createVpaVM.isVpaSuccess = true;
                        createVpaVM.isEnteredIdAvailable = "create";

                    } else {
                        yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
        }
    ]);