'use strict';
angularApp.controller('manageUpiIdController',
    ["$scope",
        "yfeiUPIService", "$state", "$ionicPopup", "utilityService", "constantConfig","$http",
        function ($scope, yfeiUPIService, $state, $ionicPopup, utilityService, constantConfig, $http) {

            var manageUpiVM = this;

            $scope.$on('$ionicView.beforeEnter', function () {
                manageUpiVM.primaryVpaSuccess = false;
                manageUpiVM.profileDetails = yfeiUPIService.payerProfileDtls;
                for (var i = 0; i < manageUpiVM.profileDetails.vpaAccountDetails.length; i++) {
                    if (manageUpiVM.profileDetails.vpaAccountDetails[i].defVPAStatus) {
                        manageUpiVM.upiId = manageUpiVM.profileDetails.vpaAccountDetails[i];
                        break;
                    }
                }
                manageUpiVM.popUpiId = "";
                
                 $http.get('pages/YFEI/bankMasterList.json')
                    .success(function (data) {
                       yfeiUPIService.bankMasterListOfflineData = data.bankMasterList;
                    })
                    .error(function (msg) {
                        yfeiUPIService.showUpiAlert("error", msg);
                 });
            });

            manageUpiVM.goBack = function () {
                if(manageUpiVM.primaryVpaSuccess){
                    yfeiUPIService.payerProfileDtls = "";
                }
                
                $state.go('menu.profileLanding');
            }
            
          $scope.$on('$ionicView.leave', function () {
            if(manageUpiVM.primaryVpaSuccess){
                 yfeiUPIService.payerProfileDtls = "";
                }         
           });

            manageUpiVM.setPrimaryVPA = function (vpaDetails, isPopUpValue , indexVal) {
               manageUpiVM.setPrimaryAccount(vpaDetails, isPopUpValue);
            } 

            manageUpiVM.setPrimaryAccount = function (vpaDetails, isPopUpValue) {
         
               utilityService.showSpinner();
                var json = JSON.stringify({
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_P,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": vpaDetails.accountInfo[0].accId,
                        "virtualAddress": vpaDetails.virtualAddress
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.onRemoveVPA, json).then(function (data) {
                    utilityService.hideSpinner();
                    if (JSON.parse(data).status == "S") {
                        manageUpiVM.primaryVpaSuccess = true;                        
                        if(isPopUpValue)
                        {
                            manageUpiVM.vpaRemovePopUp();
                        }
                        else
                        {
                             yfeiUPIService.showUpiAlert("success", "Your Primary UPI ID is updated successfully.");
                        }
                        manageUpiVM.loadProfile();
                       
                        
                      
                    } else {
                        yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }

            
        manageUpiVM.loadProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
               utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data); 
                if (getProfileResponse.status == "S") {
                    yfeiUPIService.payerProfileDtls = getProfileResponse; 
                    manageUpiVM.profileDetails = yfeiUPIService.payerProfileDtls;
                     for (var i = 0; i < manageUpiVM.profileDetails.vpaAccountDetails.length; i++) {
                     if (manageUpiVM.profileDetails.vpaAccountDetails[i].defVPAStatus) {
                         manageUpiVM.upiId = manageUpiVM.profileDetails.vpaAccountDetails[i];
                        break;
                    }
                 }
                } else {
                    yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
         }

        manageUpiVM.cancelPopUp = function () {
            manageUpiVM.popUpiId ="";
            manageUpiVM.deletePopUp.close();
        }


            manageUpiVM.deleteVpa = function (vpaDetails, indexVal) {

                var primaryVpa = vpaDetails.defVPAStatus;
                if (manageUpiVM.profileDetails.vpaAccountDetails.length == 1) {
                    yfeiUPIService.showUpiAlert("", "You have selected default UPI ID for deletion. You can not delete primary Id");
                }
                else {              
                    if (primaryVpa) {
                        manageUpiVM.deletePrimaryVPA = "You have selected default UPI ID for deletion. Select another ID to be set as default, to continue"
                        manageUpiVM.nonPrimaryVPA = manageUpiVM.profileDetails.vpaAccountDetails.filter(function (object) {
                            return object.virtualAddress !== vpaDetails.virtualAddress;
                        });                  
                        manageUpiVM.selectedVpaDetails = vpaDetails;
                        manageUpiVM.removeIndex = indexVal;
                        manageUpiVM.showDeleteVpaPopUP();
                    }
                    else {
                        manageUpiVM.selectedVpaDetails = vpaDetails;
                        manageUpiVM.removeIndex = indexVal;
                        manageUpiVM.vpaRemovePopUp();
                    }
                    
                    
                }
            }


            manageUpiVM.changeUpi = function (vpaDetails, indexVal) {            
                manageUpiVM.popUpiId = vpaDetails;
               
              
            }
            manageUpiVM.removeVpaPopUP = function () {
                if (manageUpiVM.popUpiId) {
                    manageUpiVM.deletePopUp.close();                    
                    manageUpiVM.setPrimaryAccount(manageUpiVM.popUpiId, true);
                    
                }
                else {
                    utilityService.showErrorMessage("Please Select Virtual address to proceed further.");
                }

            }
            manageUpiVM.showDeleteVpaPopUP = function () {
                manageUpiVM.deletePopUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth100 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark pop-align-end',
                    templateUrl: "pages/YFEI/profile/manageUpi/manageUpiPopUp.html",
                    scope: $scope
                });
            }
            manageUpiVM.cancelDeletion = function () {
                manageUpiVM.myPopup.close();
            }
            manageUpiVM.createNewUPI = function () {
                if (manageUpiVM.profileDetails.vpaAccountDetails.length >= 3) {
                    manageUpiVM.createNewUpiPopUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
                    templateUrl: "pages/YFEI/profile/manageUpi/upiIdErrorPopup.html",
                    scope: $scope
                });
                    return;
                }
        
                manageUpiVM.accountList = [];
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "bankCode": "SBIN",
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": "E",
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "name": "",
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": 0,
                        "virtualAddress": ""
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getaccountListAPI, json).then(function (data) {
                    var accObj = JSON.parse(data);
                    utilityService.hideSpinner();
                    if (accObj.status == 'S') {
                        manageUpiVM.accountList = accObj.accountList;
                        manageUpiVM.pspRespRefNo = accObj.requestInfo.pspRespRefNo;
                        for (var i = 0; i < manageUpiVM.accountList.length; i++) {
						var bankCode = manageUpiVM.accountList[i].bankCode;
						for (var j = 0; j < yfeiUPIService.bankMasterListOfflineData.length; j++) {
							var exiBankCode = yfeiUPIService.bankMasterListOfflineData[j].bankCode;
							if (exiBankCode == bankCode) {
								manageUpiVM.accountList[i].vpaBankName = yfeiUPIService.bankMasterListOfflineData[j].bankName;
								break;
							}
						}
					  }
                        yfeiUPIService.accountsDetails = {
                            "pspRespRefNo": manageUpiVM.pspRespRefNo,
                            "accountList": manageUpiVM.accountList,
                            "bank": "",
                            "accountObj": accObj
                        }

                        $state.go('menu.creatNewUPIID');

                    } else {
                        yfeiUPIService.showUpiAlert("alert", accObj.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });

            }

            manageUpiVM.cancelUpiPopUp = function () {
                manageUpiVM.createNewUpiPopUp.close();
            }

            manageUpiVM.vpaRemovePopUp = function () {
                manageUpiVM.myPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                    templateUrl: "pages/YFEI/profile/manageUpi/deleteVpaPopUp.html",
                    scope: $scope
                });
            }

            manageUpiVM.deleteVpaConfirm = function (selectedVpa, removeIndex) {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "requestType": constantConfig.upiConstant.requestType_D,
                    "userInfo": {
                        "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                        "isMerchant": constantConfig.upiConstant.isMerchant,
                        "showMerchant": constantConfig.upiConstant.showMerchant,
                        "accountId": selectedVpa.accountInfo[0].accId,
                        "virtualAddress": selectedVpa.virtualAddress
                    }
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.onRemoveVPA, json).then(function (data) {
                    utilityService.hideSpinner();
                    manageUpiVM.myPopup.close();
                    if (JSON.parse(data).status == "S") {
                    
                        manageUpiVM.loadProfile();
                    } else {
                        yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    manageUpiVM.myPopup.close();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
        }
    ]);