'use strict';

angularApp.controller('profileLandingController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup", "yfeiUPIService", "utilityService", "$stateParams", "constantConfig", "quickPayService", "loggedInUserService", "cryptoService", "$window",
    function ($timeout, $state, $scope, $translate, $ionicPopup, yfeiUPIService, utilityService, $stateParams, constantConfig, quickPayService, loggedInUserService, cryptoService, $window) {

        var profileLandingVm = this;
        profileLandingVm.qrCode = null;

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            if (yfeiUPIService.reloadProfileDtls) {
                yfeiUPIService.payerProfileDtls = "";
                yfeiUPIService.reloadProfileDtls = false
            }
            yfeiUPIService.addBankFlag = ""
            profileLandingVm.bioCheck = (localStorage.getItem("isYfeiBiometricSet") === "true");

            profileLandingVm.showMyVpaList = false;
            if (localStorage.getItem("customerName")) {
                profileLandingVm.custName = localStorage.getItem("customerName");
            } else {
                profileLandingVm.custName = "";
            }
            if (yfeiUPIService.payerProfileDtls) {
                profileLandingVm.vpaList = yfeiUPIService.payerProfileDtls.vpaAccountDetails;
                profileLandingVm.userInfo = yfeiUPIService.payerProfileDtls.userInfo;
                profileLandingVm.vpaObj = profileLandingVm.vpaList[0];
                profileLandingVm.vpaName = profileLandingVm.vpaObj.virtualAddress;


                $timeout(function () {

                    var qrData = "upi://pay?pa=" + profileLandingVm.vpaObj.virtualAddress + "&pn=" + profileLandingVm.custName + "&am=" + "";
                    if (!profileLandingVm.qrCode) {
                        profileLandingVm.qrCode = yfeiUPIService.generateQrCode(qrData);
                        profileLandingVm.qrCode.append(document.getElementById("canvasQrcode"));
                    }
                    else {
                        profileLandingVm.qrCode.update({
                            data: qrData,
                        });
                    }

                }, 300);


                for (var i = 0; i < profileLandingVm.vpaList.length; i++) {
                    if (profileLandingVm.vpaList[i].defVPAStatus) {
                        profileLandingVm.selectedVpa = profileLandingVm.vpaList[i];
                        profileLandingVm.accounts = profileLandingVm.selectedVpa.accountInfo;
                    }
                }
            }
            else {
                yfeiUPIService.setPrimaryOption = false;
                profileLandingVm.getProfileData();
            }

            if (yfeiUPIService.setPinPostLogin) {
                profileLandingVm.getProfileData();
                yfeiUPIService.setPinPostLogin = false;
            }
        });



        profileLandingVm.goToDashboard = function () {
            yfeiUPIService.addBankFlag = ""
            $state.go('menu.dashboard');
        }

        profileLandingVm.showMyVpaList = false;
        profileLandingVm.showVpaList = function (e) {
            if (e) e.stopPropagation();
            profileLandingVm.showMyVpaList = !profileLandingVm.showMyVpaList;
        }

        profileLandingVm.hideActiveVPA = function () {
            profileLandingVm.showMyVpaList = false;
        }

        profileLandingVm.manageUpi = function () {
            yfeiUPIService.vpaForSetPin = profileLandingVm.selectedVpa.virtualAddress;
            $state.go('menu.manageUPI');
        }

        profileLandingVm.changeUpiId = function (selectedVpa) {
            profileLandingVm.showMyVpaList = false;
            profileLandingVm.qrCode.update({
                data: "upi://pay?pa=" + selectedVpa.virtualAddress + "&pn=" + "" + "&am=" + "",
            });
            profileLandingVm.vpaName = selectedVpa.virtualAddress;
            profileLandingVm.selectedVpa = selectedVpa;
            if (selectedVpa)
                profileLandingVm.accounts = selectedVpa.accountInfo;

            else
                profileLandingVm.accounts = '';



        }


        $scope.isGroupShown = function (accountType) {
            return ($scope.shownGroup === accountType);
        };

        $scope.toggleGroup = function (accountType) {
            if ($scope.isGroupShown(accountType)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = accountType;
            }
        };

        profileLandingVm.setPrimaryAccount = function (account) {
            yfeiUPIService.setPrimaryOption = true;
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_DA,
                "accountList": [{
                    "accId": account.accId

                }],
                "updateFlag": 0,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": false,
                    "showMerchant": false,
                    "accountId": 0,
                    "virtualAddress": profileLandingVm.selectedVpa.virtualAddress
                }
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onUpdateAccountList, json).then(function (data) {
                var setPrimaryAccResp = JSON.parse(data);
                utilityService.hideSpinner();
                if (setPrimaryAccResp.status == 'S') {
                    yfeiUPIService.payerProfileDtls = "";
                    profileLandingVm.getProfileData();
                } else {
                    yfeiUPIService.showUpiAlert("error", setPrimaryAccResp.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        //reload the accounts after setting primary account
        profileLandingVm.getProfileData = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data); //set get profile response in service later
                if (getProfileResponse.status == "S") {
                    yfeiUPIService.payerProfileDtls = getProfileResponse; //saved get profile updated response
                    profileLandingVm.vpaList = yfeiUPIService.payerProfileDtls.vpaAccountDetails;
                    if (yfeiUPIService.setPrimaryOption) {
                        for (var i = 0; i < profileLandingVm.vpaList.length; i++) {
                            if (profileLandingVm.vpaList[i].virtualAddress == profileLandingVm.selectedVpa.virtualAddress) {
                                profileLandingVm.selectedVpa = profileLandingVm.vpaList[i];
                                profileLandingVm.accounts = profileLandingVm.selectedVpa.accountInfo;
                            }
                        }

                    }
                    else {

                        profileLandingVm.userInfo = yfeiUPIService.payerProfileDtls.userInfo;
                        profileLandingVm.vpaObj = profileLandingVm.vpaList[0];

                        $timeout(function () {

                            var qrObj = "upi://pay?pa=" + profileLandingVm.vpaObj.virtualAddress + "&pn=" + "" + "&am=" + "";
                            if (!profileLandingVm.qrCode) {

                                profileLandingVm.qrCode = yfeiUPIService.generateQrCode(qrObj);
                                profileLandingVm.qrCode.append(document.getElementById("canvasQrcode"));
                            }
                            else {
                                profileLandingVm.qrCode.update({
                                    data: "upi://pay?pa=" + profileLandingVm.vpaObj.virtualAddress + "&pn=" + "" + "&am=" + "",
                                });
                            }


                        }, 300);


                        for (var i = 0; i < profileLandingVm.vpaList.length; i++) {
                            if (profileLandingVm.vpaList[i].defVPAStatus) {
                                profileLandingVm.selectedVpa = profileLandingVm.vpaList[i];
                                profileLandingVm.accounts = profileLandingVm.selectedVpa.accountInfo;

                            }
                        }
                    }





                } else {
                    yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        //chnage UPI pin

        profileLandingVm.changeUpiPin = function (account) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "accountId": account.accId,
                "virtualAddress": profileLandingVm.selectedVpa.virtualAddress
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onChangeMpin, json).then(function (data) {
                var changeUpiPinResp = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
                if (changeUpiPinResp.status == 'S') {
                    yfeiUPIService.payerProfileDtls = "";
                    yfeiUPIService.headerTitle = "Profile";
                    yfeiUPIService.proSuccessMessage = "You have successfully changed your UPI PIN";
                    $state.go('menu.removeAccSuccess');

                } else {
                    yfeiUPIService.headerTitle = "Profile";
                    yfeiUPIService.iconFlag = "alert";
                    yfeiUPIService.proSuccessMessage = "Due to technical issue, we are unable to change your UPI PIN.";
                    yfeiUPIService.proSuccessMessageSecond = "Please try again after sometime";
                    $state.go('menu.removeAccSuccess');
                }
            }, function (msg) {
                utilityService.hideSpinner();
                if (msg != -101)
                    yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        // reset upi pin
        profileLandingVm.resetUpiPin = function (account) {
            yfeiUPIService.selectedAccountDtls = account;
            yfeiUPIService.navigatedSetPinFrom = "profile";
            yfeiUPIService.vpaForSetPin = profileLandingVm.selectedVpa.virtualAddress;
            $state.go('menu.setUPIPin');
        }

        profileLandingVm.setUpiPin = function (account) {
            profileLandingVm.selectedAccount = account;
            yfeiUPIService.selectedAccountDtls = profileLandingVm.selectedAccount;
            yfeiUPIService.navigatedSetPinFrom = "profile";
            yfeiUPIService.vpaForSetPin = profileLandingVm.selectedVpa.virtualAddress;
            yfeiUPIService.setPinPostLogin = true;
            $state.go('menu.setUPIPin');
        }

        profileLandingVm.addBankFromProfile = function () {
            yfeiUPIService.vpaForSetPin = profileLandingVm.selectedVpa.virtualAddress;
            yfeiUPIService.addBankFlag = "addBankFromProfile"
            $state.go('menu.addBankList');
        }



        profileLandingVm.changeLoginPin = function () {
            $state.go('menu.changeLoginMpin');
        }
        //view account balance
        profileLandingVm.viewAccBalance = function (account) {
            yfeiUPIService.selectedAccountDtls = account;
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "virtualAddress": profileLandingVm.selectedVpa.virtualAddress,
                "accountId": account.accId
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onBalanceEnquiry, json).then(function (data) {
                var checkBalanceRes = JSON.parse(data).apiResp;
                utilityService.hideSpinner();
                if (checkBalanceRes.status == 'S') {
                    yfeiUPIService.balanceDetails = checkBalanceRes.accountInfo;
                    $state.go("menu.checkBalance");


                } else {
                    yfeiUPIService.showUpiAlert("error", checkBalanceRes.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                if (msg != -101)
                    yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        profileLandingVm.removeAccount = function (account, indexValue) {
            profileLandingVm.remAccObj = account;
            profileLandingVm.removePopUp = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/YFEI/profile/removeAccountPopup.html",
                scope: $scope
            });



        }
        profileLandingVm.cancelDeletion = function () {
            profileLandingVm.removePopUp.close();
        }

        profileLandingVm.goToHelpSupport = function () {
            $state.go("menu.helpSupport");
        }


        profileLandingVm.shareQrCode = function (share) {
            var blobQrObj = "";
            profileLandingVm.qrCode.getRawData('png').then(function (result) {
                blobQrObj = result;
                var reader = new window.FileReader();
                reader.onloadend = function () {
                    if (device.platform.toLowerCase() == 'ios') {
                        var myBaseString = reader.result;
                        var block = myBaseString.split(";");
                        var myBase64 = block[1].split(",")[1];

                        var successCallback = function (data) {
                            console.log(data);
                        }
                        var failureCallback = function (error) {
                            yfeiUPIService.showUpiAlert("error", error);
                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    }
                    else {
                        var contentType = "image/png";
                        var folderpath = cordova.file.externalRootDirectory;
                        var filename = "UPI ID - " + profileLandingVm.vpaName + ".png";
                        profileLandingVm.savebase64AsImageFile(folderpath, filename, blobQrObj, contentType, share);
                    }

                };
                reader.readAsDataURL(blobQrObj);
            },
                function (error) {
                    yfeiUPIService.showUpiAlert("error", "Error Occurred");
                });


        }

        profileLandingVm.savebase64AsImageFile = function (folderpath, filename, content, contentType, share) {

            var DataBlob = content;
            if (device.version == 10) {
                folderpath = cordova.file.externalDataDirectory;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    profileLandingVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            profileLandingVm.downloadOrShare(share, profileLandingVm.popupFolderpath);
                        }, function () {
                            yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            }
            else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        profileLandingVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                profileLandingVm.downloadOrShare(share, profileLandingVm.popupFolderpath);
                            }, function () {
                                yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + profileLandingVm.popupFolderpath);
                            });
                        });
                    });
                });
            }
        }
        profileLandingVm.downloadOrShare = function (share, folderName) {
            if (share) {
                var options = {
                    message: 'QR code - ', // not supported on some apps (i.e. Facebook, Instagram)
                    subject: 'YONO QR Code : ' + profileLandingVm.vpaName, // Subject. for email
                    files: [profileLandingVm.popupFolderpath], // an array of filenames either locally or remotely
                    url: profileLandingVm.vpaName,
                    chooserTitle: 'Share YONO QR code' // Android only, you can override the default share sheet title
                };

                var onSuccess = function (result) {
                    console.log(result);
                };
                var onError = function (msg) {
                    yfeiUPIService.showUpiAlert("error", msg);
                }
                window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
            } else if (!share) {
                profileLandingVm.fileStoredAlert = $ionicPopup.show({
                    template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>QR Code downloaded successfully.</span></div></div></div>',
                    title: '',
                    cssClass: 'bhim-alert-popup',
                    scope: $scope,
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            profileLandingVm.fileStoredAlert.close();
                        }
                    }]
                });
            }
        }

        profileLandingVm.confirmDeLinkAccount = function (account) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "requestType": constantConfig.upiConstant.requestType_RA,
                "accountList": [{
                    "accId": account.accId
                }],
                "updateFlag": 0,
                "userInfo": {
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "isMerchant": false,
                    "showMerchant": false,
                    "accountId": 0,
                    "virtualAddress": profileLandingVm.selectedVpa.virtualAddress
                }
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onUpdateAccountList, json).then(function (data) {
                var setPrimaryAccResp = JSON.parse(data);
                utilityService.hideSpinner();
                profileLandingVm.removePopUp.close();
                if (setPrimaryAccResp.status == 'S') {
                    yfeiUPIService.headerTitle = "Profile";
                    yfeiUPIService.payerProfileDtls = "";
                    yfeiUPIService.proSuccessMessage = "Your account has been successfully removed";

                    $state.go('menu.removeAccSuccess');
                } else {
                    yfeiUPIService.showUpiAlert("error", setPrimaryAccResp.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        profileLandingVm.bioMetricChecked = function () {
            if (profileLandingVm.bioCheck) {
                yfeiUPIService.isFingerprintAvailable().then(function () {
                    var encryptConfig = {
                        clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                        clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                        disableBackup: true,

                    };
                    Fingerprint.show(encryptConfig, successCallback, errorCallback);
                }, function () {
                    profileLandingVm.bioCheck = false;
                });
            } else {
                disableBiometric();
            }
        }

        function successCallback(result) {
            enableBiometric();
        }

        function errorCallback(error) {
            profileLandingVm.bioCheck = false;
            $scope.$apply();
        }


        function enableBiometric() {
            var random_str = utilityService.getRandomNumber(10);
            var fingerprint_token = cryptoService.encryptRSAWithPublicKey(random_str, cryptoService.rsaPublicKey);
            var obj = {
                'bioAuthId': fingerprint_token,
                'status': "true",
                'reqValidate': ""
            };
            yfeiUPIService.setBiometric(obj).then(function (data) {
                localStorage.setItem("isYfeiBiometricSet", true);
                profileLandingVm.isBiometricSet = true;
                cordova.plugins.SecureKeyStore.set(function (res) {
                    console.log(res);
                }, function (error) {
                    yfeiUPIService.showUpiAlert("error", error);
                }, loggedInUserService.deviceInfo, random_str);

                var template = '';
                if (yfeiUPIService.isBiometricType == 'face')
                    template = "Face ID has been enabled";
                else
                    template = "Touch ID has been enabled";
                var buttontext = "OK";
                yfeiUPIService.showUpiAlert('success', template, "", buttontext, $scope);
            }, function (error) {
                profileLandingVm.bioCheck = false;
                yfeiUPIService.showUpiAlert("error", error.responseMessage);
            });
        }
        function disableBiometric() {
            var obj = {
                'bioAuthId': "",
                'status': "false",
                'reqValidate': ""
            };
            yfeiUPIService.setBiometric(obj).then(function (data) {
                localStorage.setItem("isYfeiBiometricSet", false);
                profileLandingVm.isBiometricSet = false;
                cordova.plugins.SecureKeyStore.remove(function (res) {
                    console.log(res);
                }, function (error) {
                    yfeiUPIService.showUpiAlert("error", error);
                }, loggedInUserService.deviceInfo);

                var template = '';
                if (yfeiUPIService.isBiometricType == 'face')
                    template = "Face ID has been disabled";
                else
                    template = "Touch ID has been disabled";
                var buttontext = "OK";
                yfeiUPIService.showUpiAlert('success', template, "", buttontext, $scope);
            }, function (error) {
                profileLandingVm.bioCheck = true;
                yfeiUPIService.showUpiAlert("error", error.responseMessage);
            });
        }

    }]);
