'use strict';

angularApp.controller('bankAccountCreateVPAController', ["$state",
    "$ionicPopup",
    "$scope",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$timeout",
    "loggedInUserService",
    "validationService",
    "yfeiUPIService",
    function ($state,
        $ionicPopup,
        $scope,
        $rootScope,
        utilityService,
        constantConfig,
        $timeout,
        loggedInUserService,
        validationService,
        yfeiUPIService) {

        var bankAccVPAVm = this;
        $scope.$on('$ionicView.beforeEnter', function () {
            bankAccVPAVm.selectedAccountDtls = yfeiUPIService.selectedAccountDtls;
            bankAccVPAVm.selectedBankAccount = bankAccVPAVm.selectedAccountDtls.accId;
            bankAccVPAVm.isEnteredIdAvailable = 'initial';
            bankAccVPAVm.bankName = bankAccVPAVm.selectedAccountDtls.accountName;
            bankAccVPAVm.accountNumber = bankAccVPAVm.selectedAccountDtls.maskedAccountNumber;
            bankAccVPAVm.bankImage = bankAccVPAVm.selectedAccountDtls.bankCode;
            bankAccVPAVm.pspRespRefNo = yfeiUPIService.bankRespRefNumber;
            bankAccVPAVm.secQuestions = yfeiUPIService.secQuestions;
            bankAccVPAVm.vpaSuggestionList = yfeiUPIService.bankSelectedVpaSugList;
            bankAccVPAVm.sbi = "@sbi";
            bankAccVPAVm.checkVpa = false;
        });

        bankAccVPAVm.goBankAccountListBack = function () {
            $state.go('menu.bankAccountList');
        }

        bankAccVPAVm.upiHandelCheck = function () {
            if (bankAccVPAVm.isEnteredIdAvailable == 'success') {
                bankAccVPAVm.isEnteredIdAvailable = 'initial';
                bankAccVPAVm.checkVpa = false;
            }
            bankAccVPAVm.filterVpaSuggestList = bankAccVPAVm.vpaSuggestionList.filter(function (el) {
                return el == bankAccVPAVm.enteredVpa + "@sbi";
            });

            if (bankAccVPAVm.filterVpaSuggestList.length <= 0) {
                bankAccVPAVm.isEnteredIdAvailable = 'initial';
                bankAccVPAVm.checkVpa = false;
            }
        }

        // check vpa available 
        bankAccVPAVm.checkVpaAvailability = function () {
            if (bankAccVPAVm.enteredVpa.indexOf("@") == -1) {
                if (!validationService.isValidVPA(bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                    yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            } else {
                if (!validationService.isValidVPA(bankAccVPAVm.enteredVpa)) {
                    yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            }

            if (bankAccVPAVm.enteredVpa) {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "payeeType": {
                        "virtualAddress": bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                    },
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "vAReqType": "R"
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
                    utilityService.hideSpinner();
                    if (JSON.parse(data).status === 'VN') {
                        bankAccVPAVm.isEnteredIdAvailable = 'success';
                    } else if (JSON.parse(data).status === 'VE') {
                        bankAccVPAVm.isEnteredIdAvailable = 'error';
                    } else if (JSON.parse(data).status === 'VKE') {
                        bankAccVPAVm.isEnteredIdAvailable = 'error';
                    } else {
                        yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
        };

        bankAccVPAVm.selectSuggestedVpa = function (sugesstedVpa) {
            bankAccVPAVm.enteredVpa = sugesstedVpa.split("@")[0];
            bankAccVPAVm.isEnteredIdAvailable = 'initial';
            bankAccVPAVm.checkVpaAvailability();
        }

        // create vpa  
        bankAccVPAVm.upiRegistration = function () {
            bankAccVPAVm.termFlag = false;
            if (!bankAccVPAVm.enteredVpa) {
                yfeiUPIService.showUpiAlert("alert", "Please enter UPI ID for registration.");
                return false;
            }

            if (!bankAccVPAVm.selectedBankAccount) {
                yfeiUPIService.showUpiAlert("alert", "Please select the primary account, which will be used for future transactions.");
                return false;
            }

            if (!bankAccVPAVm.agreeCheckBox) {
                bankAccVPAVm.termFlag = true;
                bankAccVPAVm.ternAndConditionMsg = "Please tick above to agree terms & conditions";
                return false;
            }

            if (bankAccVPAVm.enteredVpa.indexOf("@") == -1) {
                if (!validationService.isValidVPA(bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi")) {
                    yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            } else {
                if (!validationService.isValidVPA(bankAccVPAVm.enteredVpa)) {
                    yfeiUPIService.showUpiAlert("alert", "Kindly check the UPI ID.");
                    return false;
                }
            }

            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27),
                    "pspRespRefNo": bankAccVPAVm.pspRespRefNo
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "userInfo": {
                    "altMobNo": $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo || "",
                    "appPin": {
                        "credentialDataValue": constantConfig.upiConstant.credentialDataValue
                    },
                    "defVPAStatus": constantConfig.upiConstant.defVPAStatus,
                    "email": "",
                    "isMerchant": constantConfig.upiConstant.isMerchant,
                    "mobileNo": $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo || "",
                    "name": bankAccVPAVm.selectedAccountDtls.accountName,
                    "secretDetails": {
                        "secretAnswer": "TEST",
                        "quesId": "101"
                    },
                    "showMerchant": constantConfig.upiConstant.showMerchant,
                    "accountId": bankAccVPAVm.selectedBankAccount,
                    "virtualAddress": bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi"
                }
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onRegisterSubmit, json).then(function (data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status === 'S') {
                    yfeiUPIService.appGenID = JSON.parse(data).servGenId;
                    localStorage.setItem('yfeiAppGenId', yfeiUPIService.appGenID);
                    yfeiUPIService.getNativeData("setAppGenId", yfeiUPIService.appGenID).then(function (data) {
                        yfeiUPIService.customerName = bankAccVPAVm.selectedAccountDtls.accountName;
                        yfeiUPIService.registeredUpiId = bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi";
                        yfeiUPIService.vpaForSetPin = bankAccVPAVm.enteredVpa.split("@")[0].toLowerCase() + "@sbi";
                        if (yfeiUPIService.addBankFlag && yfeiUPIService.addBankFlag == "postLoginAddBank") {
                            $state.go('menu.scanAndPay');
                        } else {
                            yfeiUPIService.navigatedSetPinFrom = "newRegistration";
                            bankAccVPAVm.getProfile()
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", msg);
                    });
                } else {
                    yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        bankAccVPAVm.getProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    bankAccVPAVm.vpaList = getProfileResponse.vpaAccountDetails;
                    for (var i = 0; i < bankAccVPAVm.vpaList.length; i++) {
                        if (bankAccVPAVm.vpaList[i].virtualAddress == yfeiUPIService.vpaForSetPin) {
                            for (var j = 0; j < bankAccVPAVm.vpaList[i].accountInfo.length; j++) {
                                if (bankAccVPAVm.vpaList[i].accountInfo[j].maskedAccountNumber == bankAccVPAVm.selectedAccountDtls.maskedAccountNumber) {
                                    yfeiUPIService.selectedAccountDtls.linkAccountId = bankAccVPAVm.vpaList[i].accountInfo[j].accId;
                                    $state.go('menu.vpaRegistrationSuccess');
                                }
                            }
                        }
                    }

                } else {
                    yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        bankAccVPAVm.toggleSecretAns = function () {
            if (bankAccVPAVm.isTextReadable) {
                bankAccVPAVm.isTextReadable = false;
            } else {
                bankAccVPAVm.isTextReadable = true;
            }
        };


        bankAccVPAVm.openDiscliamer = function () {
            bankAccVPAVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'termsYefi-body popupWidth100  popupBackgroundTransparent removePopup-head  yefi-color-back-ff',
                templateUrl: "pages/YFEI/registration/termsAndConditonsPopup.html",
                scope: $scope
            });
        }

        bankAccVPAVm.termAndConditionclose = function () {
            bankAccVPAVm.myPopup.close();
        }

        return this;
    }

]);
