'use strict';

angularApp.controller('bankAccountListController', ["$state",
    "$ionicPopup",
    "$scope",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$timeout",
    "loggedInUserService",
    "validationService",
    "yfeiUPIService",
    function ($state,
        $ionicPopup,
        $scope,
        $rootScope,
        utilityService,
        constantConfig,
        $timeout,
        loggedInUserService,
        validationService,
        yfeiUPIService) {

        var bankAccListVm = this;
        $scope.$on('$ionicView.beforeEnter', function () {
            bankAccListVm.accountList = yfeiUPIService.bankSelectedAccountList;
            bankAccListVm.pspRespRefNo = yfeiUPIService.bankRespRefNumber;
            bankAccListVm.getSecretQuestionList();
        });

        bankAccListVm.goBankListBack = function () {
            $state.go('menu.bankList');
        }

        bankAccListVm.addAccount = function (account) {

            bankAccListVm.selectedBankAccount = account.accId;
            bankAccListVm.isEnteredIdAvailable = 'initial';
            bankAccListVm.accountNumber = account.maskedAccountNumber;
            bankAccListVm.bankImage = account.bankCode;
            yfeiUPIService.selectedAccountDtls = account;
            $state.go('menu.bankAccountCreateVPA');
        }
        bankAccListVm.getSecretQuestionList = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getSecurityQuestionsList, json).then(function (data) {
                var secQueObj = JSON.parse(data);
                if (secQueObj.status == 'S') {
                    bankAccListVm.secQuestions = secQueObj.secQuesList;
                    yfeiUPIService.secQuestions = secQueObj.secQuesList;
                }
                utilityService.hideSpinner();
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        };


        return this;
    }

]);
