'use strict';

angularApp.controller('bankListController', ["$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"$timeout",
	"loggedInUserService",
	"validationService",
	"yfeiUPIService",
	"$http",
	function ($state,
		$ionicPopup,
		$scope,
		$rootScope,
		utilityService,
		constantConfig,
		$timeout,
		loggedInUserService,
		validationService,
		yfeiUPIService,
		$http) {

		var bankListVm = this;
		$scope.$on('$ionicView.beforeEnter', function () {
			bankListVm.bankListFlag = yfeiUPIService.bankListPage;
			bankListVm.bankAccountListFlag = yfeiUPIService.bankAccountListPage;
			bankListVm.bankVPAFlag = yfeiUPIService.bankCreateVPAPage;
			bankListVm.getAccountListTimerFlag = yfeiUPIService.getAccountListTimerPage;
			bankListVm.bankList = yfeiUPIService.bankList;
			bankListVm.selectedBankCnt = 0;
			yfeiUPIService.selectedBankArray = [];
			bankListVm.accountList = [];
			bankListVm.enteredVpa = "";
			bankListVm.isEnteredIdAvailable = "donotshowError";
			bankListVm.isEnteredIdAvailable = 'initial';
			bankListVm.sbi = "@sbi";
			bankListVm.isTextReadable = false;
			bankListVm.bankListSource = yfeiUPIService.addBankFrom;
			bankListVm.termFlag = false;
			bankListVm.termAndConditionFlag = false;
			bankListVm.agreeCheckBox = false;
			$http.get('pages/YFEI/registration/popularBank.json')
				.success(function (data) {
					bankListVm.popularBankList = data.popularBankList;
				})
				.error(function (msg) {
					yfeiUPIService.showUpiAlert("error", msg);
				});
		});

		bankListVm.selectBank = function (bank) {
			bankListVm.selectedBank = bank;
			bankListVm.bankName = bank.bankName;
			bankListVm.gotoSelectVpa();
		}

		bankListVm.gotoSelectVpa = function () {
			yfeiUPIService.selectedBankArray = [];
			if (bankListVm.selectedBank)
				yfeiUPIService.selectedBankArray.push(bankListVm.selectedBank);
			if (yfeiUPIService.selectedBankArray.length >= 1) {
				bankListVm.bankListFlag = false;
				bankListVm.getAccountListTimerFlag = true;
				bankListVm.getBankAccountList(yfeiUPIService.selectedBankArray);
			} else {
				yfeiUPIService.showUpiAlert("alert", "Please select a bank to proceed further.");
			}
		}


		bankListVm.getBankAccountList = function () {
			bankListVm.enteredVpa = '';
			bankListVm.secretQuestion = '';
			bankListVm.secretAnswer = '';
			bankListVm.selectedBankAccount = '';

			bankListVm.accountList = [];
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"bankCode": yfeiUPIService.selectedBankArray[0].bankCode,
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"requestType": constantConfig.upiConstant.requestType_R,
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"userInfo": {
					"defVPAStatus": constantConfig.upiConstant.defVPAStatus,
					"isMerchant": constantConfig.upiConstant.isMerchant,
					"name": $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo,
					"showMerchant": constantConfig.upiConstant.showMerchant,
					"accountId": 0,
					"virtualAddress": $rootScope.yfeiCheckDeviceInfo && $rootScope.yfeiCheckDeviceInfo.deviceInfo && $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo ? $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo + "@sbi" : $rootScope.yfeiCheckDeviceInfo.deviceInfo.oldMobileNo + "@sbi" //By default send mob no.--- $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo
				}
			});
			yfeiUPIService.getNativeData(constantConfig.upiConstant.getaccountListAPI, json).then(function (data) {
				var accObj = JSON.parse(data);
				utilityService.hideSpinner();
				if (accObj.status == 'S') {
					bankListVm.accountList = accObj.accountList;
					for (var i = 0; i < accObj.accountList.length; i++) {
						var bankCode = accObj.accountList[i].bankCode;
						for (var j = 0; j < yfeiUPIService.bankList.length; j++) {
							var exiBankCode = yfeiUPIService.bankList[j].bankCode;
							if (exiBankCode == bankCode) {
								accObj.accountList[i].vpaBankName = yfeiUPIService.bankList[j].bankName;
								break;
							}
						}

					}
					bankListVm.vpaSuggestionList = accObj.vpaSuggestionList;
					bankListVm.pspRespRefNo = accObj.requestInfo.pspRespRefNo;
					yfeiUPIService.bankSelectedAccountList = accObj.accountList;
					yfeiUPIService.bankSelectedVpaSugList = accObj.vpaSuggestionList;
					yfeiUPIService.bankRespRefNumber = accObj.requestInfo.pspRespRefNo;
					bankListVm.bankListFlag = false;
					bankListVm.getAccountListTimerFlag = false;
					
					$state.go('menu.bankAccountList');
				} else {
					if (accObj.errCode && accObj.errCode.toLowerCase() == "upsn") {
						yfeiUPIService.showUpiAlert("alert", yfeiUPIService.selectedBankArray[0].bankName + " : " + accObj.statusDesc);
					} else {
						yfeiUPIService.showUpiAlert("error", yfeiUPIService.selectedBankArray[0].bankName + " : " + accObj.statusDesc);
					}
					bankListVm.getAccountListTimerFlag = false;
					bankListVm.bankListFlag = true;
				}
			}, function (msg) {
				bankListVm.getAccountListTimerFlag = false;
				bankListVm.bankListFlag = true;
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
		}

		bankListVm.goBankListBack = function () {
			bankListVm.getAccountListTimerFlag = false;
			bankListVm.bankListFlag = true;
		}

		bankListVm.goBack = function () {
			if (bankListVm.bankListFlag) {
				$state.go('menu.yfeiSimSelection');
			}
		};

		return this;
	}

]);
