'use strict';

angularApp.controller('reVerificationDeviceController', ["$state",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"ionicToast",
	"yfeiUPIService",
	"$scope",
	"$ionicPopup",

	function ($state,
		$rootScope,
		utilityService,
		constantConfig,
		ionicToast,
		yfeiUPIService,
		$scope,
		$ionicPopup) {

		var reVerificationDeviceVm = this;
        
		reVerificationDeviceVm.goBack = function () {
			
               $state.go('menu.yfeiSimSelection');
				
		}

		reVerificationDeviceVm.resetUpiPin = function (account) {
			reVerificationDeviceVm.selectedAccount = account;
			yfeiUPIService.navigatedSetPinFrom = "register";
			
			yfeiUPIService.selectedAccountDtls = reVerificationDeviceVm.selectedAccount;
			if (yfeiUPIService.selectedAccountDtls.mpinFlag == 'Y') { //check the code
				$state.go('menu.setUPIPin');
			} else {
				yfeiUPIService.showUpiAlert("alert", "You haven't set UPI pin for selected account. Click OK to proceed.", "menu.setUPIPin");
			}
		}

		reVerificationDeviceVm.androidReVerification = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"accountInfo": reVerificationDeviceVm.selectedAccountObj,
				"payerType": {
					"accountId": reVerificationDeviceVm.selectedAccountObj.accId,
					"accountNo": reVerificationDeviceVm.selectedAccountObj.maskedAccountNumber
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"transactionNote": ""
			})
			yfeiUPIService.getNativeData("onVerifyUPIPin", json).then(function (data) {
				utilityService.hideSpinner();
				if (JSON.parse(data).status == 'S') {
					yfeiUPIService.appGenID = JSON.parse(data).deviceInfo.servGenId;
					yfeiUPIService.mobileNumber = JSON.parse(data).deviceInfo.mobileNo;
                    localStorage.setItem('isSetMpin', "false");
					yfeiUPIService.welComePageNav = "reverifyDevice";
					$state.go('menu.yfeiWelcome');
				
				} else {
					yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				
				utilityService.hideSpinner();
				if (msg != -101)
					yfeiUPIService.showUpiAlert("error", msg);
			});
		}

		reVerificationDeviceVm.iosReVerification = function(){
			utilityService.showSpinner();
			var json = JSON.stringify({
				"passwordLength" : reVerificationDeviceVm.selectedAccountObj.uPinLength.toString(),
				"uPinFType" : reVerificationDeviceVm.selectedAccountObj.uPinFType,
				"bankName" : reVerificationDeviceVm.selectedAccountObj.bankName,
				"mobileNo" : $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo ? $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo.toString() : "",
				"payerVPA" : $rootScope.yfeiCheckDeviceInfo.userInfo.virtualAddress,
				"accountNo" : reVerificationDeviceVm.selectedAccountObj.maskedAccountNumber.toString(),
				"accID" : reVerificationDeviceVm.selectedAccountObj.accId.toString()
			})
			yfeiUPIService.getNativeData("onVerifyUPIPin", json).then(function (data) {
				utilityService.hideSpinner();
				if (JSON.parse(data).status == 'S') {
					yfeiUPIService.appGenID = JSON.parse(data).deviceInfo.servGenId;
					yfeiUPIService.mobileNumber = JSON.parse(data).deviceInfo.mobileNo;
					$state.go('menu.yfeiWelcome');
								} else {
					yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
				}
			}, function (msg) {
				
				utilityService.hideSpinner();
				if (msg != -101)
					yfeiUPIService.showUpiAlert("error", msg);
			});
		}

		reVerificationDeviceVm.reVerifyDevice = function (account) {
			
			reVerificationDeviceVm.selectedAccount = account;
			reVerificationDeviceVm.selectedAccountObj = reVerificationDeviceVm.selectedAccount;
			yfeiUPIService.selectedAccountDtls = reVerificationDeviceVm.selectedAccountObj;
			if (reVerificationDeviceVm.selectedAccountObj.mpinFlag == 'Y') {
				if (device.platform.toLowerCase() == 'android'){
					reVerificationDeviceVm.androidReVerification();
				}else{
					reVerificationDeviceVm.iosReVerification();
				}
			} else {
				yfeiUPIService.navigatedSetPinFrom = "register";
				$state.go('menu.setUPIPin');
			}
		}




       reVerificationDeviceVm.createNewUPI = function(){
		   utilityService.showSpinner();
            var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			yfeiUPIService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
				utilityService.hideSpinner();
				reVerificationDeviceVm.banklistResponse = JSON.parse(data);
				if (reVerificationDeviceVm.banklistResponse.status == 'S') {
					yfeiUPIService.bankList = reVerificationDeviceVm.banklistResponse.bankMasterList;
					yfeiUPIService.accountDtlAgainstBank = [];
					$state.go('menu.bankList');
				} else {
					yfeiUPIService.showUpiAlert("error", "Currently system is facing some technical challanges for fetching the bank list. Please try after sometime.");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
	   }

		$scope.$on('$ionicView.beforeEnter', function () {
			reVerificationDeviceVm.existingVPAId = yfeiUPIService.vpaForSetPin;
			reVerificationDeviceVm.selectedAccount = "";
			 reVerificationDeviceVm.accountList = yfeiUPIService.existingVPADetails.accountList;
			
		});

	   return this;
	}

]);

