'use strict';
angularApp.controller('setMpinSuccessController',
    ["$scope", "$state", "yfeiUPIService", "loggedInUserService", "cryptoService", "utilityService", "APICUtils", "$ionicSideMenuDelegate",
        function ($scope, $state, yfeiUPIService, loggedInUserService, cryptoService, utilityService, APICUtils, $ionicSideMenuDelegate) {
            var setMpinSuccessControllerVm = this;

            setMpinSuccessControllerVm.navigateToDashboard = function () {
              APICUtils.isUserLoggedIn = true;
                $state.go('menu.dashboard');
            }

            setMpinSuccessControllerVm.bioMetricChecked = function () {
                if (setMpinSuccessControllerVm.bioCheck) {
                    yfeiUPIService.isFingerprintAvailable().then(function () {
                        var encryptConfig = {
                            clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
                            clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
                            disableBackup: true,
                        };
                        Fingerprint.show(encryptConfig, successCallback, errorCallback);
                    }, function () {
                        setMpinSuccessControllerVm.bioCheck = false;
                    });
                } else {
                    disableBiometric();
                }
            }

            function successCallback(result) {
                enableBiometric();
            }

            function errorCallback(error) {
                setMpinSuccessControllerVm.bioCheck = false;
                yfeiUPIService.showUpiAlert("error", error.message);
            }

            function enableBiometric() {
                var random_str = utilityService.getRandomNumber(10);
                var fingerprint_token = cryptoService.encryptRSAWithPublicKey(random_str, cryptoService.rsaPublicKey);
                var obj = {
                    'bioAuthId': fingerprint_token,
                    'status': "true",
                    'reqValidate': ""
                };
                yfeiUPIService.setBiometric(obj).then(function (data) {
                    localStorage.setItem("isYfeiBiometricSet", true);
                    setMpinSuccessControllerVm.isBiometricSet = true;
                    cordova.plugins.SecureKeyStore.set(function (res) {
                        console.log(res);
                    }, function (error) {
                        yfeiUPIService.showUpiAlert("error", error);
                    }, loggedInUserService.deviceInfo, random_str);
                    var template = '';
                    if (yfeiUPIService.isBiometricType == 'face')
                        template = "Face ID has been enabled";
                    else
                        template = "Touch ID has been enabled";
                    var buttontext = "OK";
                    yfeiUPIService.showUpiAlert('success', template, "", buttontext, $scope);
                }, function (error) {
                    setMpinSuccessControllerVm.bioCheck = false;
                    if (error.responseMessage) {
                    yfeiUPIService.showUpiAlert("error", error.responseMessage);
                    }
                    else{
                        utilityService.showErrorMessage("Technical error occured");  
                    }
                });
            }

            function disableBiometric() {
                var obj = {
                    'bioAuthId': "",
                    'status': "false",
                    'reqValidate': ""
                };
                yfeiUPIService.setBiometric(obj).then(function (data) {
                    localStorage.setItem("isYfeiBiometricSet", false);
                    setMpinSuccessControllerVm.bioCheck = false;
                    cordova.plugins.SecureKeyStore.remove(function (res) {
                        console.log(res);
                    }, function (error) {
                        yfeiUPIService.showUpiAlert("error", error);
                    }, loggedInUserService.deviceInfo);

                    var template = '';
                    if (yfeiUPIService.isBiometricType == 'face')
                        template = "Face ID has been disabled";
                    else
                        template = "Touch ID has been disabled";
                    var buttontext = "OK";
                    yfeiUPIService.showUpiAlert('success', template, "", buttontext, $scope);
                }, function (error) {
                    setMpinSuccessControllerVm.bioCheck = true;
                    if (error.responseMessage) {
                        yfeiUPIService.showUpiAlert("error", error.responseMessage);
                   }
                    else{
                         utilityService.showErrorMessage("Technical error occured");  
                    }
                });
            }

            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicSideMenuDelegate.canDragContent(false);
                setMpinSuccessControllerVm.bioCheck = (localStorage.getItem("isYfeiBiometricSet") === "true");
             
            });
        }
    ]);
