'use strict';

angularApp.controller('setUpiPinATMDetailsController', ["$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"$timeout",
	"yfeiUPIService",


	function ($state,
		$ionicPopup,
		$scope,
		$rootScope,
		utilityService,
		constantConfig,
		$timeout,
		yfeiUPIService) {

		var setUpiPinATMDetailsVm = this;
		$scope.$on('$ionicView.beforeEnter', function () {
			setUpiPinATMDetailsVm.debitCardNum = "";
			setUpiPinATMDetailsVm.expiryMonthAndYear = "";
			setUpiPinATMDetailsVm.accountDetails = yfeiUPIService.selectedAccountDtls;
			setUpiPinATMDetailsVm.cardType = 'O';
			setUpiPinATMDetailsVm.showSendOtpBtn = false;
		

		});
		setUpiPinATMDetailsVm.goBack = function () {

			if (yfeiUPIService.navigatedSetPinFrom) {
				if (yfeiUPIService.navigatedSetPinFrom == "register") // reverify device page 
				{
					$state.go('menu.reverificationDevice');
				}
				else if (yfeiUPIService.navigatedSetPinFrom == "newRegistration") // new registration vpa success
				{
					$state.go('menu.vpaRegistrationSuccess');
				}
				else if (yfeiUPIService.navigatedSetPinFrom == "profile") // new registration vpa success
				{
					$state.go('menu.profileLanding');
				}
				else if (yfeiUPIService.navigatedSetPinFrom == "addAccount") // new registration vpa success
				{
					$state.go('menu.addBankAccountList');
				}

			}

		}
		setUpiPinATMDetailsVm.debitCardNumOnChange = function (debitCardNumber, event) {
			if (event == "cardNumber") {
				if (debitCardNumber.length > 2) {
					debitCardNumber = debitCardNumber.slice(0, 2) + ' ' + debitCardNumber.slice(2);
					setUpiPinATMDetailsVm.debitCardNum = debitCardNumber;
				}
				if (debitCardNumber.trim().length == 7) {
					setUpiPinATMDetailsVm.cardDetailsFlag = true;
				}
				else {
					setUpiPinATMDetailsVm.cardDetailsFlag = false;
				}
			}

			if (event == "cardExpiry") {
				if (setUpiPinATMDetailsVm.expiryMonthAndYear.length == 4) {
					setUpiPinATMDetailsVm.cardExpiryFlag = true;
				}
				else {
					setUpiPinATMDetailsVm.cardExpiryFlag = false;
				}
			}

			if (setUpiPinATMDetailsVm.cardDetailsFlag && setUpiPinATMDetailsVm.cardExpiryFlag) {
				setUpiPinATMDetailsVm.showSendOtpBtn = true;
			} else {
				setUpiPinATMDetailsVm.showSendOtpBtn = false;
			}
		}

		setUpiPinATMDetailsVm.setUpiPin = function () {
			if (setUpiPinATMDetailsVm.debitCardNum && (setUpiPinATMDetailsVm.expiryMonthAndYear && setUpiPinATMDetailsVm.expiryMonthAndYear.length == 4)) {
				setUpiPinATMDetailsVm.cardType = 'O';
			}
			else {
				setUpiPinATMDetailsVm.cardType = 'M';
			}
			if (!setUpiPinATMDetailsVm.debitCardNum) {
				yfeiUPIService.showUpiAlert("error", "Please enter last six digits of debit card");
				return false;
			}

			if (yfeiUPIService.navigatedSetPinFrom && yfeiUPIService.navigatedSetPinFrom == "profile") {
				setUpiPinATMDetailsVm.reverifyFlag = "N";
			}
			else {
				setUpiPinATMDetailsVm.reverifyFlag = "Y";
			}

			if(yfeiUPIService.navigatedSetPinFrom == "profile" && yfeiUPIService.setPinPostLogin) {
				setUpiPinATMDetailsVm.reverifyFlag = "";
			}

			utilityService.showSpinner();
			var json = {};
			if (setUpiPinATMDetailsVm.cardType == 'M') {
				json = {
					"accountId": setUpiPinATMDetailsVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": setUpiPinATMDetailsVm.cardType,
					"expiryDate": null,
					"re_verify": setUpiPinATMDetailsVm.reverifyFlag,
					"lastSixDigitDebitCardno": setUpiPinATMDetailsVm.debitCardNum.replace(/\s+/g, ''),
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": yfeiUPIService.vpaForSetPin
				};
			} else {
				if (!setUpiPinATMDetailsVm.expiryMonthAndYear || setUpiPinATMDetailsVm.expiryMonthAndYear.length != 4) {
					utilityService.hideSpinner();
					yfeiUPIService.showUpiAlert("error", "Please enter valid expiry month & year combination");
					return false;
				}
				json = {
					"accountId": setUpiPinATMDetailsVm.accountDetails.accId,
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"cardType": setUpiPinATMDetailsVm.cardType,
					"expiryDate": setUpiPinATMDetailsVm.expiryMonthAndYear,
					"lastSixDigitDebitCardno": setUpiPinATMDetailsVm.debitCardNum.replace(/\s+/g, ''),
					"re_verify": setUpiPinATMDetailsVm.reverifyFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"virtualAddress": yfeiUPIService.vpaForSetPin
				};
			}
			if (yfeiUPIService.navigatedSetPinFrom == "newRegistration") {
				json.accountId = setUpiPinATMDetailsVm.accountDetails.linkAccountId
			} else if (yfeiUPIService.addBankFlag == "addBankPaymentTime" || yfeiUPIService.addBankFlag == "addBankFromProfile" || yfeiUPIService.addBankFlag == "addBankGenQRCodeTime") {
				json.accountId = setUpiPinATMDetailsVm.accountDetails.linkAccountId
				json.re_verify = ""
			}
			yfeiUPIService.isUpiRegistration = false;
			yfeiUPIService.getNativeData(constantConfig.upiConstant.onSetMpin, JSON.stringify(json)).then(function (data) {
				utilityService.hideSpinner();
				if (JSON.parse(data).apiResp.status == 'S') {
					if (yfeiUPIService.navigatedSetPinFrom && (yfeiUPIService.navigatedSetPinFrom == "register" || yfeiUPIService.navigatedSetPinFrom == "newRegistration")) {
						yfeiUPIService.welComePageNav = "setUpiPinSucc";
						$state.go('menu.yfeiWelcome');
					} else if (yfeiUPIService.addBankFlag == "addBankPaymentTime" || yfeiUPIService.addBankFlag == "addBankGenQRCodeTime" || yfeiUPIService.addBankFlag == "addBankFromProfile") {
						yfeiUPIService.addBankDetails = yfeiUPIService.selectedAccountDtls
                        setUpiPinATMDetailsVm.getProfile()
                    } else {
						yfeiUPIService.headerTitle = "Profile";
						yfeiUPIService.proSuccessMessage = "You have successfully reset your UPI PIN";
						$state.go('menu.removeAccSuccess');
					}

				} else {
					if (yfeiUPIService.navigatedSetPinFrom == "profile") {
						yfeiUPIService.headerTitle = "Profile";
						yfeiUPIService.iconFlag = "alert";
						yfeiUPIService.footerBtn = "tryAndCancel";
						yfeiUPIService.proSuccessMessage = "Due to Invaild card details, we are	unable to reset your UPI PIN.";
						yfeiUPIService.proSuccessMessageSecond = "Please try again with valid details";
						$state.go('menu.removeAccSuccess');
					} else {
						yfeiUPIService.showUpiAlert("error", JSON.parse(data).apiResp.statusDesc);
					}
				}
			}, function (msg) {
				utilityService.hideSpinner();
				if (msg != -101)
					yfeiUPIService.showUpiAlert("error", msg);
			});
		}

		setUpiPinATMDetailsVm.getProfile = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
                utilityService.hideSpinner();
                var getProfileResponse = JSON.parse(data);
                if (getProfileResponse.status == "S") {
                    yfeiUPIService.payerProfileDtls = getProfileResponse;
                    setUpiPinATMDetailsVm.vpaList = getProfileResponse.vpaAccountDetails;
                    for (var i = 0; i < setUpiPinATMDetailsVm.vpaList.length; i++) {
                        for (var j = 0; j < setUpiPinATMDetailsVm.vpaList[i].accountInfo.length; j++) {
                            if (setUpiPinATMDetailsVm.vpaList[i].accountInfo[j].accId == setUpiPinATMDetailsVm.accountDetails.linkAccountId) {
                                yfeiUPIService.accDetails = setUpiPinATMDetailsVm.vpaList[i].accountInfo[j];
                            }
                        }
                    }
                    if (yfeiUPIService.addBankFlag == "addBankPaymentTime" || yfeiUPIService.addBankFlag == "addBankGenQRCodeTime" || yfeiUPIService.addBankFlag == "addBankFromProfile") {
                        $state.go('menu.addBankSuccess');
                    }
                } else {
                    yfeiUPIService.showUpiAlert("error", getProfileResponse.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

		return this;
	}

]);
