'use strict';

angularApp.controller('setYfeiMpinController', ["$timeout", "$state", "$scope", "$translate",
	"internetBankingService", "utilityService", "loggedInUserService", "cryptoService", "$rootScope", "$ionicSideMenuDelegate", "encryptionService", "constantConfig", "mPinLoginService", "regProcessWithAccNoService",
	"yfeiUPIService",
	function ($timeout, $state, $scope, $translate, internetBankingService, utilityService, loggedInUserService, cryptoService, $rootScope, $ionicSideMenuDelegate, encryptionService, constantConfig, mPinLoginService, regProcessWithAccNoService,
		yfeiUPIService) {

		var setMPINYFVm = this;
		var dataForHashing = "";
		var aesHashedMpin = "";

		setMPINYFVm.changeMpinSubmit = function () {
			setMPINYFVm.validConfirmFlag = true;
			setMPINYFVm.requiredFlag = false;
			var newMpin = setMPINYFVm.newMpin1 + setMPINYFVm.newMpin2 + setMPINYFVm.newMpin3 + setMPINYFVm.newMpin4 + setMPINYFVm.newMpin5 + setMPINYFVm.newMpin6;
			var confirmMpin = setMPINYFVm.reMpin1 + setMPINYFVm.reMpin2 + setMPINYFVm.reMpin3 + setMPINYFVm.reMpin4 + setMPINYFVm.reMpin5 + setMPINYFVm.reMpin6;

			if (!confirmMpin || !newMpin) {
				setMPINYFVm.requiredFlag = true;
			} else {
				var mpinPolicyMsg = setMPINYFVm.checkMPINConditions(newMpin, confirmMpin);

				if (mpinPolicyMsg == "success") {
					setMPINYFVm.mpinPolicyMsg = "MPIN Matched";
					setMPINYFVm.validConfirmFlag = false;
					dataForHashing = newMpin + loggedInUserService.deviceInfo;
					var dataForSimHash = "";
					var aesHashedSimInfo = "";
					yfeiUPIService.simId = localStorage.getItem("simSubscriptionId");
					if (utilityService.isAndroidPlatform()) {
						dataForHashing = dataForHashing + yfeiUPIService.simId;
						aesHashedMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
						dataForSimHash = device.uuid + yfeiUPIService.simId;
						aesHashedSimInfo = cryptoService.getSHA512EncryptedData(dataForSimHash);
					}
					else {
						aesHashedSimInfo = "iOS";
						aesHashedMpin = cryptoService.getSHA512EncryptedData(dataForHashing);
					}
					setMPINYFVm.mpinRegistration(aesHashedMpin, aesHashedSimInfo);

				} else {
					setMPINYFVm.mpinPolicyMsg = mpinPolicyMsg;
					setMPINYFVm.clearMpin();
				}
			}
		};
		setMPINYFVm.mpinRegistration = function (aesHashedMpinVar, aesHashedSimInfo) {

			var requestParams = {};
            if (yfeiUPIService.customerName) {
				var splitName = (yfeiUPIService.customerName).split(" ");
				if (splitName.length >= 3) {
					requestParams["firstName"] = splitName[0];
					requestParams["lastName"] = splitName[2];
				}
				else {
					requestParams["firstName"] = splitName[0];
					requestParams["lastName"] = splitName[1];
				}
			} else {
				requestParams["firstName"] = "";
				requestParams["lastName"] = "";
			}
			requestParams["mpin"] = aesHashedMpinVar.toString();
			requestParams["mobileNumber"] = yfeiUPIService.mobileNumber;
            requestParams["yfeiCustId"] = cryptoService.getSHA512EncryptedData(yfeiUPIService.mobileNumber).toString();
			requestParams["simId"] = aesHashedSimInfo.toString();
			requestParams["deviceId"] = loggedInUserService.deviceInfo;


			yfeiUPIService.setUserMpin(requestParams).then(function (data) {
				if (data.responseCode == "0000") {

					localStorage.setItem('yfeiAppGenId', yfeiUPIService.appGenID);
					localStorage.setItem('customerName', yfeiUPIService.customerName);
					loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"registrationType":"yfei","mpinConsent":true,"customername": "", "simSubscriptionId": "' + yfeiUPIService.simId + '"}').then(function (res) {
						setMPINYFVm.saveRegistrationData();


					}, function (err) {
						setMPINYFVm.saveRegistrationData();
					});
					localStorage.setItem('isSetMpin', "true");

				} else {
					setMPINYFVm.clearMpin();
					utilityService.showErrorMessage(error.responseMessage);
				}



			}, function (error) {
				setMPINYFVm.clearMpin();
				if (error.responseMessage) {
				utilityService.showErrorMessage(error.responseMessage);
				}
				else{
					utilityService.showErrorMessage("Technical error occured");
				}
				localStorage.setItem('isSetMpin', "false");

			});

		}
		setMPINYFVm.saveRegistrationData = function () {
			localStorage.setItem('isDeviceRegistered', true);
			localStorage.setItem('registrationType', "yfei");
			localStorage.setItem('mpinConsent', true);
			localStorage.setItem('customername', "");
			localStorage.setItem('simSubscriptionId', yfeiUPIService.simId);

			$state.go('menu.setMpinSuccess');
		}


		setMPINYFVm.checkMPINConditions = function (newMpin, confirmMpin) {
			if ((newMpin.toString()).length !== 6) {
				return 'MPIN should be 6 digits in length';
			}
			if (newMpin !== confirmMpin) {
				return 'MPIN does not match';
			}
			if (/(.)\1\1/.test(newMpin.toString())) {
				return 'Three consecutive numbers should not be same';
			}
			for (var i = 0; i < 4; i++) {
				if (newMpin[i + 1] == parseInt(newMpin[i]) + 1) {
					if (newMpin[i + 2] == parseInt(newMpin[i + 1]) + 1) {
						return 'Three consecutive numbers should not be in sequence';
					}
				}
			}
			for (var j = 0; j < 4; j++) {
				if (newMpin[j] == parseInt(newMpin[j + 1]) + 1) {
					if (newMpin[j + 1] == parseInt(newMpin[j + 2]) + 1) {
						return 'Three consecutive numbers should not be in sequence';
					}
				}
			}

			var validArrSet = [newMpin[0], newMpin[1], newMpin[2], newMpin[3], newMpin[4], newMpin[5]];
			var newArr = [];
			for (var k = 0; k < validArrSet.length; k++) {
				if (newArr.indexOf(validArrSet[k]) == -1) {
					newArr.push(validArrSet[k]);
				}
			}
			if (newArr.length < 3) {
				return 'At least 3 unique numbers should be there in MPIN';
			}
			return "success";
		};
		setMPINYFVm.clearMpin = function () {
			setMPINYFVm.newMpin1 = '';
			setMPINYFVm.newMpin2 = '';
			setMPINYFVm.newMpin3 = '';
			setMPINYFVm.newMpin4 = '';
			setMPINYFVm.newMpin5 = '';
			setMPINYFVm.newMpin6 = '';
			setMPINYFVm.reMpin1 = '';
			setMPINYFVm.reMpin2 = '';
			setMPINYFVm.reMpin3 = '';
			setMPINYFVm.reMpin4 = '';
			setMPINYFVm.reMpin5 = '';
			setMPINYFVm.reMpin6 = '';
		};

		setMPINYFVm.goToSendMPINOTP = function () {
			setMPINYFVm.changeMpinSubmit();
		};


		setMPINYFVm.goBack = function () {
			$state.go('menu.yfeiWelcome');

		};


		setMPINYFVm.closeView = function () {
			if (loggedInUserService.previousJourney == 'settings') {
				$state.go('menu.settings');

			}
			else if (loggedInUserService.previousJourney == 'NewLoginPage') {
				$state.go('menu.prehomeLoginRevamp');
			}
			else {
				$state.go('menu.openNewDigitalAccount');
			}
		};

		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			setMPINYFVm.isiOSFlag = false;
			if (utilityService.isIOSPlatform()) {
				setMPINYFVm.isiOSFlag = true;
			}
		});

		$scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

	}]);
