'use strict';

angularApp.controller('simSelectionController', [
	"$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"clickStreamService",
	"ionicToast",
	"yfeiUPIService",
	"$interval",
	"$translate",
	"APICUtils",
	"$filter",
	function (
		$state,
		$ionicPopup,
		$scope,
		$rootScope,
		utilityService,
		constantConfig,
		clickStreamService,
		ionicToast,
		yfeiUPIService,
		$interval,
		$translate,
		APICUtils,
		$filter) {

		var simSelectionVm = this;

		function initPage() {
			simSelectionVm.androidFlag = false;
			simSelectionVm.iOSFlag = false;
			simSelectionVm.simList = [];
			if (device.platform.toLowerCase() == 'android') {
				simSelectionVm.simList = yfeiUPIService.simCardInfo.cards;
				simSelectionVm.androidFlag = true;
			} else {
				simSelectionVm.simList = yfeiUPIService.simCardInfo;
				simSelectionVm.iOSFlag = true;
			}
		}

		simSelectionVm.goBack = function () {
			$state.go('menu.preRegistrationSelection');
		}
        
		
        $scope.$on('$ionicView.afterEnter', function () {
            if (APICUtils.appOutdateFlag) {
                var message = $filter('limitTo')(APICUtils.appOutdateMessage, 180);
                var exitAppButton = utilityService.isAndroidPlatform() ? '<button class="btn exitBtn" ng-click="simSelectionVm.exitForUpdateApp()">Exit</button>' : '';
                simSelectionVm.appUpdatePopup = $ionicPopup.show({
                    template: '<div class="popup-body"><div class="appUpdateContainer"><img class="appUpdateLogo" src="img/OMP/appUpdate.svg" alt="App update Logo"/></div><div class="appUpdateHeading">App Update Available</div><div class="appUpdateInfo">' + message + '</div><button class="btn updateAppBtn marginBottom4" ng-click="simSelectionVm.updateToStore()">Update</button>' + exitAppButton + '</div></p>',
                    title: '',
                    scope: $scope,
                    cssClass: 'app-update-popup'
                });
                var elem = angular.element(document.querySelector(".backdrop"));
                if (elem) {
                    elem.addClass('app-update-backdrop');
                }
            }
        });
        
        simSelectionVm.exitForUpdateApp = function () {
            ionic.Platform.exitApp();
            navigator.app.exitApp();
        };

        simSelectionVm.updateToStore = function () {
            utilityService.upgradeApp();
        };

		simSelectionVm.sendSms = function (sim) {
			if (sim.carrierName.indexOf('No service') == -1) {
				localStorage.setItem("simSubscriptionId", sim.subscriptionId);
				utilityService.showSpinner();
				var json = JSON.stringify({
					"smsContent": $rootScope.yfeiCheckDeviceInfo.smsGateWayContent,
					"smsEncKey": $rootScope.yfeiCheckDeviceInfo.smsGateWayKey,
					"smsGateWayNo": $rootScope.yfeiCheckDeviceInfo.smsGateWayNo,
					"slot": sim.simSlotIndex.toString()
				});
				yfeiUPIService.getNativeData(constantConfig.upiConstant.sendsms, json).then(function (data) {
					if (data.smsStatus === 'S') {
						utilityService.hideSpinner();
						$state.go("menu.smsTimer");
					} else if (data.smsStatus === 'A') {
						utilityService.hideSpinner();
						yfeiUPIService.showUpiAlert("alert", "Your phone is in flight mode. Please retry.");
					} else if (data.smsStatus === 'SN') {
						utilityService.hideSpinner();
						yfeiUPIService.showUpiAlert("alert", "Please check whether active sim card available in your device.");
					} else {
						utilityService.hideSpinner();
						yfeiUPIService.showUpiAlert("alert", "System is not able to send SMS from the selected sim. Please retry.");
					}
				}, function (msg) {
					utilityService.hideSpinner();
					yfeiUPIService.showUpiAlert("error", msg);
				});
			} else {
				yfeiUPIService.showUpiAlert("alert", "Kindly check your network settings for the selected sim card.");
			}
		};


		simSelectionVm.goToSelectNumber = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"smsGateWayContent": $rootScope.yfeiCheckDeviceInfo.smsGateWayContent,
				"smsGateWayKey": $rootScope.yfeiCheckDeviceInfo.smsGateWayKey,
				"smsGateWayNo": $rootScope.yfeiCheckDeviceInfo.smsGateWayNo,
				"appGenId": yfeiUPIService.appGenId
			});
			yfeiUPIService.getNativeData(constantConfig.upiConstant.sendsms, json).then(function (data) {
				utilityService.hideSpinner();
				$state.go("menu.smsTimer");
			}, function (msg) {
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
		});
		return this;
	}
]);


