'use strict';

angularApp.controller('smsTimerController', [
	"$state",
	"$ionicPopup",
	"$scope",
	"$rootScope",
	"utilityService",
	"constantConfig",
	"clickStreamService",
	"ionicToast",
	"yfeiUPIService",
	"$interval",
	"$translate",
	"loggedInUserService",
	function (
		$state,
		$ionicPopup,
		$scope,
		$rootScope,
		utilityService,
		constantConfig,
		clickStreamService,
		ionicToast,
        yfeiUPIService,
		$interval,
		$translate,
		loggedInUserService) {

		var smsTimerVm = this;

		function initPage() {

			smsTimerVm.timeLeft = 10;
			smsTimerVm.spinner = $interval(function () {
				if (smsTimerVm.timeLeft == 0) {
					smsTimerVm.showTimer = false;
					smsTimerVm.checkDeviceAfterSMS();
				} else {
					smsTimerVm.showTimer = true;
					smsTimerVm.timeRemaining = smsTimerVm.timeLeft;
					smsTimerVm.timeLeft--;
				}
			}, 1000)

		}

		smsTimerVm.checkDeviceAfterSMS = function () {
			$interval.cancel(smsTimerVm.spinner);
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": true
			});
			yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
				$rootScope.yfeiCheckDeviceInfo = JSON.parse(data);
				var obj = {
					'mobileNumber': $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo,
					'deviceId': $rootScope.yfeiCheckDeviceInfo.deviceInfo.deviceId,
					'simId': yfeiUPIService.generateMPINSHA512Val($rootScope.yfeiCheckDeviceInfo.deviceInfo.simId)
				};
				yfeiUPIService.simSerialNumber = $rootScope.yfeiCheckDeviceInfo.deviceInfo.simId;
				yfeiUPIService.updateRegCount(obj).then(function (data) {
					if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
						if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM' && $rootScope.yfeiCheckDeviceInfo.re_verify && $rootScope.yfeiCheckDeviceInfo.re_verify == 'Y') {
							utilityService.hideSpinner();
							yfeiUPIService.existingVPADetails = $rootScope.yfeiCheckDeviceInfo;
							smsTimerVm.existingUPIId = $rootScope.yfeiCheckDeviceInfo.userInfo.virtualAddress;
							yfeiUPIService.customerName = $rootScope.yfeiCheckDeviceInfo.userInfo.name;
							yfeiUPIService.vpaForSetPin = smsTimerVm.existingUPIId;
							yfeiUPIService.reverifyDevice = true;
							yfeiUPIService.isExistingVPA = false;  
							$state.go('menu.reverificationDevice');
							
						} else {
							if ($rootScope.yfeiCheckDeviceInfo.smsStatus == 'SS' && $rootScope.yfeiCheckDeviceInfo.simStatus == "SNN" && $rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN') {
								smsTimerVm.getBankList();
								yfeiUPIService.reverifyDevice = false;
							} else {
								utilityService.hideSpinner();
								yfeiUPIService.showUpiAlert("error", "Currently system is facing the issues with SMS gateway. Please try after sometime.");
								$state.go('menu.yfeiSimSelection');
							}
						}
					} else {
						utilityService.hideSpinner();
						yfeiUPIService.showUpiAlert("error", $rootScope.yfeiCheckDeviceInfo.statusDesc);
					}
				
			
				
				
				}, function (error) {
					utilityService.hideSpinner();
					if(error.responseMessage)
					{
                        yfeiUPIService.showUpiAlert("error", error.responseMessage, "menu.preRegistrationSelection");
					}
					else{
						yfeiUPIService.showUpiAlert("error", "Technical error occured", "menu.preRegistrationSelection");
					}
					
				})
			}, function (msg) {
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
		}
      

		
		smsTimerVm.getBankList = function () {
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			yfeiUPIService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
				utilityService.hideSpinner();
				smsTimerVm.banklistResponse = JSON.parse(data);
				if (smsTimerVm.banklistResponse.status == 'S') {
					yfeiUPIService.bankList = smsTimerVm.banklistResponse.bankMasterList;
					yfeiUPIService.accountDtlAgainstBank = [];
					$state.go('menu.bankList');
				} else {
					yfeiUPIService.showUpiAlert("error", "Currently system is facing some technical challanges for fetching the bank list. Please try after sometime.");
					$state.go('menu.yfeiSimSelection');
				}
			}, function (msg) {
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
		};


		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
		});


	

		return this;
	}
]);

