'use strict';

angularApp.controller('yfeiWelcomeController', ["$state", "$scope", "$rootScope", "yfeiUPIService", "utilityService", "constantConfig", "loggedInUserService",
	"APICUtils",
	"encryptionService",
	function ($state, $scope, $rootScope, yfeiUPIService, utilityService, constantConfig, loggedInUserService, APICUtils, encryptionService) {

		var yfeiWelcomeVm = this;
		yfeiWelcomeVm.successUpiPinCheckDevice = function () {
			utilityService.showSpinner();
			yfeiUPIService.getNativeData("setAppGenId", yfeiUPIService.appGenID).then(function (data) {
				var json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag,
					"smsSent": false
				});
				yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (res) {
					$rootScope.yfeiCheckDeviceInfo = JSON.parse(res);
					utilityService.hideSpinner();
					if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
						yfeiUPIService.mobileNumber = $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo;
						var authPayload = {};
					
						authPayload.deviceid = (device.uuid).toString();
		
						yfeiUPIService.finalSHA512Val = yfeiUPIService.generateMPINSHA512Val($rootScope.yfeiCheckDeviceInfo.deviceInfo.simId)
						
						authPayload.data = APICUtils.secretId + "^Reg" + yfeiUPIService.finalSHA512Val;

						utilityService.showSpinner();

						yfeiUPIService.yfeiLoginAuthorize(authPayload).then(
							function (data) {
								var codeData = data;
								var splitUrls = codeData.split("=");
								let splittedUrl1 = splitUrls[0];
								let splittedUrl2 = splitUrls[1];
								if (splittedUrl1 == "code") {
									var reqObj = { "requestKey": "readStatus" };
									yfeiUPIService.getAuthError(reqObj).then(
										function (data) {
											utilityService.hideSpinner();
											if (data.scrId) {
												APICUtils.clientSecret = encryptionService.getAES256DecryptedData(data.scrId);
												var jsonObj = {};
												jsonObj.code = splittedUrl2;
												jsonObj.client_id = APICUtils.clientID;
												jsonObj.client_secret = APICUtils.clientSecret;
												jsonObj.grant_type = "authorization_code";
												jsonObj.scope = APICUtils.authScope;

									utilityService.accessRestricted = "";
									utilityService.hideSpinner();

									yfeiUPIService.getAuthToken(jsonObj).then(
										function (data) {
											var tokenResponse = JSON.parse(data);
											loggedInUserService.accessToken = tokenResponse.access_token;
											$state.go('menu.setDeviceMpin');

													}, function (error) {
														if (error.responseMessage) {
															utilityService.showErrorMessage(error.responseMessage);
														}
														else {
															utilityService.showErrorMessage("Technical error occured");
														}
													});
											}
										    else{
												utilityService.showErrorMessage("Technical error occured");
											}

											

										}, function (error) {
											utilityService.hideSpinner();
											if (error.responseCode) {
												utilityService.showErrorMessage(error.responseMessage);
											}
											else {
												utilityService.showErrorMessage("Technical error occured");
											}

										});


								}
								else {
									utilityService.showErrorMessage("Technical error occured");
								}

							},
							function (error) {
								utilityService.hideSpinner();
								if (error.responseMessage) {
									utilityService.showErrorMessage(error.responseMessage);
								}
								else {
									utilityService.showErrorMessage("Technical error occured");
								}
							});

					} else {
						$state.go('menu.preRegistrationSelection');//Redirect FT main Dashboard
					}
				}, function (msg) {
					utilityService.hideSpinner();
					yfeiUPIService.showUpiAlert("error", msg);
				});
			}, function (msg) {
				utilityService.hideSpinner();
				yfeiUPIService.showUpiAlert("error", msg);
			});
		}

		yfeiWelcomeVm.goBack = function () {
			
			if(yfeiUPIService.welComePageNav)
			{
				if(yfeiUPIService.welComePageNav == "registrationVPASucc")
				{
                             $state.go('menu.vpaRegistrationSuccess');
				}
				else if(yfeiUPIService.welComePageNav == "setUpiPinSucc")
				{
                              $state.go('menu.setUPIPin');
				}else if(yfeiUPIService.welComePageNav == "reverifyDevice"){
                         $state.go('menu.reverificationDevice');
				}
			}
			else
			{
                  $state.go('menu.preRegistrationSelection');
			}
		}

		



	}]);
