'use strict';

angularApp.controller('preRegistrationSelectionController', [
    "$state",
    "$ionicPopup",
    "$scope",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "clickStreamService",
    "ionicToast",
    "yfeiUPIService",
    "loggedInUserService",
    "$translate",
    "ompMerchantsService",
    "cryptoService",
    "encryptionService",
    "APICUtils",
    "$filter",
    "AdapterUtils",
    "quickPayService",
    "registerWithSimService",
    "ConnectivityMonitorUtils",
    function (
        $state,
        $ionicPopup,
        $scope,
        $rootScope,
        utilityService,
        constantConfig,
        clickStreamService,
        ionicToast,
        yfeiUPIService,
        loggedInUserService,
        $translate,
        ompMerchantsService,
        cryptoService,
        encryptionService,
        APICUtils,
        $filter,
        AdapterUtils,
        quickPayService,
        registerWithSimService,
        ConnectivityMonitorUtils) {

        var preRegistrationSelectionVm = this;
        yfeiUPIService.yfeiNavigation = "";
        preRegistrationSelectionVm.isOffline = false;
        preRegistrationSelectionVm.retryBtn = false;
        preRegistrationSelectionVm.err = '';

        preRegistrationSelectionVm.yonoRegistration = function () {
            if (!AdapterUtils.secretData) {
                callSaveCustomInfo('yonoRegister');
            }
            else {
                $state.go('menu.landingWithOptions');
            }

        }
        preRegistrationSelectionVm.openSavingsAccount = function (pageName) {
            yfeiUPIService.yfeiNavigation = pageName;
            if (!AdapterUtils.secretData) {
            callSaveCustomInfo('openAccount');
            }
            else{
                $state.go("menu.newToSbiLanding");
            }
           
        }

        function callSaveCustomInfo(optionSelected) {
            preRegistrationSelectionVm.registrationSelected = 'yono';
            APICUtils.secretId ="";
            preRegistrationSelectionVm.optionSelect = optionSelected;
            utilityService.showSpinner();
            try {
                $translate(['VERSION_NO']).then(function (translations) {
                    preRegistrationSelectionVm.appVersion = translations['VERSION_NO'] ? translations['VERSION_NO'] : '';
                });
               
                var payload = {
					"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
					"src": loggedInUserService.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(loggedInUserService.keystoreValue, cryptoService.rsaPublicKey) : ""
				    
				};
				if(preRegistrationSelectionVm.appVersion){
					payload.appCode = "VERSION_NO"; //Build number
				}
				payload.irf = preRegistrationSelectionVm.isDeviceRegistered ? 'true' : 'false';
				payload.irv =  cryptoService.getSHA512EncryptedData(payload.irf).toString();
                var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 3000 });
                resourceRequest.send(payload).then(function (response) {
					utilityService.lastTimeStamp = new Date();
					response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
                    console.log(response.responseText);
					if (response.responseText.responseCode == '0000') {
						utilityService.hideSpinner();
						AdapterUtils.secretData = response.responseText.data.key;
						loggedInUserService.keyId = response.responseText.data.keyId;
						loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
						loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
						loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
						loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
						quickPayService.yqpVpaLimit =response.responseText.data.yqpVpaLimit;
                        
						quickPayService.yqpRaiseRequestLimit = response.responseText.data.yqpRaiseRequestLimit;
                        quickPayService.yqpBeneficiaryLimit = response.responseText.data.yqpBeneficiaryLimit;
						registerWithSimService.simVMNValidate = response.responseText.data.reqValidate;
						registerWithSimService.respValidate = response.responseText.data.respValidate;
						registerWithSimService.simBindingVirtualMobile = response.responseText.data.simVirtualMobNo;
						registerWithSimService.isSimLogin = response.responseText.data.isSimLogin;
						registerWithSimService.isSimRegistration = response.responseText.data.isSimRegistration;
						registerWithSimService.velocityMaxCount  = response.responseText.data.velocityMaxCount;
						registerWithSimService.velocityErrorMessage   = response.responseText.data.velocityErrorMessage ;
						registerWithSimService.maxVelValidate = response.responseText.data.maxVelValidate;
                        loggedInUserService.isUserTour = response.responseText.data.isUserTour;
                        loggedInUserService.bkvFundDonationUrl = response.responseText.data.bkvFundDonationUrl;
                            loggedInUserService.appOutdateFlag = response.responseText.data.appOutdateFlag === "true" ? true : false;
                            loggedInUserService.fastTagFlag = response.responseText.data.fastTagFlag;//fast tag icon removal journey
                            loggedInUserService.appOutdateMessage = response.responseText.data.appOutdateMessage;                  
                            if(response.responseText.data.latestAndroidAppVersion){    
                                loggedInUserService.latestAndroidAppVersion = "";
                                loggedInUserService.latestAndroidAppVersion = response.responseText.data.latestAndroidAppVersion;
                            }

                            if (registerWithSimService.isSimRegistration || !preRegistrationSelectionVm.deviceRegistered) {
                            var checkVMNHash = cryptoService.getSHA512EncryptedData(registerWithSimService.simBindingVirtualMobile + "SIM_BINDING");
                            if (checkVMNHash.toString() !== registerWithSimService.simVMNValidate) {
                           
                                utilityService.showExitAlertPopup("Technical Error");return;
                            }
                        }
                        var checkVelocityCountHash = cryptoService.getSHA512EncryptedData(registerWithSimService.velocityMaxCount + "SIM_BINDING");
                        if (checkVelocityCountHash.toString() !== registerWithSimService.maxVelValidate) {
                       
                            utilityService.showExitAlertPopup("Technical Error");return;
                        }
                        var checkFlagHash = cryptoService.getSHA512EncryptedData(registerWithSimService.isSimRegistration +""+ registerWithSimService.isSimLogin + "SIM_BINDING");
                        if (checkFlagHash.toString() !== registerWithSimService.respValidate) {
                       
                            utilityService.showExitAlertPopup("Technical Error");return;
                        }
                       
                        if(response.responseText.data.latestIOSAppVersion){
                        loggedInUserService.latestIOSAppVersion = "";
                        loggedInUserService.latestIOSAppVersion = response.responseText.data.latestIOSAppVersion;
                        }
                      
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NAV_YONO_REGISTER"));
						loggedInUserService.isServerConnected = true;
						if (optionSelected == 'yonoRegister') {
                           
                            $state.go('menu.landingWithOptions');
                        } else if (optionSelected == 'openAccount') {
                            $state.go("menu.newToSbiLanding");
                        }
                        else if (optionSelected == 'offers') {
                            $state.go('menu.NTBBestOffer');
                        }

					} else {
                        utilityService.hideSpinner();
                        preRegistrationSelectionVm.saveCustomErrorPopUP();
                        preRegistrationSelectionVm.msgWithRetry(response);
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    preRegistrationSelectionVm.err ="";
                    preRegistrationSelectionVm.err = utilityService.getServerExceptionMessage(error);
                    loggedInUserService.isServerConnected = false;
                    $scope.$apply(function () {
                        preRegistrationSelectionVm.err = utilityService.getServerExceptionMessage(error);
                        preRegistrationSelectionVm.saveCustomErrorPopUP();
                        if (error.errorCode == 'MAINTENANCE_CODE') {
                            preRegistrationSelectionVm.sdkVersionError = true
                            preRegistrationSelectionVm.retryBtn = false;
                        } else {
                            preRegistrationSelectionVm.retryBtn = true;
                        }
                    });

                    /**
                     * Yono lite redirection
                     */
                    if (error.errorCode == 'MAINTENANCE_PAGE') {
                        if (preRegistrationSelectionVm.errorPopup) {
                            preRegistrationSelectionVm.errorPopup.close();
                        }

                        preRegistrationSelectionVm.maintenanceMessage = error.errorMsg;
                        preRegistrationSelectionVm.appInstalled = false;
                        var template = '<div class="yono-maintenance row row-wrap text-center"><span class="col col-80 col-offset-10 maintenance-logo"></span><strong class="col col-90">YONO app is under maintenance.</strong><span class="col col-90">Do you want to <span ng-if="appInstalled">continue with</span><span ng-if="!appInstalled">download</span> our other application Yono Lite?</span><span class="col col-80 col-offset-10" style="line-height: 1.3em;"></span><button class="col col-80 col-offset-10 button button-block button-positive btn-primary-button" ng-click="redirectYonoLite()" ng-if="appInstalled">Go to Yono Lite</button><span class="col col-90"  ng-if="appInstalled">On clicking \'<strong>Go to Yono Lite</strong>\' you will be redirected to the Yono Lite applicaiton.</span><button class="col col-80 col-offset-10 button button-block button-positive btn-primary-button" ng-click="redirectAppStore()" ng-if="!appInstalled">Download Yono Lite</button><span class="col col-90" ng-if="!appInstalled">On clicking \'<strong>Download Yono Lite</strong>\' you will be redirected to the app store/play store in your mobile.</span><span class="col col-80 col-offset-10" style="line-height: 1.3em;"></span><strong class="col col-100" style="color: #673390;" ng-click="preRegistrationSelectionVm.retry(optionSelected)">Retry</strong><span class="col col-80 col-offset-10">{{maintenanceMessage}}</span></div>';
                        var myPopup;
                        if (utilityService.isAndroidPlatform()) {
                            window.plugins.launcher.canLaunch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (succes) {
                                preRegistrationSelectionVm.appInstalled = true;
                                myPopup = $ionicPopup.show({
                                    cssClass: 'maintenance-popup', // String, The custom CSS class name
                                    template: template, // String (optional). The html template to place in the popup body.
                                    scope: $scope // Scope (optional). A scope to link to the popup content.
                                });
                            }, function (responseerror) {
                                preRegistrationSelectionVm.appInstalled = false;
                                myPopup = $ionicPopup.show({
                                    cssClass: 'maintenance-popup', // String, The custom CSS class name
                                    template: template, // String (optional). The html template to place in the popup body.
                                    scope: $scope // Scope (optional). A scope to link to the popup content.
                                });
                            });
                        } else {
                            appAvailability.check(constantConfig.yonoLiteRedirectionURL.iOSPackSchema, function () {
                                preRegistrationSelectionVm.appInstalled = true;
                                myPopup = $ionicPopup.show({
                                    cssClass: 'maintenance-popup', // String, The custom CSS class name
                                    template: template, // String (optional). The html template to place in the popup body.
                                    scope: $scope // Scope (optional). A scope to link to the popup content.
                                });
                            }, function () {
                                preRegistrationSelectionVm.appInstalled = false;
                                myPopup = $ionicPopup.show({
                                    cssClass: 'maintenance-popup', // String, The custom CSS class name
                                    template: template, // String (optional). The html template to place in the popup body.
                                    scope: $scope // Scope (optional). A scope to link to the popup content.
                                });
                            });
                        }
                        $scope.redirectAppStore = function () {
                            var url = '';
                            if (utilityService.isAndroidPlatform()) {
                                url = constantConfig.yonoLiteRedirectionURL.androidPlayStore;
                            } else {
                                url = constantConfig.yonoLiteRedirectionURL.iOSAppleStore;
                            }
                            ompMerchantsService.inChromeBrowser(url);
                            myPopup.close();
                        };
                        $scope.redirectYonoLite = function () {
                            var url = constantConfig.yonoLiteRedirectionURL.androidPackSchema;
                            if (!utilityService.isAndroidPlatform()) {
                                url = constantConfig.yonoLiteRedirectionURL.iOSPackSchema;
                                ompMerchantsService.inChromeBrowser(url);
                            } else {
                                window.plugins.launcher.canLaunch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (succes) {
                                    window.plugins.launcher.launch({ packageName: constantConfig.yonoLiteRedirectionURL.yonoLiteAppPackageName }, function (success) { console.log(success) }, function (responseerror1) {
                                        console.log(responseerror1)
                                    });
                                }, function (responseerror2) {
                                    console.log(responseerror2);
                                });
                            }
                            myPopup.close();
                        };
                        /**
                         * Yono lite redirection ENDS
                         */
                    }

                });

                //write down the else condition for yfei initiate call will be happen
            } catch (err) {
                utilityService.hideSpinner();
                preRegistrationSelectionVm.saveCustomErrorPopUP();
                loggedInUserService.isServerConnected = false;
                $scope.$apply(function () {
                    preRegistrationSelectionVm.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
                    preRegistrationSelectionVm.retryBtn = true;
                });

            }
        }

        preRegistrationSelectionVm.retry = function () {
            if (preRegistrationSelectionVm.errorPopup) {
                preRegistrationSelectionVm.errorPopup.close();
            }

            preRegistrationSelectionVm.isOffline = false;
            preRegistrationSelectionVm.retryBtn = false;
            preRegistrationSelectionVm.err = "";
            if (ConnectivityMonitorUtils.isOffline()) {
                preRegistrationSelectionVm.err = "Unable to connect to Internet. Please check your connectivity.";
                preRegistrationSelectionVm.retryBtn = true;
               
            }
            else {
                preRegistrationSelectionVm.err = "";
                if (preRegistrationSelectionVm.registrationSelected == 'yono') {
                    callSaveCustomInfo(preRegistrationSelectionVm.optionSelect);
                }
                else if (preRegistrationSelectionVm.registrationSelected == 'yfei') {
                    preRegistrationSelectionVm.callInitiate();
                }

            }
        };

        preRegistrationSelectionVm.upgrade = function () {
            preRegistrationSelectionVm.errorPopup.close();
            utilityService.upgradeApp();
        }

        preRegistrationSelectionVm.cancel = function () {
            preRegistrationSelectionVm.errorPopup.close();
        }


        preRegistrationSelectionVm.saveCustomErrorPopUP = function () {
            preRegistrationSelectionVm.errorPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/YFEI/registrationSelection/saveCustomErrorPopUp.html",
                scope: $scope
            });
        }

        preRegistrationSelectionVm.msgWithRetry = function (serverresponse) {
            loggedInUserService.isServerConnected = false;
            $scope.$apply(function () {
                if (serverresponse.responseText.responseCode == '0001' || serverresponse.responseText.responseCode == '0002') {
                    preRegistrationSelectionVm.err = serverresponse.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
                    preRegistrationSelectionVm.retryBtn = true;
                }
                else if (serverresponse.responseText.responseCode == '0003' || serverresponse.responseText.responseCode == '0004') {
                    preRegistrationSelectionVm.err = constantConfig.adapter.UPDATE_APPLICATION;
                    preRegistrationSelectionVm.upgrade = true;
                }
            });

        }
        preRegistrationSelectionVm.openShoppingOffers = function (pageName) {
            yfeiUPIService.yfeiNavigation = pageName;
            ompMerchantsService.NtbBestOfferClicked = true;
            if (!AdapterUtils.secretData) {
            callSaveCustomInfo('offers');}
            else{
                $state.go('menu.NTBBestOffer');
            }
        }

        preRegistrationSelectionVm.yfeiRegistration = function () {
            APICUtils.yfeiClickStream = true;
            if (!APICUtils.secretId) {
                preRegistrationSelectionVm.callInitiate();
            }
            else {
                preRegistrationSelectionVm.continueUpiFlow();
            }

            /**/

        }
        preRegistrationSelectionVm.callInitiate = function () {
            preRegistrationSelectionVm.registrationSelected = 'yfei';
            AdapterUtils.secretData ="";
            var payload = {};
            if (loggedInUserService.vesionNumber) {
                payload.appCode = cryptoService.getSHA512EncryptedData(loggedInUserService.vesionNumber).toString();
            }
            payload.keys = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
            payload.irf = yfeiUPIService.deviceRegistered ? 'true' : 'false';
            payload.irv = cryptoService.getSHA512EncryptedData(payload.irf).toString();
            payload.deviceid = cryptoService.encryptRSAWithPublicKey(device.uuid, cryptoService.rsaPublicKey);
            payload.gethDid = cryptoService.getSHA512EncryptedData(device.uuid).toString();
            yfeiUPIService.initiate(payload).then(
                function (data) {
                    var responseObj = data;
                    if (responseObj.data) {
                        APICUtils.secretId = responseObj.data.sid;
                        yfeiUPIService.keyId = responseObj.data.mkid;
                        if (responseObj.data.latestAndroidAppVersion) {
                            APICUtils.latestAndroidAppVersion = "";
                            APICUtils.latestAndroidAppVersion = responseObj.data.latestAndroidAppVersion;
                        }
                        if (responseObj.data.latestIOSAppVersion) {
                            APICUtils.latestIOSAppVersion = "";
                            APICUtils.latestIOSAppVersion = responseObj.data.latestIOSAppVersion;
                        }
                        loggedInUserService.upiPermissionKey = responseObj.data.upiPermissionVal;
                        APICUtils.appOutdateFlag = responseObj.data.appOutdateFlag === "true" ? true : false;
                        APICUtils.appOutdateMessage = responseObj.data.appOutdateMessage;
                        APICUtils.clientID =  encryptionService.getAES256DecryptedData(responseObj.data.clientId);
                        utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
                        
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "NAV_YONO_REGISTER"));
                        preRegistrationSelectionVm.continueUpiFlow();
                    }
                },
                function (error) {
                    preRegistrationSelectionVm.saveCustomErrorPopUP();
                    if (error.responseMessage) {
                        preRegistrationSelectionVm.err = error.responseMessage;
                    }
                    else {
                        preRegistrationSelectionVm.err = "Technical error occured";
                    }

                    preRegistrationSelectionVm.retryBtn = true;


                }
            );
        }
        preRegistrationSelectionVm.checkVersionIntegrity = function () {
            if (APICUtils.latestAndroidAppVersion && APICUtils.latestIOSAppVersion) {
                var latestAndroidAppVersion_components = APICUtils.latestAndroidAppVersion.split(".");
                var latestIOSAppVersion_components = APICUtils.latestIOSAppVersion.split(".");
                var appVersion_components = loggedInUserService.vesionNumber.split(".");
                if (!localStorage.getItem('ignoredYFEIVersion')) {
                    localStorage.setItem('ignoredYFEIVersion', "0.0.0");
                }
                preRegistrationSelectionVm.ignoredVersion = localStorage.getItem('ignoredYFEIVersion');
                var ignoredVersion_components = preRegistrationSelectionVm.ignoredVersion.split(".");
                var lenAndroid = Math.min(latestAndroidAppVersion_components.length, appVersion_components.length);
                var lenIOS = Math.min(latestIOSAppVersion_components.length, appVersion_components.length);

                if (ionic.Platform.isAndroid()) {

                    for (var i = 0; i < lenAndroid; i++) {
                        if (parseInt(latestAndroidAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestAndroidAppVersion_components[i]) > parseInt(appVersion_components[i])) {

                            preRegistrationSelectionVm.appUpdatePopup = $ionicPopup.show({
                                template: '<p><center>Update for app is available. Current version is ' + loggedInUserService.vesionNumber + '. Latest Version is ' + APICUtils.latestAndroidAppVersion + '. Please Update</p>',
                                title: '',
                                scope: $scope,
                                cssClass: 'my-custom-popup',
                                buttons: [{
                                    text: 'Update',
                                    type: 'button-assertive',
                                    onTap: function () {

                                        cordova.plugins.market.open('com.sbi.lotusintouch');
                                    }
                                },

                                {
                                    text: 'Later',
                                    type: 'button-assertive',
                                    onTap: function () {

                                        localStorage.setItem('ignoredYFEIVersion', APICUtils.latestAndroidAppVersion);
                                        preRegistrationSelectionVm.continueUpiFlow();
                                    }
                                }],

                            });

                            break;
                        }
                        else {
                            preRegistrationSelectionVm.continueUpiFlow();
                        }


                    }

                }
                if (ionic.Platform.isIOS()) {

                    for (var i = 0; i < lenIOS; i++) {

                        if (parseInt(latestIOSAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestIOSAppVersion_components[i]) > parseInt(appVersion_components[i])) {
                            preRegistrationSelectionVm.appUpdatePopup = $ionicPopup.show({
                                template: '<p><center>Update for app is available. Current version is ' + loggedInUserService.vesionNumber + '. Latest Version is ' + APICUtils.latestIOSAppVersion + '. Please Update</p>',
                                title: '',
                                scope: $scope,
                                cssClass: 'my-custom-popup',
                                buttons: [{
                                    text: 'Update',
                                    type: 'button-assertive',
                                    onTap: function () {

                                        cordova.plugins.market.open('id1231393474');
                                    }
                                },

                                {
                                    text: 'Later',
                                    type: 'button-assertive',
                                    onTap: function () {

                                        localStorage.setItem('ignoredYFEIVersion', APICUtils.latestIOSAppVersion);
                                        preRegistrationSelectionVm.continueUpiFlow();
                                    }
                                }],

                            });
                            break;
                        }


                    }

                }

            }
            else {
                preRegistrationSelectionVm.continueUpiFlow();
            }
        }
        preRegistrationSelectionVm.continueUpiFlow = function () {
                yfeiUPIService.getNativeData("setAppGenId", "").then(function (data) {
            utilityService.showSpinner();
                yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (data) {
                    if (device.platform.toLowerCase() == 'android') {
                        yfeiUPIService.yfeiAppGenId = data.appGenId;
                    } else {
                        yfeiUPIService.yfeiAppGenId = data;
                    }
                    preRegistrationSelectionVm.redirectToUPIFlow();
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
                }, function (msg) {
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }

        preRegistrationSelectionVm.redirectToUPIFlow = function () {
            if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                yfeiUPIService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
                    if (data.permission === 'Allowed') {
                        preRegistrationSelectionVm.redirectToUPIJourney();
                    } else {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
            else {
                readiOSSimcardInfo();
            }
        }


        preRegistrationSelectionVm.redirectToUPIJourney = function () {
            function simInfosuccessCallback(result) {
                if (result !== undefined && result != null && result != '') {
                    if (result.cards && result.cards.length > 0) {
                        yfeiUPIService.simCardInfo = result;
                        utilityService.showSpinner();
                        var json = JSON.stringify({
                            "addInfo": {
                                "addInfo10": constantConfig.upiConstant.addInfo10,
                                "addInfo9": constantConfig.upiConstant.addInfo9
                            },
                            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                            "requestInfo": {
                                "pspId": constantConfig.upiConstant.pspId,
                                "pspRefNo": generateRandomString(27)
                            },
                            "updateFlag": constantConfig.upiConstant.updateFlag,
                            "smsSent": false
                        });
                        yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                            $rootScope.yfeiCheckDeviceInfo = JSON.parse(data);
                            if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
                                if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN') {
                                    yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (res) {
                                        utilityService.hideSpinner();
                                        yfeiUPIService.appGenId = res.appGenId;
                                        $state.go('menu.yfeiSimSelection');
                                    }, function (msg) {
                                        utilityService.hideSpinner();
                                        yfeiUPIService.showUpiAlert("error", msg);
                                    });
                                } else if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') {
                                    utilityService.hideSpinner();
                                    if ($rootScope.yfeiCheckDeviceInfo.re_verify && $rootScope.yfeiCheckDeviceInfo.re_verify == 'Y') {
                                        yfeiUPIService.showUpiAlert("alert", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                                    } else {
                                        var isMpinSet = localStorage.getItem("isSetMpin");
                                        yfeiUPIService.mobileNumber = $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo;
                                        if (isMpinSet && isMpinSet == "true") {
                                            $state.go('menu.yfeiLogin');
                                        }
                                        else {
                                            $state.go('menu.yfeiSimSelection');
                                        }
                                    }
                                } else if (($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') || ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN')) {
                                    utilityService.hideSpinner();
                                    yfeiUPIService.fileStorageRemove();
                                    yfeiUPIService.showUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.preRegistrationSelection");
                                }
                            } else {
                                utilityService.hideSpinner();
                                yfeiUPIService.showUpiAlert("error", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                            }
                        }, function (msg) {
                            utilityService.hideSpinner();
                            yfeiUPIService.showUpiAlert("error", msg);
                        });
                    } else {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg);
                    }
                } else {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg);
                }
            }

            function HasPerminionSuccessCallback(result) {
                if (result) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                } else {
                    requestReadPermission();
                }
            }

            function errorCallback(error) {
                var elementSimInfo = document.getElementById('ErrorInfo');
                elementSimInfo.innerHTML = error;
            }

            function requestSuccessCallback(result) {
                if (result) {
                    hasReadPermission();
                }
            }

            // Android only: check permission
            function hasReadPermission() {
                window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
            }

            // Android only: request permission
            function requestReadPermission() {
                window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
            }

            hasReadPermission();
            /*Sim card Info fetching - End*/
        };


        function readiOSSimcardInfo() {
            function simInfosuccessCallback(result) {
                yfeiUPIService.simCardInfo = result;
                utilityService.hideSpinner();
                if (utilityService.isIOSPlatform()) {
                    if (result.countryCode === '' || result.mnc === '' || result.mcc === '' || result.carrierName === '' || result.carrierName === 'No service') {
                        yfeiUPIService.showUpiAlert("alert", yfeiUPIService.noSimMsg);
                    } else {
                        preRegistrationSelectionVm.redirectToiOSUPIJourney();
                    }
                }

            }

            function HasPerminionSuccessCallback(result) {
                if (result) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                } else {
                    requestReadPermission();
                }
            }

            function errorCallback(error) {
                utilityService.hideSpinner();
                utilityService.showExitAlertPopup("Permission denied.");
            }

            function requestSuccessCallback(result) {
                if (result) {
                    hasReadPermission();
                }
            }
            // Android only: check permission
            function hasReadPermission() {
                window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
            }
            // Android only: request permission
            function requestReadPermission() {
                window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
            }
            if (utilityService.isIOSPlatform()) {
                window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
            }
            else hasReadPermission();

            /*Sim card Info fetching - End*/
        }


        preRegistrationSelectionVm.redirectToiOSUPIJourney = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "pspId": constantConfig.upiConstant.pspId,
                "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
            });
            yfeiUPIService.getNativeData("initializeIOSsdk", json).then(function (data) {
                if (data !== "S") {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", data);
                    return false;
                }
                utilityService.showSpinner();
                var jsonCheck = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "updateFlag": constantConfig.upiConstant.updateFlag,
                    "smsSent": "false"
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.checkDevice, jsonCheck).then(function (res) {
                    $rootScope.yfeiCheckDeviceInfo = JSON.parse(res);
                    if ($rootScope.yfeiCheckDeviceInfo.status == 'S') {
                        if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN') {
                            yfeiUPIService.getNativeData("generateAppGenId", {}).then(function (resp) {
                                utilityService.hideSpinner();
                                yfeiUPIService.appGenId = resp;
                                $state.go('menu.yfeiSimSelection');
                            }, function (msg) {
                                utilityService.hideSpinner();
                                yfeiUPIService.showUpiAlert("error", msg);
                            });
                        } else if ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') {
                            utilityService.hideSpinner();
                            if ($rootScope.yfeiCheckDeviceInfo.re_verify && $rootScope.yfeiCheckDeviceInfo.re_verify == 'Y') {
                                yfeiUPIService.showUpiAlert("alert", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                            } else {
                                var isMpinSet = localStorage.getItem("isSetMpin");
                                yfeiUPIService.mobileNumber = $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo;
                                if (isMpinSet && isMpinSet == "true") {
                                    $state.go('menu.yfeiLogin');
                                }
                                else {
                                    $state.go('menu.yfeiSimSelection');
                                }

                            }
                        } else if (($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DN' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNM') || ($rootScope.yfeiCheckDeviceInfo.deviceStatus == 'DR' && $rootScope.yfeiCheckDeviceInfo.simStatus == 'SNN')) {
                            utilityService.hideSpinner();
                            yfeiUPIService.fileStorageRemove();
                            yfeiUPIService.showUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.preRegistrationSelection");
                        }
                    } else {
                        utilityService.hideSpinner();
                        yfeiUPIService.showUpiAlert("error", $rootScope.yfeiCheckDeviceInfo.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }


        $scope.$on('$ionicView.loaded', function () {
            if (yfeiUPIService.threeAttemptWrongFlag == "ThreeWrongAttempt") {
                preRegistrationSelectionVm.yfeiRegistration();
            }
            navigator.splashscreen.hide();
        });

        $scope.$on('$ionicView.leave', function () {
            yfeiUPIService.threeAttemptWrongFlag = "";
        });

        return this;
    }
]);
