'use strict';

angularApp.controller('reqMoneyWithoutUPIController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$ionicPopup",
    "$filter",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        $ionicPopup,
        $filter) {

        var reqMoneyWithoutUPIVm = this;


        $scope.$on('$ionicView.beforeEnter', function () {

            reqMoneyWithoutUPIVm.getAccountDetails();
            reqMoneyWithoutUPIVm.popupFlag = false;

        });

        $scope.$on('$ionicView.leave', function () {
            yfeiUPIService.accDetails = "";
        });

        reqMoneyWithoutUPIVm.getAccountDetails = function () {
            reqMoneyWithoutUPIVm.virtualAddDetails = yfeiUPIService.payerProfileDtls;
            reqMoneyWithoutUPIVm.vpaList = reqMoneyWithoutUPIVm.virtualAddDetails.vpaAccountDetails;
            reqMoneyWithoutUPIVm.VPAName = reqMoneyWithoutUPIVm.virtualAddDetails.userInfo.name;
            for (var i = 0; i < reqMoneyWithoutUPIVm.vpaList.length; i++) {
                if (reqMoneyWithoutUPIVm.vpaList[i].defVPAStatus) {
                    reqMoneyWithoutUPIVm.selectedVpa = reqMoneyWithoutUPIVm.vpaList[i];
                    for (var j = 0; j < reqMoneyWithoutUPIVm.vpaList[i].accountInfo.length; j++) {
                        if (reqMoneyWithoutUPIVm.vpaList[i].accountInfo[j].preferredFlag == 'T') {
                            if (yfeiUPIService.accDetails && yfeiUPIService.accDetails != null) {
                                reqMoneyWithoutUPIVm.accountDtl = yfeiUPIService.accDetails;
                                reqMoneyWithoutUPIVm.amount = yfeiUPIService.payAmount;
                                reqMoneyWithoutUPIVm.addNotes = yfeiUPIService.payNotes;
                            } else {
                                reqMoneyWithoutUPIVm.accountDtl = reqMoneyWithoutUPIVm.vpaList[i].accountInfo[j];
                            }
                        }
                    }
                    reqMoneyWithoutUPIVm.primaryVPAName = reqMoneyWithoutUPIVm.selectedVpa.virtualAddress;
                }
            }
            if (yfeiUPIService.addBankFlag == "addBankGenQRCodeTime") {
                reqMoneyWithoutUPIVm.amount = yfeiUPIService.payAmount;
                reqMoneyWithoutUPIVm.addNotes = yfeiUPIService.payNotes;
            }
        }

        reqMoneyWithoutUPIVm.changeAccount = function () {
            reqMoneyWithoutUPIVm.popupFlag = true;
            reqMoneyWithoutUPIVm.selectBank = reqMoneyWithoutUPIVm.accountDtl.accId;
            reqMoneyWithoutUPIVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth100 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark pop-align-end',
                templateUrl: "pages/YFEI/requestMoney/accntListPopup.html",
                scope: $scope
            });
        }

        reqMoneyWithoutUPIVm.closeAccountList = function () {
            reqMoneyWithoutUPIVm.popupFlag = false;
            reqMoneyWithoutUPIVm.myPopup.close();
        }

        reqMoneyWithoutUPIVm.selectedBankAccount = function (account) {
            reqMoneyWithoutUPIVm.accountDtl = account;
            reqMoneyWithoutUPIVm.selectBank = account.accId;
        }


        reqMoneyWithoutUPIVm.validateFormFields = function () {
            if (!reqMoneyWithoutUPIVm.amount || reqMoneyWithoutUPIVm.amount < 1 || reqMoneyWithoutUPIVm.amount > 100000) {
                yfeiUPIService.showUpiAlert("alert", "Please Enter Valid Amount Between ₹1 - ₹1,00,000");
                return false;
            }
            if (!reqMoneyWithoutUPIVm.primaryVPAName) {
                yfeiUPIService.showUpiAlert("alert", "Please Select UPI ID from which you want to make a payment");
                return false;
            }
            if (!reqMoneyWithoutUPIVm.accountDtl.accId) {
                yfeiUPIService.showUpiAlert("alert", "Please Select an account number from which you want to make a payment");
                return false;
            }

            return true;
        }


        reqMoneyWithoutUPIVm.generateQR = function () {
            yfeiUPIService.addBankFlag = "";
            if (reqMoneyWithoutUPIVm.popupFlag) {
                reqMoneyWithoutUPIVm.myPopup.close();
                reqMoneyWithoutUPIVm.popupFlag = false;
            }
            if (reqMoneyWithoutUPIVm.validateFormFields()) {
                yfeiUPIService.dashTransactionSelection = "Request Money";
                yfeiUPIService.createQr = {
                    virtualAddress: reqMoneyWithoutUPIVm.primaryVPAName,
                    vpaName: reqMoneyWithoutUPIVm.VPAName,
                    amount: reqMoneyWithoutUPIVm.amount,
                    note: reqMoneyWithoutUPIVm.addNotes
                }
                $state.go("menu.createQRCode");
            }

        }



        reqMoneyWithoutUPIVm.addNewBank = function () {
            reqMoneyWithoutUPIVm.myPopup.close();
            yfeiUPIService.vpaForSetPin = reqMoneyWithoutUPIVm.primaryVPAName;
            yfeiUPIService.payAmount = reqMoneyWithoutUPIVm.amount;
            yfeiUPIService.payNotes = reqMoneyWithoutUPIVm.addNotes;
            yfeiUPIService.addBankFlag = "addBankGenQRCodeTime";
            $state.go('menu.addBankList');
        };

        reqMoneyWithoutUPIVm.goBack = function () {
            yfeiUPIService.addBankFlag = "";
            $state.go("menu.dashboard");
        }
        return this;
    }



]);
