'use strict';

angularApp.controller('scanAndPayController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "$ionicPopup",
    "$filter",
    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        $ionicPopup,
        $filter) {

        var scanPayVm = this;

        scanPayVm.getProfileCall = { "app_config": { "config_transaction_limit": 2000, "max_vpa_creation_limit": 3 }, "config_transaction_limit": 0, "notificationCount": 0, "requestInfo": { "pspId": 0, "pspRefNo": "SBIEVGK92A8TX7J74E5B8XP48YJ1FW" }, "status": "S", "statusDesc": "Request Success", "userInfo": { "altMobNo": "91343434434", "defVPAStatus": false, "isMerchant": false, "mobileNo": "917506001624", "name": "Rupesh Naikade", "regDate": "08-02-2023", "secretDetails": { "quesId": 100, "quesName": "What was your childhood nickname?" }, "showMerchant": true }, "vpaAccountDetails": [{ "accountInfo": [{ "accId": 113748324, "maskedAccountNumber": "XXXXXX3442", "aepsFlag": "N", "atmFType": "NUM", "atmLength": 4, "bankCode": "HDFC", "bankId": 110, "bankName": "HDFC BANK LTD", "checkedAccount": false, "formatType": "FORMAT2", "ifscCode": "HDFC0000967", "otpLength": 0, "preferredFlag": "T", "refUrl": "https://www.sbi.co.in", "uPinFType": "NUM", "mpinFlag": "Y", "uPinLength": 4 }, { "accId": 113510209, "maskedAccountNumber": "XXXXXX1234", "aepsFlag": "N", "atmLength": 0, "bankCode": "SBIN", "bankId": 1, "bankName": "STATE BANK OF INDIA", "checkedAccount": false, "formatType": "FORMAT1", "ifscCode": "SBIN3434", "otpFType": "NUM", "otpLength": 6, "preferredFlag": "F", "refUrl": "https://www.sbi.co.in", "uPinFType": "NUM", "mpinFlag": "Y", "uPinLength": 6 }], "defVPAStatus": true, "isVerified": false, "is_merchant_vpa": "N", "spamRefNo": 0, "virtualAddress": "aerer@sbi" }, { "accountInfo": [{ "accId": 175068150, "maskedAccountNumber": "XXXXXX1234", "aepsFlag": "N", "atmLength": 0, "bankCode": "SBIN", "bankId": 1, "bankName": "STATE BANK OF INDIA", "checkedAccount": false, "formatType": "FORMAT1", "ifscCode": "SBIN0011710", "otpLength": 0, "preferredFlag": "T", "refUrl": "https://www.sbi.co.in", "uPinFType": "NUM", "mpinFlag": "Y", "uPinLength": 6 }], "defVPAStatus": false, "isVerified": false, "is_merchant_vpa": "N", "spamRefNo": 0, "virtualAddress": "535353@sbi" }] };


        $scope.$on('$ionicView.beforeEnter', function () {
            scanPayVm.payeeDetails = yfeiUPIService.payeeDetails;
            scanPayVm.pageName = scanPayVm.payeeDetails.pageName;
            scanPayVm.payName = yfeiUPIService.payeeDetails.name;
            scanPayVm.payVpa = yfeiUPIService.payeeDetails.vpa;
            scanPayVm.mapperResponse = yfeiUPIService.mapperResponse;
            scanPayVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
            scanPayVm.popupFlag = false;
            scanPayVm.paymentFlag = true;
            if (scanPayVm.payeeDetails.amount && scanPayVm.payeeDetails.amount != null && scanPayVm.payeeDetails.amount != undefined) {
                scanPayVm.amount = scanPayVm.payeeDetails.amount;
            }
            if (scanPayVm.payeeDetails.remark && scanPayVm.payeeDetails.remark != null && scanPayVm.payeeDetails.remark != undefined) {
                scanPayVm.addNotes = scanPayVm.payeeDetails.remark;
            }
            scanPayVm.getAccountDetails();
        });

        $scope.$on('$ionicView.leave', function () {
            yfeiUPIService.accDetails = "";
        });

        scanPayVm.getAccountDetails = function () {
            scanPayVm.virtualAddDetails = yfeiUPIService.payerProfileDtls;
            scanPayVm.vpaList = scanPayVm.virtualAddDetails.vpaAccountDetails;
            scanPayVm.VPAName = localStorage.getItem("customerName");
            for (var i = 0; i < scanPayVm.vpaList.length; i++) {
                if (scanPayVm.vpaList[i].defVPAStatus) {
                    scanPayVm.selectedVpa = scanPayVm.vpaList[i];
                    for (var j = 0; j < scanPayVm.vpaList[i].accountInfo.length; j++) {
                        if (scanPayVm.vpaList[i].accountInfo[j].preferredFlag == 'T') {
                            if (yfeiUPIService.accDetails && yfeiUPIService.accDetails != null) {
                                scanPayVm.accountDtl = yfeiUPIService.accDetails;
                                scanPayVm.amount = yfeiUPIService.payAmount;
                                scanPayVm.addNotes = yfeiUPIService.payNotes;
                            } else {
                                scanPayVm.accountDtl = scanPayVm.vpaList[i].accountInfo[j];
                            }
                        }
                    }
                    scanPayVm.primaryVPAName = scanPayVm.selectedVpa.virtualAddress;
                }
            }

            if (yfeiUPIService.addBankFlag == "addBankPaymentTime") {
                scanPayVm.amount = yfeiUPIService.payAmount;
                scanPayVm.addNotes = yfeiUPIService.payNotes;
            }

        }

        scanPayVm.changeAccount = function () {
            scanPayVm.popupFlag = true;
            scanPayVm.selectBank = scanPayVm.accountDtl.accId;
            scanPayVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth100 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark pop-align-end',
                templateUrl: "pages/YFEI/scanAndPay/accountListPopup.html",
                scope: $scope
            });
        }

        scanPayVm.closeAccountList = function () {
            scanPayVm.popupFlag = false;
            scanPayVm.myPopup.close();
        }

        scanPayVm.selectedBankAccount = function (account) {
            scanPayVm.accountDtl = account;
            scanPayVm.selectBank = account.accId;
        }

        scanPayVm.validateFormFields = function () {
            if (!scanPayVm.amount || scanPayVm.amount < 1 || scanPayVm.amount > 100000) {
                yfeiUPIService.showUpiAlert("alert", "Please Enter Valid Amount Between ₹1 - ₹1,00,000");
                return false;
            }
            if (!scanPayVm.primaryVPAName) {
                yfeiUPIService.showUpiAlert("alert", "Please Select UPI ID from which you want to make a payment");
                return false;
            }
            if (!scanPayVm.accountDtl.accId) {
                yfeiUPIService.showUpiAlert("alert", "Please Select an account number from which you want to make a payment");
                return false;
            }
            if (scanPayVm.accountDtl.mpinFlag == 'N') {
                yfeiUPIService.showUpiAlert("alert", "Please set your UPI PIN for further transaction");
                return false;
            }

            return true;
        }

        scanPayVm.approvePaymentRequest = function () {
            utilityService.showSpinner();
            if (yfeiUPIService.collectRequestsList && (!yfeiUPIService.collectRequests.txnId || !yfeiUPIService.collectRequests.upiTrnRefNo)) {
                for (var i = 0; i < yfeiUPIService.collectRequestsList.length; i++) {
                    if (yfeiUPIService.collectRequestsList[i].custRefNo == yfeiUPIService.collectRequests.custRefNo && yfeiUPIService.collectRequestsList[i].txnAmount == yfeiUPIService.collectRequests.txnAmount) {
                        yfeiUPIService.collectRequests.txnId = yfeiUPIService.collectRequestsList[i].txnId
                        yfeiUPIService.collectRequests.upiTrnRefNo = yfeiUPIService.collectRequestsList[i].upiTrnRefNo
                    }
                }

            }
            var json = {};
            json = {
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "approvalStatus": "A",
                "expiryTime": 0,
                "npciTranId": yfeiUPIService.collectRequests.txnId,
                "payerType": {
                    "accountId": scanPayVm.accountDtl.accId,
                    "virtualAddress": yfeiUPIService.collectRequests.payerVa
                },
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "upiTransRefNo": yfeiUPIService.collectRequests.upiTrnRefNo
            };
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onCollectApprove, JSON.stringify(json)).then(function (data) {
                utilityService.hideSpinner();
                scanPayVm.paymentResponse = data;
                scanPayVm.displayPaymentResp(scanPayVm.paymentResponse);
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showBhimUpiAlert("error", msg);
            });
        }

        scanPayVm.payPayment = function () {
            if (scanPayVm.popupFlag) {
                scanPayVm.myPopup.close();
                scanPayVm.popupFlag = false;
            }
            if (scanPayVm.validateFormFields()) {
                var json = {};
                if (scanPayVm.payeeDetails.payType == 'paymentRequest') {
                    scanPayVm.approvePaymentRequest()
                } else if (scanPayVm.payeeDetails.payeeType == 'QR' || scanPayVm.payeeDetails.payeeType == 'VPA' || scanPayVm.payeeDetails.payeeType == 'AC') {
                    if (scanPayVm.payeeDetails.payeeType == 'AC') {
                        var payee = {
                            "accountNo": scanPayVm.payeeDetails.accountNo,
                            "ifsc": scanPayVm.payeeDetails.ifsc,
                            "name": scanPayVm.payName,
                            "vpaType": "AC"
                        }
                    } else {
                        var payee = {
                            "name": scanPayVm.payName,
                            "virtualAddress": scanPayVm.payVpa,
                            "vpaType": scanPayVm.payeeDetails.payeeType
                        }
                    }

                    json = {
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "amount": scanPayVm.amount,
                        "expiryTime": 0,
                        "payeeType": payee,
                        "payerType": {
                            "accountId": scanPayVm.accountDtl.accId,
                            "virtualAddress": scanPayVm.primaryVPAName
                        },
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "transactionNote": scanPayVm.addNotes || "",
                        "upiTransRefNo": 0
                    };


                    json = JSON.stringify(json);
                    if (yfeiUPIService.isBiometricLogin) {
                        yfeiUPIService.getNativeData(constantConfig.upiConstant.onPayInitiation, json, "YSP").then(function (data) {
                            scanPayVm.paymentResponse = data;
                            scanPayVm.displayPaymentResp(scanPayVm.paymentResponse);
                        }, function (msg) {
                            if (msg != -101)
                                yfeiUPIService.showUpiAlert("error", msg);
                        });
                    } else {
                        scanPayVm.paymentFlag = false;
                        yfeiUPIService.getNativeData(constantConfig.upiConstant.onPayInitiation, json).then(function (data) {
                            scanPayVm.paymentResponse = data;
                            scanPayVm.displayPaymentResp(scanPayVm.paymentResponse);
                        }, function (msg) {
                            scanPayVm.paymentFlag = true;
                            if (msg != -101)
                                yfeiUPIService.showUpiAlert("error", msg);
                        });

                    }
                }

                if (scanPayVm.payeeDetails.payeeType == 'MAPPER') {
                    json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "accountInfo": {
                            "accountBalance": "",
                            "accountName": "",
                            "accId": scanPayVm.accountDtl.accId,
                            "maskedAccountNumber": scanPayVm.accountDtl.maskedAccountNumber,
                            "aepsFlag": "",
                            "atmFType": "",
                            "atmLength": scanPayVm.accountDtl.atmLength,
                            "bankCode": scanPayVm.accountDtl.bankCode,
                            "bankId": scanPayVm.accountDtl.bankId,
                            "bankName": scanPayVm.accountDtl.bankName,
                            "checkedAccount": scanPayVm.accountDtl.checkedAccount ? scanPayVm.accountDtl.checkedAccount : "",
                            "formatType": scanPayVm.accountDtl.formatType,
                            "ifscCode": scanPayVm.accountDtl.ifscCode,
                            "iin": "",
                            "otpFType": "",
                            "otpLength": scanPayVm.accountDtl.otpLength,
                            "preferredFlag": "",
                            "refUrl": "",
                            "uPinFType": scanPayVm.accountDtl.uPinFType,
                            "mpinFlag": scanPayVm.accountDtl.mpinFlag,
                            "uPinLength": scanPayVm.accountDtl.uPinLength,
                            "mobileNo": $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo ? $rootScope.yfeiCheckDeviceInfo.deviceInfo.mobileNo.toString() : ""
                        },
                        "amount": Number(scanPayVm.amount).toFixed(2),
                        "cmId": scanPayVm.payeeDetails.cmid,
                        "expiryTime": 0,
                        "initMode": "00",
                        "npciTranId": generateRandomString(30),
                        "payeeType": {
                            "name": scanPayVm.payName,
                            "virtualAddress": scanPayVm.payVpa,
                            "vpaType": 'VA'
                        },
                        "payerType": {
                            "accountId": scanPayVm.accountDtl.accId,
                            "virtualAddress": scanPayVm.primaryVPAName
                        },
                        "ref_id": generateRandomString(30),
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "tid": generateRandomString(30),
                        "transactionNote": scanPayVm.addNotes || "",
                        "upiTransRefNo": 0
                    });
                    scanPayVm.UPIMapper(json);
                }
            }
        }

        scanPayVm.requestPaymentFromChangeAccount = function () {
            scanPayVm.requestPayment();
            scanPayVm.closeAccountList();
        }

        scanPayVm.requestPayment = function () {

            if (scanPayVm.validateFormFields()) {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "addInfo": {
                        "addInfo10": constantConfig.upiConstant.addInfo10,
                        "addInfo9": constantConfig.upiConstant.addInfo9
                    },
                    "requestInfo": {
                        "pspId": constantConfig.upiConstant.pspId,
                        "pspRefNo": generateRandomString(27)
                    },
                    "amount": scanPayVm.amount,
                    "expiryTime": 30,
                    "payeeType": {
                        "accountId": scanPayVm.accountDtl.accId,
                        "virtualAddress": scanPayVm.primaryVPAName,
                        "vpaType": "VA"
                    },
                    "payerType": {
                        "name": scanPayVm.payName,
                        "virtualAddress": scanPayVm.payVpa
                    },
                    "transactionNote": scanPayVm.addNotes || "",
                    "upiTransRefNo": 0
                });
                yfeiUPIService.getNativeData(constantConfig.upiConstant.onCollectInitiation, json).then(function (data) {
                    var collectResponse = JSON.parse(data).apiResp;
                    utilityService.hideSpinner();
                    if (collectResponse.status == 'S') {
                        yfeiUPIService.qrCodeSuccessPay = {
                            payTo: scanPayVm.VPAName,
                            payToVpa: scanPayVm.primaryVPAName,
                            payFrom: scanPayVm.payName,
                            payFromVpa: scanPayVm.payVpa,
                            payAmount: scanPayVm.amount,
                            payNotes: scanPayVm.addNotes,
                            payTime: collectResponse.txnAuthDate,
                            payFromBank: scanPayVm.accountDtl.bankName,
                            payFromAccount: scanPayVm.accountDtl.maskedAccountNumber,
                            payFromBankCode: scanPayVm.accountDtl.bankCode,
                            payRefNum: collectResponse.custRefNo,
                            status: collectResponse.status
                        }
                        $state.go('menu.scanAndPaySuccess');
                    } else {
                        yfeiUPIService.showUpiAlert("error", collectResponse.responseMsg || collectResponse.statusDesc);
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    yfeiUPIService.showUpiAlert("error", msg);
                });
            }
        }


        scanPayVm.UPIMapper = function (json) {
            scanPayVm.paymentFlag = false;
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getUpiFundTransfer, json).then(function (data) {
                if (data == "null") {
                    scanPayVm.paymentFlag = true;
                } else {
                    scanPayVm.paymentResponse = data;
                    scanPayVm.displayPaymentResp(scanPayVm.paymentResponse);
                }
            }, function (msg) {
                scanPayVm.paymentFlag = true;
                if (msg != -101)
                    yfeiUPIService.showUpiAlert("error", msg);
            });
        }


        scanPayVm.displayPaymentResp = function (data) {
            yfeiUPIService.addBankFlag = "";
            if (JSON.parse(data).apiResp.status == 'S') {
                yfeiUPIService.qrCodeSuccessPay = {
                    payTo: scanPayVm.payName,
                    payToVpa: scanPayVm.payVpa,
                    payFrom: scanPayVm.VPAName,
                    payFromVpa: scanPayVm.primaryVPAName,
                    payAmount: scanPayVm.amount,
                    payNotes: scanPayVm.addNotes,
                    payTime: JSON.parse(data).apiResp.txnAuthDate,
                    payFromBank: scanPayVm.accountDtl.bankName,
                    payFromAccount: scanPayVm.accountDtl.maskedAccountNumber,
                    payFromBankCode: scanPayVm.accountDtl.bankCode,
                    payRefNum: JSON.parse(data).apiResp.custRefNo,
                    status: JSON.parse(data).apiResp.status,
                    payToBank: scanPayVm.payeeDetails.bank,
                    payToAccount: scanPayVm.payeeDetails.accountNo,
                    payType: scanPayVm.payeeDetails.payType
                }
                $state.go('menu.scanAndPaySuccess');
            } else {

                if (JSON.parse(data).apiResp.status == 'F') {
                    yfeiUPIService.qrCodeSuccessPay = {
                        payTo: scanPayVm.payName,
                        payToVpa: scanPayVm.payVpa,
                        payFrom: scanPayVm.VPAName,
                        payFromVpa: scanPayVm.primaryVPAName,
                        payAmount: scanPayVm.amount,
                        payNotes: scanPayVm.addNotes,
                        payTime: JSON.parse(data).apiResp.txnAuthDate,
                        payFromBank: scanPayVm.accountDtl.bankName,
                        payFromAccount: scanPayVm.accountDtl.maskedAccountNumber,
                        payFromBankCode: scanPayVm.accountDtl.bankCode,
                        payRefNum: JSON.parse(data).apiResp.custRefNo,
                        status: JSON.parse(data).apiResp.status,
                        failedReason: JSON.parse(data).apiResp.responseMsg,
                        payToBank: scanPayVm.payeeDetails.bank,
                        payToAccount: scanPayVm.payeeDetails.accountNo,
                        payType: scanPayVm.payeeDetails.payType
                    }
                    $state.go('menu.scanAndPaySuccess');
                } else if (JSON.parse(data).apiResp.status == 'V' && scanPayVm.payeeDetails.payeeType == 'AC') {
                    yfeiUPIService.showUpiAlert("error", JSON.parse(data).apiResp.responseMsg, 'menu.payToBank');
                } else {
                    if (JSON.parse(data).apiResp.responseMsg) {
                        yfeiUPIService.showUpiAlert("error", JSON.parse(data).apiResp.responseMsg, "menu.dashboard");
                    } else {
                        yfeiUPIService.showUpiAlert("error", JSON.parse(data).apiResp.statusDesc, "menu.dashboard");
                    }
                }
            }
        };

        scanPayVm.addNewBank = function () {
            scanPayVm.myPopup.close();
            yfeiUPIService.vpaForSetPin = scanPayVm.primaryVPAName;
            yfeiUPIService.payAmount = scanPayVm.amount;
            yfeiUPIService.payNotes = scanPayVm.addNotes;
            yfeiUPIService.addBankFlag = "addBankPaymentTime";

            $state.go('menu.addBankList');
        };



        scanPayVm.goBack = function () {
            yfeiUPIService.addBankFlag = "";
            if (!scanPayVm.paymentFlag) {
                return;
            }

            if (yfeiUPIService.dashTransactionSelection == "Frequently Paid" && (scanPayVm.pageName == "Pay via UPI ID" || scanPayVm.pageName == "Pay to Bank Account")) {
                $state.go("menu.dashboard");
            }
            else if (scanPayVm.pageName == "Pay via UPI ID") {
                yfeiUPIService.dashTransactionSelection = "Pay via UPI ID";
                $state.go('menu.payUpi');
            }
            else if (scanPayVm.pageName == "Request Money") {
                yfeiUPIService.dashTransactionSelection = "Request Money";
                $state.go('menu.payUpi');
            }
            else if (scanPayVm.pageName == "Scan and Pay") {
                $state.go("menu.dashboard");
            } else if (scanPayVm.pageName == "Pay To Contact") {
                yfeiUPIService.dashTransactionSelection = "Pay To Contact";
                $state.go('menu.payToContact');
            } else if (scanPayVm.pageName == "Payment Request") {
                $state.go('menu.paymentRequestForm');
            } else if (scanPayVm.pageName == "Pay to Bank Account") {
                $state.go('menu.payToBank');
            } else {
                $state.go("menu.dashboard");
            }
        }
        return this;
    }
]);
