'use strict';

angularApp.controller('scanAndPaySuccessController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope
    ) {

        var scanPaySuccessVm = this;



        $scope.$on('$ionicView.beforeEnter', function () {
            scanPaySuccessVm.successResponse = yfeiUPIService.qrCodeSuccessPay;
            scanPaySuccessVm.payeeDetails = yfeiUPIService.payeeDetails;
            scanPaySuccessVm.pageName = scanPaySuccessVm.payeeDetails.pageName;
            scanPaySuccessVm.paymentStatus = yfeiUPIService.qrCodeSuccessPay.status;
            scanPaySuccessVm.dashboardSelItem = yfeiUPIService.dashTransactionSelection;
            yfeiUPIService.transactionHistory = "";
            if (scanPaySuccessVm.paymentStatus == 'S' && scanPaySuccessVm.dashboardSelItem != "Request Money") {
                scanPaySuccessVm.playAudio();
            }
        });

        scanPaySuccessVm.goBack = function () {
            $state.go("menu.dashboard");
        }

        scanPaySuccessVm.goToHome = function () {
            $state.go("menu.dashboard");
        }

        scanPaySuccessVm.share = function () {
            html2canvas(document.getElementById("sharediv"), {
                onrendered: function (canvas) {
                    var filename = "";
                    var img = canvas.toDataURL("image/png");
                    var myBaseString = img;
                    var block = myBaseString.split(";");
                    var myBase64 = block[1].split(",")[1];
                    var contentType = "image/png";

                    if (scanPaySuccessVm.dashboardSelItem != "Request Money") {
                        filename = "Payment Receipt" + scanPaySuccessVm.successResponse.payTo + ".png";
                    } else {
                        filename = "Request Receipt" + scanPaySuccessVm.successResponse.payTo + ".png";
                    }

                    if (utilityService.isAndroidPlatform()) {
                        var imgTimestamp = new Date().getTime();
                        filename = "Payment Receipt_" + filename + imgTimestamp + ".png";
                    }

                    if (device.platform.toLowerCase() == 'ios') {
                        var successCallback = function (data) {
                            console.log("Success");
                        }
                        var failureCallback = function (error) {
                            console.log("failure");
                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    } else {
                        scanPaySuccessVm.savebase64AsImageFile(filename, myBase64, contentType);
                    }
                }
            });
        }

        scanPaySuccessVm.savebase64AsImageFile = function (filename, content, contentType) {
            scanPaySuccessVm.popupFolderpath = "";
            var DataBlob = scanPaySuccessVm.b64toBlob(content, contentType);
            if (device.version == 10) {
                var folderpath = cordova.file.externalDataDirectory;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    scanPaySuccessVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            scanPaySuccessVm.downloadOrShare();
                        }, function () {
                            yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            } else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        scanPaySuccessVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                scanPaySuccessVm.downloadOrShare();
                            }, function () {
                                yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                });
            }
        }

        scanPaySuccessVm.downloadOrShare = function () {
            var options = {};
            if (scanPaySuccessVm.dashboardSelItem != "Request Money") {
                options = {
                    message: 'Payment receipt via YONO SBI - ', // not supported on some apps (i.e. Facebook, Instagram)
                    subject: 'Share Your Payment receipt : ',// Subject. for email
                    files: [scanPaySuccessVm.popupFolderpath], // an array of filenames either locally or remotely
                    chooserTitle: 'Share Your Payment receipt' // Android only, you can override the default share sheet title
                };
            }
            else {
                options = {
                    message: 'Request receipt - ', // not supported on some apps (i.e. Facebook, Instagram)
                    subject: 'Share Your Request receipt : ',// Subject. for email
                    files: [scanPaySuccessVm.popupFolderpath], // an array of filenames either locally or remotely
                    chooserTitle: 'Share Your Request receipt' // Android only, you can override the default share sheet title
                };
            }


            var onSuccess = function (result) {
                console.log(result);
            };
            var onError = function (msg) {
                console.log(msg);
            }
            window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
        }

        scanPaySuccessVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });
        };

        scanPaySuccessVm.raiseComplaint = function () {
            yfeiUPIService.raiseComplaint = "raiseComplaint";
            scanPaySuccessVm.getTransactionHistoryList();
        }

        scanPaySuccessVm.getTransactionHistoryList = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                }
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getTransactionHistoryList, json).then(function (data) {
                var transHistory = JSON.parse(data);
                utilityService.hideSpinner();
                if (transHistory.status == 'S') {
                    yfeiUPIService.transactionHistory = transHistory.transDetails;

                    var paymentDetails = transHistory.transDetails.filter(function (el) {
                        return el.custRefNo == scanPaySuccessVm.successResponse.payRefNum;
                    });

                    yfeiUPIService.transactionDtls = paymentDetails[0];
                    yfeiUPIService.raiseComplaint = "successRaiseAndComplaint";
                    $state.go("menu.complaintType");
                } else {
                    yfeiUPIService.showUpiAlert("error", transHistory.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        scanPaySuccessVm.playAudio = function () {
            if (scanPaySuccessVm.audio) {
                scanPaySuccessVm.stopAudio();
            }

            scanPaySuccessVm.audio = new Audio("audio/yfei/paymentSuccess.mp3");
            scanPaySuccessVm.audio.play();
            if (scanPaySuccessVm.muted)
                scanPaySuccessVm.audio.muted = true;
        }

        scanPaySuccessVm.stopAudio = function () {
            scanPaySuccessVm.audio.src = "";
        }
        return this;
    }
]);
