'use strict';

angularApp.controller('raiseComplaintTypeController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope) {

        var complaintTypeVM = this;


        complaintTypeVM.colorCode = ["#339E42", "#039BE5", "#EF6C00", "#A1887F", "#607D8B", "#039BE5", "#009688"];

        $scope.$on('$ionicView.beforeEnter', function () {
            complaintTypeVM.transDetails = yfeiUPIService.transactionDtls;
            complaintTypeVM.getComplaintType(complaintTypeVM.transDetails.payType);
            complaintTypeVM.raiseComplaints = true;
            complaintTypeVM.raiseComplaintsSuccess = false;
            complaintTypeVM.showComplaintType = true;
        });
        complaintTypeVM.complaintDetails = function (comDetails) {
            complaintTypeVM.showComplaintType = false;
            complaintTypeVM.reasonCode = comDetails.reasonCode;
            complaintTypeVM.reasonDesc = comDetails.reasonDesc;
        }
        complaintTypeVM.goBack = function () {
            if (complaintTypeVM.raiseComplaintsSuccess) {
                complaintTypeVM.raiseComplaints = true;
                complaintTypeVM.showComplaintType = false;
                $state.go('menu.dashboard');
            }
            else if (complaintTypeVM.raiseComplaints && !complaintTypeVM.showComplaintType) {
                complaintTypeVM.raiseComplaintsSuccess = false;
                complaintTypeVM.showComplaintType = true;
                complaintTypeVM.remark = "";
            } else if (yfeiUPIService.raiseComplaint == "successRaiseAndComplaint") {
                yfeiUPIService.raiseComplaint = 'TransScreen';
                $state.go('menu.yfeiTransactionHistory');
            }
            else {
                $state.go("menu.transactionHistDetails");
            }


        }
        complaintTypeVM.submitComplaint = function () {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "custRefNo": complaintTypeVM.transDetails.custRefNo,
                "disputeRemark": complaintTypeVM.remark || "Raise Dispute",
                "disputeType": complaintTypeVM.reasonCode,
                "expiryTime": 0,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "upiTranRefNo": complaintTypeVM.transDetails.trnRefNo,
                "upiTransRefNo": 0
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.onRaiseDispute, json).then(function (data) {
                var raiseDisputeResp = JSON.parse(data);
                utilityService.hideSpinner();
                if (raiseDisputeResp.status == 'S') {
                    complaintTypeVM.complaintRefNo = raiseDisputeResp.ticketNo;
                    complaintTypeVM.raiseComplaints = false;
                    complaintTypeVM.raiseComplaintsSuccess = true;

                } else {
                    yfeiUPIService.showUpiAlert("error", raiseDisputeResp.statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }


        complaintTypeVM.goToDashboard = function () {
            $state.go('menu.dashboard');
        }

        complaintTypeVM.helpSupport = function () {
            $state.go('menu.helpSupport');
        }


        complaintTypeVM.getComplaintType = function (payType) {
            utilityService.showSpinner();
            var json = JSON.stringify({
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "payType": payType
            });
            yfeiUPIService.getNativeData(constantConfig.upiConstant.getDisputeTypeList, json).then(function (data) {
                utilityService.hideSpinner();
                if (JSON.parse(data).status == 'S') {
                    complaintTypeVM.disputeTypes = JSON.parse(data).disputeList;

                } else {
                    yfeiUPIService.showUpiAlert("error", JSON.parse(data).statusDesc);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                yfeiUPIService.showUpiAlert("error", msg);
            });
        }

        return this;
    }



]);
