'use strict';

angularApp.controller('transactionHistDetailsController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope
    ) {

        var transDtlsVm = this;


        transDtlsVm.colorCode = ["#339E42", "#039BE5", "#EF6C00", "#A1887F", "#607D8B", "#039BE5", "#009688"];

        $scope.$on('$ionicView.loaded', function () {
            var maskedAccountNo = "";
            transDtlsVm.transDetails = yfeiUPIService.transactionDtls;
            transDtlsVm.raiseComplaint = yfeiUPIService.raiseComplaint;

            if(transDtlsVm.transDetails.txnStatus == "PENDING" && !transDtlsVm.transDetails.payerName){
                if(localStorage.getItem("customerName")) {
                    transDtlsVm.transDetails.payerName = localStorage.getItem("customerName");
                } else {
                    transDtlsVm.transDetails.payerName = "";
                }
            }

            if(transDtlsVm.transDetails.txnType == "PAY"){
                transDtlsVm.showBankLogo = transDtlsVm.transDetails.payerBankCode
                transDtlsVm.showAccountNo = transDtlsVm.transDetails.payerAccountNo
                maskedAccountNo = transDtlsVm.transDetails.payerAccountNo
            } else if(transDtlsVm.transDetails.txnType == "CREDIT"){
                transDtlsVm.showBankLogo = transDtlsVm.transDetails.payeeBankCode
                transDtlsVm.showAccountNo = transDtlsVm.transDetails.payeeAccountNo
                maskedAccountNo = transDtlsVm.transDetails.payeeMaskAccountNo
            } else {
                transDtlsVm.showBankLogo = ""
                transDtlsVm.showAccountNo = ""
            }

            if(transDtlsVm.showBankLogo){
                yfeiUPIService.getBankList().then(function (bankList) {
                    transDtlsVm.bankMasterList = bankList.bankMasterList
                    if(transDtlsVm.bankMasterList.length > 0){
                        for(var i=0; i < transDtlsVm.bankMasterList.length; i++){
                            if(transDtlsVm.showBankLogo == transDtlsVm.bankMasterList[i].bankCode){
                                transDtlsVm.showBankName = transDtlsVm.bankMasterList[i].bankName
                            }
                        }
                    }
                }, function (error) {
                    console.log("Error : ", error)
                });

                if(yfeiUPIService.payerProfileDtls.vpaAccountDetails){
                    for (var i = 0; i < yfeiUPIService.payerProfileDtls.vpaAccountDetails.length; i++) {
                        for (var j = 0; j < yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo.length; j++) {
                            if (yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j].maskedAccountNumber == maskedAccountNo) {
                                transDtlsVm.showAccountType = yfeiUPIService.payerProfileDtls.vpaAccountDetails[i].accountInfo[j].accountType
                                transDtlsVm.showAccountType = transDtlsVm.showAccountType ? transDtlsVm.showAccountType + " Account" : ""
                            }
                        }
                    }
                }
            }

        });

        transDtlsVm.goBack = function () {
            if (transDtlsVm.raiseComplaint == 'Pay via UPI ID' || transDtlsVm.raiseComplaint == 'Frequently Paid') {
                $state.go("menu.payUpi");
            }else if(transDtlsVm.raiseComplaint == 'Pay to Contacts'){
                $state.go("menu.payToContact");
            }else {
                $state.go("menu.yfeiTransactionHistory");
            }

        }
        transDtlsVm.raiseComplaintDetails = function () {
            $state.go("menu.yfeiTransactionHistory");
        }

        transDtlsVm.raiseComplaintType = function () {
            $state.go("menu.complaintType");
        }

        transDtlsVm.goToHome = function () {
            $state.go("menu.dashboard");
        }

        transDtlsVm.share = function () {
            html2canvas(document.getElementById("sharediv"), {
                onrendered: function (canvas) {
                    var filename = "";
                    var img = canvas.toDataURL("image/png");
                    var myBaseString = img;
                    var block = myBaseString.split(";");
                    var myBase64 = block[1].split(",")[1];
                    var contentType = "image/png";

                    if (utilityService.isAndroidPlatform()) {
                        var imgTimestamp = new Date().getTime();
                        filename = "Payment Receipt_" + transDtlsVm.transDetails.payeeName + imgTimestamp + ".png";
                    } else {
                        filename = "Payment Receipt" + transDtlsVm.transDetails.payeeName + ".png";
                    }

                    if (device.platform.toLowerCase() == 'ios') {
                        var successCallback = function (data) {
                            console.log("Success");
                        }
                        var failureCallback = function (error) {
                            console.log("failure");
                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    } else {
                        transDtlsVm.savebase64AsImageFile(filename, myBase64, contentType);
                    }
                }
            });
        }

        transDtlsVm.savebase64AsImageFile = function (filename, content, contentType) {
            transDtlsVm.popupFolderpath = "";
            var DataBlob = transDtlsVm.b64toBlob(content, contentType);
            var folderpath = cordova.file.externalDataDirectory;
            if (device.version == 10) {
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    transDtlsVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            transDtlsVm.downloadOrShare();
                        }, function () {
                            yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            } else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        transDtlsVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                transDtlsVm.downloadOrShare();
                            }, function () {
                                yfeiUPIService.showUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                });
            }
        }

        transDtlsVm.downloadOrShare = function () {
            var options = {
                message: 'Payment receipt via YONO SBI - ', // not supported on some apps (i.e. Facebook, Instagram)
                subject: 'Share Your Payment receipt : ',// Subject. for email
                files: [transDtlsVm.popupFolderpath], // an array of filenames either locally or remotely
                chooserTitle: 'Share Your Payment receipt' // Android only, you can override the default share sheet title
            };

            var onSuccess = function (result) {
                console.log(result);
            };
            var onError = function (msg) {
                yfeiUPIService.showUpiAlert("error", msg);
            }
            window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
        }

        transDtlsVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });
        };

        return this;
    }



]);
