'use strict';

angularApp.controller('transactionHistoryController', ["$state",
    "$scope", "yfeiUPIService", "utilityService", "constantConfig", "$rootScope", "$ionicPopup", "$filter", function ($state,
        $scope, yfeiUPIService, utilityService, constantConfig, $rootScope, $ionicPopup, $filter) {

        var transVm = this;
        var allTransactionHistory = [];
        var accountArray = [];
        var monthArray = [];
        var statusArray = [];
        var monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

        var accountFilteredArray = [];
        var monthFilteredArray = [];
        var statusFilteredArray = [];

        var accountFilteredObjectArray = [];
        var monthFilteredObjectArray = [];
        var statusFilteredObjectArray = [];

        var selectedAccountFilteredObjectArray = [];
        var selectedMonthFilteredObjectArray = [];
        var selectedStatusFilteredObjectArray = [];

        transVm.selectedAccountFilteredObjectArray = [];
        transVm.selectedMonthFilteredObjectArray = [];
        transVm.selectedStatusFilteredObjectArray = [];

        var filteredArr = [];

        $scope.selectedFromDateYFEI = "";
        $scope.selectedToDateYFEI = "";

        $scope.$on('$ionicView.beforeEnter', function () {
            $scope.dateYFEIObj = {};
            $scope.dateYFEIObj.dt = new Date();
            $scope.fromDateYFEI = {};
            $scope.toDateYFEI = {};
            transVm.colorCode = yfeiUPIService.colorCode;
            transVm.transHistory = yfeiUPIService.transactionHistory;
            transVm.raiseComplaint = yfeiUPIService.raiseComplaint;
            if (transVm.transHistory) {
                allTransactionHistory = transVm.transHistory;
            }
            transVm.onPageInit();
            transVm.getFilterPopupData();
        });

        transVm.onPageInit = function () {
            if (allTransactionHistory.length > 0) {
                for (var i = 0; i < allTransactionHistory.length; i++) {
                    if (allTransactionHistory[i].trnDate) {
                        var startDate = allTransactionHistory[i].trnDate.substring(0, 10);
                        var date = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + allTransactionHistory[i].trnDate.substring(10);
                        var newDate = new Date(date);
                        newDate = $filter('date')(newDate, 'MMMM yyyy');
                        allTransactionHistory[i]["monthYear"] = newDate;
                    }
                }
            }
        }

        transVm.getFilterPopupData = function () {
            if (allTransactionHistory.length > 0) {
                for (var i = 0; i < allTransactionHistory.length; i++) {
                    if (allTransactionHistory[i].payerAccountNo && allTransactionHistory[i].payerAccountNo != null && allTransactionHistory[i].payerAccountNo != undefined 
                    && allTransactionHistory[i].drCrFlag==='D' && allTransactionHistory[i].drCrFlag!=null && allTransactionHistory[i].drCrFlag!=undefined) {
                        var accountNo = allTransactionHistory[i].payerAccountNo;
                        accountArray.push(accountNo);
                    }
                    if (allTransactionHistory[i].trnDate && allTransactionHistory[i].trnDate != null && allTransactionHistory[i].trnDate != undefined) {
                        var startDate = allTransactionHistory[i].trnDate.substring(0, 10);
                        var date = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + allTransactionHistory[i].trnDate.substring(10);
                        var newDate = new Date(date);
                        monthArray.push(monthNames[newDate.getMonth()]);
                    }
                    if (allTransactionHistory[i].txnStatus && allTransactionHistory[i].txnStatus != null && allTransactionHistory[i].txnStatus != undefined) {
                        var trxnStatus = allTransactionHistory[i].txnStatus;
                        statusArray.push(trxnStatus);
                    }
                }
                accountFilteredArray = accountArray.filter(function (indx, pos) {
                    return accountArray.indexOf(indx) == pos;
                });

                monthFilteredArray = monthArray.filter(function (indx, pos) {
                    return monthArray.indexOf(indx) == pos;
                });

                statusFilteredArray = statusArray.filter(function (indx, pos) {
                    return statusArray.indexOf(indx) == pos;
                });

                transVm.defaultFilteredArray();
            }
        }

        transVm.defaultFilteredArray = function () {
            if (accountFilteredArray.length > 0) {
                for (var i = 0; i < accountFilteredArray.length; i++) {
                    accountFilteredObjectArray.push({
                        "accountNumber": accountFilteredArray[i].substr((accountFilteredArray[i]).length - 4),
                        "selectedAccount": false
                    });
                }
            }

            if (monthFilteredArray.length > 0) {
                for (var i = 0; i < monthFilteredArray.length; i++) {
                    monthFilteredObjectArray.push({
                        "month": monthFilteredArray[i],
                        "selectedMonth": false
                    });
                }
            }

            if (statusFilteredArray.length > 0) {
                for (var i = 0; i < statusFilteredArray.length; i++) {
                    statusFilteredObjectArray.push({
                        "status": statusFilteredArray[i],
                        "selectedStatus": false
                    });
                }
            }
        }

        transVm.showFilterPopup = function () {
            if (allTransactionHistory.length > 0) {
                $scope.accountYFEIFilteredArray = accountFilteredObjectArray;
                $scope.monthYFEIFilteredArray = monthFilteredObjectArray;
                $scope.statusYFEIFilteredArray = statusFilteredObjectArray;
                transVm.filterPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupBackgroundTransparentYFEI removePopup-head',
                    templateUrl: "pages/YFEI/transactionHistory/searchFilterPopup.html",
                    scope: $scope
                });
            } else {
                $ionicPopup.alert({
                    template: "<p style='text-align:center;font-weight:bold;font-size:16px'>No Transactions Available.</p>"
                });
            }
        }

        $scope.clearYFEITransHistoryFilter = function () {
            if (statusFilteredObjectArray.length > 0) {
                for (var i = 0; i < statusFilteredObjectArray.length; i++) {
                    statusFilteredObjectArray[i].selectedStatus = false;
                }
            }

            if (monthFilteredObjectArray.length > 0) {
                for (var i = 0; i < monthFilteredObjectArray.length; i++) {
                    monthFilteredObjectArray[i].selectedMonth = false;
                }
            }

            if (accountFilteredObjectArray.length > 0) {
                for (var i = 0; i < accountFilteredObjectArray.length; i++) {
                    accountFilteredObjectArray[i].selectedAccount = false;
                }
            }

            selectedAccountFilteredObjectArray = [];
            selectedMonthFilteredObjectArray = [];
            selectedStatusFilteredObjectArray = [];

            $scope.dateYFEIObj.dt = new Date();
            $scope.selectedFromDateYFEI = "";
            $scope.selectedToDateYFEI = "";
            transVm.transHistory = allTransactionHistory;
        }

        $scope.closeYFEITransHistoryFilter = function () {
            transVm.filterPopup.close();
        }

        $scope.applyYFEITransHistoryFilter = function () {
            if (!$scope.selectedFromDateYFEI && !$scope.selectedToDateYFEI) {
                $scope.selectedFromDateYFEI = "";
                $scope.selectedToDateYFEI = "";
            }

            transVm.checkFilterString(selectedAccountFilteredObjectArray, selectedStatusFilteredObjectArray, selectedMonthFilteredObjectArray, $scope.selectedFromDateYFEI, $scope.selectedToDateYFEI);
            transVm.filterPopup.close();
        }

        function filterTypeOf(allTransactionHistoryArray, selectedValues, paramter) {
            if (paramter == "trnDate") {
                filteredArr = allTransactionHistoryArray.filter(function (item, index) {
                    if (item.trnDate) {
                        var startDate = item.trnDate.substring(0, 10);
                        var date = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + item.trnDate.substring(10);
                        var newDate = new Date(date);
                        var monthVal = (newDate.getMonth() + 1).toString();
                        if (monthVal == ((monthNames.indexOf(selectedValues) + 1).toString())) {
                            return item.trnDate;
                        }
                    }
                });
            } else {
                filteredArr = allTransactionHistoryArray.filter(function (item, index) {
                    if (item[paramter] && selectedValues) {
                        return item[paramter].toLowerCase().includes(selectedValues.toLowerCase());
                    }
                });
            }
            return filteredArr;
        }

        transVm.checkFilterString = function (selectedAccountFilteredObjectArray, selectedStatusFilteredObjectArray, selectedMonthFilteredObjectArray, selectedFromDate, selectedToDate) {
            transVm.transHistory = [];
            transVm.selectedAccountFilteredObjectArray = selectedAccountFilteredObjectArray;
            transVm.selectedMonthFilteredObjectArray = selectedMonthFilteredObjectArray;
            transVm.selectedStatusFilteredObjectArray = selectedStatusFilteredObjectArray;

            if (selectedAccountFilteredObjectArray.length == 0 && selectedStatusFilteredObjectArray.length == 0 && selectedMonthFilteredObjectArray.length == 0 && selectedFromDate == "" && selectedToDate == "") {
                transVm.transHistory = allTransactionHistory;
            } else {
                if (selectedAccountFilteredObjectArray.length == 0) {
                    transVm.transHistory = allTransactionHistory;
                } else {
                    for (var i = 0; i < selectedAccountFilteredObjectArray.length; i++) {
                        var filteredList = filterTypeOf(allTransactionHistory, selectedAccountFilteredObjectArray[i], "payerAccountNo");
                        for (var j = 0; j < filteredList.length; j++) {
                            transVm.transHistory.push(filteredList[j]);
                        }
                    }
                }

                if (selectedStatusFilteredObjectArray.length > 0) {
                    var finalStatusFilteredObjectArray = [];
                    for (var i = 0; i < selectedStatusFilteredObjectArray.length; i++) {
                        var filteredList = filterTypeOf(transVm.transHistory, selectedStatusFilteredObjectArray[i], "txnStatus");
                        for (var j = 0; j < filteredList.length; j++) {
                            finalStatusFilteredObjectArray.push(filteredList[j]);
                        }
                    }
                    transVm.transHistory = [];
                    for (var k = 0; k < finalStatusFilteredObjectArray.length; k++) {
                        transVm.transHistory.push(finalStatusFilteredObjectArray[k]);
                    }
                }

                if (selectedMonthFilteredObjectArray.length > 0) {
                    var finalMonthFilteredObjectArray = [];
                    for (var i = 0; i < selectedMonthFilteredObjectArray.length; i++) {
                        var filteredList = filterTypeOf(transVm.transHistory, selectedMonthFilteredObjectArray[i], "trnDate");
                        for (var j = 0; j < filteredList.length; j++) {
                            finalMonthFilteredObjectArray.push(filteredList[j]);
                        }
                    }
                    transVm.transHistory = [];
                    for (var k = 0; k < finalMonthFilteredObjectArray.length; k++) {
                        transVm.transHistory.push(finalMonthFilteredObjectArray[k]);
                    }
                }

                if (selectedFromDate != "" && selectedToDate != "") {
                    transVm.transHistory = transVm.transHistory.filter(function (item, index) {
                        if (item.trnDate && selectedFromDate && selectedToDate) {
                            var startDate = item.trnDate.substring(0, 10);
                            var date = startDate.split('-')[1] + '/' + startDate.split('-')[0] + '/' + startDate.split('-')[2] + item.trnDate.substring(10);
                            var itemDate = new Date(date);
                            itemDate = new Date(itemDate.getFullYear(), itemDate.getMonth(), itemDate.getDate());
                            if ((itemDate >= (new Date(selectedFromDate))) && (itemDate <= (new Date(selectedToDate)))) {
                                return item.trnDate;
                            }
                        }
                    });
                }
            }
        }

        transVm.removeYFEITransHistoryFilterParameter = function (removeSelectedAccount, removeSelectedStatus, removeSelectedMonth, removeSelectedDateRange) {
            if (removeSelectedAccount) {
                for (var i = 0; i < selectedAccountFilteredObjectArray.length; i++) {
                    var indx = selectedAccountFilteredObjectArray.indexOf(removeSelectedAccount);
                    if (indx != -1) {
                        selectedAccountFilteredObjectArray.splice(indx, 1);
                    }
                }
                if (accountFilteredObjectArray.length > 0) {
                    for (var i = 0; i < accountFilteredObjectArray.length; i++) {
                        if (accountFilteredObjectArray[i].accountNumber == removeSelectedAccount)
                            accountFilteredObjectArray[i].selectedAccount = false;
                    }
                }
            }
            if (removeSelectedStatus) {
                for (var i = 0; i < selectedStatusFilteredObjectArray.length; i++) {
                    var indx = selectedStatusFilteredObjectArray.indexOf(removeSelectedStatus);
                    if (indx != -1) {
                        selectedStatusFilteredObjectArray.splice(indx, 1);
                    }
                }
                if (statusFilteredObjectArray.length > 0) {
                    for (var i = 0; i < statusFilteredObjectArray.length; i++) {
                        if (statusFilteredObjectArray[i].status == removeSelectedStatus)
                            statusFilteredObjectArray[i].selectedStatus = false;
                    }
                }
            }
            if (removeSelectedMonth) {
                for (var i = 0; i < selectedMonthFilteredObjectArray.length; i++) {
                    var indx = selectedMonthFilteredObjectArray.indexOf(removeSelectedMonth);
                    if (indx != -1) {
                        selectedMonthFilteredObjectArray.splice(indx, 1);
                    }
                }
                if (monthFilteredObjectArray.length > 0) {
                    for (var i = 0; i < monthFilteredObjectArray.length; i++) {
                        if (monthFilteredObjectArray[i].month == removeSelectedMonth)
                            monthFilteredObjectArray[i].selectedMonth = false;
                    }
                }
            }
            if (removeSelectedDateRange) {
                $scope.dateYFEIObj.dt = new Date();
                $scope.selectedFromDateYFEI = "";
                $scope.selectedToDateYFEI = "";
            }

            transVm.checkFilterString(selectedAccountFilteredObjectArray, selectedStatusFilteredObjectArray, selectedMonthFilteredObjectArray, $scope.selectedFromDateYFEI, $scope.selectedToDateYFEI);

            $scope.accountYFEIFilteredArray = accountFilteredObjectArray;
            $scope.monthYFEIFilteredArray = monthFilteredObjectArray;
            $scope.statusYFEIFilteredArray = statusFilteredObjectArray;
        }

        $scope.openYFEIFilterDatePicker = function (src) {
            var maxDateInPicker;
            var minDateInPicker;
            if ($scope.selectedToDateYFEI && src == "from") {
                var selectedToDate = $scope.selectedToDateYFEI;
                var selectedToDateVal = new Date(selectedToDate);
                maxDateInPicker = new Date(selectedToDateVal.getFullYear(), selectedToDateVal.getMonth(), selectedToDateVal.getDate() - 1);
                minDateInPicker = "";
            }
            if ($scope.selectedFromDateYFEI && src == "to") {
                var selectedFromDate = $scope.selectedFromDateYFEI;
                var selectedFromDateVal = new Date(selectedFromDate);
                minDateInPicker = new Date(selectedFromDateVal.getFullYear(), selectedFromDateVal.getMonth(), selectedFromDateVal.getDate() + 1);
                maxDateInPicker = "";
                $scope.dateYFEIObj.dt = minDateInPicker;
            }
            $scope.dateOptions = {
                maxDate: maxDateInPicker,
                minDate: minDateInPicker,
                formatYear: 'yy',
                startingDay: 1
            }
            var datePickerPopup = $ionicPopup.alert({
                cssClass: 'rtxc-datepicker-popup paplPANDOBConfirmBox',
                template: '<div class="datePickerBlock paplPadRight5 font-size-14">' +
                '<input type="text" datepicker="dd MMM yyyy" ng-model="dateYFEIObj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' + '</div>',
                scope: $scope,
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function (res) {
                        datePickerPopup.close();
                    }
                }, {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (res) {
                        if (src == "from") {
                            $scope.selectedFromDateYFEI = $filter('date')($scope.dateYFEIObj.dt, "dd MMM, yy");
                        } else {
                            $scope.selectedToDateYFEI = $filter('date')($scope.dateYFEIObj.dt, "dd MMM, yy");
                        }
                    }
                }],
            });
        }

        $scope.selectYFEIFilterAccount = function (val, index) {
            accountFilteredObjectArray[index].selectedAccount = !accountFilteredObjectArray[index].selectedAccount;
            if (!accountFilteredObjectArray[index].selectedAccount) {
                var indx = selectedAccountFilteredObjectArray.indexOf(val.accountNumber);
                if (indx != -1) {
                    selectedAccountFilteredObjectArray.splice(indx, 1);
                }
            } else {
                selectedAccountFilteredObjectArray.push(val.accountNumber);
            }
            $scope.accountYFEIFilteredArray = accountFilteredObjectArray;
        }

        $scope.selectYFEIFilterStatus = function (val, index) {
            statusFilteredObjectArray[index].selectedStatus = !statusFilteredObjectArray[index].selectedStatus;
            if (!statusFilteredObjectArray[index].selectedStatus) {
                var indx = selectedStatusFilteredObjectArray.indexOf(val.status);
                if (indx != -1) {
                    selectedStatusFilteredObjectArray.splice(indx, 1);
                }
            } else {
                selectedStatusFilteredObjectArray.push(val.status);
            }
            $scope.statusYFEIFilteredArray = statusFilteredObjectArray;
        }

        $scope.selectYFEIFilterMonth = function (val, index) {
            monthFilteredObjectArray[index].selectedMonth = !monthFilteredObjectArray[index].selectedMonth;
            if (!monthFilteredObjectArray[index].selectedMonth) {
                var indx = selectedMonthFilteredObjectArray.indexOf(val.month);
                if (indx != -1) {
                    selectedMonthFilteredObjectArray.splice(indx, 1);
                }
            } else {
                selectedMonthFilteredObjectArray.push(val.month);
            }
            $scope.monthYFEIFilteredArray = monthFilteredObjectArray;
        }

        transVm.goBack = function () {
            if (transVm.raiseComplaint == 'raiseComplaint') {
                $state.go("menu.helpSupport");
            } else {
                $state.go("menu.dashboard");
            }
        }

        transVm.paymentForm = function (payment) {
            yfeiUPIService.transactionDtls = payment;
            $state.go("menu.transactionHistDetails");
        }

        transVm.isNumeric = function (value) {
            return /^-?\d+$/.test(value);
        }

        transVm.checkString = function (value) {
            transVm.searchString = "";
            transVm.searchNumber = "";
            if (value === '') {
                transVm.transHistory = allTransactionHistory;
            } else {
                transVm.transHistory = allTransactionHistory.filter(function (item, index) {
                    return (item.payeeName.toLowerCase().includes(value.toLowerCase()) ||
                        item.txnAmount.toLowerCase().includes(value.toLowerCase()) ||
                        item.trnDate.toLowerCase().includes(value.toLowerCase()) ||
                        item.trnRefNo.toString().toLowerCase().includes(value.toLowerCase()));
                });
            }
        }

        return this;
    }
]);