/**
*   @ngdoc config
*   @name angularApp.config : aoConfig
*   @description
*	configuration file for account opening module
*/

'use strict';
angularApp.config(['$stateProvider',
    function ($stateProvider) {
        $stateProvider
            .state('menu.preRegistrationSelection', {
                url: '/preRegistrationSelection',
                data: {
                    pageId: 'REGISTRATION_SELECTION'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registrationSelection/preRegistrationSelection.html',
                        controller: 'preRegistrationSelectionController',
                        controllerAs: 'preRegistrationSelectionVm'
                    }
                }
            })
            .state('menu.yfeiSimSelection', {
                url: '/yfeiSimSelection',
                data: {
                    pageId: 'YFEI_SIM_SELECTION'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/simSelection.html',
                        controller: 'simSelectionController',
                        controllerAs: 'simSelectionVm'
                    }
                }
            })
            .state('menu.smsTimer', {
                url: '/smsTimer',
                data: {
                    pageId: 'YFEI_SMS_TIMER'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/smsTimer.html',
                        controller: 'smsTimerController',
                        controllerAs: 'smsTimerVm'
                    }
                }
            })
            .state('menu.bankList', {
                url: '/bankList',
                data: {
                    pageId: 'YFEI_BANK_LIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/bankList.html',
                        controller: 'bankListController',
                        controllerAs: 'bankListVm'
                    }
                }
            })
            .state('menu.setUPIPin', {
                url: '/setUPIPin',
                data: {
                    pageId: 'YFEI_SET_UPI_PIN'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/setUpiPinATMDetails.html',
                        controller: 'setUpiPinATMDetailsController',
                        controllerAs: 'setUpiPinATMDetailsVm'
                    }
                }
            })
            .state('menu.vpaRegistrationSuccess', {
                url: '/vpaRegistrationSuccess',
                data: {
                    pageId: 'YFEI_VPA_REG_SUCCESS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/vpaRegistrationSuccess.html',
                        controller: 'vpaRegistrationSuccessController',
                        controllerAs: 'vpaRegistrationSuccessVm'
                    }
                }
            })

            .state('menu.yfeiMpinConsent', {
                url: '/yfeiMpinConsent',
                data: {
                    pageId: 'YFEI_MPIN_CONSENT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/yfeiMpinConsent.html',
                        controller: 'yfeiMpinConsentController',
                        controllerAs: 'yfeiMpinConsentVm'
                    }
                }
            })
            .state('menu.SetMpin', {
                url: '/SetMpin',
                data: {
                    pageId: 'YFEI_SET_MPIN'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/SetMpin.html',
                        controller: 'SetMpinController',
                        controllerAs: 'setMPINYFVm'
                    }
                }
            })
            .state('menu.yfeiLogin', {
                url: '/yfeiLogin',
                data: {
                    pageId: 'YFEI_MPIN_LOGIN'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/login/yfeiLogin.html',
                        controller: 'yfeiLoginController',
                        controllerAs: 'yfeiLoginVM'
                    }
                }
            })
            .state('menu.dashboard', {
                url: '/dashboard',
                data: {
                    pageId: 'YFEI_DASHBOARD'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/home/dashboard.html',
                        controller: 'dashboardController',
                        controllerAs: 'dashboardVM'
                    }
                }
            })
            .state('menu.paymentRequest', {
                url: '/paymentRequest',
                data: {
                    pageId: 'YFEI_PAYMENT_REQUEST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/home/paymentRequest.html',
                        controller: 'paymentRequestController',
                        controllerAs: 'paymentReqVm'
                    }
                }
            })
            .state('menu.paymentRequestForm', {
                url: '/paymentRequestForm',
                data: {
                    pageId: 'YFEI_PAYMENT_REQUEST_FORM'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/home/paymentRequestForm.html',
                        controller: 'paymentRequestFormController',
                        controllerAs: 'paymentReqFormVm'
                    }
                }
            })

            .state('menu.yfeiWelcome', {
                url: '/yfeiWelcome',
                data: {
                    pageId: 'YFEI_WEL_REM'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/yfeiWelcome.html',
                        controller: 'yfeiWelcomeController',
                        controllerAs: 'yfeiWelcomeVm'
                    }
                }
            })

            .state('menu.biometricSetup', {
                url: '/biometricSetup',
                data: {
                    pageId: 'YFEI_BIO_SET_REM'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/biometricSetup.html',
                        controller: 'biometricSetupController',
                        controllerAs: 'biometricSetupVm'
                    }
                }
            })

            .state('menu.removeAccSuccess', {
                url: '/removeAccSuccess',
                data: {
                    pageId: 'YFEI_PRO_REM'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/removeAccountSuccess.html',
                        controller: 'removeAccountSuccessController',
                        controllerAs: 'removeAccVm'
                    }
                }
            })

            .state('menu.scanAndPay', {
                url: '/scanAndPay',
                data: {
                    pageId: 'YFEI_SCAN_PAY'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/scanAndPay/scanAndPay.html',
                        controller: 'scanAndPayController',
                        controllerAs: 'scanPayVm'
                    }
                }
            })
            .state('menu.scanAndPaySuccess', {
                url: '/scanAndPaySuccess',
                data: {
                    pageId: 'YFEI_SCAN_PAY_SUCCESS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/scanAndPay/scanAndPaySuccess.html',
                        controller: 'scanAndPaySuccessController',
                        controllerAs: 'scanPaySuccessVm'
                    }
                }
            })
            .state('menu.yfeiTransactionHistory', {
                url: '/yfeiTransactionHistory',
                data: {
                    pageId: 'YFEI_TRANS_HIS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/transactionHistory/transactionHistory.html',
                        controller: 'transactionHistoryController',
                        controllerAs: 'transVm'
                    }
                }
            })
            .state('menu.transactionHistDetails', {
                url: '/transactionHistDetails',
                data: {
                    pageId: 'YFEI_TRANS_HIS_DTLS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/transactionHistory/transactionHistDetails.html',
                        controller: 'transactionHistDetailsController',
                        controllerAs: 'transDtlsVm'
                    }
                }
            })
            .state('menu.payUpi', {
                url: '/payUpi',
                data: {
                    pageId: 'YFEI_PAY_UPI'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/payUpi/payUpi.html',
                        controller: 'payUpiController',
                        controllerAs: 'payUpiVm'
                    }
                }
            })
            .state('menu.payToContact', {
                url: '/payToContact',
                data: {
                    pageId: 'YFEI_PAY_CONTACT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/payToContact/payToContact.html',
                        controller: 'payToContactController',
                        controllerAs: 'payContactVm'
                    }
                }
            })
            .state('menu.profileLanding', {
                url: '/profileLanding',
                data: {
                    pageId: 'YFEI_PROFILE_LANDING'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/profileLanding.html',
                        controller: 'profileLandingController',
                        controllerAs: 'profileLandingVm'
                    }
                }
            })
            .state('menu.reverificationDevice', {
                url: '/reverificationDevice',
                data: {
                    pageId: 'YFEI_RE_VERIFY_DEVICE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/reVerificationDevice.html',
                        controller: 'reVerificationDeviceController',
                        controllerAs: 'reVerificationDeviceVm'
                    }
                }
            })
            .state('menu.setMpinSuccess', {
                url: '/setMpinSuccess',
                data: {
                    pageId: 'YFEI_SET_MPIN_SUCCESS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/setMpinSuccess.html',
                        controller: 'setMpinSuccessController',
                        controllerAs: 'setMpinSuccessControllerVm'
                    }
                }
            })
            .state('menu.setDeviceMpin', {
                url: '/setDeviceMpin',
                data: {
                    pageId: 'YFEI_SET_MPIN'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/setYfeiMpin.html',
                        controller: 'setYfeiMpinController',
                        controllerAs: 'setMPINYFVm'
                    }
                }
            })
            .state('menu.checkBalance', {
                url: '/checkBalance',
                data: {
                    pageId: 'YFEI_CHECK_BALANCE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/checkBalance.html',
                        controller: 'checkBalanceController',
                        controllerAs: 'checkBalanceVm'
                    }
                }
            })
            .state('menu.helpSupport', {
                url: '/helpSupport',
                data: {
                    pageId: 'YFEI_HELP_SUPPORT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/helpSupport/helpSupport.html',
                        controller: 'helpSupportController',
                        controllerAs: 'helpSupportControllerVm'
                    }
                }
            })
            .state('menu.yfeiContactUs', {

                url: '/yfeiContactUs',
                data: {
                    pageId: 'YFEI_CONTACT_US'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/helpSupport/contactUs.html',
                        controller: 'yfeiContactUsController',
                        controllerAs: 'yfeiContactUsControllerVm'
                    }
                }
            })
            .state('menu.changeLoginMpin', {
                url: '/changeLoginMpin',
                data: {
                    pageId: 'YFEI_CHANGE_LOGIN_MPIN'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/changeLoginMpin.html',
                        controller: 'changeLoginMpinController',
                        controllerAs: 'changeLoginMpinVm'
                    }
                }
            })
            .state('menu.complaintType', {
                url: '/complaintType',
                data: {
                    pageId: 'YFEI_COMPLAINT_TYPE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/transactionHistory/raiseComplaintType.html',
                        controller: 'raiseComplaintTypeController',
                        controllerAs: 'complaintTypeVM'
                    }
                }
            })
            .state('menu.previousComplaints', {
                url: '/previousComplaints',
                data: {
                    pageId: 'YFEI_PREVIOUS_COMPLAINT'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/transactionHistory/previousComplaint.html',
                        controller: 'previousComplaintsController',
                        controllerAs: 'previousComplaintsVm'
                    }
                }
            })

            .state('menu.previousComDetails', {
                url: '/previousComDetails',
                data: {
                    pageId: 'YFEI_PREVIOUS_COMPLAINT_DETAILS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/transactionHistory/previousComDetails.html',
                        controller: 'previousComDetailsController',
                        controllerAs: 'previousComplaintsDetailsVm'
                    }
                }
            })
            .state('menu.manageUPI', {
                url: '/manageUPI',
                data: {
                    pageId: 'YFEI_MANAGE_UPI'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/manageUpi/manageUpiId.html',
                        controller: 'manageUpiIdController',
                        controllerAs: 'manageUpiVM'
                    }
                }
            })
            .state('menu.creatNewUPIID', {
                url: '/creatNewUPIID',
                data: {
                    pageId: 'YFEI_CREATE_NEW_VPA'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/manageUpi/createVpaId.html',
                        controller: 'createVpaIdController',
                        controllerAs: 'createVpaVM'
                    }
                }
            })
            .state('menu.createQRCode', {
                url: '/createQRCode',
                data: {
                    pageId: 'YFEI_CREATE_QR_CODE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/home/createQRCode.html',
                        controller: 'createQRCodeController',
                        controllerAs: 'createQRVm'
                    }
                }
            })
            .state('menu.addBankList', {
                url: '/addBankList',
                data: {
                    pageId: 'YFEI_ADD_BANK_LIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/addBank/bankListing.html',
                        controller: 'bankListingController',
                        controllerAs: 'bankListingVm'
                    }
                }
            })
            .state('menu.addBankAccountList', {
                url: '/addBankAccountList',
                data: {
                    pageId: 'YFEI_ADD_BANK_ACC_LIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/addBank/accountList.html',
                        controller: 'accountListController',
                        controllerAs: 'addAccountListVm'
                    }
                }
            })
            .state('menu.addBankSuccess', {
                url: '/addBankSuccess',
                data: {
                    pageId: 'YFEI_ADD_BANK_SUCCESS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/profile/addBank/addBankSuccess.html',
                        controller: 'addBankSuccessController',
                        controllerAs: 'addBankSuccessVm'
                    }
                }
            })
            .state('menu.createYefiVPA', {
                url: '/createYefiVPA',
                data: {
                    pageId: 'YFEI_CREATE_Y_VPA'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/createYefiVPA.html',
                        controller: 'createYefiVPAController',
                        controllerAs: 'createYVpaVm'
                    }
                }
            })
            .state('menu.bankAccountList', {
                url: '/bankAccountList',
                data: {
                    pageId: 'YFEI_ACC_LIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/bankAccountList.html',
                        controller: 'bankAccountListController',
                        controllerAs: 'bankAccListVm'
                    }
                }
            })
            .state('menu.bankAccountCreateVPA', {
                url: '/bankAccountCreateVPA',
                data: {
                    pageId: 'YFEI_ACC_LIST'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/registration/bankAccountCreateVPA.html',
                        controller: 'bankAccountCreateVPAController',
                        controllerAs: 'bankAccVPAVm'
                    }
                }
            })
            .state('menu.reqMoneyWithoutUPI', {
                url: '/reqMoneyWithoutUPI',
                data: {
                    pageId: 'YFEI_REQ_MONEY_WITHOUTUPI'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/requestMoney/reqMoneyWithoutUPI.html',
                        controller: 'reqMoneyWithoutUPIController',
                        controllerAs: 'reqMoneyWithoutUPIVm'
                    }
                }
            })

            .state('menu.payToBank', {
                url: '/payToBank',
                data: {
                    pageId: 'YFEI_PAY_BANK'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/YFEI/payToBank/payToBank.html',
                        controller: 'payToBankController',
                        controllerAs: 'payToBankVM'
                    }
                }
            })
    }]); 