angularApp.service('yfeiUPIService',
	function ($q, utilityService, constantConfig, AdapterUtils, cryptoService, loggedInUserService, $ionicPopup, $state, $http, APICUtils, ConnectivityMonitorUtils, $timeout) {
		var yfeiUPIService = this;
		yfeiUPIService.isUpiRegistration = false;
		yfeiUPIService.bankList = [];
		yfeiUPIService.accountDtlAgainstBank = [];
		yfeiUPIService.colorCode = ["#FFCAF9", "#9B99F7", "#B22382", "#954F98", "#6B3696", "#AB4E8C", "#823DBA", "#5553AA"];
		yfeiUPIService.existingVPADetails = {};
		yfeiUPIService.simId = "";
		yfeiUPIService.securityCheckName = "YFEIAuthSecurityCheck";
		yfeiUPIService.raiseComplaint = false;
		yfeiUPIService.reverifyDevice = false;
		yfeiUPIService.isExistingVPA = false;
		yfeiUPIService.bankCreateVPAPage = false;
		yfeiUPIService.bankListPage = true;
		yfeiUPIService.bankAccountListPage = false;
		yfeiUPIService.getAccountListTimerPage = false;
		yfeiUPIService.setPrimaryOption = false;
		yfeiUPIService.dashTransactionSelection = "";

		yfeiUPIService.isBiometricType = 'finger';
		yfeiUPIService.dashTransactionSelection = "";
		yfeiUPIService.yfeiNavigation = "";
		yfeiUPIService.commonErrorMsg = "Due to technical issues, your request cannot be processed. Kindly retry after sometime."
		yfeiUPIService.noSimMsg = "Please insert a SIM or check your network settings before proceeding further";
		yfeiUPIService.deviceRegistered = false;

		yfeiUPIService.initiate = function (reqPayload) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/initiate", reqPayload, true, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		yfeiUPIService.setUserMpin = function (reqPayload) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/savecustomer", reqPayload, true, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};


		yfeiUPIService.userLogout = function () {
			var q = $q.defer();
			APICUtils.postData("v1/apic/logout", {}, true, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		yfeiUPIService.yfeiLoginAuthorize = function (reqData) {
			var q = $q.defer();
			APICUtils.postData("yfei-oauth-provider/oauth2/authorize?client_id=" + APICUtils.clientID + "&response_type=code&scope=" + APICUtils.authScope, reqData, true, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		yfeiUPIService.getAuthToken = function (reqObj) {
			var q = $q.defer();
			APICUtils.postData("yfei-oauth-provider/oauth2/token", reqObj, true, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		yfeiUPIService.setBiometric = function (reqData) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/managebioauth", reqData, true, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};



		yfeiUPIService.changeLoginMpin = function (reqPayload) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/changempin", reqPayload, true, true).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};


		yfeiUPIService.getAuthError = function (reqPayload) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/readstatus", reqPayload, true, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};


		yfeiUPIService.getContent = function (payload) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/getcontent", payload, true, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};


		yfeiUPIService.updateRegCount = function (reqData) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/updateregcount", reqData, true, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		yfeiUPIService.searchIFSC = function (reqData) {
			var q = $q.defer();
			APICUtils.postData("v1/apic/getbankdetails", reqData, true, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		yfeiUPIService.getBankList = function () {
			var q = $q.defer();
			$http.get('pages/YFEI/bankMasterList.json').then(function (response) {
				q.resolve(response.data);
			}, function (error) {
				q.reject(error);
			});
			return q.promise;
		};

		yfeiUPIService.isFingerprintAvailable = function () {
			var q = $q.defer();
			Fingerprint.isAvailable(function (result) {
				if (result == 'finger' || result == 'face' || result == 'biometric') {
					yfeiUPIService.isFingerprintAviFlag = true;
					if (result == 'face') {
						yfeiUPIService.isBiometricType = 'face';
					}
					else if (result == 'finger') {
						yfeiUPIService.isBiometricType = 'finger';
					} else if (result == 'biometric') {
						yfeiUPIService.isBiometricType = 'biometric';
					}
					q.resolve({ "responseMessage": true });
				}
				else {
					//Display error fingerprint not available
					yfeiUPIService.isFingerprintAviFlag = false;
					q.reject();
					utilityService.showErrorMessage(yfeiUPIService.biometricNotAvailable());
				}
			}, function () {
				yfeiUPIService.isFingerprintAviFlag = false;
				q.reject();
				utilityService.showErrorMessage(yfeiUPIService.biometricNotAvailable());
				//Display error fingerprint not available
			});
			return q.promise;
		}

		yfeiUPIService.generateBiometricSHA512Val = function (bio_id) {
			var SHA512HashedVal = bio_id + yfeiUPIService.keyId;
			return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
		}

		yfeiUPIService.generateMPINSHA512ValWithSim = function (mPIN, simInfo) {
			var SHA512HashedVal = "";
			if (utilityService.isAndroidPlatform()) {
				SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo + simInfo).toString() + yfeiUPIService.keyId;
			}
			else {
				SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo).toString() + yfeiUPIService.keyId;
			}
			return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
		}


		yfeiUPIService.generateMPINSHA512Val = function (mPIN) {
			var SHA512HashedVal = cryptoService.getSHA512EncryptedData(mPIN + loggedInUserService.deviceInfo).toString() + yfeiUPIService.keyId;
			return cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
		}

		yfeiUPIService.getTimeOutService = function (type) {
			if(utilityService.isAndroidPlatform()){
				if (type == "onPayInitiation" || type == "onCollectInitiation" || type == "getUpiFundTransfer") {

					yfeiUPIService.timeOutExit = $timeout(function() {
						if (ConnectivityMonitorUtils.isOffline()) {
							APICUtils.secretId = "";
							$timeout.cancel(yfeiUPIService.timeOutExit);
							var naviagte = "mannualNavigation";
							yfeiUPIService.showUpiAlert('alert', "Unable to connect to Internet. Please check your connectivity. Confirmation on status of this transaction is pending. Please check status of the transaction from transaction history before retrying.", naviagte, "OK", "", "");
						}
					}, 60000);
				} else {
					if (ConnectivityMonitorUtils.isOffline()) {
						yfeiUPIService.showUpiAlert('alert', "Unable to connect to Internet. Please check your connectivity.", "", "OK", "", "");
					}
				}
			}
		}

		yfeiUPIService.getNativeData = function (type, dataRequest, journeyName) {
			yfeiUPIService.getTimeOutService(type);
			var q = $q.defer();
			var reqData = dataRequest;
			
			if (dataRequest === null || dataRequest === undefined) {
				dataRequest = '';
			}
			if (journeyName === undefined) {
				journeyName = 'UPI';
			}
			var successCallback = function (data) {

				if (type == "onPayInitiation" || type == "onCollectInitiation" || type == "getUpiFundTransfer") {
					$timeout.cancel(yfeiUPIService.timeOutExit);
				}

				yfeiUPIService.data = data;

				if (data != "null" && isJsonString(data) && JSON.parse(data).apiResp) {
					data = JSON.parse(data).apiResp;
				} else {
					if (data == "null") {
						q.resolve(yfeiUPIService.data);
						return;
					}
				}
				
				var payload = {};
				payload.type = "audit";
				payload.upiApiName = type;
				payload.apiStatus = "0000";
				payload.statusDesc =  JSON.stringify(yfeiUPIService.data);
				
				if (isJsonString(data)) {
					if (data && JSON.parse(data) && ((JSON.parse(data).status && JSON.parse(data).status == 'S') || (!JSON.parse(data).status))) {
						payload.values = {
							upiJourneyName: journeyName,
							platform: device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus: "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
								success: isStringJson(data) ? data : data.toString(),
								responseCode: JSON.parse(data) && (JSON.parse(data).responseCode || JSON.parse(data).errCode) ? (JSON.parse(data).responseCode || JSON.parse(data).errCode) : "",
								responseMessage: (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) ? (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) : ""
							},
							validateReq: (cryptoService.getSHA512EncryptedData(payload.upiJourneyName + payload.platform + payload.upiApiName + payload.deviceId + payload.apiStatus + payload.auditData + "/auditReq")).toString()
						}
					} else {
						payload.values = {
							upiJourneyName: journeyName,
							platform: device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus: "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && reqData.requestInfo && reqData.requestInfo.pspRefNo ? reqData.requestInfo.pspRefNo : reqData.toString(),
								failure: isStringJson(data) ? data : data.toString(),
								responseCode: data && (data.responseCode || data.errCode) ? (data.responseCode || data.errCode) : "",
								responseMessage: (data.responseMsg || data.statusDesc) ? (data.responseMsg || data.statusDesc) : ""
							},
							validateReq: (cryptoService.getSHA512EncryptedData(payload.upiJourneyName + payload.platform + payload.upiApiName + payload.deviceId + payload.apiStatus + payload.auditData + "/auditReq")).toString()
						}
					}
				} else {
					if ((data.status && data.status == 'S') || (!data.status)) {
						payload.values = {
							upiJourneyName: journeyName,
							platform: device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus: "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && reqData.requestInfo && reqData.requestInfo.pspRefNo ? reqData.requestInfo.pspRefNo : reqData.toString(),
								success: isStringJson(data) ? JSON.stringify(data) : data.toString(),
								responseCode: (data.responseCode || data.errCode) ? (data.responseCode || data.errCode) : "",
								responseMessage: (data.responseMsg || data.statusDesc) ? (data.responseMsg || data.statusDesc) : ""
							},
							validateReq: (cryptoService.getSHA512EncryptedData(payload.upiJourneyName + payload.platform + payload.upiApiName + payload.deviceId + payload.apiStatus + payload.auditData + "/auditReq")).toString()
						}
					} else {

						payload.values = {
							upiJourneyName: journeyName,
							platform: device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus: "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && reqData.requestInfo && reqData.requestInfo.pspRefNo ? reqData.requestInfo.pspRefNo : reqData.toString(),
								failure: isStringJson(data) ? JSON.stringify(data) : data.toString(),
								responseCode: (data.responseCode || data.errCode) ? (data.responseCode || data.errCode) : "",
								responseMessage: (data.responseMsg || data.statusDesc) ? (data.responseMsg || data.statusDesc) : ""
							},
							validateReq: (cryptoService.getSHA512EncryptedData(payload.upiJourneyName + payload.platform + payload.upiApiName + payload.deviceId + payload.apiStatus + payload.auditData + "/auditReq")).toString()
						}
					}
				}
				
				APICUtils.postData("v1/apic/saveauditlog", payload, false, false).then(function (response) { console.log('audit logs saved', type) }, function (error) { console.log('audit logs not saved', type) });
				
				q.resolve(yfeiUPIService.data);
			}
			var failureCallback = function (error) {
				if (type == "onPayInitiation" || type == "onCollectInitiation" || type == "getUpiFundTransfer") {
					$timeout.cancel(yfeiUPIService.timeOutExit);
				}
				
				if (error == "-101. ") {
					yfeiUPIService.error = -101;
				} 
				else if (error == 103) {
					yfeiUPIService.error = "UPI Error:103";
				} 
				else {
					yfeiUPIService.error = error;
				}
				var payload = {};
				payload.type = "audit"
				payload.upiApiName = type;
				payload.apiStatus = "0001";
				payload.statusDesc = JSON.stringify(error);
				
				payload.values = {
					upiJourneyName: journeyName,
					platform: device.platform.toLowerCase(),
					upiApiName: type,
					deviceId: device.uuid,
					type: "audit",
					apiStatus: "0001",
					auditData: {
						pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
						failure: isStringJson(error) ? JSON.stringify(error) : error.toString()
					},
					validateReq: (cryptoService.getSHA512EncryptedData(payload.upiJourneyName + payload.platform + payload.upiApiName + payload.deviceId + payload.apiStatus + payload.auditData + "/auditReq")).toString()
				}
               
				APICUtils.postData("v1/apic/saveauditlog", payload, false, false).then(function (response) { console.log('audit logs saved', type) }, function (err) { console.log('audit logs not saved', type) });

				q.reject(yfeiUPIService.error);
			}


			if (device.platform.toLowerCase() == 'android') {
				cordova.exec(successCallback, failureCallback, "Upisdk", type, [dataRequest]);
			} else {
				cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", type, [dataRequest]);
			}
			return q.promise;
		};

		var isJsonString = function (str) {
			try {
				JSON.parse(str);
			} catch (e) {
				return false;
			}
			return true;
		}

		var isStringJson = function (str) {
			try {
				JSON.stringify(str);
			} catch (e) {
				return false;
			}
			return true;
		}




		yfeiUPIService.getBannerData = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/YFEIAdapter/yfei/v1/getBannerData", requestData, false).then(function (response) {
				q.resolve(response);
			},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};


		yfeiUPIService.getQRCode = function (scan_qr) {
			var q = $q.defer();
			var obj = {
				"scanQRCode": scan_qr
			};
			var q = $q.defer();
			APICUtils.postData("v1/apic/getqrcode", obj, true, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		yfeiUPIService.verifySecKey = function (secKey) {
			return ((secKey / 2) - 1) / 99;
		}


		yfeiUPIService.showUpiAlert = function (imageType, message, onTapgo, buttontext, $scope) {
			var defaultMessage = message;
			switch (message) {
				case -1: message = constantConfig.upiConstant.minusOne;
					break;

				case -2: message = constantConfig.upiConstant.minusTwo;
					break;

				case -3: message = constantConfig.upiConstant.minusThree;
					break;

				case -4: message = constantConfig.upiConstant.minusFour;
					break;

				case -5: message = constantConfig.upiConstant.minusFive;
					break;

				case -6: message = constantConfig.upiConstant.minusSix;
					break;

				case -7: message = constantConfig.upiConstant.minusSeven;
					break;

				default: message = defaultMessage;
			}

			if (message.indexOf("U00") !== -1) {
				var isUserLoggedIn = localStorage.getItem('isSetMpin');
				if (isUserLoggedIn == "true") {
					onTapgo = "menu.yfeiLogin";
				}
				else {
					onTapgo = "menu.preRegistrationSelection";
				}


			}

			if (imageType && imageType.toLowerCase() == 'error') {
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if (imageType && imageType.toLowerCase() == 'success') {
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			} else {
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src=' + imageType + ' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
					+ message + '</span></div></div></div>',
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: [
					{
						text: buttontext || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								if(onTapgo == "mannualNavigation"){
									ionic.Platform.exitApp()
								}else{
								$state.go(onTapgo);
							}
						}
					}
					}
				],
			});
			bhimErrorPopup.then(function (res) {
				console.log(res);
			});
		};

		yfeiUPIService.fileStorageRemove = function () {
			
			localStorage.removeItem("yfeiAppGenId");
			localStorage.removeItem("isSetMpin");
			localStorage.removeItem("isYfeiBiometricSet");
			loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"registrationType":"","mpinConsent":true,"customername": "", "simSubscriptionId": "' + yfeiUPIService.simId + '"}').then(function (res) {
				console.log(res)
			}, function (err) {
				console.log(err)
			});
			
		}

		yfeiUPIService.generateQrCode = function (qrData) {
			return new QRCodeStyling({
				width: 250,
				height: 250,
				type: "canvas",
				data: qrData,
				image: "img/yfei/sbi_logo_qr.png",
				qrOptions: {
					typeNumber: 0,
					mode: 'Byte',
					errorCorrectionLevel: 'Q'
				},
				dotsOptions: {
					type: "rounded",
					color: "#5E097E",
					gradient: {
						type: "linear",
						rotation: 0,
						colorStops: [
							{
								offset: 0,
								color: "#5E097E"
							},
							{
								offset: 1,
								color: "#B22382"
							}
						]
					}
				},
				backgroundOptions: {
					color: "#ffffff",
				},
				cornersSquareOptions: {
					type: "dot",
					color: "#5E097E",
					gradient: {
						type: "linear",
						rotation: 0,
						colorStops: [
							{
								offset: 0,
								color: "#5E097E"
							},
							{
								offset: 1,
								color: "#B22382"
							}
						]
					}
				},
				cornersDotOptions: {
					type: "square",
					color: "#5E097E",
					gradient: {
						type: "linear",
						rotation: 0,
						colorStops: [
							{
								offset: 0,
								color: "#5E097E"
							},
							{
								offset: 1,
								color: "#B22382"
							}
						]
					}
				},
				imageOptions: {
					margin: 0
				}
			});

		}

		yfeiUPIService.removeTransactionHistoryData = function () {
			yfeiUPIService.transactionHistory = null;
		}

		yfeiUPIService.getTimeStamp = function () {
			let day = new Date().getDate();
			let months = new Date().getMonth() + 1;
			let hours = new Date().getHours();
			let minute = new Date().getMinutes();
			let second = new Date().getSeconds();
			if (day < 10) {
				day = 0 + "" + day;
			}
			if (months < 10) {
				months = 0 + "" + months;
			}
			if (hours < 10) {
				hours = 0 + "" + hours;
			}
			if (minute < 10) {
				minute = 0 + "" + minute;
			}
			if (second < 10) {
				second = 0 + "" + second;
			}

			return day + "" + months + "" + new Date().getFullYear() + "" + hours + "" + minute + "" + second;
		}

		yfeiUPIService.biometricNotAvailable = function () {
			return "To use this functionality your devices should support biometric.";
		}

		return yfeiUPIService;
	});
