'use strict';

angularApp.controller('aoAadharConsentController', ["$state",
    "$scope",
    "instapanAuthoriseService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "enterOTPAOService",
    "accountOpeningHomeService",

    function($state,
        $scope,
        instapanAuthoriseService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        enterOTPAOService,
        accountOpeningHomeService) {

        var aoAadharConsentVm = this;

        function initPage() {
            aoAadharConsentVm.showBack = true;
            aoAadharConsentVm.showNext = true;
            aoAadharConsentVm.isChecked = false;
            aoAadharConsentVm.disableNext = true;
            aoAadharConsentVm.aofooter = true;
            aoAadharConsentVm.agreeToAuthorize();
            aoAadharConsentVm.getAdharLang();
        }

        aoAadharConsentVm.goBacktoPrevious = function() {
             $state.go('menu.taxFatcaDetailsAO');
        }

       

        $scope.goToHome = function() {
            instaService.homeNav();
        }



        aoAadharConsentVm.agreeToAuthorize = function() {
            if (aoAadharConsentVm.isChecked) {
                aoAadharConsentVm.disableNext = false;
            } else {
                aoAadharConsentVm.disableNext = true;
            }
        }

      

         aoAadharConsentVm.getAdharLang = function() {  
            instapanAuthoriseService.getAdharLang().then(function(response) {
                aoAadharConsentVm.adharLang = response.data;
                aoAadharConsentVm.panAuthorizedContent = response.panAuthorizedContent;
                
                 for (var i = 0; i < aoAadharConsentVm.adharLang.length; i++) {
                    if(aoAadharConsentVm.aId === aoAadharConsentVm.adharLang[i].id){

                         aoAadharConsentVm.aDesc = aoAadharConsentVm.adharLang[i].description;
                         aoAadharConsentVm.adLanqu = aoAadharConsentVm.adharLang[i];
                    }

                }
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

         aoAadharConsentVm.changeLang = function(aDesc) {
            if(aDesc){
                aoAadharConsentVm.aDesc = aDesc.description;
                aoAadharConsentVm.aId = aDesc.id;
            }
         }

          aoAadharConsentVm.populateResumeData = function(){
            aoAadharConsentVm.isChecked = enterOTPAOService.aadhaarConsentFlag;
            aoAadharConsentVm.aId = enterOTPAOService.aadhaarConsentLang;
            
            if(aoAadharConsentVm.aId && aoAadharConsentVm.isChecked){
                aoAadharConsentVm.disableNext = false; 
            }
            
        }


          aoAadharConsentVm.goToNextPage = function() {
                enterOTPAOService.aadhaarConsentFlag = aoAadharConsentVm.isChecked;
                enterOTPAOService.aadhaarConsentLang = aoAadharConsentVm.aId;
                aoAadharConsentVm.disableNext = false;
               $state.go('menu.aadhaarOption');
        }

      

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
                aoAadharConsentVm.isChecked = enterOTPAOService.aadhaarConsentFlag;
                aoAadharConsentVm.aId = enterOTPAOService.aadhaarConsentLang;

              if(aoAadharConsentVm.aId == null || aoAadharConsentVm.aId == undefined){
                    aoAadharConsentVm.aId = 'en';
                    aoAadharConsentVm.isChecked = false;
                    enterOTPAOService.aadhaarConsentFlag = aoAadharConsentVm.isChecked;
                    enterOTPAOService.aadhaarConsentLang = aoAadharConsentVm.aId;
                }else{
                    aoAadharConsentVm.isChecked = enterOTPAOService.aadhaarConsentFlag;
                    aoAadharConsentVm.aId = enterOTPAOService.aadhaarConsentLang;
                }

            if (enterOTPAOService.isResumeJourney){
                aoAadharConsentVm.populateResumeData();
            }else{
                aoAadharConsentVm.journeyType = accountOpeningHomeService.journeyType;
                 if(aoAadharConsentVm.aId && aoAadharConsentVm.isChecked){
                    aoAadharConsentVm.disableNext = false; 
                }
            }            
        });

        return this;
    }
]);
