'use strict';

angularApp.service('NRIAOService',
    function ($q, AdapterUtils, constantConfig, $ionicPopup, $ionicHistory) {
        var NRIAOService = this;
        NRIAOService.consentValueForYes = false;
        NRIAOService.consentValueForNo = false;

        // For validation of visa details in Other details page
        NRIAOService.nriSeaFarer = false;

        // For PIO number in visa details section
        NRIAOService.isPIO = false;

        // Account opening channel indication variables.
        NRIAOService.aoThru = '';

        //To generate Form 60
        NRIAOService.isPanAvailable = false;

        NRIAOService.personalDetails = {
            title: '',
            titleDesc: '',
            firstName: '',
            middleName: '',
            lastName: '',
            dob: '',
            gender: '',
            maidenName: '',
            panNumber: '',
        }
        NRIAOService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, $scope, obj) {

            if (imageType && imageType.toLowerCase() == 'error') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'success') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            } else if (imageType && imageType.toLowerCase() == 'alert') {
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            } else {
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>' + message1 + '</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: [
                    {
                        text: buttontext1 || "Close",
                        type: 'button-positive',
                        onTap: function () {
                            bhimErrorPopup.close();
                            // }
                        }
                    }
                ],
            });
        };
        NRIAOService.clearServiceData = function () {
            NRIAOService.resumeNRIresponse = ""; 
            NRIAOService.requestNo = "";
            NRIAOService.privacyNoticeViewed = "";
            NRIAOService.consentValueForYes = "";
            NRIAOService.consentValueForNo = "";
            NRIAOService.PrivacyNoticeFile = "";
            NRIAOService.privacyNoticeContent = "";
            NRIAOService.review = "";
            NRIAOService.customerNumber = "";
            NRIAOService.nreAccountNumber = "";
            NRIAOService.nroAccountNumber = "";
            NRIAOService.nreAccountType = "";
            NRIAOService.nroAccountType = "";
            $ionicHistory.clearCache();
            $ionicHistory.clearHistory();
        };
        NRIAOService.getCountryName = function (code) {
            for (var i = 0; i < NRIAOService.countryMaster.length; i++) {
                if (NRIAOService.countryMaster[i].code == code) {
                    return NRIAOService.countryMaster[i];
                }
            }
        };
        NRIAOService.getStateName = function (code) {
            for (var i = 0; i < NRIAOService.stateMasterdata.length; i++) {
                if (NRIAOService.stateMasterdata[i].value == code) {
                    return NRIAOService.stateMasterdata[i].description;
                }
            }
        };
        NRIAOService.getAddressProof = function (key) {

            for (var i = 0; i < NRIAOService.keyValueMap.CurrentAddressProofMaster.length; i++) {
                if (NRIAOService.keyValueMap.CurrentAddressProofMaster[i].key == key) {
                    return NRIAOService.keyValueMap.CurrentAddressProofMaster[i];
                }
            }
        }
        NRIAOService.getAddressProofPermanent = function (key) {

            for (var i = 0; i < NRIAOService.keyValueMap.PermanentAddressProofMaster.length; i++) {
                if (NRIAOService.keyValueMap.PermanentAddressProofMaster[i].key == key) {
                    return NRIAOService.keyValueMap.PermanentAddressProofMaster[i];
                }
            }
        }
        NRIAOService.getAddressType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.AddressSubTypeMaster.length; i++) {
                if (NRIAOService.keyValueMap.AddressSubTypeMaster[i].key == key) {
                    return NRIAOService.keyValueMap.AddressSubTypeMaster[i];
                }
            }
        }
        NRIAOService.getResideAddressType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.StatusProofMaster.length; i++) {
                if (NRIAOService.keyValueMap.StatusProofMaster[i].key == key) {
                    return NRIAOService.keyValueMap.StatusProofMaster[i];
                }
            }
        }
        NRIAOService.getTaxAddressType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.TaxResidenceProofMaster.length; i++) {
                if (NRIAOService.keyValueMap.TaxResidenceProofMaster[i].key == key) {
                    return NRIAOService.keyValueMap.TaxResidenceProofMaster[i];
                }
            }
        }
        NRIAOService.getEducationValue = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.EduQualificationMaster.length; i++) {
                if (NRIAOService.keyValueMap.EduQualificationMaster[i].key == key) {
                    return NRIAOService.keyValueMap.EduQualificationMaster[i];
                }
            }
        }
        NRIAOService.getReligionValue = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.ReligionMaster.length; i++) {
                if (NRIAOService.keyValueMap.ReligionMaster[i].key == key) {
                    return NRIAOService.keyValueMap.ReligionMaster[i];
                }
            }
        }

        NRIAOService.getReligionOtherSubType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.OtherReligionMaster.length; i++) {
                if (NRIAOService.keyValueMap.OtherReligionMaster[i].key == key) {
                    return NRIAOService.keyValueMap.OtherReligionMaster[i];
                }
            }
        }
        NRIAOService.getCategoryValue = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.CategoryMaster.length; i++) {
                if (NRIAOService.keyValueMap.CategoryMaster[i].key == key) {
                    return NRIAOService.keyValueMap.CategoryMaster[i];
                }
            }
        }

        NRIAOService.getOccupationOtherSubType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.OM2.length; i++) {
                if (NRIAOService.keyValueMap.OM2[i].key == key) {
                    return NRIAOService.keyValueMap.OM2[i];
                }
            }
        }
        NRIAOService.getOccupationServiceSubType = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.OM1.length; i++) {
                if (NRIAOService.keyValueMap.OM1[i].key == key) {
                    return NRIAOService.keyValueMap.OM1[i];
                }
            }
        }
        NRIAOService.getOccupationValue = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.OccupationMaster.length; i++) {
                if (NRIAOService.keyValueMap.OccupationMaster[i].key == key) {
                    return NRIAOService.keyValueMap.OccupationMaster[i];
                }
            }
        }
        NRIAOService.getTitleValue = function (key) {
            for (var i = 0; i < NRIAOService.keyValueMap.TitleMaster.length; i++) {
                if (NRIAOService.keyValueMap.TitleMaster[i].key == key) {
                    return NRIAOService.keyValueMap.TitleMaster[i];
                }
            }
        };
        NRIAOService.getISDCode = function () {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getISDCodes, {}, false).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.getOtp = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getOTPBoth, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.resendOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.resendOTP, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.checkIfApplicationExist = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.checkApplication, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        NRIAOService.checkIfApplicationExistYob = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.checkApplicationYob, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.getallMasterData = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getallMasterData, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        NRIAOService.countryNames = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.countryNames, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.stateNames = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.stateNamesService, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        NRIAOService.nriWcmConsent = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.nriWcmConsent, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        NRIAOService.supportNumberDetails = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.supportNumber, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.createSaveApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processApplication, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.savePassportApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processPassport, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.saveAddressDetails = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processAddress, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.saveAdditionalDetailsApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processAdditionalDetail, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.saveTaxDetails = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processTaxDetail, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.saveEduQualificationApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processEducationQualification, requestData, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.saveFatcaApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processState, requestData, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        NRIAOService.saveAdditionalPersonalApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processPersonal, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.saveNomineeApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processNominee, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.getBranchDetail = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getBranches, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.getWcmData = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getTnC, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        NRIAOService.saveAccountServiceApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.processAccountService, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.saveSelectedBranch = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.saveSelectedBranch, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.showReviewDetails = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.getApplicationData, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.validateOtp = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.validateOtp, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        NRIAOService.submitApplication = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.submitNriApplication, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.sendTermsAndCondition = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.saveTermsAndCondition, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        NRIAOService.downloadCover = function (requestData) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.downloadCover, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        NRIAOService.declineConsentNRI = function (requestData) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.NRIAcOpeningAdapterUrl.declineConsent, requestData, true).then(

                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        return NRIAOService;
    });
