'use strict';

angularApp.controller('NRIConsentController', ["$state",
    "$scope",
    "NRIAOService",
    "$ionicPopup",
    "utilityService",
    function ($state,
        $scope,
        NRIAOService,
        $ionicPopup,
        utilityService) {

        var NRIConsentVm = this;


        function initPage() {
            if (NRIAOService.resumeNRIresponse) {
                if (NRIAOService.resumeNRIresponse.dataSharingConsent != null) {
                    if (NRIAOService.resumeNRIresponse.dataSharingConsent) {
                        NRIConsentVm.dataSharingConsent = "Yes";
                        NRIAOService.dataSharingConsent = true;
                        NRIConsentVm.datasharing = true;
                    }
                    else {
                        NRIConsentVm.dataSharingConsent = "No";
                        NRIAOService.dataSharingConsent = false
                        NRIConsentVm.datasharing = false;
                    }

                }
                if (NRIAOService.resumeNRIresponse.euResident != null) {
                    if (NRIAOService.resumeNRIresponse.euResident) {
                        NRIConsentVm.NoneuConsent = false;
                        NRIConsentVm.euNoneuConsent = "Yes";
                        NRIConsentVm.privacyNoticeViewed = NRIAOService.privacyNoticeViewed;

                    }
                    else {
                        NRIConsentVm.NoneuConsent = true;
                        NRIConsentVm.euNoneuConsent = "No";
                    }
                }
                if (NRIAOService.resumeNRIresponse.consent != null) {
                    if (NRIAOService.resumeNRIresponse.consent) {
                        NRIConsentVm.isConsentChecked = true;
                        NRIConsentVm.disableCheckbox = false;
                        NRIConsentVm.consentClauseforNo = true;
                        NRIConsentVm.consentClauseforYes = true;
                        NRIConsentVm.agreeChkBox();
                    }
                    else {
                        NRIConsentVm.isConsentChecked = false;
                        NRIConsentVm.disableCheckbox = true;
                        NRIConsentVm.agreeChkBox();
                    }
                }




            } else {
                NRIConsentVm.NoneuConsent = true;
                NRIConsentVm.euNoneuConsent = "No";
                NRIConsentVm.datasharing = true;
                NRIConsentVm.dataSharingConsent = "Yes";
                NRIConsentVm.disableNext = true;
                NRIConsentVm.disableDataSharingClause = false;
                NRIConsentVm.privacyNoticeViewed = false;
                NRIConsentVm.consentClauseforYes = false;
                NRIConsentVm.consentClauseforNo = false;
                NRIConsentVm.disableCheckbox = true;
            }


            NRIConsentVm.supportNumberOne = NRIAOService.supportNumberOne;
            NRIConsentVm.supportNumberTwo = NRIAOService.supportNumberTwo;
            NRIConsentVm.supportNumberThree = NRIAOService.supportNumberThree;
            var wcmConsentRequest = {
                "id": NRIAOService.countryCode + NRIAOService.mobile,

            }
            NRIAOService.nriWcmConsent(wcmConsentRequest).then(function (consentResponse) {

                if (consentResponse.responseCode == '0000') {
                    NRIConsentVm.data = consentResponse.data;
                }

            }, function (error) {

                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            NRIConsentVm.consentClauseforYes = NRIAOService.consentValueForYes;
            NRIConsentVm.privacyNoticeViewed = NRIAOService.privacyNoticeViewed;
            NRIConsentVm.consentClauseforNo = NRIAOService.consentValueForNo;
            if (NRIConsentVm.euNoneuConsent == "No") {
                if (NRIConsentVm.consentClauseforNo) {
                    NRIConsentVm.disableCheckbox = false;
                }
                else {
                    NRIConsentVm.disableCheckbox = true;
                }
            }
            else if (NRIConsentVm.euNoneuConsent == "Yes") {

                if (NRIConsentVm.privacyNoticeViewed) {
                    NRIConsentVm.disableDataSharingClause = false

                    if (NRIConsentVm.consentClauseforYes) {
                        NRIConsentVm.disableCheckbox = false;
                    }
                    else {
                        NRIConsentVm.disableCheckbox = true;
                    }
                }
            }
            else {
                initPage();
            }

        });

        NRIConsentVm.goBack = function () {
            $state.go('menu.otpInitialNRIAO');
        }

        NRIConsentVm.residenceChange = function () {
            if (NRIConsentVm.euNoneuConsent == "Yes") {
                NRIConsentVm.disableDataSharingClause = true;
            } else {
                NRIConsentVm.disableDataSharingClause = false;
            }

            if (NRIConsentVm.euNoneuConsent == "Yes" && !NRIConsentVm.consentClauseforYes) {
                NRIConsentVm.disableCheckbox = true;
                NRIConsentVm.disableNext = true;
                NRIConsentVm.isConsentChecked = false;
            } else if (NRIConsentVm.euNoneuConsent == "No" && !NRIConsentVm.consentClauseforNo) {
                NRIConsentVm.disableCheckbox = true;
                NRIConsentVm.disableNext = true;
                NRIConsentVm.isConsentChecked = false
            } else {
                if (NRIConsentVm.euNoneuConsent == "Yes" && NRIConsentVm.consentClauseforYes && !NRIConsentVm.privacyNoticeViewed) {
                    NRIConsentVm.disableNext = true;
                }
                else {
                    NRIConsentVm.disableCheckbox = false;
                    NRIConsentVm.disableNext = false;
                }
            }
        }

        NRIConsentVm.consentContent = function () {
            if (NRIConsentVm.euNoneuConsent == 'Yes') {
                NRIAOService.euConsentData = NRIConsentVm.data.euData;
                $state.go('menu.euConsent');
            }
            if (NRIConsentVm.euNoneuConsent == 'No') {
                NRIAOService.nonEuConsentData = NRIConsentVm.data.nonEuData;
                $state.go('menu.nonEUConsent');
            }
        }

        NRIConsentVm.downloadPrivacyNotice = function () {
            NRIAOService.privacyNoticeContent = NRIConsentVm.data.privacyNoticeContent;
            NRIAOService.PrivacyNoticeFile = NRIConsentVm.data.privacyNoticeFileUrl;
            $state.go('menu.nriPrivacyInfo');


        }

        NRIConsentVm.agreeChkBox = function () {
            //only to be enable when the consent is read completely


            var euNoneuConsentNotNull = NRIConsentVm.isNotNullOrUndefined(NRIConsentVm.euNoneuConsent);
            var dataSharingConsentNotNull = NRIConsentVm.isNotNullOrUndefined(NRIConsentVm.dataSharingConsent);
            if (NRIConsentVm.euNoneuConsent == 'No') {
                if (NRIConsentVm.isConsentChecked && euNoneuConsentNotNull && dataSharingConsentNotNull && NRIConsentVm.consentClauseforNo) {
                    NRIConsentVm.disableNext = false;
                } else {
                    NRIConsentVm.disableNext = true;
                }

            }
            if (NRIConsentVm.euNoneuConsent == 'Yes') {
                if (NRIConsentVm.isConsentChecked && euNoneuConsentNotNull && dataSharingConsentNotNull && NRIConsentVm.privacyNoticeViewed && NRIConsentVm.consentClauseforYes) {
                    NRIConsentVm.disableNext = false;
                } else {
                    NRIConsentVm.disableNext = true;
                }
            }
        }

        NRIConsentVm.declineConsent = function () {
            //Decline consent popup and redirection to first page. 
            var declineMessageOne = NRIConsentVm.data.declineConsentData.parameter1;
            var declineMessageTwo = NRIConsentVm.data.declineConsentData.parameter2;
            NRIConsentVm.declineConsentEU = $ionicPopup.show({
                template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorSymbol.svg"></div><div class="button_fund font-dark-grey" style="font-size: 16px !important;font-family: Roboto-medium !important;padding-left: 20px;padding-right: 20px;">' + declineMessageOne + '</div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey" style="padding-left: 20px;padding-right: 20px;">' + declineMessageTwo + '</div>',
                title: '',
                cssClass: 'bhim-alert-popup',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (e) {


                        NRIConsentVm.declineConsentAudit();



                    }
                }]
            });

        }


        NRIConsentVm.declineConsentAudit = function () {
            NRIAOService.declineConsent = true;
            var declineConsentRequest = {
                "id": NRIAOService.countryCode + NRIAOService.mobile,
                "mobileNo": NRIAOService.mobile,
                "email": NRIAOService.emailId

            }
            NRIAOService.declineConsentNRI(declineConsentRequest).then(function (declineConsentResponse) {

                if (declineConsentResponse.responseCode == '0000') {
                    $state.go('menu.newToSbiLanding');
                }

            }, function (error) {

                utilityService.showErrorMessage(error.responseMessage);
            });


        }



        NRIConsentVm.isNotNullOrUndefined = function (varNull) {
            return (varNull != null && varNull != undefined && varNull != "");
        }



        NRIConsentVm.goToACType = function () {
            var euNoneuConsentNotNull = NRIConsentVm.isNotNullOrUndefined(NRIConsentVm.euNoneuConsent);
            var dataSharingConsentNotNull = NRIConsentVm.isNotNullOrUndefined(NRIConsentVm.dataSharingConsent);
            var isConsentCheckedNotNull = NRIConsentVm.isNotNullOrUndefined(NRIConsentVm.isConsentChecked);

            if (NRIConsentVm.dataSharingConsent == 'Yes') {
                NRIAOService.dataSharingConsent = true;
            }
            if (NRIConsentVm.dataSharingConsent == 'No') {
                NRIAOService.dataSharingConsent = false;
            }
            if (NRIConsentVm.euNoneuConsent == 'No') {
                if (euNoneuConsentNotNull && dataSharingConsentNotNull && isConsentCheckedNotNull && NRIConsentVm.isConsentChecked && NRIConsentVm.consentClauseforNo) {
                    NRIAOService.euResident = false;
                    if (NRIConsentVm.dataSharingConsent == 'Yes') {
                        NRIAOService.dataSharingConsent = true;
                    }
                    if (NRIConsentVm.dataSharingConsent == 'No') {
                        NRIAOService.dataSharingConsent = false;
                    }
                    NRIAOService.consent = true;
                    NRIAOService.declineConsent = false;
                    NRIAOService.privacyNoticeViewed = null;
                    NRIAOService.privacyNoticeDownloaded = null;
                    $state.go('menu.accTypeStatusPages');
                }
            }
            if (NRIConsentVm.euNoneuConsent == 'Yes') {
                if (euNoneuConsentNotNull && dataSharingConsentNotNull && isConsentCheckedNotNull && NRIConsentVm.isConsentChecked && NRIConsentVm.privacyNoticeViewed && NRIConsentVm.consentClauseforYes) {
                    NRIAOService.euResident = true;
                    if (NRIConsentVm.dataSharingConsent == 'Yes') {
                        NRIAOService.dataSharingConsent = true;
                    }
                    if (NRIConsentVm.dataSharingConsent == 'No') {
                        NRIAOService.dataSharingConsent = false;
                    }
                    NRIAOService.consent = true;
                    NRIAOService.declineConsent = false;
                    NRIAOService.privacyNoticeViewed = true;
                    $state.go('menu.accTypeStatusPages');
                }
            }

        }




        return this;
    }
]);
