'use strict';

angularApp.controller('accTypeStatusController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",
        function ($state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService) {
            var accTypeStatusVm = this;

            $scope.$on('$ionicView.loaded', function () {
                if (NRIAOService.resumeNRIresponse || NRIAOService.review) {
                    accTypeStatusVm.accountType = true;
                    if (NRIAOService.resumeNRIresponse.nreAccountDetail != {} && NRIAOService.resumeNRIresponse.nreAccountDetail != null) {
                        accTypeStatusVm.nreAccSel = true;
                        if (NRIAOService.resumeNRIresponse.nreAccountDetail.accountType == 'SAVINGS') {
                            accTypeStatusVm.nreAccTypeSel = 'NRE Saving';
                        } else if (NRIAOService.resumeNRIresponse.nreAccountDetail.accountType == 'CURRENT') {
                            accTypeStatusVm.nreAccTypeSel = 'NRE Current';
                        }

                    } else {
                        accTypeStatusVm.nreAccSel = false;
                    }
                    if (NRIAOService.resumeNRIresponse.nroAccountDetail != {} && NRIAOService.resumeNRIresponse.nroAccountDetail != null) {
                        accTypeStatusVm.nroAccSel = true;
                        if (NRIAOService.resumeNRIresponse.nroAccountDetail.accountType == 'SAVINGS') {
                            accTypeStatusVm.nroAccTypeSel = 'NRO Saving';
                        } else if (NRIAOService.resumeNRIresponse.nroAccountDetail.accountType == 'CURRENT') {
                            accTypeStatusVm.nroAccTypeSel = 'NRO Current';
                        }
                    } else {
                        accTypeStatusVm.nroAccSel = false;
                    }
                    if (NRIAOService.resumeNRIresponse.applicantStatus != null) {
                        if (NRIAOService.resumeNRIresponse.applicantStatus == 'NRI') {
                            accTypeStatusVm.statusSel = 'NRI';
                            accTypeStatusVm.seaFarChk = 'No';
                        } else if (NRIAOService.resumeNRIresponse.applicantStatus == 'NRI-Seafarer') {
                            accTypeStatusVm.statusSel = 'NRI';
                            accTypeStatusVm.seaFarChk = 'Yes';
                        }
                        else if (NRIAOService.resumeNRIresponse.applicantStatus == 'PIO') {
                            accTypeStatusVm.statusSel = 'PIO';
                            accTypeStatusVm.seaFarChk = '';
                            NRIAOService.nriSeaFarer = false;
                            NRIAOService.isPIO = true;
                        }
                    }

                } else {
                    accTypeStatusVm.accountType = true;
                    accTypeStatusVm.statusType = false;
                    accTypeStatusVm.nreAccSel = false;
                    accTypeStatusVm.nroAccSel = false;
                    accTypeStatusVm.nreAccTypeSel = '';
                    accTypeStatusVm.nroAccTypeSel = '';
                    accTypeStatusVm.statusSel = '';
                    accTypeStatusVm.seaFarChk = '';
                    accTypeStatusVm.showAccTypeErr = false;
                    accTypeStatusVm.showNreAccSelErr = false;
                    accTypeStatusVm.showNroAccSelErr = false;
                    accTypeStatusVm.showStatusTypeErr = false;
                    accTypeStatusVm.showSeaFarErr = false;
                    accTypeStatusVm.accTypeValidated = '';
                    accTypeStatusVm.statusValidated = '';
                }
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                accTypeStatusVm.statusCardClicked = false;
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    accTypeStatusVm.getUpdatedData();
                }
            });


            
            accTypeStatusVm.getUpdatedData = function () {

                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        accTypeStatusVm.initPage();
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }


            accTypeStatusVm.initPage = function () {
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                  
                    accTypeStatusVm.accountType = true;
                    if (NRIAOService.resumeNRIresponse.nreAccountDetail != {} && NRIAOService.resumeNRIresponse.nreAccountDetail != null) {
                        accTypeStatusVm.nreAccSel = true;
                        if (NRIAOService.resumeNRIresponse.nreAccountDetail.accountType == 'SAVINGS') {
                            accTypeStatusVm.nreAccTypeSel = 'NRE Saving';
                        } else if (NRIAOService.resumeNRIresponse.nreAccountDetail.accountType == 'CURRENT') {
                            accTypeStatusVm.nreAccTypeSel = 'NRE Current';
                        }

                    } else {
                        accTypeStatusVm.nreAccSel = false;
                        accTypeStatusVm.nreAccTypeSel = '';
                    }
                    if (NRIAOService.resumeNRIresponse.nroAccountDetail != {} && NRIAOService.resumeNRIresponse.nroAccountDetail != null) {
                        accTypeStatusVm.nroAccSel = true;
                        if (NRIAOService.resumeNRIresponse.nroAccountDetail.accountType == 'SAVINGS') {
                            accTypeStatusVm.nroAccTypeSel = 'NRO Saving';
                        } else if (NRIAOService.resumeNRIresponse.nroAccountDetail.accountType == 'CURRENT') {
                            accTypeStatusVm.nroAccTypeSel = 'NRO Current';
                        }
                    } else {
                        accTypeStatusVm.nroAccSel = false;
                        accTypeStatusVm.nroAccTypeSel = '';
                    }
                    if (NRIAOService.resumeNRIresponse.applicantStatus == 'NRI') {
                        accTypeStatusVm.statusSel = 'NRI';
                        accTypeStatusVm.seaFarChk = 'No';
                    } else if (NRIAOService.resumeNRIresponse.applicantStatus == 'NRI-Seafarer') {
                        accTypeStatusVm.statusSel = 'NRI';
                        accTypeStatusVm.seaFarChk = 'Yes';
                    }
                    else if (NRIAOService.resumeNRIresponse.applicantStatus == 'PIO') {
                        accTypeStatusVm.statusSel = 'PIO';
                        accTypeStatusVm.seaFarChk = '';
                        NRIAOService.nriSeaFarer = false;
                        NRIAOService.isPIO = true;
                    }


                }
            }

            accTypeStatusVm.goBack = function () {

                if (NRIAOService.resumeApplication) {
                    $state.go('menu.NRIConsent');
                } else {
                    $ionicHistory.goBack();
                }
            }

            accTypeStatusVm.toggleContent = function (item) {

                if (item == 'accSel') {
                    if (accTypeStatusVm.statusCardValidation()) {
                        accTypeStatusVm.statusValidated = 'Y';
                    } else {
                        accTypeStatusVm.statusValidated = 'N';
                    }
                    accTypeStatusVm.accountType = true;
                    accTypeStatusVm.statusType = false;

                } else if (item == 'statSel') {
                    if (accTypeStatusVm.accTypeCardValidation()) {
                        accTypeStatusVm.accTypeValidated = 'Y';
                    } else {
                        accTypeStatusVm.accTypeValidated = 'N';
                    }
                    accTypeStatusVm.accountType = false;
                    accTypeStatusVm.statusType = true;
                    accTypeStatusVm.statusCardClicked = 'Y';
                }
            }

            accTypeStatusVm.accTypChk = function (accountTypeSel) {
                if (accountTypeSel == 'NRE') {
                    NRIAOService.accountTypeSelNre = 'NRE';
                    if (!accTypeStatusVm.nreAccSel) {
                        accTypeStatusVm.nreAccTypeSel = '';
                        NRIAOService.nreAccTypeSel = null;
                        NRIAOService.accountTypeSelNre = null;
                    }
                } else if (accountTypeSel == 'NRO') {
                    NRIAOService.accountTypeSelNro = 'NRO';
                    if (!accTypeStatusVm.nroAccSel) {
                        accTypeStatusVm.nroAccTypeSel = '';
                        NRIAOService.nroAccTypeSel = null;
                        NRIAOService.accountTypeSelNro = null
                    }
                }
                accTypeStatusVm.showAccTypeErr = false;

            }

            accTypeStatusVm.accSelected = function (accType) {
                if (accTypeStatusVm.nreAccSel) {
                    if (accType == 'NRE_S') {
                        accTypeStatusVm.nreAccTypeSel = 'NRE Saving';
                    } else if (accType == 'NRE_C') {
                        accTypeStatusVm.nreAccTypeSel = 'NRE Current';
                    }
                    accTypeStatusVm.showNreAccSelErr = false;
                }

                if (accTypeStatusVm.nroAccSel) {
                    if (accType == 'NRO_S') {
                        accTypeStatusVm.nroAccTypeSel = 'NRO Saving';
                    } else if (accType == 'NRO_C') {
                        accTypeStatusVm.nroAccTypeSel = 'NRO Current';
                    }
                    accTypeStatusVm.showNroAccSelErr = false;
                }
            }

            accTypeStatusVm.statusChk = function (valueSel) {
                if (valueSel == 'PIO') {
                    accTypeStatusVm.seaFarChk = '';
                    accTypeStatusVm.statusSel = 'PIO';

                    NRIAOService.nriSeaFarer = false;
                    NRIAOService.isPIO = true;
                    accTypeStatusVm.showSeaFarErr = false;

                } else if (valueSel == 'NRI') {
                    NRIAOService.isPIO = false;
                    accTypeStatusVm.statusSel = 'NRI';

                }
                accTypeStatusVm.showStatusTypeErr = false;
            }

            accTypeStatusVm.seaFarerChk = function (option) {
                if (accTypeStatusVm.statusSel == 'NRI') {
                    if (option == 'Y') {
                        accTypeStatusVm.seaFarChk = 'Yes';
                        NRIAOService.nriSeaFarer = true;

                    } else if (option == 'N') {
                        accTypeStatusVm.seaFarChk = 'No';
                        NRIAOService.nriSeaFarer = false;
                    }
                }
                accTypeStatusVm.showSeaFarErr = false;
            }

            accTypeStatusVm.goToProductInfo = function () {

                if (accTypeStatusVm.accTypeCardValidation()) {
                    accTypeStatusVm.accTypeValidated = 'Y';

                    if (accTypeStatusVm.statusCardValidation()) {
                        accTypeStatusVm.statusValidated = 'Y';
                        accTypeStatusVm.accountType = false;
                        accTypeStatusVm.statusType = false;

                        if (accTypeStatusVm.nreAccSel) {
                            if (accTypeStatusVm.nreAccTypeSel == 'NRE Saving') {
                                NRIAOService.nreAccTypeSel = "SAVINGS";
                            }

                            else if (accTypeStatusVm.nreAccTypeSel == 'NRE Current') {
                                NRIAOService.nreAccTypeSel = "CURRENT";
                            }
                        }

                        if (accTypeStatusVm.nroAccSel) {
                            if (accTypeStatusVm.nroAccTypeSel == 'NRO Saving') {
                                NRIAOService.nroAccTypeSel = "SAVINGS";
                            }
                            else if (accTypeStatusVm.nroAccTypeSel == 'NRO Current') {
                                NRIAOService.nroAccTypeSel = "CURRENT";
                            }
                        }

                        if (NRIAOService.isPIO) {
                            NRIAOService.applicantStatus = "PIO";
                        }
                        else if (!NRIAOService.isPIO) {

                            if (NRIAOService.nriSeaFarer) {
                                NRIAOService.applicantStatus = "NRI-Seafarer";
                            }
                            else if (!NRIAOService.nriSeaFarer) {
                                NRIAOService.applicantStatus = "NRI";
                            }
                        }

                            $state.go("menu.nriProductInfoPage");
                       

                    } else {
                        accTypeStatusVm.statusValidated = 'N';
                    }
                } else {
                    accTypeStatusVm.accTypeValidated = 'N';
                }
            }

            accTypeStatusVm.accTypeCardValidation = function () {

                if (accTypeStatusVm.nreAccSel || accTypeStatusVm.nroAccSel) {
                    accTypeStatusVm.showAccTypeErr = false;

                    if (accTypeStatusVm.nreAccSel) {
                        if (accTypeStatusVm.nreAccTypeSel != '') {
                            accTypeStatusVm.showNreAccSelErr = false;
                        } else {
                            accTypeStatusVm.showNreAccSelErr = true;
                            accTypeStatusVm.cardHighlightValidation('Account Type');
                        }
                    } else {
                        accTypeStatusVm.showNreAccSelErr = false;
                    }

                    if (accTypeStatusVm.nroAccSel) {
                        if (accTypeStatusVm.nroAccTypeSel != '') {
                            accTypeStatusVm.showNroAccSelErr = false;

                        } else {
                            accTypeStatusVm.showNroAccSelErr = true;
                            accTypeStatusVm.cardHighlightValidation('Account Type');
                        }
                    } else {
                        accTypeStatusVm.showNroAccSelErr = false;
                    }

                    if (!accTypeStatusVm.showNreAccSelErr && !accTypeStatusVm.showNroAccSelErr) {
                        return true;
                    }
                } else if (!accTypeStatusVm.nreAccSel && !accTypeStatusVm.nroAccSel) {
                    accTypeStatusVm.showAccTypeErr = true;
                    accTypeStatusVm.cardHighlightValidation('Account Type');

                    accTypeStatusVm.showNreAccSelErr = false;
                    accTypeStatusVm.showNroAccSelErr = false;
                }
            }

            accTypeStatusVm.statusCardValidation = function () {
                if (accTypeStatusVm.statusSel !== null && accTypeStatusVm.statusSel !== '' && accTypeStatusVm.statusSel !== undefined) {
                    accTypeStatusVm.showStatusTypeErr = false;

                    if (accTypeStatusVm.statusSel == "NRI") {
                        if (accTypeStatusVm.seaFarChk != '') {
                            accTypeStatusVm.showSeaFarErr = false;
                            return true;

                        } else {
                            accTypeStatusVm.showSeaFarErr = true;
                            accTypeStatusVm.cardHighlightValidation('Status Type');
                        }
                    } else {
                        accTypeStatusVm.showSeaFarErr = false;
                        return true;
                    }

                } else {
                    accTypeStatusVm.showStatusTypeErr = true;
                    accTypeStatusVm.cardHighlightValidation('Status Type');
                }
            }

            accTypeStatusVm.cardHighlightValidation = function (value) {
                if (value == 'Account Type') {
                    accTypeStatusVm.accountType = true;
                    accTypeStatusVm.statusType = false;

                } else if (value == 'Status Type') {
                    accTypeStatusVm.accountType = false;
                    accTypeStatusVm.statusType = true;
                }

            }

        }
    ]);