'use strict';

angularApp.controller('additionalPersonalDetailsNRIController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",
        function ($state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService) {
            var additionalPersonalDetailsNRIVm = this;


            $scope.$on('$ionicView.beforeEnter', function () {
                additionalPersonalDetailsNRIVm.getUpdatedResumeData();
            });
            $scope.$on('$ionicView.loaded', function () {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
              
                additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = "";
                additionalPersonalDetailsNRIVm.addFatherDetailsShowError = "";
                additionalPersonalDetailsNRIVm.addMotherDetailsShowError = "";
                additionalPersonalDetailsNRIVm.countryofBirthObj = NRIAOService.countryMaster;
                additionalPersonalDetailsNRIVm.eyeAadharMasked = true;
                additionalPersonalDetailsNRIVm.maritalStatusSelfObj = NRIAOService.masterList.MaritalStatusMaster;
                additionalPersonalDetailsNRIVm.titleMaster = NRIAOService.keyValueMap.TitleMaster;
                additionalPersonalDetailsNRIVm.mailPatternError = true;
                additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
            });
            additionalPersonalDetailsNRIVm.scrollUP = function(view){
                    document.getElementById(view).scrollIntoView(); 
            }
            additionalPersonalDetailsNRIVm.getUpdatedResumeData = function(){
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "tempCode": null,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        additionalPersonalDetailsNRIVm.initPage();
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }
            additionalPersonalDetailsNRIVm.initPage = function () {
                additionalPersonalDetailsNRIVm.spousetitleMaster = [];
                for (var i = 0; i < additionalPersonalDetailsNRIVm.titleMaster.length; i++) {
                    if (additionalPersonalDetailsNRIVm.titleMaster[i].key == "F-03" || additionalPersonalDetailsNRIVm.titleMaster[i].key == "F-02") {
                        additionalPersonalDetailsNRIVm.spousetitleMaster.push(additionalPersonalDetailsNRIVm.titleMaster[i])
                    }
                }
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    additionalPersonalDetailsNRIVm.placeofBirth = NRIAOService.resumeNRIresponse.birthPlace
                    additionalPersonalDetailsNRIVm.countryofBirth = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.birthCountry)
                    additionalPersonalDetailsNRIVm.nriAadhar = NRIAOService.resumeNRIresponse.aadhaarNo
                    additionalPersonalDetailsNRIVm.maritalStatusSelf = NRIAOService.resumeNRIresponse.maritalStatus
                    additionalPersonalDetailsNRIVm.spouseFirstName = NRIAOService.resumeNRIresponse.spouseFirstName
                    additionalPersonalDetailsNRIVm.spouseMiddleName = NRIAOService.resumeNRIresponse.spouseMiddleName
                    additionalPersonalDetailsNRIVm.spouseLastName = NRIAOService.resumeNRIresponse.spouseLastName
                    additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
                    additionalPersonalDetailsNRIVm.fatherFirstName = NRIAOService.resumeNRIresponse.fatherFirstName
                    additionalPersonalDetailsNRIVm.fatherMiddleName = NRIAOService.resumeNRIresponse.fatherMiddleName
                    additionalPersonalDetailsNRIVm.fatherLastName = NRIAOService.resumeNRIresponse.fatherLastName
                    additionalPersonalDetailsNRIVm.motherTitle = NRIAOService.resumeNRIresponse.motherTitle
                    additionalPersonalDetailsNRIVm.motherFirstName = NRIAOService.resumeNRIresponse.motherFirstName
                    additionalPersonalDetailsNRIVm.motherMiddleName = NRIAOService.resumeNRIresponse.motherMiddleName
                    additionalPersonalDetailsNRIVm.motherLastName = NRIAOService.resumeNRIresponse.motherLastName
                    additionalPersonalDetailsNRIVm.applicantGender = NRIAOService.resumeNRIresponse.gender;
                    if (additionalPersonalDetailsNRIVm.applicantGender == 'Female') {
                        additionalPersonalDetailsNRIVm.spousetitleSelected = "Mr.";
                    }
                    else {
                        additionalPersonalDetailsNRIVm.spousetitleSelected = NRIAOService.resumeNRIresponse.spouseTitle;
                    }
                    if (NRIAOService.resumeNRIresponse.aadhaarNo) {

                        var aadhaarNo = NRIAOService.resumeNRIresponse.aadhaarNo
                        additionalPersonalDetailsNRIVm.eyeHideAadhar(aadhaarNo);
                    }
                    setTimeout(function(){
                        additionalPersonalDetailsNRIVm.validateFatherDetails()
                        additionalPersonalDetailsNRIVm.validateMotherDetails()
                        additionalPersonalDetailsNRIVm.validatePersonalDetails()
                    },1000);
                     
                } else {
                    additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
                    additionalPersonalDetailsNRIVm.applicantGender = NRIAOService.gender;
                    if (additionalPersonalDetailsNRIVm.applicantGender == 'Female') {
                        additionalPersonalDetailsNRIVm.spousetitleSelected = "Mr.";
                    }
                    if (NRIAOService.aadhaarNo) {
                        var aadhaarNo = NRIAOService.aadhaarNo
                        additionalPersonalDetailsNRIVm.eyeHideAadhar(aadhaarNo);
                    }
                }

            }

            
              

            additionalPersonalDetailsNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.fatcaDeclarationNRI");
                } else {
                    $ionicHistory.goBack();
                }
            }

            additionalPersonalDetailsNRIVm.changeSpouseDetails = function () {
                if(additionalPersonalDetailsNRIVm.maritalStatusSelf == "Married"){

                    if(additionalPersonalDetailsNRIVm.applicantGender == 'Female'){
                        additionalPersonalDetailsNRIVm.spousetitleSelected = "Mr."
                    }


                  
                }
                else{
                    additionalPersonalDetailsNRIVm.spousetitleSelected = " ";
                    additionalPersonalDetailsNRIVm.spouseFirstName = " ";
                    additionalPersonalDetailsNRIVm.spouseMiddleName =  " ";
                    additionalPersonalDetailsNRIVm.spouseLastName = " ";
                }
            }


            additionalPersonalDetailsNRIVm.toggleContent = function (item) {

                if (item == 'addPersonalDetails') {
                    additionalPersonalDetailsNRIVm.validatePersonalDetails(true);
                    additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                } else if (item == 'addFatherDetails') {
                    additionalPersonalDetailsNRIVm.validatePersonalDetails(true);
                    additionalPersonalDetailsNRIVm.toggleCard = 'FD';
                    additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
                } else if (item == 'addMotherDetails') {
                    additionalPersonalDetailsNRIVm.validatePersonalDetails(true);
                    additionalPersonalDetailsNRIVm.validateFatherDetails(true);
                    additionalPersonalDetailsNRIVm.toggleCard = 'MD';
                }
                else if (item == 'addAadhDetails') {
                    additionalPersonalDetailsNRIVm.validatePersonalDetails(true);
                    additionalPersonalDetailsNRIVm.validateFatherDetails(true);
                    var motherTitleNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherTitle);
                    var motherFirstNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherFirstName);
                    var motherLastNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherLastName);


                    if (!motherTitleNotNull && !motherFirstNameNotNull && !motherLastNameNotNull) {
                        additionalPersonalDetailsNRIVm.addMotherDetailsShowError = 'NO';
                        additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                    }

                    else if ((motherTitleNotNull || motherFirstNameNotNull || motherLastNameNotNull) || (motherTitleNotNull && motherFirstNameNotNull && motherLastNameNotNull)) {
                        additionalPersonalDetailsNRIVm.validateMotherDetails(true);
                        if (additionalPersonalDetailsNRIVm.addMotherDetailsShowError == "NO") {
                            additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                        }
                    }

                    additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                }
            }

            additionalPersonalDetailsNRIVm.validatePersonalDetails = function (submit) {

                    var placeofBirthNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.placeofBirth);
                    var countryofBirthNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.countryofBirth);
                if (additionalPersonalDetailsNRIVm.maritalStatusSelf == "Unmarried" || additionalPersonalDetailsNRIVm.maritalStatusSelf == "Others") {
                    additionalPersonalDetailsNRIVm.spousetitleSelected = "";
                    additionalPersonalDetailsNRIVm.spouseFirstName = "";
                    additionalPersonalDetailsNRIVm.spouseMiddleName = "";
                    additionalPersonalDetailsNRIVm.spouseLastName = "";
                    if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.placeofBirth.$valid
                        && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.countryofBirth.$valid) {
                            if(placeofBirthNotNull && countryofBirthNotNull){
                                if(submit){
                                   additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'NO';
                                }else{
                                    additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = ''; 
                                } 
                            }else{ 
                                 if(submit){
                                      additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                                      additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                                 }else{
                                     additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = ''; 
                                 }
                                 
                            }  
                    }
                    else {
                        
                        if(submit){ 
                            additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                            additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                        }else{
                            additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = ''; 
                        }
                    }

                }
                else if (additionalPersonalDetailsNRIVm.maritalStatusSelf == "Married") {

                    var spouseFirstNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.spouseFirstName);
                    var spouseLastNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.spouseLastName);
                    var spouseMiddleNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.spouseMiddleName);
                    var spousetitleSelectedNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.spousetitleSelected);

                    if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.placeofBirth.$valid && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.countryofBirth.$valid) {

                        
                            if (spousetitleSelectedNotNull && spouseFirstNameNotNull && spouseMiddleNameNotNull && spouseLastNameNotNull) {
                                if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.spouseFirstName.$valid && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.spouseMiddleName.$valid
                                    && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.spouseLastName.$valid) {

                                    additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'NO';
                                }
                                else {
                                    additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                                    additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                                }

                            }
                            else if(spousetitleSelectedNotNull && spouseFirstNameNotNull && spouseLastNameNotNull) {
                                if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.spouseFirstName.$valid && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.spouseLastName.$valid) {

                                    additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'NO';
                                }
                                else {
                                    additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                                    additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                                }
                            }
                            else{
                                additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                                additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                            }
                        
                        

                    }
                    else {
                        additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES';
                        additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                    }
                }else{
                   additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = "YES";
                    additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                }

            }


            additionalPersonalDetailsNRIVm.validateFatherDetails = function (submit) {

           

                if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.fatherFirstName.$valid
                    && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.fatherMiddleName.$valid
                    && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.fatherLastName.$valid) {
                
                        if(submit){
                            additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
                            additionalPersonalDetailsNRIVm.addFatherDetailsShowError = "NO";
                        }else{
                            additionalPersonalDetailsNRIVm.fatherTitle = "Mr.";
                            additionalPersonalDetailsNRIVm.addFatherDetailsShowError = "";
                        } 
                }
                else{
                    additionalPersonalDetailsNRIVm.addFatherDetailsShowError = 'YES';
                    additionalPersonalDetailsNRIVm.toggleCard = 'FD';
                }



                


            }

            additionalPersonalDetailsNRIVm.validateMotherDetails = function (submit) {


                if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.motherFirstName.$valid
                    && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.motherMiddleName.$valid
                    && additionalPersonalDetailsNRIVm.addPersonalDetailsForm.motherLastName.$valid) {
                        if(submit){ 
                            additionalPersonalDetailsNRIVm.addMotherDetailsShowError = "NO";
                        }else{ 
                            additionalPersonalDetailsNRIVm.addMotherDetailsShowError = "";
                        }  
                }
                else{
                    if(submit){
                        additionalPersonalDetailsNRIVm.addMotherDetailsShowError = 'YES';
                        additionalPersonalDetailsNRIVm.toggleCard = 'MD';
                   }else{
                       additionalPersonalDetailsNRIVm.addMotherDetailsShowError = "";
                   }
                }
              
            }




            additionalPersonalDetailsNRIVm.gotoPassportDetails = function () {


                if (additionalPersonalDetailsNRIVm.toggleCard == "PD") {


                    var placeofBirthNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.placeofBirth);
                    var countryofBirthNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.countryofBirth);
                    var maritalStatusSelfNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.maritalStatusSelf);

                    if (placeofBirthNotNull && countryofBirthNotNull && maritalStatusSelfNotNull) {
                        additionalPersonalDetailsNRIVm.validatePersonalDetails(true);
                        if (additionalPersonalDetailsNRIVm.addPersonalDetailsShowError == "NO") {
                            additionalPersonalDetailsNRIVm.toggleCard = 'FD';


                        }
                    }
                    else {
                        additionalPersonalDetailsNRIVm.addPersonalDetailsShowError = 'YES'
                        additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                    }



                }
                if (additionalPersonalDetailsNRIVm.toggleCard == "FD") {

                    var fatherFirstNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.fatherFirstName);
                    var fatherLastNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.fatherLastName);

                    if (fatherFirstNameNotNull && fatherLastNameNotNull) {
                        additionalPersonalDetailsNRIVm.validateFatherDetails(true);
                        if (additionalPersonalDetailsNRIVm.addFatherDetailsShowError == "NO") {
                            additionalPersonalDetailsNRIVm.toggleCard = 'MD';
                        }
                    }
                    else {
                        additionalPersonalDetailsNRIVm.addFatherDetailsShowError = 'YES';
                        additionalPersonalDetailsNRIVm.toggleCard = 'FD';
                    }

                }
                if (additionalPersonalDetailsNRIVm.toggleCard == "MD") {

                    var motherTitleNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherTitle);
                    var motherFirstNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherFirstName);
                    var motherLastNameNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.motherLastName);


                    if (!motherTitleNotNull && !motherFirstNameNotNull && !motherLastNameNotNull) {
                        additionalPersonalDetailsNRIVm.addMotherDetailsShowError = 'NO';
                        additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                    }

                    else if ((motherTitleNotNull || motherFirstNameNotNull || motherLastNameNotNull) || (motherTitleNotNull && motherFirstNameNotNull && motherLastNameNotNull)) {
                        additionalPersonalDetailsNRIVm.validateMotherDetails(true);
                        if (additionalPersonalDetailsNRIVm.addMotherDetailsShowError == "NO") {
                            additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                        }
                    }
                }

                if (additionalPersonalDetailsNRIVm.toggleCard == "AD") {
                    var nriAadharNotNull = additionalPersonalDetailsNRIVm.isNotNullOrUndefined(additionalPersonalDetailsNRIVm.nriAadhar);
                    if (nriAadharNotNull) {
                        if (additionalPersonalDetailsNRIVm.addPersonalDetailsForm.nriAadhar.$valid) {
                            additionalPersonalDetailsNRIVm.addAadhDetailsShowError = 'NO';
                        }
                        else {
                            additionalPersonalDetailsNRIVm.addAadhDetailsShowError = 'NO';
                            additionalPersonalDetailsNRIVm.toggleCard = 'AD';
                        }
                    }
                    else {
                        additionalPersonalDetailsNRIVm.addAadhDetailsShowError = 'NO';
                    }


                }

                if ((additionalPersonalDetailsNRIVm.addPersonalDetailsShowError == "NO" || additionalPersonalDetailsNRIVm.addPersonalDetailsShowError == "") && (additionalPersonalDetailsNRIVm.addFatherDetailsShowError == "NO" || additionalPersonalDetailsNRIVm.addFatherDetailsShowError == "")) {

                   if((additionalPersonalDetailsNRIVm.addMotherDetailsShowError == "NO" || additionalPersonalDetailsNRIVm.addMotherDetailsShowError == "") && (additionalPersonalDetailsNRIVm.addAadhDetailsShowError == "NO" || additionalPersonalDetailsNRIVm.addAadhDetailsShowError == "")){

                         if (additionalPersonalDetailsNRIVm.addAadhDetailsShowError == "NO") {
                            additionalPersonalDetailsNRIVm.nriAadhar = additionalPersonalDetailsNRIVm.oldnriAadharValue;
                        }
                        if (NRIAOService.review) {
                            additionalPersonalDetailsNRIVm.lastSavedState = null;
                        }
                        else {
                            additionalPersonalDetailsNRIVm.lastSavedState = "PERSONAL_DATA";

                        }

                        if (additionalPersonalDetailsNRIVm.applicantGender == 'Female') {
                            additionalPersonalDetailsNRIVm.spousetitleSelected = "M-01"
                        }


                        var requestSaveAdditionalPersonal = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "review": NRIAOService.review,
                            "requestNo": NRIAOService.requestNo,
                            "birthPlace": additionalPersonalDetailsNRIVm.placeofBirth,
                            "birthCountry": additionalPersonalDetailsNRIVm.countryofBirth.code,
                            "aadhaarNo": additionalPersonalDetailsNRIVm.nriAadhar ? additionalPersonalDetailsNRIVm.nriAadhar : " ",
                            "maritalStatus": additionalPersonalDetailsNRIVm.maritalStatusSelf,
                            "spouseTitle": additionalPersonalDetailsNRIVm.maritalStatusSelf == 'Married' ? additionalPersonalDetailsNRIVm.spousetitleSelected : " ",
                            "spouseFirstName": additionalPersonalDetailsNRIVm.spouseFirstName ? additionalPersonalDetailsNRIVm.spouseFirstName : " ",
                            "spouseMiddleName": additionalPersonalDetailsNRIVm.spouseMiddleName ? additionalPersonalDetailsNRIVm.spouseMiddleName : " ",
                            "spouseLastName": additionalPersonalDetailsNRIVm.spouseLastName ? additionalPersonalDetailsNRIVm.spouseLastName : " ",
                            "fatherTitle": "M-01",
                            "fatherFirstName": additionalPersonalDetailsNRIVm.fatherFirstName,
                            "fatherMiddleName": additionalPersonalDetailsNRIVm.fatherMiddleName ? additionalPersonalDetailsNRIVm.fatherMiddleName : " ",
                            "fatherLastName": additionalPersonalDetailsNRIVm.fatherLastName,
                            "motherTitle": additionalPersonalDetailsNRIVm.motherTitle ? additionalPersonalDetailsNRIVm.motherTitle : " ",
                            "motherFirstName": additionalPersonalDetailsNRIVm.motherFirstName ? additionalPersonalDetailsNRIVm.motherFirstName: " ",
                            "motherMiddleName": additionalPersonalDetailsNRIVm.motherMiddleName ? additionalPersonalDetailsNRIVm.motherMiddleName : " ",
                            "motherLastName": additionalPersonalDetailsNRIVm.motherLastName ? additionalPersonalDetailsNRIVm.motherLastName: " ",
                        }

                        NRIAOService.saveAdditionalPersonalApplication(requestSaveAdditionalPersonal).then(function (response) {
                            if (response.responseCode == '0000') {
                                NRIAOService.requestNo = response.data;
                                additionalPersonalDetailsNRIVm.getUpdatedData();

                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                   }
                       
                }
                else {
                    if (additionalPersonalDetailsNRIVm.addPersonalDetailsShowError == "YES") {
                        additionalPersonalDetailsNRIVm.toggleCard = 'PD';
                    }
                    else if (additionalPersonalDetailsNRIVm.addFatherDetailsShowError == "YES") {
                        additionalPersonalDetailsNRIVm.toggleCard = 'FD';
                    }
                    else if (additionalPersonalDetailsNRIVm.addMotherDetailsNoError == "YES") {
                        additionalPersonalDetailsNRIVm.toggleCard = 'MD';
                    }

                }

            }
            additionalPersonalDetailsNRIVm.getUpdatedData = function () {

                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go('menu.passportVisaDetailsNRI');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }


            additionalPersonalDetailsNRIVm.isNotNullOrUndefined = function (varNull) {


                return (varNull != null && varNull != undefined && varNull != "");

            }



            additionalPersonalDetailsNRIVm.maskAadhar = function (aadNo) {
                additionalPersonalDetailsNRIVm.oldnriAadharValue = aadNo;
                additionalPersonalDetailsNRIVm.nriAadhar = utilityService.maskData(aadNo, "front", 4);
            }



            additionalPersonalDetailsNRIVm.eyeDisplayAadhar = function () {
                additionalPersonalDetailsNRIVm.eyeAadharMasked = false;
                additionalPersonalDetailsNRIVm.nriAadhar = additionalPersonalDetailsNRIVm.oldnriAadharValue;
            }



            additionalPersonalDetailsNRIVm.eyeHideAadhar = function (aadNo) {
                additionalPersonalDetailsNRIVm.eyeAadharMasked = true;
                additionalPersonalDetailsNRIVm.oldnriAadharValue = aadNo;
                additionalPersonalDetailsNRIVm.nriAadhar = utilityService.maskData(aadNo, "front", 4);
            }

        }
    ]);
