'use strict';

angularApp.controller('applicationSubmitedNRIController',
    ["$state",
        "$scope",
        "NRIAOService",
        "utilityService", "openUrlInAppbroswerService", "$q", "$ionicPopup",


        function ($state, $scope, NRIAOService, utilityService, openUrlInAppbroswerService, $q, $ionicPopup) {
            var applicationSubmitedNRIVm = this;

            applicationSubmitedNRIVm.isPermanent = false;
            $scope.$on('$ionicView.loaded', function () {
                applicationSubmitedNRIVm.supportNumberOne = NRIAOService.supportNumberOne;
                applicationSubmitedNRIVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                applicationSubmitedNRIVm.supportNumberThree = NRIAOService.supportNumberThree;


            });

            applicationSubmitedNRIVm.initPage = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile
                }

                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        applicationSubmitedNRIVm.statusProof = NRIAOService.getResideAddressType(NRIAOService.resumeNRIresponse.statusProof).value;
                        applicationSubmitedNRIVm.taxAddrProof = NRIAOService.getTaxAddressType(NRIAOService.resumeNRIresponse.taxDetail.taxAddrProof).value;
                        applicationSubmitedNRIVm.visitBranch = NRIAOService.resumeNRIresponse.branchPref;

                        if (applicationSubmitedNRIVm.visitBranch) {
                            applicationSubmitedNRIVm.ValidUptoAppdate = NRIAOService.ValidUptoAppdate;
                        }
                        if (!applicationSubmitedNRIVm.visitBranch) {
                            applicationSubmitedNRIVm.gncResponseSuccess = NRIAOService.gncResponseSuccess;
                        }
                        applicationSubmitedNRIVm.euResident = NRIAOService.resumeNRIresponse.euResident;
                        applicationSubmitedNRIVm.panAvailable = NRIAOService.resumeNRIresponse.panAvailable
                        if (NRIAOService.resumeNRIresponse.currentAddress.addressProofType == "A") {
                            applicationSubmitedNRIVm.addressProof = "Passport"
                        } else {
                            applicationSubmitedNRIVm.addressProof = NRIAOService.getAddressProof(NRIAOService.resumeNRIresponse.currentAddress.addressProofType).value
                        }
                        if (!NRIAOService.resumeNRIresponse.sameAddress) {
                            applicationSubmitedNRIVm.isPermanent = true;
                            if (NRIAOService.resumeNRIresponse.permanentAddress.addressProofType == "04") {
                                applicationSubmitedNRIVm.permanentaddressProof = "Passport"
                            } else {
                                applicationSubmitedNRIVm.permanentaddressProof = NRIAOService.getAddressProofPermanent(NRIAOService.resumeNRIresponse.permanentAddress.addressProofType).value
                            }
                        }
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            applicationSubmitedNRIVm.downloadPdf = function (pdfName) {
                if (pdfName == "AOF") {

                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "type": "AOF"
                    }

                } else if (pdfName == "CoveringLetter") {
                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "type": "COVERING"
                    }


                } else if (pdfName == "ConsentClause") {
                    if (!applicationSubmitedNRIVm.euResident) {
                        var payload = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "requestNo": NRIAOService.requestNo,
                            "type": "CONSENT_NON_EU"
                        }
                    }

                    if (applicationSubmitedNRIVm.euResident) {
                        var payload = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "requestNo": NRIAOService.requestNo,
                            "type": "CONSENT_EU"
                        }

                    }

                } else if (pdfName == "Form60") {
                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "type": "FORM60"
                    }
                }

                NRIAOService.downloadCover(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        var content = response.data.pdf;
                        var filename = response.data.fileName;
                        var contentType = "application/pdf";
                        if (utilityService.isAndroidPlatform()) {
                            applicationSubmitedNRIVm.folderpath = cordova.file.externalDataDirectory;
                        }
                        if (utilityService.isIOSPlatform()) {
                            applicationSubmitedNRIVm.folderpath = cordova.file.documentsDirectory;
                            filename = filename + ".pdf";
                            openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
                        }
                        savebase64AsPDF(applicationSubmitedNRIVm.folderpath, filename, content, contentType);

                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }
            function b64toBlob(b64Data, contentType, sliceSize) {
                contentType = contentType || '';
                sliceSize = sliceSize || 512;
                var byteCharacters = atob(b64Data);
                var byteArrays = [];
                for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                    var slice = byteCharacters.slice(offset, offset + sliceSize);
                    var byteNumbers = [];
                    for (var i = 0; i < slice.length; i++) {
                        byteNumbers[i] = slice.charCodeAt(i);
                    }
                    var byteArray = new Uint8Array(byteNumbers);
                    byteArrays.push(byteArray);
                }
                return new Blob(byteArrays, { type: contentType });
            }
            function savebase64AsPDF(folderpath, filename, content, contentType) {
                // Convert the base64 string in a Blob
                var defer = $q.defer();
                var response = {};
                var DataBlob = b64toBlob(content, contentType);
                filename = filename + ".pdf";
                if (utilityService.isAndroidPlatform()) {
                    if (device.version == 10) {
                        applicationSubmitedNRIVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory, "") + filename;
                        window.resolveLocalFileSystemURL(folderpath, function (dir) {
                            dir.getFile(filename, { create: true }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    response = { folderpath: applicationSubmitedNRIVm.popupFolderpath }
                                    applicationSubmitedNRIVm.showSuccessPopup(response.folderpath)
                                    defer.resolve(response);
                                }, function (error) { defer.reject(error); });
                            }, function (error) { defer.reject(error); });
                        }, function (error) { defer.reject(error); });

                    }else{
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                        fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                            applicationSubmitedNRIVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    response = { folderpath: applicationSubmitedNRIVm.popupFolderpath }
                                    applicationSubmitedNRIVm.showSuccessPopup(response.folderpath)
                                    defer.resolve(response);
                                }, function (error) {defer.reject(error); });
                            });
                        });
                    });
                    }
                }
                

            }
            applicationSubmitedNRIVm.showSuccessPopup = function (folderpath) {
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{ folderpath: applicationSubmitedNRIVm.popupFolderpath }"></div>';
                applicationSubmitedNRIVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                            applicationSubmitedNRIVm.downloadPopup.close();

                        }
                    }],
                });
            }
            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function () {
                applicationSubmitedNRIVm.initPage();
            });
            applicationSubmitedNRIVm.goToNext = function () {
                $state.go("menu.otpInitialNRIAO");
            }

            applicationSubmitedNRIVm.goBack = function () {
                $state.go("menu.otpInitialNRIAO");
            }
        }
    ]);