'use strict';

angularApp.controller('enterEmailOTPPageNRIAOController', ["$state",
	"$scope",
	"$translate",
	"utilityService",
	"$ionicSideMenuDelegate",
	"mPinLoginService",
	"loggedInUserService",
	"cryptoService",
	"encryptionService",
	"AdapterUtils",
	"NRIAOService",
	"autoOtpReadService",
	"$ionicPopup",
	"$timeout",
	"constantConfig",
	function ($state,
		$scope,
		$translate,
		utilityService,
		$ionicSideMenuDelegate,
		mPinLoginService,
		loggedInUserService,
		cryptoService,
		encryptionService,
		AdapterUtils,
		NRIAOService,
		autoOtpReadService,
		$ionicPopup,
		$timeout,
		constantConfig) {

		var enterEmailOTPNRIAOVm = this;

		enterEmailOTPNRIAOVm.isChallenged = false;
		enterEmailOTPNRIAOVm.securityCheckName = "AOSecurityCheck";
		enterEmailOTPNRIAOVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(enterEmailOTPNRIAOVm.securityCheckName);
		enterEmailOTPNRIAOVm.aoAuthChallengeHandler.securityCheckName = enterEmailOTPNRIAOVm.securityCheckName;


		function initPage() {
			enterEmailOTPNRIAOVm.showBack = true;
			enterEmailOTPNRIAOVm.showNext = true;
			enterEmailOTPNRIAOVm.showOtpView = true;
			enterEmailOTPNRIAOVm.otpvalue = "";
			enterEmailOTPNRIAOVm.disableNext = true;
			$translate('AO_OK_LABEL').then(function (translatedvalue) {
				enterEmailOTPNRIAOVm.okBtntext = translatedvalue;
			});
			enterEmailOTPNRIAOVm.clickCountOTPEmail = 0;
			enterEmailOTPNRIAOVm.isDisabledOTPEmail = false;
			enterEmailOTPNRIAOVm.clickCountOTP = 0;
			enterEmailOTPNRIAOVm.isDisabledOTP = false;

		}

		enterEmailOTPNRIAOVm.goBacktoPrevious = function () {
			NRIAOService.countryCode = "";
			NRIAOService.mobile = "";
			NRIAOService.emailId = "";
			$state.go('menu.otpInitialNRIAO');
		}

		$scope.goToHome = function () {
			enterEmailOTPNRIAOVm.goBacktoPrevious();
		}

		enterEmailOTPNRIAOVm.validateOTP = function (isValid) {
			enterEmailOTPNRIAOVm.disableNext = !isValid;
		}


		/* resend OTP */

		enterEmailOTPNRIAOVm.requestOtpCallOnce = function () {
			enterEmailOTPNRIAOVm.resendOtp();
		}

		enterEmailOTPNRIAOVm.resendOtp = function () {
			var requestParams = {
				"isdCode": NRIAOService.countryCode,
				"id": NRIAOService.mobile,
				"recipientMailId": NRIAOService.emailId ? NRIAOService.emailId : null,
				"sendOTPFlg": "mobileOnly"
			}
			NRIAOService.resendOTP(requestParams).then(function (response) {

				if (utilityService.isAndroidPlatform()) {
					autoOtpReadService.startOtpReading().then(function (result) {
						enterEmailOTPNRIAOVm.otpvalue = result;
						enterEmailOTPNRIAOVm.disableNext = false;
					}, function (error) {
						utilityService.showErrorMessage(error);
					});
				} else {
					var title = '';
					var template = '{{"OTP_SENT_SUCCESS" | translate}}';
					var onTap = '';
					var buttontext = '<b>' + enterEmailOTPNRIAOVm.okBtntext + '</b>';
					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
				}

				enterEmailOTPNRIAOVm.clickCountOTP++;
				if (enterEmailOTPNRIAOVm.clickCountOTP >= 2) {
					enterEmailOTPNRIAOVm.isDisabledOTP = true;
				}
				else {
					enterEmailOTPNRIAOVm.isDisabledOTP = true;
					$timeout(function () {
						enterEmailOTPNRIAOVm.isDisabledOTP = false;
					}, 30000);
				}



			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		enterEmailOTPNRIAOVm.requestOtpEmail = function () {
			enterEmailOTPNRIAOVm.resendOtpEmail();
		}

		enterEmailOTPNRIAOVm.resendOtpEmail = function () {
			var requestParams = {
				"isdCode": NRIAOService.countryCode,
				"id": NRIAOService.mobile,
				"recipientMailId": NRIAOService.emailId,
				"sendOTPFlg": "emailOnly"
			}
			NRIAOService.resendOTP(requestParams).then(function (response) {

				var title = '';
				var template = '{{"OTP_SENT_SUCCESS_EMAIL" | translate}}';
				var onTap = '';
				var buttontext = '<b>' + enterEmailOTPNRIAOVm.okBtntext + '</b>';
				utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

				enterEmailOTPNRIAOVm.clickCountOTPEmail++;
				if (enterEmailOTPNRIAOVm.clickCountOTPEmail >= 2) {
					enterEmailOTPNRIAOVm.isDisabledOTPEmail = true;
				}
				else {
					enterEmailOTPNRIAOVm.isDisabledOTPEmail = true;
					$timeout(function () {
						enterEmailOTPNRIAOVm.isDisabledOTPEmail = false;
					}, 30000);
				}



			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		/* resend OTP END */



		enterEmailOTPNRIAOVm.goToNextPage = function () {

			utilityService.showSpinner();
			enterEmailOTPNRIAOVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
				enterEmailOTPNRIAOVm.isChallenged = true;
				utilityService.hideSpinner();
				if (challenge.errorMsg !== null) {
					utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
				} else {
					utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				}
			};

			enterEmailOTPNRIAOVm.aoAuthChallengeHandler.handleSuccess = function (data) {
				utilityService.hideSpinner();
				enterEmailOTPNRIAOVm.isChallenged = false;
				if (data.user) {
					loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
					loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
				}
			};

			enterEmailOTPNRIAOVm.aoAuthChallengeHandler.handleFailure = function (error) {
				enterEmailOTPNRIAOVm.aoAuthChallengeHandler.cancel();
				enterEmailOTPNRIAOVm.isChallenged = false;
				utilityService.hideSpinner();
				if (error.failure) {
					utilityService.showErrorMessage(error.failure);
				} else {
					utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				}
			}

			var payload = {};
			var requestParams = {
				"mobileOTPKey": NRIAOService.countryCode + NRIAOService.mobile,
				"mobileNumberOnly": NRIAOService.mobile,
				"passOTPKey": enterEmailOTPNRIAOVm.otpvalue,
				"mfDeviceId": loggedInUserService.deviceIdForMpin,
				"deviceId": device.uuid,
				"emailOTPKey": NRIAOService.emailId ? NRIAOService.emailId : null,
				"passEmailOTPKey": enterEmailOTPNRIAOVm.emailOtpvalue,
				"reqTimeStamp": (new Date()).toString(),
				"journeyName": "AO_NRI"
			}

			var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
			payload = {
				"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
				"src": src
			}

			payload = AdapterUtils.secretData == "" ? requestParams : payload;
			if (enterEmailOTPNRIAOVm.isChallenged) {
				enterEmailOTPNRIAOVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
			} else {
				WLAuthorizationManager.login(enterEmailOTPNRIAOVm.aoAuthChallengeHandler.securityCheckName, payload).then(
					function (data) {
						utilityService.accessRestricted = utilityService.AOAuthRequired;
						utilityService.hideSpinner();

						enterEmailOTPNRIAOVm.id = NRIAOService.countryCode + NRIAOService.mobile;
						
						//Check existing application exist and redirect to the year of birth page.
						var requestParamscheckApp = {
							"id": NRIAOService.countryCode + NRIAOService.mobile,
							"isdCode": NRIAOService.countryCode,
							"mobileNo": NRIAOService.mobile,
							"email": NRIAOService.emailId
						}
						NRIAOService.checkIfApplicationExist(requestParamscheckApp).then(function (response) {
							if (response.responseCode == "0000") {

								//No Application found
								if (response.statusCode == '00') {
									NRIAOService.resumeApplication = false;
									var requestParamsMaster = {
										"id": NRIAOService.countryCode + NRIAOService.mobile,
									}
									
									NRIAOService.getallMasterData(requestParamsMaster).then(function (responseMaster) {
										NRIAOService.allMaster = responseMaster.data;
										NRIAOService.masterList = NRIAOService.allMaster.masterList;
										NRIAOService.keyValueMap = NRIAOService.allMaster.keyValueMap;
										NRIAOService.supportNumber = NRIAOService.allMaster.supportNumber;
										NRIAOService.supportNumberOne = NRIAOService.supportNumber[0];
										NRIAOService.supportNumberTwo = NRIAOService.supportNumber[1];
										NRIAOService.supportNumberThree = NRIAOService.supportNumber[2];

										NRIAOService.countryNames(requestParamsMaster).then(function (responseCountryMaster) {
											NRIAOService.countryMaster = responseCountryMaster.data;

											NRIAOService.stateNames(requestParamsMaster).then(function (responseStateMaster) {
												NRIAOService.stateMasterdata = responseStateMaster.payLoad;


												$state.go('menu.NRIConsent');


											}, function (error) {
												utilityService.showErrorMessage(error.responseMessage);
											});


										}, function (error) {
											utilityService.showErrorMessage(error.responseMessage);
										});


									}, function (error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								}



								//RI application found
								if (response.statusCode == '01') {
									$state.go('menu.resumeApplicationRI');
								}


								//NRI application found
								if (response.statusCode == '02') {

									var param = {
										"id": NRIAOService.countryCode + NRIAOService.mobile,
									}
									NRIAOService.supportNumberDetails(param).then(function (responseSupportNumber) {

										NRIAOService.supportNumber = responseSupportNumber.payLoad;
										NRIAOService.supportNumberOne = NRIAOService.supportNumber[0];
										NRIAOService.supportNumberTwo = NRIAOService.supportNumber[1];
										NRIAOService.supportNumberThree = NRIAOService.supportNumber[2];

										$state.go('menu.resumeApplicationNRI');


									}, function (error) {
										utilityService.showErrorMessage(error.responseMessage);
									});



								}


								//DOB Counter attempt reached
								if (response.statusCode == '03') {
									enterEmailOTPNRIAOVm.fifteenDaysPopUp = $ionicPopup.show({
										template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorSymbol.svg"></div><div class="button_fund font-dark-grey" style="font-size: 16px !important;font-family: Roboto-medium !important;padding-left: 20px;padding-right: 20px;" translate="APP_FIFTEEN_DAYS"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="TRY_FIFTEEN_DAYS"></div>',
										title: '',
										cssClass: 'bhim-alert-popup',
										scope: $scope,
										buttons: [{
											text: 'OK',
											type: 'button-positive',
											onTap: function (e) {

												$state.go('menu.newToSbiLanding');
											}
										}]
									});
								}


								//Email does not match as per record
								if (response.statusCode == '04') {
									enterEmailOTPNRIAOVm.emailNotMatch = $ionicPopup.show({

										title: '',
										cssClass: 'nri-popup border-radius-none	yono-kcc-popup1',
										templateUrl: 'pages/accountOpening/accountOpeningNRI/emailNotMatchPopup.html',
										scope: $scope
									});
								}
							}

						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					},
					function (error) {
						utilityService.accessRestricted = "";
						utilityService.hideSpinner();
						if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
							return;
						}
						if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
							enterEmailOTPNRIAOVm.aoAuthChallengeHandler.cancel();
						}
						utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
					});
			}

		}




		enterEmailOTPNRIAOVm.closeEmailNotMatchPopup = function () {
			enterEmailOTPNRIAOVm.emailNotMatch.close();
			enterEmailOTPNRIAOVm.goBacktoPrevious();
		}



		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function () {
			initPage();
		});

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			enterEmailOTPNRIAOVm.otpvalue = "";
			enterEmailOTPNRIAOVm.emailOtpvalue = "";
		});
		return this;
	}
]);
