'use strict';

angularApp.controller('fatcaDeclarationNRIController', ["$state",
    "$scope",
    "$ionicHistory",
    "utilityService",
    "$ionicScrollDelegate",
    "NRIAOService",
    function ($state,
        $scope,
        $ionicHistory,
        utilityService,
        $ionicScrollDelegate,
        NRIAOService) {

        var fatcaDeclarationNRIVm = this;
        fatcaDeclarationNRIVm.disableNext = true;



        function initPage() {
            if (NRIAOService.resumeApplication) {
                fatcaDeclarationNRIVm.disableNext = false;
                document.getElementById('SUBMIT_OTP_PAN_PAGE').removeAttribute("disabled");
            }
        }
        fatcaDeclarationNRIVm.checkScrollOnLoad = function () {
            var tc = document.getElementById("fatcaId").offsetHeight;
            var tcContent = document.getElementById("fatcaContent").offsetHeight;
            if (tcContent <= tc) {
                fatcaDeclarationNRIVm.disableNext = false;
                document.getElementById('SUBMIT_OTP_PAN_PAGE').removeAttribute("disabled");
            }
        }
        fatcaDeclarationNRIVm.checkScroll = function (event) {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (maxTop !== 0) {
                if (currentTop >= maxTop) {
                    fatcaDeclarationNRIVm.disableNext = false;
                    document.getElementById('SUBMIT_OTP_PAN_PAGE').removeAttribute("disabled");
                }
            }
        }
        fatcaDeclarationNRIVm.goBack = function () {
            if (NRIAOService.resumeApplication) {
                $state.go("menu.personalPanDetailsPage");
            } else {
                $ionicHistory.goBack();
            }
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function (ev) {
            if (ev.targetScope !== $scope)
                return;
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {

            var fatcarequest = {
                "id": NRIAOService.countryCode + NRIAOService.mobile,
                "wcmContentType": "fatcaDeclartaionResponse"
            }

            NRIAOService.getWcmData(fatcarequest).then(function (fatcaResponse) {
                if (fatcaResponse.responseCode == '0000') {
                    fatcaDeclarationNRIVm.fatcaData = fatcaResponse.data;

                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            })
        });
        fatcaDeclarationNRIVm.gotoAdditionalPersonalDetails = function () {
            var requestSaveFatca = {
                "id": NRIAOService.countryCode + NRIAOService.mobile,

                "payload": {

                    "lastSavedState": "FATCA_CNF"
                },
                "requestNo": NRIAOService.requestNo

            }

            NRIAOService.saveFatcaApplication(requestSaveFatca).then(function (response) {
                if (response.responseCode == '0000') {
                    if (response.data == NRIAOService.requestNo) {
                        $state.go('menu.additionalPersonalDetailsNRI');
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        return this;
    }
]);
