'use strict';

angularApp.controller('gncHomeBranchSelectionNRIController',
    ["$state",
        "$scope",
        "utilityService",
        "$ionicHistory",
        "NRIAOService",
        function (
            $state,
            $scope,
            utilityService,
            $ionicHistory,
            NRIAOService) {
            var gncHomeBranchSelectionNRIVm = this;
            gncHomeBranchSelectionNRIVm.bankListLocality = [];
            gncHomeBranchSelectionNRIVm.areaName = "";

            $scope.$on('$ionicView.loaded', function () {
                gncHomeBranchSelectionNRIVm.supportNumberOne = NRIAOService.supportNumberOne;
                gncHomeBranchSelectionNRIVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                gncHomeBranchSelectionNRIVm.supportNumberThree = NRIAOService.supportNumberThree;


            });

            gncHomeBranchSelectionNRIVm.search = function () {
                if (!utilityService.isUndefined(gncHomeBranchSelectionNRIVm.areaName)) {
                    gncHomeBranchSelectionNRIVm.loadBranchesLocality();
                } else {
                    gncHomeBranchSelectionNRIVm.bankListLocality = [];
                    gncHomeBranchSelectionNRIVm.disableNext = true;
                }
            }
            gncHomeBranchSelectionNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.taxationDetailsNRI");
                } else {
                    $ionicHistory.goBack();
                }
            }
          

            gncHomeBranchSelectionNRIVm.loadBranchesLocality = function () {
                gncHomeBranchSelectionNRIVm.hideOptions = false;
                gncHomeBranchSelectionNRIVm.bankListLocality.length = 0;
                var params = {
                    "locality": gncHomeBranchSelectionNRIVm.areaName
                }
                NRIAOService.getBranchDetail(params).then(function (response) {
                    if (response.responseCode == '0000') {
                        gncHomeBranchSelectionNRIVm.bankListLocalityfinal = response.data.branches;
                        for (var i = 0; i < gncHomeBranchSelectionNRIVm.bankListLocalityfinal.length; i++) {
                            if ((gncHomeBranchSelectionNRIVm.bankListLocalityfinal[i].branchName.toUpperCase()).includes(gncHomeBranchSelectionNRIVm.areaName.toUpperCase()) || ((gncHomeBranchSelectionNRIVm.bankListLocalityfinal[i].id).toLowerCase() == (params.locality).toLowerCase())) {
                                gncHomeBranchSelectionNRIVm.bankListLocality.push(gncHomeBranchSelectionNRIVm.bankListLocalityfinal[i]);
                            }
                        }
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                })
            }

            gncHomeBranchSelectionNRIVm.isNotNullOrUndefined = function (varNull) {
                return (varNull != null && varNull != undefined && varNull != "");
            }
            
               
                
            

            gncHomeBranchSelectionNRIVm.navigatePage = function (param) {
                gncHomeBranchSelectionNRIVm.homeBranchCode = param.id;
                gncHomeBranchSelectionNRIVm.homeBranchName = param.branchName;
            }

            gncHomeBranchSelectionNRIVm.submitNext= function(){
                var params = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "requestNo": NRIAOService.requestNo,
                    "homeBranchCode": gncHomeBranchSelectionNRIVm.homeBranchCode,
                    "homeBranchName": gncHomeBranchSelectionNRIVm.homeBranchName,
                    "review": false,
                }


                NRIAOService.saveSelectedBranch(params).then(function (response) {
                    if (response.responseCode == '0000') {
                        $state.go("menu.nriReviewPage");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                })
            }
        }
    ]);