'use strict';
angularApp.controller('guardianDetailsNRIController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",

        function ($state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService) {
            var guardianDetailsNRIVm = this;
            $scope.$on('$ionicView.beforeEnter', function () {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
              
                guardianDetailsNRIVm.guardianCountrySelType = NRIAOService.countryMaster;
                guardianDetailsNRIVm.stateMaster = NRIAOService.stateMasterdata;
                guardianDetailsNRIVm.lessthanEighteen = false;
                guardianDetailsNRIVm.lessthanNinetynine = false;
                guardianDetailsNRIVm.initPage();
            });
           guardianDetailsNRIVm.initPage = function () {
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    guardianDetailsNRIVm.guardianFName = NRIAOService.resumeNRIresponse.nomineeDetail.guardianName;
                    guardianDetailsNRIVm.guardianAgeValue = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAge;
                    guardianDetailsNRIVm.sameAddressGuardian = NRIAOService.resumeNRIresponse.nomineeDetail.sameAddressGuardian;
                    if (!guardianDetailsNRIVm.sameAddressGuardian) {
                        guardianDetailsNRIVm.nomineeAddr = 'N';
                        guardianDetailsNRIVm.nomineeAddr1 = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.addressLine1;
                        guardianDetailsNRIVm.nomineeAddr2 = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.addressLine2;
                        guardianDetailsNRIVm.guardiancity = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.city;
                        guardianDetailsNRIVm.nomineestate = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.state;
                        guardianDetailsNRIVm.nomineePinCode = NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.pincode;
                        guardianDetailsNRIVm.countrySel = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.nomineeDetail.guardianAddress.country);
                    } else {
                        guardianDetailsNRIVm.nomineeAddr = 'C';
                        guardianDetailsNRIVm.nomineeAddr1 = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine1;
                        guardianDetailsNRIVm.guardiancity = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.city;
                        guardianDetailsNRIVm.nomineestate = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.state;
                        guardianDetailsNRIVm.nomineePinCode = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.pincode;
                        guardianDetailsNRIVm.countrySel = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.country);
                    }
                }
            }
            guardianDetailsNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go('menu.nriNominationDetails');
                } else {
                    $ionicHistory.goBack();
                }
            }


            guardianDetailsNRIVm.checkAge = function (age) {
                if (age < 18) {
                    guardianDetailsNRIVm.lessthanEighteen = true;
                }
                else {
                    guardianDetailsNRIVm.lessthanEighteen = false;
                }
                if (age > 99) {
                    guardianDetailsNRIVm.lessthanNinetynine = true;
                }
                else {
                    guardianDetailsNRIVm.lessthanNinetynine = false;
                }

            }


            guardianDetailsNRIVm.addressSelect = function (subType) {
                if (NRIAOService.resumeApplication && NRIAOService.resumeNRIresponse.nomineeDetail != null) {
                    if (subType == 'SAME_AS_NOMINEE') {
                        guardianDetailsNRIVm.sameAddressGuardian = true;
                        guardianDetailsNRIVm.nomineeAddr = 'C';
                        guardianDetailsNRIVm.addressNotSelected = false;
                        guardianDetailsNRIVm.addressReadOnly = true;
                        var country = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.country);
                        guardianDetailsNRIVm.countrySel = country.name;
                        guardianDetailsNRIVm.nomineeAddr1 = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine1;
                        guardianDetailsNRIVm.nomineeAddr2 = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine2;
                        guardianDetailsNRIVm.nomineestate = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.state;
                        guardianDetailsNRIVm.nomineePinCode = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.pincode;
                        guardianDetailsNRIVm.guardiancity = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.city;
                    } else if (subType == 'NEW_ADDR') {
                        guardianDetailsNRIVm.sameAddressGuardian = false;
                        guardianDetailsNRIVm.nomineeAddr = 'N';
                        guardianDetailsNRIVm.addressNotSelected = false;
                        guardianDetailsNRIVm.addressReadOnly = false;
                        guardianDetailsNRIVm.nomineeAddr1 = '';
                        guardianDetailsNRIVm.nomineeAddr2 = '';
                        guardianDetailsNRIVm.guardiancity = '';
                        guardianDetailsNRIVm.nomineestate = '';
                        guardianDetailsNRIVm.nomineePinCode = '';
                        guardianDetailsNRIVm.countrySel = '';
                    }
                } else {
                    if (subType == 'SAME_AS_NOMINEE') {
                        guardianDetailsNRIVm.sameAddressGuardian = true;
                        guardianDetailsNRIVm.nomineeAddr = 'C';
                        guardianDetailsNRIVm.addressNotSelected = false;
                        guardianDetailsNRIVm.addressReadOnly = true;

                        var country = NRIAOService.getCountryName(NRIAOService.countSel.code)
                        guardianDetailsNRIVm.countrySel = country.name;
                        guardianDetailsNRIVm.nomineeAddr1 = NRIAOService.nomineeAddr1;
                        guardianDetailsNRIVm.guardiancity = NRIAOService.nomineeAddr2;
                        guardianDetailsNRIVm.nomineestate = NRIAOService.nomineestate;
                        guardianDetailsNRIVm.nomineePinCode = NRIAOService.nomineePinCode;
                    } else if (subType == 'NEW_ADDR') {
                        guardianDetailsNRIVm.nomineeAddr = 'N';
                        guardianDetailsNRIVm.sameAddressGuardian = false;
                        guardianDetailsNRIVm.addressNotSelected = false;
                        guardianDetailsNRIVm.addressReadOnly = false;
                        guardianDetailsNRIVm.nomineeAddr1 = '';
                        guardianDetailsNRIVm.nomineeAddr2 = '';
                        guardianDetailsNRIVm.guardiancity = '';
                        guardianDetailsNRIVm.nomineestate = '';
                        guardianDetailsNRIVm.nomineePinCode = '';
                        guardianDetailsNRIVm.countrySel = '';
                    }
                }

            }

            guardianDetailsNRIVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go("menu.nriAccountServicePage");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            guardianDetailsNRIVm.submitguardianDetails = function () {
                if (guardianDetailsNRIVm.guardianDetailsForm.guardianFName.$invalid && guardianDetailsNRIVm.guardianDetailsForm.guardianAge.$invalid
                    && guardianDetailsNRIVm.guardianDetailsForm.nomineeAddr1.$invalid && guardianDetailsNRIVm.guardianDetailsForm.guardiancity.$invalid
                    && guardianDetailsNRIVm.guardianDetailsForm.nomineestate.$invalid && guardianDetailsNRIVm.guardianDetailsForm.nomineePinCode.$invalid
                    && guardianDetailsNRIVm.guardianDetailsForm.countrySel.$invalid) {
                    guardianDetailsNRIVm.detailsinComplete = true; 
                }
                else {
                    if (guardianDetailsNRIVm.guardianFName != undefined && guardianDetailsNRIVm.guardianFName != '' && guardianDetailsNRIVm.guardianFName != null &&
                        guardianDetailsNRIVm.guardianAgeValue != undefined && guardianDetailsNRIVm.guardianAgeValue != '' && guardianDetailsNRIVm.guardianAgeValue != null &&
                        guardianDetailsNRIVm.nomineeAddr1 != undefined && guardianDetailsNRIVm.nomineeAddr1 != '' && guardianDetailsNRIVm.nomineeAddr1 != null &&
                        guardianDetailsNRIVm.guardiancity != undefined && guardianDetailsNRIVm.guardiancity != '' && guardianDetailsNRIVm.guardiancity != null &&
                        guardianDetailsNRIVm.nomineePinCode != undefined && guardianDetailsNRIVm.nomineePinCode != '' && guardianDetailsNRIVm.nomineePinCode != null &&
                        guardianDetailsNRIVm.nomineestate != undefined && guardianDetailsNRIVm.nomineestate != '' && guardianDetailsNRIVm.nomineestate != null &&
                        guardianDetailsNRIVm.countrySel != undefined && guardianDetailsNRIVm.countrySel != "" && guardianDetailsNRIVm.countrySel != null) {

                        if (!guardianDetailsNRIVm.lessthanNinetynine && !guardianDetailsNRIVm.lessthanEighteen) {
                            guardianDetailsNRIVm.detailsComplete = true;
                            guardianDetailsNRIVm.detailsinComplete = false;

                            if (guardianDetailsNRIVm.sameAddressGuardian) {
                                var payload = {
                                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                                    "requestNo": NRIAOService.requestNo,
                                    "nomineeRequired": NRIAOService.nomineeTypeSel,

                                    "review": NRIAOService.review,
                                    "payload": {
                                        "name": NRIAOService.nomineeName,
                                        "relationship": NRIAOService.relSel,
                                        "otherRelationship": NRIAOService.nomineeOther ? NRIAOService.nomineeOther : null,
                                        "dob": NRIAOService.dob,
                                        "nomineeAddress": {
                                            "addressLine1": NRIAOService.nomineeAddr1 ? NRIAOService.nomineeAddr1 : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine1,
                                            "city": NRIAOService.nomineeAddr2 ? NRIAOService.nomineeAddr2 : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.city,
                                            "state": NRIAOService.nomineestate ? NRIAOService.nomineestate : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.state,
                                            "pincode": NRIAOService.nomineePinCode ? NRIAOService.nomineePinCode : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.pincode,
                                            "country": NRIAOService.countSel.code ? NRIAOService.countSel.code : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.country
                                        }, 
                                        "sameAddressGuardian": guardianDetailsNRIVm.sameAddressGuardian,
                                        "guardianName": guardianDetailsNRIVm.guardianFName,
                                        "guardianAge": guardianDetailsNRIVm.guardianAgeValue,
                                        "guardianAddress": null
                                    }
                                }

                            } else {
                                var payload = {
                                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                                    "requestNo": NRIAOService.requestNo,
                                    "nomineeRequired": NRIAOService.nomineeTypeSel,

                                    "review": NRIAOService.review,
                                    "payload": {
                                        "name": NRIAOService.nomineeName,
                                        "relationship": NRIAOService.relSel,
                                        "otherRelationship": NRIAOService.nomineeOther ? NRIAOService.nomineeOther : null,
                                        "dob": NRIAOService.dob,
                                        "nomineeAddress": {
                                            "addressLine1": NRIAOService.nomineeAddr1 ? NRIAOService.nomineeAddr1 : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine1,
                                            "city": NRIAOService.nomineeAddr2 ? NRIAOService.nomineeAddr2 : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.city,
                                            "state": NRIAOService.nomineestate ? NRIAOService.nomineestate : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.state,
                                            "pincode": NRIAOService.nomineePinCode ? NRIAOService.nomineePinCode : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.pincode,
                                            "country": NRIAOService.countSel.code ? NRIAOService.countSel.code : NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.country

                                        }, 
                                        "sameAddressGuardian": guardianDetailsNRIVm.sameAddressGuardian,
                                        "guardianName": guardianDetailsNRIVm.guardianFName,
                                        "guardianAge": guardianDetailsNRIVm.guardianAgeValue,
                                        "guardianAddress": {
                                            "addressLine1": guardianDetailsNRIVm.nomineeAddr1,
                                            "addressLine2": guardianDetailsNRIVm.nomineeAddr2,
                                            "city": guardianDetailsNRIVm.guardiancity,
                                            "state": guardianDetailsNRIVm.nomineestate,
                                            "pincode": guardianDetailsNRIVm.nomineePinCode,
                                            "country": guardianDetailsNRIVm.countrySel.code
                                        }
                                    }
                                }
                            }


                            NRIAOService.saveNomineeApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;

                                    guardianDetailsNRIVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });

                        }
                        else {
                            utilityService.showBhimUpiAlert("", "Guardian age should be between 18 to 99", "", "", "");
                        }


                    }
                    else {
                        guardianDetailsNRIVm.detailsinComplete = true; 
                    }
                }
            }

        }
    ])

