'use strict';

angularApp.controller('nriAccountServiceController',
    ["$scope",
        "$state",
        "utilityService",
        "NRIAOService",
        "$ionicHistory",
        function (
            $scope,
            $state,
            utilityService,
            NRIAOService,
            $ionicHistory) {
            var nriAccountServiceVm = this;
            nriAccountServiceVm.nreSelected = false;
            nriAccountServiceVm.nroSelected = false;
            nriAccountServiceVm.nreCard = true;

            $scope.$on('$ionicView.beforeEnter', function () {
                nriAccountServiceVm.initPage();
            });
            nriAccountServiceVm.scrollUP = function(view){
                    document.getElementById(view).scrollIntoView(); 
            }
            nriAccountServiceVm.initPage = function () {

                nriAccountServiceVm.supportNumberOne = NRIAOService.supportNumberOne;
                nriAccountServiceVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                nriAccountServiceVm.supportNumberThree = NRIAOService.supportNumberThree;

                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    if (NRIAOService.resumeNRIresponse["nreAccountDetail"]) {
                        nriAccountServiceVm.accountTypeSelNre = 'NRE';
                        if (NRIAOService.resumeNRIresponse.nreAccountDetail.accountType == "SAVINGS") {
                            nriAccountServiceVm.nreAccTypeSel = 'Savings';
                        } else {
                            nriAccountServiceVm.nreAccTypeSel = 'Current';
                        }
                        nriAccountServiceVm.nreSmsAlertTypeSel = NRIAOService.resumeNRIresponse.nreAccountDetail.smsAlertsFlag
                        nriAccountServiceVm.nreChequeBookTypeSel = NRIAOService.resumeNRIresponse.nreAccountDetail.chequebookFlag
                        nriAccountServiceVm.nreDebitCardTypeSel = NRIAOService.resumeNRIresponse.nreAccountDetail.debitCardFlag;
                        if (nriAccountServiceVm.nreDebitCardTypeSel) {
                            nriAccountServiceVm.nreNameoncard = NRIAOService.resumeNRIresponse.nreAccountDetail.nameOnCard
                        }

                    }
                    if (NRIAOService.resumeNRIresponse["nroAccountDetail"]) {
                        nriAccountServiceVm.accountTypeSelNro = 'NRO';
                        if (NRIAOService.resumeNRIresponse.nroAccountDetail.accountType == "SAVINGS") {
                            nriAccountServiceVm.nroAccTypeSel = 'Savings';
                        } else {
                            nriAccountServiceVm.nroAccTypeSel = 'Current';
                        }
                        nriAccountServiceVm.nroSmsAlertTypeSel = NRIAOService.resumeNRIresponse.nroAccountDetail.smsAlertsFlag
                        nriAccountServiceVm.nroChequeBookTypeSel = NRIAOService.resumeNRIresponse.nroAccountDetail.chequebookFlag
                        nriAccountServiceVm.nroDebitCardTypeSel = NRIAOService.resumeNRIresponse.nroAccountDetail.debitCardFlag
                        if (nriAccountServiceVm.nroDebitCardTypeSel) {
                            nriAccountServiceVm.nroNameoncard = NRIAOService.resumeNRIresponse.nroAccountDetail.nameOnCard
                        }
                    }
                } else {
                    nriAccountServiceVm.accountTypeSelNre = NRIAOService.accountTypeSelNre;
                    nriAccountServiceVm.accountTypeSelNro = NRIAOService.accountTypeSelNro;
                    nriAccountServiceVm.nreAccTypeSel = NRIAOService.nreAccTypeSel;
                    nriAccountServiceVm.nroAccTypeSel = NRIAOService.nroAccTypeSel;

                    if (nriAccountServiceVm.nreAccTypeSel) {
                        if (nriAccountServiceVm.nreAccTypeSel == 'SAVINGS') {
                            nriAccountServiceVm.nreAccTypeSel = 'Savings';
                        }
                        if (nriAccountServiceVm.nreAccTypeSel == 'CURRENT') {
                            nriAccountServiceVm.nreAccTypeSel = 'Current';
                        }
                    }

                    if (nriAccountServiceVm.nroAccTypeSel) {
                        if (nriAccountServiceVm.nroAccTypeSel == 'SAVINGS') {
                            nriAccountServiceVm.nroAccTypeSel = 'Savings';
                        }
                        if (nriAccountServiceVm.nroAccTypeSel == 'CURRENT') {
                            nriAccountServiceVm.nroAccTypeSel = 'Current';
                        }
                    }

                }

            }
            nriAccountServiceVm.goBack = function () {
                if (NRIAOService.resumeApplication) {


                    if (NRIAOService.resumeNRIresponse.nomineeRequired) {
                      
                        if(NRIAOService.resumeNRIresponse.nomineeDetail.guardianName){
                            $state.go('menu.guardianDetailsNRI');
        
                        } else {
                            $state.go('menu.nriNominationDetails');
                        }
                    } else {
                        $state.go('menu.nriNominationDetails');
                    }

                   
                } else {
                    $ionicHistory.goBack();
                }
            }
            nriAccountServiceVm.toggleContent = function (selectedVal) {
                if (selectedVal == 'NRO_SERVICE') {
                    nriAccountServiceVm.nroCard = true;
                    nriAccountServiceVm.nreCard = false;
                } else if (selectedVal == 'NRE_SERVICE') {
                    nriAccountServiceVm.nreCard = true;
                    nriAccountServiceVm.nroCard = false;
                } else {
                    nriAccountServiceVm.nreCard = false;
                    nriAccountServiceVm.nroCard = false;
                }
            }
            nriAccountServiceVm.nreAccountSelected = function (selectval, type) {
                if (type == 'sms_type') {
                    nriAccountServiceVm.nreSmsAlertTypeSel = selectval
                } else if (type == 'cheque_book') {
                    nriAccountServiceVm.nreChequeBookTypeSel = selectval
                } else if (type == 'Debit_card') {
                    nriAccountServiceVm.nreDebitCardTypeSel = selectval
                    if(!selectval){
                        nriAccountServiceVm.nreNameoncard= null;
                    }
                }

            }
            nriAccountServiceVm.nroAccountSelected = function (selectval, type) {
                if (type == 'sms_type') {
                    nriAccountServiceVm.nroSmsAlertTypeSel = selectval
                } else if (type == 'cheque_book') {
                    nriAccountServiceVm.nroChequeBookTypeSel = selectval
                } else if (type == 'Debit_card') {
                    nriAccountServiceVm.nroDebitCardTypeSel = selectval
                    if(!selectval){
                        nriAccountServiceVm.nroNameoncard = null;
                    }
                }

            }
            nriAccountServiceVm.verifyNreAccountDetail = function () {
                if (nriAccountServiceVm.nreSmsAlertTypeSel == undefined || nriAccountServiceVm.nreSmsAlertTypeSel === "" || nriAccountServiceVm.nreSmsAlertTypeSel == null
                    || nriAccountServiceVm.nreChequeBookTypeSel == undefined || nriAccountServiceVm.nreChequeBookTypeSel === "" || nriAccountServiceVm.nreChequeBookTypeSel == null
                    || nriAccountServiceVm.nreDebitCardTypeSel == undefined || nriAccountServiceVm.nreDebitCardTypeSel === "" || nriAccountServiceVm.nreDebitCardTypeSel == null) {
                    nriAccountServiceVm.nreAccountError = true;
                    nriAccountServiceVm.showNreSmsAlertErr = true;
                } else {
                    if (!nriAccountServiceVm.nreDebitCardTypeSel) {
                        nriAccountServiceVm.nreAccountError = false;
                        nriAccountServiceVm.showNreSmsAlertErr = false;
                    } else if (nriAccountServiceVm.nreDebitCardTypeSel) {
                        if (nriAccountServiceVm.nreNameoncard != undefined && nriAccountServiceVm.nreNameoncard != "" && nriAccountServiceVm.nreNameoncard != null) {
                            nriAccountServiceVm.nreAccountError = false;
                            nriAccountServiceVm.showNreSmsAlertErr = false;
                        }
                        else {
                            nriAccountServiceVm.nreAccountError = true;
                            nriAccountServiceVm.showNreSmsAlertErr = false;
                        }

                    }
                }
                nriAccountServiceVm.verifyNroaccountdetail = function () {
                    if (nriAccountServiceVm.nroSmsAlertTypeSel == undefined || nriAccountServiceVm.nroSmsAlertTypeSel === "" || nriAccountServiceVm.nroSmsAlertTypeSel == null
                        || nriAccountServiceVm.nroChequeBookTypeSel == undefined || nriAccountServiceVm.nroChequeBookTypeSel === "" || nriAccountServiceVm.nroChequeBookTypeSel == null
                        || nriAccountServiceVm.nroDebitCardTypeSel == undefined || nriAccountServiceVm.nroDebitCardTypeSel === "" || nriAccountServiceVm.nroDebitCardTypeSel == null) {
                        nriAccountServiceVm.nroAccountError = true;
                        nriAccountServiceVm.showNroSmsAlertErr = true;
                    }
                    else {
                        if (!nriAccountServiceVm.nroDebitCardTypeSel) {
                            nriAccountServiceVm.nroAccountError = false;
                            nriAccountServiceVm.showNroSmsAlertErr = false;
                        }
                        else if (nriAccountServiceVm.nroDebitCardTypeSel) {
                            if (nriAccountServiceVm.nroNameoncard != undefined && nriAccountServiceVm.nroNameoncard != "" && nriAccountServiceVm.nroNameoncard != null) {
                                nriAccountServiceVm.nroAccountError = false;
                                nriAccountServiceVm.showNroSmsAlertErr = false;
                            }
                            else {
                                nriAccountServiceVm.nroAccountError = true;
                                nriAccountServiceVm.showNroSmsAlertErr = false;
                            }
                        }

                    }
                }
            }
            nriAccountServiceVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go("menu.taxationDetailsNRI");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            nriAccountServiceVm.gotonextpage = function () {


                if (nriAccountServiceVm.accountTypeSelNre != "") {
                    nriAccountServiceVm.verifyNreAccountDetail();

                    if (nriAccountServiceVm.nreAccountError) {
                        nriAccountServiceVm.nreNotSelected = true;
                        nriAccountServiceVm.nreSelected = false;
                    }
                    else {
                        nriAccountServiceVm.nreNotSelected = false;
                        nriAccountServiceVm.nreSelected = true;
                    }


                }
                if (nriAccountServiceVm.accountTypeSelNro != "") {
                    nriAccountServiceVm.verifyNroaccountdetail();
                    if (nriAccountServiceVm.nroAccountError) {
                        nriAccountServiceVm.nroNotSelected = true;
                        nriAccountServiceVm.nroSelected = false;
                    }
                    else {
                        nriAccountServiceVm.nroNotSelected = false;
                        nriAccountServiceVm.nroSelected = true;
                    }
                }

                if (nriAccountServiceVm.nreSelected && !nriAccountServiceVm.nroSelected) {
                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "review": NRIAOService.review,
                        "payload": {
                            "nreAccountDetail": {
                                "accountType": nriAccountServiceVm.nreAccTypeSel.toUpperCase(),
                                "smsAlertsFlag": nriAccountServiceVm.nreSmsAlertTypeSel,
                                "chequebookFlag": nriAccountServiceVm.nreChequeBookTypeSel,
                                "debitCardFlag": nriAccountServiceVm.nreDebitCardTypeSel,
                                "nameOnCard": nriAccountServiceVm.nreNameoncard ? nriAccountServiceVm.nreNameoncard : null
                            },
                            "nroAccountDetail": null,
                        }

                    }
                    NRIAOService.saveAccountServiceApplication(payload).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.requestNo = response.data;
                            nriAccountServiceVm.getUpdatedData()
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }
                if (!nriAccountServiceVm.nreSelected && nriAccountServiceVm.nroSelected) {

                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "review": NRIAOService.review,
                        "payload": {
                            "nroAccountDetail": {
                                "accountType": nriAccountServiceVm.nroAccTypeSel.toUpperCase(),
                                "smsAlertsFlag": nriAccountServiceVm.nroSmsAlertTypeSel,
                                "chequebookFlag": nriAccountServiceVm.nroChequeBookTypeSel,
                                "debitCardFlag": nriAccountServiceVm.nroDebitCardTypeSel,
                                "nameOnCard": nriAccountServiceVm.nroNameoncard ? nriAccountServiceVm.nroNameoncard : null
                            },
                            "nreAccountDetail": null,
                        }

                    }
                    NRIAOService.saveAccountServiceApplication(payload).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.requestNo = response.data;
                            nriAccountServiceVm.getUpdatedData()
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }
                if (nriAccountServiceVm.nreSelected && nriAccountServiceVm.nroSelected) {

                    var payload = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "requestNo": NRIAOService.requestNo,
                        "review": NRIAOService.review,
                        "payload": {
                            "nroAccountDetail": {
                                "accountType": nriAccountServiceVm.nroAccTypeSel.toUpperCase(),
                                "smsAlertsFlag": nriAccountServiceVm.nroSmsAlertTypeSel,
                                "chequebookFlag": nriAccountServiceVm.nroChequeBookTypeSel,
                                "debitCardFlag": nriAccountServiceVm.nroDebitCardTypeSel,
                                "nameOnCard": nriAccountServiceVm.nroNameoncard ? nriAccountServiceVm.nroNameoncard : null
                            },
                            "nreAccountDetail": {
                                "accountType": nriAccountServiceVm.nreAccTypeSel.toUpperCase(),
                                "smsAlertsFlag": nriAccountServiceVm.nreSmsAlertTypeSel,
                                "chequebookFlag": nriAccountServiceVm.nreChequeBookTypeSel,
                                "debitCardFlag": nriAccountServiceVm.nreDebitCardTypeSel,
                                "nameOnCard": nriAccountServiceVm.nreNameoncard ? nriAccountServiceVm.nreNameoncard : null
                            }
                        }

                    }

                    NRIAOService.saveAccountServiceApplication(payload).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.requestNo = response.data;
                            nriAccountServiceVm.getUpdatedData();
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }

            }
        }
    ]);