'use strict';

angularApp.controller('nriAdditionalDetailsController',
    ["$scope",
        "$state",
        "$ionicHistory",
        "$translate",
        "NRIAOService",
        "utilityService",
        function (
            $scope,
            $state,
            $ionicHistory,
            $translate,
            NRIAOService,
            utilityService) {
            var nriAdditionalDetailsVm = this;
            nriAdditionalDetailsVm.stdNumberMaxLength = 11;
            nriAdditionalDetailsVm.telNumberMaxLength = 11;
            nriAdditionalDetailsVm.additionalDetailsNoError = false;
            nriAdditionalDetailsVm.countrySubType = NRIAOService.countryMaster;
            nriAdditionalDetailsVm.addlDetailsCard = true;
            nriAdditionalDetailsVm.contactDetailsCard = false;
            nriAdditionalDetailsVm.annualIncome = null;
            nriAdditionalDetailsVm.assetIncome = null;
            nriAdditionalDetailsVm.annualIncomeErr = false;
            nriAdditionalDetailsVm.assetIncomeErr = false;
            nriAdditionalDetailsVm.statusProofErr = false;
            nriAdditionalDetailsVm.countryErr = false;
            nriAdditionalDetailsVm.destinationErr = false;
            nriAdditionalDetailsVm.detailsComplete = false;
            nriAdditionalDetailsVm.detailsinComplete = false;
            nriAdditionalDetailsVm.contactDetailsComplete = false;
            nriAdditionalDetailsVm.contactDetailsIncomplete = false;
            nriAdditionalDetailsVm.residenceCodeErr = false;    
            nriAdditionalDetailsVm.residenceTelNumErr = false;
            nriAdditionalDetailsVm.officeCodeErr = false;
            nriAdditionalDetailsVm.offTelErr = false;
            nriAdditionalDetailsVm.maxAllowedAmount = 100000000000;
            nriAdditionalDetailsVm.statusProofSubType = NRIAOService.keyValueMap.StatusProofMaster;
            nriAdditionalDetailsVm.proofOfStatus = NRIAOService.applicantStatus;
            $scope.$on('$ionicView.beforeEnter', function () {
                nriAdditionalDetailsVm.getUpdatedResumeData();
            });
            nriAdditionalDetailsVm.getUpdatedResumeData = function(){
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.resumeNRIresponse = response.data;
                            nriAdditionalDetailsVm.initPage();
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                });

            }
            nriAdditionalDetailsVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    if (NRIAOService.resumeNRIresponse.sameAddress) {
                        $state.go("menu.nriCurrentAddressDetailPage");
                    } else {
                        $state.go("menu.nriPermanentAddressDetails");
                    }
                } else {
                    $ionicHistory.goBack();
                }
            }

            $translate(['MANDATORY_ERROR', 'INCOME_RANGE_ERR']).then(function (translations) {
                nriAdditionalDetailsVm.mandatoryError = translations['MANDATORY_ERROR'];
                nriAdditionalDetailsVm.incomeRangeError = translations['INCOME_RANGE_ERR'];
            });

            nriAdditionalDetailsVm.initPage = function () {

                nriAdditionalDetailsVm.supportNumberOne = NRIAOService.supportNumberOne;
                nriAdditionalDetailsVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                nriAdditionalDetailsVm.supportNumberThree = NRIAOService.supportNumberThree;

                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    if (NRIAOService.resumeNRIresponse.annualIncome == "" || NRIAOService.resumeNRIresponse.annualIncome == null || NRIAOService.resumeNRIresponse.annualIncome == undefined) {

                        nriAdditionalDetailsVm.annualIncome = null;

                    }

                    else {

                        nriAdditionalDetailsVm.annualIncome = Number(NRIAOService.resumeNRIresponse.annualIncome);

                    }
                    if (NRIAOService.resumeNRIresponse.assets == "" || NRIAOService.resumeNRIresponse.assets == null || NRIAOService.resumeNRIresponse.assets == undefined) {

                        nriAdditionalDetailsVm.assetIncome = null;

                    }

                    else {
                        nriAdditionalDetailsVm.assetIncome = Number(NRIAOService.resumeNRIresponse.assets);

                    }

                    nriAdditionalDetailsVm.statusProofSel = NRIAOService.getResideAddressType(NRIAOService.resumeNRIresponse.statusProof)
                    nriAdditionalDetailsVm.countrySel = NRIAOService.resumeNRIresponse.currentResCountry
                    nriAdditionalDetailsVm.designation = NRIAOService.resumeNRIresponse.designation
                    nriAdditionalDetailsVm.residenceCode = NRIAOService.resumeNRIresponse.resIsdCode;
                    nriAdditionalDetailsVm.residenceTelNum = NRIAOService.resumeNRIresponse.resNum;
                    nriAdditionalDetailsVm.officeCode = NRIAOService.resumeNRIresponse.officeIsdCode;
                    nriAdditionalDetailsVm.offTel = NRIAOService.resumeNRIresponse.officeNum;

                    var pageTabAddNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(NRIAOService.pageTabAdd);
                    if(pageTabAddNotNull){
                        if(NRIAOService.pageTabAdd == "Contact_Details"){
                            nriAdditionalDetailsVm.toggleContent('Contact_Details');
                        }
                        if(NRIAOService.pageTabAdd == "Additional_Details"){
                            nriAdditionalDetailsVm.toggleContent('Addl_Details');
                        }
                    }
                }

            }

            nriAdditionalDetailsVm.toggleContent = function (selectedVal) {
                if (selectedVal == 'Addl_Details') {
                    nriAdditionalDetailsVm.addlDetailsCard = true;
                    nriAdditionalDetailsVm.contactDetailsCard = false;
                }
                else if (selectedVal == 'Contact_Details') {
                    nriAdditionalDetailsVm.addlDetailsCard = false;
                    nriAdditionalDetailsVm.contactDetailsCard = true;
                    nriAdditionalDetailsVm.validateAdditionalDetails();
                    nriAdditionalDetailsVm.validateContactDetails();

                }
            }

            nriAdditionalDetailsVm.isNotNullOrUndefined = function (varNull) {

                return (varNull != null && varNull != undefined && varNull != "");
            }

            nriAdditionalDetailsVm.validateAdditionalDetails = function () {

                nriAdditionalDetailsVm.annualIncomeNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.annualIncome);
                nriAdditionalDetailsVm.assetIncomeNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.assetIncome);
                nriAdditionalDetailsVm.statusProofSelNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.statusProofSel);
                nriAdditionalDetailsVm.countrySelNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.countrySel);

                if (nriAdditionalDetailsVm.annualIncomeNotNull && nriAdditionalDetailsVm.assetIncomeNotNull && nriAdditionalDetailsVm.statusProofSelNotNull && nriAdditionalDetailsVm.countrySelNotNull) {
                    nriAdditionalDetailsVm.detailsComplete = true;
                    nriAdditionalDetailsVm.detailsinComplete = false;
                }
                else {
                    nriAdditionalDetailsVm.detailsComplete = false;
                    nriAdditionalDetailsVm.detailsinComplete = true;
                }

            }

            nriAdditionalDetailsVm.contactDetailsNotNull = function () {
            nriAdditionalDetailsVm.residenceCodeNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.residenceCode);
            nriAdditionalDetailsVm.residenceTelNumNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.residenceTelNum);
            nriAdditionalDetailsVm.officeCodeNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.officeCode);
            nriAdditionalDetailsVm.offTelNotNull = nriAdditionalDetailsVm.isNotNullOrUndefined(nriAdditionalDetailsVm.offTel);
            }

            nriAdditionalDetailsVm.validateContactDetails = function () {
                nriAdditionalDetailsVm.contactDetailsNotNull();
                if (nriAdditionalDetailsVm.residenceCodeNotNull && nriAdditionalDetailsVm.residenceTelNumNotNull && nriAdditionalDetailsVm.officeCodeNotNull && nriAdditionalDetailsVm.offTelNotNull != null) {
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                }
                else {
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                }

               

            }

            nriAdditionalDetailsVm.validateAnnualIncome = function () {
                if (nriAdditionalDetailsVm.annualIncome > nriAdditionalDetailsVm.maxAllowedAmount) {
                    nriAdditionalDetailsVm.annualIncomeErr = true;
                    nriAdditionalDetailsVm.annualIncomeErrTxt = nriAdditionalDetailsVm.incomeRangeError;
                    return false;
                }
                else {
                    nriAdditionalDetailsVm.annualIncomeErr = false;
                    nriAdditionalDetailsVm.annualIncomeErrTxt = '';
                    return true;
                }
            }

            nriAdditionalDetailsVm.validateAssets = function () {
                if (nriAdditionalDetailsVm.assetIncome > nriAdditionalDetailsVm.maxAllowedAmount) {
                    nriAdditionalDetailsVm.assetIncomeErr = true;
                    nriAdditionalDetailsVm.annualIncomeErrTxt = nriAdditionalDetailsVm.incomeRangeError;
                    return false;

                }
                else {
                    nriAdditionalDetailsVm.assetIncomeErr = false;
                    nriAdditionalDetailsVm.annualIncomeErrTxt = '';
                    return true;
                }
            }
            
            nriAdditionalDetailsVm.validateResidenceCode = function (){
                nriAdditionalDetailsVm.contactDetailsNotNull();
            if(nriAdditionalDetailsVm.residenceCodeNotNull && !nriAdditionalDetailsVm.residenceTelNumNotNull){
                nriAdditionalDetailsVm.residenceTelNumErr = true;
                nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                nriAdditionalDetailsVm.contactDetailsComplete = false;
                nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                return false;
            }
            else if(!nriAdditionalDetailsVm.residenceCodeNotNull && nriAdditionalDetailsVm.residenceTelNumNotNull){
                nriAdditionalDetailsVm.residenceCodeErr = true;
                nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                nriAdditionalDetailsVm.contactDetailsComplete = false;
                nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                return false;
            }
            else if(nriAdditionalDetailsVm.residenceCodeNotNull && nriAdditionalDetailsVm.residenceTelNumNotNull){
                nriAdditionalDetailsVm.residenceTelNumErr = false;
                nriAdditionalDetailsVm.residenceCodeErr = false;
                nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                nriAdditionalDetailsVm.contactDetailsComplete = true;
                nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                return true;
            }
            else if(!nriAdditionalDetailsVm.residenceCodeNotNull && !nriAdditionalDetailsVm.residenceTelNumNotNull){
                nriAdditionalDetailsVm.residenceTelNumErr = false;
                nriAdditionalDetailsVm.residenceCodeErr = false;
                nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                nriAdditionalDetailsVm.contactDetailsComplete = false;
                nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                return true;
            }
            else{
                nriAdditionalDetailsVm.residenceTelNumErr = false;
                nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                nriAdditionalDetailsVm.contactDetailsComplete = true;
                nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                return true;
            }
            }
            nriAdditionalDetailsVm.validateResidenceTelNum = function (){
                nriAdditionalDetailsVm.contactDetailsNotNull();
                if(!nriAdditionalDetailsVm.residenceCodeNotNull && nriAdditionalDetailsVm.residenceTelNumNotNull){
                    nriAdditionalDetailsVm.residenceCodeErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                 else if(nriAdditionalDetailsVm.residenceCodeNotNull && !nriAdditionalDetailsVm.residenceTelNumNotNull){
                    nriAdditionalDetailsVm.residenceTelNumErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                else if(nriAdditionalDetailsVm.residenceCodeNotNull && nriAdditionalDetailsVm.residenceTelNumNotNull){
                    nriAdditionalDetailsVm.residenceTelNumErr = false;
                    nriAdditionalDetailsVm.residenceCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else if(!nriAdditionalDetailsVm.residenceCodeNotNull && !nriAdditionalDetailsVm.residenceTelNumNotNull){
                    nriAdditionalDetailsVm.residenceTelNumErr = false;
                    nriAdditionalDetailsVm.residenceCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else{
                    nriAdditionalDetailsVm.residenceCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
            }
            nriAdditionalDetailsVm.validateOfficeCode = function (){
                nriAdditionalDetailsVm.contactDetailsNotNull();
                if(nriAdditionalDetailsVm.officeCodeNotNull && !nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                else if(!nriAdditionalDetailsVm.officeCodeNotNull && nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.officeCodeErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                else if(nriAdditionalDetailsVm.officeCodeNotNull && nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = false;
                    nriAdditionalDetailsVm.officeCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else if(!nriAdditionalDetailsVm.officeCodeNotNull && !nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = false;
                    nriAdditionalDetailsVm.officeCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else{
                    nriAdditionalDetailsVm.offTelErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
            }
            nriAdditionalDetailsVm.validateOfficeTel = function (){
                nriAdditionalDetailsVm.contactDetailsNotNull();
                if(!nriAdditionalDetailsVm.officeCodeNotNull && nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.officeCodeErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                else if(nriAdditionalDetailsVm.officeCodeNotNull && !nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = true;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt =  nriAdditionalDetailsVm.mandatoryError;
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = true;
                    return false;
                }
                else if(nriAdditionalDetailsVm.officeCodeNotNull && nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = false;
                    nriAdditionalDetailsVm.officeCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else if(!nriAdditionalDetailsVm.officeCodeNotNull && !nriAdditionalDetailsVm.offTelNotNull){
                    nriAdditionalDetailsVm.offTelErr = false;
                    nriAdditionalDetailsVm.officeCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = false;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
                else{
                    nriAdditionalDetailsVm.officeCodeErr = false;
                    nriAdditionalDetailsVm.residenceTelNumErrTxt = '';
                    nriAdditionalDetailsVm.contactDetailsComplete = true;
                    nriAdditionalDetailsVm.contactDetailsIncomplete = false;
                    return true;
                }
            }



            nriAdditionalDetailsVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }


                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go('menu.nriEduPage');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            nriAdditionalDetailsVm.goToNextPage = function () {

                nriAdditionalDetailsVm.validateAnnualIncomeTrue = nriAdditionalDetailsVm.validateAnnualIncome();
                nriAdditionalDetailsVm.validateAssetsTrue = nriAdditionalDetailsVm.validateAssets();

                if (nriAdditionalDetailsVm.additionalDetailsForm.annualIncome.$invalid && nriAdditionalDetailsVm.additionalDetailsForm.assetIncome.$invalid &&
                    nriAdditionalDetailsVm.additionalDetailsForm.psId.$invalid && nriAdditionalDetailsVm.additionalDetailsForm.countryNames.$invalid) {
                    nriAdditionalDetailsVm.detailsinComplete = true;
                    nriAdditionalDetailsVm.toggleContent('Addl_Details');

                } else {
                    nriAdditionalDetailsVm.validateAdditionalDetails();
                    nriAdditionalDetailsVm.validateContactDetails();
                    if (nriAdditionalDetailsVm.validateAnnualIncomeTrue && nriAdditionalDetailsVm.validateAssetsTrue) {
                        var requestCreateApp = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "review": NRIAOService.review,
                            "requestNo": NRIAOService.requestNo,
                            "annualIncome": nriAdditionalDetailsVm.annualIncome,
                            "assets": nriAdditionalDetailsVm.assetIncome,
                            "statusProof": nriAdditionalDetailsVm.statusProofSel.key,
                            "currentResCountry": nriAdditionalDetailsVm.countrySel,
                            "designation": nriAdditionalDetailsVm.designation ? nriAdditionalDetailsVm.designation : " ",
                            "resIsdCode": nriAdditionalDetailsVm.residenceCode ? nriAdditionalDetailsVm.residenceCode : " ",
                            "resNum": nriAdditionalDetailsVm.residenceTelNum ? nriAdditionalDetailsVm.residenceTelNum : " ",
                            "officeIsdCode": nriAdditionalDetailsVm.officeCode ? nriAdditionalDetailsVm.officeCode : " ",
                            "officeNum": nriAdditionalDetailsVm.offTel ? nriAdditionalDetailsVm.offTel : " "
                        }
                        NRIAOService.saveAdditionalDetailsApplication(requestCreateApp).then(function (response) {
                            if (response.responseCode == '0000') {
                                NRIAOService.requestNo = response.data;

                                nriAdditionalDetailsVm.getUpdatedData()
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }

                    else {
                        nriAdditionalDetailsVm.detailsinComplete = true;
                        nriAdditionalDetailsVm.detailsComplete = false;
                        nriAdditionalDetailsVm.toggleContent('Addl_Details');
                    }

                }

            }
        }

    ]);

