'use strict';

angularApp.controller('nriEducationalQualificationController',
    ["$scope",
        "$state",
        "NRIAOService",
        "$ionicHistory",
        "utilityService",
        function (
            $scope,
            $state,
            NRIAOService,
            $ionicHistory,
            utilityService) {
            var nriEducationalQualificationVm = this;


            $scope.$on('$ionicView.loaded', function () {
                nriEducationalQualificationVm.eduSelected = false;
                nriEducationalQualificationVm.eduDetails = false;
                nriEducationalQualificationVm.riligionSelected = false;
                nriEducationalQualificationVm.occupationSelected = false;
                nriEducationalQualificationVm.serviceDetail = false;
                nriEducationalQualificationVm.otherDetail = false;
                nriEducationalQualificationVm.eduNotSelected = false;
                nriEducationalQualificationVm.religionNotSelected = false;
                nriEducationalQualificationVm.otherReligionDetail = false;
                nriEducationalQualificationVm.occupationNotSelected = false;
                nriEducationalQualificationVm.eduQualificationMaster = NRIAOService.keyValueMap.EduQualificationMaster;
                nriEducationalQualificationVm.religionMaster = NRIAOService.keyValueMap.ReligionMaster;
                nriEducationalQualificationVm.otherReligionSubType = NRIAOService.keyValueMap.OtherReligionMaster;
                nriEducationalQualificationVm.occupationMaster = NRIAOService.keyValueMap.OccupationMaster;
                nriEducationalQualificationVm.categoryMaster = NRIAOService.keyValueMap.CategoryMaster
                nriEducationalQualificationVm.otherSubType = NRIAOService.keyValueMap.OM2;
                nriEducationalQualificationVm.occupationSubType = NRIAOService.keyValueMap.OM1

            });
            $scope.$on('$ionicView.beforeEnter', function () {
                nriEducationalQualificationVm.initPage();
            });
            nriEducationalQualificationVm.initPage = function () {
                if (NRIAOService.review) {
                    nriEducationalQualificationVm.educationCard = true;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.eduSelected = true;
                    nriEducationalQualificationVm.riligionSelected = true;
                    nriEducationalQualificationVm.catSelected = true;
                    nriEducationalQualificationVm.occupationSelected = true;
                    nriEducationalQualificationVm.nriEduQu = NRIAOService.resumeNRIresponse.eduQual;
                    nriEducationalQualificationVm.nriReligion = NRIAOService.resumeNRIresponse.religion;
                    nriEducationalQualificationVm.selectedOtherReligionsubtype = NRIAOService.getReligionOtherSubType(NRIAOService.resumeNRIresponse.otherReligion);
                    nriEducationalQualificationVm.nriOccupation = NRIAOService.resumeNRIresponse.occupation;
                    if (nriEducationalQualificationVm.nriOccupation == "OM2") {
                        nriEducationalQualificationVm.selectedOthersubtype = NRIAOService.getOccupationOtherSubType(NRIAOService.resumeNRIresponse.occupationSubtype);
                    } else if (nriEducationalQualificationVm.nriOccupation == "OM1") {
                        nriEducationalQualificationVm.selectedOccupationsubtype = NRIAOService.getOccupationServiceSubType(NRIAOService.resumeNRIresponse.occupationSubtype);
                    }

                    nriEducationalQualificationVm.nriCategory = NRIAOService.resumeNRIresponse.category;
                } else if (NRIAOService.resumeApplication) {
                    nriEducationalQualificationVm.educationCard = true;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.nriEduQu = NRIAOService.resumeNRIresponse.eduQual;
                    nriEducationalQualificationVm.nriReligion = NRIAOService.resumeNRIresponse.religion;
                    nriEducationalQualificationVm.selectedOtherReligionsubtype = NRIAOService.getReligionOtherSubType(NRIAOService.resumeNRIresponse.otherReligion);
                    nriEducationalQualificationVm.nriOccupation = NRIAOService.resumeNRIresponse.occupation;
                    if (nriEducationalQualificationVm.nriOccupation == "OM2") {
                        nriEducationalQualificationVm.selectedOthersubtype = NRIAOService.getOccupationOtherSubType(NRIAOService.resumeNRIresponse.occupationSubtype);
                    } else if (nriEducationalQualificationVm.nriOccupation == "OM1") {
                        nriEducationalQualificationVm.selectedOccupationsubtype = NRIAOService.getOccupationServiceSubType(NRIAOService.resumeNRIresponse.occupationSubtype);
                    }
                    nriEducationalQualificationVm.nriCategory = NRIAOService.resumeNRIresponse.category;
                }
                else {
                    nriEducationalQualificationVm.educationCard = true;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                }
            }
            nriEducationalQualificationVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriAdditionalDetails");
                } else {
                    $ionicHistory.goBack();
                }
            }


            nriEducationalQualificationVm.toggleContent = function (selectedVal) {
                if (selectedVal == '1') {
                    nriEducationalQualificationVm.educationCard = true;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.religionNotSelected = false;
                    nriEducationalQualificationVm.occupationNotSelected = false;
                } else if (selectedVal == '2') {
                    if (!nriEducationalQualificationVm.nriEduQu) {
                        nriEducationalQualificationVm.eduNotSelected = true;
                    } else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = true;
                        nriEducationalQualificationVm.occupationCard = false;
                        nriEducationalQualificationVm.categoryCard = false;
                        nriEducationalQualificationVm.occupationNotSelected = false;
                        nriEducationalQualificationVm.eduNotSelected = false;
                    }


                } else if (selectedVal == '3') {
                    if (!nriEducationalQualificationVm.nriEduQu) {
                        nriEducationalQualificationVm.eduNotSelected = true;
                    }
                    if (!nriEducationalQualificationVm.nriReligion) {
                        nriEducationalQualificationVm.religionNotSelected = true;
                    } else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = false;
                        nriEducationalQualificationVm.categoryCard = true;
                        nriEducationalQualificationVm.occupationCard = false;
                        nriEducationalQualificationVm.occupationNotSelected = false;
                        nriEducationalQualificationVm.eduNotSelected = false;
                    }

                } else if (selectedVal == '4') {
                    if (!nriEducationalQualificationVm.nriEduQu) {
                        nriEducationalQualificationVm.eduNotSelected = true;
                    }
                    if (!nriEducationalQualificationVm.nriReligion) {
                        nriEducationalQualificationVm.religionNotSelected = true;
                    }
                    if (!nriEducationalQualificationVm.nriCategory) {
                        nriEducationalQualificationVm.catNotSelected = true;
                    } else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = false;
                        nriEducationalQualificationVm.categoryCard = false;
                        nriEducationalQualificationVm.occupationCard = true;
                        nriEducationalQualificationVm.eduNotSelected = false;
                        nriEducationalQualificationVm.religionNotSelected = false;
                    }

                } else {
                    nriEducationalQualificationVm.educationCard = false;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                }

            }
            nriEducationalQualificationVm.eduSubSelect = function (subType, option) {
                if (option == "Edu") {
                    nriEducationalQualificationVm.eduSelected = true;
                    nriEducationalQualificationVm.nriEduQu = subType;
                    if (nriEducationalQualificationVm.nriEduQu == "O") {
                        nriEducationalQualificationVm.eduDetails = true;
                        nriEducationalQualificationVm.eduNotSelected = false;
                    } else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = true;
                        nriEducationalQualificationVm.eduDetails = false;
                        nriEducationalQualificationVm.eduDetail = "";
                        nriEducationalQualificationVm.eduNotSelected = false;
                    }

                } else if (option == "Religion") {
                    nriEducationalQualificationVm.nriReligion = subType;
                    if (nriEducationalQualificationVm.nriReligion == "O") {
                        nriEducationalQualificationVm.otherReligionSubType = NRIAOService.keyValueMap.OtherReligionMaster;
                        if (nriEducationalQualificationVm.selectedOtherReligionsubtype.key != undefined ||
                            nriEducationalQualificationVm.selectedOtherReligionsubtype.key != null || nriEducationalQualificationVm.selectedOtherReligionsubtype.key != '') {

                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.religionCard = false;
                            nriEducationalQualificationVm.occupationCard = false;
                            nriEducationalQualificationVm.categoryCard = true;
                            nriEducationalQualificationVm.religionNotSelected = false;
                            nriEducationalQualificationVm.riligionSelected = true;


                        }
                        else {
                            nriEducationalQualificationVm.religionCard = true;

                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.categoryCard = false;
                            nriEducationalQualificationVm.otherReligionDetail = false;
                            nriEducationalQualificationVm.occupationCard = false;
                        }

                    }
                    else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = false;
                        nriEducationalQualificationVm.occupationCard = false;
                        nriEducationalQualificationVm.categoryCard = true;
                        nriEducationalQualificationVm.religionNotSelected = false;
                        nriEducationalQualificationVm.riligionSelected = true;
                    }

                } else if (option == "Cat") {
                    nriEducationalQualificationVm.catSelected = true;
                    nriEducationalQualificationVm.nriCategory = subType;
                    nriEducationalQualificationVm.educationCard = false;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = true;
                    nriEducationalQualificationVm.religionNotSelected = false;
                    nriEducationalQualificationVm.catNotSelected = false;
                }
                else if (option == "Occupation") {
                    nriEducationalQualificationVm.nriOccupation = subType;
                    if (nriEducationalQualificationVm.nriOccupation == "OM2") {
                        nriEducationalQualificationVm.otherSubType = NRIAOService.keyValueMap.OM2;
                        if (nriEducationalQualificationVm.selectedOthersubtype.key != undefined ||
                            nriEducationalQualificationVm.selectedOthersubtype.key != null || nriEducationalQualificationVm.selectedOthersubtype.key != '') {
                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.religionCard = false;
                            nriEducationalQualificationVm.serviceDetail = false;
                            nriEducationalQualificationVm.otherDetail = true;
                            nriEducationalQualificationVm.occupationNotSelected = false;
                            nriEducationalQualificationVm.occupationCard = false;
                            nriEducationalQualificationVm.occupationSelected = true;
                        }
                        else {
                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.religionCard = false;
                            nriEducationalQualificationVm.occupationCard = true;
                            nriEducationalQualificationVm.serviceDetail = false;
                            nriEducationalQualificationVm.otherDetail = false;
                            nriEducationalQualificationVm.occupationNotSelected = false;

                        }
                    } else if (nriEducationalQualificationVm.nriOccupation == "OM1") {
                        nriEducationalQualificationVm.occupationSubType = NRIAOService.keyValueMap.OM1;
                        if (nriEducationalQualificationVm.selectedOccupationsubtype.key != undefined ||
                            nriEducationalQualificationVm.selectedOccupationsubtype.key != null || nriEducationalQualificationVm.selectedOccupationsubtype.key != '') {

                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.religionCard = false;
                            nriEducationalQualificationVm.serviceDetail = true;
                            nriEducationalQualificationVm.otherDetail = false;
                            nriEducationalQualificationVm.occupationNotSelected = false;
                            nriEducationalQualificationVm.occupationCard = false;
                            nriEducationalQualificationVm.occupationSelected = true;
                        }
                        else {
                            nriEducationalQualificationVm.educationCard = false;
                            nriEducationalQualificationVm.religionCard = false;
                            nriEducationalQualificationVm.occupationCard = true;
                            nriEducationalQualificationVm.serviceDetail = false;
                            nriEducationalQualificationVm.otherDetail = false;
                            nriEducationalQualificationVm.occupationNotSelected = false;
                        }

                    } else {
                        nriEducationalQualificationVm.educationCard = false;
                        nriEducationalQualificationVm.religionCard = false;
                        nriEducationalQualificationVm.occupationCard = true;
                        nriEducationalQualificationVm.serviceDetail = false;
                        nriEducationalQualificationVm.otherDetail = false;
                        nriEducationalQualificationVm.occupationNotSelected = false;
                    }

                }

            }
            nriEducationalQualificationVm.erroeInformation = function (selectedVal) {
                if (selectedVal == 'Edu') {
                    nriEducationalQualificationVm.educationCard = true;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.religionSelected = false;
                    nriEducationalQualificationVm.occupationSelected = false;
                    nriEducationalQualificationVm.eduSelected = false;
                    nriEducationalQualificationVm.catSelected = false;

                }
                else if (selectedVal == 'Religion') {
                    nriEducationalQualificationVm.educationCard = false;
                    nriEducationalQualificationVm.religionCard = true;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.eduNotSelected = false;
                    nriEducationalQualificationVm.religionSelected = false;
                    nriEducationalQualificationVm.occupationSelected = false;
                    nriEducationalQualificationVm.catSelected = false;
                }
                else if (selectedVal == 'Category') {
                    nriEducationalQualificationVm.educationCard = false;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.categoryCard = true;
                    nriEducationalQualificationVm.occupationCard = false;
                    nriEducationalQualificationVm.eduNotSelected = false;
                    nriEducationalQualificationVm.religionNotSelected = false;
                    nriEducationalQualificationVm.occupationSelected = false;
                    nriEducationalQualificationVm.catSelected = false;
                }
                else if (selectedVal == 'Occupation') {
                    nriEducationalQualificationVm.educationCard = false;
                    nriEducationalQualificationVm.religionCard = false;
                    nriEducationalQualificationVm.occupationCard = true;
                    nriEducationalQualificationVm.categoryCard = false;
                    nriEducationalQualificationVm.eduNotSelected = false;
                    nriEducationalQualificationVm.religionNotSelected = false;
                    nriEducationalQualificationVm.occupationSelected = false;
                    nriEducationalQualificationVm.catNotSelected = false;
                }


            }
            nriEducationalQualificationVm.verifyEducationDetails = function () {
                if (nriEducationalQualificationVm.nriEduQu == undefined || nriEducationalQualificationVm.nriEduQu == null || nriEducationalQualificationVm.nriEduQu == '') {
                    nriEducationalQualificationVm.eduNotSelected = true
                } else {
                    if (nriEducationalQualificationVm.nriEduQu == 'O' && (nriEducationalQualificationVm.eduDetail == undefined || nriEducationalQualificationVm.eduDetail == null || nriEducationalQualificationVm.eduDetail == '')) {
                        nriEducationalQualificationVm.eduDetailsNoError = false;
                    } else {
                        nriEducationalQualificationVm.eduNotSelected = false;
                        nriEducationalQualificationVm.eduSelected = true;
                        nriEducationalQualificationVm.eduDetailsNoError = true;
                        if (nriEducationalQualificationVm.nriEduQu == 'OtherGrad') {
                            nriEducationalQualificationVm.nriEduQu = nriEducationalQualificationVm.eduDetail;
                        }

                    }
                }
            }

            nriEducationalQualificationVm.verifyOccupationDetails = function () {
                if (nriEducationalQualificationVm.nriOccupation == undefined || nriEducationalQualificationVm.nriOccupation == null || nriEducationalQualificationVm.nriOccupation == '') {
                    nriEducationalQualificationVm.occupationNotSelected = true
                } else {
                    if (nriEducationalQualificationVm.nriOccupation == 'OM2' && (nriEducationalQualificationVm.selectedOthersubtype == undefined || nriEducationalQualificationVm.selectedOthersubtype == null || nriEducationalQualificationVm.selectedOthersubtype == '')) {
                        nriEducationalQualificationVm.occupationDetailsNoError = false;
                    } else if (nriEducationalQualificationVm.nriOccupation == 'OM1' && (nriEducationalQualificationVm.selectedOccupationsubtype == undefined || nriEducationalQualificationVm.selectedOccupationsubtype == null || nriEducationalQualificationVm.selectedOccupationsubtype == '')) {
                        nriEducationalQualificationVm.occupationDetailsNoError = false;
                    } else {
                        nriEducationalQualificationVm.occupationNotSelected = false;
                        nriEducationalQualificationVm.occupationSelected = true;
                        nriEducationalQualificationVm.occupationDetailsNoError = true;
                    }
                }
            }


            nriEducationalQualificationVm.verifyCategoryDetails = function () {
                if (nriEducationalQualificationVm.nriCategory == undefined || nriEducationalQualificationVm.nriCategory == null || nriEducationalQualificationVm.nriCategory == '') {
                    nriEducationalQualificationVm.catNotSelected = true;
                    nriEducationalQualificationVm.categoryDetailsNoError = false;
                } else {
                    nriEducationalQualificationVm.catNotSelected = false;
                    nriEducationalQualificationVm.catSelected = true;
                    nriEducationalQualificationVm.categoryDetailsNoError = true;
                }

            }
            nriEducationalQualificationVm.verifyReligionDetails = function () {
                if (nriEducationalQualificationVm.nriReligion == undefined || nriEducationalQualificationVm.nriReligion == null || nriEducationalQualificationVm.nriReligion == '') {
                    nriEducationalQualificationVm.religionNotSelected = true
                } else {
                    if (nriEducationalQualificationVm.nriReligion == 'O' && (nriEducationalQualificationVm.selectedOtherReligionsubtype == undefined || nriEducationalQualificationVm.selectedOtherReligionsubtype == null || nriEducationalQualificationVm.selectedOtherReligionsubtype == '')) {
                        nriEducationalQualificationVm.religionDetailsNoError = false;
                    } else {
                        nriEducationalQualificationVm.religionNotSelected = false;
                        nriEducationalQualificationVm.riligionSelected = true;
                        nriEducationalQualificationVm.religionDetailsNoError = true;
                    }
                }
            }

            nriEducationalQualificationVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }

                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go('menu.nriNominationDetails');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            nriEducationalQualificationVm.goToNomineeAddition = function () {
                nriEducationalQualificationVm.verifyEducationDetails();
                nriEducationalQualificationVm.verifyReligionDetails();
                nriEducationalQualificationVm.verifyCategoryDetails();
                nriEducationalQualificationVm.verifyOccupationDetails();

                if (!nriEducationalQualificationVm.eduDetailsNoError) {
                    nriEducationalQualificationVm.eduNotSelected = true;
                    nriEducationalQualificationVm.erroeInformation('Edu');
                }
                else if (!nriEducationalQualificationVm.religionDetailsNoError) {
                    nriEducationalQualificationVm.religionNotSelected = true;
                    nriEducationalQualificationVm.erroeInformation('Religion');
                }
                else if (!nriEducationalQualificationVm.categoryDetailsNoError) {
                    nriEducationalQualificationVm.catNotSelected = true;
                    nriEducationalQualificationVm.erroeInformation('Category');
                }
                else if (!nriEducationalQualificationVm.occupationDetailsNoError) {
                    nriEducationalQualificationVm.occupationNotSelected = true;
                    nriEducationalQualificationVm.erroeInformation('Occupation');
                }
                else
                    if (nriEducationalQualificationVm.nriReligion == 'O') {
                        if (nriEducationalQualificationVm.nriOccupation == "OM1") {
                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": nriEducationalQualificationVm.selectedOtherReligionsubtype.key,
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": nriEducationalQualificationVm.selectedOccupationsubtype.key
                            }

                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });


                        }
                        else if (nriEducationalQualificationVm.nriOccupation == "OM2") {

                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": nriEducationalQualificationVm.selectedOtherReligionsubtype.key,
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": nriEducationalQualificationVm.selectedOthersubtype.key
                            }


                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });


                        }
                        else {

                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": nriEducationalQualificationVm.selectedOtherReligionsubtype.key,
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": " "

                            }
                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }

                    }
                    else {

                        if (nriEducationalQualificationVm.nriOccupation == "OM1") {

                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": " ",
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": nriEducationalQualificationVm.selectedOccupationsubtype.key
                            }


                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });


                        } else if (nriEducationalQualificationVm.nriOccupation == "OM2") {

                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": " ",
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": nriEducationalQualificationVm.selectedOthersubtype.key
                            }



                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });


                        } else {

                            var payload = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "review": NRIAOService.review,
                                "requestNo": NRIAOService.requestNo,
                                "eduQual": nriEducationalQualificationVm.nriEduQu,
                                "religion": nriEducationalQualificationVm.nriReligion,
                                "otherReligion": " ",
                                "category": nriEducationalQualificationVm.nriCategory,
                                "occupation": nriEducationalQualificationVm.nriOccupation,
                                "occupationSubtype": " "
                            }


                            NRIAOService.saveEduQualificationApplication(payload).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    nriEducationalQualificationVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });


                        }
                    }

            }

        }


    ]);