'use strict';

angularApp.controller('nriNominationDetailsController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",
        "$ionicPopup",
        function (
            $state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService,
            $ionicPopup
        ) {
            var nriNominationDetailsVm = this;

            $scope.$on('$ionicView.beforeEnter', function () {
                nriNominationDetailsVm.initPage();
            });

            $scope.$on('$ionicView.loaded', function () {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
              
                nriNominationDetailsVm.nomineeRelSubType = NRIAOService.masterList.RelationshipMaster;
                nriNominationDetailsVm.nomineeCountrySelType = NRIAOService.countryMaster;
                nriNominationDetailsVm.stateMaster = NRIAOService.stateMasterdata;
               
                nriNominationDetailsVm.nomineeTypeSel = false;
                nriNominationDetailsVm.relOtherSel = false;
                nriNominationDetailsVm.addressNotSelected = true;
                nriNominationDetailsVm.nomineeReqSel = '';
                nriNominationDetailsVm.nomineeAddr = '';
                nriNominationDetailsVm.showNomineeSelErr = false;
                nriNominationDetailsVm.ageshow = null;
            });
            nriNominationDetailsVm.initPage = function () {
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    if (NRIAOService.resumeNRIresponse.nomineeRequired && NRIAOService.resumeNRIresponse.nomineeRequired != null) {
                        nriNominationDetailsVm.nomineeReqSel = 'Nominee Yes';
                        nriNominationDetailsVm.nomineeTypeSel = true;
                        nriNominationDetailsVm.nomineeName = NRIAOService.resumeNRIresponse.nomineeDetail.name
                        nriNominationDetailsVm.relSel = NRIAOService.resumeNRIresponse.nomineeDetail.relationship
                        nriNominationDetailsVm.nomineeOther = NRIAOService.resumeNRIresponse.nomineeDetail.otherRelationship
                        nriNominationDetailsVm.dob = NRIAOService.resumeNRIresponse.nomineeDetail.dob
                        nriNominationDetailsVm.nomineeAddr = NRIAOService.resumeNRIresponse.nomineeDetail.sameAddress
                        if (NRIAOService.resumeNRIresponse.nomineeDetail.sameAddress == 'C' || NRIAOService.resumeNRIresponse.nomineeDetail.sameAddress == 'P') {
                            nriNominationDetailsVm.addressReadOnly = true;
                        } else {
                            nriNominationDetailsVm.addressReadOnly = false;
                        }
                        nriNominationDetailsVm.nomineeAddr1 = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.addressLine1
                        nriNominationDetailsVm.nomineeAddr2 = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.city
                        nriNominationDetailsVm.nomineestate = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.state
                        nriNominationDetailsVm.nomineePinCode = NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.pincode
                        nriNominationDetailsVm.countSel = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.nomineeDetail.nomineeAddress.country)

                    } else if(!NRIAOService.resumeNRIresponse.nomineeRequired && NRIAOService.resumeNRIresponse.nomineeRequired != null){
                        nriNominationDetailsVm.nomineeReqSel = 'Nominee No'
                        nriNominationDetailsVm.nomineeTypeSel = false;
                    }
                }


            }
            nriNominationDetailsVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriEduPage");
                } else {
                    $ionicHistory.goBack();
                }
            }
            nriNominationDetailsVm.openDOBdatepicker = function () {
                $scope.dateOptions = {
                    maxDate: new Date(),
                    minDate: (new Date().setYear(new Date().getFullYear() - 99)),
                    formatYear: 'yy',
                    startingDay: 1,

                }

                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="nriNominationDetailsVm.dateDOBobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,

                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            nriNominationDetailsVm.dob = nriNominationDetailsVm.dateDOBobj.dt;
                            nriNominationDetailsVm.getAge();

                        }
                    }],
                });

            }

            nriNominationDetailsVm.changeCountry = function () {
                if (nriNominationDetailsVm.nomineeCountrySelType.code != 'IN') {
                    nriNominationDetailsVm.nomineestate = "";
                }
            }
            nriNominationDetailsVm.nomineeRelationChange = function () {
                if (nriNominationDetailsVm.relSel == "Other") {
                    nriNominationDetailsVm.relOtherSel = true;
                } else {
                    nriNominationDetailsVm.relOtherSel = false;
                    nriNominationDetailsVm.nomineeOther = "";
                }
            }
            nriNominationDetailsVm.nomineeSelected = function (nomineeSel) {
                if (nomineeSel == 'NOMINEE_YES') {
                    nriNominationDetailsVm.nomineeReqSel = 'Nominee Yes';
                    nriNominationDetailsVm.nomineeTypeSel = true;
                } else if (nomineeSel == 'NOMINEE_NO') {
                    nriNominationDetailsVm.nomineeReqSel = 'Nominee No';
                    nriNominationDetailsVm.nomineeTypeSel = false;
                }
            }


            nriNominationDetailsVm.getAge = function () {
                nriNominationDetailsVm.birthday = new Date(nriNominationDetailsVm.dob);
                nriNominationDetailsVm.today = new Date();
                if (nriNominationDetailsVm.today > nriNominationDetailsVm.birthday) {
                    nriNominationDetailsVm.currentAge = ((nriNominationDetailsVm.today - nriNominationDetailsVm.birthday) / (31557600000));
                    nriNominationDetailsVm.age = Math.floor(nriNominationDetailsVm.currentAge);
                    nriNominationDetailsVm.ageshow = true;
                } else {
                    nriNominationDetailsVm.age = "Date of birth exceeds today's date";
                    nriNominationDetailsVm.ageshow = false;
                }

            }
            nriNominationDetailsVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }

                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go("menu.nriAccountServicePage");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            nriNominationDetailsVm.SubmitNominationDetails = function () {
                if (nriNominationDetailsVm.nomineeReqSel == "") {
                    nriNominationDetailsVm.showNomineeSelErr = true;
                } else {
                    nriNominationDetailsVm.showNomineeSelErr = false;

                    if (nriNominationDetailsVm.nomineeTypeSel) {
                        if (nriNominationDetailsVm.nomineeDetailsForm.nomineeName.$invalid && nriNominationDetailsVm.nomineeDetailsForm.relSel.$invalid
                            && nriNominationDetailsVm.nomineeDetailsForm.nomineeAddr1Id.$invalid && nriNominationDetailsVm.nomineeDetailsForm.nomineeAddr2.$invalid && nriNominationDetailsVm.nomineeDetailsForm.nomineestate.$invalid
                            && nriNominationDetailsVm.nomineeDetailsForm.countrySel.$invalid) {
                            nriNominationDetailsVm.detailsinComplete = true;
                        }
                        else {
                            if (nriNominationDetailsVm.nomineeName != undefined && nriNominationDetailsVm.nomineeName != '' && nriNominationDetailsVm.nomineeName != null &&
                                nriNominationDetailsVm.relSel != undefined && nriNominationDetailsVm.relSel != '' && nriNominationDetailsVm.relSel != null &&
                                nriNominationDetailsVm.dob != undefined && nriNominationDetailsVm.dob != '' && nriNominationDetailsVm.dob != null &&
                                nriNominationDetailsVm.nomineeAddr1 != undefined && nriNominationDetailsVm.nomineeAddr1 != '' && nriNominationDetailsVm.nomineeAddr1 != null &&
                                nriNominationDetailsVm.nomineeAddr2 != undefined && nriNominationDetailsVm.nomineeAddr2 != '' && nriNominationDetailsVm.nomineeAddr2 != null &&
                                nriNominationDetailsVm.nomineestate != undefined && nriNominationDetailsVm.nomineestate != '' && nriNominationDetailsVm.nomineestate != null &&
                                nriNominationDetailsVm.countSel != undefined && nriNominationDetailsVm.countSel != "" && nriNominationDetailsVm.countSel != null) {
                                nriNominationDetailsVm.birthday = new Date(nriNominationDetailsVm.dob);
                                nriNominationDetailsVm.today = new Date();
                                nriNominationDetailsVm.currentAge = ((nriNominationDetailsVm.today - nriNominationDetailsVm.birthday) / (31557600000));
                                if (typeof (nriNominationDetailsVm.dob) === "object") {
                                    nriNominationDetailsVm.dateOfBirth = nriNominationDetailsVm.dob.getFullYear() + "-" + ('0' + (nriNominationDetailsVm.dob.getMonth() + 1)).slice(-2) + "-" + ('0' + nriNominationDetailsVm.dob.getDate()).slice(-2);
                                } else {
                                    nriNominationDetailsVm.dateOfBirth = nriNominationDetailsVm.dob
                                }

                                if (Math.floor(nriNominationDetailsVm.currentAge) < 18) {
                                    NRIAOService.nomineeTypeSel = nriNominationDetailsVm.nomineeTypeSel;
                                    NRIAOService.nomineeName = nriNominationDetailsVm.nomineeName;
                                    NRIAOService.relSel = nriNominationDetailsVm.relSel;
                                    NRIAOService.nomineeOther = nriNominationDetailsVm.nomineeOther ? nriNominationDetailsVm.nomineeOther : null;
                                    NRIAOService.dob = nriNominationDetailsVm.dateOfBirth;
                                    NRIAOService.nomineeAddr = nriNominationDetailsVm.nomineeAddr;
                                    NRIAOService.nomineeAddr1 = nriNominationDetailsVm.nomineeAddr1;
                                    NRIAOService.nomineeAddr2 = nriNominationDetailsVm.nomineeAddr2;
                                    NRIAOService.nomineestate = nriNominationDetailsVm.nomineestate;
                                    NRIAOService.nomineePinCode = nriNominationDetailsVm.nomineePinCode;
                                    NRIAOService.countSel = nriNominationDetailsVm.countSel;
                                    $state.go("menu.guardianDetailsNRI");
                                }
                                else {
                                    nriNominationDetailsVm.detailsComplete = true;
                                    nriNominationDetailsVm.detailsinComplete = false;

                                    var payload = {
                                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                                        "requestNo": NRIAOService.requestNo,
                                        "nomineeRequired": nriNominationDetailsVm.nomineeTypeSel,
                                        "review": NRIAOService.review,
                                        "payload": {
                                            "name": nriNominationDetailsVm.nomineeName,
                                            "relationship": nriNominationDetailsVm.relSel,
                                            "otherRelationship": nriNominationDetailsVm.nomineeOther ? nriNominationDetailsVm.nomineeOther : null,
                                            "dob": nriNominationDetailsVm.dateOfBirth,
                                            "sameAddressGuardian": null,
                                            "guardianName": null,
                                            "guardianAge": null,
                                            "nomineeAddress": {
                                                "addressLine1": nriNominationDetailsVm.nomineeAddr1,
                                                "city": nriNominationDetailsVm.nomineeAddr2,
                                                "state": nriNominationDetailsVm.nomineestate,
                                                "pincode": nriNominationDetailsVm.nomineePinCode,
                                                "country": nriNominationDetailsVm.countSel.code
                                            },
                                            "guardianAddress": null
                                        }
                                    }

                                    NRIAOService.saveNomineeApplication(payload).then(function (response) {
                                        if (response.responseCode == '0000') {
                                            NRIAOService.requestNo = response.data;
                                            nriNominationDetailsVm.getUpdatedData()
                                        }
                                    }, function (error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });
                                }
                            }
                            else {
                                nriNominationDetailsVm.detailsinComplete = true;
                            }
                        }
                    }
                    else {


                        var payload = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "requestNo": NRIAOService.requestNo,
                            "nomineeRequired": nriNominationDetailsVm.nomineeTypeSel,
                            "review": NRIAOService.review,
                            "payload": null
                        }


                        NRIAOService.saveNomineeApplication(payload).then(function (response) {
                            if (response.responseCode == '0000') {
                                NRIAOService.requestNo = response.data;
                                nriNominationDetailsVm.getUpdatedData()
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });



                    }
                }

            }

        }

    ])