'use strict';

angularApp.controller('nriPrivacyInfoController', ["$state",
    "$scope",
    "NRIAOService",
    "ompMerchantsService",
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    function ($state,
        $scope,
        NRIAOService,
        ompMerchantsService,
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory) {

        var nriPrivacyInfoVm = this;
        nriPrivacyInfoVm.disableNext = true;
        nriPrivacyInfoVm.disableCheckboxPrivacy = true;

        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {

            nriPrivacyInfoVm.privacyData = NRIAOService.PrivacyNoticeFile;
            nriPrivacyInfoVm.privacyNoticeContent = NRIAOService.privacyNoticeContent;
            nriPrivacyInfoVm.privacyNoticeDownloaded = false;
            nriPrivacyInfoVm.disableCheckboxPrivacy = true;

            if (NRIAOService.resumeNRIresponse.privacyNoticeViewed != null && NRIAOService.resumeNRIresponse.privacyNoticeViewed != undefined && NRIAOService.resumeNRIresponse.privacyNoticeViewed != "") {
                if (NRIAOService.resumeNRIresponse.privacyNoticeViewed) {
                    nriPrivacyInfoVm.isConsentChecked = true;

                }
                else {
                    nriPrivacyInfoVm.isConsentChecked = false;
                }
                nriPrivacyInfoVm.agreeChkBox();
            }

        });


        function initPage() {
            utilityService.showBhimUpiAlert("", "Please read full consent", "", "", "");

        }

        nriPrivacyInfoVm.goBack = function () {
            nriPrivacyInfoVm.disableCheckboxPrivacy = true;
            $state.go('menu.NRIConsent');
        }

        nriPrivacyInfoVm.agreeChkBox = function () {
            if (nriPrivacyInfoVm.isConsentChecked) {
                nriPrivacyInfoVm.disableNext = false;
            } else {
                nriPrivacyInfoVm.disableNext = true;
            }
        }
        nriPrivacyInfoVm.checkScroll = function () {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (maxTop !== 0) {
                if (currentTop >= maxTop) {
                    nriPrivacyInfoVm.disableCheckboxPrivacy = false;
                    document.getElementById('TERMCOND_CHK_PRIVACY').removeAttribute("disabled");
                }
            }
        }





        nriPrivacyInfoVm.downloadPrivacyNotice = function () {
            nriPrivacyInfoVm.privacyNoticeDownloaded = true;
            ompMerchantsService.inChromeBrowser(nriPrivacyInfoVm.privacyData);

        }
        nriPrivacyInfoVm.isNotNullOrUndefined = function (varNull) {

            return (varNull != null && varNull != undefined && varNull != "");
        }
        nriPrivacyInfoVm.goToConsent = function () {

            var isConsentCheckedNotNull = nriPrivacyInfoVm.isNotNullOrUndefined(nriPrivacyInfoVm.isConsentChecked);
            if (isConsentCheckedNotNull) {
                NRIAOService.privacyNoticeViewed = true;
                NRIAOService.privacyNoticeDownloaded = nriPrivacyInfoVm.privacyNoticeDownloaded;
                $ionicHistory.goBack();

            }
        }


        return this;
    }
]);

