'use strict';

angularApp.controller('nriProductInfoController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "openUrlInAppbroswerService",
        "NRIAOService",
        "utilityService",
        function ($state,
            $scope,
            $ionicHistory,
            openUrlInAppbroswerService,
            NRIAOService,
            utilityService) {
            var nriProductInfoVm = this;

            $scope.$on('$ionicView.loaded', function () {
                nriProductInfoVm.initPage();
            });

            nriProductInfoVm.initPage = function () {


                var productInforequest = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "wcmContentType": "productInformationResponse"
                }

                NRIAOService.getWcmData(productInforequest).then(function (productInforesponse) {
                    if (productInforesponse.responseCode == '0000') {
                        nriProductInfoVm.productInfo = productInforesponse.data;
                        nriProductInfoVm.knowMoreUrl = productInforesponse.url;
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

            nriProductInfoVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go('menu.accTypeStatusPages');
                } else {
                    $ionicHistory.goBack();
                }
            }

            nriProductInfoVm.goToPersonalDetails = function () {
                $state.go("menu.personalPanDetailsPage");
            }

            nriProductInfoVm.knowmoreLink = function () {
                openUrlInAppbroswerService.openUrl(nriProductInfoVm.knowMoreUrl, "");
            }
        }
    ]);