'use strict';

angularApp.controller('nriReviewController',
    ["$scope",
        "utilityService",
        "$ionicHistory",
        "NRIAOService",
        "$translate",
        "$state",
        function (
            $scope,
            utilityService,
            $ionicHistory,
            NRIAOService,
            $translate,
            $state) {
            var nriReviewVm = this;
            nriReviewVm.reiewData = null;
            nriReviewVm.accountDetailCardReview = false;
            nriReviewVm.personalDetailCardReview = false;
            nriReviewVm.passportDetailCardReview = false;
            nriReviewVm.addressDetailCardReview = false;
            nriReviewVm.additionalDetailCardReview = false;
            nriReviewVm.nominationDetailCardReview = false;
            nriReviewVm.accountServicesCardReview = false;
            nriReviewVm.taxationDetailCardReview = false;           
            NRIAOService.review = false;
            $scope.$on('$ionicView.beforeEnter', function () {
                nriReviewVm.initPage();
            });

            nriReviewVm.initPage = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile
                }

                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        nriReviewVm.reiewData = response.data;
                        NRIAOService.resumeNRIresponse = response.data;
                        NRIAOService.review = true;
                        nriReviewVm.setData();
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            nriReviewVm.setData = function () {

                if (nriReviewVm.reiewData.nreAccountDetail && nriReviewVm.reiewData.nroAccountDetail) {
                    nriReviewVm.accountType = "NRE" + " " + nriReviewVm.reiewData.nreAccountDetail.accountType + " " + "and" + " " + "NRO" + " " + nriReviewVm.reiewData.nroAccountDetail.accountType
                } else if (nriReviewVm.reiewData.nreAccountDetail) {
                    nriReviewVm.accountType = "NRE" + " " + nriReviewVm.reiewData.nreAccountDetail.accountType
                } else {
                    nriReviewVm.accountType = "NRO" + " " + nriReviewVm.reiewData.nroAccountDetail.accountType
                }


                if (nriReviewVm.reiewData.branchPref) {
                    nriReviewVm.accountOpeningVia = $translate.instant('BRANCH_VISIT');
                } else {
                    nriReviewVm.accountOpeningVia = $translate.instant('THROUGH_GNC');
                }

                nriReviewVm.personalDetailTitle = NRIAOService.getTitleValue(nriReviewVm.reiewData.title).value;

                nriReviewVm.personalDetailCountry = NRIAOService.getCountryName(nriReviewVm.reiewData.birthCountry).name;
             
                if (nriReviewVm.reiewData.aadhaarNo) {
                    nriReviewVm.nriAadhar = utilityService.maskData(nriReviewVm.reiewData.aadhaarNo, "front", 4);
                }

                nriReviewVm.passportNationalityCode = NRIAOService.getCountryName(nriReviewVm.reiewData.passportVisaDetail.nationality).code;
                if(nriReviewVm.passportNationalityCode == 'IN'){
                    nriReviewVm.passportNationality = "INDIAN";
                }
                else{
                    nriReviewVm.passportNationality = NRIAOService.getCountryName(nriReviewVm.reiewData.passportVisaDetail.nationality).name;
                }
             
                nriReviewVm.passportCitizenship = NRIAOService.getCountryName(nriReviewVm.reiewData.passportVisaDetail.citizenship).name;


                if (nriReviewVm.reiewData.sameAddress) {
                    nriReviewVm.correspondence = "Current Address";
                    nriReviewVm.currentAddSameAsPermanent = $translate.instant('NRI_PARMANENTADDRESS');
                } else {
                    if(nriReviewVm.reiewData.correspAddress == 'C'){
                        nriReviewVm.correspondence = "Current Address";
                    }
                    if(nriReviewVm.reiewData.correspAddress == 'P'){
                        nriReviewVm.correspondence = "Permanent Address";
                    }
                   
                    nriReviewVm.currentAddSameAsPermanent = null
                }

                if (nriReviewVm.reiewData.currentAddress.addressProofType == "A") {
                    nriReviewVm.addressProof = "Passport"
                } else {
                    nriReviewVm.addressProof = NRIAOService.getAddressProof(nriReviewVm.reiewData.currentAddress.addressProofType).value
                }

                nriReviewVm.addresstype = NRIAOService.getAddressType(nriReviewVm.reiewData.currentAddress.addressType).value;

                if (nriReviewVm.reiewData.currentAddress.country == 'IN') {
                    nriReviewVm.addressState = NRIAOService.getStateName(nriReviewVm.reiewData.currentAddress.state);
                } else {
                    nriReviewVm.addressState = nriReviewVm.reiewData.currentAddress.state;
                }

                nriReviewVm.addressCountry = NRIAOService.getCountryName(nriReviewVm.reiewData.currentAddress.country).name;

             

                if (!nriReviewVm.reiewData.sameAddress) {

                    if (nriReviewVm.reiewData.permanentAddress.addressProofType == "04") {
                        nriReviewVm.permanentaddressProof = "Passport"
                    } else {
                        nriReviewVm.permanentaddressProof = NRIAOService.getAddressProofPermanent(nriReviewVm.reiewData.permanentAddress.addressProofType).value
                    }
    
                    if (nriReviewVm.reiewData.permanentAddress.country == 'IN') {
                        nriReviewVm.permanentaddressState = NRIAOService.getStateName(nriReviewVm.reiewData.permanentAddress.state);
                    } else {
                        nriReviewVm.permanentaddressState = nriReviewVm.reiewData.permanentAddress.state;
                    }
                    nriReviewVm.paddresstype = NRIAOService.getAddressType(nriReviewVm.reiewData.permanentAddress.addressType).value;
                    nriReviewVm.paddressCountry = NRIAOService.getCountryName(nriReviewVm.reiewData.permanentAddress.country).name;
                 
                    if (nriReviewVm.reiewData.permanentAddress.idNumber) {
                        nriReviewVm.idNumberAvailable = true;
                        nriReviewVm.idNumber = nriReviewVm.reiewData.permanentAddress.idNumber;
                    } else {
                        nriReviewVm.idNumberAvailable = false;
                    }
                }

                nriReviewVm.additionaladdresstype = NRIAOService.getResideAddressType(nriReviewVm.reiewData.statusProof).value;

                nriReviewVm.additionalDetailaddressCountry = NRIAOService.getCountryName(nriReviewVm.reiewData.currentResCountry).name;

                nriReviewVm.selectedEdu = NRIAOService.getEducationValue(nriReviewVm.reiewData.eduQual).value;
                nriReviewVm.selectedReligion = NRIAOService.getReligionValue(nriReviewVm.reiewData.religion).value;
                if (nriReviewVm.selectedReligion == 'Others') {
                    nriReviewVm.selectedOtherReligionSubType = NRIAOService.getReligionOtherSubType(nriReviewVm.reiewData.otherReligion).value;
                } else {
                    nriReviewVm.selectedOtherReligionSubType = null;
                }

                nriReviewVm.selectedCategory = NRIAOService.getCategoryValue(nriReviewVm.reiewData.category).value;
                nriReviewVm.selectedOccupation = NRIAOService.getOccupationValue(nriReviewVm.reiewData.occupation).value;

                if (nriReviewVm.reiewData.occupation == 'OM1') {
                    nriReviewVm.selectedOccupationSubType = NRIAOService.getOccupationServiceSubType(nriReviewVm.reiewData.occupationSubtype).value;
                } else if (nriReviewVm.reiewData.occupation == 'OM2') {
                    nriReviewVm.selectedOccupationSubType = NRIAOService.getOccupationOtherSubType(nriReviewVm.reiewData.occupationSubtype).value;
                } else {
                    nriReviewVm.selectedOccupationSubType = null;
                }

    
                if (nriReviewVm.reiewData.nomineeRequired) {
                    nriReviewVm.nomineeRequired = "Yes";
                    nriReviewVm.nomineeCountry = NRIAOService.getCountryName(nriReviewVm.reiewData.nomineeDetail.nomineeAddress.country).name;

                    if(nriReviewVm.reiewData.nomineeDetail.guardianName){
                        nriReviewVm.guardian = true;
                        if (nriReviewVm.reiewData.nomineeDetail.sameAddressGuardian) {
                            nriReviewVm.nomineeAddr = 'C';
                            nriReviewVm.nomineeAddr1 = nriReviewVm.reiewData.nomineeDetail.nomineeAddress.addressLine1;
                            nriReviewVm.guardiancity = nriReviewVm.reiewData.nomineeDetail.nomineeAddress.city;
                            nriReviewVm.nomineestate = nriReviewVm.reiewData.nomineeDetail.nomineeAddress.state;
                            nriReviewVm.nomineePinCode = nriReviewVm.reiewData.nomineeDetail.nomineeAddress.pincode;
                            nriReviewVm.countrySel = NRIAOService.getCountryName(nriReviewVm.reiewData.nomineeDetail.nomineeAddress.country).name;
                        } else {
                            nriReviewVm.nomineeAddr = 'N';
                            nriReviewVm.nomineeAddr1 = nriReviewVm.reiewData.nomineeDetail.guardianAddress.addressLine1;
                            nriReviewVm.nomineeAddr2 = nriReviewVm.reiewData.nomineeDetail.guardianAddress.addressLine2;
                            nriReviewVm.guardiancity = nriReviewVm.reiewData.nomineeDetail.guardianAddress.city;
                            nriReviewVm.nomineestate = nriReviewVm.reiewData.nomineeDetail.guardianAddress.state;
                            nriReviewVm.nomineePinCode = nriReviewVm.reiewData.nomineeDetail.guardianAddress.pincode;
                            nriReviewVm.countrySel = NRIAOService.getCountryName(nriReviewVm.reiewData.nomineeDetail.guardianAddress.country).name;
                        }
    
                    } else {
                        nriReviewVm.guardian = false;
                    }
                } else {
                    nriReviewVm.nomineeRequired = "No";
                }

            }

            nriReviewVm.getCountryName = function (code) {
                for (var i = 0; i < NRIAOService.countryMaster.length; i++) {
                    if (NRIAOService.countryMaster[i].code == code) {
                        return NRIAOService.countryMaster[i];
                    }
                }
            }
            nriReviewVm.getTitle = function (code) {
                for (var i = 0; i < NRIAOService.keyValueMap.TitleMaster.length; i++) {
                    if (NRIAOService.keyValueMap.TitleMaster[i].key == code) {
                        return NRIAOService.keyValueMap.TitleMaster[i];
                    }
                }
            };
            nriReviewVm.taxIdentification = function (code) {
                for (var i = 0; i < NRIAOService.keyValueMap.TaxResidenceProofMaster.length; i++) {
                    if (NRIAOService.keyValueMap.TaxResidenceProofMaster[i].key == code) {
                        return NRIAOService.keyValueMap.TaxResidenceProofMaster[i];
                    }
                }
            }

            nriReviewVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    NRIAOService.review = false;
                    if (!NRIAOService.resumeNRIresponse.branchPref) {
                        $state.go('menu.gncHomeBranchSelectionNRI');
                    } else {
                        $state.go("menu.taxationDetailsNRI");
                    }
                } else {
                    NRIAOService.review = false;
                    $ionicHistory.goBack();
                }
            }
            nriReviewVm.openEdit = function (page) {
                NRIAOService.review = true;
                if (page == "PCC_Detail") {

                    $state.go("menu.personalPanDetailsPage");

                } else if (page == "PERSONAL_Detail") {

                    $state.go("menu.additionalPersonalDetailsNRI");

                } else if (page == "Passport_Detail" || page == "Visa_Detail") {
                    NRIAOService.pageTabPass = page;
                    $state.go("menu.passportVisaDetailsNRI");

                } else if (page == "Current_address") {

                    $state.go("menu.nriCurrentAddressDetailPage");

                }
                else if (page == "Additional_Details" || page == "Contact_Details") {
                    NRIAOService.pageTabAdd = page;
                    $state.go("menu.nriAdditionalDetails");

                } else if (page == "Education_Qualification") {

                    $state.go('menu.nriEduPage');

                } else if (page == "Nomination") {

                    $state.go("menu.nriNominationDetails");

                } else if (page == "Guardian") {

                    $state.go("menu.guardianDetailsNRI");

                } else if (page == "AccountService") {

                    $state.go("menu.nriAccountServicePage");

                } else if (page == "Taxation") {

                    $state.go("menu.taxationDetailsNRI");

                } else if (page == "ACC_Detail") {

                    $state.go("menu.accTypeStatusPages");

                }
            }
            nriReviewVm.submitReviewData = function () {

                if (nriReviewVm.reiewData.nomineeDetail != null) {

                    if (nriReviewVm.accountDetailCardReview && nriReviewVm.personalDetailCardReview && nriReviewVm.passportDetailCardReview
                        && nriReviewVm.currentaddressDetailCardReview && nriReviewVm.additionalDetailCardReview && nriReviewVm.nominationDetailCardReview
                        && nriReviewVm.accountServicesCardReview && nriReviewVm.taxationDetailCardReview) {
                        $state.go("menu.tncNRI");
                    } else {
                        utilityService.showBhimUpiAlert("", "Kindly open all sections and review all details", "", "", "");
                    }
                }
                else {
                    if (nriReviewVm.accountDetailCardReview && nriReviewVm.personalDetailCardReview && nriReviewVm.passportDetailCardReview
                        && nriReviewVm.currentaddressDetailCardReview && nriReviewVm.additionalDetailCardReview
                        && nriReviewVm.accountServicesCardReview && nriReviewVm.taxationDetailCardReview) {
                        $state.go("menu.tncNRI");
                    } else {
                        utilityService.showBhimUpiAlert("", "Kindly open all sections and review all details", "", "", "");
                    }
                }

            }   
            
            nriReviewVm.toggleContent = function (selectedVal) {
                if (selectedVal == 'Account_Details') {
                    nriReviewVm.accountCardOpened = true;
                    nriReviewVm.accountDetailCard = true;
                    nriReviewVm.accountDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;
                } else if (selectedVal == 'Personal_Details') {
                    nriReviewVm.personalCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.personalDetailCardReview = true;
                    nriReviewVm.personalDetailCard = true;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;
                } else if (selectedVal == 'Passport_Details') {
                    nriReviewVm.passportCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.passportDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = true;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;
                } else if (selectedVal == 'Current_address_Details') {
                    nriReviewVm.addressCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.currentaddressDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = true;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                }
                else if (selectedVal == 'Additional_Details') {
                    nriReviewVm.additionalDetCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.additionalDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = true;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;
                } else if (selectedVal == 'Nomination_Details') {
                    nriReviewVm.nominationDetCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.nominationDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = true;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;

                } else if (selectedVal == 'Account_Services') {
                    nriReviewVm.accountServicesCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.accountServicesCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    if (nriReviewVm.reiewData["nreAccountDetail"] && nriReviewVm.reiewData["nroAccountDetail"]) {
                        nriReviewVm.accountServicesCardNre = true;
                        nriReviewVm.accountServicesCardNro = true
                    } else if (nriReviewVm.reiewData["nreAccountDetail"]) {
                        nriReviewVm.accountServicesCardNre = true;
                    } else {
                        nriReviewVm.accountServicesCardNro = true;
                    }
                    nriReviewVm.taxationDetailCard = false;
                    nriReviewVm.currentaddressDetailCard = false;
                } else if (selectedVal == 'Taxation_Details') {
                    nriReviewVm.taxationDetailCardOpened = true;
                    nriReviewVm.accountDetailCard = false;
                    nriReviewVm.taxationDetailCardReview = true;
                    nriReviewVm.personalDetailCard = false;
                    nriReviewVm.passportDetailCard = false;
                    nriReviewVm.addressDetailCard = false;
                    nriReviewVm.additionalDetailCard = false;
                    nriReviewVm.nominationDetailCard = false;
                    nriReviewVm.accountServicesCardNre = false;
                    nriReviewVm.accountServicesCardNro = false;
                    nriReviewVm.taxationDetailCard = true;
                    nriReviewVm.currentaddressDetailCard = false;
                }
            }


        }
    ]);