'use strict';

angularApp.controller('otpInitialNRIAOController', ["$state",
    "$scope",
    "NRIAOService",
    "utilityService",
    "$ionicPopover",
    function ($state,
        $scope,
        NRIAOService,
        utilityService,
        $ionicPopover) {

        var otpInitialNRIAOVm = this;

        function initPage() {


            $scope.regex = /^[a-z0-9A-Z.\-_]{6,30}@[A-Za-z0-9.\-_]+\.[A-Za-z]{2,}$/
            otpInitialNRIAOVm.countryMandatoryError = false;
            otpInitialNRIAOVm.mobileMandatoryError = false;
            otpInitialNRIAOVm.mobilePatternError = false;
            otpInitialNRIAOVm.mailMandatoryError = false;
            otpInitialNRIAOVm.mailPatternError = false;
            otpInitialNRIAOVm.getInfoMsg = "Email id is mandatory";
            if(utilityService.isAndroidPlatform()){
                otpInitialNRIAOVm.template = '<ion-popover-view class="tooltiptext ao-NRI-long-popupInfo-email roboto-regular">' + '<ion-content>' +
                '<div class="" ng-bind="otpInitialNRIAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';
    
            }
            else if(utilityService.isIOSPlatform()){
                otpInitialNRIAOVm.template = '<ion-popover-view class="tooltiptext ao-NRI-long-popupInfo-email-ios roboto-regular">' + '<ion-content>' +
                '<div class="" ng-bind="otpInitialNRIAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';
            }

            $scope.popover = $ionicPopover.fromTemplate(otpInitialNRIAOVm.template, {
                scope: $scope
            });
        }


        otpInitialNRIAOVm.infoPopup = function ($event) {
           
            $scope.popover.show($event);

        };


        otpInitialNRIAOVm.goBack = function () {
            $state.go('menu.newToSbiLanding');
        }
        $scope.goToHome = function () {
            $state.go('menu.otpInitialNRIAO');

        }



        otpInitialNRIAOVm.goToOTPValid = function () {
            otpInitialNRIAOVm.checkFormValid();

            if (!otpInitialNRIAOVm.countryMandatoryError && !otpInitialNRIAOVm.mobileMandatoryError && !otpInitialNRIAOVm.mobilePatternError
                && !otpInitialNRIAOVm.mailMandatoryError && !otpInitialNRIAOVm.mailPatternError) {
                NRIAOService.countryCode = otpInitialNRIAOVm.countryCode;
                NRIAOService.mobile = otpInitialNRIAOVm.newMobile;
                NRIAOService.emailId = otpInitialNRIAOVm.newMail;
                var requestParams = {
                    "id": NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "recipientMailId": NRIAOService.emailId,
                    "sendOTPFlg": "BOTH"
                }

                NRIAOService.getOtp(requestParams).then(function (response) {
                    if (response.responseCode === "0000") {

                        $state.go('menu.enterEmailOTPPageNRIAO');

                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }


        }


        otpInitialNRIAOVm.isNotNullOrUndefined = function (varNull) {
            return (varNull != null && varNull != undefined && varNull != "");
        }



        otpInitialNRIAOVm.checkFormValid = function () {


            var countryCodeNotNull = otpInitialNRIAOVm.isNotNullOrUndefined(otpInitialNRIAOVm.countryCode);
            var newMobileNotNull = otpInitialNRIAOVm.isNotNullOrUndefined(otpInitialNRIAOVm.newMobile);
            var newMailNull = otpInitialNRIAOVm.isNotNullOrUndefined(otpInitialNRIAOVm.newMail);


            if (countryCodeNotNull) {
                otpInitialNRIAOVm.countryMandatoryError = false;
            }
            else {
                otpInitialNRIAOVm.countryMandatoryError = true;
            }


            if (newMobileNotNull) {

                otpInitialNRIAOVm.mobileMandatoryError = false;

                otpInitialNRIAOVm.mobileLen = otpInitialNRIAOVm.newMobile.toString();
                if (otpInitialNRIAOVm.mobileLen.length < 8 || otpInitialNRIAOVm.mobileLen.length > 15) {
                    otpInitialNRIAOVm.mobilePatternError = true;

                }
                else {
                    otpInitialNRIAOVm.mobilePatternError = false;
                }
            }
            else {
                otpInitialNRIAOVm.mobileMandatoryError = true;
                otpInitialNRIAOVm.mobilePatternError = false;

            }

            if (newMailNull) {

                otpInitialNRIAOVm.mailMandatoryError = false;
                if (otpInitialNRIAOVm.newMail.match($scope.regex)) {
                    let textArray = otpInitialNRIAOVm.newMail.split('@');
                    if (textArray[1] == 'sbi.co.in' || textArray[1] == 'SBI.CO.IN') {
                        otpInitialNRIAOVm.mailPatternError = true;

                    }
                    else {
                        otpInitialNRIAOVm.mailPatternError = false;

                    }
                }
                else {
                    otpInitialNRIAOVm.mailPatternError = true;

                }



            }
            else {
                otpInitialNRIAOVm.mailMandatoryError = true;
                otpInitialNRIAOVm.mailPatternError = false;

            }



        }

        //get country code master
        otpInitialNRIAOVm.getCountryList = function () {

            NRIAOService.getISDCode().then(function (response) {
                utilityService.hideSpinner();
                otpInitialNRIAOVm.countryCodeObj = response.data.code;

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            otpInitialNRIAOVm.getOtpForm.$setPristine();
            //    To be changed to
            otpInitialNRIAOVm.countryCode = "";
            otpInitialNRIAOVm.newMobile = "";
            otpInitialNRIAOVm.newMail = "";
            NRIAOService.resumeNRIresponse = null;
            NRIAOService.clearServiceData();
            utilityService.showSpinner();
            otpInitialNRIAOVm.getCountryList();



        });

        return this;
    }
]);
