'use strict';

angularApp.controller('otpVerificationSubmissionController', ["$state",
	"$scope",
	"$translate",
	"utilityService",
	"NRIAOService",
	"autoOtpReadService",
	"$ionicHistory",
	function ($state,
		$scope,
		$translate,
		utilityService,
		NRIAOService,
		autoOtpReadService,
		$ionicHistory) {

		var otpVerficatiosubmissionVm = this;



		function initPage() {
			otpVerficatiosubmissionVm.mobileNumber = NRIAOService.countryCode + NRIAOService.mobile

		}

		$scope.goToHome = function () {
			$ionicHistory.goBack();
		}


		otpVerficatiosubmissionVm.validateOTP = function (isValid) {
			otpVerficatiosubmissionVm.disableNext = !isValid;
		}
		$translate('AO_OK_LABEL').then(function (translatedvalue) {
			otpVerficatiosubmissionVm.okBtntext = translatedvalue;
		});
		otpVerficatiosubmissionVm.invokeGetOTPService = function () {
			var requestParams = {
				"id": NRIAOService.mobile,
				"isdCode": NRIAOService.countryCode,
				"recipientMailId": NRIAOService.emailId ? NRIAOService.emailId : null,
				"sendOTPFlg": "mobileOnly"
			}
			NRIAOService.getOtp(requestParams).then(function (response) {
				if (response.responseCode === "0000") {
					if (utilityService.isAndroidPlatform()) {
						autoOtpReadService.startOtpReading().then(function (result) {
							otpVerficatiosubmissionVm.otpvalue = result;
							otpVerficatiosubmissionVm.disableNext = false;
						}, function (error) {
							utilityService.showErrorMessage(error);
						});
					}
					else {
						var title = '';
						var template = '{{"OTP_SENT_SUCCESS" | translate}}';
						var onTap = '';
						var buttontext = '<b>' + otpVerficatiosubmissionVm.okBtntext + '</b>';
						utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					}
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

		}



		/* resend OTP */

		otpVerficatiosubmissionVm.requestOtpCallOnce = function () {
			otpVerficatiosubmissionVm.resendOtp();
		}

		otpVerficatiosubmissionVm.resendOtp = function () {
			var requestParams = {
				"id": NRIAOService.mobile,
				"isdCode": NRIAOService.countryCode,
				"recipientMailId": NRIAOService.emailId ? NRIAOService.emailId : "",
				"sendOTPFlg": "mobileOnly"
			}
			NRIAOService.resendOTP(requestParams).then(function (response) {
				NRIAOService.requestNo = response.data;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		otpVerficatiosubmissionVm.goToNextPage = function () {
			var payload = {
				"otp": otpVerficatiosubmissionVm.otp,
				"mobile": NRIAOService.countryCode + NRIAOService.mobile,
				"journeyName": "AO_NRI",
				"data": {
					"commonId": null
				}
			}
			NRIAOService.validateOtp(payload).then(function (response) {
				if (response.responseCode === "0000") {
					otpVerficatiosubmissionVm.submitNriApplication()
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

		}
		otpVerficatiosubmissionVm.submitNriApplication = function () {
			var payload = {
				"id": NRIAOService.countryCode + NRIAOService.mobile,
				"requestNo": NRIAOService.requestNo,
				"payload": {
					"requestNo": NRIAOService.requestNo,
					"requestStatus": "Draft",
				}
			}

			NRIAOService.submitApplication(payload).then(function (response) {
				if (response.responseCode === "0000") {

					if (NRIAOService.resumeNRIresponse.branchPref) {
						NRIAOService.ValidUptoAppdate = response.date;
					}

					if (!NRIAOService.resumeNRIresponse.branchPref) {
						NRIAOService.gncResponseSuccess = response.sucessContent;
					}
					$state.go("menu.applicationSubmitedNRI");
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			otpVerficatiosubmissionVm.invokeGetOTPService();
			initPage();
		});
		return this;
	}
]);
