'use strict';

angularApp.controller('passportVisaDetailsNRIController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",
        "$ionicPopup",
        function ($state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService,
            $ionicPopup) {
            var passportVisaDetailsNRIVm = this;



            passportVisaDetailsNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.additionalPersonalDetailsNRI");
                } else {
                    $ionicHistory.goBack();
                }
            }


            passportVisaDetailsNRIVm.toggleContent = function (item) {

                if (item == 'addPassportDetails') {
                    passportVisaDetailsNRIVm.toggleCard = 'PD';
                } else if (item == 'addVisaDetails') {
                    passportVisaDetailsNRIVm.validatePassportDetails();
                    passportVisaDetailsNRIVm.toggleCard = 'VD';
                }
            }



            $scope.$on('$ionicView.loaded', function () {
                passportVisaDetailsNRIVm.valuetocheck = "IN";
                passportVisaDetailsNRIVm.toggleCard = 'PD';
                passportVisaDetailsNRIVm.addPassportDetailsShowError = "";
                passportVisaDetailsNRIVm.addVisaDetailsShowError = "";
                passportVisaDetailsNRIVm.addMotherDetailsShowError = "";
                passportVisaDetailsNRIVm.dedupConsentFlag = false;
                passportVisaDetailsNRIVm.citizenshipObj = NRIAOService.countryMaster;
                passportVisaDetailsNRIVm.addressOnPassportObj = NRIAOService.masterList.AddressTypeMaster;
                passportVisaDetailsNRIVm.applicantStatus = NRIAOService.applicantStatus;
                passportVisaDetailsNRIVm.disableValidTill = false;
                if (NRIAOService.isPIO) {
                    passportVisaDetailsNRIVm.pio = true
                    passportVisaDetailsNRIVm.nationalitylist = NRIAOService.countryMaster;
                    passportVisaDetailsNRIVm.nationalityvalue = "";
                } else {
                    passportVisaDetailsNRIVm.pio = false
                    passportVisaDetailsNRIVm.nationalityname = "INDIAN"
                    passportVisaDetailsNRIVm.nationalityvalue = "IN"
                }

                if (passportVisaDetailsNRIVm.applicantStatus == 'NRI' || passportVisaDetailsNRIVm.applicantStatus == 'NRI-Seafarer') {
                    passportVisaDetailsNRIVm.disableValidTill = false;
                } else {
                    passportVisaDetailsNRIVm.disableValidTill = true;
                    passportVisaDetailsNRIVm.visavalidtill = null;
                }

            });



            passportVisaDetailsNRIVm.initPage = function () {

                passportVisaDetailsNRIVm.supportNumberOne = NRIAOService.supportNumberOne;
                passportVisaDetailsNRIVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                passportVisaDetailsNRIVm.supportNumberThree = NRIAOService.supportNumberThree;
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    passportVisaDetailsNRIVm.applicantStatus = NRIAOService.resumeNRIresponse.applicantStatus;
                    if (NRIAOService.resumeNRIresponse.passportVisaDetail) {
                        passportVisaDetailsNRIVm.passportNo = NRIAOService.resumeNRIresponse.passportVisaDetail.passportNumber
                        passportVisaDetailsNRIVm.dateofIssuePassport = NRIAOService.resumeNRIresponse.passportVisaDetail.issuedDate
                        passportVisaDetailsNRIVm.validtillPassport = NRIAOService.resumeNRIresponse.passportVisaDetail.validUpto
                        passportVisaDetailsNRIVm.placeOfIssuePassport = NRIAOService.resumeNRIresponse.passportVisaDetail.issuedPlace
                        if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                            passportVisaDetailsNRIVm.pio = true;
                            passportVisaDetailsNRIVm.nationalitylist = NRIAOService.countryMaster;
                            if (NRIAOService.resumeNRIresponse.passportVisaDetail.nationality == "IN") {
                                passportVisaDetailsNRIVm.nationalityvalue = "";
                            }
                            else {
                                passportVisaDetailsNRIVm.nationalityvalue = NRIAOService.resumeNRIresponse.passportVisaDetail.nationality;
                            }


                        } else {
                            passportVisaDetailsNRIVm.pio = false;
                            passportVisaDetailsNRIVm.nationalityvalue = "IN";
                            passportVisaDetailsNRIVm.nationalityname = "INDIAN";
                        }
                        passportVisaDetailsNRIVm.citizenship = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.passportVisaDetail.citizenship)
                        passportVisaDetailsNRIVm.addressOnPassport = NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType
                        passportVisaDetailsNRIVm.visaPIONo = NRIAOService.resumeNRIresponse.passportVisaDetail.visaOciNo
                        passportVisaDetailsNRIVm.dateofIssueVisa = NRIAOService.resumeNRIresponse.passportVisaDetail.visaIssuedDate
                        if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                            passportVisaDetailsNRIVm.validtillVisa = null;
                        }
                        else {
                            passportVisaDetailsNRIVm.validtillVisa = NRIAOService.resumeNRIresponse.passportVisaDetail.visaValidUpto
                        }

                        passportVisaDetailsNRIVm.placeOfIssueVisa = NRIAOService.resumeNRIresponse.passportVisaDetail.visaIssuedPlace
                    } else {
                        if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                            passportVisaDetailsNRIVm.pio = true;
                            passportVisaDetailsNRIVm.nationalitylist = NRIAOService.countryMaster;
                            passportVisaDetailsNRIVm.nationalityvalue = ""
                        } else {
                            passportVisaDetailsNRIVm.pio = false;
                            passportVisaDetailsNRIVm.nationalityvalue = "IN";
                            passportVisaDetailsNRIVm.nationalityname = "INDIAN";
                        }


                    }
                    var pageTabPassNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(NRIAOService.pageTabPass);
                    if(pageTabPassNotNull){
                        if(NRIAOService.pageTabPass == "Visa_Detail"){
                            passportVisaDetailsNRIVm.toggleCard = 'VD';
                        }
                        if(NRIAOService.pageTabPass == "Passport_Detail"){
                            passportVisaDetailsNRIVm.toggleCard = 'PD';
                        }
                    }
                }
                else{
                    passportVisaDetailsNRIVm.applicantStatus = NRIAOService.applicantStatus;
                    if (passportVisaDetailsNRIVm.applicantStatus == "PIO") {
                        passportVisaDetailsNRIVm.validtillVisa = null;
                    }
                }
            }




            passportVisaDetailsNRIVm.openDatePickerIssuePassport = function () {
                $scope.dateOptionsPassportIssue = {
                    maxDate: new Date(),
                    minDate: (new Date().setYear(new Date().getFullYear() - 99)),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="passportVisaDetailsNRIVm.dateDOBobj.dtPs" max-date="dateOptionsPassportIssue.maxDate" min-date="dateOptionsPassportIssue.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            passportVisaDetailsNRIVm.dateofIssuePassport = passportVisaDetailsNRIVm.dateDOBobj.dtPs;
                        }
                    }],
                });

            };


            passportVisaDetailsNRIVm.openDatePickerValidTillPassport = function () {
                $scope.dateOptionsPassportValidity = {
                    maxDate: (new Date().setYear(new Date().getFullYear() + 30)),
                    minDate: new Date(),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="passportVisaDetailsNRIVm.dateDOBobj.dtPv" max-date="dateOptionsPassportValidity.maxDate" min-date="dateOptionsPassportValidity.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            passportVisaDetailsNRIVm.validtillPassport = passportVisaDetailsNRIVm.dateDOBobj.dtPv;
                        }
                    }],
                });

            };
            passportVisaDetailsNRIVm.openDatePickerIssueVisa = function () {
                $scope.dateOptionsVisaIssue = {
                    maxDate: new Date(),
                    minDate: (new Date().setYear(new Date().getFullYear() - 99)),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="passportVisaDetailsNRIVm.dateDOBobj.dtVs" max-date="dateOptionsVisaIssue.maxDate" min-date="dateOptionsVisaIssue.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            passportVisaDetailsNRIVm.dateofIssueVisa = passportVisaDetailsNRIVm.dateDOBobj.dtVs;
                        }
                    }],
                });

            };
            passportVisaDetailsNRIVm.openDatePickerValidTillVisa = function () {
                $scope.dateOptionsVisaValidity = {
                    maxDate: (new Date().setYear(new Date().getFullYear() + 30)),
                    minDate: new Date(),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="passportVisaDetailsNRIVm.dateDOBobj.dtVv" max-date="dateOptionsVisaValidity.maxDate" min-date="dateOptionsVisaValidity.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            passportVisaDetailsNRIVm.validtillVisa = passportVisaDetailsNRIVm.dateDOBobj.dtVv;
                        }
                    }],
                });

            };


            passportVisaDetailsNRIVm.validatePassportDetails = function () {
                if (passportVisaDetailsNRIVm.pio) {
                    if (passportVisaDetailsNRIVm.addPassportVisaDetailsForm.passportNumber.$valid && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.placeOfIssuePassport.$valid
                        && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.nationality.$valid && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.citizenship.$valid
                        && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.addressOnPassport.$valid && passportVisaDetailsNRIVm.dateofIssuePassport!= null && passportVisaDetailsNRIVm.validtillPassport!= null) {
                        passportVisaDetailsNRIVm.addPassportDetailsShowError = "NO";
                    }
                    else {
                        passportVisaDetailsNRIVm.addPassportDetailsShowError = "YES";
                        passportVisaDetailsNRIVm.toggleCard = 'PD';
                    }
                } else {
                    if (passportVisaDetailsNRIVm.addPassportVisaDetailsForm.passportNumber.$valid && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.placeOfIssuePassport.$valid
                        && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.citizenship.$valid
                        && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.addressOnPassport.$valid && passportVisaDetailsNRIVm.dateofIssuePassport!= null && passportVisaDetailsNRIVm.validtillPassport!= null) {
                        passportVisaDetailsNRIVm.addPassportDetailsShowError = "NO";
                    }
                    else {
                        passportVisaDetailsNRIVm.addPassportDetailsShowError = "YES";
                        passportVisaDetailsNRIVm.toggleCard = 'PD';
                    }
                }

            }


            passportVisaDetailsNRIVm.validateVisaDetails = function () {
                if(passportVisaDetailsNRIVm.applicantStatus == 'PIO'){
                     if (passportVisaDetailsNRIVm.addPassportVisaDetailsForm.visaPIONo.$valid && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.placeOfIssueVisa.$valid
                         && passportVisaDetailsNRIVm.dateofIssueVisa != null) {
                        passportVisaDetailsNRIVm.addVisaDetailsShowError = "NO";
                      }
                        else {
                            passportVisaDetailsNRIVm.addVisaDetailsShowError = "YES";
                            passportVisaDetailsNRIVm.toggleCard = 'VD';
                        }
                }else{
                    if (passportVisaDetailsNRIVm.addPassportVisaDetailsForm.visaPIONo.$valid && passportVisaDetailsNRIVm.addPassportVisaDetailsForm.placeOfIssueVisa.$valid
                        && passportVisaDetailsNRIVm.dateofIssueVisa != null &&  passportVisaDetailsNRIVm.validtillVisa!= null) {
                        passportVisaDetailsNRIVm.addVisaDetailsShowError = "NO";
                    }
                    else {
                        passportVisaDetailsNRIVm.addVisaDetailsShowError = "YES";
                        passportVisaDetailsNRIVm.toggleCard = 'VD';
                    }
                }
                
            }


            passportVisaDetailsNRIVm.isNotNullOrUndefined = function (varNull) {
                return (varNull != null && varNull != undefined && varNull != "");
            }

            passportVisaDetailsNRIVm.checkValidityExpiry = function (date) {
                var date1 = new Date(date);
                var date2 = new Date();
                var Time = date1.getTime() - date2.getTime();
                return (Time / (1000 * 3600 * 24));
            }
            passportVisaDetailsNRIVm.redirectingToNextPage = function () { 
                passportVisaDetailsNRIVm.toggleCard = "";
                if (typeof (passportVisaDetailsNRIVm.dateofIssuePassport) === "object") {
                    passportVisaDetailsNRIVm.issueofdatePassport = passportVisaDetailsNRIVm.dateofIssuePassport.getFullYear() + "-" + ('0' + (passportVisaDetailsNRIVm.dateofIssuePassport.getMonth() + 1)).slice(-2) + "-" + ('0' + passportVisaDetailsNRIVm.dateofIssuePassport.getDate()).slice(-2)
                } else {
                    passportVisaDetailsNRIVm.issueofdatePassport = passportVisaDetailsNRIVm.dateofIssuePassport
                }
                if (typeof (passportVisaDetailsNRIVm.validtillPassport) === "object") {
                    passportVisaDetailsNRIVm.passportValidity = passportVisaDetailsNRIVm.validtillPassport.getFullYear() + "-" + ('0' + (passportVisaDetailsNRIVm.validtillPassport.getMonth() + 1)).slice(-2) + "-" + ('0' + passportVisaDetailsNRIVm.validtillPassport.getDate()).slice(-2);
                } else {
                    passportVisaDetailsNRIVm.passportValidity = passportVisaDetailsNRIVm.validtillPassport
                }
                if (typeof (passportVisaDetailsNRIVm.dateofIssueVisa) === "object") {
                    passportVisaDetailsNRIVm.issueofdateVisa = passportVisaDetailsNRIVm.dateofIssueVisa.getFullYear() + "-" + ('0' + (passportVisaDetailsNRIVm.dateofIssueVisa.getMonth() + 1)).slice(-2) + "-" + ('0' + passportVisaDetailsNRIVm.dateofIssueVisa.getDate()).slice(-2);
                } else {
                    passportVisaDetailsNRIVm.issueofdateVisa = passportVisaDetailsNRIVm.dateofIssueVisa
                }
                if (passportVisaDetailsNRIVm.validtillVisa != null && passportVisaDetailsNRIVm.validtillVisa != undefined && passportVisaDetailsNRIVm.validtillVisa != "") {
                    if (typeof (passportVisaDetailsNRIVm.validtillVisa) === "object") {
                        passportVisaDetailsNRIVm.visavalidtill = passportVisaDetailsNRIVm.validtillVisa.getFullYear() + "-" + ('0' + (passportVisaDetailsNRIVm.validtillVisa.getMonth() + 1)).slice(-2) + "-" + ('0' + passportVisaDetailsNRIVm.validtillVisa.getDate()).slice(-2);
                    } else {
                        passportVisaDetailsNRIVm.visavalidtill = passportVisaDetailsNRIVm.validtillVisa
                    }
                }


               if(passportVisaDetailsNRIVm.applicantStatus == 'PIO'){
                   if(passportVisaDetailsNRIVm.issueofdatePassport!= null && passportVisaDetailsNRIVm.passportValidity!= null && passportVisaDetailsNRIVm.issueofdateVisa != null){
                          var requestCreateApp = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "requestNo": NRIAOService.requestNo,
                            "review": NRIAOService.review,
                            "dedupConsentFlag":passportVisaDetailsNRIVm.dedupConsentFlag,
                            "payload": {
                                "passportAddType": passportVisaDetailsNRIVm.addressOnPassport,
                                "passportNumber": passportVisaDetailsNRIVm.passportNo ? passportVisaDetailsNRIVm.passportNo.toUpperCase() : passportVisaDetailsNRIVm.passportNo,
                                "issuedPlace": passportVisaDetailsNRIVm.placeOfIssuePassport,
                                "issuedDate": passportVisaDetailsNRIVm.issueofdatePassport,
                                "validUpto": passportVisaDetailsNRIVm.passportValidity,
                                "nationality": passportVisaDetailsNRIVm.nationalityvalue,
                                "citizenship": passportVisaDetailsNRIVm.citizenship.code,
                                "visaOciNo": passportVisaDetailsNRIVm.visaPIONo,
                                "visaIssuedDate": passportVisaDetailsNRIVm.issueofdateVisa,
                                "visaValidUpto": passportVisaDetailsNRIVm.visavalidtill ? passportVisaDetailsNRIVm.visavalidtill : null,
                                "visaIssuedPlace": passportVisaDetailsNRIVm.placeOfIssueVisa
                            
                            }
                        }


                        NRIAOService.savePassportApplication(requestCreateApp).then(function (response) {
                            if (response.responseCode == '0000') {
                                NRIAOService.addressOnPassport = passportVisaDetailsNRIVm.addressOnPassport
                                if (NRIAOService.addressOnPassport == 'Current Address' || NRIAOService.addressOnPassport == 'Permanent Address' || NRIAOService.addressOnPassport == 'Other Address') {
                                    NRIAOService.addressProof = "Passport"
                                    NRIAOService.idNumber = passportVisaDetailsNRIVm.passportNo;

                                }
                                NRIAOService.requestNo = response.data;
                                if (response.statusCode == "00") {
                                    passportVisaDetailsNRIVm.getUpdatedData();

                                }
                                else if (response.statusCode == "02") {

                                    NRIAOService.showAlertPopup("error", response.caseList[0], response.caseList[1], "", "Close", "", "");
                                }
                                else if (response.statusCode == "03") {
                                


                                    passportVisaDetailsNRIVm.parameterOne = response.caseList[0]; 
                                    passportVisaDetailsNRIVm.parameterTwo = response.caseList[1];
                                    passportVisaDetailsNRIVm.parameterThree = response.caseList[2];


                                    passportVisaDetailsNRIVm.declarationPopUp = $ionicPopup.show({
                                        templateUrl: 'pages/accountOpening/accountOpeningNRI/dedupDeclaration.html',
                                        title: '',
                                        cssClass: 'bhim-alert-popup',
                                        scope: $scope,
                                    });
                                }
                                else if (response.statusCode == "04") {
                                    utilityService.showErrorMessage(response.responseMessage);
                                }

                            }
                        }, function (error) {

                            utilityService.showErrorMessage(error.responseMessage);
                        });
                   }

               }
               else{
                if(passportVisaDetailsNRIVm.issueofdatePassport!= null && passportVisaDetailsNRIVm.passportValidity!= null && passportVisaDetailsNRIVm.issueofdateVisa != null
                    && (passportVisaDetailsNRIVm.visavalidtill!= null || passportVisaDetailsNRIVm.visavalidtill!= "" || passportVisaDetailsNRIVm.visavalidtill!= undefined) ){
                            var requestCreateApp = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                            "requestNo": NRIAOService.requestNo,
                            "review": NRIAOService.review,
                            "dedupConsentFlag":passportVisaDetailsNRIVm.dedupConsentFlag,
                            "payload": {
                                "passportAddType": passportVisaDetailsNRIVm.addressOnPassport,
                                "passportNumber": passportVisaDetailsNRIVm.passportNo ? passportVisaDetailsNRIVm.passportNo.toUpperCase() : passportVisaDetailsNRIVm.passportNo,
                                "issuedPlace": passportVisaDetailsNRIVm.placeOfIssuePassport,
                                "issuedDate": passportVisaDetailsNRIVm.issueofdatePassport,
                                "validUpto": passportVisaDetailsNRIVm.passportValidity,
                                "nationality": passportVisaDetailsNRIVm.nationalityvalue,
                                "citizenship": passportVisaDetailsNRIVm.citizenship.code,
                                "visaOciNo": passportVisaDetailsNRIVm.visaPIONo,
                                "visaIssuedDate": passportVisaDetailsNRIVm.issueofdateVisa,
                                "visaValidUpto": passportVisaDetailsNRIVm.visavalidtill,
                                "visaIssuedPlace": passportVisaDetailsNRIVm.placeOfIssueVisa
                            
                            }
                        }

                        NRIAOService.savePassportApplication(requestCreateApp).then(function (response) {
                            if (response.responseCode == '0000') {
                                NRIAOService.addressOnPassport = passportVisaDetailsNRIVm.addressOnPassport
                                if (NRIAOService.addressOnPassport == 'Current Address' || NRIAOService.addressOnPassport == 'Permanent Address' || NRIAOService.addressOnPassport == 'Other Address') {
                                    NRIAOService.addressProof = "Passport"
                                    NRIAOService.idNumber = passportVisaDetailsNRIVm.passportNo;

                                }
                                NRIAOService.requestNo = response.data;
                                if (response.statusCode == "00") {
                                    passportVisaDetailsNRIVm.getUpdatedData();

                                }
                                else if (response.statusCode == "02") {

                                    NRIAOService.showAlertPopup("error", response.caseList[0], response.caseList[1], "", "Close", "", "");
                                }
                                else if (response.statusCode == "03") {
                                


                                    passportVisaDetailsNRIVm.parameterOne = response.caseList[0]; 
                                    passportVisaDetailsNRIVm.parameterTwo = response.caseList[1];
                                    passportVisaDetailsNRIVm.parameterThree = response.caseList[2];


                                    passportVisaDetailsNRIVm.declarationPopUp = $ionicPopup.show({
                                        templateUrl: 'pages/accountOpening/accountOpeningNRI/dedupDeclaration.html',
                                        title: '',
                                        cssClass: 'bhim-alert-popup',
                                        scope: $scope,
                                    });
                                }
                                else if (response.statusCode == "04") {
                                    utilityService.showErrorMessage(response.responseMessage);
                                }

                            }
                        }, function (error) {

                            utilityService.showErrorMessage(error.responseMessage);
                        });
                   }
               }
            
            }

            passportVisaDetailsNRIVm.closeDeclarationPopup = function () {

                if (passportVisaDetailsNRIVm.isConsentChecked) {
                    passportVisaDetailsNRIVm.dedupConsentFlag = true;

                    passportVisaDetailsNRIVm.declarationPopUp.close();
                    passportVisaDetailsNRIVm.redirectingToNextPage();
                }


            }

            passportVisaDetailsNRIVm.gotoAddressDetails = function () {
                var passportNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.passportNo);
                var dateofIssuePassportNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.dateofIssuePassport);
                var validtillPassportNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.validtillPassport);
                var placeOfIssuePassportNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.placeOfIssuePassport);
                var nationalityNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.nationalityvalue);
                var citizenshipNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.citizenship);
                var addressOnPassportNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.addressOnPassport);
                var visaPIONoNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.visaPIONo);
                var dateofIssueVisaNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.dateofIssueVisa);
                var validtillVisaNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.validtillVisa);
                var placeOfIssueVisaNoNotNull = passportVisaDetailsNRIVm.isNotNullOrUndefined(passportVisaDetailsNRIVm.placeOfIssueVisa);


                if (passportNoNotNull && dateofIssuePassportNoNotNull && validtillPassportNoNotNull && placeOfIssuePassportNoNotNull && nationalityNoNotNull && citizenshipNoNotNull && addressOnPassportNoNotNull) {
                    passportVisaDetailsNRIVm.validatePassportDetails();

                    if (passportVisaDetailsNRIVm.checkValidityExpiry(passportVisaDetailsNRIVm.validtillPassport) < 45) {
                        utilityService.showErrorMessage("Validity of Passport /Visa documents is less than 45 days. Please resume the journey after renewal of the same. Application will be valid for 90 days");
                    } else {
                        if (passportVisaDetailsNRIVm.addPassportDetailsShowError == 'NO') {
                            passportVisaDetailsNRIVm.toggleCard = 'VD';
                        }

                        if (visaPIONoNoNotNull && dateofIssueVisaNoNotNull && validtillVisaNoNotNull && placeOfIssueVisaNoNotNull) {

                            passportVisaDetailsNRIVm.validateVisaDetails();
                            if (passportVisaDetailsNRIVm.checkValidityExpiry(passportVisaDetailsNRIVm.validtillVisa) < 45) {
                                utilityService.showErrorMessage("Validity of Passport /Visa documents is less than 45 days. Please resume the journey after renewal of the same. Application will be valid for 90 days");
                            } else {

                                passportVisaDetailsNRIVm.redirectingToNextPage();

                            }

                        }
                        else if (visaPIONoNoNotNull && dateofIssueVisaNoNotNull && placeOfIssueVisaNoNotNull) {

                            passportVisaDetailsNRIVm.validateVisaDetails();
                            if(passportVisaDetailsNRIVm.addVisaDetailsShowError == "NO"){
                                passportVisaDetailsNRIVm.redirectingToNextPage();
                            } 

                        }
                        else {
                            passportVisaDetailsNRIVm.addVisaDetailsShowError = "YES";
                            passportVisaDetailsNRIVm.toggleCard = 'VD';
                        }
                    }

                }
                else {
                    passportVisaDetailsNRIVm.addPassportDetailsShowError = "YES";
                    passportVisaDetailsNRIVm.toggleCard = 'PD';
                }



            }

            passportVisaDetailsNRIVm.getUpdatedData = function () {

                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go('menu.nriCurrentAddressDetailPage');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function () {
                passportVisaDetailsNRIVm.initPage();
            });



        }
    ]);