'use strict';

angularApp.controller('resumeApplicationNRIController',
    ["$state",
        "$scope",
        "NRIAOService",
        "utilityService",
        "$ionicPopup",
        function ($state,
            $scope,
            NRIAOService,
            utilityService,
            $ionicPopup) {
            var resumeApplicationNRIVm = this;



            $scope.$on('$ionicView.loaded', function () {
                resumeApplicationNRIVm.yearOfBirthList = [];
                resumeApplicationNRIVm.countryCode = NRIAOService.countryCode;
                resumeApplicationNRIVm.newMobile = NRIAOService.mobile;
                var todate = new Date();
                resumeApplicationNRIVm.fromYear = todate.getFullYear() - 99;
                resumeApplicationNRIVm.toYear = todate.getFullYear();
                resumeApplicationNRIVm.yearOfBirthChange();
                resumeApplicationNRIVm.errorCountDOBNotMatch = 0;
                resumeApplicationNRIVm.supportNumberOne = NRIAOService.supportNumberOne ;
                resumeApplicationNRIVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                resumeApplicationNRIVm.supportNumberThree = NRIAOService.supportNumberThree;
            });



            resumeApplicationNRIVm.yearOfBirthChange = function () {

                for (var i = resumeApplicationNRIVm.fromYear, j = 0; i <= resumeApplicationNRIVm.toYear && j <= 99; i++, j++) {
                    resumeApplicationNRIVm.yearOfBirthList.push(i);
                }
            }
            resumeApplicationNRIVm.goBack = function () {
                $state.go('menu.otpInitialNRIAO');
            }
            resumeApplicationNRIVm.getAge = function (dob) {
                resumeApplicationNRIVm.birthday = new Date(dob);
                resumeApplicationNRIVm.today = new Date();
                resumeApplicationNRIVm.currentAge = ((resumeApplicationNRIVm.today - resumeApplicationNRIVm.birthday) / (31557600000));
                return resumeApplicationNRIVm.currentAge

            }

            resumeApplicationNRIVm.goTORINRI = function () {
                resumeApplicationNRIVm.passportVisaExipryPopUP.close();
                $state.go('menu.newToSbiLanding');
            }

            resumeApplicationNRIVm.goToPassportPage = function () {
                resumeApplicationNRIVm.passportVisaExipryPopUP.close();
                resumeApplicationNRIVm.getNRIAPP();
            }


            resumeApplicationNRIVm.getNRIAPP = function () {
                var requestParamsNriAppExist = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile
                }
                NRIAOService.showReviewDetails(requestParamsNriAppExist).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeApplication = true;
                        NRIAOService.resumeNRIresponse = response.data;

                        resumeApplicationNRIVm.resumeNRIresponse = NRIAOService.resumeNRIresponse;
                        NRIAOService.requestNo = NRIAOService.resumeNRIresponse.requestNo;
                        if (NRIAOService.resumeNRIresponse.applicantStatus == 'PIO') {
                            NRIAOService.isPIO = true
                        } else {
                            NRIAOService.isPIO = false
                        }

                        var requestParamsMaster = {
                            "id": NRIAOService.countryCode + NRIAOService.mobile,
                        }
                        NRIAOService.getallMasterData(requestParamsMaster).then(function (responseMaster) {
                            NRIAOService.allMaster = responseMaster.data;
                            NRIAOService.masterList = NRIAOService.allMaster.masterList;
                            NRIAOService.keyValueMap = NRIAOService.allMaster.keyValueMap;
                            NRIAOService.supportNumber = NRIAOService.allMaster.supportNumber;
                            NRIAOService.supportNumberOne = NRIAOService.supportNumber[0];
                            NRIAOService.supportNumberTwo = NRIAOService.supportNumber[1];
                            NRIAOService.supportNumberThree = NRIAOService.supportNumber[2];

                            NRIAOService.countryNames(requestParamsMaster).then(function (responseCountryMaster) {
                                NRIAOService.countryMaster = responseCountryMaster.data;

                                NRIAOService.stateNames(requestParamsMaster).then(function (responseCountryMaster) {
                                    NRIAOService.stateMasterdata = responseCountryMaster.payLoad;

                                    if (resumeApplicationNRIVm.NRIStatusCode == '00') {


                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "PAN_DATA") {
                                            $state.go('menu.fatcaDeclarationNRI');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "FATCA_CNF") {
                                            $state.go('menu.additionalPersonalDetailsNRI');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "PERSONAL_DATA") {
                                            $state.go('menu.passportVisaDetailsNRI');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "PASSPORT_VISA_DATA") {
                                            $state.go('menu.nriCurrentAddressDetailPage');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "CURRENT_ADDRESS_DATA") {
                                            if (NRIAOService.resumeNRIresponse.sameAddress) {
                                                $state.go('menu.nriAdditionalDetails');
                                            } else {
                                                $state.go('menu.nriPermanentAddressDetails');
                                            }
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "PERMANENT_ADDRESS_DATA") {
                                            $state.go('menu.nriAdditionalDetails');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "ADDITIONAL_CONTACT_DATA") {
                                            $state.go('menu.nriEduPage');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "EDU_REL_OCC_DATA") {
                                            $state.go('menu.nriNominationDetails');

                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "NOMINEE_DATA") {

                                            $state.go('menu.nriAccountServicePage');

                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "ACC_SERVICES_DATA") {
                                            $state.go('menu.taxationDetailsNRI');
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "TAXATION_DATA") {
                                            if (NRIAOService.resumeNRIresponse.branchPref) {
                                                $state.go('menu.nriReviewPage');
                                            } else {
                                                $state.go("menu.gncHomeBranchSelectionNRI");
                                            }
                                        }
                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "BRANCH_CNF") {
                                            $state.go('menu.nriReviewPage');
                                        }

                                        if (resumeApplicationNRIVm.resumeNRIresponse.lastSavedState == "SUBMITTED") {
                                            NRIAOService.NriSubmittedStage = "1";
                                            $state.go('menu.applicationTrackerNRI');
                                        }
                                    }
                                    else {
                                        $state.go('menu.passportVisaDetailsNRI');
                                    }


                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });

                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });



                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });




                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            resumeApplicationNRIVm.gotoCheckYOB = function () {
                var requestParams = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "yob": resumeApplicationNRIVm.yearOfBirth
                }
                NRIAOService.checkIfApplicationExistYob(requestParams).then(function (response) {
                    //Check if NRI application exist:

                    // if NRI application exist:
                    if (response.responseCode == '0000') {



                        //RESUME NRI APPLICATION - YOB MATCH, PASSPORT/VISA GOOD TO GO
                        if (response.statusCode == '00') {
                            if (response.applicationType == 'NRI') {
                                if (response.requestStatus == 'Draft') {

                                    resumeApplicationNRIVm.NRIStatusCode = response.statusCode;
                                    resumeApplicationNRIVm.getNRIAPP();
                                }
                                else {


                                    if (response.requestStatus == 'Initiated' || response.requestStatus == 'Pending' || response.requestStatus == 'Returned' || response.requestStatus == 'Approved') {

                                        NRIAOService.supportNumber = response.supportNumber;
                                        NRIAOService.supportNumberOne = NRIAOService.supportNumber[0];
                                        NRIAOService.supportNumberTwo = NRIAOService.supportNumber[1];
                                        NRIAOService.supportNumberThree = NRIAOService.supportNumber[2];
                                    }

                                    if (response.requestStatus == 'Initiated' || response.requestStatus == 'Pending' || response.requestStatus == 'Returned') {
                                        NRIAOService.NriSubmittedStage = "2";
                                        $state.go('menu.applicationTrackerNRI');
                                    }
                                    else if (response.requestStatus == 'Approved') {

                                        NRIAOService.NriSubmittedStage = "3";
                                        NRIAOService.customerNumber = response.customerNumber;
                                        if (response.nreAccountNumber) {
                                            NRIAOService.nreAccountNumber = response.nreAccountNumber;
                                            NRIAOService.nreAccountType = response.nreAccountType;
                                        }
                                        else{
                                            NRIAOService.nreAccountNumber = "";
                                            NRIAOService.nreAccountType = "";
                                        }
                                        if (response.nroAccountNumber) {
                                            NRIAOService.nroAccountNumber = response.nroAccountNumber;
                                            NRIAOService.nroAccountType = response.nroAccountType;
                                        }
                                        else{
                                            NRIAOService.nroAccountNumber = "";
                                            NRIAOService.nroAccountType = "";
                                        }
                                        $state.go('menu.applicationTrackerNRI');

                                    }
                                    else if (response.requestStatus == 'Declined') {

                                        NRIAOService.NriSubmittedStage = "4";
                                        NRIAOService.checkerReason = response.checkerReason;
                                        NRIAOService.footerMessage = response.footerMessage;
                                        $state.go('menu.applicationTrackerNRI');

                                    }


                                }


                            }
                        }


                        // NRI APP FOUND, PASSPORT/VISA expiry issue
                        if (response.statusCode == '01') {
                            resumeApplicationNRIVm.passportVisaExipryPopUP = $ionicPopup.show({

                                title: '',
                                cssClass: 'nri-popup border-radius-none	yono-kcc-popup1',
                                templateUrl: 'pages/accountOpening/accountOpeningNRI/passportVisaExpiryPopup.html',
                                scope: $scope
                            });
                        }

                        if (response.statusCode == '02') {
                            var errorMessage = response.responseMessage;
                            resumeApplicationNRIVm.noMatchDOB = $ionicPopup.show({
                                template: '<div class="button_fund font-dark-grey" style="font-size: 16px !important;font-family: Roboto-medium !important;padding-left: 20px;padding-right: 20px;">' + errorMessage + '</div>',
                                title: '',
                                cssClass: 'bhim-alert-popup',
                                scope: $scope,
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-positive',
                                    onTap: function (e) {
                                        resumeApplicationNRIVm.noMatchDOB.close();
                                    }
                                }]
                            });
                        }

                        if (response.statusCode == '03') {
                            var errorMessage = response.responseMessage;
                            resumeApplicationNRIVm.noMatchDOB = $ionicPopup.show({
                                template: '<div class="button_fund font-dark-grey" style="font-size: 16px !important;font-family: Roboto-medium !important;padding-left: 20px;padding-right: 20px;">' + errorMessage + '</div>',
                                title: '',
                                cssClass: 'bhim-alert-popup',
                                scope: $scope,
                                buttons: [{
                                    text: 'OK',
                                    type: 'button-positive',
                                    onTap: function (e) {
                                        $state.go('menu.newToSbiLanding');
                                    }
                                }]
                            });
                        }



                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);

                }
                )
            }
        }
    ]);