'use strict';

angularApp.controller('tncNRIController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "$ionicScrollDelegate",
        "NRIAOService",
        "utilityService",
        function ($state,
            $scope,
            $ionicHistory,
            $ionicScrollDelegate,
            NRIAOService,
            utilityService) {
            var tncNRIVm = this;

            $scope.$on('$ionicView.loaded', function () {
                tncNRIVm.disableCheckbox = true;
                tncNRIVm.disableNext = true; 
                tncNRIVm.disableNextbutton = true;
            });

            tncNRIVm.initPage = function () { 
                tncNRIVm.getWcmContent();
            }
            $scope.$on('$ionicView.beforeEnter', function () {
                tncNRIVm.initPage();
            });
            tncNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriReviewPage");
                } else {
                    $ionicHistory.goBack();
                }
            }
            tncNRIVm.getWcmContent = function () {
                var requestCreateApp = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "wcmContentType": "tncResponse"
                }
                NRIAOService.getWcmData(requestCreateApp).then(function (response) {
                    if (response.responseCode == '0000') {
                        var str = response.data;
                        tncNRIVm.data = str.replace("\<.*?\>", ""); 
                         setTimeout(function () {
                            tncNRIVm.checkScrollOnLoad();
                        }, 1000);
                        
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage); 
                });
            }
            tncNRIVm.agreeChkBox = function(){
                 if (tncNRIVm.isChecked) {  
                        tncNRIVm.disableNextbutton = false;
                    } else {
                        tncNRIVm.disableNextbutton = true;
                    
                    }
            }
            tncNRIVm.goToOTPFinal = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "requestNo": NRIAOService.requestNo,
                    "tncFlag": tncNRIVm.isChecked
                }

                NRIAOService.sendTermsAndCondition(payload).then(function (response) {
                    if (response.responseCode === "0000") {
                        $state.go("menu.otpVerificationForSubmission");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

            tncNRIVm.checkScrollOnLoad = function () {
                var tc = document.getElementById("tncId").offsetHeight;
                var tcContent = document.getElementById("tncContent").offsetHeight;
                if (tcContent <= tc) { 
                    document.getElementById('TERMCOND_NRI_CHK').removeAttribute("disabled");
                }
            }

            tncNRIVm.checkScroll = function (event) {
                var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
                var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
                if (maxTop !== 0) {
                    if (currentTop >= maxTop) {
                        tncNRIVm.disableCheckbox = false; 
                        document.getElementById('TERMCOND_NRI_CHK').removeAttribute("disabled");
                    }
                }
            }

        }
    ]);