'use strict';

angularApp.controller('userLoginDetailsAOController', ["$state",
    "$scope",
    "utilityService",
    "$translate",
    "$ionicSideMenuDelegate",
    "AdapterUtils",
    "constantConfig",
    "userLoginDetailsService",
    "$ionicPopover",
    "accountOpeningHomeService",
    "$ionicPopup",
    function ($state,
        $scope,
        utilityService,
        $translate,
        $ionicSideMenuDelegate,
        AdapterUtils,
        constantConfig,
        userLoginDetailsService,
        $ionicPopover,
        accountOpeningHomeService,
        $ionicPopup) {

        var userLoginDetailsAOVm = this;

      
        function initPage() {
           userLoginDetailsAOVm.showNext = true;
           userLoginDetailsAOVm.showBack = true;
           userLoginDetailsAOVm.disableNext = true;
           userLoginDetailsService.getFeatureComparison().then(function(response) {
            userLoginDetailsAOVm.policyWording = response.policyWording;
           });
           
        }

        userLoginDetailsAOVm.goBacktoPrevious = function () {
            
            $state.go('menu.productInformationPageAO');  
        }
		 userLoginDetailsAOVm.goToNextPage = function () {
		 	userLoginDetailsService.mobile = userLoginDetailsAOVm.mobile;
		 	userLoginDetailsService.emailId = userLoginDetailsAOVm.emailId;
             userLoginDetailsService.reffCode = userLoginDetailsAOVm.reffCode;
            userLoginDetailsAOVm.checkIfDetailsExists();
        }

        $scope.goToHome = function () {
            accountOpeningHomeService.homeNav();
        }

       userLoginDetailsAOVm.checkFormValid = function (isValid) {
            

             if (isValid){
                 if( ( userLoginDetailsAOVm.userDetailsForm.emailId.$valid && !userLoginDetailsAOVm.restrictedDomainNames && !userLoginDetailsAOVm.restrictedForSbi)){
                    userLoginDetailsAOVm.disableNext = false;
                 }else{
                    userLoginDetailsAOVm.disableNext = true;
                 }
             }else{
                 userLoginDetailsAOVm.disableNext = true;
             }
        }

       


        userLoginDetailsAOVm.restrictEmailDomains = function () {
            if (userLoginDetailsAOVm.userDetailsForm.emailId.$valid) {
                if (!userLoginDetailsAOVm.emailId) {
                    userLoginDetailsAOVm.restrictedDomainNames = false;
                    userLoginDetailsAOVm.restrictedForSbi = false;
                }
                else {
                    var newmail = userLoginDetailsAOVm.emailId;
                    var newmailCase = newmail.toLowerCase();
                    
                    var postMailSplit = newmailCase.split("@")[1];

                    if (postMailSplit.indexOf("sbi") != -1) {
                        
                        var sbiExtensions = [".com", ".co.in"];
                        var counts = 0;
                        for (var i = 0; i < sbiExtensions.length; i++) {
                            if (postMailSplit.indexOf(sbiExtensions[i]) != -1) {
                                counts++;
                            }
                        }
                        if (counts > 0) {
                            userLoginDetailsAOVm.restrictedDomainNames = false;
                            userLoginDetailsAOVm.restrictedForSbi = true;
                        }
                        else {
                            userLoginDetailsAOVm.restrictedDomainNames = false;
                            userLoginDetailsAOVm.restrictedForSbi = false;
                        }
                    }
                    else if ((postMailSplit.indexOf("gmail") != -1 && postMailSplit.indexOf(".com") === -1) || (postMailSplit.indexOf("rediffmail") != -1 && postMailSplit.indexOf(".com") === -1)) {
                        userLoginDetailsAOVm.restrictedDomainNames = true;
                        userLoginDetailsAOVm.restrictedForSbi = false;
                    }
                    else if (postMailSplit.indexOf("yahoo") != -1) {
                        var yahooExtensions = [".com", ".co.in", ".in"];
                        var count = 0;
                        for (var i = 0; i < yahooExtensions.length; i++) {
                            if (postMailSplit.indexOf(yahooExtensions[i]) != -1) {
                                count++;
                            }
                        }
                        if (count > 0) {
                            userLoginDetailsAOVm.restrictedDomainNames = false;
                            userLoginDetailsAOVm.restrictedForSbi = false;
                        }
                        else {
                            userLoginDetailsAOVm.restrictedDomainNames = true;
                            userLoginDetailsAOVm.restrictedForSbi = false;
                        }
                    }
                    
                    
                   

                    else {
                        
                        userLoginDetailsAOVm.restrictedDomainNames = false;
                        userLoginDetailsAOVm.restrictedForSbi = false;
                    }
                }
            }
        }


         /* Info Popup */
         var template = '<ion-popover-view class="tooltiptext ao-long-popupInfo roboto-regular">' + '<ion-content>' +
         '<div class="" ng-bind="userLoginDetailsAOVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

     $scope.popover = $ionicPopover.fromTemplate(template, {
         scope: $scope
     });

        userLoginDetailsAOVm.infoPopup = function($event) {
            userLoginDetailsAOVm.getInfoMsg = "Separate OTP would be sent on E-mail and Mobile Number.";
            $scope.popover.show($event); 
                
       };
       
       userLoginDetailsAOVm.infoPopupReferral = function($event) {
        userLoginDetailsAOVm.getInfoMsg = "Please enter Mobile Number of the person who recommended YONO here.";
        $scope.popover.show($event); 
            
   };
        
         userLoginDetailsAOVm.checkIfDetailsExists = function(mobileNumber) {
            var requestParams = {
                "id": userLoginDetailsAOVm.mobile
            }
            
            userLoginDetailsService.getCustomerDetails(requestParams).then(function(response) {
                
                if(response.data != null && response.data.isPresent == false ){
                   
                    if(userLoginDetailsAOVm.emailId){
		                	$state.go('menu.enterEmailOTPPageAO');
		                }else{

                            var infoPopup = $ionicPopup.show({
                                template: '<p translate="EMAIL_NOT_AVAILABLE" ></p>',
                                title:'Alert',
                                cssClass: 'dialog activated-blue',		
                                scope: $scope,
                                buttons: [ {
                                    text: 'Ok',
                                    onTap: function(e) {
                                        $state.go('menu.enterOTPPageAO');
                                    }
                                }]
                            });

		                }
                    
                }
                else{

           
                    $state.go('menu.resumeAccountPageAO');	
                }
               
            }, function(error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
              
                
            });
        }
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
           // $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            userLoginDetailsAOVm.mobile = userLoginDetailsService.mobile;
		 	userLoginDetailsAOVm.emailId = userLoginDetailsService.emailId;
             userLoginDetailsAOVm.reffCode = userLoginDetailsService.reffCode;
             userLoginDetailsAOVm.userDetailsForm.$setPristine();
             userLoginDetailsAOVm.restrictedForSbi = false;
            userLoginDetailsAOVm.restrictedDomainNames = false;
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);
