'use strict';

angularApp.controller('borrowAccDetails',
	["$timeout",
		"$state",
		"$scope",
		"homeScreenService",
		"getAccountDetailsService",
		"$ionicPopup",
		"utilityService",
		"$ionicPopover",
		"loanAccClosureService",
		"instaHomeService",
		"customerInfoService",
		function ($timeout,
			$state,
			$scope,
			homeScreenService,
			getAccountDetailsService,
			$ionicPopup,
			utilityService,
			$ionicPopover,
			loanAccClosureService,
			instaHomeService,
			customerInfoService) {

			var borrowAccDetailsVm = this;
			borrowAccDetailsVm.isAccountMasked = false;

			function initPage() {

				borrowAccDetailsVm.LACHeaderName = loanAccClosureService.LACHeaderName;
				borrowAccDetailsVm.accountDetails = [];
			    // code for account filter
				
				borrowAccDetailsVm.accountDetails = loanAccClosureService.DLTLAccounts;
				borrowAccDetailsVm.accno = borrowAccDetailsVm.accountDetails[0].accountNumber;
				borrowAccDetailsVm.type = borrowAccDetailsVm.accountDetails[0].accountType;
				borrowAccDetailsVm.amount = borrowAccDetailsVm.accountDetails[0].accountBalance;
				loanAccClosureService.transferAccountNo = borrowAccDetailsVm.accno;

				borrowAccDetailsVm.virtualShowSelect = true;
				borrowAccDetailsVm.LoanAccDetails = loanAccClosureService.closureAccDetails;
				borrowAccDetailsVm.amount1 = parseInt(borrowAccDetailsVm.LoanAccDetails.amount1);
				borrowAccDetailsVm.lacProductType = loanAccClosureService.selectedProductDetails.productType;
				if(loanAccClosureService.selectedProductDetails.productType == "PA2WL"){
					borrowAccDetailsVm.amount2 = parseInt(borrowAccDetailsVm.LoanAccDetails.amount2);
				}
                borrowAccDetailsVm.LoanAccDetails.loanAccountNumber = loanAccClosureService.selectedLoanAcc;
				borrowAccDetailsVm.eyesOffFun(borrowAccDetailsVm.LoanAccDetails.loanAccountNumber);
				borrowAccDetailsVm.secondAmountDebit = (borrowAccDetailsVm.LoanAccDetails.totalClosureAmount - borrowAccDetailsVm.LoanAccDetails.outstandingBalance + 1).toFixed(2);
			}

			borrowAccDetailsVm.showDebitAlertPopup = function () {
				if (parseFloat(borrowAccDetailsVm.amount) < parseFloat(borrowAccDetailsVm.amount1)) {
					borrowAccDetailsVm.insuffBalPopup = $ionicPopup.show({
						title: '',
						cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
						templateUrl: 'pages/accountOverview/borrowAccClosure/debitAccInsufBalPopup.html',
						scope: $scope
					})
				} else {
					if(loanAccClosureService.selectedProductDetails.productType == "RTXC" || loanAccClosureService.selectedProductDetails.productType == "PAPL"){
						borrowAccDetailsVm.myPopup = $ionicPopup.show({
							title: '',
							cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
							templateUrl: 'pages/accountOverview/borrowAccClosure/accountDebitInfoPopup.html',
							scope: $scope
						})
					}
					if(loanAccClosureService.selectedProductDetails.productType == "PA2WL") {
						if(parseInt(borrowAccDetailsVm.LoanAccDetails.amount1) < 1){
							borrowAccDetailsVm.amount1 = borrowAccDetailsVm.amount2;
							borrowAccDetailsVm.twoWheelerPopup = $ionicPopup.show({
								title: '',
								cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
								templateUrl: 'pages/accountOverview/borrowAccClosure/accountDebitInfoPopup.html',
								scope: $scope
							})
						} else {
							borrowAccDetailsVm.twoWheelerPopup = $ionicPopup.show({
								title: '',
								cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
								templateUrl: 'pages/accountOverview/borrowAccClosure/twoWheelerAccDebitInfoPopup.html',
								scope: $scope
							})
						}
					    
					}

				}
			}

			borrowAccDetailsVm.inSuffBalOK = function () {
				borrowAccDetailsVm.insuffBalPopup.close();
			}

			borrowAccDetailsVm.getOtpCall = function () {
				var obj = {
					"id": customerInfoService.customer.mobile,
					"emailId": customerInfoService.customer.emailID
			   }
			   instaHomeService.requestOtp(obj).then(function (data) {
				   $state.go('menu.loanAccClosureOtpVerify');
			   }, function (error) {
				   utilityService.showErrorMessage(error.responseMessage);
			   });
			}

			borrowAccDetailsVm.yesNo = function (data) {
				if(loanAccClosureService.selectedProductDetails.productType == "PA2WL") {
					borrowAccDetailsVm.twoWheelerPopup.close();
				} else {
					borrowAccDetailsVm.myPopup.close();
				}

				if(data == 'yes'){
					borrowAccDetailsVm.getOtpCall();
				}
			}

			borrowAccDetailsVm.virtualPopup = function () {
				if (borrowAccDetailsVm.accountDetails.length > 0) {
					borrowAccDetailsVm.balanceDetails = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
						templateUrl: 'pages/accountOverview/borrowAccClosure/accountModalPopup.html',
						scope: $scope
					});
				}
			}

			borrowAccDetailsVm.virtualClose = function (acc) {
				borrowAccDetailsVm.virtualShowSelect = true;
				borrowAccDetailsVm.balanceDetails.close();
				borrowAccDetailsVm.amount = acc.accountBalance;
				borrowAccDetailsVm.type = acc.accountType;
				borrowAccDetailsVm.accno = acc.accountNumber;
				loanAccClosureService.transferAccountNo = borrowAccDetailsVm.accno;
			}

			borrowAccDetailsVm.eyesOnFun = function (accNo) {
				borrowAccDetailsVm.isAccountMasked = false;
				borrowAccDetailsVm.LoanAccDetails.loanAccountNumber = borrowAccDetailsVm.oldValue;
			}

			borrowAccDetailsVm.eyesOffFun = function (accNo) {
				borrowAccDetailsVm.isAccountMasked = true;
				borrowAccDetailsVm.oldValue = accNo;
				borrowAccDetailsVm.LoanAccDetails.loanAccountNumber = utilityService.maskData(accNo, "front", 4);
			}

			borrowAccDetailsVm.goBacktoPrevious = function () {
				homeScreenService.ishamburgerMenuRO = false;
				getAccountDetailsService.tabIndex.tabIndex = 2;
				$state.go('menu.autoLoan');
			}

			if(utilityService.isAndroidPlatform()){
				borrowAccDetailsVm.template = '<ion-popover-view class="tooltip-nominee1 custom-tooltip-acc-closure roboto-light">' +
				'<ion-content class="tooltip-popup">' +
				'<div class=row><div class="lac-textAlignLeft col font-light fs-12 font-color-74 font-weight-200 p-0" translate="LAC_INT_DIV_LBL"></div></div>' +
				'</ion-content></ion-popover-view>';
	
			} else if(utilityService.isIOSPlatform()){
				borrowAccDetailsVm.template = '<ion-popover-view class="lac-tooltip-nominee1-ios tooltip-nominee1 custom-tooltip-acc-closure roboto-light">' +
				'<ion-content class="tooltip-popup">' +
				'<div class=row><div class="lac-textAlignLeft col font-light fs-12 font-color-74 font-weight-200 p-0" translate="LAC_INT_DIV_LBL"></div></div>' +
				'</ion-content></ion-popover-view>';
			}

			borrowAccDetailsVm.infoPopup = function ($event) {
				$scope.popover.show($event);
			}

			$scope.popover = $ionicPopover.fromTemplate(borrowAccDetailsVm.template, {
				scope: $scope
			});

			borrowAccDetailsVm.closeTooltip = function ($event) {
				$scope.popover.hide();
			}

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}]);