'use strict';

angularApp.controller('loanAccClosureOtpVerifyCtrl',
	["$timeout",
		"$state",
		"$scope",
		"homeScreenService",
		"getAccountDetailsService",
		"$ionicPopup",
		"utilityService",
		"$ionicPopover",
		"$translate",
		"$ionicHistory",
		"instaHomeService",
		"customerInfoService",
		"$filter",
		"loanAccClosureService",
		function ($timeout,
			$state,
			$scope,
			homeScreenService,
			getAccountDetailsService,
			$ionicPopup,
			utilityService,
			$ionicPopover,
			$translate,
			$ionicHistory,
			instaHomeService,
			customerInfoService,
			$filter,
			loanAccClosureService) {

			var loanAccClosureOtpVerifyVm = this;

			function initPage() {
				loanAccClosureOtpVerifyVm.isNextEnabled = true;
				loanAccClosureOtpVerifyVm.isDisabledOTP = false;
				loanAccClosureOtpVerifyVm.showDateDiv = true;
				loanAccClosureOtpVerifyVm.indexId = 0;
				loanAccClosureOtpVerifyVm.clickCount = 0;
				loanAccClosureOtpVerifyVm.otpCount = 0;
				loanAccClosureOtpVerifyVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
				loanAccClosureOtpVerifyVm.loanAccountNumber = loanAccClosureService.selectedLoanAcc;
				loanAccClosureOtpVerifyVm.LACHeaderName = loanAccClosureService.LACHeaderName;
				loanAccClosureOtpVerifyVm.lacProductType = loanAccClosureService.selectedProductDetails.productType;
				if(loanAccClosureService.selectedProductDetails.productType == "PA2WL"){
					loanAccClosureOtpVerifyVm.loanCategory = 'SBI Easy Ride Pre-Approved 2-Wheeler Loan';
				} else {
					if(loanAccClosureService.selectedProductDetails.productType == "PAPL"){
						loanAccClosureOtpVerifyVm.loanCategory =  "PAPL";
					} else {
						loanAccClosureOtpVerifyVm.loanCategory =  "Real Time Xpress Credit Loan";
					}
				}
				loanAccClosureOtpVerifyVm.LoanAccDetails = loanAccClosureService.closureAccDetails;
				loanAccClosureOtpVerifyVm.transferAccountNo = loanAccClosureService.transferAccountNo;
			}

			loanAccClosureOtpVerifyVm.otpFinal = function () {
				if (loanAccClosureOtpVerifyVm.otp.length < 6) {
					loanAccClosureOtpVerifyVm.changeOtp();
				} else {
					var requestParams = {
						"otp": loanAccClosureOtpVerifyVm.otp,
						"mobile": customerInfoService.customer.mobile
					}
					instaHomeService.validateOtp(requestParams).then(function (data) {
						// Further process for FT / SI / collateral / closure
						if(loanAccClosureService.selectedProductDetails.productType == "PA2WL"){
							// For PA2WL
							loanAccClosureOtpVerifyVm.twoWheelerfundTranfer();
						} else {
							// For RTXC / PAPL
							loanAccClosureOtpVerifyVm.sIDelete();
						}
						
					}, function (error) {
						loanAccClosureOtpVerifyVm.isSubmitDisabled = false;
						loanAccClosureOtpVerifyVm.otpCount++;
						if (loanAccClosureOtpVerifyVm.otpCount >= 3) {
							utilityService.showErrorMessage("You have reached maximum attempts to send OTP, please try after 3 minutes.");
						} else {
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
			}
			// Two Wheeler step 1
			loanAccClosureOtpVerifyVm.twoWheelerfundTranfer = function () {
					var reqParams = {
						"accountNumber": loanAccClosureOtpVerifyVm.transferAccountNo,
						"branchCode": getAccountDetailsService.branchCode ? getAccountDetailsService.branchCode : "",
						"amount": loanAccClosureOtpVerifyVm.LoanAccDetails.amount1
					  }
					loanAccClosureService.loanClosure.fundTransfer(reqParams).then(function (SIResponse) {
						loanAccClosureOtpVerifyVm.twoWheelerSIDelete();
					}, function (error) {
						loanAccClosureOtpVerifyVm.showErrorPopUp(error,"twoWheelerfundTranfer");
					});
			}
			// Two Wheeler step 2
			loanAccClosureOtpVerifyVm.twoWheelerSIDelete = function () {
				// Incase Loan Type is RTXC /PAPL delete SI
				loanAccClosureService.loanClosure.deleteSI().then(function (SIResponse) {
					// Close Account
					loanAccClosureOtpVerifyVm.deleteCollateral();
				}, function (error) {
					loanAccClosureOtpVerifyVm.showErrorPopUp(error,"twoWheelerSIDelete");
				})
			}
			// Two Wheeler step 3
			loanAccClosureOtpVerifyVm.deleteCollateral = function () {
				loanAccClosureService.loanClosure.deleteCollateral().then(function (CAResponse) {
					// loan account closed successfully 
					loanAccClosureOtpVerifyVm.closeAccount();
				}, function (error) {
					loanAccClosureOtpVerifyVm.showErrorPopUp(error,"deleteCollateral");
				});
			}
			// Two Wheeler step 4
			// PAPL / RTXC step 2
			// CLosure common for PAPL / RTXC / Two wheeler
			loanAccClosureOtpVerifyVm.closeAccount = function () {
				var requestParams = {
					accountNumber : loanAccClosureOtpVerifyVm.transferAccountNo
				}
				loanAccClosureService.loanClosure.closeAccount(requestParams).then(function (CAResponse) {
					// loan account closed successfully 
					loanAccClosureOtpVerifyVm.showDebitSuccessPopup();
				}, function (error) {
					loanAccClosureOtpVerifyVm.showErrorPopUp(error,"closeAccount");
					
				});
			}
			// PAPL / RTXC step 1
			loanAccClosureOtpVerifyVm.sIDelete = function () {
				// Incase Loan Type is RTXC /PAPL delete SI
				loanAccClosureService.loanClosure.deleteSI().then(function (SIResponse) {
					// Close Account
					loanAccClosureOtpVerifyVm.closeAccount();
				}, function (error) {
					loanAccClosureOtpVerifyVm.showErrorPopUp(error,"sIDelete");
				})
			}

			loanAccClosureOtpVerifyVm.showErrorPopUp = function(error, apiStage){
				if (error.errMsgType === "EM1") {
					loanAccClosureOtpVerifyVm.customErrorMsg = error.responseMessage;
					loanAccClosureOtpVerifyVm.apiCallStage = apiStage;
					loanAccClosureOtpVerifyVm.EM1Call();
				} else if (error.errMsgType === "EM2") {
					loanAccClosureOtpVerifyVm.customErrorMsg = error.responseMessage;
					loanAccClosureOtpVerifyVm.EM2Call();
				} else {
					utilityService.showErrorMessage(error.responseMessage);
				}
			}

			loanAccClosureOtpVerifyVm.changeOtp = function () {
				if (loanAccClosureOtpVerifyVm.otp) {
					loanAccClosureOtpVerifyVm.showNameError = loanAccClosureOtpVerifyVm.otp.length;
					if (loanAccClosureOtpVerifyVm.otp.length == 6) {
						loanAccClosureOtpVerifyVm.isNextEnabled = false;
					} else {
						loanAccClosureOtpVerifyVm.isNextEnabled = true;
					}
				} else {
					loanAccClosureOtpVerifyVm.isNextEnabled = true;
				}
			}


			loanAccClosureOtpVerifyVm.resendOtp = function () {
				loanAccClosureOtpVerifyVm.otp = "";
				var reqData = {
					"id": customerInfoService.customer.mobile,
					"emailId": customerInfoService.customer.emailID
				}
				instaHomeService.requestOtp(reqData).then(function (data) {
					loanAccClosureOtpVerifyVm.otpCount = 0;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


			loanAccClosureOtpVerifyVm.showDebitSuccessPopup = function () {
				loanAccClosureOtpVerifyVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
					templateUrl: 'pages/accountOverview/borrowAccClosure/loanAccountDebitSuccessPopup.html',
					scope: $scope
				})
			}

			loanAccClosureOtpVerifyVm.OK = function () {
				loanAccClosureOtpVerifyVm.myPopup.close();
				getAccountDetailsService.accountOverviewData = "";
				$state.go('menu.homeScreen');
			}

			loanAccClosureOtpVerifyVm.EM1Call = function () {
				loanAccClosureOtpVerifyVm.EM1Popup = $ionicPopup.show({
					title: '',
					cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
					templateUrl: 'pages/accountOverview/borrowAccClosure/EM1ErrorPopup.html',
					scope: $scope
				})
			}

			loanAccClosureOtpVerifyVm.em1Ok = function () {
				loanAccClosureOtpVerifyVm.EM1Popup.close();
				// conditions to check which api needs to call if there is api failure in each steps.
				if(loanAccClosureService.selectedProductDetails.productType == "PA2WL"){
					if(loanAccClosureOtpVerifyVm.apiCallStage == "twoWheelerfundTranfer") {
						loanAccClosureOtpVerifyVm.twoWheelerfundTranfer();
					} else if(loanAccClosureOtpVerifyVm.apiCallStage == "twoWheelerSIDelete"){
						loanAccClosureOtpVerifyVm.twoWheelerSIDelete();
					} else if(loanAccClosureOtpVerifyVm.apiCallStage == "deleteCollateral"){
						loanAccClosureOtpVerifyVm.deleteCollateral();
					} else if(loanAccClosureOtpVerifyVm.apiCallStage == "closeAccount") {
						loanAccClosureOtpVerifyVm.closeAccount();
					}
				} else{
					if(loanAccClosureOtpVerifyVm.apiCallStage == "sIDelete"){
						loanAccClosureOtpVerifyVm.sIDelete();
					} else {
						loanAccClosureOtpVerifyVm.closeAccount();
					}
				}
			}

			loanAccClosureOtpVerifyVm.EM2Call = function () {
				loanAccClosureOtpVerifyVm.EM2Popup = $ionicPopup.show({
					title: '',
					cssClass: 'lac-borderBottomNone lac-popupBoxBorderRadius new-purp-popup1 yono-kcc-popup1 lac-debit-acc-popup-margin',
					templateUrl: 'pages/accountOverview/borrowAccClosure/EM2ErrorPopup.html',
					scope: $scope
				})
			}

			loanAccClosureOtpVerifyVm.em2Ok = function () {
				loanAccClosureOtpVerifyVm.EM2Popup.close();
				getAccountDetailsService.tabIndex.tabIndex = 2;
				$state.go('menu.accountOverviewMyBalance');
			}


			loanAccClosureOtpVerifyVm.goBacktoPrevious = function () {
				homeScreenService.ishamburgerMenuRO = false;
				getAccountDetailsService.tabIndex.tabIndex = 2;
				$state.go('menu.borrowAccDetails');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				loanAccClosureOtpVerifyVm.isSubmitDisabled = false;
			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});
			return this;
		}]);


