angularApp.service('loanAccClosureService',
    function ($q, AdapterUtils) {
        var loanAccClosureService = this;

        loanAccClosureService.closureAccDetails = "";
        loanAccClosureService.selectedLoanAcc = "";
        loanAccClosureService.productCodeIndexFound = false;
        loanAccClosureService.LACHeaderName = "";
        loanAccClosureService.skipFundTrasfer = false;
        /**
         * Loan Account Closure Integration
         */
        loanAccClosureService.loanClosure = {
            DLTLAccountFilter: function () {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/DLTLAccountFilter', {}, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            },
            preClosureDLTLAccount: function (params) {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/preClosureDLTLAccount', params, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            },
            fundTransfer: function (params) {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/fundTransfer', params, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            },
            deleteCollateral: function () {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/deleteCollateral', {}, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            },
            deleteSI: function () {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/deleteSI', {}, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            },
            closeAccount: function (params) {
                var q = $q.defer();
                AdapterUtils.postData('adapters/PreApprovedLoanAdapter/loanClosure/closeAccount', params, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            }
        };
        /**
         * IRCTC Account creation Integration End
         */

        return loanAccClosureService;

    });
