'use strict';
angularApp.service('csatServices', ["$q", "AdapterUtils", "$state", "mPinLoginService","loggedInUserService","clearServiceDataService",
    function ($q, AdapterUtils, $state, mPinLoginService, loggedInUserService,clearServiceDataService) {

        var csatServices = this;
        var journeyName;
        this.goldenJourneyCompletionCounter = 0;
        this.highestGoldenJourneyCounter = 10;

        this.ratingGiven = "";
        this.showNewCsatScreen = false;
        this.csatFeedbackdata = "";

        // Setter/Getter
        csatServices.setGoldenJourney = function(data) {
            journeyName = data;
        };

        csatServices.getGoldenJourney = function() {
            return journeyName;
        };

        csatServices.sessionLogout = function() {
            sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
            clearServiceDataService.clearServiceData();
            mPinLoginService.isLoggedIn = false;
			AdapterUtils.sessionLogout().then( function (response) {
				loggedInUserService.logoutUser(true);
			},function (error) {
				loggedInUserService.logoutUser(true);
			});
        }

        csatServices.whetherGoldenJourney = function(journey) {
            var list = csatServices.feedbackGoldenJourneyList;
            var result = list.includes(journey);
            if(result){
                csatServices.setGoldenJourney(journey);
                csatServices.showNewCsatScreen = true;
                csatServices.updateGoldenJourneyData(journey);
            }else{
                csatServices.setGoldenJourney();
                csatServices.showNewCsatScreen = false;
                csatServices.goldenJourneyCompletionCounter = 0;
            }
        }

        csatServices.updateGoldenJourneyData = function(goldenJourney) {
            loggedInUserService.manageLocalData('',"CSATSampleData2.json",false,'read').then(function(res){
                console.log("Read result 1 ----> "+JSON.stringify(res));
                var journeyName = goldenJourney;
                var journeyCompletionCounter = "";	
                var journeyRatedDate = "";
                
                if(res.golden_JourneyCompletionCounter){
                    if(parseInt(res.golden_JourneyCompletionCounter) >= csatServices.highestGoldenJourneyCounter){                        
                        journeyCompletionCounter = res.golden_JourneyCompletionCounter;                                          
                    }else if(parseInt(res.golden_JourneyCompletionCounter) == 0){                        
                        res.golden_JourneyCompletionCounter = 1;                                          
                    }else{
                        res.golden_JourneyCompletionCounter = parseInt(res.golden_JourneyCompletionCounter) + 1;
                    }                        
                }else{
                    journeyCompletionCounter = 1;
                }

                if(res.golden_JourneyRatedDate){
                    journeyRatedDate = res.golden_JourneyRatedDate;
                }

                if(res){
                    journeyCompletionCounter = res.golden_JourneyCompletionCounter;	
                    journeyRatedDate = res.golden_JourneyRatedDate; 
                }

                var csatRateData = '"golden_Journey": "'+journeyName+'","golden_JourneyCompletionCounter": "'+journeyCompletionCounter+'","golden_JourneyRatedDate": "'+journeyRatedDate+'"';
                csatServices.createGoldenJourneyData(csatRateData);

                csatServices.goldenJourneyCompletionCounter = parseInt(journeyCompletionCounter);
            },function(e){
                console.log("error----> "+e);
            });
        }

        csatServices.createGoldenJourneyData = function(csatRateData) {
            loggedInUserService.manageLocalData(csatRateData,"CSATSampleData2.json",true,'write').then(function(res){
                console.log("Sucessfully data updated"+res);                
            },function(e) {
                console.log("error----> "+e);
            });
        }

        csatServices.saveGoldenJourneyFeedback = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CSATFeedbackAdapter/saveGoldenJourneyFeedback", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        return csatServices;
    }])
