'use strict';
angularApp.controller('feedbackMattersController', ["$state",
	"$scope",
    "csatServices",
	"constantConfig",
	"loggedInUserService","cryptoService",
	function ($state,
		$scope,
        csatServices,
		constantConfig,
		loggedInUserService,cryptoService) {
		//functions, variables that can be accessed from the HTML come here
		var feedbackMattersControllerVm = this;

		function initPage() {
			csatServices.goldenJourneyCompletionCounter = 0;
			feedbackMattersControllerVm.csatRating = constantConfig.New_CSAT.DEFAULT_CSAT_RATING;
			feedbackMattersControllerVm.npsRating = constantConfig.New_CSAT.DEFAULT_NPS_RATING;
			feedbackMattersControllerVm.cesRating = constantConfig.New_CSAT.DEFAULT_CES_RATING;
		}

		feedbackMattersControllerVm.submitAllRatings = function() {
			loggedInUserService.manageLocalData('',"CSATSampleData2.json",false,'read').then(function(res){				
				var journeyName = csatServices.getGoldenJourney();
				var journeyCompletionCounter = 0;
				var journeyRatedDate = "";
				if(res.golden_JourneyRatedDate){
					journeyRatedDate = res.golden_JourneyRatedDate;
				}
				var csatRateData = '"golden_Journey": "'+journeyName+'","golden_JourneyCompletionCounter": "'+journeyCompletionCounter+'","golden_JourneyRatedDate": "'+journeyRatedDate+'"';

				var SHA512HashedVal = feedbackMattersControllerVm.csatRating + feedbackMattersControllerVm.npsRating + feedbackMattersControllerVm.cesRating + "saveGoldenJourneyFeedback";
			    var value = cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();

				var request = {
					"feedbackData": [{
						"overallExpRating": feedbackMattersControllerVm.csatRating ? feedbackMattersControllerVm.csatRating :"",
						"npsRating": feedbackMattersControllerVm.npsRating ? feedbackMattersControllerVm.npsRating :"",
						"cesRating": feedbackMattersControllerVm.cesRating ? feedbackMattersControllerVm.cesRating :""
					}],
  					"reqValidate": value
				};
				csatServices.saveGoldenJourneyFeedback(request).then(function (data) {
					if(feedbackMattersControllerVm.csatRating == "good" || feedbackMattersControllerVm.csatRating =="outstanding"){
						csatServices.ratingGiven = "H";
					}else if(feedbackMattersControllerVm.csatRating == "poor" || feedbackMattersControllerVm.csatRating =="average"){
						csatServices.ratingGiven = "L";
					}
					csatServices.createGoldenJourneyData(csatRateData);
					$state.go('menu.feedbackThankYouPage');
				}, function (error) {
					csatServices.sessionLogout();
				});
			},function(e){
				console.log("error----> "+e);
			});						
		}

		feedbackMattersControllerVm.skipAllRatings = function(){
			csatServices.sessionLogout();
		}

		//one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

		return this;
	}
]);
