'use strict';
angularApp.controller('feedbackPageController', ["$state",
	"$scope",
    "csatServices",
	"constantConfig","cryptoService",
	function ($state,
		$scope,
        csatServices,
		constantConfig,cryptoService) {
		//functions, variables that can be accessed from the HTML come here
		var feedbackPageControllerVm = this;

		function initPage() {
			csatServices.goldenJourneyCompletionCounter = 0;
			feedbackPageControllerVm.csatRating = constantConfig.New_CSAT.DEFAULT_CSAT_RATING;
        }

		feedbackPageControllerVm.submitRating = function(rating) {
			if(rating == "good" || rating =="outstanding"){
				csatServices.ratingGiven = "H";
			}else if(rating == "poor" || rating =="average"){
				csatServices.ratingGiven = "L";
			}

			var SHA512HashedVal = feedbackPageControllerVm.csatRating + "" + "" + "saveGoldenJourneyFeedback";
			var value = cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
			var request = {
				"feedbackData": [{
					"overallExpRating": feedbackPageControllerVm.csatRating ? feedbackPageControllerVm.csatRating :"",
					"npsRating": "",
					"cesRating": ""
				}],
  				"reqValidate": value
			};

			csatServices.saveGoldenJourneyFeedback(request).then(function (data) {
				$state.go('menu.feedbackThankYouPage');
			}, function (error) {
				csatServices.sessionLogout();
			});
		}

		feedbackPageControllerVm.submitNextTime = function(){
			csatServices.sessionLogout();
		}

		//one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

		return this;
	}
]);