'use strict';
angularApp.controller('feedbackThankYouPageController', ["$scope",
    "csatServices",
	"utilityService",
	"loggedInUserService",
	function ($scope,
        csatServices,
		utilityService,
		loggedInUserService) {
		//functions, variables that can be accessed from the HTML come here
		var feedbackPageThankYouControllerVm = this;

		function initPage() {
			feedbackPageThankYouControllerVm.rated = false;
			feedbackPageThankYouControllerVm.journeyRatedDate = "";
			feedbackPageThankYouControllerVm.journeyCompletionCounter = "";
			feedbackPageThankYouControllerVm.ratingGiven = csatServices.ratingGiven;
			feedbackPageThankYouControllerVm.appRateGapDays = parseInt(csatServices.csatFeedbackdata.feedbackMaxRedirectLimit);

			feedbackPageThankYouControllerVm.journeyCompleted = csatServices.getGoldenJourney();

			loggedInUserService.manageLocalData('',"CSATSampleData2.json",false,'read').then(function(res){
				feedbackPageThankYouControllerVm.journeyCompletionCounter = res.golden_JourneyCompletionCounter;
				if(res.golden_JourneyRatedDate){
					feedbackPageThankYouControllerVm.journeyRatedDate = res.golden_JourneyRatedDate;
					console.log("journeyRatedDate ---> "+feedbackPageThankYouControllerVm.journeyRatedDate);
					var today = new Date();
					var diffTime = Math.abs(today - new Date(feedbackPageThankYouControllerVm.journeyRatedDate));
					var diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24));
					if(diffDays <= feedbackPageThankYouControllerVm.appRateGapDays){
						feedbackPageThankYouControllerVm.rated = true;
					}else{
						feedbackPageThankYouControllerVm.rated = false;
					}
				}				
			},function(e){
				console.log("error----> "+e);
			});
		}

		feedbackPageThankYouControllerVm.rateNow = function(){
			var journeyName = csatServices.getGoldenJourney();
			var journeyCompletionCounter = feedbackPageThankYouControllerVm.journeyCompletionCounter;
			var journeyRatedDate = new Date();
			var csatRateData = '"golden_Journey": "'+journeyName+'","golden_JourneyCompletionCounter": "'+journeyCompletionCounter+'","golden_JourneyRatedDate": "'+journeyRatedDate+'"';
			csatServices.createGoldenJourneyData(csatRateData);			
			utilityService.upgradeApp();
			csatServices.sessionLogout();
		}

		feedbackPageThankYouControllerVm.rateLater = function(){
			csatServices.sessionLogout();
		}

		feedbackPageThankYouControllerVm.ratedOK = function(){
			csatServices.sessionLogout();
		}

		//one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

		return this;
	}
]);