angularApp.service('fdODDetailService',
	function ($q, AdapterUtils, fixedDepositService, cryptoService) {
		var FDservice = this;
		FDservice.fetchODDetails = function (data, odData) {
			var q = $q.defer();
			var obj = {
				"fdAccountNumber": data.fdnumber,
				"pfId": data.pfId,
				"modeOfOperation": data.modeOfOperation,
				"accountNumber": data.selectedAccountNumber,
				"odLimit": odData.olimvalue,
				"odInterestRate": odData.oirate,
				"odExpiryDate": data.ODExyDate,
				"principalAmount": data.principalAmount,
				"product": data.product,
				"maturityAmount": data.maturityAmount,
				"transactionId": data.transactionId,
				"termsNcondition": data.checkTnC,
				"intCategory": data.intCategory,
				"accountTypeCode": data.accountTypeCode,
				"branchCode": data.branchCode,
				"scheme" : data.scheme
			};

			AdapterUtils.postData("adapters/FixedDepositAdapter/getOdAgainstFD", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);

			return q.promise;
		};

		FDservice.fetchtermcondition = function () {
			var q = $q.defer();

			AdapterUtils.getData("adapters/FixedDepositAdapter/fetchODagainstFDTermsandConditions", false).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.getProductInfo = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/FixedDepositAdapter/getProductInfo", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.getTncInfo = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/FixedDepositAdapter/getTncInfo", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.uploadDocs = function (data) {
			var q = $q.defer();
			let reqObj = {
				"fdNumber": data.fdnumber,
				"requestKey": (cryptoService.getSHA512EncryptedData(data.fdnumber)).toString()
			}
			AdapterUtils.postData("adapters/FixedDepositAdapter/uploadDocs", reqObj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.downloadTnC = function (data) {
			var q = $q.defer();
			let reqObj = {
				"fdNumber": data.fdnumber,
				"requestKey": (cryptoService.getSHA512EncryptedData(data.fdnumber)).toString()
			}
			AdapterUtils.postData("adapters/FixedDepositAdapter/downloadTnC", reqObj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.sendEmailODagainstFD = function (data) {
			var q = $q.defer();
			let reqObj = {
				"fdNumber": data.fdnumber,
				"docHashKey": (cryptoService.getSHA512EncryptedData(data.fdnumber)).toString()
			}
			AdapterUtils.postData("adapters/FixedDepositAdapter/sendEmailODagainstFD", reqObj, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return FDservice;
	});  