'use strict';

angularApp.controller('overdraftInfoController', 
	["$state",
	"$scope",
	"fixedDepositService",
	"fdODDetailService",
	"utilityService",
	"getAccountDetailsService",

	function ($state,
		$scope,
		fixedDepositService,
		fdODDetailService,
		utilityService,
		getAccountDetailsService) {

	var overdraftInfoVm = this;
	
	overdraftInfoVm.goToOD = function(){
		if (overdraftInfoVm.odProductInfo) {
			$state.go('menu.overdraft');
		}
	}

	overdraftInfoVm.goToAO = function(){
		if(fixedDepositService.customer.AODclick === 'detailsfd'){
			$state.go('menu.fixedDepositDetails');
		}
		if(fixedDepositService.customer.AODclick === 'reviewfd'){
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		}
	}

	overdraftInfoVm.getProductInfo = function(){
		fdODDetailService.getProductInfo().then(function(data){
			overdraftInfoVm.productInfoLink = data.footerSbiUrl
			overdraftInfoVm.odProductInfo = data.productInfo
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	$scope.$on('$ionicView.beforeEnter', function() {
		overdraftInfoVm.getProductInfo()
	});

	overdraftInfoVm.openLink = function(url){
		cordova.ThemeableBrowser.open(url, '_system', {});
	}

	return this;
}]);
