'use strict';

angularApp.controller('overdraftSuccessController', 
	["$state",
	"$scope",
	"$translate",
	"$stateParams",
	"fixedDepositService",
	"fdODDetailService",
	"$ionicPopover",
	"$ionicPopup",
	"utilityService",
	"getAccountDetailsService",
	"pdfDownloadService",

	function ($state,
		$scope,
		$translate,
		$stateParams,
		fixedDepositService,
		fdODDetailService,
		$ionicPopover,
		$ionicPopup,
		utilityService,
		getAccountDetailsService,
		pdfDownloadService) {

	var overdraftSuccessVm = this;

	overdraftSuccessVm.goToAO = function(){
		if(fixedDepositService.customer.AODclick === 'detailsfd'){
			$state.go('menu.fixedDepositDetails');
		}
		if(fixedDepositService.customer.AODclick === 'reviewfd'){
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		}
	}

	overdraftSuccessVm.goToRelationships = function () {
        $state.go('menu.accountOverviewMyBalance');
    }

	overdraftSuccessVm.openPasswordInfo = function ($event) {
        overdraftSuccessVm.leftStyle = "left : " + ($event.clientX - 10) + "px";
        overdraftSuccessVm.template = '<ion-popover-view class="od-pwd-info-popup" id="runtimeHeight">'+ ' <div class="pointer" style="{{overdraftSuccessVm.leftStyle}}"></div>'+' <div class="pad-bot-4"><span class="heading">Password eg. - 05Mar!8899</span></div>'+ ' <span class="close-btn" ng-click="overdraftSuccessVm.closePopover()"><img src="img/irctc/close_icon.svg" class="icon-size-12"></span>'+ ' <div class="bottom-line"></div>'+' <ion-content class="nfs-popover" has-bouncing="false">'+' <div class="row roboto-light font-size-12 pad-top-22">'+ ' <div class="col col-40"> <div class="row"> <div><span class="bold-content">05Mar</span><span>&nbsp;ch</span></div><span class="thin-content pad-left-50">+</span></div> <div class="row thin-content text-left pad-top4">Birth date and first 3 letters of birth month with first letter capital</div> </div>'+ ' <div class="col col-20"> <div class="row"><span class="bold-content pad-left-25">!</span><span class="thin-content pad-left-50">+</span></div> <div class="row thin-content text-left pad-top4">Mandatory "!" sign</div> </div>'+ ' <div class="col col-40"> <div class="row"><span class="pad-left-50">9XXXXX</span><span class="bold-content">&nbsp;8899</span></div> <div class="row thin-content pad-left-25 text-left pad-top4">Last 4 digits of the registered mobile number</div> </div> </div> </ion-content> </ion-popover-view>';
        $scope.popover = $ionicPopover.fromTemplate(overdraftSuccessVm.template, {
            scope: $scope
        });
        $scope.popover.show($event);               
    }

	overdraftSuccessVm.closePopover = function() {
		$scope.popover.hide();
	};

	// Download PDF code begin
    overdraftSuccessVm.pdfDownload = function (res) {
		let content = res.tncBase64;
		let refNo = (overdraftSuccessVm.nightMode == "Y" ? overdraftSuccessVm.storeRefNumber : overdraftSuccessVm.refNo)
        let filename = "TermsAndConditions" + "_" + refNo.slice(-4) + "_" + pdfDownloadService.getTimeStamp() + ".pdf";

        pdfDownloadService.savePDF(filename, content, "").then(function (response) {
            overdraftSuccessVm.folderpath = response.folderpath ? response.folderpath : "";
            if (utilityService.isAndroidPlatform()) {
                console.log('file downloaded successfully');
            }
            else {
                cordova.plugins.fileOpener2.open(
                    cordova.file.documentsDirectory + filename,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    });
            }
        }, function error(e) {
            utilityService.showErrorMessage(e);
        });
    }

	overdraftSuccessVm.manualPdfDownload = function () {
		overdraftSuccessVm.showTitle = false;
		overdraftSuccessVm.isTncPdfSuccess = false;
		overdraftSuccessVm.isEmailSuccess = false;

		fdODDetailService.downloadTnC(overdraftSuccessVm).then(function(data){
			overdraftSuccessVm.pdfDownload(data);
			overdraftSuccessVm.isTncPdfSuccess = true;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
    //Download PDF code ends

	overdraftSuccessVm.sendEmailODagainstFD = function () {
		overdraftSuccessVm.showTitle = false;
		overdraftSuccessVm.isEmailSuccess = false;
		overdraftSuccessVm.isTncPdfSuccess = false;

		fdODDetailService.sendEmailODagainstFD(overdraftSuccessVm).then(function(data){
			overdraftSuccessVm.isEmailSuccess = true;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	$scope.$on('$ionicView.beforeEnter', function() {
		overdraftSuccessVm.isEmailSuccess = false;
		overdraftSuccessVm.isTncPdfSuccess = false;

		overdraftSuccessVm.showTitle = true;

		overdraftSuccessVm.isAndroid = utilityService.isAndroidPlatform()
		overdraftSuccessVm.odSuccessObject = $stateParams.odSuccessObject.odSuccessObj;
		if (overdraftSuccessVm.odSuccessObject) {
			overdraftSuccessVm.fdnumber = overdraftSuccessVm.odSuccessObject.fdnumber;
			overdraftSuccessVm.nightMode = overdraftSuccessVm.odSuccessObject.nightMode;
			if (overdraftSuccessVm.nightMode == "Y") {
				overdraftSuccessVm.storeRefNumber = overdraftSuccessVm.odSuccessObject.storeRefNumber;
				overdraftSuccessVm.nightModeRefObj = {
					requestNumberOD : overdraftSuccessVm.storeRefNumber
				}
			} else {
				overdraftSuccessVm.refNo = overdraftSuccessVm.odSuccessObject.refNo;
			}
			overdraftSuccessVm.pdfDownload(overdraftSuccessVm.odSuccessObject)
		}		
	});

	return this;
}]);
