'use strict';

angularApp.controller('jvOffersController', [
    "$state",
    "$ionicPopup",
    "$translate",
    "$scope",
    "$q",
    "$rootScope",
    "getAccountDetailsService",
    "fTBeneficiaryService",
    "utilityService",
    "jvOffersService",
    "newCardService",
    "openAccountService",
    "mutualFundsService",
    "loggedInUserService",
    "linkCardService",
    "cardsService",
    "applyNowService",
    "leadGenerationService",
    "clickStreamService",
    "mySecurityProfileService",
    "generalInsurenceHomeService",
    "cardCompareService",
    "payNowServices",
    "homeScreenService", "cardConfig", function (
        $state,
        $ionicPopup,
        $translate,
        $scope,
        $q,
        $rootScope,
        getAccountDetailsService,
        fTBeneficiaryService,
        utilityService,
        jvOffersService,
        newCardService,
        openAccountService,
        mutualFundsService,
        loggedInUserService,
        linkCardService,
        cardsService,
        applyNowService,
        leadGenerationService,
        clickStreamService,
        mySecurityProfileService,
        generalInsurenceHomeService,
        cardCompareService,
        payNowServices,
        homeScreenService, cardConfig
    ) {
        var jvOffersVM = this;
        jvOffersVM.offersType = jvOffersService.offersType;
        jvOffersVM.isCrmRcmmndsExist = null;
        jvOffersVM.jvOffersForAll = [];
        jvOffersVM.investmentAndCardOffers = [];
        jvOffersVM.insuranceOffers = [];

        function initPage() {
            jvOffersVM.isCrmRcmmndsExist = jvOffersService.getIsCrmRcmmndsExist();
            let offersBanners = jvOffersService.getOfferBanners();
            if (offersBanners && (offersBanners[0].name == "jvOffersForAll")) {
                jvOffersVM.jvOffersForAll = jvOffersService.getSortedOffers(offersBanners[0].banners, 5);
            } else {
                offersBanners.map(function (offer) {
                    if (offer && offer.name === "investmentAndCardOffers") {
                        jvOffersVM.investmentAndCardOffers = jvOffersService.getSortedOffers(offer.banners, 4);
                    } else {
                        jvOffersVM.insuranceOffers = jvOffersService.getSortedOffers(offer.banners, 4);
                    }
                })
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
        });

        /**
         * Handling selected banner routing
         * @param {*} pageID targeted page id for banner
         */
        jvOffersVM.goToTriggeredOffer = function (pageID) {
            if (pageID == 'ccDefault') {
                homeScreenService.ishamMenu = true;
                newCardService.browseCardsTabs("All");
            } else if (pageID == 'dmDefault' || pageID == 'dmatAccOpen' || pageID == 'dmPortView') {
                utilityService.showSpinner();
                if (!mutualFundsService.totalSecurities) {
                    mySecurityProfileService.getSecProfile().then(function (data) {
                        utilityService.hideSpinner();
                        mutualFundsService.totalSecurities = data.securities;
                        jvOffersVM.checkDpList(pageID);
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    utilityService.hideSpinner();
                    jvOffersVM.checkDpList(pageID);
                }
            } else if (pageID == 'mfDefault' || pageID == 'mfPurchases') {
                utilityService.showSpinner();
                var nfoArray = [];
                mutualFundsService.getAllMutualFunds().then(function (data) {
                    if (data.fundList.length > 5) {
                        angular.forEach(data, function (value, key) {
                            for (var i in value) {
                                if (value[i].fundSchemeName == "NFO") {
                                    console.log(data.fundList[i]);
                                    nfoArray.push(data.fundList[i]);
                                    data.fundList.splice(i, 1);
                                    data.fundList.splice(1, 0, nfoArray[0]);
                                }
                            }
                        });
                    }
                    mutualFundsService.addFundList(data.fundList);
                    mutualFundsService.setPageId('quickBuy');
                    homeScreenService.ishamMenu = true;
                    utilityService.hideSpinner();
                    $state.go('menu.mutualFundsList');
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (pageID == 'giDefault' || pageID == 'giHealth') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamMenu = true;
                generalInsurenceHomeService.setGIProductsID('health-insurance');
                newCardService.setPostLoginSelectedMenu('insure');
                $state.go('menu.declaimer');
            } else if (pageID == 'giMiDefault' || pageID == 'giMotor') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamMenu = true;
                generalInsurenceHomeService.setGIProductsID('motor-insurance');
                newCardService.setPostLoginSelectedMenu('insure');
                $state.go('menu.declaimer');
            } else if (pageID == 'liRinnRaksha' || pageID == 'liSampoornaSuraksha') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamburgerMenuRO = false;
                homeScreenService.isInsuranceFlag = true;
                getAccountDetailsService.setRewTab = true;
                getAccountDetailsService.tabIndex.tabIndex = 4;
                $state.go('menu.accountOverviewMyBalance');
            } else if (pageID == 'giPai') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamMenu = true;
                generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                newCardService.setPostLoginSelectedMenu('insure');
                $state.go('menu.declaimer');
            } else if (pageID == 'ccApplication') {
                const card = {
                    "cardName": "SimplyCLICK SBI Card",
                    "description": "Get upto 10X reward points every time you spend online",
                    "pictureURL": "https://www.sbicard.com/sbi-card-en/assets/media/images/personal/credit-cards/value-savings/card-faces/simplyclick-card-face.png",
                    "number": "3"
                }
                if (!loggedInUserService.isLoggedInDetails.isLoggedIn) {
                    newCardService.setPreLoginSelectedMenu('cards');
                    newCardService.setTermsAndConditionsOutboundAnalyticsData(card);
                    loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                    // $state.go('menu.userLogin');
                    $state.go('menu.prehomeLoginRevamp');
                } else {
                    utilityService.showSpinner();
                    if (linkCardService.getAllowAppStatus() == "") {
                        linkCardService.getPendingApplicationStatus({})
                            .then(function (response) {
                                cardsService.errorLogger(response);
                                if (response.data) {
                                    if (response.data.allow == "false") {
                                        linkCardService.setAllowAppStatus(response.data);
                                        utilityService.hideSpinner();
                                        utilityService.enableShowErrorMessage();
                                        utilityService.showErrorMessage(response.data.allowMessage);
                                        return false;
                                    }
                                    else {
                                        linkCardService.setAllowAppStatus(response.data);
                                        allowApplication(card);
                                    }
                                }
                            },
                                function (error) {
                                    utilityService.hideSpinner();
                                    allowApplication(card);
                                });
                    }
                    else {
                        if (linkCardService.getAllowAppStatus().allow == "false") {
                            utilityService.hideSpinner();
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);
                            return false;
                        }
                        else {
                            utilityService.hideSpinner();
                            allowApplication(card);
                        }
                    }
                }
            } else if (pageID == 'ccPayment') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamburgerMenuRO = false;
                fTBeneficiaryService.isCreditCardFlag = true;
                getAccountDetailsService.setRewTab = true;
                getAccountDetailsService.tabIndex.tabIndex = 5;
                $state.go('menu.accountOverviewMyBalance');
            } else if (pageID == 'mfPortView') {
                utilityService.showSpinner();
                if (!mutualFundsService.multiFolio) {
                    mutualFundsService.getPortfolio().then(function (data) {
                        utilityService.hideSpinner();
                        data = data.multiFolio;
                        mutualFundsService.multiFolio = data;
                        if (data) {
                            $state.go('menu.portfolio');
                        } else {
                            // If user didn't have any folio account.
                            jvOffersService.navFromJVBanner = true;
                            homeScreenService.ishamburgerMenuRO = false;
                            homeScreenService.isInvestmentFlag = true;
                            getAccountDetailsService.setRewTab = true;
                            getAccountDetailsService.tabIndex.tabIndex = 3;
                            $state.go('menu.accountOverviewMyBalance');
                        }
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    utilityService.hideSpinner();
                    if (mutualFundsService.multiFolio) {
                        $state.go('menu.portfolio');
                    } else {
                        // If user didn't have any folio account.
                        jvOffersService.navFromJVBanner = true;
                        homeScreenService.ishamburgerMenuRO = false;
                        homeScreenService.isInvestmentFlag = true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex = 3;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }
            } else if (pageID == 'mfZeroFolio') {
                // Checking whether user have Yono Folio or not
                utilityService.showSpinner();
                mutualFundsService.getPortfolio().then(function (data) {
                    utilityService.hideSpinner();
                    if (data.multiFolio) {
                        const isLotusfolio = data.multiFolio.portFolio.some(function (el) {
                            return el.isLotusfolio == "Yes";
                        });
                        if (isLotusfolio) {
                            jvOffersVM.showAlertAlreadyFolio($translate.instant('YONO_FOLIO_ALREADY_AVAILABLE_FOR_INVESTMENT'));
                        } else {
                            jvOffersVM.checkFolio();
                        }
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (pageID == 'ccMngServices') {
                utilityService.showSpinner();
                linkCardService.getLinkedCards({}).then(function (response) {
                    utilityService.hideSpinner();
                    if (response.data.cards.length > 0) {
                        cardsService.errorLogger(response);
                        let cardList = (response.data.cards) ? response.data.cards : [];
                        for (var i = 0; i < cardList.length; i++) {
                            cardList[i].oldCardNumber = cardList[i].cardNumber.match(new RegExp('.{1,4}', 'g')).join("-");
                            if (cardList[i].dueDate) {
                                cardList[i].dueDate = cardList[i].dueDate.replace(/-/g, " ");
                            }
                            else {
                                cardList[i].dueDate = "";
                            }
                        }
                        console.log("cardList" + JSON.stringify(cardList));
                        getAccountDetailsService.accountOverviewData.cards = response.data;
                        cardsService.setCardList(cardList);
                        getAccountDetailsService.response = response;
                        jvOffersVM.goCardServices(cardList, 0);
                    } else {
                        jvOffersService.navFromJVBanner = true;
                        homeScreenService.ishamburgerMenuRO = false;
                        fTBeneficiaryService.isCreditCardFlag = true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex = 5;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        /**
         * Handling DEMAT account flow as per the selected banner
         * @param {*} pageId targeted page id for banner
         */
        jvOffersVM.checkDpList = function (pageId) {
            if (pageId == 'dmDefault' || pageId == 'dmatAccOpen') {
                if (mutualFundsService.totalSecurities.dpList != null && mutualFundsService.totalSecurities.dpList.length > 0) {
                    // If user already have demat aacount
                    jvOffersVM.showError($translate.instant('OPEN_DEMAT_ALREADY_HAVE_ACCOUNT_LBL'));
                } else {
                    utilityService.showSpinner();
                    openAccountService.checkDematApplicationExists().then(function (data) {
                        utilityService.hideSpinner();
                        if (data.applicationStatus == null || data.applicationStatus.trim() == "" || data.applicationStatus.toLowerCase() == "initiated") {
                            openAccountService.setStatusOfOpenAccount(0);
                            utilityService.showSpinner();
                            jvOffersService.navFromJVBanner = true;
                            // code added for centralized consent Check
                            leadGenerationService.checkConsent().then(function (data) {
                                utilityService.hideSpinner();
                                if (data.customerRecordExists == "false") {
                                    newCardService.setPreLoginSelectedMenu('open');
                                    loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                                    $state.go('menu.termsAndConditionsOutboundAnalytics');

                                } else {
                                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
                                    $state.go('menu.dematAndTradingAccount');
                                }
                            }, function (error) {
                                utilityService.hideSpinner();
                                jvOffersService.navFromJVBanner = false;
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        } else {
                            jvOffersService.navFromJVBanner = true;
                            homeScreenService.isInvestmentFlag = true;
                            getAccountDetailsService.tabIndex.tabIndex = 3;
                            $state.go('menu.accountOverviewMyBalance');
                        }
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    })
                }
            } else {
                // For SBI Security Cap portfolio
                if (mutualFundsService.totalSecurities.dpList != null && mutualFundsService.totalSecurities.dpList.length > 0) {
                    // If user have demat account linked with yono
                    jvOffersService.navFromJVBanner = true;
                    $state.go('menu.securitiesPortfolio');
                } else {
                    // If user haven't linked demat account with yono showing My investment
                    jvOffersService.navFromJVBanner = true;
                    homeScreenService.isInvestmentFlag = true;
                    getAccountDetailsService.tabIndex.tabIndex = 3;
                    $state.go('menu.accountOverviewMyBalance');
                }
            }
        }

        /**
         * Default Card applying
         * @param {*} card Default card details
         */
        function allowApplication(card) {
            utilityService.showSpinner();
            applyNowService.resetApplyForm();
            newCardService.setParams({ "applyCardType": card.cardType });
            newCardService.setParams({ "applyCardName": card.cardName });
            newCardService.setParams({ "applyPictureURL": card.pictureURL });
            newCardService.setParams({ "applyCardCategory": card.categoryName });

            applyNowService.getCities().then(function (response) {
                utilityService.hideSpinner();
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                jvOffersService.navFromJVBanner = true;
                utilityService.showSpinner();
                //Adding below code for centralised consent sprint 2 journey
                leadGenerationService.checkConsent().then(function (response) {
                    utilityService.hideSpinner();
                    console.log("check consent call from browse cards");
                    if (response.customerRecordExists == "false") {
                        newCardService.setPreLoginSelectedMenu('cards');
                        loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                        $state.go('menu.termsAndConditionsOutboundAnalytics');
                    } else {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
                        $state.go('menu.cardPersonalDetails1');
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    jvOffersService.navFromJVBanner = false;
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /**
         * Handling Credit card manage service screen 
         * @param {*} cards  
         * @param {*} index 
         */
        jvOffersVM.goCardServices = function (cards, index) {
            var responseData = {
                primaryCardSelected: index
            }
            cardsService.setParams(responseData);
            cardCompareService.policyWrapper = cards[index].policyWrapper;
            if (cardCompareService.policyWrapper.accountInformation !== 'Approved' && cardCompareService.policyWrapper.cardStatement !== 'Approved' && cardCompareService.policyWrapper.login !== 'Approved') {
                var loginError = {
                    cssClass: 'sbi-alert-popup',
                    template: '<div class="text-align-center font-content roboto-regular" translate="LOGIN_FAILED_WRAPPER" ></div>',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive'
                    }]
                };
                cardsService.alertModal(loginError, null);
            } else {
                var addOnCardPayload = {
                    "cardNumber": cards[index].cardNumber
                };
                utilityService.showSpinner();
                payNowServices.getAddOnCards(addOnCardPayload).then(function (response) {
                    if (response.data && response.data.cards) {
                        cardsService.setParams({
                            "addOnCards": response.data.cards || []
                        });
                        utilityService.hideSpinner();
                        jvOffersService.navFromJVBanner = true;
                        $state.go('menu.cardServices');
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        jvOffersVM.checkFolio = function () {
            utilityService.showSpinner();
            jvOffersVM.getServerUrl().then(function (data) {
                jvOffersVM.URL = data;
                jvOffersVM.panCard = jvOffersVM.URL.kycNo;
                if (jvOffersVM.panCard == '' || jvOffersVM.panCard == null || jvOffersVM.panCard == undefined) {
                    $rootScope.isCreateFolio = 1;
                    $rootScope.checkStatusPage = 1;
                    $rootScope.kycCompliant = 0;
                    $rootScope.kycNonCompliant = 0;
                    utilityService.hideSpinner();
                    $state.go('menu.KYC');
                } else {
                    utilityService.hideSpinner();
                    jvOffersVM.checkKycStatus();
                }
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        jvOffersVM.getServerUrl = function () {
            var q = $q.defer();
            mutualFundsService.getServerUrl().then(function (data) {
                q.resolve(data);
            }, function (error) {
                q.reject(error);
            });
            return q.promise;
        }

        //kyc check for create folio user
        /***Function to check KYC Status***/
        jvOffersVM.checkKycStatus = function () {
            var pageContent = "";
            var pageContentUrl = "";
            $rootScope.isCreateFolio = 1;
            jvOffersVM.sessionId = utilityService.getRandomNumber();
            var reqPara = {};
            reqPara['panId'] = jvOffersVM.panCard.toUpperCase();
            mutualFundsService.getEncryptString(reqPara).then(function (data) {
                jvOffersVM.encKycData = JSON.parse(data.encryptedString).data.responseString;

                pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="' + jvOffersVM.URL.camsUrl + '" method="POST">' +
                    '<input type="hidden" name="url" value="' + jvOffersVM.URL.mobileUrl + '">' +
                    '<input type="hidden" name="sess_id" value="abcd1234">' +
                    '<input type="hidden" name="ekyctype" value="E">' +
                    '<input type="hidden" name="plkyc_type" value="INVESTOR">' +
                    '<input type="hidden" name="kyc_data" value="' + jvOffersVM.encKycData + '">' +
                    '</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';

                pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
                var ref = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                    statusbar: { color: '#ffffffff' },
                    toolbar: {
                        height: 44,
                        color: '#ffffffff',
                        image: 'share'
                    }, closeButton: {
                        wwwImage: 'img/inappback.png',
                        align: 'left',
                        event: 'closePressed'
                    }, backButtonCanClose: true
                });

                ref.addEventListener('loadstart', function (event) {
                    var URL = event.url;
                    var n = URL.indexOf("result");
                    if (n == -1) {
                        return;
                    }
                    if (n) {
                        var result = URL.split('?')[1];
                        result = result.split("=")[1];
                        result = decodeURIComponent(result).toString();
                    }
                    mutualFundsService.getDecryptString(result).then(function (data) {
                        try {
                            var resultData = JSON.parse(data.plainString);
                            resultData = resultData.data.responseString.split("|")[2];
                            resultData = resultData.replace('&sess_id', '');
                            jvOffersVM.todayDate = $scope.currentDate.setDate($scope.currentDate.getDate());
                            jvOffersVM.ekycType = JSON.parse(data.plainString).data.responseString.split("|")[0];
                        } catch (e) {
                            ref.close();
                        }
                        if (n != -1) {
                            if (jvOffersVM.ekycType == 'Y' || resultData == 'KS100') {
                                jvOffersVM.reqParams = {
                                    "mfKyc": {
                                        "panNo": jvOffersVM.panCard ? jvOffersVM.panCard : "",
                                        "aadharNo": jvOffersVM.aadhaarCard ? jvOffersVM.aadhaarCard : "",
                                        "gender": jvOffersVM.gender ? jvOffersVM.gender : "",
                                        "dob": jvOffersVM.dob ? jvOffersVM.dob : "",
                                        "ekycStatus": "Submitted",
                                        "aofStatus": "",
                                        "ekycType": jvOffersVM.ekycType ? jvOffersVM.ekycType : "",
                                        "ekycTimeStamp": jvOffersVM.todayDate ? jvOffersVM.todayDate : "",
                                        "ekycMaxInvestmentLimit": ""
                                    }
                                };
                                utilityService.showSpinner();
                                mutualFundsService.checkKYCStatus(jvOffersVM.reqParams).then(function (data) {
                                    if (data.id) {
                                        var reqParams = {};
                                        reqParams['id'] = '';
                                        mutualFundsService.getPanCardNumber(reqParams).then(function (data) {
                                            jvOffersVM.divPayOutMechanism = data.mfKyc.divPayOutMechanism;
                                            jvOffersVM.redPayOutMechanism = data.mfKyc.redPayOutMechanism;
                                            jvOffersVM.applicationStatus = data.mfKyc.aofStatus;
                                            mutualFundsService.addeKycPanDetails(jvOffersVM.URL.kycNo);
                                            $rootScope.kycCompliant = 1;
                                            $rootScope.checkStatusPage = 0;
                                            $rootScope.kycNonCompliant = 0;
                                            utilityService.hideSpinner();
                                            $state.go('menu.KYC');
                                        }, function (error) {
                                            utilityService.hideSpinner();
                                            utilityService.showErrorMessage(error.responseMessage);
                                        });
                                    }
                                }, function (error) {
                                    utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                            } else if (jvOffersVM.ekycType == 'N' || resultData == 'KS101') {
                                $rootScope.kycCompliant = 0;
                                $rootScope.checkStatusPage = 0;
                                $rootScope.kycNonCompliant = 1;
                                $state.go('menu.KYC');
                            } else {
                                if (resultData == 'KS102') {
                                    jvOffersVM.showInformationPopup('KYC_STATUS_INCOMPLETE_UPDATE_WITH_KRA');
                                } else {
                                    jvOffersVM.showInformationPopup("Internal Error.Retry after some time");
                                }
                            }
                            ref.close();
                        }
                    }, function (error) {
                        ref.close();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                });
                ref.addEventListener('loadstop', function (event) {
                    ref.close();
                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            })
        }

        /**
         * Handling Tiles routing
         * @param {*} type selected tile type
         */
        jvOffersVM.goToSelectedSegments = function (type) {
            if (type == 'INVEST') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamburgerMenuRO = false;
                homeScreenService.isInvestmentFlag = true;
                getAccountDetailsService.setRewTab = true;
                getAccountDetailsService.tabIndex.tabIndex = 3;
                $state.go('menu.accountOverviewMyBalance');
            }
            if (type == 'GI') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamburgerMenuRO = false;
                homeScreenService.isInsuranceFlag = true;
                getAccountDetailsService.setRewTab = true;
                getAccountDetailsService.tabIndex.tabIndex = 4;
                $state.go('menu.accountOverviewMyBalance');
            }
            if (type == 'CC') {
                jvOffersService.navFromJVBanner = true;
                homeScreenService.ishamburgerMenuRO = false;
                fTBeneficiaryService.isCreditCardFlag = true;
                getAccountDetailsService.setRewTab = true;
                getAccountDetailsService.tabIndex.tabIndex = 5;
                $state.go('menu.accountOverviewMyBalance');
            }
        }

        //Show popup of showError if user is already having Demat ID
        jvOffersVM.showError = function (message) {
            $ionicPopup.show({
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                    + message + '</span></div></div></div>',
                title: 'Alert',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'Ok',
                    onTap: function (e) {
                        jvOffersService.navFromJVBanner = true;
                        homeScreenService.isInvestmentFlag = true;
                        getAccountDetailsService.tabIndex.tabIndex = 3;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            });
        }

        //Showing popup for customer already has a ‘YONO’ folio available for Mutual Fund
        jvOffersVM.showAlertAlreadyFolio = function (message) {
            $ionicPopup.show({
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                    + message + '</span></div></div></div>',
                title: 'Alert',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'Ok',
                    onTap: function (e) {
                        jvOffersService.navFromJVBanner = true;
                        homeScreenService.ishamburgerMenuRO = false;
                        homeScreenService.isInvestmentFlag = true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex = 3;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            });
        }
    }]);
