'use strict';
angularApp.service('jvOffersService', ["$q", "AdapterUtils", "$translate",
    function ($q, AdapterUtils, $translate) {

        var jvOffersService = this;
        // Mock data for all offers tiles
        jvOffersService.offersType = [
            {
                typeInfo: 'INVEST',
                type: $translate.instant('JV_INVEST'),
                typeCaption: $translate.instant('GET_INVESTMENT_READY'),
                typeDesc: $translate.instant('PLENTY_OPTIONS_GROW_YOUR_HEALTH'),
                typeIcon: 'img/landingPage/Investment.svg',
                banner: 'img/lifeInsurance/Investment-Banner-illustration.svg'
            },
            {
                typeInfo: 'GI',
                type: $translate.instant('INSURANCE'),
                typeCaption: $translate.instant('ENSURE_FINANCIAL_SECURITY'),
                typeDesc: $translate.instant('SELECT_BEST_INSURANCE'),
                typeIcon: 'img/landingPage/Insurance.svg',
                banner: 'img/lifeInsurance/Insurance-Illustrations.svg'
            },
            {
                typeInfo: 'CC',
                type: $translate.instant('CARDS'),
                typeCaption: $translate.instant('CC_SUITS_YOUR_LIFESTYLE'),
                typeDesc: $translate.instant('FIND_PERFECT_CARD'),
                typeIcon: 'img/landingPage/Cards.svg',
                banner: 'img/lifeInsurance/Credit-cards-Illustration.svg'
            },
        ];

        jvOffersService.offerBanners = [];
        jvOffersService.crmRcmmndsExist = null;

        jvOffersService.setIsCrmRcmmndsExist = function (value) {
            jvOffersService.crmRcmmndsExist = value;
        }

        jvOffersService.getIsCrmRcmmndsExist = function () {
            return jvOffersService.crmRcmmndsExist;
        }

        jvOffersService.setOfferBanners = function (banners) {
            jvOffersService.offerBanners = banners;
        }

        jvOffersService.getOfferBanners = function () {
            return jvOffersService.offerBanners;
        }

        jvOffersService.getJvOffersList = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getJvOffers", true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /**
         * Sorting Banners array to handle null or blank banners images 
         * @param {*} offers offers array
         * @param {*} MAX_LENGTH max banners length required
         * @returns offers with sorted max length as an array
         */
        jvOffersService.getSortedOffers = function (offers, MAX_LENGTH) {
            const offerBanners = offers.filter(function (banner) {
                return banner.bannerImage != null && banner !== "";
            })
            return offerBanners.slice(0, MAX_LENGTH);
        }

        return jvOffersService;
    }])
