'use strict';

angularApp.controller('payToVpa_SuccessController', ["$state",
	"$scope",
	"customerInfoService",
	"bhimUpiService",
	"loggedInUserService",
	"$translate",

	function ($state,
		$scope,
		customerInfoService,
		bhimUpiService,
		loggedInUserService,
		$translate) {

		var payToVpa_SuccessVm = this;

		payToVpa_SuccessVm.close = function () {
			customerInfoService.vpaPaymentDetails = '';
			if(payToVpa_SuccessVm.isLaunchPageTxn) {
				bhimUpiService.isPrehomeLoginScan = false;
				$state.go('menu.prehomeLoginRevamp');
			}				
			else
				$state.go('menu.fundtrans');
		}

		payToVpa_SuccessVm.goToFundTransfer = function () {
			customerInfoService.vpaPaymentDetails = '';
			$state.go('menu.fundtrans');
		}

		payToVpa_SuccessVm.goToRelationshipOverview = function () {
			customerInfoService.vpaPaymentDetails = '';
			if(payToVpa_SuccessVm.isLaunchPageTxn){
				bhimUpiService.isPrehomeLoginScan = false;
			}
			$state.go('menu.accountOverviewMyBalance');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			payToVpa_SuccessVm.payeeDetails = {
				payeeType: customerInfoService.payeeDetails.payeeType,
				accountNo: customerInfoService.payeeDetails.accountNo,
				ifsc: customerInfoService.payeeDetails.ifsc,
				bankName : customerInfoService.payeeDetails.bankName,
				name: customerInfoService.payeeDetails.name,
				vpa: customerInfoService.payeeDetails.vpa,
				amount: customerInfoService.payeeDetails.amount,
				remark: customerInfoService.payeeDetails.remark,
				nickName: customerInfoService.payeeDetails.nickName,
				phoneNumber: customerInfoService.payeeDetails.phoneNumber,
				savePayee: customerInfoService.payeeDetails.savePayee
			}
			payToVpa_SuccessVm.payerDetails = {
				vpa: customerInfoService.payerDetails.vpa,
				account: customerInfoService.payerDetails.accountObj
			}
			payToVpa_SuccessVm.upiTransRefNo = customerInfoService.payeeDetails.upiTransRefNo;

			if (payToVpa_SuccessVm.payeeDetails.payeeType == "QR")
				payToVpa_SuccessVm.paymentType = "QR CODE";
			else if (payToVpa_SuccessVm.payeeDetails.payeeType == "AC")
				payToVpa_SuccessVm.paymentType = "BANK ACCOUNT";
			else
				payToVpa_SuccessVm.paymentType = "UPI";
			//Inserted as part of Prelogin UI revamp journey
			payToVpa_SuccessVm.isLaunchPageTxn = bhimUpiService.isPrehomeLoginScan;
			payToVpa_SuccessVm.isBiometricLogin = loggedInUserService.isBiometricLogin;
			payToVpa_SuccessVm.isPaymentSuccess = bhimUpiService.paymentSuccess;
			payToVpa_SuccessVm.transactionErrorResp = bhimUpiService.scanPayResp;
		});

		return this;
	}
]);
