'use strict';

angularApp.controller('instapanAuthoriseController', ["$state",
    "$scope",
    "instapanAuthoriseService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instapanAuthoriseService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instapanAuthoriseVm = this;

        function initPage() {
            instapanAuthoriseVm.showBack = true;
            instapanAuthoriseVm.showNext = true;
            instapanAuthoriseVm.isChecked = '';
            instapanAuthoriseVm.disableNext = true;
            instapanAuthoriseVm.aofooter = true;
            instapanAuthoriseVm.loadAuthorizeDetails();
            $scope.isiPhone = utilityService.isIOSPlatform();
            instapanAuthoriseVm.isChecked = instaService.aadhaarAuthorizeFlag;
            instapanAuthoriseVm.agreeToAuthorize();
            
        }

        instapanAuthoriseVm.goBacktoPrevious = function() {
             $state.go('menu.instaKit_tax');
        }

        instapanAuthoriseVm.goToNextPage = function() {
            instapanAuthoriseVm.postAuthorizeDetails();
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instapanAuthoriseVm.agreeToAuthorize = function() {
            if (instapanAuthoriseVm.isChecked) {
                instapanAuthoriseVm.disableNext = false;
            } else {
                instapanAuthoriseVm.disableNext = true;
            }
        }

        instapanAuthoriseVm.loadAuthorizeDetails = function() {
            instapanAuthoriseService.getAuthorizationDetails().then(function(data) {
                instapanAuthoriseVm.authorisationDetails = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //for language selection 
         instapanAuthoriseVm.getAdharLang = function() {
            instapanAuthoriseService.getAdharLang().then(function(response) {
                instapanAuthoriseVm.adharLang = response.data;
                instapanAuthoriseVm.panAuthorizedContent = response.panAuthorizedContent;
               
                
                for (var i = 0; i < instapanAuthoriseVm.adharLang.length; i++) {
                    if(instapanAuthoriseVm.vId === instapanAuthoriseVm.adharLang[i].id){

                         instapanAuthoriseVm.vDesc = instapanAuthoriseVm.adharLang[i].description;
                         instapanAuthoriseVm.adLanqu = instapanAuthoriseVm.adharLang[i];
                    }
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //for language change
         instapanAuthoriseVm.changeLang = function(vDesc) {
            if(vDesc){
                instapanAuthoriseVm.vDesc = vDesc.description;
                instapanAuthoriseVm.vId = vDesc.id;
            }
         }

        
        instapanAuthoriseVm.postAuthorizeDetails = function() {
            instaService.aadhaarConsentFlag = instapanAuthoriseVm.isChecked;
            instaService.aadhaarConsentLang = instapanAuthoriseVm.vId;
            var requestParams = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "aadhaarConsentFlag": instaService.aadhaarConsentFlag,
                    "aadhaarConsentLang":instaService.aadhaarConsentLang,
                    "commonId": $state.$current.data.commonId
                }
            }

            instapanAuthoriseService.setPanAuthorizeFlag(requestParams).then(function(data) {
                $state.go('menu.instaKit_personalDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instapanAuthoriseVm.getAdharLang();
            
            instapanAuthoriseVm.isChecked = instaService.aadhaarConsentFlag;
            instapanAuthoriseVm.vId = instaService.aadhaarConsentLang;

           

    if(instapanAuthoriseVm.vId == null || instapanAuthoriseVm.vId == undefined ){
                    instapanAuthoriseVm.vId = 'en';
                    instapanAuthoriseVm.isChecked = false;
                    instaService.aadhaarConsentFlag = instapanAuthoriseVm.isChecked;
                    instaService.aadhaarConsentLang = instapanAuthoriseVm.vId;
                }else{
                    instapanAuthoriseVm.isChecked = instaService.aadhaarConsentFlag;
                    instapanAuthoriseVm.vId = instaService.aadhaarConsentLang;
                }

                  if(instapanAuthoriseVm.isChecked && instapanAuthoriseVm.vId){
                    instapanAuthoriseVm.disableNext = false; 
                }

              if(instaService.isResumeJourney){
                instapanAuthoriseVm.isChecked = instaService.aadhaarConsentFlag;
                instapanAuthoriseVm.vId = instaService.aadhaarConsentLang;
               
                if(instapanAuthoriseVm.isChecked && instapanAuthoriseVm.vId){
                    instapanAuthoriseVm.disableNext = false; 
                }
            }
        });

        return this;
    }
]);
