'use strict';

angularApp.controller('ntbAccountAggregatorListController', ["$state",
    "$scope",
    "$ionicPopup",
    "$ionicHistory",
    "clNTBCalculatorService",
    "utilityService",
    "clickStreamService",
    "cryptoService",
    "$timeout",
    "hlNTBCalculatorService",
    function (
        $state,
        $scope,
        $ionicPopup,
        $ionicHistory,
        clNTBCalculatorService,
        utilityService,
        clickStreamService,
        cryptoService,
        $timeout,
        hlNTBCalculatorService) {
            
        var ntbAccountAggregatorListVm = this;
        var ref;
        $scope.showNTBAADisclaimerError = false;

        ntbAccountAggregatorListVm.initPage = function(){
            ntbAccountAggregatorListVm.accountAggregatorsList = [];
            ntbAccountAggregatorListVm.accountAggregatorsList = [{
                icons: "img/CarLoanNTB/NESL_hires.png",
                aAname: "nadl",
                width: "65",
                height: "25",
                name: "NADL"
            }];

            $scope.disclaimerContentNTBAA = clNTBCalculatorService.disclaimerLine1;
            $scope.disclaimerContentNTBAA2 = clNTBCalculatorService.disclaimerLine2;

            if(clNTBCalculatorService.productIDNTBCL){
                ntbAccountAggregatorListVm.productIDNTBAA = clNTBCalculatorService.productIDNTBCL;
                ntbAccountAggregatorListVm.crmLeadID = clNTBCalculatorService.getReferenceStatusData().crmLeadID;
                ntbAccountAggregatorListVm.mobile = clNTBCalculatorService.getGenerateLeadData().mobile;
            }else if(hlNTBCalculatorService.productIDNTBHL){
                ntbAccountAggregatorListVm.productIDNTBAA = hlNTBCalculatorService.productIDNTBHL;
                ntbAccountAggregatorListVm.crmLeadID = hlNTBCalculatorService.getReferenceStatusData().crmLeadID;
                ntbAccountAggregatorListVm.mobile = hlNTBCalculatorService.getGenerateLeadData().mobile;
            }

            $scope.productIDNTBAA = ntbAccountAggregatorListVm.productIDNTBAA;
        }

        ntbAccountAggregatorListVm.goBack = function () {
            $ionicHistory.goBack();
        }

        ntbAccountAggregatorListVm.selectAA = function (selectedAA) {
            clickStreamService.clickStreamData = "AA," + selectedAA.aAname;
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_OPT" + clickStreamService.appTypeIdentifier));
            clNTBCalculatorService.selectedAccAggr = selectedAA;
            ntbAccountAggregatorListVm.reqObj = {};
            if (clNTBCalculatorService.isIdAvailiable) {
                $state.go('menu.ntbEnterAccountAggregatorID');
            } else {
                 switch (selectedAA.name) {
                    case "One Money":
                        ntbAccountAggregatorListVm.reqObj = { "aaId": "onemoney", "vua": "" };
                        break;
                    case "NADL":
                        ntbAccountAggregatorListVm.reqObj = { "aaId": "nadl", "vua": "" };
                        break;
                    case "CAMS":
                        ntbAccountAggregatorListVm.reqObj = { "aaId": "camsaa", "vua": "" };
                        break;
                    case "FinU":
                        ntbAccountAggregatorListVm.reqObj = { "aaId": "finvu", "vua": "" };
                        break;
                }
                ntbAccountAggregatorListVm.openDisclaimer();
            }
        }

        ntbAccountAggregatorListVm.openDisclaimer = function () {
            clNTBCalculatorService.openDisclaimerPopup($scope);
        }

        $scope.closeDisclaimer = function () {
            clNTBCalculatorService.closeDisclaimerPopup($scope);
        }

        $scope.agreeNTBAADisclaimer = function(disclaimerNTBAAChecked){
            if(disclaimerNTBAAChecked){
                ntbAccountAggregatorListVm.checkBoxChecked = true;
                $scope.showNTBAADisclaimerError = false;
            }else{
                ntbAccountAggregatorListVm.checkBoxChecked = false;
                $scope.showNTBAADisclaimerError = true;
            }
        }

        $scope.ntbAAContinue = function() {
            if(ntbAccountAggregatorListVm.checkBoxChecked){
                $scope.showNTBAADisclaimerError = false;
                var SHA512HashedVal = ntbAccountAggregatorListVm.productIDNTBAA + ntbAccountAggregatorListVm.mobile + ntbAccountAggregatorListVm.reqObj.aaId+ntbAccountAggregatorListVm.reqObj.vua + ntbAccountAggregatorListVm.crmLeadID;
			    var value = cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();
                var payload= {
                    "productId": ntbAccountAggregatorListVm.productIDNTBAA,
                    "mobileNo": ntbAccountAggregatorListVm.mobile,
                    "aaId": ntbAccountAggregatorListVm.reqObj.aaId,
                    "vua": ntbAccountAggregatorListVm.reqObj.vua,
                    "accountID":ntbAccountAggregatorListVm.crmLeadID,
                    "val": value
                }
                clNTBCalculatorService.getAAUrl(payload).then(function (response) {
                    $scope.closeDisclaimer();
                    ntbAccountAggregatorListVm.inAppBrowser(response.webRedirectionUrl);
                    clNTBCalculatorService.ntbAARespURL = response.respUrl;
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                $scope.showNTBAADisclaimerError = true;
            }
        }

        ntbAccountAggregatorListVm.inAppBrowser = function (url) {
            $timeout(function () {
                var payload= {
                    "productId": ntbAccountAggregatorListVm.productIDNTBAA                   
                }
                clNTBCalculatorService.extendSession(payload).then(function(response) {
                    console.log("session extended"+response);
                },function(error){ 
                    console.log("error"+error);
                });                
            }, 150000);

            ref = cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 44,
                    color: '#ffffffff',
                    image: 'share'
                },
                closeButton: {
                    wwwImage: 'img/inappback.png',
                    align: 'left'
                },                 
                backButtonCanClose: true
            });

            ref.addEventListener('loadstart', function (event) {
                console.log("loadstart",event);
                var URL=event.url;               
                if(URL.indexOf(clNTBCalculatorService.ntbAARespURL) > -1) {
                    ref.close();
                }
            });

            ref.addEventListener('exit', function () {
                ref.close();
                clNTBCalculatorService.finalConsentCheck();                
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ntbAccountAggregatorListVm.initPage();
        }); 
        return this;
    }

])