'use strict';

angularApp.controller('newCLCalculatorController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "$morphCarousel",
    "newLoansLandingService",
    "carLoanService",
    "homeLoanService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,$morphCarousel,newLoansLandingService,carLoanService,homeLoanService) {

        var newCLCalculatorVm = this;
        newCLCalculatorVm.tab = 1;
        newCLCalculatorVm.initPage = function () {
            newCLCalculatorVm.buttonText = carLoanService.buttonText;
            var tenuresInc = []; var tenuresVeh = [];
       
            newCLCalculatorVm.carLoanDetails = newLoansLandingService.getCarLoanData().loanDetails; 
            var carLoanData = newCLCalculatorVm.carLoanDetails;
            for (var i = 0; i <= carLoanData.length; i++) {
                if(carLoanData[i] && carLoanData[i].type == "income"){
                    newCLCalculatorVm.loanMinAmountInc = carLoanData[i].minLoanAmount;
                    newCLCalculatorVm.LoanMaxAmountInc = parseInt(carLoanData[i].maxAnnualIncome) * 4;
                    newCLCalculatorVm.intRateInc = carLoanData[i].intRate;
                    newCLCalculatorVm.maxAnnualIncomeInc = carLoanData[i].maxAnnualIncome;
                    newCLCalculatorVm.maxTenureInc = carLoanData[i].maxTenure;
                    newCLCalculatorVm.minTenureInc = carLoanData[i].minTenure;
                    newCLCalculatorVm.minAnnualIncomeInc = carLoanData[i].minAnnualIncome;
                } else if(carLoanData[i] && carLoanData[i].type == "vehicle"){
                    newCLCalculatorVm.loanMinAmountVeh = carLoanData[i].minLoanAmount;
                    newCLCalculatorVm.LoanMaxAmountVeh = parseInt(carLoanData[i].maxAnnualIncome) * 0.85;
                    newCLCalculatorVm.intRateVeh = carLoanData[i].intRate;
                    newCLCalculatorVm.maxAnnualIncomeVeh = carLoanData[i].maxAnnualIncome;
                    newCLCalculatorVm.maxTenureVeh = carLoanData[i].maxTenure;
                    newCLCalculatorVm.minTenureVeh = carLoanData[i].minTenure;
                    newCLCalculatorVm.minAnnualIncomeVeh = carLoanData[i].minAnnualIncome;
                }
                
            }                           

            newCLCalculatorVm.tenuresInc = [];
            var minTenure = parseInt(newCLCalculatorVm.minTenureInc);
            var maxTenure = parseInt( newCLCalculatorVm.maxTenureInc);

            for (var i = minTenure; i <= maxTenure; i++) {
                tenuresInc.push(i);
            }
            newCLCalculatorVm.tenuresInc = tenuresInc;

            newCLCalculatorVm.tenuresVeh = [];
            var minTenureVeh = parseInt(newCLCalculatorVm.minTenureVeh);
            var maxTenureVeh = parseInt( newCLCalculatorVm.maxTenureVeh);

            for (var i = minTenureVeh; i <= maxTenureVeh; i++) {
                tenuresVeh.push(i);
            }

            newCLCalculatorVm.tenuresVeh = tenuresVeh;
            newCLCalculatorVm.loanAmountIncAnnual = newCLCalculatorVm.maxAnnualIncomeInc;
            newCLCalculatorVm.loanAmountIncLoan = newCLCalculatorVm.LoanMaxAmountInc;
            newCLCalculatorVm.loanAmountVehCost = newCLCalculatorVm.maxAnnualIncomeVeh;
            newCLCalculatorVm.loanAmountVehLoan = newCLCalculatorVm.LoanMaxAmountVeh;

            // for tab 1 i.e income based buttons.
            newCLCalculatorVm.disablePBtnIncAnnual = false;
            newCLCalculatorVm.disablePBtnIncLoan = false;
            newCLCalculatorVm.disableMBtnIncAnnual = false;
            newCLCalculatorVm.disableMBtnIncLoan = false;

            // for tab 2 i.e vehicle based buttons.
            newCLCalculatorVm.disableMBtnVehCost = false;
            newCLCalculatorVm.disableMBtnVehLoan = false;
            newCLCalculatorVm.disablePBtnVehCost = false;
            newCLCalculatorVm.disablePBtnVehLoan = false;

            newCLCalculatorVm.steppingAmountInc = 1000;
            newCLCalculatorVm.steppingAmountVeh = 1000;
            newCLCalculatorVm.maxTenureInc = maxTenure;
            newCLCalculatorVm.maxTenureVeh = maxTenureVeh;
            
        }

        newCLCalculatorVm.selTab = function(sel) {
            newCLCalculatorVm.tab = sel;
        }

        var listener = $scope.$watch(function () {
            return (newCLCalculatorVm.maxTenureInc);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                newCLCalculatorVm.maxTenureInc = tenureValue;
                if (newCLCalculatorVm.maxTenureInc) {
                    newCLCalculatorVm.tenure = newCLCalculatorVm.maxTenureInc;
                    newCLCalculatorVm.emiCalculation();
                }
            }
        });

         // for tab 1 i.e income based.
        newCLCalculatorVm.loanAmountCheckInc = function(loanValue){
            var loanAmt = parseInt(loanValue);
            if((loanAmt % parseInt(newCLCalculatorVm.steppingAmountInc)) > 0){
                newCLCalculatorVm.loanAmountIncLoan -= (loanAmt % parseInt(newCLCalculatorVm.steppingAmountInc));
            }else{
                newCLCalculatorVm.loanAmountIncLoan = loanAmt*4;
            }
            if(loanAmt <= newCLCalculatorVm.minAnnualIncomeInc){
                newCLCalculatorVm.loanAmountIncLoan = newCLCalculatorVm.minAnnualIncomeInc * 4;
                newCLCalculatorVm.loanAmountIncAnnual = newCLCalculatorVm.minAnnualIncomeInc;
                newCLCalculatorVm.disableMBtnIncAnnual = true;
                newCLCalculatorVm.disablePBtnIncAnnual = false;
            }else{
                newCLCalculatorVm.disableMBtn = false;
            }
            if(loanAmt >= newCLCalculatorVm.maxAnnualIncomeInc){
                newCLCalculatorVm.loanAmountIncLoan = newCLCalculatorVm.maxAnnualIncomeInc * 4;
                newCLCalculatorVm.loanAmountIncAnnual = newCLCalculatorVm.maxAnnualIncomeInc;
                newCLCalculatorVm.disablePBtnIncAnnual = true;
                newCLCalculatorVm.disableMBtnIncAnnual = false;
            }else{
                newCLCalculatorVm.disablePBtn = false;
            }
            newCLCalculatorVm.emiCalculation();
        }

        newCLCalculatorVm.emiCalculation = function() {
            newCLCalculatorVm.emiAmountInc = rxtcService.emiCalculation(newCLCalculatorVm.loanAmountIncLoan,newCLCalculatorVm.intRateInc,newCLCalculatorVm.maxTenureInc);
        }

        newCLCalculatorVm.decreaseIncreaseAmountInc = function (loanValue,btnClicked) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newCLCalculatorVm.disableMBtnIncAnnual = false;
                newCLCalculatorVm.disablePBtnIncAnnual = false;
                if(loanAmount <= newCLCalculatorVm.minAnnualIncomeInc){
                    newCLCalculatorVm.disableMBtnIncAnnual = true;            
                }else if(loanAmount >= newCLCalculatorVm.maxAnnualIncomeInc){   
                    newCLCalculatorVm.disablePBtnIncAnnual = true; 
                }

                if(btnClicked=='D'){
                    newCLCalculatorVm.loanAmountIncAnnual = loanAmount - parseInt(newCLCalculatorVm.steppingAmountInc);
                    if(newCLCalculatorVm.loanAmountIncAnnual <= newCLCalculatorVm.minAnnualIncomeInc){
                        newCLCalculatorVm.disableMBtnIncAnnual = true; 
                        newCLCalculatorVm.disablePBtnIncAnnual = false;           
                    } else {
                        if(newCLCalculatorVm.loanAmountIncAnnual <= newCLCalculatorVm.maxAnnualIncomeInc){
                            newCLCalculatorVm.disablePBtnIncAnnual = false;            
                        } else {
                            newCLCalculatorVm.disableMBtnIncAnnual = true; 
                        }
                    }

                    if(newCLCalculatorVm.loanAmountIncLoan /4 >> 0 >= newCLCalculatorVm.loanAmountIncAnnual){
                        newCLCalculatorVm.disablePBtnIncLoan = true;              
                    }
                    
                }

                if(btnClicked=='I'){
                    newCLCalculatorVm.loanAmountIncAnnual = loanAmount + parseInt(newCLCalculatorVm.steppingAmountInc);
                    if(newCLCalculatorVm.loanAmountIncAnnual >= newCLCalculatorVm.maxAnnualIncomeInc){  
                        newCLCalculatorVm.disablePBtnIncAnnual = true;  
                        newCLCalculatorVm.disableMBtnIncAnnual = false;            
                    } else {
                        if(newCLCalculatorVm.loanAmountIncAnnual >= newCLCalculatorVm.minAnnualIncomeInc){
                            newCLCalculatorVm.disableMBtnIncAnnual = false;            
                        } else {
                            newCLCalculatorVm.disableMBtnIncAnnual = true; 
                            newCLCalculatorVm.disablePBtnIncAnnual = false;
                        } 
                    }
                }
                newCLCalculatorVm.loanAmountCheckInc(newCLCalculatorVm.loanAmountIncAnnual);
            }  
        }

        newCLCalculatorVm.decreaseAmountLoan = function (loanAmtValue) {
            var loanAmount = parseInt(loanAmtValue);
            if(loanAmount){
                newCLCalculatorVm.disablePBtnIncLoan = false;
                if(loanAmount <= newCLCalculatorVm.loanMinAmountInc){
                    newCLCalculatorVm.disableMBtnIncLoan = true;               
                }else{
                    newCLCalculatorVm.loanAmountIncLoan = loanAmount - parseInt(newCLCalculatorVm.steppingAmountInc);
                    if(newCLCalculatorVm.loanAmountIncLoan <= newCLCalculatorVm.loanMinAmountInc){
                        newCLCalculatorVm.disableMBtnIncLoan = true;               
                    }
                }
                newCLCalculatorVm.loanAmountCheck(newCLCalculatorVm.loanAmountIncLoan);
            }  
        }

        newCLCalculatorVm.increaseAmountLoan = function (loanAmtValue) {
            var loanAmount = parseInt(loanAmtValue);
            if(loanAmount){
                newCLCalculatorVm.disableMBtnIncLoan = false;
                if(Math.floor(loanAmount/4) >= newCLCalculatorVm.loanAmountIncAnnual){
                    newCLCalculatorVm.disablePBtnIncLoan = true;              
                }else{
                    newCLCalculatorVm.loanAmountIncLoan = loanAmount + parseInt(newCLCalculatorVm.steppingAmountInc);
                    if(Math.floor(newCLCalculatorVm.loanAmountIncLoan/4) >= newCLCalculatorVm.loanAmountIncAnnual){
                        newCLCalculatorVm.disablePBtnIncLoan = true;              
                    }
                }
                newCLCalculatorVm.loanAmountCheck(newCLCalculatorVm.loanAmountIncLoan);
            }
        }


        newCLCalculatorVm.loanAmountCheck = function(loanValue){
            var loanAmt = parseInt(loanValue);
           if(loanAmt){
                if(Math.floor(loanAmt/4) >= newCLCalculatorVm.loanAmountIncAnnual){
                    newCLCalculatorVm.disablePBtnIncLoan = true;
                    newCLCalculatorVm.disableMBtnIncLoan = false;
                    newCLCalculatorVm.loanAmountIncLoan = newCLCalculatorVm.loanAmountIncAnnual *4;
                } else {
                    newCLCalculatorVm.disablePBtnIncLoan = false;
                }
                newCLCalculatorVm.emiCalculation();
           }
            
        }


        // for tab 2 i.e vehicle based.
        var listener2 = $scope.$watch(function () {
            return (newCLCalculatorVm.maxTenureVeh);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                newCLCalculatorVm.maxTenureVeh = tenureValue;
                if (newCLCalculatorVm.maxTenureVeh) {
                    newCLCalculatorVm.tenureVeh = newCLCalculatorVm.maxTenureVeh;
                    newCLCalculatorVm.emiCalculationVeh();
                }
            }
        });

        newCLCalculatorVm.loanAmountCheckVeh = function(loanValue){
            var loanAmt = parseInt(loanValue);
            if((loanAmt % parseInt(newCLCalculatorVm.steppingAmountVeh)) > 0){
                newCLCalculatorVm.loanAmountVehLoan -= (loanAmt % parseInt(newCLCalculatorVm.steppingAmountVeh));
            }else{
                newCLCalculatorVm.loanAmountVehLoan = loanAmt* 0.85;
            }
            if(loanAmt <= newCLCalculatorVm.minAnnualIncomeVeh){
                newCLCalculatorVm.loanAmountVehLoan = newCLCalculatorVm.minAnnualIncomeVeh * 0.85;
                newCLCalculatorVm.loanAmountVehCost = newCLCalculatorVm.minAnnualIncomeVeh;
                newCLCalculatorVm.disableMBtnVehCost = true;
                newCLCalculatorVm.disablePBtnVehCost = false;
            }else{
                newCLCalculatorVm.disableMBtn = false;
            }
            if(loanAmt >= newCLCalculatorVm.maxAnnualIncomeVeh){
                newCLCalculatorVm.loanAmountVehLoan = newCLCalculatorVm.maxAnnualIncomeVeh * 0.85;
                newCLCalculatorVm.loanAmountVehCost = newCLCalculatorVm.maxAnnualIncomeVeh;
                newCLCalculatorVm.disablePBtnVehCost = true;
                newCLCalculatorVm.disableMBtnVehCost = false;
            }else{
                newCLCalculatorVm.disablePBtn = false;
            }
            newCLCalculatorVm.emiCalculationVeh();
        }

        newCLCalculatorVm.emiCalculationVeh = function() {
            newCLCalculatorVm.emiAmountVeh = rxtcService.emiCalculation(newCLCalculatorVm.loanAmountVehLoan,newCLCalculatorVm.intRateVeh,newCLCalculatorVm.maxTenureVeh);
        }

        newCLCalculatorVm.decreaseIncreaseAmountIncVeh = function (loanValue,btnClicked) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newCLCalculatorVm.disableMBtnVehCost = false;
                newCLCalculatorVm.disablePBtnVehCost = false;
                if(loanAmount <= newCLCalculatorVm.minAnnualIncomeVeh){
                    newCLCalculatorVm.disableMBtnVehCost = true;            
                }

                if(btnClicked=='D'){
                    newCLCalculatorVm.loanAmountVehCost = loanAmount - parseInt(newCLCalculatorVm.steppingAmountVeh);
                    if(newCLCalculatorVm.loanAmountVehCost <= newCLCalculatorVm.minAnnualIncomeVeh){
                        newCLCalculatorVm.disableMBtnVehCost = true; 
                        newCLCalculatorVm.disablePBtnVehCost = false;           
                    } else {
                        if(newCLCalculatorVm.loanAmountVehCost <= newCLCalculatorVm.maxAnnualIncomeVeh){
                            newCLCalculatorVm.disablePBtnVehCost = false;            
                        } else {
                            newCLCalculatorVm.disableMBtnVehCost = true; 
                        }
                    }

                    if(newCLCalculatorVm.loanAmountVehLoan / 0.85 >> 0 >= newCLCalculatorVm.loanAmountVehCost){
                        newCLCalculatorVm.disablePBtnVehLoan = true;              
                    }
                    
                }

                if(btnClicked=='I'){
                    newCLCalculatorVm.loanAmountVehCost = loanAmount + parseInt(newCLCalculatorVm.steppingAmountVeh);
                    if(newCLCalculatorVm.loanAmountVehCost >= newCLCalculatorVm.maxAnnualIncomeVeh){  
                        newCLCalculatorVm.disablePBtnVehCost = true;  
                        newCLCalculatorVm.disableMBtnVehCost = false;            
                    } else {
                        if(newCLCalculatorVm.loanAmountVehCost >= newCLCalculatorVm.minAnnualIncomeVeh){
                            newCLCalculatorVm.disableMBtnVehCost = false;            
                        } else {
                            newCLCalculatorVm.disableMBtnVehCost = true; 
                            newCLCalculatorVm.disablePBtnVehCost = false;
                        } 
                    }
                }
                newCLCalculatorVm.loanAmountCheckVeh(newCLCalculatorVm.loanAmountVehCost);
            }  
        }

        newCLCalculatorVm.decreaseAmountLoanVeh = function (loanAmtValue) {
            var loanAmount = parseInt(loanAmtValue);
            if(loanAmount){
                newCLCalculatorVm.disablePBtnVehLoan = false;
                if(loanAmount <= newCLCalculatorVm.loanMinAmountVeh){
                    newCLCalculatorVm.disableMBtnVehLoan = true;               
                }else{
                    newCLCalculatorVm.loanAmountVehLoan = loanAmount - parseInt(newCLCalculatorVm.steppingAmountVeh);
                    if(newCLCalculatorVm.loanAmountVehLoan <= newCLCalculatorVm.loanMinAmountVeh){
                        newCLCalculatorVm.disableMBtnVehLoan = true;               
                    }
                }
                newCLCalculatorVm.loanAmountCheckVehicle(newCLCalculatorVm.loanAmountVehLoan);
            }  
        }

        newCLCalculatorVm.increaseAmountLoanVeh = function (loanAmtValue) {
            var loanAmount = parseInt(loanAmtValue);
            if(loanAmount){
                newCLCalculatorVm.disableMBtnVehLoan = false;
                if(Math.floor(loanAmount/4) >= newCLCalculatorVm.loanAmountVehCost){
                    newCLCalculatorVm.disablePBtnVehLoan = true;              
                }else{
                    newCLCalculatorVm.loanAmountVehLoan = loanAmount + parseInt(newCLCalculatorVm.steppingAmountVeh);
                    if(Math.floor(newCLCalculatorVm.loanAmountVehLoan/4) >= newCLCalculatorVm.loanAmountVehCost){
                        newCLCalculatorVm.disablePBtnVehLoan = true;              
                    }
                }
                newCLCalculatorVm.loanAmountCheckVehicle(newCLCalculatorVm.loanAmountVehLoan);
            }
        }


        newCLCalculatorVm.loanAmountCheckVehicle = function(loanValue){
            var loanAmt = parseInt(loanValue);
           if(loanAmt){
                if(Math.floor(loanAmt/0.85) >= newCLCalculatorVm.loanAmountVehCost){
                    newCLCalculatorVm.disablePBtnVehLoan = true;
                    newCLCalculatorVm.disableMBtnVehLoan = false;
                    newCLCalculatorVm.loanAmountVehLoan = newCLCalculatorVm.loanAmountVehCost  * 0.85;
                } else {
                    newCLCalculatorVm.disablePBtnVehLoan = false;
                }
                newCLCalculatorVm.emiCalculationVeh();
           }
            
        }

       

        newCLCalculatorVm.goback = function() {
            $ionicHistory.goBack(-1);
        };
        
        $scope.$on('$ionicView.beforeEnter', function() {
            newCLCalculatorVm.initPage();        
        });

        newCLCalculatorVm.applyCLoan = function() {            
            var request = {
                "loanType": "car"
            }

            if (carLoanService.YonodedupeData.status == '0') {
                carLoanService.getEligiblityCheck(request).then(function(data) {
                    listener();
                    listener2();
                    carLoanService.userMaster = data;
                    carLoanService.homeBranch = data.homeBranch;
                    if (data.status == "CL02") {
                        homeLoanService.source='car';
                        homeLoanService.dedupErrors = data.reasons;
                        $state.go('menu.homeLoanError');
                    } else if (data.status == "0000") {
                        $state.go('menu.carPersonaldetails');

                    } else if (data.status == "CL03") {
                        $state.go('menu.cLExtinginLos');
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go('menu.clApplicationStatus');
            }
    
        }
        return this;
    }
]);