'use strict';

angularApp.controller('newHLCalculatorController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "newLoansLandingService",
    "$morphCarousel",
    "homeLoanService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        newLoansLandingService,
        $morphCarousel,
        homeLoanService) {

        var newHLCalculatorVm = this;

        newHLCalculatorVm.initPage = function () {
            newHLCalculatorVm.buttonText = homeLoanService.getButtonText();
            var tenures = [];            
            newHLCalculatorVm.emiAmount = 0;
            newHLCalculatorVm.homeLoanDetails = newLoansLandingService.getHomeLoanData().getLoansDetails;         
            newHLCalculatorVm.loanInitialAmount = newHLCalculatorVm.homeLoanDetails.amount.initial;
            newHLCalculatorVm.loanMaxAmount = newHLCalculatorVm.homeLoanDetails.amount.max;
            newHLCalculatorVm.loanMinAmount = newHLCalculatorVm.homeLoanDetails.amount.min;
            newHLCalculatorVm.minTenure =  parseInt(newHLCalculatorVm.homeLoanDetails.tenure.min);
            newHLCalculatorVm.maxTenure =  parseInt(newHLCalculatorVm.homeLoanDetails.tenure.max);
            newHLCalculatorVm.initialTenure =  parseInt(newHLCalculatorVm.homeLoanDetails.tenure.initial);
            newHLCalculatorVm.tenuresHl = [];
            var minTenure = parseInt(newHLCalculatorVm.homeLoanDetails.tenure.min);
            var maxTenure = parseInt(newHLCalculatorVm.homeLoanDetails.tenure.max);
            newHLCalculatorVm.selectedTenure = newHLCalculatorVm.initialTenure;
            newHLCalculatorVm.steppingAmount = 1000;
            
            for (var i = minTenure; i <= maxTenure; i++) {
                tenures.push(i);
            }
            
            newHLCalculatorVm.tenuresHl = tenures;
            newHLCalculatorVm.disableMBtn = false;
            newHLCalculatorVm.disablePBtn = false;
            
            newHLCalculatorVm.tenure = newHLCalculatorVm.selectedTenure;
            newHLCalculatorVm.loanAmount = newHLCalculatorVm.loanInitialAmount;
            if(newHLCalculatorVm.loanAmount <= newHLCalculatorVm.loanMinAmount){
                newHLCalculatorVm.disableMBtn = true;
            }
            if(newHLCalculatorVm.loanAmount >= newHLCalculatorVm.loanMaxAmount){
                newHLCalculatorVm.disablePBtn = true;
            }
            newHLCalculatorVm.emiCalculation();
        }

        newHLCalculatorVm.emiCalculation = function(){
            var range = newLoansLandingService.getHomeLoanData().loanDetails;
            var p = newHLCalculatorVm.loanAmount;
            for(var i = 0; i < range.length ; i++){
                if(range[i].minLaonAmount <= p  && range[i].maxLaonAmount >= p){
                    newHLCalculatorVm.interestRate = range[i].intRate;
                    break;
                }
            }
            var i = (newHLCalculatorVm.interestRate/1200);
            var t = newHLCalculatorVm.selectedTenure;
            var numerator = p * i * Math.pow((1+i),t);
            var denominator = Math.pow((1+i),t) - 1;
            newHLCalculatorVm.emiAmount = Math.ceil((numerator/denominator));		
        }

        var listener = $scope.$watch(function () {
            return (newHLCalculatorVm.selectedTenure);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                newHLCalculatorVm.selectedTenure = tenureValue;
                if (newHLCalculatorVm.selectedTenure) {
                    newHLCalculatorVm.tenure = newHLCalculatorVm.selectedTenure;
                    newHLCalculatorVm.emiCalculation();
                }
            }
        });

        newHLCalculatorVm.loanAmountCheck = function(loanValue){
            var loanAmt = parseInt(loanValue);
            if((loanAmt % parseInt(newHLCalculatorVm.steppingAmount)) > 0){
                newHLCalculatorVm.loanAmount -= (loanAmt % parseInt(newHLCalculatorVm.steppingAmount));
            }else{
                newHLCalculatorVm.loanAmount = loanAmt;
            }
            if(newHLCalculatorVm.loanAmount <= newHLCalculatorVm.loanMinAmount){
                newHLCalculatorVm.loanAmount = parseInt(newHLCalculatorVm.loanMinAmount);
                newHLCalculatorVm.disableMBtn = true;
            }else{
                newHLCalculatorVm.disableMBtn = false;
            }
            if(newHLCalculatorVm.loanAmount >= newHLCalculatorVm.loanMaxAmount){
                newHLCalculatorVm.loanAmount = parseInt(newHLCalculatorVm.loanMaxAmount)
                newHLCalculatorVm.disablePBtn = true;
            }else{
                newHLCalculatorVm.disablePBtn = false;
            }
            newHLCalculatorVm.emiCalculation();
        }


        newHLCalculatorVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newHLCalculatorVm.disablePBtn = false;
                if(loanAmount <= newHLCalculatorVm.loanMinAmount){
                    newHLCalculatorVm.disableMBtn = true;               
                }else{
                    newHLCalculatorVm.loanAmount = loanAmount - parseInt(newHLCalculatorVm.steppingAmount);
                    if(newHLCalculatorVm.loanAmount <= newHLCalculatorVm.loanMinAmount){
                        newHLCalculatorVm.disableMBtn = true;               
                    }
                }
                newHLCalculatorVm.loanAmountCheck(newHLCalculatorVm.loanAmount);
                newHLCalculatorVm.emiCalculation();
            }  
        }

        newHLCalculatorVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newHLCalculatorVm.disableMBtn = false;
                if(loanAmount >= newHLCalculatorVm.loanMaxAmount){
                    newHLCalculatorVm.disablePBtn = true;              
                }else{
                    newHLCalculatorVm.loanAmount = loanAmount + parseInt(newHLCalculatorVm.steppingAmount);
                    if(newHLCalculatorVm.loanAmount >= newHLCalculatorVm.loanMaxAmount){
                        newHLCalculatorVm.disablePBtn = true;              
                    }
                }
                newHLCalculatorVm.loanAmountCheck(newHLCalculatorVm.loanAmount);
            }
            newHLCalculatorVm.emiCalculation();
        }

        newHLCalculatorVm.goback = function() {
            $ionicHistory.goBack(-1);
        };
        
        $scope.$on('$ionicView.beforeEnter', function() {
            newHLCalculatorVm.initPage();
        });

        newHLCalculatorVm.applyHLoan = function() {            
            var request = {
                "loanType": "home"
            }
            homeLoanService.disableBackButton = false;
            if (homeLoanService.getYonoDedupeData().status == '0') {
                homeLoanService.getEligiblityCheck(request).then(function(data) {
                    listener();
                    homeLoanService.homeBranch=data.homeBranch;
                    homeLoanService.userMaster = data;
                    if (data.status == "HL02") {
                        homeLoanService.dedupErrors = data.reasons;
                        $state.go('menu.homeLoanError');
                    } else if (data.status == "0000") {
                        $state.go('menu.homeLoanPersonalDetails');
                    } else if (data.status == "HL03") {
                        homeLoanService.multipleAppErrors = data;
                        homeLoanService.isMultipleLOS = true;
                        $state.go('menu.homeLoanRetApp');
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }      
        }
        return this;
    }
]);