'use strict';

angularApp.controller('newLoansLandingController', ["$state", "$scope", "$translate","mobilityLandingService","$ionicSideMenuDelegate","utilityService","$ionicSlideBoxDelegate","homeLoanService","automallService","$filter","homeScreenService","patwlService","getAccountDetailsService","newLoansLandingService","carLoanService","xpressCreditService","educationLoanService","goldLoanRLMSService","rxtcService","$ionicPopup","personalLoanService","$sce","instaHomeService",
    function($state, $scope,$translate,mobilityLandingService, $ionicSideMenuDelegate, utilityService,$ionicSlideBoxDelegate,homeLoanService,automallService,$filter,homeScreenService,patwlService,getAccountDetailsService,newLoansLandingService,carLoanService,xpressCreditService,educationLoanService,goldLoanRLMSService,rxtcService,$ionicPopup,personalLoanService,$sce,instaHomeService) {

        var newLoansLandingVm = this;
        newLoansLandingVm.mobilityData = "";

        function initPage() {
            newLoansLandingVm.mobilityData = newLoansLandingService.getBannersData();
            newLoansLandingVm.loansGroups = newLoansLandingVm.mobilityData.loansTypes;
            newLoansLandingVm.banner1List=[];
            newLoansLandingVm.banner2List=[];
            newLoansLandingVm.getBannersList(); 

            newLoansLandingVm.buttonText = "";
            if (utilityService.isAndroidPlatform()) {
                newLoansLandingVm.osType = "android";
            }
            if (utilityService.isIOSPlatform()) { 
                newLoansLandingVm.osType = "ios";
            }
            var payload = {
                "osType": newLoansLandingVm.osType ? newLoansLandingVm.osType : ''
            }

            homeLoanService.getLoanLanding(payload).then(function(data) {
                homeLoanService.setlandingPageDetails(data.getLoans);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            utilityService.hideSpinner();
        }

        newLoansLandingVm.flpcLanding = function () {
			$state.go('menu.flpcLanding');
		};

        newLoansLandingVm.getBannersList = function(){
            newLoansLandingVm.banner1List = newLoansLandingVm.mobilityData.staticBanners;
            newLoansLandingVm.preApprovedBannersArray = newLoansLandingVm.mobilityData.preApprovedBanners;

            if(newLoansLandingVm.preApprovedBannersArray && newLoansLandingVm.preApprovedBannersArray.length > 0){
                newLoansLandingService.setPreApprovedBannerData(newLoansLandingVm.preApprovedBannersArray);
                var eligibleSumAssured = "";
                for (var i = 0; i < newLoansLandingVm.preApprovedBannersArray.length; i++) {
                    if(newLoansLandingVm.preApprovedBannersArray[i].category == "PAPL"){
                         eligibleSumAssured = $filter('INR')(parseInt(newLoansLandingVm.preApprovedBannersArray[i].palAmount));
                    } else  if(newLoansLandingVm.preApprovedBannersArray[i].category == "PACL" || newLoansLandingVm.preApprovedBannersArray[i].category == "IHL"){
                         eligibleSumAssured = $filter('INR')(parseInt(newLoansLandingVm.preApprovedBannersArray[i].amount));
                    } else  if(newLoansLandingVm.preApprovedBannersArray[i].category == "PA2WL"){
                         eligibleSumAssured = $filter('INR')(parseInt(newLoansLandingVm.preApprovedBannersArray[i].maxLoanAmt));
                    }
                    newLoansLandingVm.preApprovedBannersArray[i].messageDescription = newLoansLandingVm.preApprovedBannersArray[i].messageDescription ? newLoansLandingVm.preApprovedBannersArray[i].messageDescription.replace("eligibleAmount}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                }
                newLoansLandingVm.banner2List = newLoansLandingVm.preApprovedBannersArray;
            }
            
            setTimeout(function () {
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.loop(true);
            }, 500);
        }

        newLoansLandingVm.goBacktoPrevious = function() {
            $state.go('menu.homeScreen');
        };

        newLoansLandingVm.goToLandingPage = function(redirectURL) {
            if(redirectURL=="menu.loans"){
                newLoansLandingVm.gotoCarloan();
            }else if(redirectURL=="menu.automall"){
                newLoansLandingVm.gotoAutomall();
            }else if(redirectURL=="menu.fasTagLanding"){
                newLoansLandingVm.gotoFastag();
            }else{
                $state.go(redirectURL);
            }
        }

        newLoansLandingVm.goToPreApproved = function(category) {
            if(category == "PA2WL"){
                patwlService.getInitialEligibility().then(function (response) {
					if (response.eligibilityResult.toUpperCase() == 'Y') {
						patwlService.setInitailEligibilityData(response);
						newLoansLandingService.getPreApprovedKnowMoreAPICall('PA2WL');
					}
				}, function (error) {
					if (error.responseCode == "IE01") {
						homeScreenService.isNotificationDataAvail = false;
						patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
					} else {
						utilityService.showErrorMessage(error.responseMessage);
					}
				});
            } else if(category == "PACL"){
                $state.go('menu.paclReqDetails');
            } else if(category== "PAPL"){
                personalLoanService.getLoanDetails({category:category}).then(function (data) {
                    personalLoanService.setPANDOBData();
                    personalLoanService.personalLoanData = data;
                    personalLoanService.minDuration = data.minTenure;
                    personalLoanService.maxDuration = data.maxTenure;
                    personalLoanService.interestRate = data.interestRate;
                    personalLoanService.product = data.productCode;
                    personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                    personalLoanService.processingFee = data.processingFee;
                    personalLoanService.minBestOffer = data.minPalAmount;
                    personalLoanService.activityCode = data.activityCode;
                    personalLoanService.schemeCode = data.schemeCode;
                    personalLoanService.categoryType = category;
                    newLoansLandingService.getPreApprovedKnowMoreAPICall('PAPL'); 
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if(category == "IHL"){
                instaHomeService.getFetchData().then(function(data) {
                    instaHomeService.initialValueInsta();
                    if (data) {
                        instaHomeService.customer.accountno = data.loanAccountNumber;
                        instaHomeService.customer.bestofferamount = data.maxLoanAmount;
                        instaHomeService.customer.selectedamount = data.maxLoanAmount;
                        instaHomeService.customer.interestrate = data.interestRate;
                        instaHomeService.customer.loanduration = data.duration;
                        instaHomeService.customer.processingfees = data.processingFees;
                        instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
                        instaHomeService.customer.mclr = data.mclr;
                        instaHomeService.customer.nightMode = data.nightMode;
                        instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
                        instaHomeService.customer.minLoanAmount = data.minLoanAmount;
                        instaHomeService.customer.steppingAmount = data.steppingAmount;
                        instaHomeService.customer.customerName = data.customerName;
                    }
                    newLoansLandingService.getPreApprovedKnowMoreAPICall('IHL'); 
                }, function (error) {
                    if(error.responseCode == '0002')
                    {
                        $ionicPopup.show({
                        title: null,
                        cssClass: 'my-custom-popup',
                        template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+error.responseMessage+'</div>',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive'
                        }]
                    });
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }
        }

        newLoansLandingVm.gotoMyLoans = function() {
            homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isLoansFlag = true;
            getAccountDetailsService.tabIndex.tabIndex=2;
            $state.go('menu.accountOverviewMyBalance');            
        };

        newLoansLandingVm.goToLoanEntryPointPage = function(group) {
            homeScreenService.ishamMenu = false;
            newLoansLandingService.setSelectedGroup(group);
            newLoansLandingService.goToLoan(group);
            
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();            
        });
	
        return this;
    }
]);