'use strict';

angularApp.controller('newPLCalculatorController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "$morphCarousel",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,$morphCarousel) {

        var newPLCalculatorVm = this;

        newPLCalculatorVm.initPage = function () {
            newPLCalculatorVm.buttonText = rxtcService.getButtonText();
            var tenures = [];

            newPLCalculatorVm.rtxcKnowMoreDetails = rxtcService.getKnowMoreDetailsData().emiCalcDetails;          

            newPLCalculatorVm.loanMaxAmount = newPLCalculatorVm.rtxcKnowMoreDetails.maxLoanAmount;
            newPLCalculatorVm.loanMinAmount = newPLCalculatorVm.rtxcKnowMoreDetails.minLoanAmount;
            
            var minTenure = parseInt(newPLCalculatorVm.rtxcKnowMoreDetails.minTenure);
            var maxTenure = parseInt(newPLCalculatorVm.rtxcKnowMoreDetails.maxTenure);
            newPLCalculatorVm.selectedTenure = maxTenure;
            newPLCalculatorVm.steppingAmount = 1000;

            for (var i = minTenure; i <= maxTenure; i++) {
                tenures.push(i);
            }
            newPLCalculatorVm.tenures = [];
            newPLCalculatorVm.tenures = tenures;
            newPLCalculatorVm.disableMBtn = false;
            newPLCalculatorVm.disablePBtn = false;
            
            newPLCalculatorVm.loanAmount = newPLCalculatorVm.loanMaxAmount;

            newPLCalculatorVm.interestRate = newPLCalculatorVm.rtxcKnowMoreDetails.rateOfInterest;
            newPLCalculatorVm.tenure = newPLCalculatorVm.selectedTenure;

            if(newPLCalculatorVm.loanAmount <= newPLCalculatorVm.loanMinAmount){
                newPLCalculatorVm.disableMBtn = true;
            }
            if(newPLCalculatorVm.loanAmount >= newPLCalculatorVm.loanMaxAmount){
                newPLCalculatorVm.disablePBtn = true;
            }

            newPLCalculatorVm.emiCalculation();
            
        }

        var listener = $scope.$watch(function () {
            return (newPLCalculatorVm.selectedTenure);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                newPLCalculatorVm.selectedTenure = tenureValue;
                if (newPLCalculatorVm.selectedTenure) {
                    newPLCalculatorVm.tenure = newPLCalculatorVm.selectedTenure;
                    newPLCalculatorVm.emiCalculation();
                }
            }
        });

        newPLCalculatorVm.loanAmountCheck = function(loanValue){
            var loanAmt = parseInt(loanValue);
            if((loanAmt % parseInt(newPLCalculatorVm.steppingAmount)) > 0){
                newPLCalculatorVm.loanAmount -= (loanAmt % parseInt(newPLCalculatorVm.steppingAmount));
            }else{
                newPLCalculatorVm.loanAmount = loanAmt;
            }
            if(newPLCalculatorVm.loanAmount <= newPLCalculatorVm.loanMinAmount){
                newPLCalculatorVm.loanAmount = parseInt(newPLCalculatorVm.loanMinAmount);
                newPLCalculatorVm.disableMBtn = true;
            }else{
                newPLCalculatorVm.disableMBtn = false;
            }
            if(newPLCalculatorVm.loanAmount >= newPLCalculatorVm.loanMaxAmount){
                newPLCalculatorVm.loanAmount = parseInt(newPLCalculatorVm.loanMaxAmount)
                newPLCalculatorVm.disablePBtn = true;
            }else{
                newPLCalculatorVm.disablePBtn = false;
            }
            newPLCalculatorVm.emiCalculation();
        }

        newPLCalculatorVm.emiCalculation = function() {
            newPLCalculatorVm.emiAmount = rxtcService.emiCalculation(newPLCalculatorVm.loanAmount,newPLCalculatorVm.interestRate,newPLCalculatorVm.tenure);
        }

        newPLCalculatorVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newPLCalculatorVm.disablePBtn = false;
                if(loanAmount <= newPLCalculatorVm.loanMinAmount){
                    newPLCalculatorVm.disableMBtn = true;               
                }else{
                    newPLCalculatorVm.loanAmount = loanAmount - parseInt(newPLCalculatorVm.steppingAmount);
                    if(newPLCalculatorVm.loanAmount <= newPLCalculatorVm.loanMinAmount){
                        newPLCalculatorVm.disableMBtn = true;               
                    }
                }
                newPLCalculatorVm.loanAmountCheck(newPLCalculatorVm.loanAmount);
            }  
        }

        newPLCalculatorVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                newPLCalculatorVm.disableMBtn = false;
                if(loanAmount >= newPLCalculatorVm.loanMaxAmount){
                    newPLCalculatorVm.disablePBtn = true;              
                }else{
                    newPLCalculatorVm.loanAmount = loanAmount + parseInt(newPLCalculatorVm.steppingAmount);
                    if(newPLCalculatorVm.loanAmount >= newPLCalculatorVm.loanMaxAmount){
                        newPLCalculatorVm.disablePBtn = true;              
                    }
                }
                newPLCalculatorVm.loanAmountCheck(newPLCalculatorVm.loanAmount);
            }
        }

        newPLCalculatorVm.goback = function() {
            $ionicHistory.goBack(-1);
        };
        
        $scope.$on('$ionicView.beforeEnter', function() {
            newPLCalculatorVm.initPage();    
        });

        newPLCalculatorVm.applyNewRTXCLoan = function() {            
            rxtcService.isLoanAppSanction = false;
            if (rxtcService.getYonoDedupeData().status == '0') {
                rxtcService.getEligiblityCheck().then(function(data) {
                    listener();
                    rxtcService.clearAll();
                    rxtcService.rtxcPush = false;
                    rxtcService.backToDetails =  false;
                    rxtcService.resumeData = false;
                    rxtcService.initialData = data;
                    rxtcService.userMaster = data.master;
                    rxtcService.yonoRef = data.yonoRef;
                    if (data.salaryAccountPackage == "DSP" || data.salaryAccountPackage == "PMSP" || data.salaryAccountPackage == "ICGSP") {
                        rxtcService.salaryAccountSpecial = true;
                    }
                    if (!rxtcService.initialData.isDuplicate && rxtcService.initialData.isSanctioned) {
                        rxtcService.isLoanAppSanction = true;
                        rxtcService.initialData.isYonoApp = false;
                        $state.go('menu.rtxcApplicationStatus');
                    }else if (!rxtcService.initialData.isYonoApp && !rxtcService.initialData.isNonYonoApp) {
                        $state.go('menu.rxtcDetails');
                    }else {
                        $state.go('menu.rtxcApplicationStatus');
                    }
                }, function(error) {
                    if(error.responseCode == "IE01"){
                        rxtcService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }else if (rxtcService.getYonoDedupeData().status == '1') {
                rxtcService.getRlmsDedup().then(function(data) {
                    listener();
                    rxtcService.resumeData = data;
                    rxtcService.userMaster = data.master;
                    rxtcService.yonoRef = data.referenceNo;
                    rxtcService.initialData = false;
                    if (!rxtcService.resumeData.isDuplicate && rxtcService.resumeData.isSanctioned) {
                        rxtcService.isLoanAppSanction = true;
                        rxtcService.resumeData.isYonoApp = false;
                        var reqParams = {
                            "isSanctioned": true
                        }                   
                        rxtcService.deleteApplication(reqParams).then(function() {
                            rxtcService.clearAll();
                            rxtcService.resumeData = false;
                            rxtcService.personalDetailCheck = false;                             
                        },function(error){
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }else if (rxtcService.resumeData.isDuplicate) {
                        rxtcService.resumeData.isNonYonoApp = false;
                    }
                    $state.go('menu.rtxcApplicationStatus');                        
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }        
        }
        return this;
    }
]);