'use strict';

angularApp.controller('clNTBIncomeStmtController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "cryptoService",
    "clNTBCalculatorService",
    "hlNTBCalculatorService",
    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        cryptoService,
        clNTBCalculatorService,
        hlNTBCalculatorService) {

        var clNTBIncomeStmtVm = this;     

        clNTBIncomeStmtVm.initPage = function () {
            if(clNTBCalculatorService.productIDNTBCL){
                clNTBIncomeStmtVm.productIDNTBAA = clNTBCalculatorService.productIDNTBCL;
            }else if(hlNTBCalculatorService.productIDNTBHL){
                clNTBIncomeStmtVm.productIDNTBAA = hlNTBCalculatorService.productIDNTBHL;
            }
            var payload= {
                "productId": clNTBIncomeStmtVm.productIDNTBAA                   
            }
            clNTBCalculatorService.getDisclaimerContent(payload).then(function (response) {
                clNTBCalculatorService.disclaimerLine1 = response.disclaimerLine1;
                clNTBCalculatorService.disclaimerLine2 = response.disclaimerLine2;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        clNTBIncomeStmtVm.goBack = function (){
            $ionicHistory.goBack();
        }

        clNTBIncomeStmtVm.proceedToAA = function() {
            if(clNTBCalculatorService.ntbConsentCounter === 1){
                clNTBCalculatorService.finalConsentCheck();
            }else{
                $state.go('menu.ntbAALandingPage');
            }
        }

        clNTBIncomeStmtVm.skipAA = function() {
            clNTBCalculatorService.ntbConsentCounterSubmitted = 1;
            clNTBCalculatorService.ntbConsentCounter = 0;
            if(clNTBCalculatorService.productIDNTBCL){
                $state.go('menu.clNTBReferenceDetails');
            }else if(hlNTBCalculatorService.productIDNTBHL){
                $state.go('menu.hlNTBReferenceDetails');
            }             
        }
     
        $scope.$on('$ionicView.beforeEnter', function () {
            clNTBIncomeStmtVm.initPage();
        });

        return this;
    }
]);