'use strict';

angularApp.controller('carLoanProcessingRAASController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$interval", "$timeout","utilityService","carLoanService","homeLoanService",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $interval,
        $timeout,
        utilityService,
        carLoanService,
        homeLoanService) {
        var carLoanProcessingVm = this;
        function initPage() {
            carLoanProcessingVm.timeInSeconds = 30;
            carLoanProcessingVm.showProcessingTimer = true;
            carLoanProcessingVm.startTimer(carLoanProcessingVm.timeInSeconds);
        }


        carLoanProcessingVm.startTimer = function (timeIn) {
            carLoanProcessingVm.countdown = timeIn;
            var div = 60;
            carLoanProcessingVm.textContentSec = carLoanProcessingVm.countdown % div;
            var rem = carLoanProcessingVm.countdown - carLoanProcessingVm.textContentSec;
            carLoanProcessingVm.textContentMin = rem / div;

            $interval(function () {
                carLoanProcessingVm.textContentSec = carLoanProcessingVm.countdown % div;
                rem = carLoanProcessingVm.countdown - carLoanProcessingVm.textContentSec;
                carLoanProcessingVm.textContentMin = rem / div;
                if (carLoanProcessingVm.textContentMin == 0 && carLoanProcessingVm.textContentSec == 0) {
                    carLoanProcessingVm.showProcessingTimer = false;
                } else {
                    carLoanProcessingVm.countdown = --carLoanProcessingVm.countdown;
                }
            }, 1000)
        }

        carLoanProcessingVm.triggerfetchROIMaster = function () {
            var request = carLoanService.saveObj;
            carLoanService.fetchROIMaster(request).then(function (data) {
                homeLoanService.source = "car";
                carLoanService.saveObj = request;
                carLoanService.roiResponse = data;
                carLoanService.roiMasterData = data.roiMasterData;
                carLoanProcessingVm.decideNextPageRedirection(data);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carLoanProcessingVm.decideNextPageRedirection = function (roiResponse) {
            if (roiResponse.result == 'C') {
                carLoanService.emiData = roiResponse.emiData;
                $state.go('menu.carLoancalculateEMI');
            } else if (roiResponse.result == 'N') {
                $state.go('menu.carLoanSelectBranch');
            } else if (roiResponse.result == 'P' || roiResponse.result == 'E') {
                $state.go('menu.carLoanAdditionalInfo');
            }
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
        });

        return this;
    }
]);