'use strict';
angularApp.controller('carLoanWorkDetailsRAASController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "customerInfoService",
    "validateService",
    "$filter",
    "homeLoanService", "carLoanService", "AdapterUtils",
    function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, customerInfoService, validateService, $filter, homeLoanService, carLoanService, AdapterUtils) {

        var carLoanWorkDetailsVm = this;

        function initPage() {
            carLoanWorkDetailsVm.detail = {};
            carLoanWorkDetailsVm.errObj = {};
            carLoanWorkDetailsVm.isCSPFlag = false;
            
            if (carLoanService.workData) {
                carLoanWorkDetailsVm.detail = carLoanService.workData;
                carLoanWorkDetailsVm.showFields(true, true);

                if (carLoanService.resumeData) {
                    carLoanWorkDetailsVm.employmentType = carLoanService.resumeData.master.employemntTypes;
                    carLoanWorkDetailsVm.employerType = carLoanService.resumeData.master.employerTypes;
                    carLoanWorkDetailsVm.professionType = carLoanService.resumeData.master.professionTypes;
                    carLoanWorkDetailsVm.states = carLoanService.resumeData.master.states;

                    for (var i = 0; i < carLoanService.resumeData.applicants[0].address.length; i++) {
                        if (carLoanService.resumeData.applicants[0].address[i].addressType == 'O') {
                            if (carLoanService.resumeData.applicants[0].address[i].pincode) {
                                carLoanWorkDetailsVm.detail.pin = carLoanService.resumeData.applicants[0].address[i].pincode;
                            }
                        }
                    }
                    carLoanWorkDetailsVm.emiTypes = carLoanService.resumeData.master.emises;
                    carLoanWorkDetailsVm.calculateEMIs();
                } else {
                    carLoanWorkDetailsVm.masterData = carLoanService.userMaster;

                    carLoanWorkDetailsVm.employmentType = carLoanWorkDetailsVm.masterData.master.employemntTypes;
                    carLoanWorkDetailsVm.employerType = carLoanWorkDetailsVm.masterData.master.employerTypes;
                    carLoanWorkDetailsVm.professionType = carLoanWorkDetailsVm.masterData.master.professionTypes;
                    carLoanWorkDetailsVm.emiTypes = carLoanWorkDetailsVm.masterData.master.emises;
                    carLoanWorkDetailsVm.calculateEMIs();
                }


                carLoanWorkDetailsVm.states = carLoanService.stateDistrictCityMasterDataWork.states;
                carLoanWorkDetailsVm.districts = carLoanService.stateDistrictCityMasterDataWork.districts;
                carLoanWorkDetailsVm.cities = carLoanService.stateDistrictCityMasterDataWork.cities;

            } else if (carLoanService.resumeData) {
                carLoanWorkDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                carLoanWorkDetailsVm.employmentType = carLoanService.resumeData.master.employemntTypes;
                carLoanWorkDetailsVm.employerType = carLoanService.resumeData.master.employerTypes;
                carLoanWorkDetailsVm.professionType = carLoanService.resumeData.master.professionTypes;

                if (carLoanWorkDetailsVm.masterData.employmentType) {
                    carLoanWorkDetailsVm.detail.employmentType = carLoanWorkDetailsVm.masterData.employmentType;
                    carLoanWorkDetailsVm.employmentType = carLoanService.resumeData.master.employemntTypes;
                    carLoanWorkDetailsVm.states = [];
                    carLoanWorkDetailsVm.districts = [];
                    carLoanWorkDetailsVm.cities = [];
                    carLoanWorkDetailsVm.emiTypes = carLoanService.resumeData.master.emises;
                    carLoanWorkDetailsVm.showFields(true);
                    carLoanWorkDetailsVm.detail.custName = carLoanWorkDetailsVm.masterData.firstName + ' ' + carLoanWorkDetailsVm.masterData.lastName;
                    carLoanWorkDetailsVm.employmentType = carLoanService.resumeData.master.employemntTypes;

                    if (carLoanWorkDetailsVm.detail.employmentType == '1') {
                        carLoanWorkDetailsVm.detail.employerType = carLoanWorkDetailsVm.masterData.employerType;
                        carLoanWorkDetailsVm.detail.netMonthlyIncome = carLoanWorkDetailsVm.masterData.netMonthlyIncome;
                        carLoanWorkDetailsVm.detail.incomeFromHouseProp = carLoanWorkDetailsVm.masterData.netMonthlyIncome;
                    } else {
                        carLoanWorkDetailsVm.detail.professionType = carLoanWorkDetailsVm.masterData.professionType;
                        carLoanWorkDetailsVm.detail.netMonthlyIncome = carLoanWorkDetailsVm.masterData.netMonthlyIncome;
                        carLoanWorkDetailsVm.detail.pan = carLoanWorkDetailsVm.masterData.tan;

                    }

                    carLoanWorkDetailsVm.detail.incomeFromHouseProp = carLoanWorkDetailsVm.masterData.incomeHouseProperty;
                    carLoanWorkDetailsVm.detail.officename = carLoanWorkDetailsVm.masterData.officeName;
                    carLoanWorkDetailsVm.detail.email = carLoanWorkDetailsVm.masterData.officalEmail;
                    carLoanWorkDetailsVm.detail.workExpYears = carLoanWorkDetailsVm.masterData.workExpinyears;
                    carLoanWorkDetailsVm.detail.workExpMonths = carLoanWorkDetailsVm.masterData.workExpinmoths;
                    carLoanWorkDetailsVm.detail.currentExpYears = carLoanWorkDetailsVm.masterData.currJobinyears;
                    carLoanWorkDetailsVm.detail.currentExpMonths = carLoanWorkDetailsVm.masterData.currJobinmonths;


                    for (var i = 0; i < carLoanWorkDetailsVm.masterData.address.length; i++) {
                        if (carLoanWorkDetailsVm.masterData.address[i].addressType.toLowerCase() == 'o') {
                            carLoanWorkDetailsVm.detail.addressLine1 = carLoanWorkDetailsVm.masterData.address[i].addressLine1;
                            carLoanWorkDetailsVm.detail.address2 = carLoanWorkDetailsVm.masterData.address[i].addressLine2;
                            carLoanWorkDetailsVm.detail.pin = carLoanWorkDetailsVm.masterData.address[i].pincode;
                            carLoanWorkDetailsVm.fetchStateDistrictCityByPinCode(carLoanWorkDetailsVm.detail.pin, 'office');
                            var cityObj = JSON.parse(carLoanWorkDetailsVm.masterData.address[i].cityText);
                            carLoanWorkDetailsVm.detail.city = cityObj;

                            var districtObj = JSON.parse(carLoanWorkDetailsVm.masterData.address[i].districtText);
                            carLoanWorkDetailsVm.detail.district = districtObj;
                            carLoanWorkDetailsVm.detail.state = JSON.parse(carLoanWorkDetailsVm.masterData.address[i].stateText);

                        }
                    }
                    carLoanWorkDetailsVm.detail.totalEMIs = carLoanWorkDetailsVm.masterData.emi ? carLoanWorkDetailsVm.masterData.emi : [];
                    carLoanWorkDetailsVm.calculateEMIs();
                } else {
                    carLoanWorkDetailsVm.masterData = carLoanService.userMaster;
                    carLoanWorkDetailsVm.detail.custName = carLoanWorkDetailsVm.masterData.firstName + ' ' + carLoanWorkDetailsVm.masterData.lastName;
                    carLoanWorkDetailsVm.employmentType = carLoanWorkDetailsVm.masterData.master.employemntTypes;
                    carLoanWorkDetailsVm.employerType = carLoanWorkDetailsVm.masterData.master.employerTypes;
                    carLoanWorkDetailsVm.professionType = carLoanWorkDetailsVm.masterData.master.professionTypes;
                    carLoanWorkDetailsVm.states = [];
                    carLoanWorkDetailsVm.districts = [];
                    carLoanWorkDetailsVm.cities = [];
                    carLoanWorkDetailsVm.emiTypes = carLoanWorkDetailsVm.masterData.master.emises;
                    carLoanWorkDetailsVm.detail.totalEMIs = [];
                    carLoanWorkDetailsVm.hideAllFields();
                    carLoanWorkDetailsVm.addEMI();
                }


            } else {
                carLoanWorkDetailsVm.masterData = carLoanService.userMaster;

                carLoanWorkDetailsVm.employmentType = carLoanWorkDetailsVm.masterData.master.employemntTypes;
                carLoanWorkDetailsVm.employerType = carLoanWorkDetailsVm.masterData.master.employerTypes;
                carLoanWorkDetailsVm.professionType = carLoanWorkDetailsVm.masterData.master.professionTypes;
                carLoanWorkDetailsVm.states = [];
                carLoanWorkDetailsVm.districts = [];
                carLoanWorkDetailsVm.cities = [];
                carLoanWorkDetailsVm.emiTypes = carLoanWorkDetailsVm.masterData.master.emises;
                carLoanWorkDetailsVm.detail.totalEMIs = [];
                carLoanWorkDetailsVm.hideAllFields();
                carLoanWorkDetailsVm.addEMI();

            }

            $ionicScrollDelegate.resize();

            var request = {

            };
            carLoanService.validateCSP(request).then(function (data) {

                if (data.cspFlag) {
                    carLoanWorkDetailsVm.isCSP = true;
                }

            });

        };

        carLoanWorkDetailsVm.showMInfoPopup = function (type) {
            console.log("inininiinini")
            //alert("info icon ");
            var templateInfo = "";
            if (type == 'netMonthlyIncome') {
                templateInfo = '<p translate="MONTHLY_INFO"></p>';
            } else if (type == 'netAnnualIncome') {
                templateInfo = '<p translate="ANNUAL_INCOME_TOOL_TIP"></p>';
            } else if (type == 'houseProp') {
                templateInfo = '<p translate="RENTAL_INCOME"></p>';
            } else if (type == 'propertyCost') {
                templateInfo = '<p translate="PROP_COST_TOOL_TIP"></p>';
            } else if (type == 'netProfit') {
                templateInfo = '<p translate="NET_PROFIT"></p>';
            }

            var hlInfoIcon = $ionicPopup.show({
                template: templateInfo,
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });

        }


        carLoanWorkDetailsVm.validateForm = function () {
            carLoanWorkDetailsVm.errObj = {};


            if (validateService.isValidEmploymentType(carLoanWorkDetailsVm.detail.employmentType)) {
                carLoanWorkDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(carLoanWorkDetailsVm.detail.employmentType);
            }

            if (carLoanWorkDetailsVm.isNetMonthlyIncome) {
                if (validateService.isValidMonthlyIncome(carLoanWorkDetailsVm.detail.netMonthlyIncome)) {
                    carLoanWorkDetailsVm.errObj.netMonthlyIncome = validateService.isValidMonthlyIncome(carLoanWorkDetailsVm.detail.netMonthlyIncome);
                }
            }

            if (carLoanWorkDetailsVm.isNetAnnualIncome) {
                if (validateService.isValidMonthlyIncome(carLoanWorkDetailsVm.detail.netMonthlyIncome)) {
                    carLoanWorkDetailsVm.errObj.netMonthlyIncome = validateService.isValidMonthlyIncome(carLoanWorkDetailsVm.detail.netMonthlyIncome);
                }
            }

            if (carLoanWorkDetailsVm.isProfessionType) {
                if (validateService.isValidProfession(carLoanWorkDetailsVm.detail.professionType)) {
                    carLoanWorkDetailsVm.errObj.professionType = validateService.isValidProfession(carLoanWorkDetailsVm.detail.professionType);
                }
            }

            // if(carLoanWorkDetailsVm.isIncomeFromHouseProp){
            //     if (validateService.isValidIncome(carLoanWorkDetailsVm.detail.incomeFromHouseProp)) {
            //         carLoanWorkDetailsVm.errObj.incomeFromHouseProp = validateService.isValidIncome(carLoanWorkDetailsVm.detail.incomeFromHouseProp);
            //     }
            // }

            if (carLoanWorkDetailsVm.isEmployerType) {
                if (validateService.isValidEmployerType(carLoanWorkDetailsVm.detail.employerType)) {
                    carLoanWorkDetailsVm.errObj.employerType = validateService.isValidEmployerType(carLoanWorkDetailsVm.detail.employerType);
                }
            }

            if (carLoanWorkDetailsVm.isWorkExp) {
                if (validateService.isValidMonthsInWorkCar(carLoanWorkDetailsVm.detail.workExpMonths)) {
                    carLoanWorkDetailsVm.errObj.workExpMonths = validateService.isValidMonthsInWorkCar(carLoanWorkDetailsVm.detail.workExpMonths);
                }

                if (validateService.isValidYearsInWorkCar(carLoanWorkDetailsVm.detail.workExpYears)) {
                    carLoanWorkDetailsVm.errObj.workExpYears = validateService.isValidYearsInWorkCar(carLoanWorkDetailsVm.detail.workExpYears);
                }

                if (validateService.isValidMonthsInWorkCar(carLoanWorkDetailsVm.detail.currentExpMonths)) {
                    carLoanWorkDetailsVm.errObj.currentExpMonths = validateService.isValidMonthsInWorkCar(carLoanWorkDetailsVm.detail.currentExpMonths);
                }

                if (validateService.isValidYearsInWorkCar(carLoanWorkDetailsVm.detail.currentExpYears)) {
                    carLoanWorkDetailsVm.errObj.currentExpYears = validateService.isValidYearsInWorkCar(carLoanWorkDetailsVm.detail.currentExpYears);
                }
            }

            if (carLoanWorkDetailsVm.isOfficeDetails) {
                if (!carLoanWorkDetailsVm.detail.officename) {
                    carLoanWorkDetailsVm.errObj.officename = "Please Enter Office Name";
                }

                if (carLoanWorkDetailsVm.detail.officename) {
                    if(validateService.isValidWorkOfficeName(carLoanWorkDetailsVm.detail.officename)) {
                        carLoanWorkDetailsVm.errObj.officename = 'Please Enter Valid Office Name';
                    }
                }
                
                if (validateService.isValidAdress(carLoanWorkDetailsVm.detail.addressLine1)) {
                    carLoanWorkDetailsVm.errObj.addressLine1 = validateService.isValidAdress(carLoanWorkDetailsVm.detail.addressLine1);
                }

                if(validateService.isValidAddressLine(carLoanWorkDetailsVm.detail.addressLine1)) {
                    carLoanWorkDetailsVm.errObj.addressLine1 = 'Minimum 5 characters required';
                }

                if (validateService.isValidAdressNonMandatory(carLoanWorkDetailsVm.detail.address2)) {
                    carLoanWorkDetailsVm.errObj.address2 = validateService.isValidAdress(carLoanWorkDetailsVm.detail.address2);
                }

                if (validateService.isValidEmailHL(carLoanWorkDetailsVm.detail.email)) {
                    carLoanWorkDetailsVm.errObj.email = validateService.isValidEmailHL(carLoanWorkDetailsVm.detail.email);
                }
                
                if (validateService.isValidPincode(carLoanWorkDetailsVm.detail.pin)) {
                    carLoanWorkDetailsVm.errObj.pin = validateService.isValidPincode(carLoanWorkDetailsVm.detail.pin);
                }

                if (validateService.hlValidState(carLoanWorkDetailsVm.detail.state)) {
                    carLoanWorkDetailsVm.errObj.state = validateService.hlValidState(carLoanWorkDetailsVm.detail.state);
                }
                if (validateService.hlValidDistrict(carLoanWorkDetailsVm.detail.district)) {
                    carLoanWorkDetailsVm.errObj.district = validateService.hlValidDistrict(carLoanWorkDetailsVm.detail.district);
                }
                if (validateService.hlValidCity(carLoanWorkDetailsVm.detail.city)) {
                    carLoanWorkDetailsVm.errObj.city = validateService.hlValidCity(carLoanWorkDetailsVm.detail.city);
                }
            }

            if (carLoanWorkDetailsVm.isTANPANRequired) {
                if (validateService.isValidPANTANNo(carLoanWorkDetailsVm.detail.pan)) {
                    carLoanWorkDetailsVm.errObj.pan = validateService.isValidPANTANNo(carLoanWorkDetailsVm.detail.pan);
                }

            }


            return (angular.equals({}, carLoanWorkDetailsVm.errObj)) ? true : false;
        }


        carLoanWorkDetailsVm.goBack = function () {

            $ionicHistory.goBack(-1);


        }


        carLoanWorkDetailsVm.saveApplication = function () {

            var workExp = (parseInt(carLoanWorkDetailsVm.detail.workExpYears) * 12 + parseInt(carLoanWorkDetailsVm.detail.workExpMonths)).toString();
            var currExp = (parseInt(carLoanWorkDetailsVm.detail.currentExpYears) * 12 + parseInt(carLoanWorkDetailsVm.detail.currentExpMonths)).toString();
            if (workExp == 0) {
                utilityService.showErrorMessage("Work experience should be greater 0");
                return;
            } else if (currExp == 0) {
                utilityService.showErrorMessage("Current experience should be greater 0");
                return;
            }
            if (parseInt(currExp) > parseInt(workExp)) {
                utilityService.showErrorMessage("Time in current job should be less than total work experience");
                return;
            }

            var myDOB = carLoanService.dob;// homeLoanService.userMaster.dob;
            var today = new Date();

            var dob = new Date(myDOB);

            var year1 = myDOB.split('/')[2];// dob.getFullYear();
            var year2 = today.getFullYear();

            var totalYears = year2 - parseInt(year1) - 14;
            var month1 = myDOB.split('/')[1];
            var month2 = today.getMonth();

            var totalMonths = (totalYears * 12) + month2 - parseInt(month1);

            if (totalMonths < parseInt(workExp)) {
                utilityService.showErrorMessage("Maximum experience should be less than your age minus 14 years");
                return;
            }


            var request = carLoanService.saveObj;
            request.page = "workDetails";
            request.applicants[0].employmentType = carLoanWorkDetailsVm.detail.employmentType;
            request.applicants[0].employerType = carLoanWorkDetailsVm.detail.employerType;
            request.applicants[0].professionType = carLoanWorkDetailsVm.detail.professionType;
            request.applicants[0].netMonthlyIncome = carLoanWorkDetailsVm.detail.netMonthlyIncome;
            request.applicants[0].officalEmail = carLoanWorkDetailsVm.detail.email;
            request.applicants[0].incomeHouseProperty = carLoanWorkDetailsVm.detail.incomeFromHouseProp;
            request.applicants[0].workExp = workExp;
            request.applicants[0].monthsInCurrJob = currExp;
            request.applicants[0].officeName = carLoanWorkDetailsVm.detail.officename;
            request.applicants[0].emi = carLoanWorkDetailsVm.detail.emi;
            request.applicants[0].tan = carLoanWorkDetailsVm.detail.pan;
            request.applicants[0].workExpinyears = carLoanWorkDetailsVm.detail.workExpYears;
            request.applicants[0].workExpinmoths = carLoanWorkDetailsVm.detail.workExpMonths;
            request.applicants[0].currJobinyears = carLoanWorkDetailsVm.detail.currentExpYears;
            request.applicants[0].currJobinmonths = carLoanWorkDetailsVm.detail.currentExpMonths;
            request.consent = true;

            var addressArray = [];
            request.applicants[0].address = [];


            var addObj = {
                "addressLine1": carLoanWorkDetailsVm.detail.addressLine1,
                "addressLine2": carLoanWorkDetailsVm.detail.address2,
                "addressLine3": "",
                "districtText": JSON.stringify(carLoanWorkDetailsVm.detail.district),
                "cityText": JSON.stringify(carLoanWorkDetailsVm.detail.city),
                "stateText": JSON.stringify(carLoanWorkDetailsVm.detail.state),
                "pincode": carLoanWorkDetailsVm.detail.pin,
                "addressType": "O",
                "districtCode": carLoanWorkDetailsVm.detail.district.key,
                //   "cityCode": carLoanWorkDetailsVm.detail.currentCityCode,
                "cityCode": carLoanWorkDetailsVm.detail.city.key,
                // "stateCode": carLoanWorkDetailsVm.detail.stateCode
                "stateCode": carLoanWorkDetailsVm.detail.state.key
            };

            addressArray.push(addObj)

            addressArray = addressArray.concat(carLoanService.personalDetailsArray)

            request.applicants[0].address = addressArray;


            carLoanService.crmLeadCreate(request).then(function (data) {
                console.log(request);
                carLoanService.saveObj = request;
                carLoanService.workData = carLoanWorkDetailsVm.detail;
                carLoanService.crmLeadId = data.crmLeadId;
                carLoanService.stateDistrictCityMasterDataWork = {
                    states: carLoanWorkDetailsVm.states,
                    districts: carLoanWorkDetailsVm.districts,
                    cities: carLoanWorkDetailsVm.cities
                };
                $state.go("menu.cardetails");
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


            // var request = {
            //         "loanType": "car",
            //         "custFlag": "",
            //         "page": "personalDetails",

            //         "yonoRef": "",
            //         "losRef": "",
            //         "loanStatus": "",
            //         "loanStage": "",
            //         "loanAmount": "",
            //         "loanTenure": "",
            //         "applicantType": "",
            //         "applicantState": "",
            //         "applicantStatus": "",
            //         "firstName": carLoanWorkDetailsVm.masterData.firstName,
            //         "middleName": "",
            //         "stateOfPurchase": "",
            //         "stateOfPurchaseValue": "",
            //         "cityOfPurchase": "",
            //         "cityOfPurchaseValue": "",
            //         "lastName": carLoanWorkDetailsVm.masterData.lastName,
            //         "dob": "",
            //         "pan": "",
            //         "aadhaar": "",
            //         "residenceType": carLoanWorkDetailsVm.detail.residenceType,
            //         "maritalStatus": carLoanWorkDetailsVm.detail.maritalStatus,
            //         "gender": "",
            //         "employmentType": "",
            //         "netMonthlyIncome": "",
            //         "emis": [{
            //             "type": "",
            //             "typeValue": "",
            //             "amount": ""
            //         }],
            //         "totalExistingEMI": "",
            //         "retirementAge": "",
            //         "workExp": "",
            //         "monthsInCurrJob": "",
            //         "make": "",
            //         "makeValue": "",
            //         "model": "",
            //         "modelValue": "",
            //         "variant": "",
            //         "variantValue": "",
            //         "exshowRoomPrice": "",
            //         "proforma": "",
            //         "warantty": "",
            //         "rto": "",
            //         "insurance": "",
            //         "accessories": "",
            //         "others": "",
            //         "dealerName": "",
            //         "onRoadPrice": "",
            //         "minVehiclecost": "",
            //         "maxVehiclecost": "",
            //         "minIncomeCost": "",
            //         "maxIncomeCost": "",
            //         "minloanAmt": "",
            //         "maxloanAmt": "",
            //         "minTenure": "",
            //         "maxTenure": "",
            //         "roi": "string",
            //         "applicants": [{
            //             "loanType": "",
            //             "custFlag": "",
            //             "cifNo": "",
            //             "yonoRef": "",
            //             "loanAmount": "",
            //             "loanTenure": "",
            //             "applicantType": "",
            //             "firstName": carLoanWorkDetailsVm.masterData.firstName,
            //             "middleName": "",
            //             "lastName": carLoanWorkDetailsVm.masterData.lastName,
            //             "dob": "",
            //             "pan": "",
            //             "aadhaar": "",
            //             "residenceType": carLoanWorkDetailsVm.detail.residenceType,
            //             "residenceTypeValue": "",
            //             "maritalStatus": carLoanWorkDetailsVm.detail.maritalStatus,
            //             "maritalStatusValue": "",
            //             "gender": "",
            //             "genderValue": "",
            //             "employmentType": "",
            //             "employmentTypeValue": "",
            //             "address": [{
            //                 "addressType": addressType,
            //                 "addressLine1": "",
            //                 "addressLine2": "",
            //                 "addressLine3": "",
            //                 "districtCode": "",
            //                 "cityCode": "",
            //                 "stateCode": "",
            //                 "districtText": "",
            //                 "cityText": "",
            //                 "stateText": "",
            //                 "pincode": ""
            //             }],
            //             "netMonthlyIncome": "",
            //             "emis": [{
            //                 "type": "",
            //                 "typeValue": "",
            //                 "amount": ""
            //             }],
            //             "totalExistingEMI": "",
            //             "retirementAge": "",
            //             "workExp": "",
            //             "monthsInCurrJob": "",
            //             "incomeHouseProperty": "",
            //             "monthsInCurrResidence": carLoanWorkDetailsVm.detail.residenceMonth,
            //             "primaryApplicantRef": "",
            //             "applicantState": "",
            //             "loanApprovalStatus": "",
            //             "title": "",
            //             "titleValue": "",
            //             "email": carLoanWorkDetailsVm.detail.email,
            //             "age": "",
            //             "mobile": "",
            //             "accountNo": "",
            //             "motherMaidenName": "",
            //             "tan": "",
            //             "qualification": "",
            //             "category": "",
            //             "categoryValue": "",
            //             "employerType": "",
            //             "employerTypeValue": "",
            //             "professionTypeValue": "",
            //             "professionType": "",
            //             "officeName": "",
            //             "officalEmail": ""
            //         }],
            //         "channel": {
            //             "mobile": {
            //                 "pageNos": [
            //                     ""
            //                 ]
            //             },
            //             "portal": {
            //                 "pageNos": [
            //                     ""
            //                 ]
            //             }
            //         }





        }

        carLoanWorkDetailsVm.goToNextPage = function () {
            if (carLoanWorkDetailsVm.validateForm()) {
                carLoanWorkDetailsVm.detail.emi = [];
                if (carLoanWorkDetailsVm.detail.totalEMIs.length > 0) {
                    for (var i = 0; i < carLoanWorkDetailsVm.detail.totalEMIs.length; i++) {

                        var obj = {};
                        obj.type = carLoanWorkDetailsVm.detail.totalEMIs[i].type;

                        obj.amount = carLoanWorkDetailsVm.detail.totalEMIs[i].amount ? carLoanWorkDetailsVm.detail.totalEMIs[i].amount : 0;
                        var index = i + 1;
                        if (!obj.type) {
                            utilityService.showErrorMessage("Please select Loan type of " + index + " in Existing EMI");
                            return;
                        } else if (parseInt(obj.amount) < 0) {
                            utilityService.showErrorMessage("Please enter EMI of " + index + " in Existing EMI");
                            return;
                        }
                        carLoanWorkDetailsVm.detail.emi.push(obj);
                    }
                }

                if (carLoanWorkDetailsVm.validateEmiRatio()) {
                    carLoanWorkDetailsVm.saveApplication();
                } else {
                    utilityService.showErrorMessage($translate.instant('CL_EMI_NMI_VALIDATION_ERR_MSG'));

                }


            }
        }


        carLoanWorkDetailsVm.validateEmiRatio = function () {
            carLoanWorkDetailsVm.emiNmiMasterData = carLoanService.emiNmiMasterData;
            carLoanWorkDetailsVm.annualIncome = carLoanWorkDetailsVm.detail.netMonthlyIncome * 12;
            var EmiNmiRatio = (carLoanWorkDetailsVm.totalEMICost / carLoanWorkDetailsVm.detail.netMonthlyIncome) * 100;
            if (carLoanWorkDetailsVm.annualIncome >= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[0].minAnnualIncome) && carLoanWorkDetailsVm.annualIncome <= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[0].maxAnnualIncome)) {
                return EmiNmiRatio < JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[0].maxEmiNmiRatio) ? true : false;
            }
            else if (carLoanWorkDetailsVm.annualIncome >= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[1].minAnnualIncome) && carLoanWorkDetailsVm.annualIncome <= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[1].maxAnnualIncome)) {
                return EmiNmiRatio < JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[1].maxEmiNmiRatio) ? true : false;
            }
            else if (carLoanWorkDetailsVm.annualIncome >= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[2].minAnnualIncome) && carLoanWorkDetailsVm.annualIncome <= JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[2].maxAnnualIncome)) {
                return EmiNmiRatio < JSON.parse(carLoanWorkDetailsVm.emiNmiMasterData[2].maxEmiNmiRatio) ? true : false;
            }
        }

        carLoanWorkDetailsVm.goBack = function () {
            $ionicHistory.goBack(-1);
        }

        carLoanWorkDetailsVm.addEMI = function () {
            carLoanWorkDetailsVm.emiObj = {
                "type": "",
                "amount": "0"
            };
            if (carLoanWorkDetailsVm.detail.totalEMIs.length < 6) {
                carLoanWorkDetailsVm.detail.totalEMIs.push(carLoanWorkDetailsVm.emiObj);
            }



        }

        carLoanWorkDetailsVm.calculateEMIs = function () {
            carLoanWorkDetailsVm.totalEMICost = 0;
            for (var i = 0; i < carLoanWorkDetailsVm.detail.totalEMIs.length; i++) {
                carLoanWorkDetailsVm.totalEMICost = carLoanWorkDetailsVm.totalEMICost + parseInt(carLoanWorkDetailsVm.detail.totalEMIs[i].amount);
            }

        }

        carLoanWorkDetailsVm.deleteEMI = function (emiIndex) {
            carLoanWorkDetailsVm.detail.totalEMIs.splice(emiIndex, 1);
            carLoanWorkDetailsVm.calculateEMIs();
        }

        carLoanWorkDetailsVm.checkTerms = function() {
            if(carLoanWorkDetailsVm.checkTnc) {
                carLoanWorkDetailsVm.homeLoanTNC();
            } else {
                carLoanWorkDetailsVm.tnc = false;
            }
        }

        carLoanWorkDetailsVm.homeLoanTNC = function () {
            var request = {
                "type": "getCarLoanTnC"
            };

            // homeLoanService.getTermsAndCondition(request).then(function(data) {
            //     var title = "Declaration";
            //     var buttontext = "OK";
            //     var blankdata = null;
            //     var detail = $filter('ngBindHtmlFilter')(data);
            //     utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
            // }, function(error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });


            homeLoanService.getTermsAndCondition(request).then(function (data) {
                var titlePopup = "Terms & Conditions";


                var buttontext = "OK";
                var blankdata = null;
                var detail = $filter('ngBindHtmlFilter')(data);
                var tncStatus = $ionicPopup.show({
                    title: titlePopup,
                    cssClass: 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
                    template: data,
                    scope: $scope,
                    buttons: [

                        {
                            text: '<b>OK</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                carLoanWorkDetailsVm.tnc = true;
                                carLoanWorkDetailsVm.checkTnc = true;
                                tncStatus.close();
                            }
                        }
                    ]
                });
                //utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carLoanWorkDetailsVm.hideAllFields = function () {
            carLoanWorkDetailsVm.isNetMonthlyIncome = false;
            carLoanWorkDetailsVm.isNetAnnualIncome = false;
            carLoanWorkDetailsVm.isIncomeFromHouseProp = false;
            carLoanWorkDetailsVm.isEmployerType = false;
            //carLoanWorkDetailsVm.isRetirementAge = false;
            carLoanWorkDetailsVm.isProfessionType = false;
            //carLoanWorkDetailsVm.isProfession = false;
            carLoanWorkDetailsVm.isWorkExp = false;
            carLoanWorkDetailsVm.isOfficeDetails = false;
            carLoanWorkDetailsVm.isTANPANRequired = false;
            $ionicScrollDelegate.resize();

        }

        function clearFields() {
            carLoanWorkDetailsVm.detail.pan = "";
            carLoanWorkDetailsVm.detail.employerType = "";
            carLoanWorkDetailsVm.detail.professionType = "";
            carLoanWorkDetailsVm.detail.netMonthlyIncome = "";
            carLoanWorkDetailsVm.detail.incomeFromHouseProp = "";
            carLoanWorkDetailsVm.detail.workExpYears = "";
            carLoanWorkDetailsVm.detail.workExpMonths = "";
            carLoanWorkDetailsVm.detail.currentExpYears = "";
            carLoanWorkDetailsVm.detail.currentExpMonths = "";
            carLoanWorkDetailsVm.detail.officename = "";
            carLoanWorkDetailsVm.detail.addressLine1 = "";
            carLoanWorkDetailsVm.detail.address2 = "";
            carLoanWorkDetailsVm.detail.email = "";
        }

        carLoanWorkDetailsVm.showFields = function (isInit, backData) {
            carLoanWorkDetailsVm.errObj = {};
            carLoanWorkDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(carLoanWorkDetailsVm.detail.employmentType);


            if (!isInit) {
                carLoanWorkDetailsVm.hideAllFields();
            }


            if (carLoanWorkDetailsVm.detail.employmentType) {
                if (carLoanWorkDetailsVm.detail.employmentType == "1") {
                    carLoanWorkDetailsVm.isNetMonthlyIncome = true;
                    carLoanWorkDetailsVm.isIncomeFromHouseProp = true;
                    carLoanWorkDetailsVm.isEmployerType = true;
                    carLoanWorkDetailsVm.isWorkExp = true;
                    carLoanWorkDetailsVm.isOfficeDetails = true;
                    carLoanWorkDetailsVm.detail.pan = "";
                    if (carLoanWorkDetailsVm.isCSP) {
                        carLoanWorkDetailsVm.isCSPFlag = true;
                    }
                    if (!carLoanService.workData && !backData) {
                        clearFields();
                    }
                } else {
                    carLoanWorkDetailsVm.isNetAnnualIncome = true;
                    carLoanWorkDetailsVm.isIncomeFromHouseProp = true;
                    carLoanWorkDetailsVm.isProfessionType = true;
                    carLoanWorkDetailsVm.isWorkExp = true;
                    carLoanWorkDetailsVm.isOfficeDetails = true;
                    carLoanWorkDetailsVm.isTANPANRequired = true;
                    carLoanWorkDetailsVm.isCSPFlag = false;
                    if (!carLoanService.workData && !backData) {
                        clearFields();
                    }
                }
            }

            $ionicScrollDelegate.resize();


        }

        carLoanWorkDetailsVm.fetchStateDistrictCityByPinCode = function (pincode, addressType) {
            if (addressType === 'office') {
                if (validateService.isValidDestPinCode(pincode)) {
                    if (pincode.toString().length == 6) {
                        var requestParam = {
                            "pincode": pincode,
                            "addressType": "O"
                        };

                        carLoanService.getMasterDataByPinCode(requestParam).then(function (data) {
                            if (data) {
                                if (data.cities && data.cities.length > 0) {
                                    carLoanWorkDetailsVm.cities = data.cities;
                                }
                                if (data.districts && data.districts.length) {
                                    carLoanWorkDetailsVm.districts = data.districts;
                                }
                                if (data.state) {
                                    carLoanWorkDetailsVm.states = [data.state];
                                    carLoanWorkDetailsVm.detail.state = data.state;
                                }
                            } else {
                                utilityService.showErrorMessage('Please enter valid pincode');
                            }

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }


                }

            }
        }

        carLoanWorkDetailsVm.clearStateDistrictCity = function (addressType) {
            if (addressType === 'office') {
                carLoanWorkDetailsVm.states = [];
                carLoanWorkDetailsVm.districts = [];
                carLoanWorkDetailsVm.cities = [];
            }
        }


        $scope.$on('$ionicView.loaded', function () {

        });

        $scope.$on('$ionicView.beforeEnter', function () {

            if (utilityService.isIOSPlatform()) {
                carLoanWorkDetailsVm.scroll = false;
            }

            else {
                carLoanWorkDetailsVm.scroll = true;
            }


            initPage();

        });



        return this;
    }


]);