'use strict';
angularApp.controller('carPersonalDetailsRAASController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "loanConfig",
    "homeLoanService", "validateService", "carLoanService", "$filter", "AdapterUtils",
    function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, loanConfig, homeLoanService, validateService, carLoanService, $filter, AdapterUtils) {

        var carPersonalDetailsVm = this;
        carPersonalDetailsVm.detail = {};

        function initPage() {
            
            carPersonalDetailsVm.detail.currentAddressCheck = true;
            
            if (carLoanService.personalData) {

                carPersonalDetailsVm.detail = carLoanService.personalData;

                if (carLoanService.resumeData) {
                    carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                    carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                    carPersonalDetailsVm.genderMaster = carLoanService.resumeData.master.genders;
                    carPersonalDetailsVm.addressMaster = carLoanService.resumeData.master.residenceTypes;
                    carPersonalDetailsVm.martialStatus = carLoanService.resumeData.master.maritalStatuses;
                    carPersonalDetailsVm.states = carLoanService.resumeData.master.states;
                } else {
                    carPersonalDetailsVm.masterData = carLoanService.userMaster;
                    carPersonalDetailsVm.genderMaster = carPersonalDetailsVm.masterData.master.genders;
                    carPersonalDetailsVm.addressMaster = carPersonalDetailsVm.masterData.master.residenceTypes;
                    carPersonalDetailsVm.martialStatus = carPersonalDetailsVm.masterData.master.maritalStatuses;
                    carPersonalDetailsVm.states = carPersonalDetailsVm.masterData.master.states;
                }

                carPersonalDetailsVm.states = carLoanService.stateDistrictCityMasterData.states;
                carPersonalDetailsVm.districts = carLoanService.stateDistrictCityMasterData.districts;
                carPersonalDetailsVm.cities = carLoanService.stateDistrictCityMasterData.cities;
                carPersonalDetailsVm.currentStates = carLoanService.stateDistrictCityMasterData.currentStates;
                carPersonalDetailsVm.currentDistricts = carLoanService.stateDistrictCityMasterData.currentDistricts;
                carPersonalDetailsVm.currentCities = carLoanService.stateDistrictCityMasterData.currentCities;
                carPersonalDetailsVm.isFirstInit = false;

            } else if (carLoanService.resumeData) {
                carPersonalDetailsVm.isFirstInit = true;
                carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                carPersonalDetailsVm.genderMaster = carLoanService.resumeData.master.genders;
                carPersonalDetailsVm.addressMaster = carLoanService.resumeData.master.residenceTypes;
                carPersonalDetailsVm.martialStatus = carLoanService.resumeData.master.maritalStatuses;
                carPersonalDetailsVm.states = [];
                carPersonalDetailsVm.districts = [];
                carPersonalDetailsVm.cities = [];
                carPersonalDetailsVm.currentStates = [];
                carPersonalDetailsVm.currentDistricts = [];
                carPersonalDetailsVm.currentCities = [];
                carLoanService.userMaster = carLoanService.resumeData;

                carPersonalDetailsVm.detail.maritalStatus = carPersonalDetailsVm.masterData.maritalStatus
                carPersonalDetailsVm.detail.residenceType = carPersonalDetailsVm.masterData.residenceType;
                carPersonalDetailsVm.detail.residenceMonth = carPersonalDetailsVm.masterData.monthsInCurrResidence;
                carPersonalDetailsVm.detail.userInputLoanAmount = carLoanService.resumeData.userInputLoanAmount;

                for (var i = 0; i < carPersonalDetailsVm.masterData.address.length; i++) {
                    if (carPersonalDetailsVm.masterData.address[i].addressType == 'P') {
                        if (carPersonalDetailsVm.masterData.address[i].addressLine2 == null) {
                            carPersonalDetailsVm.masterData.address[i].addressLine2 = '';
                        }
                        if (carPersonalDetailsVm.masterData.address[i].addressLine3 == null) {
                            carPersonalDetailsVm.masterData.address[i].addressLine3 = '';
                        }
                        carPersonalDetailsVm.detail.address = carPersonalDetailsVm.masterData.address[i].addressLine1 + ' ' + carPersonalDetailsVm.masterData.address[i].addressLine2 + ' ' + carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.masterData.permanentAddress = {};
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine1 = carPersonalDetailsVm.masterData.address[i].addressLine1;
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine2 = carPersonalDetailsVm.masterData.address[i].addressLine2;
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine3 = carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.masterData.permanentAddress.pincode = carPersonalDetailsVm.masterData.address[i].pincode;

                        if (carPersonalDetailsVm.masterData.address[i].pincode) {
                            carPersonalDetailsVm.detail.address = carPersonalDetailsVm.detail.address + ',' + carPersonalDetailsVm.masterData.address[i].pincode;
                            carPersonalDetailsVm.fetchStateDistrictCityByPinCode(carPersonalDetailsVm.masterData.address[i].pincode, 'permanent');
                        }

                        var cityObj = JSON.parse(carPersonalDetailsVm.masterData.address[i].cityText);
                        carPersonalDetailsVm.detail.city = cityObj;

                        var districtObj = JSON.parse(carPersonalDetailsVm.masterData.address[i].districtText);
                        carPersonalDetailsVm.detail.district = districtObj;

                        carPersonalDetailsVm.detail.state = JSON.parse(carPersonalDetailsVm.masterData.address[i].stateText);

                    } else if (carPersonalDetailsVm.masterData.address[i].addressType == 'C') {

                        carPersonalDetailsVm.detail.addressLine1 = carPersonalDetailsVm.masterData.address[i].addressLine1;
                        carPersonalDetailsVm.detail.addressLine2 = carPersonalDetailsVm.masterData.address[i].addressLine2;
                        carPersonalDetailsVm.detail.addressLine3 = carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.detail.currentPincode = carPersonalDetailsVm.masterData.address[i].pincode;
                        if(carPersonalDetailsVm.detail.currentPincode) {
                            carPersonalDetailsVm.fetchStateDistrictCityByPinCode(carPersonalDetailsVm.masterData.address[i].pincode, 'current');
                        }
                        
                        var cityObj = JSON.parse(carPersonalDetailsVm.masterData.address[i].cityText);
                        carPersonalDetailsVm.detail.currentCity = cityObj;

                        var districtObj = JSON.parse(carPersonalDetailsVm.masterData.address[i].districtText);
                        carPersonalDetailsVm.detail.currentDistrict = districtObj;

                        carPersonalDetailsVm.detail.currentState = JSON.parse(carPersonalDetailsVm.masterData.address[i].stateText);
                        carPersonalDetailsVm.detail.currentAddressCheck = false;
                    }
                }
            } else {
                carPersonalDetailsVm.isFirstInit = true;
                carPersonalDetailsVm.masterData = carLoanService.userMaster;
                carPersonalDetailsVm.genderMaster = carPersonalDetailsVm.masterData.master.genders;
                carPersonalDetailsVm.addressMaster = carPersonalDetailsVm.masterData.master.residenceTypes;
                carPersonalDetailsVm.martialStatus = carPersonalDetailsVm.masterData.master.maritalStatuses;
                carPersonalDetailsVm.states = [];
                carPersonalDetailsVm.districts = [];
                carPersonalDetailsVm.cities = [];
                carPersonalDetailsVm.currentStates = [];
                carPersonalDetailsVm.currentDistricts = [];
                carPersonalDetailsVm.currentCities = [];

                carPersonalDetailsVm.detail.address = carPersonalDetailsVm.masterData.permanentAddress.addressLine1 + ' ' + carPersonalDetailsVm.masterData.permanentAddress.addressLine2 + ' ' + carPersonalDetailsVm.masterData.permanentAddress.addressLine3;

                if (carPersonalDetailsVm.masterData.permanentAddress.pincode) {
                    carPersonalDetailsVm.detail.address = carPersonalDetailsVm.detail.address + ',' + carPersonalDetailsVm.masterData.permanentAddress.pincode;
                    carPersonalDetailsVm.fetchStateDistrictCityByPinCode(carPersonalDetailsVm.masterData.permanentAddress.pincode, 'permanent');
                }

            }
            
            carPersonalDetailsVm.isMaskPan = true;
            carPersonalDetailsVm.isMaskAd = true;
            carPersonalDetailsVm.isMaskEmail = true;
            carPersonalDetailsVm.isMaskMobile = true;
            carPersonalDetailsVm.isMaskDob = true;
            carPersonalDetailsVm.detail.title = homeLoanService.findObject(carPersonalDetailsVm.masterData.title, carLoanService.userMaster.master.titles);
            carPersonalDetailsVm.detail.custName = carPersonalDetailsVm.detail.title.value + ' ' + carPersonalDetailsVm.masterData.firstName + ' ' + carPersonalDetailsVm.masterData.lastName;
            carPersonalDetailsVm.detail.custNameFull = carPersonalDetailsVm.masterData.firstName + ' ' + carPersonalDetailsVm.masterData.lastName;
            carPersonalDetailsVm.detail.firstName = carPersonalDetailsVm.masterData.firstName;
            carPersonalDetailsVm.detail.lastName = carPersonalDetailsVm.masterData.lastName;
            if (carLoanService.resumeData) {
                carPersonalDetailsVm.detail.minamount = JSON.parse(carLoanService.resumeData.minamount);
                carPersonalDetailsVm.detail.maxamount = JSON.parse(carLoanService.resumeData.maxamount);
                carPersonalDetailsVm.userInputLoanAmountErrTxt = $translate.instant('PLS_ENTER_TXT') + ' ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.minamount) + ' - ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.maxamount);
                carPersonalDetailsVm.LoanAmountValidationTxtUI = $translate.instant('CL_AMOUNT_VALIDATION_TXT') + ' ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.minamount) + ' - ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.maxamount);

            } else {
                carPersonalDetailsVm.detail.minamount = JSON.parse(carPersonalDetailsVm.masterData.minamount);
                carPersonalDetailsVm.detail.maxamount = JSON.parse(carPersonalDetailsVm.masterData.maxamount);
                carPersonalDetailsVm.userInputLoanAmountErrTxt = $translate.instant('PLS_ENTER_TXT') + ' ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.minamount) + ' - ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.maxamount);
                carPersonalDetailsVm.LoanAmountValidationTxtUI = $translate.instant('CL_AMOUNT_VALIDATION_TXT') + ' ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.minamount) + ' - ' + carPersonalDetailsVm.numDifferentiation(carPersonalDetailsVm.detail.maxamount);
            }

            carPersonalDetailsVm.detail.dob = $filter('homeDateFormat')(carPersonalDetailsVm.masterData.dob);
            var str = carPersonalDetailsVm.detail.dob.split(' ');
            var year = str[2];
            var Mask = year.replace(year, 'XXXX');
            carPersonalDetailsVm.detail.dobMask = str[0] + ' ' + str[1] + ' ' + Mask;

            carPersonalDetailsVm.detail.pan = carPersonalDetailsVm.masterData.pan;

            carPersonalDetailsVm.detail.aadhaar = carPersonalDetailsVm.masterData.aadhaar;

            carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile;
            if (!carLoanService.personalData) {
                carPersonalDetailsVm.detail.email = carPersonalDetailsVm.masterData.email;
            }
            if (carPersonalDetailsVm.masterData.email) {
                carPersonalDetailsVm.showMaskedEmail = true;
            } else {
                carPersonalDetailsVm.showMaskedEmail = false;
            }

            carPersonalDetailsVm.detail.permanentAddressLine1 = carPersonalDetailsVm.masterData.permanentAddress.addressLine1;
            carPersonalDetailsVm.detail.permanentAddressLine2 = carPersonalDetailsVm.masterData.permanentAddress.addressLine2;
            carPersonalDetailsVm.detail.permanentAddressLine3 = carPersonalDetailsVm.masterData.permanentAddress.addressLine3;
            carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile ? carPersonalDetailsVm.masterData.mobile : "";
            if (carPersonalDetailsVm.isFirstInit) {
                if (carPersonalDetailsVm.masterData.permanentAddress.pincode) {
                    carPersonalDetailsVm.detail.pincode = carPersonalDetailsVm.masterData.permanentAddress.pincode;
                }
            }


            carPersonalDetailsVm.hideAllFields();
            carLoanService.dob = carPersonalDetailsVm.masterData.dob;




        };

        carPersonalDetailsVm.unmaskDob = function () {
            carPersonalDetailsVm.isMaskDob = !carPersonalDetailsVm.isMaskDob;
        }

        
        carPersonalDetailsVm.showCurrentAddress = function () {
            $ionicScrollDelegate.resize();
            carPersonalDetailsVm.detail.addressLine1 = "";
            carPersonalDetailsVm.detail.addressLine2 = "";
            carPersonalDetailsVm.detail.addressLine3 = "";
            carPersonalDetailsVm.detail.currentPincode = "";
            carPersonalDetailsVm.detail.currentCity = "";
            carPersonalDetailsVm.detail.currentState = "";
            carPersonalDetailsVm.detail.residenceType = "";
            carPersonalDetailsVm.detail.residenceMonth = "";
        }


        carPersonalDetailsVm.unmaskData = function (idType) {
            var request = {
                "type": idType,
                "loanType": "car"
            }
            if (idType == 'pan' || idType == 'aadhaar' || idType == 'mobile' || idType == 'email' || idType == 'dob') {
                homeLoanService.getUnmaskData(request).then(function (data) {
                    if (idType == 'pan') {
                        carPersonalDetailsVm.isMaskPan = false;
                        carPersonalDetailsVm.detail.pan = data;
                    } else if (idType == 'aadhaar') {
                        carPersonalDetailsVm.isMaskAd = false;
                        carPersonalDetailsVm.detail.aadhaar = data;
                    } else if (idType == 'mobile') {
                        carPersonalDetailsVm.isMaskMobile = false;
                        carPersonalDetailsVm.detail.mobile = data;
                    } else if (idType == 'email') {
                        carPersonalDetailsVm.isMaskEmail = false;
                        carPersonalDetailsVm.detail.email = data;
                    } else if (idType == 'dob') {
                        carPersonalDetailsVm.isMaskDob = false;
                        carPersonalDetailsVm.detail.dob = data;
                    }

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'npan') {
                    carPersonalDetailsVm.isMaskPan = true;
                    carPersonalDetailsVm.detail.pan = carPersonalDetailsVm.masterData.pan;
                } else if (idType == 'naadhaar') {
                    carPersonalDetailsVm.isMaskAd = true;
                    carPersonalDetailsVm.detail.aadhaar = carPersonalDetailsVm.masterData.aadhaar;
                } else if (idType == 'nmobile') {
                    carPersonalDetailsVm.isMaskMobile = true;
                    carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile;
                } else if (idType == 'nemail') {
                    carPersonalDetailsVm.isMaskEmail = true;
                    carPersonalDetailsVm.detail.email = carPersonalDetailsVm.masterData.email;
                } else if (idType == 'ndob') {
                    carPersonalDetailsVm.isMaskDob = true;
                    carPersonalDetailsVm.detail.dob = carPersonalDetailsVm.masterData.dob;

                }

            }

        }

        

        carPersonalDetailsVm.applyknowmore = function (group) {

        }

        carPersonalDetailsVm.applyloan = function (group) {

        }

        carPersonalDetailsVm.hideAllFields = function () {
            carPersonalDetailsVm.isNetMonthlyIncome = false;
            //carPersonalDetailsVm.isNetAnnualIncome = false;
            carPersonalDetailsVm.isIncomeFromHouseProp = false;
            carPersonalDetailsVm.isEmployerType = false;
            carPersonalDetailsVm.isRetirementAge = false;
            carPersonalDetailsVm.isProfessionType = false;
            carPersonalDetailsVm.isProfession = false;
            carPersonalDetailsVm.isWorkExp = false;
            carPersonalDetailsVm.isMonthsInCurrJob = false;
            carPersonalDetailsVm.isMonthsInCurrJobProfession = false;
        }

        carPersonalDetailsVm.goToAO = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.loaded', function () {

        });

        $scope.$on('$ionicView.beforeEnter', function () {
            if (utilityService.isIOSPlatform()) {
                carPersonalDetailsVm.scroll = false;
            }

            else {
                carPersonalDetailsVm.scroll = true;
            }
            initPage();
        });

        carPersonalDetailsVm.validateForm = function () {
            carPersonalDetailsVm.errObj = {};

            if (carPersonalDetailsVm.detail.currentAddressCheck) {
                if (validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth)) {
                    carPersonalDetailsVm.errObj.residenceMonth = validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth);
                }
                if (validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType)) {
                    carPersonalDetailsVm.errObj.residenceType = validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType);
                }
            }


            if (validateService.isValidEmailHL(carPersonalDetailsVm.detail.email)) {
                carPersonalDetailsVm.errObj.email = validateService.isValidEmailHL(carPersonalDetailsVm.detail.email);
            }

            
            if (validateService.isMarritialStatus(carPersonalDetailsVm.detail.maritalStatus)) {
                carPersonalDetailsVm.errObj.maritalStatus = validateService.isMarritialStatus(carPersonalDetailsVm.detail.maritalStatus);
            }

            if (validateService.hlValidState(carPersonalDetailsVm.detail.state)) {
                carPersonalDetailsVm.errObj.state = validateService.hlValidState(carPersonalDetailsVm.detail.state);
            }
            if (validateService.hlValidDistrict(carPersonalDetailsVm.detail.district)) {
                carPersonalDetailsVm.errObj.district = validateService.hlValidDistrict(carPersonalDetailsVm.detail.district);
            }
            if (validateService.hlValidCity(carPersonalDetailsVm.detail.city)) {
                carPersonalDetailsVm.errObj.city = validateService.hlValidCity(carPersonalDetailsVm.detail.city);
            }

            if (!carPersonalDetailsVm.detail.currentAddressCheck) {
                if (validateService.isValidPincode(carPersonalDetailsVm.detail.currentPincode)) {
                    carPersonalDetailsVm.errObj.currentPincode = validateService.isValidPincode(carPersonalDetailsVm.detail.currentPincode);
                }
                if (validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine1)) {
                    carPersonalDetailsVm.errObj.addressLine1 = validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine1);
                }

                if(validateService.isValidAddressLine(carPersonalDetailsVm.detail.addressLine1)) {
                    carPersonalDetailsVm.errObj.addressLine1 = 'Minimum 5 characters required';
                }

                if (validateService.isValidAdressNonMandatory(carPersonalDetailsVm.detail.addressLine2)) {
                    carPersonalDetailsVm.errObj.addressLine2 = validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine2);
                }

                if (validateService.isValidAdressNonMandatory(carPersonalDetailsVm.detail.addressLine3)) {
                    carPersonalDetailsVm.errObj.addressLine3 = validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine3);
                }

                if (validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType)) {
                    carPersonalDetailsVm.errObj.residenceTypeCurrent = validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType);
                }

                if (validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth)) {
                    carPersonalDetailsVm.errObj.residenceMonthCurrent = validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth);
                }

                if (validateService.hlValidState(carPersonalDetailsVm.detail.currentState)) {
                    carPersonalDetailsVm.errObj.currentState = validateService.hlValidState(carPersonalDetailsVm.detail.currentState);
                }
                if (validateService.hlValidDistrict(carPersonalDetailsVm.detail.currentDistrict)) {
                    carPersonalDetailsVm.errObj.currentDistrict = validateService.hlValidDistrict(carPersonalDetailsVm.detail.currentDistrict);
                }
                if (validateService.hlValidCity(carPersonalDetailsVm.detail.currentCity)) {
                    carPersonalDetailsVm.errObj.currentCity = validateService.hlValidCity(carPersonalDetailsVm.detail.currentCity);
                }
            }

            return (angular.equals({}, carPersonalDetailsVm.errObj)) ? true : false;
        }

        function saveApplication() {
            var addressType = "";
            var addressArray = [];




            var addObjP = {
                "addressType": 'P',
                "addressLine1": carPersonalDetailsVm.masterData.permanentAddress.addressLine1,
                "addressLine2": carPersonalDetailsVm.masterData.permanentAddress.addressLine2,
                "addressLine3": carPersonalDetailsVm.masterData.permanentAddress.addressLine3,
                //"districtCode": carPersonalDetailsVm.detail.districtCode,
                "districtCode": carPersonalDetailsVm.detail.district.key,
                //  "cityCode": carPersonalDetailsVm.detail.districtCode,
                "cityCode": carPersonalDetailsVm.detail.city.key,
                //   "stateCode": carPersonalDetailsVm.detail.stateCode,
                "stateCode": carPersonalDetailsVm.detail.state.key,
                "districtText": JSON.stringify(carPersonalDetailsVm.detail.district),
                "cityText": JSON.stringify(carPersonalDetailsVm.detail.city),
                "stateText": JSON.stringify(carPersonalDetailsVm.detail.state),
                "pincode": carPersonalDetailsVm.masterData.permanentAddress.pincode

            }
            addressArray.push(addObjP);
            if (!carPersonalDetailsVm.detail.currentAddressCheck) {


                var addObj = {
                    "addressType": 'C',
                    "addressLine1": carPersonalDetailsVm.detail.addressLine1,
                    "addressLine2": carPersonalDetailsVm.detail.addressLine2,
                    "addressLine3": carPersonalDetailsVm.detail.addressLine3,
                    // "districtCode": carPersonalDetailsVm.detail.currentCityCode,
                    "districtCode": carPersonalDetailsVm.detail.currentDistrict.key,
                    // "cityCode": carPersonalDetailsVm.detail.currentCityCode,
                    "cityCode": carPersonalDetailsVm.detail.currentCity.key,
                    // "stateCode": carPersonalDetailsVm.detail.currentStateCode,
                    "stateCode": carPersonalDetailsVm.detail.currentState.key,
                    "districtText": JSON.stringify(carPersonalDetailsVm.detail.currentDistrict),
                    "cityText": JSON.stringify(carPersonalDetailsVm.detail.currentCity),
                    "stateText": JSON.stringify(carPersonalDetailsVm.detail.currentState),
                    "pincode": carPersonalDetailsVm.detail.currentPincode
                }

                addressArray.push(addObj);


            }
            carLoanService.personalDetailsArray = addressArray;
            carPersonalDetailsVm.request = {
                "loanType": "car",
                "custFlag": "",
                "page": "personalDetails",
                "yonoRef": "",
                "losRef": "",
                "loanStatus": "",
                "loanStage": "",
                "userInputLoanAmount": "",
                "loanAmount": "",
                "loanTenure": "",
                "applicantType": "",
                "applicantState": "",
                "applicantStatus": "",
                "firstName": carPersonalDetailsVm.masterData.firstName,
                "middleName": "",
                "stateOfPurchase": "",
                "stateOfPurchaseValue": "",
                "cityOfPurchase": "",
                "cityOfPurchaseValue": "",
                "lastName": carPersonalDetailsVm.masterData.lastName,
                "dob": "",
                "pan": "",
                "aadhaar": "",
                "residenceType": carPersonalDetailsVm.detail.residenceType,
                "maritalStatus": carPersonalDetailsVm.detail.maritalStatus,
                "gender": "",
                "employmentType": "",
                "netMonthlyIncome": "",
                "emis": [{
                    "type": "",
                    "typeValue": "",
                    "amount": ""
                }],
                "totalExistingEMI": "",
                "retirementAge": "",
                "workExp": "",
                "monthsInCurrJob": "",
                "make": "",
                "makeValue": "",
                "model": "",
                "modelValue": "",
                "variant": "",
                "variantValue": "",
                "exshowRoomPrice": "",
                "proforma": "",
                "warantty": "",
                "rto": "",
                "insurance": "",
                "accessories": "",
                "roadTax": "",
                "others": "",
                "dealerName": "",
                "onRoadPrice": "",
                "minVehiclecost": "",
                "maxVehiclecost": "",
                "minIncomeCost": "",
                "maxIncomeCost": "",
                "minloanAmt": "",
                "maxloanAmt": "",
                "minTenure": "",
                "maxTenure": "",
                "roi": "string",
                "applicants": [{
                    "loanType": "",
                    "custFlag": "",
                    "cifNo": "",
                    "yonoRef": "",
                    "loanAmount": "",
                    "loanTenure": "",
                    "applicantType": "",
                    "firstName": carPersonalDetailsVm.masterData.firstName,
                    "middleName": "",
                    "lastName": carPersonalDetailsVm.masterData.lastName,
                    "dob": "",
                    "pan": "",
                    "aadhaar": "",
                    "residenceType": carPersonalDetailsVm.detail.residenceType,
                    "residenceTypeValue": "",
                    "maritalStatus": carPersonalDetailsVm.detail.maritalStatus,

                    "workExpinyears": "",
                    "currJobinyears": "",
                    "workExpinmoths": "",
                    "currJobinmonths": "",
                    "maritalStatusValue": "",
                    "gender": "",
                    "genderValue": "",
                    "employmentType": "",
                    "employmentTypeValue": "",
                    "address": addressArray,
                    "netMonthlyIncome": "",
                    "emi": [{
                        "type": "",
                        "typeValue": "",
                        "amount": ""
                    }],
                    "totalExistingEMI": "",
                    "retirementAge": "",
                    "workExp": "",
                    "monthsInCurrJob": "",
                    "incomeHouseProperty": "",
                    "monthsInCurrResidence": carPersonalDetailsVm.detail.residenceMonth,
                    "primaryApplicantRef": "",
                    "applicantState": "",
                    "loanApprovalStatus": "",
                    "title": carPersonalDetailsVm.masterData.title,
                    "titleValue": carPersonalDetailsVm.detail.title.value,
                    "email": carPersonalDetailsVm.detail.email,
                    "age": "",
                    "mobile": "",
                    "accountNo": "",
                    "motherMaidenName": "",
                    "tan": "",
                    "qualification": "",
                    "category": "",
                    "categoryValue": "",
                    "employerType": "",
                    "employerTypeValue": "",
                    "professionTypeValue": "",
                    "professionType": "",
                    "officeName": "",
                    "officalEmail": ""
                }],
                "channel": {
                    "mobile": {
                        "pageNos": [
                            ""
                        ]
                    },
                    "portal": {
                        "pageNos": [
                            ""
                        ]
                    }
                }
            }


            carPersonalDetailsVm.popup = $ionicPopup.show({
                templateUrl: 'pages/loans/carLoan/carLoanRAAS/carLoanAmountPopupRAAS.html',
                cssClass: 'cl-dialog-loanInput',
                scope: $scope,
                buttons: [],
            });
           
        }


        carPersonalDetailsVm.okBtnClicked = function () {
            carPersonalDetailsVm.request.userInputLoanAmount = carPersonalDetailsVm.detail.userInputLoanAmount;
            carPersonalDetailsVm.popup.close();
            carLoanService.triggerCIC(carPersonalDetailsVm.request).then(function (data) {
                carLoanService.saveObj = carPersonalDetailsVm.request;
                carLoanService.personalData = carPersonalDetailsVm.detail;
                carLoanService.emiNmiMasterData = data.emiNmiMasterData;
                carLoanService.stateDistrictCityMasterData = {
                    states: carPersonalDetailsVm.states,
                    districts: carPersonalDetailsVm.districts,
                    cities: carPersonalDetailsVm.cities,
                    currentStates: carPersonalDetailsVm.currentStates,
                    currentDistricts: carPersonalDetailsVm.currentDistricts,
                    currentCities: carPersonalDetailsVm.currentCities
                };
                $state.go('menu.carLoanWorkDetails');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carPersonalDetailsVm.validateLoanAmount = function () {
            carPersonalDetailsVm.errObj.userInputLoanAmountErr = false;
            if (carPersonalDetailsVm.detail.userInputLoanAmount < carPersonalDetailsVm.detail.minamount || carPersonalDetailsVm.detail.userInputLoanAmount > carPersonalDetailsVm.detail.maxamount) {
                carPersonalDetailsVm.errObj.userInputLoanAmountErr = carPersonalDetailsVm.userInputLoanAmountErrTxt;
            } else {
                carPersonalDetailsVm.errObj.userInputLoanAmountErr = null;
            }
        }

        carPersonalDetailsVm.numDifferentiation = function (value) {
            var val = Math.abs(value)
            if (val >= 10000000) {
                val = (val / 10000000) + ' ' + $translate.instant('CRORE');
            } else if (val >= 100000) {
                val = (val / 100000) + ' ' + $translate.instant('LAKH');
            }
            return val;
        }

        carPersonalDetailsVm.fetchStateDistrictCityByPinCode = function (pincode, addressType) {
            if (addressType === 'permanent') {
                if (validateService.isValidDestPinCode(pincode)) {
                    if (pincode.toString().length == 6) {
                        var requestParam = {
                            "pincode": pincode,
                            "addressType": "P"
                        };

                        carLoanService.getMasterDataByPinCode(requestParam).then(function (data) {
                            if (data) {
                                if (data.cities && data.cities.length > 0) {
                                    carPersonalDetailsVm.cities = data.cities;
                                }
                                if (data.districts && data.districts.length > 0) {
                                    carPersonalDetailsVm.districts = data.districts;
                                }
                                if (data.state) {
                                    carPersonalDetailsVm.states = [data.state];
                                    carPersonalDetailsVm.detail.state = data.state;
                                }
                            } else {
                                utilityService.showErrorMessage('Please correct your CBS postal pin code. it seems incorrect.');
                            }

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }


                }

            } else if (addressType === 'current') {
                if (validateService.isValidDestPinCode(pincode)) {
                    if (pincode.toString().length == 6) {
                        var requestParam = {
                            "pincode": pincode,
                            "addressType": "C"
                        };
                        carLoanService.getMasterDataByPinCode(requestParam).then(function (data) {
                            if (data) {
                                if (data.cities && data.cities.length > 0) {
                                    carPersonalDetailsVm.currentCities = data.cities;
                                }
                                if (data.districts && data.districts.length) {
                                    carPersonalDetailsVm.currentDistricts = data.districts;
                                }
                                if (data.state) {
                                    carPersonalDetailsVm.currentStates = [data.state];
                                    carPersonalDetailsVm.detail.currentState = data.state;
                                }
                            } else {
                                utilityService.showErrorMessage('Please enter valid pincode');
                            }

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }
                }
            }
        }

        carPersonalDetailsVm.clearStateDistrictCity = function (addressType) {
            if (addressType === 'permanent') {
                carPersonalDetailsVm.states = [];
                carPersonalDetailsVm.districts = [];
                carPersonalDetailsVm.cities = [];

            } else if (addressType === 'current') {
                carPersonalDetailsVm.currentStates = [];
                carPersonalDetailsVm.currentDistricts = [];
                carPersonalDetailsVm.currentCities = [];
            }
        }


        carPersonalDetailsVm.goToNextPage = function () {
            if (carPersonalDetailsVm.validateForm()) {
                saveApplication();

            }
        }

        carPersonalDetailsVm.goBack = function () {
            $ionicHistory.goBack(-1);
        }



        return this;
    }


]);