angularApp.service('carLoanService',
    function ($q, AdapterUtils, utilityService, constantConfig) {

        var carLoanService = this;
        this.loanDetails = "";
        carLoanService.resumeData = "";

        carLoanService.getCarLoanDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/getCarLoanDetails", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.getDistrictCity = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/getDistrictSubDistrict", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }


        carLoanService.getDealerList = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/getDealerList", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }

        carLoanService.getEligiblityCheck = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/executeBusinessEligibility", payload, true).then(
                function (response) {
                    carLoanService.clearAll();
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.pushRAASData = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/pushRAASData", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        carLoanService.clearAll = function () {
            carLoanService.resumeData = "";
            carLoanService.saveObj = "";
            carLoanService.personalData = "";
            carLoanService.workData = "";
            carLoanService.carData = "";
            carLoanService.amountSlider = "";
            carLoanService.tenureSlider = "";
        }


        carLoanService.getYonoDedupe = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/getYonoDedupe", payload, false).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.updateLoanApp = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/updateLoanApp", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        carLoanService.finalEligibility = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/finalEligibiltyCheck", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.getSubData = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/fetchDependentMaster", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.delete = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/deleteExistingYonoApplication", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.validateCSP = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/validateCSP", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.resumeApplication = function (payload) {

            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/resumeApplication", payload, true).then(
                function (response) {
                    carLoanService.clearAll();
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.getDocument = function (payload) {

            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/getDocument", payload, true).then(
                function (response) {

                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.triggerCIC = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/triggerCIC", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        carLoanService.crmLeadCreate = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/crmLeadCreate", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.fetchROIMaster = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/fetchROIMaster", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        carLoanService.calculateMinMaxIntrestRateForCustomer = function (roiResponse, noCivilHistory) {
            var cicScrore = roiResponse.cicScore;
            var minMaxIntestMatrix = {
                interestRateMax: roiResponse.roiMasterData[0].interestRate,
                interestRateMin: roiResponse.roiMasterData[0].interestRate
            }
            if (noCivilHistory) {
                for (var i = 0, len = roiResponse.roiMasterData.length; i < len; i++) {
                    var roiObj = roiResponse.roiMasterData[i];
                    if (JSON.parse(roiObj['interestRate']) > minMaxIntestMatrix.interestRateMax) {
                        minMaxIntestMatrix.interestRateMax = JSON.parse(roiObj['interestRate']);
                    }
                    if (JSON.parse(roiObj['interestRate']) < minMaxIntestMatrix.interestRateMin) {
                        minMaxIntestMatrix.interestRateMin = JSON.parse(roiObj['interestRate']);
                    }
                }
            } else {
                for (var i = 0, len = roiResponse.roiMasterData.length; i < len; i++) {
                    var roiObj = roiResponse.roiMasterData[i];
                    if (cicScrore >= JSON.parse(roiObj['minCIC']) && cicScrore <= JSON.parse(roiObj['maxCIC'])) {
                        if (JSON.parse(roiObj['minLoanTenure'] > 5)) {
                            minMaxIntestMatrix.interestRateMax = JSON.parse(roiObj['interestRate']);
                        } else {
                            minMaxIntestMatrix.interestRateMin = JSON.parse(roiObj['interestRate']);
                        }
                    }
                }
            }

            return minMaxIntestMatrix;
        }

        carLoanService.getMasterDataByPinCode = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/RAAS/getDetailsByPincode", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        return carLoanService;

    });