'use strict';

angularApp.controller('newDebitCardOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"newDebitCardService",
	"cardsService","fTSetOTPService","$filter","cryptoService","loggedInUserService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		newDebitCardService,
		cardsService,fTSetOTPService,$filter,cryptoService,loggedInUserService) {

		//functions, variables that can be accessed from the HTML come here
		var newDebitCardOtpVm = this;


		$scope.$on('$ionicView.beforeEnter', function() {         
	
			 
			newDebitCardOtpVm.userMobile = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
			newDebitCardOtpVm.isDisabledOTP=false;
			newDebitCardOtpVm.clickCount=0;
			newDebitCardOtpVm.disableNext=true;
			//newDebitCardOtpVm.isNextEnabled = true;
			newDebitCardOtpVm.clickSubmitCount = 0;
	
		 });
 

		 newDebitCardOtpVm.resendOTP = function () {
			newDebitCardOtpVm.otp="";
            newDebitCardOtpVm.isResendOTP=true;
            var reqData = {};

			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.CARDOTP;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.CARDOTP).toString();
      		reqData.journeyName = "NEW_DEBIT_CARD"
            fTSetOTPService.generateOTP(reqData).then(function (response) {
                newDebitCardOtpVm.clickCount++;
                if(newDebitCardOtpVm.clickCount>=2){
                    newDebitCardOtpVm.isDisabledOTP=true;
                }
                else{
                    newDebitCardOtpVm.isDisabledOTP=true;
                    $timeout(function () {
                        newDebitCardOtpVm.isDisabledOTP=false;
                    }, 30000);
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
		
		}


		
		newDebitCardOtpVm.nextEnable = function () {
			newDebitCardOtpVm.showNameError = newDebitCardOtpVm.otp.length;
			if (newDebitCardOtpVm.otp.length==6 || !newDebitCardOtpVm.otp)

				newDebitCardOtpVm.disableNext = false;
			else
				newDebitCardOtpVm.disableNext = true;
		}


		
		newDebitCardOtpVm.goToNext = function () {

			if (newDebitCardOtpVm.otp.length < 6) {
				newDebitCardOtpVm.nextEnable();

			} else {
				var reqParams = {
					otp: newDebitCardOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}
				newDebitCardOtpVm.clickSubmitCount++;
				if (newDebitCardOtpVm.clickSubmitCount <= 3) {
					fTSetOTPService.validateOTPForNewDebitCard(reqParams).then(function (data) {

						newDebitCardOtpVm.requestReferenceNumber = data.requestReferenceNumber;
						newDebitCardOtpVm.storeRefNumber = data.storeRefNumber;
						newDebitCardOtpVm.nightMode = data.nightMode;
						newDebitCardOtpVm.statusCode = data.statusCode;
						newDebitCardOtpVm.errorDesc = data.errorDesc;
						if (newDebitCardOtpVm.nightMode == "Y") {
							newDebitCardOtpVm.showNightMode = true;
						} else {
							newDebitCardOtpVm.dayMode = true;
						}

						if (newDebitCardOtpVm.statusCode == "00") {
							newDebitCardOtpVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'new-purp-popup my-custom-popup',
								templateUrl: 'pages/nfs/newDebitCard/Congratulations.html',
								scope: $scope
							});
						} else {
							if (newDebitCardOtpVm.errorDesc == "ATM ALREADY ISSUED TO CUSTOMER") {
								utilityService.showNfsAlertModal("", newDebitCardOtpVm.errorDesc, "menu.innerPage", $scope, $state, "OK");
							}
							else {
								utilityService.showNfsAlertModal("", "We are unable to process your request, please try later", "menu.innerPage", $scope, $state, "OK");
							}
						}

					}, function (error) {
						if (error.responseCode == "RD01") {
							utilityService.showErrorMessage(error.responseMessage, "menu.innerPage");
						}
						else {
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
				}
				else {
					newDebitCardOtpVm.disableNext = true;
				}

			}

		};

		newDebitCardOtpVm.ok = function () {
			newDebitCardOtpVm.myPopup.close();
			utilityService.setCsatJournies('newDebitCard');
			newDebitCardOtpVm.otp = "";
			$state.go('menu.innerPage');
		};


		return this;
	}
]);
