'use strict';

angularApp.controller('fatcaDLooksGreatRelNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $ionicPopover) {

        var factDGreatRelNPSControllerVM = this;
        $scope.currentPage = "13";
        $scope.lastPage = "16";
        factDGreatRelNPSControllerVM.isPanNumMasked = false;
        factDGreatRelNPSControllerVM.isAadhaarNumMasked = false;
        factDGreatRelNPSControllerVM.cancelconf = npsServices.applicantData.setCancelRelng;
        

        factDGreatRelNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        factDGreatRelNPSControllerVM.sizeInfo = function ($event) {
          
            var orGetInfoMsg = "Document should be in jpg format. Size should be between 4KB - 12KB.";
                var template = '<ion-popover-view class="tooltiptext commonPopNps npsCustomerPic roboto-regular" style = "height: 65px;">' + '<ion-content>' +
                '<div class="text-left">' + orGetInfoMsg + '</div>' + '</ion-content>' + '</ion-popover-view>';

                var popover = $ionicPopover.fromTemplate(template, {
                    scope: $scope
                });
                    popover.show($event);
        }

        

        factDGreatRelNPSControllerVM.goBack = function () {

            $state.go("menu.npsFatcDSelfiRel");

        }

        factDGreatRelNPSControllerVM.goNext = function () {

            var newImg = factDGreatRelNPSControllerVM.croppedImage;
            var baseImg = newImg.split("base64,")[1];
            var requestParams = {
                "documentClass": "LT_AccountOpening_NPS",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Photo",
                "documentData": baseImg,
                "documentType": "Relinquishment Certificate",
                "accountNo": "",
                "documentID": "",
                "commonId": "",
                "id": npsServices.applicantData.uscitizenevidencedocid,
                "confirmFlag": factDGreatRelNPSControllerVM.applicantData.relinquishmentconfirmflag ? "Y" : "N"
            }
            if(npsServices.applicantData.uscitizenevidencedocid !== '' && factDGreatRelNPSControllerVM.cancelconf || factDGreatRelNPSControllerVM.cancelconf){
                   npsServices.uploadDocument(requestParams).then(function (response) {
                    npsServices.applicantData.uscitizenevidencedocid = response.data.docRef;
                    $state.go("menu.moneyLaunderingDeclaration");
                }, function (error) {
                    npsServices.showErrorMessage(error.responseMessage);
                });
            }else{
                $state.go("menu.moneyLaunderingDeclaration");
                
            }
         

            
        }

        factDGreatRelNPSControllerVM.retrievePhotoCall = function () {
            var param = npsServices.applicantData.uscitizenevidencedocid;

            npsServices.retrievePhoto(param).then(function (response) {

                factDGreatRelNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                npsServices.applicantData.usCitizenPhoto = factDGreatRelNPSControllerVM.croppedImage;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            factDGreatRelNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            factDGreatRelNPSControllerVM.disableTitle = false;
            factDGreatRelNPSControllerVM.croppedImage = "img/client-img.png";

            if (!npsServices.applicantData.usCitizenPhoto) {
                if (!utilityService.isUndefined(npsServices.applicantData.uscitizenevidencedocid)) {
                    factDGreatRelNPSControllerVM.retrievePhotoCall();
                }
            }
            else {
                factDGreatRelNPSControllerVM.croppedImage = npsServices.applicantData.usCitizenPhoto;

            }

         

        });

        return this;
    }
]);
