'use strict';

angularApp.controller('finalSuccessNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "openUrlInAppbroswerService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        openUrlInAppbroswerService) {

        var finalSuccessNPSControllerVM = this;
        $scope.currentPage = "16";
        $scope.lastPage = "16";

        finalSuccessNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        finalSuccessNPSControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        finalSuccessNPSControllerVM.goNext = function () {
            $state.go('menu.homeScreen');
        }

        //Download PDF
        finalSuccessNPSControllerVM.pranPdfDownload = function () {

            npsServices.getDocument().then(function (response) {

            var myBase64 = finalSuccessNPSControllerVM.pdfContent = response.data.base64Pdf;
            var contentType = "application/pdf";
            if (utilityService.isAndroidPlatform()) {
                finalSuccessNPSControllerVM.folderpath = cordova.file.externalRootDirectory;
            }
            if (utilityService.isIOSPlatform()) {
                
                if (finalSuccessNPSControllerVM.pdfContent !== "") {
                    finalSuccessNPSControllerVM.isTncDownloaded = true;
                    finalSuccessNPSControllerVM.openPdf();
                }
            }
            

            if (utilityService.isAndroidPlatform()) {

                var filename = finalSuccessNPSControllerVM.npsFinalSuccessDetails.pdfDocName + ".pdf";



                finalSuccessNPSControllerVM.b64toBlob = function (b64Data, contentTypeNew, sliceSize) {
                    contentTypeNew = contentTypeNew || '';
                    sliceSize = sliceSize || 512;

                    var byteCharacters = atob(b64Data);
                    var byteArrays = [];

                    for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                        var slice = byteCharacters.slice(offset, offset + sliceSize);

                        var byteNumbers = new Array(slice.length);
                        for (var i = 0; i < slice.length; i++) {
                            byteNumbers[i] = slice.charCodeAt(i);
                        }

                        var byteArray = new Uint8Array(byteNumbers);

                        byteArrays.push(byteArray);
                    }

                    return new Blob(byteArrays, { type: contentTypeNew });
                    
                }


                finalSuccessNPSControllerVM.savebase64AsPDF = function (folderpath, filenameNew, content, contentTypePdf) {
                    
                    // Convert the base64 string in a Blob
                    var DataBlob = finalSuccessNPSControllerVM.b64toBlob(content, contentTypePdf);
                  
                    console.log("Starting to write the file :3");
                    if(device.version==10){
                         var folderpathDir = cordova.file.externalDataDirectory;
                         finalSuccessNPSControllerVM.popupFolderpath = folderpathDir.replace(cordova.file.externalRootDirectory,"") + filename;
                            window.resolveLocalFileSystemURL(folderpathDir, function (dir) {
                                console.log("Access to the directory granted succesfully");
                                dir.getFile(filenameNew, { create: true }, function (file) {
                                    console.log("File created succesfully.");
                                    file.createWriter(function (fileWriter) {
                                        console.log("Writing content to file");
                                        fileWriter.write(DataBlob);
                                        finalSuccessNPSControllerVM.isTncDownloaded = true;
                                        
        
        
                                        finalSuccessNPSControllerVM.myPopup = $ionicPopup.show({
                                            template: 'File Downloaded to Internal Storage',
                                            title: '',
                                            cssClass: 'dialog',
                                            scope: $scope,
                                            buttons: [{
                                                text: 'OK',
                                                type: 'button-positive'
                                            }]
                                        });
        
        
                                    }, function () {
                                        alert('Unable to save file in path ' + finalSuccessNPSControllerVM.popupFolderpath);
                                    });
                                });
                            });
                        }else{
                                            //for Android below 10 and Android 11 not for 10
                                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                                    fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                                        finalSuccessNPSControllerVM.popupFolderpath = dir.fullPath + filenameNew;
                                        dir.getFile(filenameNew, { create: true }, function(file) {
                                            file.createWriter(function(fileWriter) {
                                                fileWriter.write(DataBlob);
                                                //Show popup 
                                                var template = 'File Downloaded to download folder.';
                                                finalSuccessNPSControllerVM.myPopup = $ionicPopup.show({
                                                    title: '',
                                                    template: template,
                                                    scope: $scope,
                                                    cssClass: 'my-custom-popup npsFinalSuccessPopupPdf',
                                                    buttons: [{
                                                        text: 'OK',
                                                        type: 'button-positive'
                                                    }]
                                                });
                                            }, function() {
                                                console.log("test");
                                            });
                                        });
                                    });
                                });
                         }
                    }
                finalSuccessNPSControllerVM.savebase64AsPDF(finalSuccessNPSControllerVM.folderpath, filename, myBase64, contentType);

            }

            }, function (error) {
                console.log(error);
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        finalSuccessNPSControllerVM.openPdf = function () {
            openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + finalSuccessNPSControllerVM.pdfContent + "", "");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            finalSuccessNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            finalSuccessNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);
            finalSuccessNPSControllerVM.totalInvestmentAmount = npsServices.npsContributionReviewDetails.totalInvestmentAmount;
            finalSuccessNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
        });

        return this;
    }
]);
