'use strict';

angularApp.controller('landingNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsServices) {

        var landingNPSControllerVM = this;
        landingNPSControllerVM.isFeaturesActive = true;
        landingNPSControllerVM.isEligibilityActive = false;
        landingNPSControllerVM.isCalculatorActive = false;
        landingNPSControllerVM.preRequisite = npsServices.resumeRedirectData.preRequisite;

        landingNPSControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        landingNPSControllerVM.selType = function (type) {
            landingNPSControllerVM.isFeaturesActive = type === "F" ? true : false;
            landingNPSControllerVM.isEligibilityActive = type === "E" ? true : false;
            landingNPSControllerVM.isCalculatorActive = type === "C" ? true : false;
        }

       

  


        landingNPSControllerVM.applyNow = function () {

            utilityService.doNotHideSpinner();
            var requestParams = {};
            npsServices.fetchNPSDropDown(requestParams).then(function (data) {
                npsServices.npsDropdownData = data;
                landingNPSControllerVM.preRequisite = npsServices.npsDropdownData.preRequisite;
                //redirection to specific page
                if (npsServices.resumeRedirectData.resumeid && npsServices.resumeRedirectData.resumeState) {

                    if(landingNPSControllerVM.npsFinalSuccessDetails.leg == '1' || landingNPSControllerVM.npsFinalSuccessDetails.leg == '2'){
                        $ionicPopup.alert({
                            title: "",
                            template: '<div class="customAlertPopupPadding font-dark-grey"><div ng-hide="false" style="height: 10px;"></div><div><center><img ng-show="false" class="w-70" src="img/errorImage.png"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                            + "{{'NPS_DATA_CAPTURED'| translate}}" + '</span></div></div></div>',
                            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive',
                                onTap: function () {
                                    npsServices.resumeRedirect();
                                }
                            }]
                        })
                    }else{
                        npsServices.resumeRedirect();
                    }


                } else {
                    $ionicPopup.alert({

                        title: "",
                        template: '<div class="customAlertPopupPadding font-dark-grey"><div ng-hide="false"></div><div><center><img ng-show="true" class="w-55" src="img/nps/nps_alert_icon.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><h3>Pre requisite</h3></div><div class="popUp-msg-color">'
                        + landingNPSControllerVM.preRequisite + '</div></div></div>',
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup disclNps',
                        buttons: [{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function () {
                                $state.go("menu.termsConditionsNPSView");
                            }
                        }]

                            
                    })
                    
                    
                }

            }, function (error) {
                landingNPSControllerVM.preRequisite = error.preRequisite;
                $ionicPopup.alert({

                    title: "",
                    template: '<div class="customAlertPopupPadding font-dark-grey"><div ng-hide="false"></div><div><center><img ng-show="true" class="w-55" src="img/nps/nps_alert_icon.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><h3>Pre requisite</h3></div><div class="popUp-msg-color">'
                    + landingNPSControllerVM.preRequisite + '</div></div></div>',
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup disclNps',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function () {
                            
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    }]
                })
            });
        }


        landingNPSControllerVM.thirdPartyDisclaimer = function () {

            var disclaimerPopup = $ionicPopup.confirm({
                title: 'Disclaimer',
                template: '<div ng-bind-html="landingNPSControllerVM.npsDisclaimer"></div>',
                scope: $scope,
                cssClass: 'NPSDialog NPSDisclaimer',
                buttons: [
                    {
                        text: 'Cancel',
                        onTap: function (e) {
                            disclaimerPopup.close();
                        }
                    }, {
                        text: 'CONFIRM',
                        onTap: function (e) {
                            disclaimerPopup.close();
                            var url = "https://npstrust.org.in/content/pension-calculator"; // Changed after CDAC Observartion


                            cordova.ThemeableBrowser.open(url, '_blank', {
                                statusbar: {
                                    color: '#ffffffff'
                                },
                                toolbar: {
                                    height: 44,
                                    color: '#ffffffff',
                                    image: 'share'
                                },

                                closeButton: {
                                    wwwImage: 'img/inappback.png',
                                    align: 'left',
                                    event: 'closePressed'
                                },

                                backButtonCanClose: true
                                
                            })



                        }

                    }
                ]
            });

        }

        // Added below code to resolve NPS calculator link issue on new API32 build 
        landingNPSControllerVM.openNpsCalculator = function (){
            SafariViewController.isAvailable(function (available) {
                if (available) {
                  SafariViewController.show({
                        url: 'https://www.npstrust.org.in/content/pension-calculator',
                        hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
                        animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
                        transition: 'curl', // (this only works in iOS 9.1/9.2 and lower) unless animated is false you can choose from: curl, flip, fade, slide (default)
                        enterReaderModeIfAvailable: false, // default false
                        tintColor: "#00ffff", // default is ios blue
                        toolbarColor: "#90305e", // change color of address bar in android
                        barColor: "#90305e", // on iOS 10+ you can change the background color as well
                        controlTintColor: "#ffffff" // on iOS 10+ you can override the default tintColor
                      },
                      // this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
                      function(result) {
                        if (result.event === 'opened') {
                          console.log('opened');
                        } else if (result.event === 'loaded') {
                          console.log('loaded');
                        } else if (result.event === 'closed') {
                          console.log('closed');
                        }
                      },
                      function(msg) {
                        console.log("Error: " + msg);
                      })
                } else {
                  // potentially powered by InAppBrowser because that (currently) clobbers window.open
                  window.open('https://www.npstrust.org.in/content/pension-calculator', '_blank', 'location=yes');
                }
              })
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            landingNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            landingNPSControllerVM.npsFeatures = npsServices.NPSDetails.npsFeatures;
            landingNPSControllerVM.npsEligibility = npsServices.NPSDetails.npsEligibility;
            landingNPSControllerVM.npsCalculator = npsServices.NPSDetails.npsCalculator;
            landingNPSControllerVM.npsDisclaimer = npsServices.NPSDetails.npsDisclaimer;
            landingNPSControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            landingNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);
        });

        return this;
    }
]);
