'use strict';

angularApp.controller('nominationDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "ionicDatePicker",
    "$q",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        ionicDatePicker,
        $q,
        $ionicPopover) {

        var nominationDetailsNPSControllerVM = this;
        nominationDetailsNPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "11";
        $scope.lastPage = "16";
       
        nominationDetailsNPSControllerVM.nomineeLabel = "Nominee";
        nominationDetailsNPSControllerVM.sameNomineeForTierII = false;
        nominationDetailsNPSControllerVM.nominees = [{
            count: 1,
            enableDelete: false,
            npsNomineeType: "",
            nomineeFirstName: "",
            nomineeMiddleName: "",
            nomineeSurname: "",
            nomineeRelationship: "",
            relationshipcode:"",
            nomineeDob: "",
            percentageShare: "",
            guardianFirstName: "",
            guardianMiddleName: "",
            guardianSurname: "",
            nomineeage:""

        }];

        //contact data edit from review page 
            nominationDetailsNPSControllerVM.reviewBtn = false;
            nominationDetailsNPSControllerVM.originalFBtn = true;
            var reviewEditData = npsServices.getReviewEditData();

            nominationDetailsNPSControllerVM.comingFromReview = function () {
                if(reviewEditData == 'nominationDetails'){
                    nominationDetailsNPSControllerVM.reviewBtn = true;
                    nominationDetailsNPSControllerVM.originalFBtn = false;
                }
            }

            nominationDetailsNPSControllerVM.goCancel = function(){
                nominationDetailsNPSControllerVM.originalFBtn = true;
                nominationDetailsNPSControllerVM.reviewBtn = false;  
                npsServices.npsNominationDetails.nominees = angular.copy(nominationDetailsNPSControllerVM.nomineesTemp);
                $state.go("menu.reviewDetailsNps");
            }

           
        //end code here

        nominationDetailsNPSControllerVM.getRelationshipDpwn = function () {
            npsServices.getRelationshipDrpwn().then(function (response) {
                
                nominationDetailsNPSControllerVM.relationshipOptions = response;
                

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        //for DOB age calculation
        

        function getCalculatedAge(born) {
            var now = new Date();
            var birthday = new Date(now.getFullYear(), born.getMonth(), born.getDate());
            if (now >= birthday)
                return now.getFullYear() - born.getFullYear();
            else
                return (now.getFullYear() - born.getFullYear()) - 1;
        }

        nominationDetailsNPSControllerVM.getNomineeAge = function (index) {
            if (nominationDetailsNPSControllerVM.nominees[index].nomineeage !== undefined && nominationDetailsNPSControllerVM.nominees[index].nomineeage !== "" && nominationDetailsNPSControllerVM.nominees[index].nomineeage !== null) {
                nominationDetailsNPSControllerVM.nominees[index].nomineeage = parseInt(nominationDetailsNPSControllerVM.nominees[index].nomineeage);
                
            } else {
                nominationDetailsNPSControllerVM.nominees[index].nomineeage = "";
            }
        }

        nominationDetailsNPSControllerVM.openDatePicker = function (index) {
            nominationDetailsNPSControllerVM.ipObj1 = {
            callback: function (val) {
                
                var dateN = new Date(val);
                nominationDetailsNPSControllerVM.nominees[index].nomineeage = parseInt(getCalculatedAge(dateN));
                nominationDetailsNPSControllerVM.nominees[index].nomineeageAge = nominationDetailsNPSControllerVM.nominees[index].nomineeage + ' ' + 'years';
                nominationDetailsNPSControllerVM.nominees[index].nomineeDob = $filter('date')(dateN, "dd MMM yyyy");
            },
            inputDate: new Date(),
            to: new Date(),
            mondayFirst: true,
            closeOnSelect: false,
            templateType: 'popup',
        };
            ionicDatePicker.openDatePicker(nominationDetailsNPSControllerVM.ipObj1);
        };

        //end code for age calculation


        /* Open the date picker popup for nominee minor */  //existing code
        



        //end code here for DOB minor


        nominationDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nominationDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsBankDetails');
        }


        //for info popup
        var template = '<ion-popover-view class="tooltiptext commonPopNps nps-tooltip nps-fatca-tooltip nps-fatca-tooltipNom roboto-regular npsNominee">' + '<ion-content>' +
            '<div class="npsInfoHeading"><p>Nominee Information</p></div><div class="text-left" ng-bind-html="nominationDetailsNPSControllerVM.NPSDetails.nominformation"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        nominationDetailsNPSControllerVM.npsNomineeInfo = function ($event) {
            
            $scope.popover.show($event);

        };

        nominationDetailsNPSControllerVM.selectRelationship = function (index) {
            nominationDetailsNPSControllerVM.nominees[index].relationshipcode = utilityService.getTextFromDropdown("value", nominationDetailsNPSControllerVM.nominees[index].nomineeRelationship, nominationDetailsNPSControllerVM.relationshipOptions, "description");
            if(nominationDetailsNPSControllerVM.nominees[index].relationshipcode){
                nominationDetailsNPSControllerVM.nextBtnFRelAct = false;
            }else{
                nominationDetailsNPSControllerVM.nextBtnFRelAct = true;
            }
            
        }



        nominationDetailsNPSControllerVM.goNext = function () {

            npsServices.npsNominationDetails.numberOfNominee = nominationDetailsNPSControllerVM.nominees.length;
            npsServices.npsNominationDetails.nominees = nominationDetailsNPSControllerVM.nominees;
            console.log("gonext", npsServices.npsNominationDetails.nominees);
            npsServices.npsNominationDetails.sameNomineeForTierII = nominationDetailsNPSControllerVM.sameNomineeForTierII;
            var requestParams;

            if (nominationDetailsNPSControllerVM.nominees.length > 1) {
                nominationDetailsNPSControllerVM.nomineesRequest = [];

                for (var i = 0; i < npsServices.npsNominationDetails.numberOfNominee; i++) {
                     var insert = {
                        "type": "Tier1_Nominee" + (i + 1),
                        "firstName": npsServices.npsNominationDetails.nominees[i].nomineeFirstName,
                        "middleName": npsServices.npsNominationDetails.nominees[i].nomineeMiddleName,
                        "lastName": npsServices.npsNominationDetails.nominees[i].nomineeSurname,
                        "relationship": npsServices.npsNominationDetails.nominees[i].relationshipcode,
                        "isMajor": npsServices.npsNominationDetails.nominees[i].npsNomineeType,
                        "percentageShare": npsServices.npsNominationDetails.nominees[i].percentageShare,
                        "dob": npsServices.npsNominationDetails.nominees[i].nomineeDob,
                        "guardian": {
                            "firstName": npsServices.npsNominationDetails.nominees[i].guardianFirstName,
                            "middleName": npsServices.npsNominationDetails.nominees[i].guardianMiddleName,
                            "lastName": npsServices.npsNominationDetails.nominees[i].guardianSurname
                        },
                        "nomineeage":nominationDetailsNPSControllerVM.nominees[i].nomineeage,
                        "relationshipcode":nominationDetailsNPSControllerVM.nominees[i].nomineeRelationship
                    }

                    nominationDetailsNPSControllerVM.nomineesRequest.push(insert);
                }

                requestParams = {
                    "npsAccountType": "Tier1",
                    "isNomineeSame": npsServices.npsNominationDetails.sameNomineeForTierII  ? "Y" : "N",
                    "nominees": nominationDetailsNPSControllerVM.nomineesRequest
                };
            } else {
                requestParams = {
                    "npsAccountType": "Tier1",
                    "isNomineeSame": nominationDetailsNPSControllerVM.sameNomineeForTierII,
                    "nominees": [{
                        "type": "Tier1_Nominee1",
                        "firstName": npsServices.npsNominationDetails.nominees[0].nomineeFirstName,
                        "middleName": nominationDetailsNPSControllerVM.nominees[0].nomineeMiddleName,
                        "lastName": nominationDetailsNPSControllerVM.nominees[0].nomineeSurname,
                        "relationship": nominationDetailsNPSControllerVM.nominees[0].relationshipcode,
                        "isMajor": nominationDetailsNPSControllerVM.nominees[0].npsNomineeType,
                        "percentageShare": nominationDetailsNPSControllerVM.nominees[0].percentageShare,
                        "dob": npsServices.npsNominationDetails.nominees[0].nomineeDob,
                        "guardian": {
                            "firstName": nominationDetailsNPSControllerVM.nominees[0].guardianFirstName,
                            "middleName": nominationDetailsNPSControllerVM.nominees[0].guardianMiddleName,
                            "lastName": nominationDetailsNPSControllerVM.nominees[0].guardianSurname
                        },
                        "nomineeage":nominationDetailsNPSControllerVM.nominees[0].nomineeage,
                        "relationshipcode":nominationDetailsNPSControllerVM.nominees[0].nomineeRelationship
                    }]
                };
            }


           


             if (nominationDetailsNPSControllerVM.sameNomineeForTierII || nominationDetailsNPSControllerVM.npsAccountType.toUpperCase() == "TIER1") {


                    if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                        $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {

                            npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                            npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;

                            if(nominationDetailsNPSControllerVM.reviewBtn && reviewEditData == 'nominationDetails'){
                                $state.go("menu.reviewDetailsNps");
                            }else{
                                $state.go("menu.npsPensionFundDetails");   
                            }
                            
                         }, function (error) {
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    } else {

                        npsServices.saveNomineeDetails(requestParams).then(function (response) {
                           
                           if(nominationDetailsNPSControllerVM.reviewBtn && reviewEditData == 'nominationDetails'){
                                $state.go("menu.reviewDetailsNps");
                            }else{
                                $state.go("menu.npsPensionFundDetails");   
                            }

                        }, function (error) {
                            utilityService.enableShowErrorMessage();
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }

                } else {

                    npsServices.saveNomineeDetails(requestParams).then(function (response) {
                        
                        if(nominationDetailsNPSControllerVM.reviewBtn && reviewEditData == 'nominationDetails'){
                                $state.go("menu.reviewDetailsNps");
                        }else{
                            $state.go("menu.npsNominationDetailsTierII");   
                        }

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });


                }

        }

        nominationDetailsNPSControllerVM.resetTotalPercentageShare = function () {
            nominationDetailsNPSControllerVM.totalPercentageShare = 0;
            for (var i = 0; i < (nominationDetailsNPSControllerVM.nominees.length); i++) {
                nominationDetailsNPSControllerVM.totalPercentageShare = nominationDetailsNPSControllerVM.totalPercentageShare + parseFloat(nominationDetailsNPSControllerVM.nominees[i].percentageShare);
            }

            if (nominationDetailsNPSControllerVM.totalPercentageShare == 100.0) {
                nominationDetailsNPSControllerVM.disableNextButton = false
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsNPSControllerVM.disableNextButton = true
                if (nominationDetailsNPSControllerVM.nominees.length < 3) {
                    nominationDetailsNPSControllerVM.disableAddNominiee = false;
                }
            }
        }

        nominationDetailsNPSControllerVM.addNominee = function () {
           

            if (nominationDetailsNPSControllerVM.nominees.length < 3) {

                if (nominationDetailsNPSControllerVM.nominees.length == 2) {
                    nominationDetailsNPSControllerVM.disableAddNominiee = true;
                } else {
                    nominationDetailsNPSControllerVM.disableAddNominiee = false;
                }

                var incrementValue = nominationDetailsNPSControllerVM.nominees[nominationDetailsNPSControllerVM.nominees.length - 1].count + 1;

                var insert = {
                    count: incrementValue,
                    enableDelete: true,
                    npsNomineeType: "",
                    nomineeFirstName: "",
                    nomineeMiddleName: "",
                    nomineeSurname: "",
                    nomineeRelationship: "",
                    relationshipcode: "",
                    nomineeDob: "",
                    percentageShare: nominationDetailsNPSControllerVM.percentageShareList[0].value,
                    guardianFirstName: "",
                    guardianMiddleName: "",
                    guardianSurname: ""
                }

                nominationDetailsNPSControllerVM.nominees.push(insert);
            } else {
                console.log("Not allowed");
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            }

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

        }

        nominationDetailsNPSControllerVM.deleteNominee = function (index) {
            nominationDetailsNPSControllerVM.nominees.splice(index, 1);

            if (nominationDetailsNPSControllerVM.nominees.length < 3) {
                nominationDetailsNPSControllerVM.disableAddNominiee = false;
            }

            for (var i = 0; i < (nominationDetailsNPSControllerVM.nominees.length); i++) {
                nominationDetailsNPSControllerVM.nominees[i].count = i + 1;
            }

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

        }

        nominationDetailsNPSControllerVM.percentageShareChange = function (index) {

            nominationDetailsNPSControllerVM.resetTotalPercentageShare();

            console.log(nominationDetailsNPSControllerVM.totalPercentageShare);
            if (nominationDetailsNPSControllerVM.totalPercentageShare > 100.0) {
                var message = "Nominee share cannot be more than 100%";
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(message);
                nominationDetailsNPSControllerVM.nominees[index].percentageShare = nominationDetailsNPSControllerVM.percentageShareList[0].value;

                nominationDetailsNPSControllerVM.resetTotalPercentageShare();
            }

            if (nominationDetailsNPSControllerVM.totalPercentageShare >= 100.0) {
                nominationDetailsNPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsNPSControllerVM.disableAddNominiee = false;
            }
        }

       



        $scope.$on('$ionicView.beforeEnter', function () {
            nominationDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nominationDetailsNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
            nominationDetailsNPSControllerVM.percentageShareList = npsServices.npsDropdownData.nomineePercentage;
            nominationDetailsNPSControllerVM.nominees[0].percentageShare = nominationDetailsNPSControllerVM.percentageShareList[nominationDetailsNPSControllerVM.percentageShareList.length - 1].value;
            
            if (npsServices.npsNominationDetails.nominees[0]) {
                nominationDetailsNPSControllerVM.nominees = angular.copy(npsServices.npsNominationDetails.nominees);
                nominationDetailsNPSControllerVM.nomineesTemp = angular.copy(npsServices.npsNominationDetails.nominees);
            }


           nominationDetailsNPSControllerVM.NPSDetails =  npsServices.NPSDetails;

            nominationDetailsNPSControllerVM.sameNomineeForTierII = npsServices.npsNominationDetails.sameNomineeForTierII;
            nominationDetailsNPSControllerVM.resetTotalPercentageShare();
            nominationDetailsNPSControllerVM.getRelationshipDpwn();
            nominationDetailsNPSControllerVM.comingFromReview();

             //for nominee age
             if (nominationDetailsNPSControllerVM.nominees[0].nomineeage !== undefined && nominationDetailsNPSControllerVM.nominees[0].nomineeage !== "" && nominationDetailsNPSControllerVM.nominees[0].nomineeage !== null) {
                nominationDetailsNPSControllerVM.nominees[0].nomineeage = parseInt(nominationDetailsNPSControllerVM.nominees[0].nomineeage);
                nominationDetailsNPSControllerVM.nominees[0].nomineeageAge = nominationDetailsNPSControllerVM.nominees[0].nomineeage + ' ' + 'years';
                
            } else {
                nominationDetailsNPSControllerVM.nominees[0].nomineeage = "";
            }
 
            
            
        });
        return this;
    }
]);
