'use strict';

angularApp.controller('otherDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $ionicPopover) {

        var otherDetailsNPSControllerVM = this;
        $scope.currentPage = "8";
        $scope.lastPage = "16";

         //contact data edit from review page 
            otherDetailsNPSControllerVM.reviewBtn = false;
            otherDetailsNPSControllerVM.originalFBtn = true;
            var reviewEditData = npsServices.getReviewEditData();

            otherDetailsNPSControllerVM.comingFromReview = function () {
                if(reviewEditData == 'otherDetails'){
                    otherDetailsNPSControllerVM.reviewBtn = true;
                    otherDetailsNPSControllerVM.originalFBtn = false;
                }
            }

            otherDetailsNPSControllerVM.goCancel = function(){
                otherDetailsNPSControllerVM.originalFBtn = true;
                otherDetailsNPSControllerVM.reviewBtn = false;
                $state.go("menu.reviewDetailsNps");
            }

           
        //end code here


        otherDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        otherDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsContactDetails');
        }

        otherDetailsNPSControllerVM.selectedOccupation = function () {

          

            otherDetailsNPSControllerVM.npsOtherDetails.occupationText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.occupation, otherDetailsNPSControllerVM.occupationList, "description");

        }

        otherDetailsNPSControllerVM.selectedIncomeRange = function () {

            otherDetailsNPSControllerVM.npsOtherDetails.incomeText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.income, otherDetailsNPSControllerVM.incomeList, "description");

        }

        otherDetailsNPSControllerVM.selectedEducationQualification = function () {

            otherDetailsNPSControllerVM.npsOtherDetails.educationText = utilityService.getTextFromDropdown("value", otherDetailsNPSControllerVM.npsOtherDetails.education, otherDetailsNPSControllerVM.educationList, "description");

        }

        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext commonPopNps npsCustomerPic npsFatca nps-fatca-tooltip npsOtherTooltip roboto-regular">' + '<ion-content>' +
            '<div class="npsInfoHeading"><p>PEP Information</p></div><div class="text-left" ng-bind-html="otherDetailsNPSControllerVM.NPSDetails.pep"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        otherDetailsNPSControllerVM.politicalInfo = function ($event) {
            
            $scope.popover.show($event);
        }


        otherDetailsNPSControllerVM.goNext = function () {
            npsServices.npsOtherDetails.occupation = otherDetailsNPSControllerVM.npsOtherDetails.occupation;
            npsServices.npsOtherDetails.occupationText = otherDetailsNPSControllerVM.npsOtherDetails.occupationText;
            npsServices.npsOtherDetails.otherOccupationDetails = otherDetailsNPSControllerVM.npsOtherDetails.otherOccupationDetails;
            npsServices.npsOtherDetails.income = otherDetailsNPSControllerVM.npsOtherDetails.income;
            npsServices.npsOtherDetails.incomeText = otherDetailsNPSControllerVM.npsOtherDetails.incomeText;
            npsServices.npsOtherDetails.education = otherDetailsNPSControllerVM.npsOtherDetails.education;
            npsServices.npsOtherDetails.educationText = otherDetailsNPSControllerVM.npsOtherDetails.educationText;
            npsServices.npsOtherDetails.politicalExposed = otherDetailsNPSControllerVM.npsOtherDetails.politicalExposed; 

            npsServices.npsBankDetails.micrCode = otherDetailsNPSControllerVM.npsBankDetails.micrCode;
            npsServices.npsBankDetails.stateCode = otherDetailsNPSControllerVM.npsBankDetails.stateCode;
            npsServices.npsBankDetails.state = otherDetailsNPSControllerVM.npsBankDetails.state;

            var requestParams = {
                "otherDetails": {
                "residentialStatus": "",
                "education": npsServices.npsOtherDetails.educationText,
                "occupation": npsServices.npsOtherDetails.occupationText,
                "annualIncome": npsServices.npsOtherDetails.incomeText,
                "annualIncomeCode": npsServices.npsOtherDetails.income,
                "subOccupation": npsServices.npsOtherDetails.otherOccupationDetails,
                "educationCode": npsServices.npsOtherDetails.education,
                "occupationCode": npsServices.npsOtherDetails.occupation,
                "subOccupationCode": "",
                "thresholdLimitAmount": ""
                },
                "bankDetails": {
                "micr": otherDetailsNPSControllerVM.npsBankDetails.micrCode,
                "state": npsServices.npsBankDetails.state,
                "stateCode": npsServices.npsBankDetails.stateCode
                },
                "userConsent": {
                "isPoliticallyExposed": npsServices.npsOtherDetails.politicalExposed
                }
            };

           

            npsServices.saveOtherDetails(requestParams).then(function (response) {
                    if(otherDetailsNPSControllerVM.reviewBtn && reviewEditData == 'otherDetails'){
                       $state.go("menu.reviewDetailsNps");
                    }else{
                    if(npsServices.applicantData.customerSignature || npsServices.applicantData.custsignid){
                        $state.go('menu.npsSignaturePreview');
                    }else{
                        $state.go("menu.npsTakeSignature");
                    }
                }
                    
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });  

            }

        $scope.$on('$ionicView.beforeEnter', function () {
            otherDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            otherDetailsNPSControllerVM.occupationList = npsServices.npsDropdownData.rioccupation;
            otherDetailsNPSControllerVM.educationList = npsServices.npsDropdownData.educationMaster;
            otherDetailsNPSControllerVM.incomeList = npsServices.npsDropdownData.incomeMaster;
            otherDetailsNPSControllerVM.npsOtherDetails = angular.copy(npsServices.npsOtherDetails);
           otherDetailsNPSControllerVM.npsBankDetails = angular.copy(npsServices.npsBankDetails);
            
             otherDetailsNPSControllerVM.comingFromReview();
             otherDetailsNPSControllerVM.NPSDetails = npsServices.NPSDetails;

        });


        return this;
    }
]);
