'use strict';

angularApp.controller('signaturePreviewNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var signaturePreviewNPSControllerVM = this;
        $scope.currentPage = "9";
        $scope.lastPage = "16";
        signaturePreviewNPSControllerVM.isPanNumMasked = false;
        signaturePreviewNPSControllerVM.isAadhaarNumMasked = false;
        signaturePreviewNPSControllerVM.cancelconf = npsServices.applicantData.setCancelSign;

        signaturePreviewNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        signaturePreviewNPSControllerVM.sizeInfo = function ($event) {
            npsServices.sizeInfoPopover($event, $scope);
        }

       

        signaturePreviewNPSControllerVM.goBack = function () {

            $state.go("menu.npsTakeSignature");

        }

       
        signaturePreviewNPSControllerVM.goNext = function () {
           
            var newImg = signaturePreviewNPSControllerVM.croppedImage;
            var baseImg = newImg.split("base64,")[1];
            var requestParams = {
                "documentClass": "LT_AccountOpening_NPS",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Signature",
                "documentData": baseImg,
                "documentType": "Signature",
                "accountNo": "",
                "documentID": "",
                "commonId": "",
                "id": npsServices.applicantData.custsignid,
                "confirmFlag": signaturePreviewNPSControllerVM.applicantData.signConfirmFlag ? "Y" : "N"
            }
            if(npsServices.applicantData.custsignid !== '' && signaturePreviewNPSControllerVM.cancelconf || signaturePreviewNPSControllerVM.cancelconf){
                npsServices.uploadDocument(requestParams).then(function (response) {
                npsServices.applicantData.custsignid = response.data.docRef;
                    $state.go("menu.npsBankDetails");
                }, function (error) {
                    npsServices.showErrorMessage(error.responseMessage);
                });
            }else{
                 $state.go("menu.npsBankDetails");
            }
            
            

        }

        signaturePreviewNPSControllerVM.retrievePhotoCall = function () {
            var param = npsServices.applicantData.custsignid;

            npsServices.retrievePhoto(param).then(function (response) {

                signaturePreviewNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                npsServices.applicantData.customerSignature = signaturePreviewNPSControllerVM.croppedImage;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            signaturePreviewNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            signaturePreviewNPSControllerVM.disableTitle = false;

            if (!npsServices.applicantData.customerSignature) {
                if (!utilityService.isUndefined(npsServices.applicantData.custsignid)) {
                    signaturePreviewNPSControllerVM.retrievePhotoCall();
                }
            }
            else {
                signaturePreviewNPSControllerVM.croppedImage = npsServices.applicantData.customerSignature;

            }

            signaturePreviewNPSControllerVM.getBranchName();

            



        });

        return this;
    }
]);
