'use strict';

angularApp.controller('orphanLooksGreatNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        $ionicPopover) {

        var orplooksGreatNPSControllerVM = this;
        $scope.currentPage = "5";
        $scope.lastPage = "16";
        orplooksGreatNPSControllerVM.isPanNumMasked = false;
        orplooksGreatNPSControllerVM.isAadhaarNumMasked = false;
        
        orplooksGreatNPSControllerVM.countryOfBirthValue = npsServices.applicantData.countryOfBirthValue;
        orplooksGreatNPSControllerVM.orphCancelBtn = false;
        orplooksGreatNPSControllerVM.cancelconf = npsServices.applicantData.setCancelOrh;
         orplooksGreatNPSControllerVM.orpWhCancelBtn = false;
        orplooksGreatNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        orplooksGreatNPSControllerVM.sizeInfo = function ($event) {
           
            var orGetInfoMsg = "Document should be in jpg format. Size should be between 4KB - 12KB.";
                var template = '<ion-popover-view class="tooltiptext commonPopNps npsCustomerPic roboto-regular" style = "height: 65px;">' + '<ion-content>' +
                '<div class="text-left">' + orGetInfoMsg + '</div>' + '</ion-content>' + '</ion-popover-view>';

                var popover = $ionicPopover.fromTemplate(template, {
                    scope: $scope
                });
                    popover.show($event);
        }

        

        orplooksGreatNPSControllerVM.goBack = function () {

            $state.go("menu.npsOrpSelfi");
            orplooksGreatNPSControllerVM.orphCancelBtn = true;
            npsServices.applicantData.orphBCancelBtn = orplooksGreatNPSControllerVM.orphCancelBtn;
        }
 
        orplooksGreatNPSControllerVM.goNext = function () {
            
            
            var newImg = orplooksGreatNPSControllerVM.croppedImage;
            var baseImg = newImg.split("base64,")[1];
            var requestParams = {
                "documentClass": "LT_AccountOpening_NPS",
                "mimeType": "image/jpg",
                "documentTitle": "Customer Photo",
                "documentData": baseImg,
                "documentType": "Orphan Document",
                "accountNo": "",
                "documentID": "",
                "commonId": "",
                "id": npsServices.applicantData.orphanevidencedocid, // change value here
                "confirmFlag": orplooksGreatNPSControllerVM.applicantData.orphanconfirmflag  ? "Y" : "N"
            }
            
             if((npsServices.applicantData.orphanevidencedocid !== '' && orplooksGreatNPSControllerVM.cancelconf || orplooksGreatNPSControllerVM.cancelconf) || orplooksGreatNPSControllerVM.orpWhCancelBtn ){
                    npsServices.uploadDocument(requestParams).then(function (response) {
                npsServices.applicantData.orphanevidencedocid = response.data.docRef; // change variable here
                   npsServices.applicantData.orphanActivePage = true;
                    $state.go("menu.npsAddressDetails");
                
                
                }, function (error) {
                    npsServices.showErrorMessage(error.responseMessage);
                });
              }else{
                  $state.go("menu.npsAddressDetails");
              }
              

            
        }

     
        

        orplooksGreatNPSControllerVM.retrievePhotoCall = function () {
            var param = npsServices.applicantData.orphanevidencedocid;

            npsServices.retrievePhoto(param).then(function (response) {

                orplooksGreatNPSControllerVM.croppedImage = "data:image/jpeg;base64," + response.data.documentData;
                npsServices.applicantData.orphanPhoto = orplooksGreatNPSControllerVM.croppedImage;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        $scope.$on('$ionicView.beforeEnter', function () {
            orplooksGreatNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            orplooksGreatNPSControllerVM.disableTitle = false;
            orplooksGreatNPSControllerVM.croppedImage = "img/client-img.png";

            if (!npsServices.applicantData.orphanPhoto) {
                if (!utilityService.isUndefined(npsServices.applicantData.orphanevidencedocid)) {
                    orplooksGreatNPSControllerVM.retrievePhotoCall();
                }
            }
            else {
                orplooksGreatNPSControllerVM.croppedImage = npsServices.applicantData.orphanPhoto;

            }

            





        });

        return this;
    }
]);
