'use strict';

angularApp.controller('orphSelfieNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "cameraService",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        cameraService,
        $ionicPopover) {

        var orphSelfieNPSControllerVM = this;
        $scope.currentPage = "5";
        $scope.lastPage = "16";
        orphSelfieNPSControllerVM.isPanNumMasked = false;
        orphSelfieNPSControllerVM.isAadhaarNumMasked = false;
        npsServices.applicantData.setCancelConf = false;

        function initPage() {

            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                orphSelfieNPSControllerVM.okBtntext = translatedvalue;
            });

            orphSelfieNPSControllerVM.npsCountryBirth = npsServices.applicantData.countryOfBirthValue;
            

        }

        orphSelfieNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        orphSelfieNPSControllerVM.goBack = function () {
            $state.go("menu.npsParentDetails");
        }



        orphSelfieNPSControllerVM.sizeInfo = function ($event) {
          

           //for orphan documents
                

                var orGetInfoMsg = "Document should be in jpg format. Size should be between 4KB - 12KB.";
                var template = '<ion-popover-view class="tooltiptext commonPopNps npsCustomerPic roboto-regular" style = "height: 65px;">' + '<ion-content>' +
                '<div class="text-left">' + orGetInfoMsg + '</div>' + '</ion-content>' + '</ion-popover-view>';

                var popover = $ionicPopover.fromTemplate(template, {
                    scope: $scope
                });
                    popover.show($event);
                
        }

        /* Opens Mobile Camera */
        orphSelfieNPSControllerVM.openCamera = function () {
            cameraService.getnewImageAoNps().then(function (data) {
                orphSelfieNPSControllerVM.setImage(data);
                npsServices.applicantData.setCancelOrh = true;
                
               
                $state.go('menu.npsOrpLooksGreat');
            }, function (error) {
                if(error != "error"){
                var title = '';
                var template = error;
                var onTap = '';
                var buttontext = '<strong>' + orphSelfieNPSControllerVM.okBtntext + '</strong>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }else {
                var title1 = '';
                var template1 = '{{"SERVICE_ERR_MSG" | translate}}';
                var onTap1 = '';
                var buttontext1 = '<strong>' + orphSelfieNPSControllerVM.okBtntext + '</strong>';
                utilityService.showAlertModal(title1, template1, onTap1, $scope, $state, buttontext1);
                }
            });
        }

        /* Set the image captured in camera */
        orphSelfieNPSControllerVM.setImage = function (img) {
            npsServices.applicantData.orphanPhoto = img;
        }

        /* Fetch image from gallery */
        orphSelfieNPSControllerVM.chooseFromGallery = function () {
            cameraService.getImageFromGalleryAoNps().then(function (data) {
                npsServices.applicantData.setCancelOrh = true;
                orphSelfieNPSControllerVM.setImage(data);
                
                $state.go('menu.npsOrpLooksGreat');
            }, function (error) {
                if(error != "error"){
                    var title2 = '';
                    var template2 = error;
                    var onTap2 = '';
                    var buttontext2 = '<strong>' + orphSelfieNPSControllerVM.okBtntext + '</strong>';
                    utilityService.showAlertModal(title2, template2, onTap2, $scope, $state, buttontext2);
                    }else {
                    var title3 = '';
                    var template3 = '{{"SERVICE_ERR_MSG" | translate}}';
                    var onTap3 = '';
                    var buttontext3 = '<strong>' + orphSelfieNPSControllerVM.okBtntext + '</strong>';
                    utilityService.showAlertModal(title3, template3, onTap3, $scope, $state, buttontext3);
                    }
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });


        $scope.$on('$ionicView.beforeEnter', function () {
            orphSelfieNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            orphSelfieNPSControllerVM.orphCancelBtn = npsServices.applicantData.orphCancelBtn;
        });

        return this;
    }
]);
