'use strict';

angularApp.controller('reviewDetailsNPSController', ["$timeout",
  "$ionicPopup",
  "$state",
  "$scope",
  "utilityService",
  "$ionicHistory",
  "homeScreenService",
  "$ionicViewSwitcher",
  "npsServices",
  "$ionicPopover",
  "getAccountDetailsService",
  function ($timeout,
    $ionicPopup,
    $state,
    $scope,
    utilityService,
    $ionicHistory,
    homeScreenService,
    $ionicViewSwitcher,
    npsServices,
    $ionicPopover,
    getAccountDetailsService) {

    var reviewDetailsNPSControllerVM = this;
    $scope.currentPage = "16";
    $scope.lastPage = "16";
    reviewDetailsNPSControllerVM.isPanNumMasked = false;
    reviewDetailsNPSControllerVM.nomineeLabel = "Nominee";
    reviewDetailsNPSControllerVM.countryLabel = "Country";


    reviewDetailsNPSControllerVM.close = function () {
      $ionicViewSwitcher.nextDirection('back');
      $state.go('menu.homeScreen');
    }

    reviewDetailsNPSControllerVM.goBack = function () {
      $state.go("menu.contributionReview");
      npsServices.setReviewEditData('');
    }


    reviewDetailsNPSControllerVM.goNext = function () {

      npsServices.applicantData.reviewconsent = reviewDetailsNPSControllerVM.applicantData.reviewconsent;
      npsServices.applicantData.otpflag = reviewDetailsNPSControllerVM.applicantData.otpflag;

      var requestParams = {
        "reviewconsent": reviewDetailsNPSControllerVM.applicantData.reviewconsent ? "Y" : "N",
        "otpflag": reviewDetailsNPSControllerVM.applicantData.otpflag ? "Y" : "N"
      }

      npsServices.generateOTP(requestParams).then(function (response) {
        $state.go("menu.otpNps");

      }, function (error) {
        
        
         if(error.responseCode == "2022"){
              var timeBanner = $ionicPopup.show({
                        title: '',
                        template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/errorDndRed.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                      + error.responseMessage + '</span></div></div></div>',
                        scope: $scope,
                        cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function () {
                              homeScreenService.ishamburgerMenuRO = false;
                              homeScreenService.isInvestmentFlag = true;
                              getAccountDetailsService.tabIndex.tabIndex = 3;
                              $state.go('menu.accountOverviewMyBalance');
                              timeBanner.close();
                            }
                        }],
                    });
              }else{
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
              }
        });
      }

    reviewDetailsNPSControllerVM.edit = function (data) {
       if(reviewDetailsNPSControllerVM.npsFinalSuccessDetails && reviewDetailsNPSControllerVM.npsFinalSuccessDetails.leg){
              console.log('edit disabled');
      }else{
          switch (data) {

          case 'accountDetails':
            var requestData = {}; 

            if(!npsServices.accDetails){
              npsServices.setReviewEditData('accountDetails');

              npsServices.getAccountList(requestData).then(function (response) {
                  
                  npsServices.accDetails = response.data.accList;    
                  $state.go("menu.accountDetailsNPSView");

              }, function (error) {
                  utilityService.enableShowErrorMessage();
                  utilityService.showErrorMessage(error.responseMessage);
              });

            }else{
                npsServices.setReviewData('edit');
                  $state.go("menu.accountDetailsNPSView");
            }

            break;

          case 'personalDetails':
            npsServices.setReviewEditData('personalDetails');
            $state.go('menu.npsPersonalDetails');
            break;

          case 'parentsDetails':
            npsServices.setReviewEditData('parentsDetails');
            $state.go('menu.npsParentDetails');
            break;

          case 'addressDetails':
            npsServices.setReviewEditData('addressDetails');
            $state.go('menu.npsAddressDetails');
            break;

          case 'contactDetails':
            npsServices.setReviewEditData('contactDetails');
            $state.go('menu.npsContactDetails');
            break;

          case 'otherDetails':
            npsServices.setReviewEditData('otherDetails');
            $state.go('menu.npsOtherDetails');
            break;

          case 'bankDetailS':
            npsServices.setReviewEditData('bankDetailS');
            $state.go('menu.npsBankDetails');
            break;

          case 'nominationDetails':
            npsServices.setReviewEditData('nominationDetails');
            $state.go('menu.npsNominationDetails');
            break;

          case 'npsNominationDetailsTierII':
            npsServices.setReviewEditData('npsNominationDetailsTierII');
            $state.go('menu.npsNominationDetailsTierII');
            break;

          case 'pensionFund':
            npsServices.setReviewEditData('pensionFund');
            if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

              npsServices.fetchPensionFundList().then(function (response) {
                npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
                npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;
                $state.go("menu.npsPensionFundDetails");

              }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
              });

            } else {
              $state.go("menu.npsPensionFundDetails");
            }

            break;

          case 'pensionFundTier2':
            npsServices.setReviewEditData('pensionFundTier2');
            if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

              npsServices.fetchPensionFundList().then(function (response) {
                npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
                npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;
                $state.go('menu.npsPensionFundDetailsTierII');

              }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
              });

            } else {
              $state.go('menu.npsPensionFundDetailsTierII');
            }

            break;

          case 'fatcaDetails':
            npsServices.setReviewEditData('fatcaDetails');
            $state.go('menu.fatcaDetails');
            break;

          case 'contributionDetails':
            npsServices.setReviewEditData('contributionDetails');
            $state.go('menu.contributionDetails');
            break;

        }
      }
      
     
    }


    reviewDetailsNPSControllerVM.toggleGroup = function (group) {
      if (reviewDetailsNPSControllerVM.isGroupShown(group)) {
        reviewDetailsNPSControllerVM.shownGroup = null;
      } else {
        reviewDetailsNPSControllerVM.shownGroup = group;
      }
    };
    reviewDetailsNPSControllerVM.isGroupShown = function (group) {
      return reviewDetailsNPSControllerVM.shownGroup === group;
    };

    reviewDetailsNPSControllerVM.eyesOnFun = function (numForMasked, type) {
      if (type === "pan") {
        reviewDetailsNPSControllerVM.isPanNumMasked = false;
        reviewDetailsNPSControllerVM.applicantData.panNumber = reviewDetailsNPSControllerVM.oldPANValue;
      } else {
        reviewDetailsNPSControllerVM.isAadhaarNumMasked = false;
        reviewDetailsNPSControllerVM.applicantData.aadhaarNumber = reviewDetailsNPSControllerVM.oldAadhaarValue;
      }
    }

    reviewDetailsNPSControllerVM.eyesOffFun = function (numForMasked, type) {
      if (type === "pan") {
        reviewDetailsNPSControllerVM.isPanNumMasked = true;
        reviewDetailsNPSControllerVM.oldPANValue = numForMasked;
        reviewDetailsNPSControllerVM.applicantData.panNumber = utilityService.maskData(numForMasked, "front", 4);
      } else {
        reviewDetailsNPSControllerVM.isAadhaarNumMasked = true;
        reviewDetailsNPSControllerVM.oldAadhaarValue = numForMasked;
        reviewDetailsNPSControllerVM.applicantData.aadhaarNumber = utilityService.maskData(numForMasked, "front", 4);
      }
    }

    reviewDetailsNPSControllerVM.calculateTotalCharges = function () {
      reviewDetailsNPSControllerVM.charges = parseFloat(reviewDetailsNPSControllerVM.npsContributionReviewDetails.charges ? reviewDetailsNPSControllerVM.npsContributionReviewDetails.charges : 0) + parseFloat(reviewDetailsNPSControllerVM.npsContributionReviewDetails.registrationCharges ? reviewDetailsNPSControllerVM.npsContributionReviewDetails.registrationCharges : 0);
    }

    reviewDetailsNPSControllerVM.npsPensionTier1Total = function () {
      return parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.equity : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.corporateDebt : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.governmentBond : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund && reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIdata.alternativeFund : "0");
    }

    reviewDetailsNPSControllerVM.npsPensionTier2Total = function () {
      return parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.equity : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt : "0") + parseFloat(reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond && reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond != '.' ? reviewDetailsNPSControllerVM.npsPensionDetails.tierIIdata.governmentBond : "0");
    }




    $scope.$on('$ionicView.beforeEnter', function () {
      
      reviewDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);
      reviewDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
      reviewDetailsNPSControllerVM.npsOtherDetails = angular.copy(npsServices.npsOtherDetails);
      reviewDetailsNPSControllerVM.npsBankDetails = angular.copy(npsServices.npsBankDetails);
      reviewDetailsNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);

      if (npsServices.npsNominationDetails.nominees[0]) {
        reviewDetailsNPSControllerVM.nominees = angular.copy(npsServices.npsNominationDetails.nominees);
      }

     

      reviewDetailsNPSControllerVM.sameNomineeForTierII = npsServices.npsNominationDetails.sameNomineeForTierII;

      if (npsServices.npsNominationDetailsTierII.nominees[0]) {
        reviewDetailsNPSControllerVM.nomineesTierII = npsServices.npsNominationDetailsTierII.nominees;
      }

      reviewDetailsNPSControllerVM.npsPensionDetails = angular.copy(npsServices.npsPensionDetails);
      reviewDetailsNPSControllerVM.npsFatcaDetails = angular.copy(npsServices.npsFatcaDetails);
      if (npsServices.npsFatcaDetails.residentCountries[0]) {
        reviewDetailsNPSControllerVM.residentCountries = npsServices.npsFatcaDetails.residentCountries;

      }

      if(npsServices.npsFatcaDetails.residentCountries.length > 0){
        for(var i=0; i < npsServices.npsFatcaDetails.residentCountries.length; i++){
          if(npsServices.npsFatcaDetails.residentCountries[i].validTill == undefined || npsServices.npsFatcaDetails.residentCountries[i].validTill == null || npsServices.npsFatcaDetails.residentCountries[i].validTill == ""){
            reviewDetailsNPSControllerVM.residentCountries[i].validTill = "-"
          }
        }
      }

      reviewDetailsNPSControllerVM.npsContributionDetails = angular.copy(npsServices.npsContributionDetails);
      reviewDetailsNPSControllerVM.npsContributionReviewDetails = angular.copy(npsServices.npsContributionReviewDetails);
      reviewDetailsNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);

      reviewDetailsNPSControllerVM.calculateTotalCharges();
      reviewDetailsNPSControllerVM.eyesOffFun(reviewDetailsNPSControllerVM.applicantData.panNumber, 'pan');

     

      if(reviewDetailsNPSControllerVM.npsFatcaDetails.istaxresidentothers == 'Y'){
        reviewDetailsNPSControllerVM.npsFatcaDetails.taxResident = true; 
      }else{
        reviewDetailsNPSControllerVM.npsFatcaDetails.taxResident = false;
      }

    });


    return this;
  }
]);
