'use strict';

angularApp.controller('accountDetailsContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "$ionicViewSwitcher",
    "$ionicPopover",
    "homeScreenService",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        $ionicViewSwitcher,
        $ionicPopover,
        homeScreenService,
        npsContributionServices) {

        var accountDetailsContributionControllerVM = this;

        accountDetailsContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        accountDetailsContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        accountDetailsContributionControllerVM.goNext = function () {
            npsContributionServices.setNpsAccntData("makeContri");
            $state.go("menu.contriDetailsContribution");
        }

        accountDetailsContributionControllerVM.setNewSi = function () {
            npsContributionServices.setNpsAccntData("setNewSI");
            $state.go("menu.newStandingInstructionContribution");
        }

        //get user details 
        accountDetailsContributionControllerVM.getUserDetails = function () {
            for (var i = 0; i < accountDetailsContributionControllerVM.npsUserListB.length; i++) {
                if (accountDetailsContributionControllerVM.pranNoOnClick == accountDetailsContributionControllerVM.npsUserListB[i].pranNo) {
                    accountDetailsContributionControllerVM.nickName = accountDetailsContributionControllerVM.npsUserListB[i].nickName;
                    accountDetailsContributionControllerVM.getAllMasterData = accountDetailsContributionControllerVM.getAllMasterDataM;
                }
            }
        }


        //nps delete account confirmation popup
        accountDetailsContributionControllerVM.deleteAccntConfPopup = function () {
            var deleteAccntConfPopup = $ionicPopup.alert({
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + 'Are you sure you want to delink selected NPS account?' + '</span></div></div></div>',
                scope: $scope,
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup insurButton npsContriPopup',
                buttons: [

                    {
                        text: "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            deleteAccntConfPopup.close();
                        }
                    },

                    {
                        text: "Yes",
                        type: 'button-positive',
                        onTap: function () {
                            npsContributionServices.setNpsAccntData("fromNpsDeleteAccntConf");
                            $state.go("menu.otpLinkAccountContribution");
                        }
                    }
                ],
            });
        }

        //for delete NPS Account 
        accountDetailsContributionControllerVM.deleteNpsAccnt = function () {
            var isPran = {
                "pranNo": accountDetailsContributionControllerVM.pranNoOnClick,
                "cif": ""
            }

            npsContributionServices.checkSIExist(isPran).then(function (data) {
                 accountDetailsContributionControllerVM.response = data;
                 accountDetailsContributionControllerVM.deleteAccntConfPopup();
            }, function (error) {
                
                 if (error.isAlert) {
                    npsContributionServices.showAlertPopup('alert', error.responseMessage, "", "", "OK", "", "", "");
                    $state.go("menu.accountDetailsContribution");
                } else {
                    utilityService.showErrorMessage(error.responseMessage);
                }
                accountDetailsContributionControllerVM.breakupCalculated = false;
            });

        }


        //go to all SI list and check if SI list is available or not
        accountDetailsContributionControllerVM.goToSIList = function () {
            if (accountDetailsContributionControllerVM.getAllActiveSiList.length !== 0) {
                $state.go("menu.showAllSiContribution");
            } else {
                var popUpFCheckSiList = $ionicPopup.alert({
                    template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + 'There is no Standing Instruction (SI) against this PRAN' + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup insurButton npsContriPopup',
                    buttons: [

                        {
                            text: "OK",
                            type: 'button-positive',
                            onTap: function () {
                                popUpFCheckSiList.close();
                            }
                        }
                    ],
                });
            }

        }

        //get display SI list
        accountDetailsContributionControllerVM.getSIActiveList = function () {
            accountDetailsContributionControllerVM.pranNoOnClick = npsContributionServices.userAccntDetails.pranNoOnClick;
            var requestParams = {
                "pranNo": accountDetailsContributionControllerVM.pranNoOnClick,
                "cif": ""
            }

            npsContributionServices.getAllActiveSI(requestParams).then(function (data) {
                accountDetailsContributionControllerVM.getAllActiveSiData = data;
                accountDetailsContributionControllerVM.getAllActiveSiList = accountDetailsContributionControllerVM.getAllActiveSiData.activeSIList;
                
                console.log("getAllActiveSiList", accountDetailsContributionControllerVM.getAllActiveSiList);
                npsContributionServices.getAllActiveSiList = accountDetailsContributionControllerVM.getAllActiveSiList;


            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }


        //go to linked page from success page
        accountDetailsContributionControllerVM.goToNpsAccunt = function () {
            $state.go("menu.linkedAccountsContribution");
        }


        // on page landing
        $scope.$on('$ionicView.beforeEnter', function () {
            accountDetailsContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            accountDetailsContributionControllerVM.getAllMasterDataM = angular.copy(npsContributionServices.getAllMasterData);
            accountDetailsContributionControllerVM.npsUserListB = angular.copy(npsContributionServices.npsUserListB);
            accountDetailsContributionControllerVM.userAccntDetails = angular.copy(npsContributionServices.userAccntDetails);
            accountDetailsContributionControllerVM.pranNoOnClick = npsContributionServices.userAccntDetails.pranNoOnClick;
            accountDetailsContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            accountDetailsContributionControllerVM.npsChannelCode = accountDetailsContributionControllerVM.getAllnpsContWcmCont.npsChannelCode;
            //fetch data for other details

            accountDetailsContributionControllerVM.getUserDetails();
            accountDetailsContributionControllerVM.getSIActiveList();

            //check sectorCd description using sectorcode
            accountDetailsContributionControllerVM.npsAllSectorCode = accountDetailsContributionControllerVM.getAllnpsContWcmCont.npsSectorCode;
            for (var i = 0; i < accountDetailsContributionControllerVM.npsAllSectorCode.length; i++) {
                if (accountDetailsContributionControllerVM.getAllMasterData.tier1SectorCd == accountDetailsContributionControllerVM.npsAllSectorCode[i].value) {
                    accountDetailsContributionControllerVM.tier1SectorDes = accountDetailsContributionControllerVM.npsAllSectorCode[i].description;
                    npsContributionServices.tier1SectorDes = accountDetailsContributionControllerVM.tier1SectorDes;
                }

                if (accountDetailsContributionControllerVM.getAllMasterData.tier2SectorCd == accountDetailsContributionControllerVM.npsAllSectorCode[i].value) {
                    accountDetailsContributionControllerVM.tier2SectorDes = accountDetailsContributionControllerVM.npsAllSectorCode[i].description;
                    npsContributionServices.tier2SectorDes = accountDetailsContributionControllerVM.tier2SectorDes;
                }
            }



        });


        return this;
    }
]);
