'use strict';

angularApp.controller('contriDetailsContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "npsContributionServices",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        npsContributionServices,
        $ionicPopover) {

        var contriDetailsContributionControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        contriDetailsContributionControllerVM.validAccountFlag = false;
        contriDetailsContributionControllerVM.breakupCalculated = false;
        contriDetailsContributionControllerVM.npsContriAmntSection = true;
       
        contriDetailsContributionControllerVM.contributionAmountTierI = '';
        contriDetailsContributionControllerVM.contributionAmountTierII = '';
        contriDetailsContributionControllerVM.getNpsAccntData = npsContributionServices.getNpsAccntData();

        contriDetailsContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        contriDetailsContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

      

        //find tier 1 and tier 2 for users
        contriDetailsContributionControllerVM.getTierDetails = function () {
            contriDetailsContributionControllerVM.getTierData = [];

            if (contriDetailsContributionControllerVM.getAllMasterData.tier1SectorCd && contriDetailsContributionControllerVM.getAllMasterData.tier1PopRegNo) {
                contriDetailsContributionControllerVM.getTierData.push({
                    "id": 1,
                    "tierType": "Tier 1"
                });
            }

            if (contriDetailsContributionControllerVM.getAllMasterData.tier2SectorCd && contriDetailsContributionControllerVM.getAllMasterData.tier2PopRegNo) {
                contriDetailsContributionControllerVM.getTierData.push({
                    "id": 2,
                    "tierType": "Tier 2"
                });
            }

            if ((contriDetailsContributionControllerVM.getAllMasterData.tier1SectorCd && contriDetailsContributionControllerVM.getAllMasterData.tier1PopRegNo) && (contriDetailsContributionControllerVM.getAllMasterData.tier2SectorCd && contriDetailsContributionControllerVM.getAllMasterData.tier2PopRegNo)) {
                contriDetailsContributionControllerVM.getTierData.push({
                    "id": 3,
                    "tierType": "Tier 1 and Tier 2"
                });
            }

            if(contriDetailsContributionControllerVM.getTierData.length > 1){
                contriDetailsContributionControllerVM.defaultData = contriDetailsContributionControllerVM.getTierData[2];
                contriDetailsContributionControllerVM.tierChange();
            }else{
                contriDetailsContributionControllerVM.defaultData = contriDetailsContributionControllerVM.getTierData[0];
                contriDetailsContributionControllerVM.tierChange();
            }

        }



        //for info popup tier1

        var templateTier1 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="contriDetailsContributionControllerVM.getAllnpsWcmcont.tier1ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier1 = $ionicPopover.fromTemplate(templateTier1, {
            scope: $scope
        });

        contriDetailsContributionControllerVM.contributionTierInfoTier1 = function ($eventT) {
            $scope.popoverTier1.show($eventT);
        }


        //for info popup tier2

        var templateTier2 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="contriDetailsContributionControllerVM.getAllnpsWcmcont.tier2ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier2 = $ionicPopover.fromTemplate(templateTier2, {
            scope: $scope
        });

        contriDetailsContributionControllerVM.contributionTierInfoTier2 = function ($event) {
           $scope.popoverTier2.show($event);
        }


        //for info popup tier3

        var templateTier3 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup npsContriPopupTier2">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="contriDetailsContributionControllerVM.getAllnpsWcmcont.tier2ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier3 = $ionicPopover.fromTemplate(templateTier3, {
            scope: $scope
        });

        contriDetailsContributionControllerVM.contributionTierInfoTier3 = function ($event) {
           $scope.popoverTier3.show($event);
        }

      

        //for toggle arrow
        contriDetailsContributionControllerVM.clickOnArrow = function () {
            contriDetailsContributionControllerVM.npsContriAmntSection = !contriDetailsContributionControllerVM.npsContriAmntSection;
        }


        //for account list
        contriDetailsContributionControllerVM.getAccountList = function () {
            contriDetailsContributionControllerVM.balance = contriDetailsContributionControllerVM.accDetails[0].accountBalance;
            contriDetailsContributionControllerVM.accType = contriDetailsContributionControllerVM.accDetails[0].accountType;
            contriDetailsContributionControllerVM.accountNumber = contriDetailsContributionControllerVM.accDetails[0].accountNumber;
           
        }


        contriDetailsContributionControllerVM.showPop = function () {
            contriDetailsContributionControllerVM.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/npsContribution/contriDetailsContribution/accountListModal.html',
                scope: $scope
            });
        }
        contriDetailsContributionControllerVM.closePopup = function (index) {
            contriDetailsContributionControllerVM.popUp.close();
            contriDetailsContributionControllerVM.accountSelectedIndex = index;
            contriDetailsContributionControllerVM.balance = contriDetailsContributionControllerVM.accDetails[index].accountBalance;
            contriDetailsContributionControllerVM.accType = contriDetailsContributionControllerVM.accDetails[index].accountType;
            contriDetailsContributionControllerVM.accountNumber = contriDetailsContributionControllerVM.accDetails[index].accountNumber;
            contriDetailsContributionControllerVM.showSelect = false;
            contriDetailsContributionControllerVM.validateAccountNumber();
        }


        //for validate account number
        contriDetailsContributionControllerVM.validateAccountNumber = function () {
            contriDetailsContributionControllerVM.isContribution = "Y";
            var requestParams = {
                "cif": "",
                "makerId": "",
                "accNo": contriDetailsContributionControllerVM.accountNumber,
                "branchCode": "",
                "tprn":"",
                "isContribution":contriDetailsContributionControllerVM.isContribution
            }

            npsServices.validateAccountNumber(requestParams).then(function (data) {
                contriDetailsContributionControllerVM.validAccountFlag = true;
                console.log("Validate account success");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                contriDetailsContributionControllerVM.validAccountFlag = false;
            });
        }


        //tier change
        contriDetailsContributionControllerVM.tierChange = function (tierModel) {
            contriDetailsContributionControllerVM.contributionAmountTierI = '';
            contriDetailsContributionControllerVM.contributionAmountTierII = '';
            contriDetailsContributionControllerVM.validationErrorTierI = false;
            contriDetailsContributionControllerVM.validationErrorTierII = false;
            

            if(tierModel == undefined || tierModel == null ){
                contriDetailsContributionControllerVM.tierModel1 = contriDetailsContributionControllerVM.defaultData;
                contriDetailsContributionControllerVM.tierTypeSelected = contriDetailsContributionControllerVM.tierModel1;
                
            }else{
                contriDetailsContributionControllerVM.tierModel1 = tierModel;
            }

            contriDetailsContributionControllerVM.tierId = contriDetailsContributionControllerVM.tierModel1.id;
            contriDetailsContributionControllerVM.tierType = contriDetailsContributionControllerVM.tierModel1.tierType;
            

            contriDetailsContributionControllerVM.checkTierTypePassData();
            
            
            contriDetailsContributionControllerVM.checkActiveOrInactiveTier();
            console.log("tierID", contriDetailsContributionControllerVM.tierId);
            contriDetailsContributionControllerVM.breakupCalculated = false;
        }

        //check tiertypepass data
        contriDetailsContributionControllerVM.checkTierTypePassData = function () {
            if(contriDetailsContributionControllerVM.tierId == 3 ){
                //on select tier3 - and tier2 is inactive or deactive - 
                 if(contriDetailsContributionControllerVM.tier2Inactive || contriDetailsContributionControllerVM.tier2DeActive){
                    contriDetailsContributionControllerVM.tierTypePassData = 'Tier1';
                }else{
                    contriDetailsContributionControllerVM.tierTypePassData = 'Both';
                }
                
            }else if(contriDetailsContributionControllerVM.tierId == 2){
                contriDetailsContributionControllerVM.tierTypePassData = 'Tier2';
            }else{
                contriDetailsContributionControllerVM.tierTypePassData = 'Tier1';
            }
        }

        

        //go to next page
        contriDetailsContributionControllerVM.goNext = function () {
            npsContributionServices.contributionDetails.tierType = contriDetailsContributionControllerVM.tierType;
            npsContributionServices.userAccntDetails.balance = contriDetailsContributionControllerVM.balance;
            npsContributionServices.userAccntDetails.accType = contriDetailsContributionControllerVM.accType;
            npsContributionServices.userAccntDetails.accountNumber = contriDetailsContributionControllerVM.accountNumber;
            npsContributionServices.contributionDetails.tierId = contriDetailsContributionControllerVM.tierId;

            $state.go('menu.contriReviewDetailsContribution');
            

        }

        //for contribution charges
        contriDetailsContributionControllerVM.calculate = function () {
            
           
            
                npsContributionServices.contributionDetails.tierTypePassData = contriDetailsContributionControllerVM.tierTypePassData;

                //for tierI
                var amntTierI = parseInt(contriDetailsContributionControllerVM.contributionAmountTierI);
                contriDetailsContributionControllerVM.contriAmntTierI = amntTierI.toFixed(2);
                npsContributionServices.contributionDetails.contributionAmountTierI = contriDetailsContributionControllerVM.contributionAmountTierI;

                //for TierII
                var amntTierII = parseInt(contriDetailsContributionControllerVM.contributionAmountTierII);
                contriDetailsContributionControllerVM.contriAmntTierII =  amntTierII.toFixed(2);
                npsContributionServices.contributionDetails.contributionAmountTierII = contriDetailsContributionControllerVM.contributionAmountTierII;

                var requestParamsFcharges = {
                    "reqTier1Amount": npsContributionServices.contributionDetails.contributionAmountTierI,
                    "reqTier2Amount": npsContributionServices.contributionDetails.contributionAmountTierII,
                    "reqType": "Contribution",
                    "reqTierType": npsContributionServices.contributionDetails.tierTypePassData,
                    "launderingFlag": "",
                    "tprn": ""
                }

                npsContributionServices.fetchCharges(requestParamsFcharges).then(function (data) {
                
               
                    contriDetailsContributionControllerVM.contriCharges = data;
                    console.log("contriCharges",contriDetailsContributionControllerVM.contriCharges );

                    //for charges
                    var charges = parseInt(contriDetailsContributionControllerVM.contriCharges.charges);
                    contriDetailsContributionControllerVM.charges = charges.toFixed(2);
                    npsContributionServices.contributionDetails.charges = contriDetailsContributionControllerVM.charges;

                    //for gst
                    var gst = parseInt(contriDetailsContributionControllerVM.contriCharges.gst);
                    contriDetailsContributionControllerVM.gst = gst.toFixed(2);
                    npsContributionServices.contributionDetails.gst = contriDetailsContributionControllerVM.gst

                    //for total amount
                    var totalAmount = parseInt(contriDetailsContributionControllerVM.contriCharges.totalAmtReceivable);
                    contriDetailsContributionControllerVM.totalAmtReceivable = totalAmount.toFixed(2);
                    npsContributionServices.contributionDetails.totalAmtReceivable = contriDetailsContributionControllerVM.totalAmtReceivable;

                    
                    contriDetailsContributionControllerVM.breakupCalculated = true;
                
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                contriDetailsContributionControllerVM.breakupCalculated = false;
            });

        }

      

            contriDetailsContributionControllerVM.resetValidationTier = function (tierTypeVal) {
                    var minTierIval = parseInt(contriDetailsContributionControllerVM.getAllnpsContWcmCont.minTier1Amount);
                    var maxTierIval = parseInt(contriDetailsContributionControllerVM.getAllnpsContWcmCont.maxTier1Amount);

                    var minTierIIval = parseInt(contriDetailsContributionControllerVM.getAllnpsContWcmCont.minTier2Amount);
                    var maxTierIIval = parseInt(contriDetailsContributionControllerVM.getAllnpsContWcmCont.maxTier2Amount);

                if(tierTypeVal == 'contributionAmountTierI'){
                    if(contriDetailsContributionControllerVM.contributionNpsForm.contributionAmountTierI.$valid){
                        if((contriDetailsContributionControllerVM.contributionAmountTierI < minTierIval) 
                              || (contriDetailsContributionControllerVM.contributionAmountTierI > maxTierIval)){
                            contriDetailsContributionControllerVM.validationErrorTierI = true;
                            contriDetailsContributionControllerVM.validationErrorTierIMsg = 'minimum amount is Rs'+ minTierIval;
                            contriDetailsContributionControllerVM.breakupCalculated = false;
                        }else{
                            contriDetailsContributionControllerVM.validationErrorTierI = false;
                            
                        }
                    }

                    if(contriDetailsContributionControllerVM.contributionNpsForm.contributionAmountTierI.$invalid){
                        contriDetailsContributionControllerVM.validationErrorTierI = false;
                    }
                }

                if(tierTypeVal == 'contributionAmountTierII'){
                   if(contriDetailsContributionControllerVM.contributionNpsForm.contributionAmountTierII.$valid){
                        if((contriDetailsContributionControllerVM.contributionAmountTierII < minTierIIval) 
                            || (contriDetailsContributionControllerVM.contributionAmountTierII > maxTierIIval)){
                            contriDetailsContributionControllerVM.validationErrorTierII = true;
                            contriDetailsContributionControllerVM.validationErrorTierIIMsg = 'minimum amount is Rs'+ minTierIIval;
                            contriDetailsContributionControllerVM.breakupCalculated = false;
                        }else{
                            contriDetailsContributionControllerVM.validationErrorTierII = false;
                            
                        }
                   }

                   if(contriDetailsContributionControllerVM.contributionNpsForm.contributionAmountTierII.$invalid){
                        contriDetailsContributionControllerVM.validationErrorTierII = false;
                    }

                }
            }

            

        //check tier1 or tier2 inactive or not
        contriDetailsContributionControllerVM.checkActiveOrInactiveTier = function () {

             //for tier 1
            if (contriDetailsContributionControllerVM.contributionMatrix.onlyT1 == 'Allowed') {
                contriDetailsContributionControllerVM.tier1Inactive = false;
            } else {
                contriDetailsContributionControllerVM.tier1Inactive = true;
            }

            //for tier2 for inactive
            if ((contriDetailsContributionControllerVM.contributionMatrix.onlyT2 == 'Not Allowed' && contriDetailsContributionControllerVM.getAllMasterData.tier2StsCode == 'D') || 
               (contriDetailsContributionControllerVM.contributionMatrix.onlyT2 == 'Not Allowed' && contriDetailsContributionControllerVM.getAllMasterData.tier2StsCode == 'I') || 
               (contriDetailsContributionControllerVM.contributionMatrix.onlyT2 == 'Not Allowed' && contriDetailsContributionControllerVM.tierId == 2 && contriDetailsContributionControllerVM.getAllMasterData.tier2StsCode == 'F')) {
                contriDetailsContributionControllerVM.tier2ActDeact = 'Contribution can be made for Tier 1 only. Tier 2 is '+ contriDetailsContributionControllerVM.getAllMasterData.tier2Sts;
                contriDetailsContributionControllerVM.tier2ActiveStatus = true;
            } else {
                contriDetailsContributionControllerVM.tier2ActiveStatus = false;
            }
        }   


        $scope.$on('$ionicView.beforeEnter', function () {
            contriDetailsContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;

            contriDetailsContributionControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            contriDetailsContributionControllerVM.accDetails = angular.copy(npsServices.accDetails);
            contriDetailsContributionControllerVM.accountNumberService = npsContributionServices.userAccntDetails.accountNumber;
            contriDetailsContributionControllerVM.getAllMasterData = npsContributionServices.getAllMasterData;
            contriDetailsContributionControllerVM.contributionMatrix = contriDetailsContributionControllerVM.getAllMasterData.contributionMatrix;
           
            contriDetailsContributionControllerVM.getAccountList();

           

                if (contriDetailsContributionControllerVM.accDetails && contriDetailsContributionControllerVM.accountNumber) {
                    for (var i = 0; i < contriDetailsContributionControllerVM.accDetails.length; i++) {
                        if (contriDetailsContributionControllerVM.accDetails[i].accountNumber.trim() == contriDetailsContributionControllerVM.accountNumberService.trim()) {
                            contriDetailsContributionControllerVM.balance = contriDetailsContributionControllerVM.accDetails[i].accountBalance;
                            contriDetailsContributionControllerVM.accType = contriDetailsContributionControllerVM.accDetails[i].accountType;
                            contriDetailsContributionControllerVM.accountNumber = contriDetailsContributionControllerVM.accDetails[i].accountNumber;
                            contriDetailsContributionControllerVM.showSelect = false;
                        }
                    }

                }
            

            contriDetailsContributionControllerVM.validateAccountNumber();
            console.log("contriDetailsContributionControllerVM.tierSelection", contriDetailsContributionControllerVM.tierSelection);
            
            contriDetailsContributionControllerVM.makeContribution = npsContributionServices.makeContribution;
            contriDetailsContributionControllerVM.getTierDetails();
            
            contriDetailsContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            contriDetailsContributionControllerVM.getAllnpsWcmcont = contriDetailsContributionControllerVM.getAllnpsContWcmCont.data;

            contriDetailsContributionControllerVM.contributionDetails = angular.copy(npsContributionServices.contributionDetails);

            if(contriDetailsContributionControllerVM.getNpsAccntData == 'makeContri'){
                contriDetailsContributionControllerVM.contributionAmountTierI = '';
                contriDetailsContributionControllerVM.contributionAmountTierII = '';
                
                 contriDetailsContributionControllerVM.checkTierTypePassData();
                 contriDetailsContributionControllerVM.checkActiveOrInactiveTier();
                 if(contriDetailsContributionControllerVM.tierId){
                    
                    for (var i = 0; i < contriDetailsContributionControllerVM.getTierData.length; i++) {
                        if(contriDetailsContributionControllerVM.tierId == contriDetailsContributionControllerVM.getTierData[i].id){
                            contriDetailsContributionControllerVM.tierId = contriDetailsContributionControllerVM.getTierData[i].id;
                            contriDetailsContributionControllerVM.tierType = contriDetailsContributionControllerVM.getTierData[i].tierType;
                            contriDetailsContributionControllerVM.tierTypeSelected = contriDetailsContributionControllerVM.getTierData[i];
                        }
                    }
                }
            }else{
                if(contriDetailsContributionControllerVM.contributionDetails){
                    contriDetailsContributionControllerVM.contributionAmountTierI = contriDetailsContributionControllerVM.contributionDetails.contributionAmountTierI;
                    contriDetailsContributionControllerVM.contributionAmountTierII = contriDetailsContributionControllerVM.contributionDetails.contributionAmountTierII;
                }

                 if(contriDetailsContributionControllerVM.contributionDetails.tierId){
                    contriDetailsContributionControllerVM.tierId = contriDetailsContributionControllerVM.contributionDetails.tierId;
                    contriDetailsContributionControllerVM.checkTierTypePassData();
                    for (var i = 0; i < contriDetailsContributionControllerVM.getTierData.length; i++) {
                        if(contriDetailsContributionControllerVM.tierId == contriDetailsContributionControllerVM.getTierData[i].id){
                            contriDetailsContributionControllerVM.tierId = contriDetailsContributionControllerVM.getTierData[i].id;
                            contriDetailsContributionControllerVM.tierType = contriDetailsContributionControllerVM.getTierData[i].tierType;
                            contriDetailsContributionControllerVM.tierTypeSelected = contriDetailsContributionControllerVM.getTierData[i];
                        }
                    }
                }
            }

           
     
        });



        return this;
    }
]);
