'use strict';

angularApp.controller('contriReviewDetailsSuccessController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "openUrlInAppbroswerService",
    "npsContributionServices",
    "$q",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        openUrlInAppbroswerService,
        npsContributionServices,
        $q) {

        var contriReviewDetailsSuccessControllerVM = this;
        contriReviewDetailsSuccessControllerVM.isEmail = false;

        contriReviewDetailsSuccessControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        //go to linked page from success page
        contriReviewDetailsSuccessControllerVM.goToNpsAccunt = function () {
            $state.go("menu.linkedAccountsContribution");
        }



        contriReviewDetailsSuccessControllerVM.pranPdfDownload = function () {
            var respGetReceipt = {
                "cif": "",
                "pran": contriReviewDetailsSuccessControllerVM.userAccntDetails.pranNoOnClick,
                "isEmail": contriReviewDetailsSuccessControllerVM.isEmail
            }
            npsContributionServices.getNPSReciept(respGetReceipt).then(function (response) {
                var filename = response.data.pdfName;
                var content = response.data.base64Pdf;
                var contentType = "application/pdf";

                if (utilityService.isAndroidPlatform()) {
                    contriReviewDetailsSuccessControllerVM.android = true;
                    contriReviewDetailsSuccessControllerVM.folderpath = cordova.file.externalDataDirectory;
                }

                if (utilityService.isIOSPlatform()) {
                    contriReviewDetailsSuccessControllerVM.folderpath = cordova.file.documentsDirectory;
                    filename = filename + ".pdf";
                    openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "", "");
                }

                savebase64AsPDF(contriReviewDetailsSuccessControllerVM.folderpath, filename, content, contentType);



            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }

            return new Blob(byteArrays, { type: contentType });
        }


        function savebase64AsPDF(folderpath, filename, content, contentType) {
            // Convert the base64 string in a Blob
            var defer = $q.defer();
            var response = {};
            var DataBlob = b64toBlob(content, contentType);
            filename = filename + ".pdf";
            if (utilityService.isAndroidPlatform()) {
                if (device.version == 10) {
                    contriReviewDetailsSuccessControllerVM.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory, "") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                response = { folderpath: contriReviewDetailsSuccessControllerVM.popupFolderpath }
                                contriReviewDetailsSuccessControllerVM.showSuccessPopup(response.folderpath)
                                defer.resolve(response);
                            }, function (error) { defer.reject(error); });
                        }, function (error) { defer.reject(error); });
                    }, function (error) { defer.reject(error); });

                } else {
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                        fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                            contriReviewDetailsSuccessControllerVM.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    response = { folderpath: contriReviewDetailsSuccessControllerVM.popupFolderpath }
                                    contriReviewDetailsSuccessControllerVM.showSuccessPopup(response.folderpath)
                                    defer.resolve(response);
                                }, function (error) { defer.reject(error); });
                            });
                        });
                    });
                }
            }
        }
        contriReviewDetailsSuccessControllerVM.showSuccessPopup = function (folderpath) {
            var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{ folderpath: contriReviewDetailsSuccessControllerVM.popupFolderpath }"></div>';
            contriReviewDetailsSuccessControllerVM.downloadPopup = $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        contriReviewDetailsSuccessControllerVM.downloadPopup.close();

                    }
                }],
            });
        }

        contriReviewDetailsSuccessControllerVM.emailSend = function () {
            contriReviewDetailsSuccessControllerVM.isEmail = true;

            var respGetReceiptEmail = {
                "cif": "",
                "pran": contriReviewDetailsSuccessControllerVM.userAccntDetails.pranNoOnClick,
                "isEmail": contriReviewDetailsSuccessControllerVM.isEmail
            }

            npsContributionServices.getNPSReciept(respGetReceiptEmail).then(function (response) {
                var templateEmail = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
                contriReviewDetailsSuccessControllerVM.emailPopup = $ionicPopup.show({
                    title: '',
                    template: templateEmail,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function () {
                            contriReviewDetailsSuccessControllerVM.emailPopup.close();

                        }
                    }],
                });
            }, function (error) {
                utilityService.showAlertPopUp('error', error.responseMessage, "", "OK", "", "");
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            contriReviewDetailsSuccessControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;

            contriReviewDetailsSuccessControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            contriReviewDetailsSuccessControllerVM.getAllnpsWcmcont = contriReviewDetailsSuccessControllerVM.getAllnpsContWcmCont.data;
            contriReviewDetailsSuccessControllerVM.userAccntDetails = angular.copy(npsContributionServices.userAccntDetails)
            contriReviewDetailsSuccessControllerVM.successContributionCharges = angular.copy(npsContributionServices.successContributionCharges);

            contriReviewDetailsSuccessControllerVM.contributionDetails = angular.copy(npsContributionServices.contributionDetails);

            var contributionAmountTierI = contriReviewDetailsSuccessControllerVM.contributionDetails.contributionAmountTierI ? parseInt(contriReviewDetailsSuccessControllerVM.contributionDetails.contributionAmountTierI) : 0;
            var contributionAmountTierII = contriReviewDetailsSuccessControllerVM.contributionDetails.contributionAmountTierII ? parseInt(contriReviewDetailsSuccessControllerVM.contributionDetails.contributionAmountTierII) : 0;

            contriReviewDetailsSuccessControllerVM.contriSuccessTotal = contributionAmountTierI + contributionAmountTierII;
        });

        return this;
    }
]);
