'use strict';

angularApp.controller('linkedAccountsContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsContributionServices",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsContributionServices,
        npsServices) {

        var linkedAccountsContributionControllerVM = this;


        linkedAccountsContributionControllerVM.goBack = function () {
           
            $state.go("menu.fundsTransferLanding");
        }



        //fetchNpsUserList
        linkedAccountsContributionControllerVM.fetchNpsUserList = function () {
            utilityService.showSpinner();
            npsContributionServices.fetchNpsUserList().then(function (data) {
                linkedAccountsContributionControllerVM.fetchNpsUserList = data;

                if (linkedAccountsContributionControllerVM.fetchNpsUserList) {
                    utilityService.hideSpinner();
                }

                linkedAccountsContributionControllerVM.npsUserListB = linkedAccountsContributionControllerVM.fetchNpsUserList.beneficiaries;
                for (var i = 0; i < linkedAccountsContributionControllerVM.npsUserListB.length; i++) {
                    linkedAccountsContributionControllerVM.pranNo = linkedAccountsContributionControllerVM.npsUserListB[i].pranNo;
                }
                npsContributionServices.npsUserListB = linkedAccountsContributionControllerVM.npsUserListB;
                console.log("npsUserListB", npsContributionServices.npsUserListB);
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.hideSpinner();
            });
        }

        //fetch account details 
        linkedAccountsContributionControllerVM.getAccountList = function () {
            var requestData = {};
            utilityService.showSpinner();
            npsServices.getAccountList(requestData).then(function (response) {
                utilityService.hideSpinner();
                linkedAccountsContributionControllerVM.accDetails = response.data.accList;
                npsServices.accDetails = linkedAccountsContributionControllerVM.accDetails;


                console.log("npsServices.accDetails", npsServices.accDetails);


            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.hideSpinner();
            });


        }


        //fetchall wcm content
        linkedAccountsContributionControllerVM.getNpsContributionInfo = function () {
            utilityService.showSpinner();
            npsContributionServices.getNpsContributionInfo().then(function (data) {

                linkedAccountsContributionControllerVM.getAllnpsContWcmCont = data;
                if (linkedAccountsContributionControllerVM.getAllnpsContWcmCont) {
                    utilityService.hideSpinner();
                }
                npsContributionServices.getAllnpsContWcmCont = linkedAccountsContributionControllerVM.getAllnpsContWcmCont;
                console.log("getAllnpsContWcmCont", linkedAccountsContributionControllerVM.getAllnpsContWcmCont);

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.hideSpinner();
            });
        }

        //fetch pran data
        linkedAccountsContributionControllerVM.accountDetails = function (pranNoOnClick) {
            npsContributionServices.userAccntDetails.pranNoOnClick = pranNoOnClick;
            npsContributionServices.SIStngUserAccntDetails.pranNoOnClick = pranNoOnClick;

            if (npsContributionServices.userAccntDetails.pranNoOnClick || npsContributionServices.SIStngUserAccntDetails.pranNoOnClick) {
                utilityService.showSpinner();
                var requestParam = {
                    "pran": npsContributionServices.userAccntDetails.pranNoOnClick,
                }
                npsContributionServices.getPRANDetails(requestParam).then(function (data) {

                    linkedAccountsContributionControllerVM.getAllMasterData = data;
                    if (linkedAccountsContributionControllerVM.getAllMasterData) {
                        utilityService.hideSpinner();
                    }
                    npsContributionServices.getAllMasterData = linkedAccountsContributionControllerVM.getAllMasterData;
                    console.log("getPRANDetails", npsContributionServices.getAllMasterData);
                    $state.go("menu.accountDetailsContribution");
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.hideSpinner();
                });
            }
        }

        linkedAccountsContributionControllerVM.linkNewAccount = function () {
            npsContributionServices.setNpsAccntData('frLinkPran');
            $state.go("menu.newNpsContribution");
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            linkedAccountsContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;

            linkedAccountsContributionControllerVM.fetchNpsUserList();
            linkedAccountsContributionControllerVM.getNpsContributionInfo();

            linkedAccountsContributionControllerVM.getAccountList();

        });


        return this;
    }
]);
