'use strict';

angularApp.controller('newNpsContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        npsContributionServices) {

        var newNpsContributionControllerVM = this;
        $scope.currentPage = "6";
        $scope.lastPage = "16";
        newNpsContributionControllerVM.prancheckError = false;
        newNpsContributionControllerVM.validPranError = false;
        newNpsContributionControllerVM.getNpsAccntData = npsContributionServices.getNpsAccntData();

        newNpsContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }



        newNpsContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        //check pran mismatch 
        newNpsContributionControllerVM.pranCheckMismatch = function () {

            if (newNpsContributionControllerVM.enterPran && newNpsContributionControllerVM.confirmPran) {
                if (newNpsContributionControllerVM.enterPran !== newNpsContributionControllerVM.confirmPran) {
                    newNpsContributionControllerVM.prancheckError = true;

                } else {
                    newNpsContributionControllerVM.prancheckError = false;
                }
            }

        }


        newNpsContributionControllerVM.goNext = function () {
            newNpsContributionControllerVM.pranCheckMismatch();

            if (newNpsContributionControllerVM.prancheckError) {
                var pranMismatch = $ionicPopup.alert({
                    template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + 'PRAN mismatch' + '</span></div></div></div>',
                    scope: $scope,
                    cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                    buttons: [
                        {
                            text: "OK",
                            type: 'button-positive',
                            onTap: function () {
                                pranMismatch.close();

                            }
                        }
                    ],
                });
            } else {
                npsContributionServices.pranDetails.pranNo = newNpsContributionControllerVM.enterPran;
                npsContributionServices.pranDetails.confirmPranNo = newNpsContributionControllerVM.confirmPran;
                npsContributionServices.pranDetails.nickName = newNpsContributionControllerVM.nickname;
                npsContributionServices.pranDetails.consentFlag = newNpsContributionControllerVM.customerConsent;


                var requestParams = {
                    "pranNo": newNpsContributionControllerVM.enterPran,
                    "confirmPranNo": newNpsContributionControllerVM.confirmPran,
                    "nickName": newNpsContributionControllerVM.nickname,
                    "consentFlag": newNpsContributionControllerVM.customerConsent
                }
                npsContributionServices.validatePRAN(requestParams).then(function (response) {
                    newNpsContributionControllerVM.getUserList = response;
                    npsContributionServices.getUserList = newNpsContributionControllerVM.getUserList;
                    console.log("userlist", newNpsContributionControllerVM.getUserList);
                    $state.go('menu.newNpsReviewContribution');
                    //check tier active or not 


                }, function (error) {


                    if (error.isAlert) {
                        npsContributionServices.showAlertPopup('alert', error.responseMessage, "", "", "OK", "", "", "");
                        $state.go("menu.linkedAccountsContribution");
                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }

                });
            }

        }




        $scope.$on('$ionicView.beforeEnter', function () {
            newNpsContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;


            //fetch data for other details
            newNpsContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            newNpsContributionControllerVM.getAllnpsWcmcont = newNpsContributionControllerVM.getAllnpsContWcmCont.data;

            //check sectorCd description using sectorcode

            if (newNpsContributionControllerVM.getNpsAccntData == 'frLinkPran') {
                newNpsContributionControllerVM.enterPran = '';
                newNpsContributionControllerVM.confirmPran = '';
                newNpsContributionControllerVM.nickname = '';
                newNpsContributionControllerVM.customerConsent = '';
            } else {
                newNpsContributionControllerVM.enterPran = npsContributionServices.pranDetails.pranNo;
                newNpsContributionControllerVM.confirmPran = npsContributionServices.pranDetails.confirmPranNo;
                newNpsContributionControllerVM.nickname = npsContributionServices.pranDetails.nickName;
                newNpsContributionControllerVM.customerConsent = npsContributionServices.pranDetails.consentFlag;
            }


        });


        return this;
    }
]);
