'use strict';

angularApp.controller('newStandingInstructionContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "npsContributionServices",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        npsContributionServices,
        $ionicPopover) {

        var newStandingInstructionContributionControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        newStandingInstructionContributionControllerVM.validAccountFlag = false;
        newStandingInstructionContributionControllerVM.breakupCalculated = false;
        newStandingInstructionContributionControllerVM.npsContriAmntSection = true;

        newStandingInstructionContributionControllerVM.contributionAmountTierI = '';
        newStandingInstructionContributionControllerVM.contributionAmountTierII = '';

        newStandingInstructionContributionControllerVM.getNpsAccntData = npsContributionServices.getNpsAccntData();

        newStandingInstructionContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        newStandingInstructionContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }



        //find tier 1 and tier 2 for users
        newStandingInstructionContributionControllerVM.getTierDetails = function () {
            newStandingInstructionContributionControllerVM.getTierData = [];

            if (newStandingInstructionContributionControllerVM.getAllMasterData.tier1SectorCd && newStandingInstructionContributionControllerVM.getAllMasterData.tier1PopRegNo) {
                newStandingInstructionContributionControllerVM.getTierData.push({
                    "id": 1,
                    "tierType": "Tier 1"
                });
            }

            if (newStandingInstructionContributionControllerVM.getAllMasterData.tier2SectorCd && newStandingInstructionContributionControllerVM.getAllMasterData.tier2PopRegNo) {
                newStandingInstructionContributionControllerVM.getTierData.push({
                    "id": 2,
                    "tierType": "Tier 2"
                });
            }

            if ((newStandingInstructionContributionControllerVM.getAllMasterData.tier1SectorCd && newStandingInstructionContributionControllerVM.getAllMasterData.tier1PopRegNo) && (newStandingInstructionContributionControllerVM.getAllMasterData.tier2SectorCd && newStandingInstructionContributionControllerVM.getAllMasterData.tier2PopRegNo)) {
                newStandingInstructionContributionControllerVM.getTierData.push({
                    "id": 3,
                    "tierType": "Tier 1 and Tier 2"
                });
            }

            if (newStandingInstructionContributionControllerVM.getTierData.length > 1) {
                newStandingInstructionContributionControllerVM.defaultData = newStandingInstructionContributionControllerVM.getTierData[2];
                newStandingInstructionContributionControllerVM.tierChange();
            } else {
                newStandingInstructionContributionControllerVM.defaultData = newStandingInstructionContributionControllerVM.getTierData[0];
                newStandingInstructionContributionControllerVM.tierChange();
            }

        }



        //for info popup tier1

        var templateTier1 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="newStandingInstructionContributionControllerVM.getAllnpsWcmcont.tier1ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier1 = $ionicPopover.fromTemplate(templateTier1, {
            scope: $scope
        });

        newStandingInstructionContributionControllerVM.contributionTierInfoTier1 = function ($eventT) {
            $scope.popoverTier1.show($eventT);
        }


        //for info popup tier2

        var templateTier2 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup ">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="newStandingInstructionContributionControllerVM.getAllnpsWcmcont.tier2ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier2 = $ionicPopover.fromTemplate(templateTier2, {
            scope: $scope
        });

        newStandingInstructionContributionControllerVM.contributionTierInfoTier2 = function ($event) {
            $scope.popoverTier2.show($event);
        }

        //for info popup tier3

        var templateTier3 = '<ion-popover-view id="contriPopup" class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular npsContriPopup npsContriPopupTier2">' + '<ion-content>' +
            '<div class="text-left" ng-bind-html="newStandingInstructionContributionControllerVM.getAllnpsWcmcont.tier2ContributionContent"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popoverTier3 = $ionicPopover.fromTemplate(templateTier3, {
            scope: $scope
        });

        newStandingInstructionContributionControllerVM.contributionTierInfoTier3 = function ($event) {
            $scope.popoverTier3.show($event);
        }



        //for toggle arrow
        newStandingInstructionContributionControllerVM.clickOnArrow = function () {
            newStandingInstructionContributionControllerVM.npsContriAmntSection = !newStandingInstructionContributionControllerVM.npsContriAmntSection;
        }


        //for account list
        newStandingInstructionContributionControllerVM.getAccountList = function () {
            newStandingInstructionContributionControllerVM.balance = newStandingInstructionContributionControllerVM.accDetails[0].accountBalance;
            newStandingInstructionContributionControllerVM.accType = newStandingInstructionContributionControllerVM.accDetails[0].accountType;
            newStandingInstructionContributionControllerVM.accountNumber = newStandingInstructionContributionControllerVM.accDetails[0].accountNumber;
        }


        newStandingInstructionContributionControllerVM.showPop = function () {
            newStandingInstructionContributionControllerVM.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/npsContribution/newStandingInstructionContribution/accountListModal.html',
                scope: $scope
            });
        }
        newStandingInstructionContributionControllerVM.closePopup = function (index) {
            newStandingInstructionContributionControllerVM.popUp.close();
            newStandingInstructionContributionControllerVM.accountSelectedIndex = index;
            newStandingInstructionContributionControllerVM.balance = newStandingInstructionContributionControllerVM.accDetails[index].accountBalance;
            newStandingInstructionContributionControllerVM.accType = newStandingInstructionContributionControllerVM.accDetails[index].accountType;
            newStandingInstructionContributionControllerVM.accountNumber = newStandingInstructionContributionControllerVM.accDetails[index].accountNumber;
            newStandingInstructionContributionControllerVM.showSelect = false;
            newStandingInstructionContributionControllerVM.validateAccountNumber();
        }


        //for validate account number
        newStandingInstructionContributionControllerVM.validateAccountNumber = function () {
            newStandingInstructionContributionControllerVM.isContribution = "Y";
            var requestParams = {
                "cif": "",
                "makerId": "",
                "accNo": newStandingInstructionContributionControllerVM.accountNumber,
                "branchCode": "",
                "tprn": "",
                "isContribution": newStandingInstructionContributionControllerVM.isContribution
            }

            npsServices.validateAccountNumber(requestParams).then(function (data) {
                newStandingInstructionContributionControllerVM.validAccountFlag = true;
                console.log("Validate account success");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                newStandingInstructionContributionControllerVM.validAccountFlag = false;
            });
        }


        //tier change
        newStandingInstructionContributionControllerVM.tierChange = function (tierModel) {
            newStandingInstructionContributionControllerVM.contributionAmountTierI = '';
            newStandingInstructionContributionControllerVM.contributionAmountTierII = '';
            newStandingInstructionContributionControllerVM.validationErrorTierI = false;
            newStandingInstructionContributionControllerVM.validationErrorTierII = false;


            if (tierModel == undefined || tierModel == null) {
                newStandingInstructionContributionControllerVM.tierModel1 = newStandingInstructionContributionControllerVM.defaultData;
                newStandingInstructionContributionControllerVM.tierTypeSelected = newStandingInstructionContributionControllerVM.tierModel1;

            } else {
                newStandingInstructionContributionControllerVM.tierModel1 = tierModel;
            }


            newStandingInstructionContributionControllerVM.tierId = newStandingInstructionContributionControllerVM.tierModel1.id;
            newStandingInstructionContributionControllerVM.tierType = newStandingInstructionContributionControllerVM.tierModel1.tierType;
            newStandingInstructionContributionControllerVM.checkTierTypePassData();


            newStandingInstructionContributionControllerVM.checkActiveOrInactiveTier();
            console.log("tierID", newStandingInstructionContributionControllerVM.tierId);
            newStandingInstructionContributionControllerVM.breakupCalculated = false;
        }


        //check tiertypepass data
        newStandingInstructionContributionControllerVM.checkTierTypePassData = function () {
            if (newStandingInstructionContributionControllerVM.tierId == 3) {
                //on select tier3 - and tier2 is inactive or deactive - 
                if (newStandingInstructionContributionControllerVM.tier2Inactive || newStandingInstructionContributionControllerVM.tier2DeActive) {
                    newStandingInstructionContributionControllerVM.tierTypePassData = 'Tier1';
                } else {
                    newStandingInstructionContributionControllerVM.tierTypePassData = 'Both';
                }
            } else if (newStandingInstructionContributionControllerVM.tierId == 2) {
                newStandingInstructionContributionControllerVM.tierTypePassData = 'Tier2';
            } else {
                newStandingInstructionContributionControllerVM.tierTypePassData = 'Tier1';
            }
        }



        //go to next page
        newStandingInstructionContributionControllerVM.goNext = function () {
            npsContributionServices.SIStandingAccntDetails.tierType = newStandingInstructionContributionControllerVM.tierType;
            npsContributionServices.SIStngUserAccntDetails.balance = newStandingInstructionContributionControllerVM.balance;
            npsContributionServices.SIStngUserAccntDetails.accType = newStandingInstructionContributionControllerVM.accType;
            npsContributionServices.SIStngUserAccntDetails.accountNumber = newStandingInstructionContributionControllerVM.accountNumber;
            npsContributionServices.SIStandingAccntDetails.tierId = newStandingInstructionContributionControllerVM.tierId;
            npsContributionServices.SIStandingAccntDetails.tier2DeActive = newStandingInstructionContributionControllerVM.tier2DeActive;
            npsContributionServices.SIStandingAccntDetails.tier2Inactive = newStandingInstructionContributionControllerVM.tier2Inactive;
            $state.go('menu.setSiContribution');


        }

        //for contribution charges
        newStandingInstructionContributionControllerVM.calculate = function () {

            npsContributionServices.SIStandingAccntDetails.tierTypePassData = newStandingInstructionContributionControllerVM.tierTypePassData;

            //for tierI
            var amntTierI = parseInt(newStandingInstructionContributionControllerVM.contributionAmountTierI);
            newStandingInstructionContributionControllerVM.contriAmntTierI = amntTierI.toFixed(2);
            npsContributionServices.SIStandingAccntDetails.contributionAmountTierI = newStandingInstructionContributionControllerVM.contributionAmountTierI;

            //for TierII
            var amntTierII = parseInt(newStandingInstructionContributionControllerVM.contributionAmountTierII);
            newStandingInstructionContributionControllerVM.contriAmntTierII = amntTierII.toFixed(2);
            npsContributionServices.SIStandingAccntDetails.contributionAmountTierII = newStandingInstructionContributionControllerVM.contributionAmountTierII;

            var requestParamsFcharges = {
                "reqTier1Amount": npsContributionServices.SIStandingAccntDetails.contributionAmountTierI,
                "reqTier2Amount": npsContributionServices.SIStandingAccntDetails.contributionAmountTierII,
                "reqType": "SISetup",
                "reqTierType": npsContributionServices.SIStandingAccntDetails.tierTypePassData,
                "launderingFlag": "",
                "tprn": ""
            }

            npsContributionServices.fetchCharges(requestParamsFcharges).then(function (data) {


                newStandingInstructionContributionControllerVM.contriCharges = data;
                console.log("contriCharges", newStandingInstructionContributionControllerVM.contriCharges);

                //for charges
                var charges = parseInt(newStandingInstructionContributionControllerVM.contriCharges.charges);
                newStandingInstructionContributionControllerVM.charges = charges.toFixed(2);
                npsContributionServices.SIStandingAccntDetails.charges = newStandingInstructionContributionControllerVM.charges;

                //for gst
                var gst = parseInt(newStandingInstructionContributionControllerVM.contriCharges.gst);
                newStandingInstructionContributionControllerVM.gst = gst.toFixed(2);
                npsContributionServices.SIStandingAccntDetails.gst = newStandingInstructionContributionControllerVM.gst

                //for total amount
                var totalAmount = parseInt(newStandingInstructionContributionControllerVM.contriCharges.totalAmtReceivable);
                newStandingInstructionContributionControllerVM.totalAmtReceivable = totalAmount.toFixed(2);
                npsContributionServices.SIStandingAccntDetails.totalAmtReceivable = newStandingInstructionContributionControllerVM.totalAmtReceivable;

                newStandingInstructionContributionControllerVM.breakupCalculated = true;


            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                newStandingInstructionContributionControllerVM.breakupCalculated = false;
            });

        }


        //validation 
        newStandingInstructionContributionControllerVM.resetValidationTier = function (tierTypeVal) {
                var minTierIval = parseInt(newStandingInstructionContributionControllerVM.getAllnpsContWcmCont.minTier1Amount);
                var maxTierIval = parseInt(newStandingInstructionContributionControllerVM.getAllnpsContWcmCont.maxTier1Amount);

                var minTierIIval = parseInt(newStandingInstructionContributionControllerVM.getAllnpsContWcmCont.minTier2Amount);
                var maxTierIIval = parseInt(newStandingInstructionContributionControllerVM.getAllnpsContWcmCont.maxTier2Amount);

            if (tierTypeVal == 'contributionAmountTierI') {
                if (newStandingInstructionContributionControllerVM.contributionSIForm.contributionAmountTierI.$valid) {
                    if ((newStandingInstructionContributionControllerVM.contributionAmountTierI < minTierIval)
                       || (newStandingInstructionContributionControllerVM.contributionAmountTierI > maxTierIval)) {
                        newStandingInstructionContributionControllerVM.validationErrorTierI = true;
                        newStandingInstructionContributionControllerVM.validationErrorTierIMsg = 'minimum amount is Rs'+ minTierIval;
                        newStandingInstructionContributionControllerVM.breakupCalculated = false;
                    } else {
                        newStandingInstructionContributionControllerVM.validationErrorTierI = false;
                    }
                }

                if (newStandingInstructionContributionControllerVM.contributionSIForm.contributionAmountTierI.$invalid) {
                    newStandingInstructionContributionControllerVM.validationErrorTierI = false;
                }
            }

            if (tierTypeVal == 'contributionAmountTierII') {
                if (newStandingInstructionContributionControllerVM.contributionSIForm.contributionAmountTierII.$valid) {
                    if ((newStandingInstructionContributionControllerVM.contributionAmountTierII < minTierIIval) || 
                         (newStandingInstructionContributionControllerVM.contributionAmountTierII > maxTierIIval)) {
                        newStandingInstructionContributionControllerVM.validationErrorTierII = true;
                        newStandingInstructionContributionControllerVM.validationErrorTierIIMsg = 'minimum amount is Rs'+ minTierIIval;
                        newStandingInstructionContributionControllerVM.breakupCalculated = false;
                    } else {
                        newStandingInstructionContributionControllerVM.validationErrorTierII = false;
                    }
                }

                if (newStandingInstructionContributionControllerVM.contributionSIForm.contributionAmountTierII.$invalid) {
                    newStandingInstructionContributionControllerVM.validationErrorTierII = false;
                }

            }
        }



        //check tier1 or tier2 inactive or not
        newStandingInstructionContributionControllerVM.checkActiveOrInactiveTier = function () {
            //for tier 1
            if (newStandingInstructionContributionControllerVM.getAllMasterData.tier1Sts == 'Inactive' && newStandingInstructionContributionControllerVM.getAllMasterData.tier1StsCode == 'I') {
                newStandingInstructionContributionControllerVM.tier1Inactive = true;
            } else {
                newStandingInstructionContributionControllerVM.tier1Inactive = false;
            }

            //for tier 2 for inactive
            if (newStandingInstructionContributionControllerVM.getAllMasterData.tier2Sts == 'Inactive' && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsCode == 'I') {
                newStandingInstructionContributionControllerVM.tier2Inactive = true;
            } else {
                newStandingInstructionContributionControllerVM.tier2Inactive = false;
            }


            //for tier 2 for Deactive
            if (newStandingInstructionContributionControllerVM.getAllMasterData.tier2Sts == 'Deactive' && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsCode == 'D') {
                newStandingInstructionContributionControllerVM.tier2DeActive = true;
            } else {
                newStandingInstructionContributionControllerVM.tier2DeActive = false;
            }

            //for tier2 for freeze
            if ((newStandingInstructionContributionControllerVM.getAllMasterData.tier2Sts == 'Freeze' && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsCode == 'F'
                && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsReasonCd == '1' && newStandingInstructionContributionControllerVM.tierId == 2)
                || (newStandingInstructionContributionControllerVM.getAllMasterData.tier2Sts == 'Freeze' && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsCode == 'F'
                    && newStandingInstructionContributionControllerVM.getAllMasterData.tier2StsReasonCd == '2' && newStandingInstructionContributionControllerVM.tierId == 2)) {
                newStandingInstructionContributionControllerVM.tier2Freeze = true;
            } else {
                newStandingInstructionContributionControllerVM.tier2Freeze = false;
            }
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            newStandingInstructionContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;

            newStandingInstructionContributionControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            newStandingInstructionContributionControllerVM.accDetails = angular.copy(npsServices.accDetails);
            newStandingInstructionContributionControllerVM.accountNumberService = npsContributionServices.SIStngUserAccntDetails.accountNumber;
            newStandingInstructionContributionControllerVM.getAccountList();



            if (newStandingInstructionContributionControllerVM.accDetails && newStandingInstructionContributionControllerVM.accountNumber) {
                for (var i = 0; i < newStandingInstructionContributionControllerVM.accDetails.length; i++) {
                    if (newStandingInstructionContributionControllerVM.accDetails[i].accountNumber.trim() == newStandingInstructionContributionControllerVM.accountNumberService.trim()) {
                        newStandingInstructionContributionControllerVM.balance = newStandingInstructionContributionControllerVM.accDetails[i].accountBalance;
                        newStandingInstructionContributionControllerVM.accType = newStandingInstructionContributionControllerVM.accDetails[i].accountType;
                        newStandingInstructionContributionControllerVM.accountNumber = newStandingInstructionContributionControllerVM.accDetails[i].accountNumber;
                        newStandingInstructionContributionControllerVM.showSelect = false;
                    }
                }

            }


            newStandingInstructionContributionControllerVM.validateAccountNumber();
            console.log("newStandingInstructionContributionControllerVM.tierSelection", newStandingInstructionContributionControllerVM.tierSelection);
            newStandingInstructionContributionControllerVM.getAllMasterData = angular.copy(npsContributionServices.getAllMasterData);
            newStandingInstructionContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            newStandingInstructionContributionControllerVM.getAllnpsWcmcont = newStandingInstructionContributionControllerVM.getAllnpsContWcmCont.data;
            newStandingInstructionContributionControllerVM.SIStandingAccntDetails = angular.copy(npsContributionServices.SIStandingAccntDetails);
            newStandingInstructionContributionControllerVM.getTierDetails();


            if (newStandingInstructionContributionControllerVM.getNpsAccntData == 'setNewSI') {
                newStandingInstructionContributionControllerVM.contributionAmountTierI = '';
                newStandingInstructionContributionControllerVM.contributionAmountTierII = '';

                newStandingInstructionContributionControllerVM.checkTierTypePassData();
                newStandingInstructionContributionControllerVM.checkActiveOrInactiveTier();
                if (newStandingInstructionContributionControllerVM.tierId) {

                    for (var i = 0; i < newStandingInstructionContributionControllerVM.getTierData.length; i++) {
                        if (newStandingInstructionContributionControllerVM.tierId == newStandingInstructionContributionControllerVM.getTierData[i].id) {
                            newStandingInstructionContributionControllerVM.tierId = newStandingInstructionContributionControllerVM.getTierData[i].id;
                            newStandingInstructionContributionControllerVM.tierType = newStandingInstructionContributionControllerVM.getTierData[i].tierType;
                            newStandingInstructionContributionControllerVM.tierTypeSelected = newStandingInstructionContributionControllerVM.getTierData[i];
                        }
                    }
                }
            } else {
                if (newStandingInstructionContributionControllerVM.SIStandingAccntDetails) {
                    newStandingInstructionContributionControllerVM.contributionAmountTierI = newStandingInstructionContributionControllerVM.SIStandingAccntDetails.contributionAmountTierI;
                    newStandingInstructionContributionControllerVM.contributionAmountTierII = newStandingInstructionContributionControllerVM.SIStandingAccntDetails.contributionAmountTierII;
                }

                if (newStandingInstructionContributionControllerVM.SIStandingAccntDetails.tierId) {
                    newStandingInstructionContributionControllerVM.tierId = newStandingInstructionContributionControllerVM.SIStandingAccntDetails.tierId;
                    newStandingInstructionContributionControllerVM.checkTierTypePassData();
                    for (var i = 0; i < newStandingInstructionContributionControllerVM.getTierData.length; i++) {
                        if (newStandingInstructionContributionControllerVM.tierId == newStandingInstructionContributionControllerVM.getTierData[i].id) {
                            newStandingInstructionContributionControllerVM.tierId = newStandingInstructionContributionControllerVM.getTierData[i].id;
                            newStandingInstructionContributionControllerVM.tierType = newStandingInstructionContributionControllerVM.getTierData[i].tierType;
                            newStandingInstructionContributionControllerVM.tierTypeSelected = newStandingInstructionContributionControllerVM.getTierData[i];
                        }
                    }
                }
            }
        });



        return this;
    }
]);
