/**
*   @ngdoc config
*   @name angularApp.config : npsConfig
*   @description
*	configuration file for NPS module
*/

'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
    function ($stateProvider) {
        $stateProvider
            .state('menu.linkedAccountsContribution', {
                url: '/linkedAccountsContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_LINKED_ACCOUNTS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/linkedAccountsContribution/linkedAccountsContribution.html',
                        controller: 'linkedAccountsContributionController',
                        controllerAs: 'linkedAccountsContributionControllerVM',
                    }
                }
            })
            .state('menu.accountDetailsContribution', {
                url: '/accountDetailsContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_ACCOUNTS_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/accountDetailsContribution/accountDetailsContribution.html',
                        controller: 'accountDetailsContributionController',
                        controllerAs: 'accountDetailsContributionControllerVM',
                    }
                }
            })
            .state('menu.showAllSiContribution', {
                url: '/showAllSiContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_SHOW_ALL_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/accountDetailsContribution/showAllSiContribution.html',
                        controller: 'showAllSiContributionController',
                        controllerAs: 'showAllSiContributionControllerVM',
                    }
                }
            })

            .state('menu.showSIDetails', {
                url: '/showSIDetails',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_SHOW_SI_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/accountDetailsContribution/showSiContributionDetail.html',
                        controller: 'showSiContributionDetailController',
                        controllerAs: 'showSiContributionDetailControllerVM',
                    }
                }
            })

            .state('menu.deleteSISuccessPage', {
                url: '/deleteSISuccessPage',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_DELETE_SI_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/accountDetailsContribution/deletedSISuccess.html',
                        controller: 'accountDetailsContributionController',
                        controllerAs: 'accountDetailsContributionControllerVM',
                    }
                }
            })


            .state('menu.deleteAccntSuccess', {
                url: '/deleteAccntSuccess',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_DELETE_ACCNT_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/accountDetailsContribution/deleteAccntSuccess.html',
                        controller: 'deleteAccntSuccesscController',
                        controllerAs: 'deleteAccntSuccesscControllerVM',
                    }
                }
            })

            .state('menu.contriDetailsContribution', {
                url: '/contriDetailsContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/contriDetailsContribution/contriDetailsContribution.html',
                        controller: 'contriDetailsContributionController',
                        controllerAs: 'contriDetailsContributionControllerVM',
                    }
                }
            })
            .state('menu.contriReviewDetailsContribution', {
                url: '/contriReviewDetailsContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_REVIEW_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/contriReviewDetailsContribution/contriReviewDetailsContribution.html',
                        controller: 'contriReviewDetailsContributionController',
                        controllerAs: 'contriReviewDetailsContributionControllerVM',
                    }
                }
            })
            .state('menu.contriReviewDetailsSuccess', {
                url: '/contriReviewDetailsSuccess',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_REVIEW_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/contriReviewDetailsContribution/contriReviewDetailsSuccess.html',
                        controller: 'contriReviewDetailsSuccessController',
                        controllerAs: 'contriReviewDetailsSuccessControllerVM',
                    }
                }
            })
            .state('menu.otpContribution', {
                url: '/otpContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_OTP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/otpContribution/otpContribution.html',
                        controller: 'otpContributionController',
                        controllerAs: 'otpContributionControllerVM',
                    }
                }
            })
            .state('menu.finalSuccessContribution', {
                url: '/finalSuccessContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/finalSuccessContribution/finalSuccessContribution.html',
                        controller: 'finalSuccessContributionController',
                        controllerAs: 'finalSuccessContributionControllerVM',
                    }
                }
            })
            .state('menu.newNpsContribution', {
                url: '/newNpsContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_NEW_ACCOUNT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/newNpsContribution/newNpsContribution.html',
                        controller: 'newNpsContributionController',
                        controllerAs: 'newNpsContributionControllerVM',
                    }
                }
            })
            .state('menu.newNpsReviewContribution', {
                url: '/newNpsReviewContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_NEW_ACCOUNT_REVIEW'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/newNpsReviewContribution/newNpsReviewContribution.html',
                        controller: 'newNpsReviewContributionController',
                        controllerAs: 'newNpsReviewContributionControllerVM',
                    }
                }
            })
            .state('menu.otpLinkAccountContribution', {
                url: '/otpLinkAccountContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_LINKNEWACCOUNT_OTP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/otpLinkAccountContribution/otpLinkAccountContribution.html',
                        controller: 'otpLinkAccountContributionController',
                        controllerAs: 'otpLinkAccountContributionControllerVM',
                    }
                }
            })
            .state('menu.linkAccountSuccessContribution', {
                url: '/linkAccountSuccessContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_LINKNEWACCOUNT_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/linkAccountSuccessContribution/linkAccountSuccessContribution.html',
                        controller: 'linkAccountSuccessContributionController',
                        controllerAs: 'linkAccountSuccessContributionControllerVM',
                    }
                }
            })
            .state('menu.newStandingInstructionContribution', {
                url: '/newStandingInstructionContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_NEW_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/newStandingInstructionContribution/newStandingInstructionContribution.html',
                        controller: 'newStandingInstructionContributionController',
                        controllerAs: 'newStandingInstructionContributionControllerVM',
                    }
                }
            })
            .state('menu.setSiContribution', {
                url: '/setSiContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_SET_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/setSiContribution/setSiContribution.html',
                        controller: 'setSiContributionController',
                        controllerAs: 'setSiContributionControllerVM',
                    }
                }
            })
            .state('menu.reviewStandingInstructionContribution', {
                url: '/reviewStandingInstructionContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_REVIEW_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/reviewStandingInstructionContribution/reviewStandingInstructionContribution.html',
                        controller: 'reviewStandingInstructionContributionController',
                        controllerAs: 'reviewStandingInstructionContributionControllerVM',
                    }
                }
            })

            .state('menu.contriReviewSIStandingSuccess', {
                url: '/contriReviewSIStandingSuccess',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_SUCCESS_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/reviewStandingInstructionContribution/contriReviewSIStandingSuccess.html',
                        controller: 'contriReviewSIStandingSuccessController',
                        controllerAs: 'contriReviewSIStandingSuccessControllerVM',
                    }
                }
            })

            .state('menu.otpStandingInstructionContribution', {
                url: '/otpStandingInstructionContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_OTP_SI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/otpStandingInstructionContribution/otpStandingInstructionContribution.html',
                        controller: 'otpStandingInstructionContributionController',
                        controllerAs: 'otpStandingInstructionContributionControllerVM',
                    }
                }
            })
            .state('menu.createSiFinalSuccessContribution', {
                url: '/createSiFinalSuccessContribution',
                cache: false,
                data: {
                    pageId: 'NPS_CONTRIBUTION_CREATE_SI_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/npsContribution/createSiFinalSuccessContribution/createSiFinalSuccessContribution.html',
                        controller: 'createSiFinalSuccessContributionController',
                        controllerAs: 'createSiFinalSuccessContributionControllerVM',
                    }
                }
            })



    }
]);