'use strict';

angularApp.controller('otpLinkAccountContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsServices",
    "$ionicViewSwitcher",
    "fTSetOTPService",
    "constantConfig",
    "cryptoService",
    "autoOtpReadService",
    "npsContributionServices",
    "customerInfoService",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsServices,
        $ionicViewSwitcher,
        fTSetOTPService,
        constantConfig,
        cryptoService,
        autoOtpReadService,
        npsContributionServices,
        customerInfoService) {

        var otpLinkAccountContributionControllerVM = this;
        otpLinkAccountContributionControllerVM.isOtpFieldEmpty = false;
      
        otpLinkAccountContributionControllerVM.getNpsAccntData = npsContributionServices.getNpsAccntData();
        
        
        otpLinkAccountContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

      

        otpLinkAccountContributionControllerVM.goNext = function () {

            if (!otpLinkAccountContributionControllerVM.otp) {
				otpLinkAccountContributionControllerVM.isOtpFieldEmpty = true;
			} else {
				var reqParams = {};
				reqParams["otp"] = otpLinkAccountContributionControllerVM.otp;
				reqParams["mobile"] = $rootScope.mobileNo;

				fTSetOTPService.validateOTP(reqParams).then(function (resOtp) {
					if (resOtp.status.toLowerCase() == 'success') {

                        //for link nps account
                        if(otpLinkAccountContributionControllerVM.getNpsAccntData == 'fromnpsReview'){
                            var reqParamsUser = {
                                "pranNo": otpLinkAccountContributionControllerVM.pranDetails.pranNo,
                                "cif": "",
                                "nickName": otpLinkAccountContributionControllerVM.pranDetails.nickName,
                                "sectorCode": otpLinkAccountContributionControllerVM.getUserList.tier1SectorCd !=='' ? otpLinkAccountContributionControllerVM.getUserList.tier1SectorCd : otpLinkAccountContributionControllerVM.getUserList.tier2SectorCd,
                                "popSpNumber": "",
                                "statusCode": otpLinkAccountContributionControllerVM.getUserList.tier1StsCode !=='' ? otpLinkAccountContributionControllerVM.getUserList.tier1StsCode : otpLinkAccountContributionControllerVM.getUserList.tier2StsCode
                            };

                            npsContributionServices.linkNpsAccnt(reqParamsUser).then(function () {
                                $state.go("menu.linkAccountSuccessContribution");
                            }, function (error) {
                                
                                if(error.isAlert){
                                    npsContributionServices.showAlertPopup('alert', error.responseMessage, "", "", "OK", "", "", "");
                                    $state.go("menu.linkedAccountsContribution");
                                }else{
                                    utilityService.showErrorMessage(error.responseMessage);
                                    $state.go("menu.linkedAccountsContribution");
                                }
                            });
                        }

                        //for delete NpS account 
                        if(otpLinkAccountContributionControllerVM.getNpsAccntData == 'fromNpsDeleteAccntConf'){

                            var requestParamsFDeleteAccnt = {
                                "pranNo": otpLinkAccountContributionControllerVM.userAccntDetails.pranNoOnClick,
                                "cif": ""
                            }

                            npsContributionServices.deleteLinkedNPSAcc(requestParamsFDeleteAccnt).then(function (data) {
                                $state.go("menu.deleteAccntSuccess");
                            
                            }, function (error) {
                                utilityService.enableShowErrorMessage();
                                utilityService.showErrorMessage(error.responseMessage);
                                $state.go("menu.linkedAccountsContribution");
                            });
                        }


                         //for nps pre confirmation contribution review details page
                        if(otpLinkAccountContributionControllerVM.getNpsAccntData == 'fromNpsContriReviewDetails'){
                            
                             //UNCOMMENT BELOW CODE FOR API CALL 
                            var requestDataConfirmContri = {};
                            npsContributionServices.confirmContribution(requestDataConfirmContri).then(function (data) {
                                otpLinkAccountContributionControllerVM.successContributionCharges = data;
                                npsContributionServices.successContributionCharges = otpLinkAccountContributionControllerVM.successContributionCharges;
                                $state.go("menu.contriReviewDetailsSuccess"); 
                            
                            }, function (error) {
                                
                                if(error.isAlert){
                                    npsContributionServices.showAlertPopup('alert', error.responseMessage, "", "", "OK", "", "", "");
                                    $state.go("menu.fundsTransferLanding");
                                }else{
                                    utilityService.showErrorMessage(error.responseMessage);
                                    $state.go("menu.fundsTransferLanding");
                                }
                                
                                
                            });
                        }


                         //for review SI standing confirmation page
                        if(otpLinkAccountContributionControllerVM.getNpsAccntData == 'fromNpsContriSIStandingPage'){
                            
                           
                            var requestSetSI = {
                                "accNum": otpLinkAccountContributionControllerVM.SIStngUserAccntDetails.accountNumber,
                                "accType": otpLinkAccountContributionControllerVM.SIStngUserAccntDetails.accType,
                                "cif": "",
                                "cifCustName": "",
                                "custName": otpLinkAccountContributionControllerVM.getUserList.username,
                                "pranNo": otpLinkAccountContributionControllerVM.SIStngUserAccntDetails.pranNoOnClick,
                                "siDay": otpLinkAccountContributionControllerVM.setSIStandingDetails.siDay,
                                "siStartDate": moment(otpLinkAccountContributionControllerVM.setSIStandingDetails.siStartDate).format("DD-MM-YYYY"),
                                "siEndDate": "",
                                "siPeriod": otpLinkAccountContributionControllerVM.setSIStandingDetails.equityVal,
                                "gst": otpLinkAccountContributionControllerVM.SIStandingAccntDetails.gst,
                                "totalCharges": otpLinkAccountContributionControllerVM.SIStandingAccntDetails.charges,
                                "tier1ContriAmnt": otpLinkAccountContributionControllerVM.SIStandingAccntDetails.contributionAmountTierI,
                                "tier2ContriAmnt": otpLinkAccountContributionControllerVM.SIStandingAccntDetails.contributionAmountTierII,
                                "tierType": otpLinkAccountContributionControllerVM.SIStandingAccntDetails.tierType,
                                "sector": otpLinkAccountContributionControllerVM.getUserList.tier1SectorCd
                            };
                            npsContributionServices.setSI(requestSetSI).then(function (data) {
                                otpLinkAccountContributionControllerVM.siList = data;
                                npsContributionServices.siReceiptNumber = otpLinkAccountContributionControllerVM.siList.siReceiptNumber;
                                $state.go("menu.contriReviewSIStandingSuccess"); 
                            
                            }, function (error) {
                                utilityService.enableShowErrorMessage();
                                utilityService.showErrorMessage(error.responseMessage);
                                $state.go("menu.linkedAccountsContribution");
                            });
                        }
                           
                            
                        
					} else {
						utilityService.showErrorMessage(resOtp.status);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

           
        }

        otpLinkAccountContributionControllerVM.resendOTP = function () {
            otpLinkAccountContributionControllerVM.disableResend++;
			otpLinkAccountContributionControllerVM.otp = "";
			otpLinkAccountContributionControllerVM.isOtpFieldEmpty = false;
			var reqData = {};
			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.linkOtpNps;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.linkOtpNps).toString();
			fTSetOTPService.generateOTP(reqData).then(function (data) {
				if (utilityService.isAndroidPlatform()) {
					autoOtpReadService.startOtpReading().then(function (result) {
						otpLinkAccountContributionControllerVM.otp = result;
					}, function (error) {
						utilityService.showErrorMessage(error);
					});
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
          
        }


       


        $scope.$on('$ionicView.beforeEnter', function () {
            otpLinkAccountContributionControllerVM.disableResend = 0;
			otpLinkAccountContributionControllerVM.resendOTP();
            otpLinkAccountContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            otpLinkAccountContributionControllerVM.pranDetails = angular.copy(npsContributionServices.pranDetails);
            otpLinkAccountContributionControllerVM.getUserList = npsContributionServices.getUserList;
            
            otpLinkAccountContributionControllerVM.userAccntDetails = angular.copy(npsContributionServices.userAccntDetails);
            otpLinkAccountContributionControllerVM.SIStngUserAccntDetails = npsContributionServices.SIStngUserAccntDetails;
            otpLinkAccountContributionControllerVM.SIStandingAccntDetails = npsContributionServices.SIStandingAccntDetails;
            otpLinkAccountContributionControllerVM.setSIStandingDetails = npsContributionServices.setSIStandingDetails;
            otpLinkAccountContributionControllerVM.mobileNo = customerInfoService.customer.mobile;
        });


        return this;
    }
]);
