'use strict';

angularApp.controller('plOTPController', [
	"$state",
	"$scope",
	"$rootScope",
	"utilityService",
	"$ionicPopup",
	"personalLoanService",
	"getAccountDetailsService",
	"$ionicHistory",
	"clickStreamService",
	//"autoOtpReadService",
	"sampoornSurakshaService",
	"generalInsurenceHomeService",
	"homeScreenService",
	"$ionicSlideBoxDelegate",
  "constantConfig",
	"$timeout",
	"$ionicPopover",
	"$ionicScrollDelegate",
	"csatServices",
	function ($state,
		$scope,
		$rootScope,
		utilityService,
		$ionicPopup,
		personalLoanService,
		getAccountDetailsService,
		$ionicHistory,
		clickStreamService,
		//autoOtpReadService,
		sampoornSurakshaService,
		generalInsurenceHomeService,
		homeScreenService,
		$ionicSlideBoxDelegate,
		constantConfig,
		$timeout,
		$ionicPopover,
		$ionicScrollDelegate,
		csatServices) {

		var plOTPVm = this;
		$scope.resendLable = false;
		$scope.sendLable = true;
		plOTPVm.mobileNumber = $rootScope.mobileNo;
		$rootScope.currentPage = 4;
		$scope.isKavach = false;

		plOTPVm.nextEnable = function () {
			plOTPVm.showNameError = plOTPVm.otp.length;
			if (plOTPVm.otp === plOTPVm.otpValue) {
				plOTPVm.disableNext = false;
			} else {
				plOTPVm.disableNext = true;
			}
		}

		plOTPVm.goToBack = function () {
			plOTPVm.otp = "";
			$ionicHistory.goBack(-1);
		};

		plOTPVm.sendTxnIdData = function (transactionId) {
			clickStreamService.clickStreamData = transactionId;
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "APLY_LOAN_BTN"));
		}

		plOTPVm.goToNext = function () {
			var requestParams = {
				otp: plOTPVm.otp
			}
			personalLoanService.requestOtp(requestParams).then(function (data) {
				if (data.status.toLowerCase() == "success") {
					var transactionId = utilityService.getRandomNumber();
					var reqData = {
						product: personalLoanService.product,
						applicationAmount: personalLoanService.loanAmount,
						loanTerm: personalLoanService.duration,
						toDepositAccount: personalLoanService.personalLoanData.accountNumber,
						emiPaymentStartDate: personalLoanService.emiDate,
						termsNcondition: personalLoanService.checkTnC,
						txnId: transactionId
					}
					personalLoanService.applyForLoan(reqData).then(function (data) {
						personalLoanService.pdfContent = data.pdfContent;
						homeScreenService.isNotificationDataAvail = false;
						personalLoanService.storeRefNumber = data.storeRefNumber;
						plOTPVm.sendTxnIdData(reqData.txnId);
						plOTPVm.successData = data.responseStatus;
						if(csatServices.goldenJourneyCompletionCounter < 1){
							csatServices.whetherGoldenJourney("PAPL");
						}
						$state.go('menu.congratulations');
						plOTPVm.downloadPAPLTnC();
					}, function (error) {
						plOTPVm.sendTxnIdData(reqData.txnId);
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					utilityService.showErrorMessage(data.status);
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});			
		};

		plOTPVm.openPasswordInfo = function ($event) {
            plOTPVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            plOTPVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew passwordInfoPopup" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew" style="{{plOTPVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="plOTPVm.closePopover()"><img src="img/Close.png" alt="" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft50">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(plOTPVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
        }

		plOTPVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }		

		plOTPVm.downloadPAPLTnC = function () {
            var myBase64 = personalLoanService.pdfContent;
            var fileContentType = "application/pdf";
            var tcFileName = '';

            //added file name for kavach file get replaced with new file with same name.
            if (personalLoanService.categoryType == 'KAVACH') {
                tcFileName = "terms_and_condition_kavach";
            } else {
                if (utilityService.isAndroidPlatform()) {
                    var pdfTimestamp = new Date().getTime();
                    tcFileName = "terms_and_conditions_personal_loan_"+pdfTimestamp;
                }else{
                    tcFileName = "terms_and_conditions_personal_loan";
                }                
            }                       
            savebase64AsPDF(tcFileName + ".pdf", myBase64, fileContentType);
        }

		function savebase64AsPDF(filename, content, contentType) {
            plOTPVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
				if(device.version==10) {
                    const folderpath = cordova.file.externalDataDirectory;
                    plOTPVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
								$timeout(function() {
									plOTPVm.showDownloadPopUp();
								 }, 600);
                            }, function(e) {
								console.log(e);
							});
                        });
                    });
                } else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            plOTPVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
									$timeout(function() {
										plOTPVm.showDownloadPopUp();
									 }, 600);
                                }, function(e) {
									console.log(e);
								});
                            });
                        });
                    });
                }                        
            }
            if (utilityService.isIOSPlatform()){
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {

							fileWriter.onwrite = function(evt) {
								cordova.plugins.fileOpener2.open(
									finalPath,
									'application/pdf', {
										error: function (e) {
											console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
										},
										success: function () {
											console.log('file opened successfully');
										}
									}
								);
							};
							
                            fileWriter.write(DataBlob);
                        },  function(e) {
							console.log(e);
						});
                    });
                });
            }
        }

		plOTPVm.showDownloadPopUp = function() {
            //Show popup 
			var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:plOTPVm.popupFolderpath}"></div>';
			plOTPVm.downloadPopup = $ionicPopup.alert({
				title: '',
				template: template
			});
        }

		function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {                           
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });
        }

		plOTPVm.buySS = function () {
			sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
				sampoornSurakshaService.clearAll();
				sampoornSurakshaService.setPremiumDetails(data);
				$state.go('menu.ssPremiumCalculation');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		plOTPVm.buyPAI = function() {
			generalInsurenceHomeService.setGIProductsID("personal-accident-insurance-buy");
			generalInsurenceHomeService.setBackNavigationState("menu.congratulations");
			$state.go('menu.declaimer');
		}

		plOTPVm.knowMorePAI = function() {
			generalInsurenceHomeService.setGIProductsID("personal-accident-insurance-details");
			generalInsurenceHomeService.setBackNavigationState("menu.congratulations");
			$state.go('menu.declaimer');
		}


		plOTPVm.knowMore = function(){
			sampoornSurakshaService.getPolicyFeatures().then(function(data) {
				sampoornSurakshaService.setPolicyDetails(data);
				sampoornSurakshaService.setBuyNow(true);
				sampoornSurakshaService.isFromPapl = true;
				$state.go('menu.ssPolicyFeatures');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		plOTPVm.ok = function () {
			// plOTPVm.myPopup.close();
			plOTPVm.otp = "";
			utilityService.setCsatJournies("preApprovedPersonalLoans");
			getAccountDetailsService.accountOverviewData = "";
			$state.go('menu.accountOverviewMyBalance');
		};

		$scope.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		plOTPVm.sendOTP = function () {

			if (utilityService.isAndroidPlatform()) {
			// autoOtpReadService.startOtpReading().then(function (result) {
			// 	plOTPVm.otp = result;
			// 	// plOTPVm.goToNext();
			// }, function (error) {
			// 	console.log(error);
			// }, function (watchStatus) {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					console.log("PersonalLoanOTPSuccess")
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			//});
			} else {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					console.log("PersonalLoanOTPSuccess")
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


		}
		//Function call to redirect to cards journey
		plOTPVm.gotoCards = function(){
			getAccountDetailsService.tabIndex.tabIndex=5;
			homeScreenService.isCreditCardFlag = true;//set in order to load cards api
          	$state.go('menu.accountOverviewMyBalance');
		}

		plOTPVm.slideChanged = function (index) {
			$scope.slideIndex = index;
		};

		plOTPVm.resendOTP = function () {
			if (plOTPVm.isDisabledOTP) { return true }
			$scope.resendLable = true;
			$scope.sendLable = false;
			plOTPVm.otp = "";

			if (utilityService.isAndroidPlatform()) {
			// autoOtpReadService.startOtpReading().then(function (result) {
			// 	plOTPVm.otp = result;
			// 	// plOTPVm.goToNext();
			// }, function (error) {
			// 	console.log(error);
			// }, function (watchStatus) {
				var reqData = {}
			

				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					plOTPVm.otpValue = personalLoanService.otp;
					plOTPVm.isDisabledOTP = true;
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			//});
			} else {
				var reqData = {}
				personalLoanService.otpLoan(reqData).then(function (data) {
					personalLoanService.otp = data.otp;
					plOTPVm.otpValue = personalLoanService.otp;
					plOTPVm.isDisabledOTP = true;
				}, function (error) {
					autoOtpReadService.stopOtpReading();
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

		}

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.beforeEnter', function () {
			plOTPVm.disableNext = true;
			plOTPVm.loanAccountNumber = personalLoanService.loanAccountNumber;
			plOTPVm.storeRefNumber = personalLoanService.storeRefNumber;
			plOTPVm.amount = personalLoanService.loanAmount;
			plOTPVm.accNo = personalLoanService.personalLoanData.accountNumber;
			plOTPVm.otpValue = personalLoanService.otp;
			plOTPVm.isDisabledOTP = false;
			if(personalLoanService.categoryType == "KAVACH"){
				$scope.isKavach = true ;
			}else{
				$scope.isKavach = false;
			}
		});

		$scope.$on('$ionicView.loaded', function () {
			if ($state.current.name == "menu.plOTP") {
				plOTPVm.sendOTP();
			}
			if($state.current.name == "menu.congratulations"){
				var request = {
					"journey" : "PAPL"
				}
				sampoornSurakshaService.checkCustomerStatusPAPL(request).then(function (data) {
					if(data && data.customerFlag === 'true'){
						plOTPVm.showBanner = true;
						plOTPVm.bannerMsg = data.bannerMsg;
						plOTPVm.bannerImg = data.bannerImg;
					}else{
						plOTPVm.showBanner = false;
					}
					$ionicSlideBoxDelegate.update();
				}, function (error) {
				});

				generalInsurenceHomeService.loadPersonalAccidentBannerInfo().then(function (data) {
					for(var notif = 0 ; notif < data.notifications.length ; notif++) {
						if(data.notifications[notif].category == "PAPL_PAI") {
							var mssg = data.notifications[notif].message;
							plOTPVm.bannerMsgPAI = mssg.replace("Rs.","&#8377;");
							plOTPVm.bannerImgPAI = data.notifications[notif].offerImgMobile;
						} 
					}
					$ionicSlideBoxDelegate.update();
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				//wcm service call for cards papl image banner
				generalInsurenceHomeService.getCardswithPapl().then(function(data){
					 plOTPVm.cardImage = true; 
					 plOTPVm.cardsPaplBanner = data.imgUrl;
					 $ionicSlideBoxDelegate.update();
				}, function(error) {
					plOTPVm.cardImage = false;
					utilityService.showErrorMessage(error.responseMessage);
				});
				
			}
		});

		$scope.$on('$ionicView.afterEnter', function () {
			$ionicSlideBoxDelegate.update();
		});

		return this;
	}
]);
