'use strict';

angularApp.controller('userEligibilityController',
    ["$state",
        "$scope",
        "$filter",
        "regProcessWithAccNoService",
        "registerWithSimService",
        "$ionicSideMenuDelegate",
        "utilityService",
        function (
            $state,
            $scope,
            $filter,
            regProcessWithAccNoService,
            registerWithSimService,
            $ionicSideMenuDelegate,
            utilityService) {
            var userEligibilityVm = this;
            userEligibilityVm.regFlag = registerWithSimService.userRegFlag;
            userEligibilityVm.regOptionList = [
                {
                    regFlag: 'AVAILCF',
                    regImg: 'img/register/regWithSimA.svg',
                    regTitle: $filter('translate')('UE_REG_OP_TITLE1'),
                    regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE1'),
                    regDesc: $filter('translate')('UE_REG_OP_DESC1'),
                },
                {
                    regFlag: 'ACTCODE',
                    regImg: 'img/register/regWithSimB.svg',
                    regTitle: $filter('translate')('UE_REG_OP_TITLE2'),
                    regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE2'),
                    regDesc: $filter('translate')('UE_REG_OP_DESC2'),
                },
                {
                    regFlag: 'EXTNOINB',
                    regImg: 'img/register/regWithSimC.svg',
                    regTitle: $filter('translate')('UE_REG_OP_TITLE3'),
                    regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE3'),
                    regDesc: $filter('translate')('UE_REG_OP_DESC3'),
                }
            ];
            userEligibilityVm.proceedReg = function (type) {
                registerWithSimService.MLTCFAcc = '';
                var request = {
                    'inbUserConsent': true,
                }
                registerWithSimService.sendDeviceDetails(request).then(function (data) {
                    // Internet Banking
                    if (type === 'AVAILCF') {
                        // $state.go('menu.openNewDigitalAccount',{previousPage : "existingCustomer"});
                        $state.go('menu.inbLogin', { previousPage: "" });
                    }
                    // Activation Code
                    else if (type === 'ACTCODE') {
                        regProcessWithAccNoService.isActivationCodeBtnClicked = true;
                        $state.go("menu.regProcessMenu", { previousPage: "" });
                    }
                    // Register with ATM or Account Details
                    else if (type === 'EXTNOINB') {
                        $state.go('menu.haveInternetBanking');
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });


            }
            registerWithSimService.getINBConsentContent().then(function (data) {

                userEligibilityVm.featuresJson = data.inbConsentContent;
                userEligibilityVm.maxCustAge = data.maxCustAge;
                registerWithSimService.maxCustAge = userEligibilityVm.maxCustAge;

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function () {
                $ionicSideMenuDelegate.canDragContent(false)
            });

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function () {
                $ionicSideMenuDelegate.canDragContent(false);
            });

            //any cleanup needs to be done here: executes everytime when page is left
            $scope.$on('$ionicView.afterLeave', function () {
                $ionicSideMenuDelegate.canDragContent(false)
            });

            userEligibilityVm.goToConsentPage = function () {
                if (userEligibilityVm.regFlag == 'ACTCODE') {
                    regProcessWithAccNoService.isActivationCodeBtnClicked = true;
                    $state.go("menu.regProcessMenu", { previousPage: "" });
                } else if (userEligibilityVm.regFlag === 'AVAILCF') {
                    $state.go('menu.inbLogin', { previousPage: "" });
                } else {
                    $state.go('menu.consent');
                }
            }

            userEligibilityVm.goBacktoPrevious = function () {
                $state.go('menu.userEligibility');
            }

            userEligibilityVm.cancelConsent = function () {
                $state.go('menu.landingWithOptions');
            }
        }]);