'use strict';
angularApp.controller('quickPayTransactionsController', [
    "$state",
    "$scope",
    "utilityService",
    "customerInfoService", "$filter", "quickPayService","constantConfig","loggedInUserService",
    function ($state, $scope, utilityService, customerInfoService, $filter, quickPayService, constantConfig, loggedInUserService) {

        var quickPayTransactionsVm = this;

         quickPayTransactionsVm.goToQuickPayLanding = function(){
            if(quickPayTransactionsVm.qpayType == 'paycontact'){
                $state.go('menu.payToContactLanding');
            }else{
                $state.go('menu.quickPayLanding');
            }
        }

        quickPayTransactionsVm.goToTransactionListPage = function(){
             $state.go('menu.quickPayTransactions');
        }

        //for share 
        quickPayTransactionsVm.share = function () {
            html2canvas(document.getElementById("sharedivTransaction"), {background: '#FFFFFF', 
                onrendered: function (canvas) {
                    var img = canvas.toDataURL("image/jpg");
                    var filename ="";

                    var myBaseString = img;
                    var block = myBaseString.split(";");
                    var myBase64 = block[1].split(",")[1];
                    var contentType = "image/jpg";
                    
                     
                    //for cache issue
                    if (utilityService.isAndroidPlatform()) {
                        var imgTimestamp = new Date().getTime();
                        filename = "Payment Receipt" + imgTimestamp + ".jpg";
                    } else {
                        filename = "Payment Receipt.jpg";
                    }

                    //check device 
                     if (device.platform.toLowerCase() == 'ios') {
                        var successCallback = function (data) {
                            console.log("Success");
                        }
                        var failureCallback = function (error) {
                            console.log("failure");
                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    }else{
                        quickPayTransactionsVm.savebase64AsImageFile(filename, myBase64, contentType);
                    }
                    
                }
            });
        }

        //share receipt
        quickPayTransactionsVm.savebase64AsImageFile = function ( filename, content, contentType) {
                var DataBlob = quickPayTransactionsVm.b64toBlob(content, contentType);
                if (device.version == 10) {
                    var folderpath = cordova.file.externalDataDirectory;
                    window.resolveLocalFileSystemURL(folderpath, function (dir) {
                        quickPayTransactionsVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                quickPayTransactionsVm.downloadOrShare();
                            }, function () {
                                utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                } else {
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                        fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                            quickPayTransactionsVm.popupFolderpath = dir.nativeURL + filename;
                            dir.getFile(filename, { create: true }, function (file) {
                                file.createWriter(function (fileWriter) {
                                    fileWriter.write(DataBlob);
                                    quickPayTransactionsVm.downloadOrShare();
                                }, function () {
                                    utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                                });
                            });
                        });
                    });
                }
            }

        quickPayTransactionsVm.downloadOrShare = function () {
            var options = {
                message: 'Payment receipt via YONO SBI', // not supported on some apps (i.e. Facebook, Instagram)
                subject: 'Share Your Payment receipt : ',// Subject. for email
                files: [quickPayTransactionsVm.popupFolderpath], // an array of filenames either locally or remotely
                chooserTitle: 'Share Your Payment receipt' // Android only, you can override the default share sheet title
            };

            var onSuccess = function (result) {
				console.log(result);
            };
            var onError = function (msg) {
				console.log(msg);
            }
            window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
        }

        quickPayTransactionsVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });
            
        };


        
        quickPayTransactionsVm.payFromTransList = function(transaction){
            quickPayService.payFromTransList = true;
            quickPayService.paytoFavClick = false;
            quickPayService.payFromTransListData = transaction;
            if(quickPayService.payFromTransListData.beneficiaryType == 'Contact'){
                $state.go('menu.payToContactDetails');
            }else if(quickPayService.payFromTransListData.beneficiaryType == 'VPA_Contact'){
                $state.go('menu.payToContactUPIDetails');
            }else if(quickPayService.payFromTransListData.beneficiaryType == 'VPA' || quickPayService.payFromTransListData.beneficiaryType == 'vpa' ){
                $state.go('menu.payToUPIDetails');
            }else{
                $state.go('menu.quickPayLanding');
            }   
            
        }

        quickPayTransactionsVm.goToTransaction = function () {
            var params = { "methodName": "getTransactionList" };
            quickPayService.addTofavorite(params).then(function (data) {

              quickPayService.transactionLists = data.beneficiaryList;
              quickPayTransactionsVm.transactionLists = quickPayService.transactionLists;

              quickPayTransactionsVm.getTransactionListFromExisting();
               
                 
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //for get new transaction list for different scenarios - pay to contact and beneficiary
        quickPayTransactionsVm.getTransactionListFromExisting = function () {
            quickPayTransactionsVm.newBenForPayToCon = [];
            quickPayTransactionsVm.newBenForAccnt = [];
            quickPayTransactionsVm.newBenForOther = [];

                for (var l = 0; l < quickPayTransactionsVm.transactionLists.length; l++) {
                    if(quickPayTransactionsVm.transactionLists[l].beneficiaryType == "VPA" || quickPayTransactionsVm.transactionLists[l].beneficiaryType == "Contact" 
                        || quickPayTransactionsVm.transactionLists[l].beneficiaryType == "VPA_Contact") {
                        quickPayTransactionsVm.newBenForPayToCon.push(quickPayTransactionsVm.transactionLists[l]);
                    }else if(quickPayTransactionsVm.transactionLists[l].beneficiaryType == "Account"){
                        quickPayTransactionsVm.newBenForAccnt.push(quickPayTransactionsVm.transactionLists[l]);
                    }else{
                        quickPayTransactionsVm.newBenForOther.push(quickPayTransactionsVm.transactionLists[l]);
                    }   
                }

                quickPayService.newBenForPayToCon = quickPayTransactionsVm.newBenForPayToCon;
                quickPayService.newBenForAccnt = quickPayTransactionsVm.newBenForAccnt;
                quickPayService.newBenForOther = quickPayTransactionsVm.newBenForOther;
        }

        //go to transaction detail page
        quickPayTransactionsVm.goToTransDetails = function(transDet){
            quickPayService.transDetails = transDet;
            $state.go('menu.quickPayTranDetail');
            
        }

        //on page load
        $scope.$on('$ionicView.beforeEnter', function () {
            
            quickPayService.payFromTransListData = [];
            if (quickPayService.transactionListsNew.length > 0) {
                quickPayTransactionsVm.transactionLists = quickPayService.transactionListsNew;
                quickPayTransactionsVm.getTransactionListFromExisting();
            }
            else {
                quickPayTransactionsVm.goToTransaction();

            }
            quickPayTransactionsVm.colorCode = quickPayService.colorCode;
            quickPayTransactionsVm.transDetails = quickPayService.transDetails;
            console.log("quickPayTransactionsVm.transDetails", quickPayTransactionsVm.transDetails);
            
            quickPayTransactionsVm.qpayType = loggedInUserService.qpayType;
           
        });

        return this;
    }


]);


