'use strict';
angularApp.controller('quickPaymentSuccessController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "loggedInUserService",
    "cryptoService",
    "mPinLoginService",
    "quickPayService",
    "$ionicModal",
    "constantConfig",
    "bhimUpiService",
    "$stateParams",
    "clickStreamService",
    "getAccountDetailsService",
    "clearServiceDataService",
    "AdapterUtils",
    "appRateService",
    "csatService","csatServices",
    function ($state,
        $scope,
        $ionicPopup,
        $translate,
        $ionicHistory,
        utilityService,
        loggedInUserService,
        cryptoService,
        mPinLoginService,
        quickPayService,
        $ionicModal,
        constantConfig,
        bhimUpiService,
        $stateParams,
        clickStreamService,
        getAccountDetailsService,
        clearServiceDataService,
        AdapterUtils,
        appRateService,
        csatService,csatServices) {

        var quickPaymentSuccessVm = this;
        quickPaymentSuccessVm.getCSATDetails = function () {
            mPinLoginService.isLoggedIn = false;
            quickPaymentSuccessVm.sessionLogout();

        }

        quickPaymentSuccessVm.sessionLogout = function () {
            AdapterUtils.sessionLogout().then(
                function (response) {
                    loggedInUserService.logoutUser(true);
                },
                function (error) {
                    loggedInUserService.logoutUser(true);
                }
            );
        }

       

        //for share 
        quickPaymentSuccessVm.share = function () {
            html2canvas(document.getElementById("sharedivSuccess"), {background: '#FFFFFF',
                onrendered: function (canvas) {
                    var img = canvas.toDataURL("image/jpg");
                    var filename = "";

                    var myBaseString = img;
                    var block = myBaseString.split(";");
                    var myBase64 = block[1].split(",")[1];

                    var contentType = "image/jpg";
                    

                     //for cache issue
                    if (utilityService.isAndroidPlatform()) {
                        var imgTimestamp = new Date().getTime();
                        filename = "Payment Receipt" + imgTimestamp + ".jpg";
                    } else {
                        filename = "Payment Receipt.jpg";
                    }

                    if (device.platform.toLowerCase() == 'ios') {
                        var successCallback = function (data) {
                            console.log("Success");
                        }
                        var failureCallback = function (error) {
                            console.log("failure");
                        }
                        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
                    }else{
                         quickPaymentSuccessVm.savebase64AsImageFile(filename, myBase64, contentType);
                    }
                   
                }
            });
        }

        //share receipt
        quickPaymentSuccessVm.savebase64AsImageFile = function (filename, content, contentType) {
            var DataBlob = quickPaymentSuccessVm.b64toBlob(content, contentType);
            if (device.version == 10) {
                var folderpath = cordova.file.externalDataDirectory;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    quickPaymentSuccessVm.popupFolderpath = dir.nativeURL + filename;
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                            quickPaymentSuccessVm.downloadOrShare();
                        }, function () {
                            utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                        });
                    });
                });
            } else {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                    fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
                        quickPaymentSuccessVm.popupFolderpath = dir.nativeURL + filename;
                        dir.getFile(filename, { create: true }, function (file) {
                            file.createWriter(function (fileWriter) {
                                fileWriter.write(DataBlob);
                                quickPaymentSuccessVm.downloadOrShare();
                            }, function () {
                                utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
                            });
                        });
                    });
                });
            }
        }

        quickPaymentSuccessVm.downloadOrShare = function () {
            var options = {
                message: 'Payment receipt via YONO SBI', // not supported on some apps (i.e. Facebook, Instagram)
                subject: 'Share Your Payment receipt : ',// Subject. for email
                files: [quickPaymentSuccessVm.popupFolderpath], // an array of filenames either locally or remotely
                chooserTitle: 'Share Your Payment receipt' // Android only, you can override the default share sheet title
            };

            var onSuccess = function (result) {
				console.log(result);
            };
            var onError = function (msg) {
				console.log(msg);
            }
            window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
        }

        quickPaymentSuccessVm.b64toBlob = function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });
            
        };


        quickPaymentSuccessVm.goToUserLogin = function () {
            if (quickPaymentSuccessVm.isSuccess) {
                
                clearServiceVars();
                if(csatServices.getGoldenJourney() && csatServices.showNewCsatScreen && csatServices.goldenJourneyCompletionCounter > 0){
                    loggedInUserService.manageLocalData('',"CSATSampleData2.json",false,'read').then(function(res){
                        if(parseInt(res.golden_JourneyCompletionCounter) >= csatServices.highestGoldenJourneyCounter){
                            $state.go('menu.csatNPSCESfeedbackMatters');
                        }else{
                            $state.go('menu.feedbackPage');
                        }
                    },function(e){
                        console.log("error----> "+e);
                    });							
                } else {
                    quickPaymentSuccessVm.redirectToUserLogin();
                    if (quickPaymentSuccessVm.preAuthType != 'biometric') {
                        sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
                        clearServiceDataService.clearServiceData();
                        quickPaymentSuccessVm.getCSATDetails();
                    } else {
                        $state.go('menu.prehomeLoginRevamp');
                    }
                }
            } else {
                quickPaymentSuccessVm.redirectToUserLogin();              
                $state.go('menu.prehomeLoginRevamp');
            }
        }

        quickPaymentSuccessVm.redirectToUserLogin = function () {
            clearServiceVars();
            quickPayService.exitYqp().then(function (data) {
                loggedInUserService.tokenLotus = "";
            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        quickPaymentSuccessVm.goToYonoHome = function () {
            clearServiceVars();
            $state.go('menu.homeScreen');
        }
        quickPaymentSuccessVm.goToPreAuth = function () {
            clearServiceVars();
            quickPayService.fromSuccessPage = true;
            $state.go('menu.quickPayPreAuth');
            quickPayService.payment_type = quickPaymentSuccessVm.payment_type;            
        }
        quickPaymentSuccessVm.goToQuickPayLanding = function () {
            clearServiceVars();
            
            if(quickPaymentSuccessVm.payment_type == 'VPA_Contact' || quickPaymentSuccessVm.payment_type == 'vpa' || quickPaymentSuccessVm.payment_type == 'VPA' 
            || quickPaymentSuccessVm.payment_type == 'account'){
                $state.go('menu.payToContactLanding');
                quickPayService.fromSuccessPageUPI = true;
            }else{
                $state.go('menu.quickPayLanding');
                quickPayService.payToBeneficiaryN = {};
                quickPayService.fromSuccessPageBank = true;
            }
            
        }

        quickPaymentSuccessVm.setBiometric = function () {
            $ionicHistory.clearCache().then(function () {
                $state.go('menu.quickPayBiometricSetUp', { goBackToState: 3 });
            });
        }

        //for add favorite 
        quickPaymentSuccessVm.addToFavourite = function () {
           
            if (!quickPaymentSuccessVm.addFavFlag)
                quickPaymentSuccessVm.manageBeneficiary();
        }

        //method call for add favorite
        quickPaymentSuccessVm.manageBeneficiary = function () {
            var params = {};
            params = {
                "beneficiaryList": [
                    {
                        //"beneficiaryId": quickPaymentSuccessVm.benID
                    }
                ],
                "methodName": "updateBeneficiary"
            }

            quickPayService.favLists = [];
            quickPayService.addTofavorite(params).then(function (data) {
                quickPaymentSuccessVm.favData = data;
                quickPayService.favLists.push(quickPaymentSuccessVm.favData);
                console.log("favData",quickPaymentSuccessVm.favData );
                quickPaymentSuccessVm.addFavFlag = true;
                
                
                

            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //function to clear service variables
        function clearServiceVars() {
            quickPayService.clearVariables();
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            quickPaymentSuccessVm.payment_type = quickPayService.payToContactData.payment_type;
            quickPayService.checkVapaResponseAvailability = false;
            quickPaymentSuccessVm.payToContactData = quickPayService.payToContactData;
            quickPaymentSuccessVm.merchantInfo =  quickPaymentSuccessVm.payToContactData.merchantInfo;
            quickPayService.fromPaytoContactNumb = false;
            quickPayService.isFromMapper = false;
            quickPayService.isFromUPI = false;
            quickPayService.fav_id = "";
            quickPayService.bankResponse = "";
            //for- get account user details
            quickPaymentSuccessVm.customerInfo = quickPayService.customerInfo;
            quickPaymentSuccessVm.customerInformation = quickPayService.customerInfo.customerInformation;
            
            //for payer details from getprofile
            if(quickPayService.userProfileDet){
                quickPaymentSuccessVm.userProfileDet = quickPayService.userProfileDet;
                quickPaymentSuccessVm.selectedAccount = quickPaymentSuccessVm.userProfileDet.selectedAccount;
                quickPaymentSuccessVm.selectedVpa = quickPaymentSuccessVm.userProfileDet.selectedVpa;
                console.log("quickPaymentSuccessVm.userProfileDet", quickPaymentSuccessVm.userProfileDet);
            }
            

            //from account payer details
            if(quickPayService.payerAccntDetails){
                quickPaymentSuccessVm.payerAccntDetails = quickPayService.payerAccntDetails;
                console.log("quickPaymentSuccessVm.payerAccntDetails", quickPaymentSuccessVm.payerAccntDetails);
            }
            

           
            
            quickPaymentSuccessVm.preAuthType = quickPayService.preAuthType;
            quickPaymentSuccessVm.benID = "";
            quickPaymentSuccessVm.addFavFlag = false;
            quickPaymentSuccessVm.showAddToFavBtn = true;
            quickPaymentSuccessVm.showReceiveContent = false;
            quickPaymentSuccessVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            if (quickPaymentSuccessVm.isBiometricSet == undefined || quickPaymentSuccessVm.isBiometricSet == "false") {
                quickPaymentSuccessVm.isBiometricSet = false;
            }
            else {
                quickPaymentSuccessVm.isBiometricSet = true;
            }
            quickPaymentSuccessVm.action = $stateParams.action;
            quickPaymentSuccessVm.isSuccess = $stateParams.isSuccess;

            if (quickPaymentSuccessVm.isSuccess && quickPaymentSuccessVm.preAuthType != 'biometric') {
                getAccountDetailsService.accountOverviewData = "";
            }
            if (quickPaymentSuccessVm.isSuccess) {
                if (quickPaymentSuccessVm.action == 'pay_to_existing_beneficiary') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.benName;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];
                    });

                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOEXTBEN"));
                             
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_sbi') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.recipient_name;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTONEWSBIBEN"));

                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_other') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.recipient_name;

                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Beneficiary ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];
                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTONEWOTHERBEN"));

                                 
                }
                else if (quickPaymentSuccessVm.action == 'pay_to_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToContactData;
                    quickPaymentSuccessVm.accntTransactionId = quickPayService.accntTransactionId;

                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.name;

                        $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'Contact ', name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];
                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOCONTACTACC"));

                                    

                         var params = {
                            "beneficiaryList": [
                                {
                                    
                                    "beneficiaryName": quickPaymentSuccessVm.payeeName,
                                    "beneficiaryTransferAmount": quickPayService.paymentResponse.amount,
                                    "beneficiaryType": "account",
                                    "favoriteFlag": "",
                                    "lastTransactionType": quickPaymentSuccessVm.paymentResponse.payment_type,
                                    "beneficiaryMobNo":quickPaymentSuccessVm.paymentResponse.mobile_number,
                                    "senderName":quickPaymentSuccessVm.customerInformation.customerName,
                                    "senderAccountNumber":quickPaymentSuccessVm.customerInformation.accountNumber,
                                    "senderVpa":"",
                                    "transactionId":quickPaymentSuccessVm.accntTransactionId

                                }
                            ]
                        }

                        quickPayService.addTofavorite(params).then(function (data) {
                            quickPaymentSuccessVm.benID = "";
                           
                        }, function (error) {
                            quickPaymentSuccessVm.suError = error;
                        });
                       
                    }
                    else {
                        

                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse;
                        quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payeeVPA;
                        quickPaymentSuccessVm.payeeName = quickPaymentSuccessVm.payToContactData.name;
                        quickPaymentSuccessVm.payeeMobileNo = quickPaymentSuccessVm.payToContactData.mobile_number;

                        $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'VPA ID ', name: quickPaymentSuccessVm.payeeName }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOCONTACTVPA"));

                                      
                        var params = {
                            "beneficiaryList": [
                                {
                                    
                                    "beneficiaryName": quickPaymentSuccessVm.payeeName,
                                    "beneficiaryTransferAmount": quickPayService.paymentResponse.amount,
                                    "beneficiaryType": "VPA_Contact",
                                    "favoriteFlag": "",
                                    "lastTransactionType": quickPaymentSuccessVm.name,
                                    "beneficiaryMobNo":quickPaymentSuccessVm.payeeMobileNo,
                                    "senderName":quickPaymentSuccessVm.userProfileDet.name,
                                    "senderAccountNumber":quickPaymentSuccessVm.selectedAccount.maskedAccountNumber,
                                    "senderVpa":quickPaymentSuccessVm.selectedVpa.virtualAddress,
                                    "transactionId":quickPayService.paymentResponse.npciTransId

                                }
                            ]
                        }

                        quickPayService.addTofavorite(params).then(function (data) {
                            quickPaymentSuccessVm.benID = "";
                            quickPayService.forFrequentlyList = data;
                        }, function (error) {
                            quickPaymentSuccessVm.suError = error;
                        });
                    }
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_vpa') {
                    quickPaymentSuccessVm.showAddToFavBtn = false;
                    quickPaymentSuccessVm.showReceiveContent = true;
                    quickPaymentSuccessVm.name = quickPayService.splitPaymentIds[0];
                    $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];

                    });
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTVPA"));
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_contact') {
                    quickPaymentSuccessVm.showAddToFavBtn = false;
                    quickPaymentSuccessVm.showReceiveContent = true;
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToCollectContactData;
                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payerDisplayName;
                        $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];
                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTCONTACTACC"));
                    }
                    else {
                        //pay by contact vpa flow
                        quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payerDisplayName;
                        $translate(['YQP_COLLECT_SUCCESS_MSG'], { name: quickPaymentSuccessVm.name }).then(function (translations) {
                            quickPaymentSuccessVm.paymentResponse = translations['YQP_COLLECT_SUCCESS_MSG'];
                        });
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_COLLECTCONTACTVPA"));
                    }
                }
                else {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse;
                    quickPaymentSuccessVm.amount = quickPaymentSuccessVm.paymentResponse.amount;
                    quickPaymentSuccessVm.payeeName = quickPaymentSuccessVm.paymentResponse.payeeName;
                    quickPaymentSuccessVm.name = quickPaymentSuccessVm.paymentResponse.payeeVPA;
                    $translate(['YQP_SUCCESS_MSG'], { amount: quickPaymentSuccessVm.amount, type: 'VPA ID', name: quickPaymentSuccessVm.payeeName }).then(function (translations) {
                        quickPaymentSuccessVm.paymentResponse = translations['YQP_SUCCESS_MSG'];

                    });
                    var type = '';
                    if (quickPaymentSuccessVm.action == 'pay_to_vpa') {
                        type = 'VPA';
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOVPA"));
                    }

                  
                    else {
                        type = 'QR';
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPSUCCESS_PAYTOQR"));
                    }
                    var params1 = {
                        "beneficiaryList": [
                            {
                                
                                "beneficiaryName": quickPayService.paymentResponse.payeeName,
                                "beneficiaryTransferAmount": quickPayService.paymentResponse.amount,
                                "beneficiaryType": type,
                                "favoriteFlag": "",
                                "lastTransactionType": quickPayService.paymentResponse.payeeVPA,
                                "beneficiaryMobNo":"",
                                "senderName":quickPaymentSuccessVm.userProfileDet.name,
                                "senderAccountNumber":quickPaymentSuccessVm.selectedAccount.maskedAccountNumber,
                                "senderVpa":quickPaymentSuccessVm.selectedVpa.virtualAddress,
                                "transactionId":quickPayService.paymentResponse.npciTransId
                            }
                        ]
                    }

                    quickPayService.addTofavorite(params1).then(function (data) {
                        quickPaymentSuccessVm.benID = "";
                        
                    }, function (error) {
                       quickPaymentSuccessVm.suError = error;
                    });
                }
            }
            else {
                //in case of failure
                quickPaymentSuccessVm.showAddToFavBtn = false;
                if (quickPaymentSuccessVm.action == 'pay_to_existing_beneficiary') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOEXTBEN"));

                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_sbi') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTONEWSBIBEN"));

                }
                else if (quickPaymentSuccessVm.action == 'pay_to_new_other') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTONEWOTHERBEN"));

                }
                else if (quickPaymentSuccessVm.action == 'pay_to_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToContactData;

                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOCONTACTACC"));

                    }
                    else {
                        if (quickPayService.paymentResponse.responseMsg) {
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                        }
                        else {
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                        }
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOCONTACTVPA"));

                    }
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_vpa') {
                    if (quickPayService.paymentResponse.responseMsg)
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                    else
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTVPA"));
                }
                else if (quickPaymentSuccessVm.action == 'collect_via_contact') {
                    quickPaymentSuccessVm.paymentResponse = quickPayService.payToCollectContactData;
                    if (quickPaymentSuccessVm.paymentResponse.payment_type == 'account') {
                        //pay by contact account flow
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMessage;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTCONTACTACC"));
                    }
                    else {
                        //pay by contact vpa flow
                        if (quickPayService.paymentResponse.responseMsg)
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                        else
                            quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_COLLECTCONTACTVPA"));
                    }
                }
                else {
                    if (quickPayService.paymentResponse.responseMsg) {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.responseMsg;
                    }
                    else {
                        quickPaymentSuccessVm.paymentResponse = quickPayService.paymentResponse.statusDesc;
                    }
                    if (quickPaymentSuccessVm.action == 'pay_to_vpa') {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOVPA"));
                    }
                    else {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQPFAIL_PAYTOQR"));
                    }
                }
            }
        });

        $scope.$on('$ionicView.beforeLeave', function () {

            clearServiceVars();


        });
        return this;
    }
]);
