'use strict';

angularApp.controller('contactUsController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
				         "$ionicPopup","$stateParams","$ionicSideMenuDelegate","supportServices","utilityService","ompMerchantsService",
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicPopup,$stateParams,$ionicSideMenuDelegate,supportServices,utilityService,ompMerchantsService) {
	
	//functions, variables that can be accessed from the HTML come here
	var contactUsVm = this;
	
	/*************************Fetch all helpline categories start************************************/
	function initPage(){
		contactUsVm.showBack = false;
		contactUsVm.showNext = true;
		supportServices.getSBIHelpline().then(function(data){
			if(data != "" && data != undefined && data != null){
			contactUsVm.contactData = data.getSBIHelplines;
			contactUsVm.helpLine1 = data.defaultHelpline1;
		    contactUsVm.helpLine2 = data.defaultHelpline2;
			contactUsVm.digitalGrevianceUrl = data.url ? data.url : "";
			}else{
			contactUsVm.helpLine1 = '1800-1234';
		    contactUsVm.helpLine2 = '1800-2100' ;
			}
		},function(error){
			contactUsVm.helpLine1 = '1800-1234';
		    contactUsVm.helpLine2 = '1800-2100' ;
		}); 
	}
	/*************************Fetch all helpline categories end************************************/
	 
   /*************************Fetch all helpline numbers start************************************/	 
	contactUsVm.helplineTypeClick = function(helplineType){
		 $scope.sbiHelplineNumber = '';
		 if(helplineType == 'Digital Grievance Redressal' && contactUsVm.digitalGrevianceUrl){ 
			ompMerchantsService.inChromeBrowser(contactUsVm.digitalGrevianceUrl);
		} else {
		 for(var i=0;i<contactUsVm.contactData.length;i++){
			 if(contactUsVm.contactData[i].sbiHelplineType == helplineType){ 
			 $scope.sbiHelplineNumbers = contactUsVm.contactData[i].sbiHelpline;
			/*  $scope.sbiHelplineNumber2 = contactUsVm.contactData[i].sbiHelplineNumber2; */
			  $scope.helplineType = helplineType;
				$ionicPopup.alert({
				 title: '',
				 templateUrl: 'pages/support/contactUs/contactUsPopup.html',
				 scope: $scope,
				 cssClass: 'dialog',
				 //template: 
				 buttons: [
					 {                                                                  
					   text: 'Close',
						  onTap: function(e) {
							$state.go("menu.contactUs");            
							 
						  }
					}
				 ]
			   });
			 }
		 }
		}
		}
  /*************************Fetch all helpline numbers end************************************/	
  
	contactUsVm.manageVpa = function(){
		$state.go('menu.createVPA');
	}
	
	contactUsVm.manageQr = function(){
		$state.go('menu.qrCode');
	}
	contactUsVm.selPrimaryAcc = function(){
		$state.go('menu.selPrimaryAcc');
	}
	contactUsVm.setNotifications = function(){
		$state.go('menu.settingsNotifications');
	}
	
	contactUsVm.changeMpin = function(){
		$state.go('menu.changeMpin');
	}
	contactUsVm.mmidDetails = function(){
		$state.go('menu.mmidDetails');
	}
	contactUsVm.raiseQuery = function(){
		$state.go('menu.raiseQuery');
	}
	contactUsVm.trackQuery = function(){
		$state.go('menu.trackQuery');
	}
	contactUsVm.disFeatures = function(){
		$state.go('menu.disFeatures');
	}	
	
	//back to prev page
	contactUsVm.gotToPreviousPage = function(){
		$state.go('menu.support');
	
	}
	
	//go to next page
	contactUsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
