'use strict';
angularApp.controller('quickPayLandingController', [
  "$state",
  "$scope",
  "$rootScope",
  "$ionicPopup",
  "$translate",
  "utilityService",
  "loggedInUserService",
  "cryptoService",
  "mPinLoginService",
  "quickPayService",
  "$ionicModal",
  "constantConfig",
  "bhimUpiService",
  "customerInfoService",
  "$filter",
  "$ionicPopover",
  "$timeout",
  "$ionicScrollDelegate",
  "getAccountDetailsService",
  "homeScreenService",
  "clearServiceDataService",
  "AdapterUtils", "csatServices",
  "quickTransferService",
  "npsServices",
  "wearableServices",
  function ($state,
    $scope,
    $rootScope,
    $ionicPopup,
    $translate,
    utilityService,
    loggedInUserService,
    cryptoService,
    mPinLoginService,
    quickPayService,
    $ionicModal,
    constantConfig,
    bhimUpiService,
    customerInfoService,
    $filter,
    $ionicPopover,
    $timeout,
    $ionicScrollDelegate,
    getAccountDetailsService,
    homeScreenService,
    clearServiceDataService,
    AdapterUtils, csatServices,
    quickTransferService,
    npsServices,
    wearableServices) {

    var quickPayLandingVm = this;

    quickPayLandingVm.goToUserLanding = function () {
      if (quickPayLandingVm.preAuthType == 'mpin') {
        $state.go('menu.prehomeLoginRevamp');
        sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
        clearServiceDataService.clearServiceData();
        quickPayLandingVm.getCSATDetails();
      } else {
        $state.go('menu.prehomeLoginRevamp');
      }
    }

    //redirect to landing page on clik back btn - from detail page 
    quickPayLandingVm.goToPayToContactLand = function () {
        $state.go('menu.payToContactLanding');
        quickPayService.payFromTransList = false;
        quickPayService.paytoFavClick = false;
        quickPayService.frequentlClick = false;
        quickPayService.fav_id = "";
        quickPayService.bankResponse = "";
        //for clear cache
        quickPayService.myTab = "contact";
        quickPayService.paytoFavClick = false;
        
        quickPayService.qp_vpa_upiId = '';
        quickPayLandingVm.bankUpiHide = false;
        quickPayLandingVm.payeeName = "";
        quickPayLandingVm.verifyUpiIdError = '';

        if(quickPayLandingVm.isFromMapper){
           quickPayService.merchantInfo = ''
        }

      }

    quickPayLandingVm.getCSATDetails = function () {
      mPinLoginService.isLoggedIn = false;
      quickPayLandingVm.sessionLogout();
    }

    quickPayLandingVm.sessionLogout = function () {
      AdapterUtils.sessionLogout().then(
        function (response) {
          loggedInUserService.logoutUser(true);
        },
        function (error) {
          loggedInUserService.logoutUser(true);
        }
      );
    }

    function initPage() {

      homeScreenService.getRevisedOfferOptions().then(function (response) {
        csatServices.csatFeedbackdata = response.feedbackData;
        csatServices.highestGoldenJourneyCounter = parseInt(csatServices.csatFeedbackdata.feedbackMaxCounter);
        csatServices.feedbackGoldenJourneyList = csatServices.csatFeedbackdata.feedbackGoldenJourneyList;
      }, function (error) {
        console.log(error);
      });

      quickPayLandingVm.forCheckTransactionPage = false;
      quickPayLandingVm.isFromMapper = true;
      quickPayLandingVm.isFromUPI = false;
      
      //for clear cache while coming from success page - pay to contact
       if(quickPayService.fromSuccessPageUPI){
            quickPayLandingVm.qp_vpa_upiId = '';
            quickPayService.qp_vpa_upiId = '';
            quickPayService.fromSuccessPageUPI = false;
        }

      //for clear cache while coming from success page - pay to beneficiary
      if(quickPayService.fromSuccessPageBank){
          quickPayService.payToBeneficiaryData.existingBeneficiaries = {};
          quickPayService.fromSuccessPageBank = false;
      }

      if (quickPayLandingVm.payToContact == undefined) {
         quickPayLandingVm.payToContact = {};
      }
      quickPayLandingVm.setPaymentMethod(quickPayService.myTab);
      
      
      
      //get customer info
      quickPayLandingVm.customerInfo = quickPayService.customerInfo;
      quickPayLandingVm.customerInformation = quickPayService.customerInfo.customerInformation;
      quickPayLandingVm.paymentType = quickPayService.payToContactData.payment_type;

      //account section
      quickPayLandingVm.accDetails =  quickPayService.customerInfo.accounts;
      quickPayLandingVm.getAccountList();

      //for contacts
      if(!quickPayLandingVm.newContacts){
          quickPayLandingVm.getAllContacts();
      }
      
      
      quickPayLandingVm.newResultContact = quickPayService.newResultContact;
      

      //function call for frequently paid
      quickPayLandingVm.getTransactionList();
      quickPayLandingVm.getTransactionListLatest();
      console.log("quickPayLandingVm.payToContact", quickPayLandingVm.payToContact);
      
     if((loggedInUserService.fromPreAuthSecondAuth && !loggedInUserService.isFromMapper) 
         && (loggedInUserService.fromPreAuthSecondAuth && !loggedInUserService.isFromUPI)
         || (loggedInUserService.isPaytoUpiContSecondAuth && !loggedInUserService.fromPaytoContactNumb)){
         quickPayLandingVm.comingFromSeconAuthFavList();
         loggedInUserService.fromPreAuthSecondAuth = false;
         loggedInUserService.isPaytoUpiContSecondAuth = false;
         
      }

       if(loggedInUserService.isPaytoAccntSecondAuth){
          quickPayLandingVm.comingFromSeconAuthAccnt();
          loggedInUserService.isPaytoAccntSecondAuth = false;
          
      }

      
      //for contact colors
      quickPayLandingVm.colorCode = ["#339E42", "#039BE5", "#EF6C00", "#A1887F", "#607D8B", "#1E1B92", "#009688"];
      quickPayLandingVm.colorCodeFav = ["#F492D4", "#C9A0EA", "#ECD7FD", "#E5C2E7", "#BDB0CE", "#954F98", "#9B99F7"];

      //upi bank list - as per bank 
      quickPayLandingVm.checkUpiBankList = [{ type: "oksbi" }, { type: "sbi" }, { type: "ybl" }, { type: "okicici" }, { type: "okaxis" }, { type: "okhdfc" }, { type: "paytm" }, { type: "bob" }, { type: "apl" }, { type: "icici" }, { type: "hdfcbank" }];

      quickPayLandingVm.yqp_beneficiary_toggle = { "checked": false };
      quickPayLandingVm.yqpBeneficiaryLimit = quickPayService.yqpBeneficiaryLimit;
      quickPayLandingVm.yqpVpaLimit = quickPayService.yqpVpaLimit;
      console.log("quickPayLandingVm.yqpVpaLimit", quickPayLandingVm.yqpVpaLimit);

      if(quickPayService.myTab == 'vpa'){
        quickPayLandingVm.classForPay = 'tab-item tabs-style div-bottom ';
        quickPayLandingVm.classForRequest = 'tab-item tabs-style div-bottom bor-bot-active';
      }else{
        quickPayLandingVm.classForPay = 'tab-item tabs-style div-bottom bor-bot-active';
        quickPayLandingVm.classForRequest = 'tab-item tabs-style div-bottom';
      }
      
      quickPayLandingVm.showDivContacts = false;
      quickPayLandingVm.isEditVpaField = false;

      

      //modal for contact list
      $ionicModal.fromTemplateUrl('pages/quickPay/payToContactModal.html', {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (modal) {
        $scope.payToContactModal = modal;
        if (loggedInUserService.launchPageTxn && loggedInUserService.qpayType == "paycontact") {
          quickPayLandingVm.openPayToContactModal();
        }
      });

      //modal for upi id
      $ionicModal.fromTemplateUrl('pages/quickPay/payToUPIModal.html', {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (modal) {
        $scope.payToUPIModal = modal;
        if (loggedInUserService.launchPageTxn && loggedInUserService.qpayType == "paycontact") {

          quickPayLandingVm.openPayToContactModal();
        }
      });

      $ionicModal.fromTemplateUrl('pages/quickPay/payToBeneficiaryModal.html', {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (modal) {
        $scope.payToBeneficiaryModal = modal;
        if (loggedInUserService.launchPageTxn && loggedInUserService.qpayType == "paybank") {
            quickPayLandingVm.openPayToBeneficiaryModal();
        }
      });



      // //for find contacts
     

      //for get response from mindgate response 
      
      if(quickPayService.checkVpaResponse || (loggedInUserService.fromPreAuthSecondAuth && loggedInUserService.isFromMapper) 
          || (loggedInUserService.fromPreAuthSecondAuth && loggedInUserService.isFromUPI) || (loggedInUserService.isPaytoUpiContSecondAuth && loggedInUserService.fromPaytoContactNumb)){

          if (quickPayService.checkVpaResponse.status == 'VE' && quickPayService.qp_vpa_upiId) {
              quickPayLandingVm.checkVpaResponse = quickPayService.checkVpaResponse;
              quickPayService.payeeType = quickPayLandingVm.checkVpaResponse.payeeType;
              quickPayLandingVm.payeeName = quickPayService.payeeType.name;
              quickPayLandingVm.qp_vpa_upiId = quickPayService.qp_vpa_upiId;
              quickPayLandingVm.merchantInfo = quickPayService.merchantInfo;

              if((loggedInUserService.fromPreAuthSecondAuth && loggedInUserService.isFromMapper) 
                  || (loggedInUserService.fromPreAuthSecondAuth && loggedInUserService.isFromUPI)){
                  quickPayLandingVm.qp_vpa_amount = loggedInUserService.qp_vpa_amount;
                  quickPayLandingVm.qp_vpa_remark = loggedInUserService.qp_vpa_remark;
                  quickPayService.isFromMapper = false;
                  quickPayService.isFromUPI = false;
                  loggedInUserService.isFromMapper = false;
                  loggedInUserService.isFromUPI = false;
              }

              if (quickPayLandingVm.merchantInfo) {
                quickPayLandingVm.favUPIAddr = quickPayLandingVm.merchantInfo.fvaddr;
              } else {
                quickPayLandingVm.favUPIAddr = quickPayService.payeeVAP;
              }

            }
      }



      //section for pay to contact 
      if(quickPayService.checkVpaConResponse || (loggedInUserService.isPaytoUpiContSecondAuth && loggedInUserService.fromPaytoContactNumb)){
        if(quickPayService.checkVpaConResponse.status == 'VE' ){
            quickPayLandingVm.checkVpaConResponse =  quickPayService.checkVpaConResponse;
            quickPayLandingVm.payeeType = quickPayLandingVm.checkVpaConResponse.payeeType;
            quickPayLandingVm.payToContact.name = quickPayService.payToContactData.name;
            console.log("quickPayService.checkVpaConResponse",quickPayLandingVm.payToContact.name );
            quickPayLandingVm.merchantInfo = quickPayLandingVm.payeeType.merchantInfo;
            quickPayLandingVm.payToContact.favUPIAddr = quickPayLandingVm.merchantInfo.fvaddr;

            if(loggedInUserService.isPaytoUpiContSecondAuth && loggedInUserService.fromPaytoContactNumb){
                quickPayLandingVm.payToContact.amount = loggedInUserService.Accntamount;
                quickPayLandingVm.payToContact.remark = loggedInUserService.AccntRemark;

                loggedInUserService.isPaytoUpiContSecondAuth = false;
                quickPayService.fromPaytoContactNumb = false;
                loggedInUserService.fromPaytoContactNumb = false;
            }
          }
      }
   

      if(quickPayService.bankResponse){
          quickPayLandingVm.payToContact.name = quickPayService.payToContactData.name;
          console.log("quickPayService.bankResponse",quickPayLandingVm.payToContact.name );
          quickPayLandingVm.payToContact.account_number = quickPayService.payToContactData.account_number;

          if(quickPayService.paytoFavClick){
              quickPayLandingVm.payToContact.amount = quickPayService.payToContact.amount;
              quickPayService.paytoFavClick = false;
          }
           if(quickPayService.payFromTransList){
              quickPayService.payFromTransList = false;
           }

           if(quickPayService.frequentlClick){
              quickPayService.frequentlClick = false;
           }
      }

     //for get profile response
      if (quickPayService.getProfileResponse) {
          quickPayLandingVm.getProfileResponse = quickPayService.getProfileResponse;
          quickPayLandingVm.vpaAccountDetails = quickPayLandingVm.getProfileResponse.vpaAccountDetails;
          quickPayLandingVm.userInfo = quickPayLandingVm.getProfileResponse.userInfo;
          quickPayLandingVm.userProfileDet = {};

        for (var i = 0; i < quickPayLandingVm.vpaAccountDetails.length; i++) {
          if (quickPayLandingVm.vpaAccountDetails[i].defVPAStatus) {
            quickPayLandingVm.selectedVpa = quickPayLandingVm.vpaAccountDetails[i];
            quickPayLandingVm.remitterVPA = quickPayLandingVm.selectedVpa.virtualAddress;
            quickPayLandingVm.remitterAccountObj = quickPayLandingVm.selectedVpa.accountInfo;
            quickPayLandingVm.accId = quickPayLandingVm.remitterAccountObj[0].accId;
            quickPayLandingVm.remitterAccountObj.accId = quickPayLandingVm.accId;
            var filteredArray = quickPayLandingVm.selectedVpa.accountInfo.filter(function (itm) {
              return itm.mpinFlag == 'Y';
            });

            quickPayLandingVm.accountInfo = filteredArray;
            quickPayLandingVm.accounts = quickPayLandingVm.accountInfo;
            quickPayLandingVm.selectedAccount = quickPayLandingVm.accountInfo[0];
            quickPayLandingVm.selectedVpa = quickPayLandingVm.vpaAccountDetails[0];

           

            for (var j = 0; j < quickPayLandingVm.accountInfo.length; j++) {
              if (quickPayLandingVm.accountInfo[j].preferredFlag == 'T') {
                  quickPayLandingVm.selectedAccount = quickPayLandingVm.accountInfo[j];
                  quickPayLandingVm.userProfileDet.selectedAccount = quickPayLandingVm.selectedAccount;
              }
            }
          }
        }
      }

      

      //for checking same vpa payee and payer

      if(quickPayLandingVm.favUPIAddr){
          if (quickPayLandingVm.favUPIAddr == quickPayLandingVm.selectedVpa.virtualAddress) {
            quickPayLandingVm.sameVpaAddreError = true;
        } else {
          quickPayLandingVm.sameVpaAddreError = false;
        }
      }
      
     

     
      // Inserted for Login Revamp sub-demand
      if (loggedInUserService.launchPageTxn) {
        onLoadFunctionCalls();
      }
      else {
          if (loggedInUserService.qpayType == "paycontact") {
            //Inserted as part of Prod specific fixes
            angular.element(document.body).removeClass('popover-open'); // added to avoid un-responsive page after second authentication.
            quickPayLandingVm.setPaymentMethod('contact');
            quickPayLandingVm.payToContact.mobile_number = quickPayService.payToContactData.mobile_number;
            quickPayLandingVm.payToContact.name = quickPayService.payToContactData.name;
            console.log("paycontact", quickPayLandingVm.payToContact.name);
            quickPayLandingVm.payToContact.beneficiaryError = quickPayService.payToContactData.beneficiaryError;
            quickPayLandingVm.payToContact.payment_type = quickPayService.payToContactData.payment_type;
            if (quickPayService.payToContactData.account_number) {
              quickPayLandingVm.payToContact.account_number = quickPayService.payToContactData.account_number;
            }
            quickPayLandingVm.payToContact.amount = quickPayService.payToContactData.amount;
            if (quickPayService.payToContactData.remark) {
              quickPayLandingVm.payToContact.remark = quickPayService.payToContactData.remark;
            }
            if (loggedInUserService.isSecondAuthCompleted) {
              loggedInUserService.isSecondAuthCompleted = false;
            }
            loggedInUserService.qpayType = "";
            //Inserted to load fav after sec auth as part of Prod specific fixes
            if (quickPayService.favLists.length > 0) {
              quickPayLandingVm.favLists = quickPayService.favLists;
            }
          }
          else if (loggedInUserService.qpayType == "paybank") {
              //Inserted as part of Prod specific fixes
              angular.element(document.body).removeClass('popover-open'); // added to avoid un-responsive page after second authentication.

              if(quickPayService.payFromTransList){
                 quickPayLandingVm.payViaTransaction(quickPayService.payFromTransListData);
              }else{
                quickPayLandingVm.setPaymentMethod('beneficiary', quickPayService.payFromTransListData);
                quickPayLandingVm.payToBeneficiary.beneficiaryName = quickPayService.dataComingFromFavTransBene.beneficiaryName;
                quickPayLandingVm.payToBeneficiary.amount = quickPayService.dataComingFromFavTransBene.beneficiaryTransferAmount;
                quickPayService.payToBeneficiaryN = quickPayLandingVm.payToBeneficiary;

                if (quickPayService.dataComingFromFavTransBene.remark) {
                    quickPayLandingVm.payToBeneficiary.remark = quickPayService.dataComingFromFavTransBene.remark;
                }
              }
              

              if (loggedInUserService.isSecondAuthCompleted) {
                loggedInUserService.isSecondAuthCompleted = false;
              }
                quickPayLandingVm.getFavorites();
            }
          else {
            onLoadFunctionCalls();
          }
      }
    };

    //end init code here

    //coming from secondary auth - favorite list
    quickPayLandingVm.comingFromSeconAuthFavList = function () {
       quickPayLandingVm.secondaryAuthFav =  quickPayService.secondaryAuthFav;
       quickPayLandingVm.payment_type = quickPayLandingVm.secondaryAuthFav.beneficiaryType;

       if(quickPayLandingVm.secondaryAuthFav.beneficiaryType == 'VPA_Contact'){
            quickPayLandingVm.payToContact.name = quickPayLandingVm.secondaryAuthFav.beneficiaryName;
            quickPayLandingVm.payToContact.favUPIAddr = quickPayLandingVm.secondaryAuthFav.lastTransactionType;
            quickPayLandingVm.payToContact.amount = loggedInUserService.Accntamount;
            quickPayLandingVm.payToContact.remark = loggedInUserService.AccntRemark;
            quickPayLandingVm.qp_vpa_upiId = quickPayLandingVm.secondaryAuthFav.lastTransactionType;
      }else{
            quickPayLandingVm.payeeName = quickPayLandingVm.secondaryAuthFav.beneficiaryName;
            quickPayLandingVm.favUPIAddr = quickPayLandingVm.secondaryAuthFav.lastTransactionType;
            quickPayLandingVm.qp_vpa_amount = loggedInUserService.qp_vpa_amount;
            quickPayLandingVm.qp_vpa_remark = loggedInUserService.qp_vpa_remark;
            quickPayLandingVm.qp_vpa_upiId = quickPayLandingVm.secondaryAuthFav.lastTransactionType;
       }
          
    }

    //for second authetication from account
    quickPayLandingVm.comingFromSeconAuthAccnt = function(){
        quickPayLandingVm.payToContact.name = loggedInUserService.AccntPayeeName;
        quickPayLandingVm.payToContact.account_number = loggedInUserService.AccntPayeeAcnt_number;
        quickPayLandingVm.payToContact.amount = loggedInUserService.Accntamount;
        quickPayLandingVm.payToContact.remark = loggedInUserService.AccntRemark;
    } 
     

       //for transaction list - for transaction list
      quickPayLandingVm.getTransactionListLatest = function () {
        

            var params = { "methodName": "getTransactionList" };
            quickPayService.addTofavorite(params).then(function (data) {
            quickPayService.transactionListsNew = data.beneficiaryList;
            quickPayLandingVm.transactionListsNew = quickPayService.transactionListsNew;

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
   

     //for transaction list - for frequently paid
      quickPayLandingVm.getTransactionList = function () {
         quickPayLandingVm.frequentList = [];

            var params = { "beneficiaryList": [
                    {
                        
                    }
                ],
                 "methodName": "updateBeneficiary" 
              };
            quickPayService.addTofavorite(params).then(function (data) {
            quickPayService.transactionLists = data.beneficiaryList;
            quickPayLandingVm.transactionLists = quickPayService.transactionLists;

            quickPayLandingVm.fListFinal = quickPayLandingVm.transactionLists.filter(function (value, index, self) {
                  return index === self.findIndex(function (t) { return (t.beneficiaryId === value.beneficiaryId); });
            });

             

              quickPayLandingVm.newFreqPayToCon = [];
             

                for (var l = 0; l < quickPayLandingVm.fListFinal.length; l++) {
                    if(quickPayLandingVm.fListFinal[l].beneficiaryType == "VPA" || quickPayLandingVm.fListFinal[l].beneficiaryType == "Contact" 
                        || quickPayLandingVm.fListFinal[l].beneficiaryType == "VPA_Contact") {
                        quickPayLandingVm.newFreqPayToCon.push(quickPayLandingVm.fListFinal[l]);
                    }
                }

                quickPayService.newFreqPayToCon = quickPayLandingVm.newFreqPayToCon;
                

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

   

    //account list details
     
          quickPayLandingVm.getAccountList = function () {
            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    
                    quickPayLandingVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    if (quickPayLandingVm.accDetails.length == 0) {
                        quickPayService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    quickPayLandingVm.setPrimaryAccount();
                    
                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {
              
                quickPayLandingVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                if (quickPayLandingVm.accDetails.length == 0) {
                    quickPayService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
                quickPayLandingVm.showSelect = false;
                if (quickPayService.selIndex == "") {
                    quickPayLandingVm.setPrimaryAccount();
                } else {
                    quickPayLandingVm.closeAccntD(quickPayService.selIndex);

                }
            }

        }

        quickPayLandingVm.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = quickPayLandingVm.accDetails;

                for (var i = 0, j = arr.length; i < j; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        var topElement = quickPayLandingVm.accDetails[i];
                        quickPayLandingVm.closeAccntD(i);
                        if (quickPayLandingVm.accDetails.indexOf(topElement) > 0) {
                            quickPayLandingVm.accDetails.splice(quickPayLandingVm.accDetails.indexOf(topElement), 1);
                            quickPayLandingVm.accDetails.unshift(topElement);
                        }
                    }
                }
            } else {

                quickPayLandingVm.closeAccntD(0);
            }
        }

       quickPayLandingVm.showPop = function(){
          quickPayLandingVm.popUp = $ionicPopup.show({
            title: '',
            cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
            templateUrl: 'pages/quickPay/accountListModal.html',
            scope: $scope
          });
      }

      quickPayLandingVm.closeAccntD = function(index){
          if(quickPayLandingVm.popUp){
            quickPayLandingVm.popUp.close();
          }
          
          quickPayLandingVm.balance = quickPayLandingVm.accDetails[index].accountBalance;
          quickPayLandingVm.accType = quickPayLandingVm.accDetails[index].accountType;
          quickPayLandingVm.accountNumber = quickPayLandingVm.accDetails[index].accountNumber;
          quickPayLandingVm.isActive = quickPayLandingVm.accDetails[index].isActive;
          quickPayLandingVm.isTransactional = quickPayLandingVm.accDetails[index].isTransactional;
          quickPayService.selIndex = index ;
          quickPayService.isTransactional = quickPayLandingVm.isTransactional;
          quickPayService.accountNumber = quickPayLandingVm.accDetails[index].accountNumber;
          quickPayService.accountBalance = quickPayLandingVm.accDetails[index].accountBalance;
          quickPayService.accType = quickPayLandingVm.accType;
          
          quickPayLandingVm.showSelect = false;
          quickPayLandingVm.payToContact.amountError = '';
          quickPayLandingVm.checkAccountOperation();

         
        }

     


        quickPayLandingVm.checkAccountOperation = function () {

            quickPayService.checkAccountOperation(quickPayService.accountNumber).then(function (data) {

                utilityService.hideSpinner();
                if (data.operationAllowed == 'Y') {
                      quickPayLandingVm.unableFetchAccountMOPTransactional = false;
                  }
                if (data.operationAllowed == 'N') {
                    quickPayLandingVm.unableFetchAccountMOPTransactional = true;
                  }
                  quickPayService.unableFetchAccountMOPTransactional = quickPayLandingVm.unableFetchAccountMOPTransactional;
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
            });

        }

     //account details section end


      //for frequent list - show more
      quickPayLandingVm.showMoreFre = function () {
        quickPayLandingVm.showMoreHeight = !quickPayLandingVm.showMoreHeight;
      }



      //on click gotofrequently
      quickPayLandingVm.goToFrequently = function (frequenDetails) {
          quickPayService.frequentlClick = true;
          quickPayService.frequenDetails = frequenDetails;

            if (frequenDetails.beneficiaryType == 'Contact') {
              $ionicScrollDelegate.scrollTop();

              quickPayLandingVm.contactSearchText = frequenDetails.lastTransactionType;
              quickPayService.contactSearchText = quickPayLandingVm.contactSearchText;

              quickPayLandingVm.setPaymentMethod('contact');
              quickPayLandingVm.setContactDetails('2', false);

            }else if(frequenDetails.beneficiaryType == 'Account'){
                
                if (!quickPayService.payToBeneficiaryData.existingBeneficiaries) {
                  quickPayService.getBeneficiaryList().then(function (data) {
                    if (!utilityService.isUndefined(data)) {
                      quickPayService.payToBeneficiaryData.existingBeneficiaries = data;
                    }
                    quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
                    quickPayService.frequentlClick = false;
                    getExistingBeneficiaryDetail(frequenDetails);
                  }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                  });
                }
                else {
                  quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
                  getExistingBeneficiaryDetail(frequenDetails);
                }
            }
        
          else{
            quickPayLandingVm.setPaymentMethod('vpa', frequenDetails);
            $ionicScrollDelegate.scrollTop();
          }
        }

        //section for select vpa 
        quickPayLandingVm.changeVpa = function (selectedVpa) {
          if (selectedVpa) {
            quickPayLandingVm.accounts = selectedVpa.accountInfo;
            for (var j = 0; j < selectedVpa.accountInfo.length; j++) {
              if (selectedVpa.accountInfo[j].preferredFlag == 'T') {
                quickPayLandingVm.selectedAccount = selectedVpa.accountInfo[j];
              }
            }
          } else {
            quickPayLandingVm.accounts = '';
          }
        }

      //modal for contact list - open on click input div
      quickPayLandingVm.openContactModal = function (fromContactClick) {
        
        $scope.payToContactModal.show();
      }
      //end contact modal 


      //modal for vpa or upi id - open on click input div 
      quickPayLandingVm.openUpiModal = function () {
        $scope.payToUPIModal.show();
        quickPayLandingVm.resetVpaFields();
        quickPayLandingVm.qp_vpa_upiId = '';
        quickPayLandingVm.payeeName = "";
        quickPayLandingVm.verifyUpiIdError = '';
        
      }

    //end vpa or upi id modal popup

     //find contacts list 
     quickPayLandingVm.getAllContacts = function () {
       utilityService.showSpinner();

      function onSuccess(contacts) {
      console.log("contacts", contacts);
          

        quickPayLandingVm.newResultContact = [];
        quickPayLandingVm.createNewArPhone = [];
        quickPayService.newResultContact = quickPayLandingVm.newResultContact;
        //for remove duplicate contacts
        for (var i = 0; i < contacts.length; i++) {
          var phoneList = (contacts[i].phoneNumbers);

          if(phoneList == null){
              phoneList = 0;
          }
          for (var j = 0; j < phoneList.length; j++) {
              var phoneNum = (phoneList[j].value);
              var sliceNum = phoneNum.replace(/[^\d]/g, '');
              quickPayLandingVm.createNewArPhone.push(sliceNum);
              for (var k = 0; k <= quickPayLandingVm.createNewArPhone.length; k++) {
                var resultList = quickPayLandingVm.createNewArPhone.filter(function (item, index) {
                  return quickPayLandingVm.createNewArPhone.indexOf(item) === index;
                })
              }
            }
          
       

          var contactlist = {
            name: contacts[i].displayName,
            phone: resultList
          }
          quickPayLandingVm.newResultContact.push(contactlist);
          console.log("quickPayLandingVm.newResultContact", quickPayLandingVm.newResultContact);
		utilityService.hideSpinner();
          if (quickPayLandingVm.newResultContact) {
            quickPayLandingVm.createNewArPhone = [];
          }
        }

        
         
          function compare(a,b) {
            if(a.name === null){
                a.name = '';
            }
            if(b.name === null){
              b.name = '';
            }
            if (a.name < b.name){
              return -1;
            }
                
            if (a.name > b.name){
              return 1;
            }
            return 0;
          }

         var contactListMain = quickPayLandingVm.newResultContact.sort(compare);
         quickPayLandingVm.newContactsList = [];

         for (var k = 0; k < contactListMain.length; k++) {
            if((contactListMain[k].name == '' && contactListMain[k].phone) || (contactListMain[k].name !== '' && contactListMain[k].phone)){
                quickPayLandingVm.newContactsList.push(contactListMain[k]);
            }
         }

         //main contact list after filter null undefined and with sorted list
        quickPayLandingVm.newContacts = quickPayLandingVm.newContactsList;

         

      } //success function close

      function onError(contactError) {
        quickPayLandingVm.contactError = contactError;
      }

      

      // find all contacts with 'Bob' in any name field
      var options;
      var fields;
      
  
      options = new ContactFindOptions();
      options.filter = "";
      options.multiple = true;
      options.desiredFields = [navigator.contacts.fieldType.id, navigator.contacts.fieldType.displayName, navigator.contacts.fieldType.phoneNumbers];
      options.hasPhoneNumber = false;
      
      fields = [navigator.contacts.fieldType.displayName, navigator.contacts.fieldType.phoneNumbers];
      navigator.contacts.find(fields, onSuccess, onError, options);
  } //find function close

  

  //onchange contacts
    quickPayLandingVm.checkString = function (value) {
        quickPayLandingVm.searchString = "";
        quickPayLandingVm.searchNumber = "";
              
              if (value === undefined) {
                  quickPayLandingVm.newContacts = quickPayLandingVm.newContactsList;
              } else {
                  quickPayLandingVm.newContacts = quickPayLandingVm.newContactsList.filter(function (item, index) {
                    
                    if(item.name === null || item.name == ""){
                       return (item.phone.toString().toLowerCase().includes(value.toLowerCase()));
                    }else{
                      return (item.name.toLowerCase().includes(value.toLowerCase())||
                              item.phone.toString().toLowerCase().includes(value.toLowerCase()));
                      }
                  });
              }

              

               if (quickPayLandingVm.newContacts.length == 0) {
                    quickPayLandingVm.showDivContacts = false;
                    quickPayLandingVm.phoneNotFoundError = true;
                    quickPayLandingVm.showAllContacts = false;
              } else {
                  quickPayLandingVm.showAllContacts = true;
                  quickPayLandingVm.phoneNotFoundError = false;
                  quickPayLandingVm.showDivContacts = false;
              }
          }




    quickPayLandingVm.getContactsList = function(){
        quickPayLandingVm.showDivContacts = true;
    }



    /********** Pay To VPA START ************/
     quickPayLandingVm.verifyUpiId = function (paymentType) {
      quickPayLandingVm.bankUpiHide = false;
      quickPayLandingVm.isEditVpaField = true;

      var mapperTextNew = '@mapper.npci';
      var checkVpaResponse;
      var jsonMapperUpi;
      quickPayLandingVm.qp_vpa_upiId_varifyAct = false;
     
      if ((quickPayLandingVm.qp_vpa_upiId !== undefined && quickPayLandingVm.qp_vpa_upiId && quickPayLandingVm.qp_vpa_upiId_validSign)) {
          if (quickPayLandingVm.qp_vpa_upiId) {
            quickPayService.qp_vpa_upiId = quickPayLandingVm.qp_vpa_upiId.concat(mapperTextNew);
          }

          utilityService.showSpinner();
          if (utilityService.isAndroidPlatform()) {
              jsonMapperUpi = JSON.stringify({
                
                "payeeType": {
                  "virtualAddress": paymentType !== 'QR' ? quickPayService.qp_vpa_upiId.toString() : quickPayLandingVm.qp_qr_upiId.toString()
                },
                "requestInfo": {
                  "pspId": constantConfig.upiConstant.pspId,
                  "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
          }else{
              jsonMapperUpi = JSON.stringify({
                "addInfo": {
                  "addInfo10": constantConfig.upiConstant.addInfo10,
                  "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "payeeType": {
                  "virtualAddress": paymentType !== 'QR' ? quickPayService.qp_vpa_upiId.toString() : quickPayLandingVm.qp_qr_upiId.toString()
                },
                "requestInfo": {
                  "pspId": constantConfig.upiConstant.pspId,
                  "pspRefNo": generateRandomString(27)
                },
                "vAReqType": constantConfig.upiConstant.vAReqType_T
            });
          }
      


        bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, jsonMapperUpi, "YQP").then(function (data) {
          utilityService.hideSpinner();
          checkVpaResponse = JSON.parse(data);
          quickPayService.payToContactData.payment_type = paymentType;
          quickPayService.checkVpaResponse = checkVpaResponse;

          if(quickPayService.checkVpaResponse){
              quickPayService.checkVapaResponseAvailability = true;
          }else{
              quickPayService.checkVapaResponseAvailability = false;
          }
         
          //check status - depends on show error msg
          if (checkVpaResponse.status == 'VE') {
              quickPayService.respStatus = quickPayService.checkVpaResponse.status;
              quickPayLandingVm.payeeType = checkVpaResponse.payeeType;
              quickPayLandingVm.payeeName = checkVpaResponse.payeeType.name;
              quickPayLandingVm.payeeVAP = checkVpaResponse.payeeType.virtualAddress;
              quickPayService.merchantInfo = checkVpaResponse.payeeType.merchantInfo;

              //verify from mapper/number or upi id
              quickPayLandingVm.isFromMapper = true;
              quickPayLandingVm.isFromUPI = false;

              quickPayService.isFromMapper = quickPayLandingVm.isFromMapper;
              quickPayService.isFromUPI = quickPayLandingVm.isFromUPI;

              if (quickPayService.merchantInfo) {
                quickPayLandingVm.favUPIAddr = quickPayService.merchantInfo.fvaddr;
              } else {
                quickPayLandingVm.favUPIAddr = quickPayLandingVm.payeeVAP;
              }

              if (quickPayService.contact_active) {
                $scope.payToContactModal.hide();
                $state.go('menu.payToUPIDetails');
                if (loggedInUserService.launchPageTxn) {
                 
                  angular.element(document.body).removeClass('modal-open');
                }
              }


          } else if (checkVpaResponse.status == 'VN') {
            
            var closeYqpPop = $ionicPopup.alert({
              template: '<div class="popup-padding font-dark-grey yqpPayLng"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter yqpMsgSection"><span class="popUp-msg-color roboto-medium ypqMsg1">' + 'We couldn’t find any SBI account or UPI ID mapped to this phone number' + '</span></div><div class="textAlignCenter marBtm20"><span class="popUp-msg-color ypqMsg2">' + 'You can still send money using following options' + '</span></div></div></div>',
              scope: $scope,
              cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup yqpMainPopup',
              buttons: [{
                  text: "Try with another UPI ID or Number",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();

                    if (quickPayLandingVm.contact_active) {
                      quickPayService.contact_active = quickPayLandingVm.contact_active;
                      $state.go("menu.payToContactLanding");
                    }

                    if (loggedInUserService.launchPageTxn) {
                      
                      angular.element(document.body).removeClass('modal-open');
                    }

                  }
                },

                {
                  text: "Bank Account",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();
                    $state.go("menu.quickPayLanding");
                    if (loggedInUserService.launchPageTxn) {
                     
                      angular.element(document.body).removeClass('modal-open');
                    }

                  }
                },
                {
                  text: "",
                  type: 'button-positive',
                  onTap: function () {
                    closeYqpPop.close();
                  }
                }

              ],
            });

          } else if (checkVpaResponse.status == 'F') {
            $ionicPopup.alert({
              template: '<div class="popup-padding font-dark-grey yqpPayLng"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter yqpMsgSection"></div><div class="textAlignCenter marBtm20"><span class="popUp-msg-color ypqMsg2">' + checkVpaResponse.statusDesc + '</span></div></div></div>',
              scope: $scope,
              cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup yqpFailedStatus',
              buttons: [
                {
                  text: "OK",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();
                    $state.go("menu.payToContactLanding");
                    if (loggedInUserService.launchPageTxn) {
                      
                      angular.element(document.body).removeClass('modal-open');
                    }
                  }
                }

              ],
            });
          }

          else {
            quickPayLandingVm.verifyUpiIdError = checkVpaResponse.statusDesc;
          }

        }, function (msg) {
          utilityService.hideSpinner();
          if (paymentType !== 'QR')
            quickPayLandingVm.verifyUpiIdError = quickPayLandingVm.displayVpaErrorMessage(msg);
          else {
            quickPayLandingVm.verifyUpiIdError = quickPayLandingVm.displayVpaErrorMessage(msg);
            console.log("quickPayLandingVm.verifyUpiIdError", quickPayLandingVm.verifyUpiIdError);
          }

        });
      } else { //for UPI Id 
        quickPayService.qp_vpa_upiId = quickPayLandingVm.qp_vpa_upiId;
        utilityService.showSpinner();

        var json = JSON.stringify({
          "addInfo": {
            "addInfo10": constantConfig.upiConstant.addInfo10,
            "addInfo9": constantConfig.upiConstant.addInfo9
          },
          "payeeType": {
            "virtualAddress": paymentType !== 'QR' ? quickPayLandingVm.qp_vpa_upiId.toString() : quickPayLandingVm.qp_qr_upiId.toString()
          },
          "requestInfo": {
            "pspId": constantConfig.upiConstant.pspId,
            "pspRefNo": generateRandomString(27)
          },
          "vAReqType": constantConfig.upiConstant.vAReqType_T
        });

        bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json, "YQP").then(function (data) {
          utilityService.hideSpinner();
          quickPayService.payToContactData.payment_type = paymentType;
          checkVpaResponse = JSON.parse(data);
          quickPayService.checkVpaResponse = checkVpaResponse;

           if(quickPayService.checkVpaResponse){
              quickPayService.checkVapaResponseAvailability = true;
            }else{
                quickPayService.checkVapaResponseAvailability = false;
            }

          console.log("checkVpaResponse", checkVpaResponse);
          if (checkVpaResponse.status == 'VE') {
            quickPayLandingVm.payeeName = checkVpaResponse.payeeType.name;
            quickPayLandingVm.payeeVAP = checkVpaResponse.payeeType.virtualAddress;
            quickPayService.payeeVAP = quickPayLandingVm.payeeVAP;

            //verify from mapper/number or upi id 
            quickPayLandingVm.isFromMapper = false;
            quickPayLandingVm.isFromUPI = true;

            quickPayService.isFromMapper = quickPayLandingVm.isFromMapper;
            quickPayService.isFromUPI = quickPayLandingVm.isFromUPI;
           
            //clear merchant info from mapper
            if (quickPayService.merchantInfo) {
                quickPayService.merchantInfo = '';
            } 

            quickPayLandingVm.favUPIAddr = quickPayLandingVm.payeeVAP;

            if (paymentType == 'QR')
              quickPayLandingVm.payToVpa('QR');
          } else {
            if (paymentType !== 'QR')
              quickPayLandingVm.verifyUpiIdError = checkVpaResponse.statusDesc;
            else {
              utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);

            }

          }
        }, function (msg) {
          utilityService.hideSpinner();
          if (paymentType !== 'QR')
            quickPayLandingVm.verifyUpiIdError = quickPayLandingVm.displayVpaErrorMessage(msg);
          else {
            quickPayLandingVm.verifyUpiIdError = quickPayLandingVm.displayVpaErrorMessage(msg);
          }

        });
      }
    }

      //for view balance
      quickPayLandingVm.viewBalance = function (account) {
        quickPayLandingVm.accountBalance = "";
        
        utilityService.showSpinner();
        
        var json = JSON.stringify({
          "addInfo": {
            "addInfo10": constantConfig.upiConstant.addInfo10,
            "addInfo9": constantConfig.upiConstant.addInfo9
          },
          "requestInfo": {
            "pspId": constantConfig.upiConstant.pspId,
            "pspRefNo": generateRandomString(27)
          },
          "virtualAddress": quickPayLandingVm.selectedVpa.virtualAddress,
          "accountId": account.accId
        });

        bhimUpiService.getNativeData(constantConfig.upiConstant.onBalanceEnquiry, json).then(function (data) {
          var checkBalanceRes = JSON.parse(data).apiResp;
          utilityService.hideSpinner();
          if (checkBalanceRes.status == 'S') {
            quickPayLandingVm.accountBalance = checkBalanceRes.accountInfo.accountBalance;
          } else {
            utilityService.showBhimUpiAlert("error", checkBalanceRes.statusDesc);
          }
        }, function (msg) {
          utilityService.hideSpinner();
          if (msg != -101)
            utilityService.showBhimUpiAlert("error", msg);
        });
      }

      quickPayLandingVm.hideBalance = function(){
        quickPayLandingVm.accountBalance = !quickPayLandingVm.accountBalance;
      }



    //functionality for pay to vpa - pay button click
    quickPayLandingVm.payToVpa = function (paymentType) {
     var template = "";
    

      if (paymentType !== 'QR' && (!quickPayLandingVm.qp_vpa_amount || quickPayLandingVm.qp_vpa_amount < 1 || quickPayLandingVm.qp_vpa_amount > parseInt(quickPayService.yqpVpaLimit))) {
        quickPayLandingVm.amountError = true;
        return true;
      } else if (paymentType == 'QR' && (!quickPayLandingVm.qp_qr_amount || quickPayLandingVm.qp_qr_amount < 1 || quickPayLandingVm.qp_qr_amount > parseInt(quickPayService.yqpVpaLimit))) {
        quickPayLandingVm.qrAmountError = true;
        return true;
      }
      else if (paymentType !== 'QR' && quickPayService.preAuthType == 'biometric') {
         quickPayService.payment_type = paymentType;
         quickPayService.qp_vpa_amount = quickPayLandingVm.qp_vpa_amount;
         quickPayService.qp_vpa_remark = quickPayLandingVm.qp_vpa_remark;

        if (quickPayService.customerInfo.yqpBiometricAmt !== null) {
          if (parseInt(quickPayService.customerInfo.yqpBiometricAmt) >= 0) {
            var checkAmount = parseInt(quickPayService.yqpBiometricLimit) - parseInt(quickPayService.customerInfo.yqpBiometricAmt);
            if (parseInt(quickPayLandingVm.qp_vpa_amount) > checkAmount) {
              //show error message
              
              var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
              var ok_btn = "OK";
              var onTapgo = 'menu.quickPayPreAuth';
              var onTapCancel = '';
              var cancel_btn = 'Cancel';
              quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
              return true;
            }
          }
        }
        else {
          var checkAmount = quickPayService.yqpBiometricLimit;
          if (parseInt(quickPayLandingVm.qp_vpa_amount) > checkAmount) {
            //show error message
            var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
            var ok_btn = "OK";
            var onTapgo = 'menu.quickPayPreAuth';
            var onTapCancel = '';
            var cancel_btn = 'Cancel';
            quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
            return true;
          }
        }
      }
      else if (paymentType == 'QR' && quickPayService.preAuthType == 'biometric') {
          quickPayService.payment_type = paymentType;
        if (quickPayService.customerInfo.yqpBiometricAmt !== null) {
          if (parseInt(quickPayService.customerInfo.yqpBiometricAmt) >= 0) {
            var checkAmount = parseInt(quickPayService.yqpBiometricLimit) - parseInt(quickPayService.customerInfo.yqpBiometricAmt);
            if (parseInt(quickPayLandingVm.qp_qr_amount) > checkAmount) {
              //show error message
              var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
              var btn_array = [
                {
                  text: "Cancel",
                  type: 'button-negative',
                  onTap: function () {
                    checkEnablePopup.close();

                  }
                },
                {
                  text: "OK",
                  type: 'button-positive',
                  onTap: function () {
                    checkEnablePopup.close();
                    $scope.payToScanQRModal.hide();
                    $timeout(function () {
                      $state.go('menu.quickPayPreAuth');
                    }, 300);
                  }
                }
              ];
              template = '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" alt="popup_icon" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
                + message + '</span></div></div></div>';
              var checkEnablePopup = $ionicPopup.alert({
                template: template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
              });
              checkEnablePopup.then(function (res) {
              });
              return true;
            }
          }
        }
        else {
          var checkAmount = quickPayService.yqpBiometricLimit;
          if (parseInt(quickPayLandingVm.qp_qr_amount) > checkAmount) {
            //show error message
            var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
            var btn_array = [
              {
                text: "Cancel",
                type: 'button-negative',
                onTap: function () {
                  checkEnablePopup.close();

                }
              },
              {
                text: "OK",
                type: 'button-positive',
                onTap: function () {
                  checkEnablePopup.close();
                  $scope.payToScanQRModal.hide();
                  $timeout(function () {
                    $state.go('menu.quickPayPreAuth');
                  }, 300);
                }
              }
            ];
            template = '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" alt="popup_icon" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
              + message + '</span></div></div></div>';
            var checkEnablePopup = $ionicPopup.alert({
              template: template,
              scope: $scope,
              cssClass: 'bhim-alert-popup',
              buttons: btn_array,
            });
            checkEnablePopup.then(function (res) {
            });
            return true;
          }
        }
      }

      if (quickPayLandingVm.amountDisabled) {
        quickPayLandingVm.approveCollect();
      }
      else {
        utilityService.showSpinner();
          //for transaction details
            quickPayLandingVm.userProfileDet.selectedAccount = quickPayLandingVm.selectedAccount;
            quickPayLandingVm.userProfileDet.selectedVpa = quickPayLandingVm.selectedVpa;
            quickPayLandingVm.userProfileDet.name = quickPayLandingVm.userInfo.name;

            quickPayService.payToContactData.payment_type = paymentType;

            quickPayService.userProfileDet = quickPayLandingVm.userProfileDet;
            console.log("quickPayService.userProfileDet", quickPayService.userProfileDet);

        //check mapper or normal upi id depends on redirect to that perticular function 
        if (quickPayLandingVm.merchantInfo ) {
            quickPayLandingVm.payViaUpiNumber();
        } else {
          quickPayLandingVm.payViaUpiId();
         }
      }
    }


    //pay to upi using upi id
    quickPayLandingVm.payViaUpiId = function (paymentType) {
      var json = {
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "amount": paymentType !== 'QR' ? Number(quickPayLandingVm.qp_vpa_amount) : Number(quickPayLandingVm.qp_qr_amount),
        "expiryTime": 0,
        "payeeType": {
          "name": quickPayLandingVm.payeeName,
          "virtualAddress": paymentType !== 'QR' ? quickPayLandingVm.qp_vpa_upiId.toString() : quickPayLandingVm.qp_qr_upiId.toString(),
          "vpaType": "VA"
        },
        "payerType": {
          "accountId": quickPayLandingVm.remitterAccountObj.accId,
          "virtualAddress": quickPayLandingVm.remitterVPA
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "transactionNote": paymentType !== 'QR' ? (quickPayLandingVm.qp_vpa_remark || "") : (quickPayLandingVm.qp_qr_remark || ""),
        "upiTransRefNo": 0
      };

      if (quickPayLandingVm.currencyCode) {
        json["currencyCode"] = quickPayLandingVm.currencyCode;
      }
     
      if (quickPayLandingVm.ref_id) {
        json["ref_id"] = quickPayLandingVm.ref_id;
      }
      
      if (quickPayLandingVm.merchantCatCode) {
        json["merchantCatCode"] = quickPayLandingVm.merchantCatCode;
      }
      
      if (quickPayLandingVm.minAmount) {
        json["minAmount"] = quickPayLandingVm.minAmount;
      }
      
      if (quickPayLandingVm.ref_url) {
        json["ref_url"] = quickPayLandingVm.ref_url;
      }
      
      if (quickPayLandingVm.tid) {
        json["tid"] = quickPayLandingVm.tid;
      }
      
      json = JSON.stringify(json);

      bhimUpiService.getNativeData(constantConfig.upiConstant.onPayInitiation, json, "YQP").then(function (data) {
        utilityService.hideSpinner();

        if (paymentType == 'QR') {
          $scope.payToScanQRModal.hide();
        }
        $timeout(function () {

         quickPayService.paymentResponse = JSON.parse(data).apiResp;
           if (JSON.parse(data).apiResp.status == 'S') {
            utilityService.setCsatJournies("fundTransfer");
            quickPayService.paymentResponse.payeeName = quickPayLandingVm.payeeName;
            if (paymentType == 'QR')
              $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: true });
            else
              $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: true });
          } else {
            if (paymentType == 'QR')
              $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: false });
            else
              $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: false });
            }

        }, 500);
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = {};
        quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
        var errorMsg = "Confirmation on status of this transaction is pending. Please check status of the transaction from transaction history before retrying.";
        if (msg == ". UPI1006 : Connection Lost, please try again.")
          utilityService.showAlertPopUp('error', errorMsg, "", "", "", "");
        else if (paymentType == 'QR')
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: false });
        else
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: false });

      });
    }

    //for pay to upi - via number - mapper
    quickPayLandingVm.payViaUpiNumber = function (paymentType) {
       var jsonUpiMapperPay = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "accountInfo": {
          "accountBalance": "",
          "accountName": "",
          "accId": quickPayLandingVm.remitterAccountObj.accId,
          "maskedAccountNumber": quickPayLandingVm.selectedAccount.maskedAccountNumber,
          "aepsFlag": "",
          "atmFType": "",
          "atmLength": quickPayLandingVm.selectedAccount.bankId,
          "bankCode": quickPayLandingVm.selectedAccount.bankCode,
          "bankId": quickPayLandingVm.selectedAccount.bankId,
          "bankName": quickPayLandingVm.selectedAccount.bankName,
          "checkedAccount": quickPayLandingVm.selectedAccount.checkedAccount ? quickPayLandingVm.selectedAccount.checkedAccount : "",
          "formatType": quickPayLandingVm.selectedAccount.formatType,
          "ifscCode": quickPayLandingVm.selectedAccount.ifscCode,
          "iin": "",
          "otpFType": "",
          "otpLength": quickPayLandingVm.selectedAccount.otpLength,
          "preferredFlag": "",
          "refUrl": "",
          "uPinFType": quickPayLandingVm.selectedAccount.uPinFType,
          "mpinFlag": quickPayLandingVm.selectedAccount.mpinFlag,
          "uPinLength": quickPayLandingVm.selectedAccount.uPinLength,
          "mobileNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo ? $rootScope.checkDeviceInfo.deviceInfo.mobileNo.toString() : ""
        },
        "amount": paymentType !== 'QR' ? Number(quickPayLandingVm.qp_vpa_amount).toFixed(2) : Number(quickPayLandingVm.qp_qr_amount).toFixed(2),
        "expiryTime": 0,
        "initMode": "00",
        "cmId": quickPayLandingVm.merchantInfo.cmid,
        "npciTranId": generateRandomString(30),
        "payeeType": {
          "name": quickPayLandingVm.payeeName,
          "virtualAddress": paymentType !== 'QR' ? quickPayService.merchantInfo.fvaddr.toString() : quickPayLandingVm.qp_qr_upiId.toString(),
          "vpaType": "VA"
        },
        "payerType": {
          "accountId": quickPayLandingVm.remitterAccountObj.accId,
          "virtualAddress": quickPayLandingVm.remitterVPA
        },
        "ref_id": generateRandomString(30),
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "tid": generateRandomString(30),
        "transactionNote": paymentType !== 'QR' ? (quickPayLandingVm.qp_vpa_remark || "") : (quickPayLandingVm.qp_qr_remark || ""),
        "upiTransRefNo": 0
      });


      bhimUpiService.getNativeData(constantConfig.upiConstant.getUpiFundTransfer, jsonUpiMapperPay, "YQP").then(function (data) {
        utilityService.hideSpinner();
        
        $timeout(function () {

           quickPayService.paymentResponse = JSON.parse(data).apiResp;
          
          if (JSON.parse(data).apiResp.status == 'S') {
              utilityService.setCsatJournies("fundTransfer");
              quickPayService.paymentResponse.payeeName = quickPayLandingVm.payeeName;
              if (paymentType == 'QR')
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: true });
              else
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: true });
            } else {
              if (paymentType == 'QR')
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: false });
              else
                $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: false });
            }

        }, 500);
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = {};
        quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
        var errorMsg = "Confirmation on status of this transaction is pending. Please check status of the transaction from transaction history before retrying.";
        if (msg == ". UPI1006 : Connection Lost, please try again.")
          utilityService.showAlertPopUp('error', errorMsg, "", "", "", "");
        else if (paymentType == 'QR')
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_qr', isSuccess: false });
        else
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_vpa', isSuccess: false });

      });
    }

    //for reset vpa
    quickPayLandingVm.resetUserId = function(){
       if(quickPayLandingVm.favUPIAddr){
         quickPayLandingVm.favUPIAddr = '';
       }
    }
   
    //for reset vap fields
    quickPayLandingVm.resetVpaFields = function (type) {
      if (type == 'collect') {
        quickPayLandingVm.collect.verifyUpiIdError = "";
        quickPayLandingVm.collect.qp_vpa_amount = "";
        quickPayLandingVm.collect.qp_vpa_remark = "";
        quickPayLandingVm.collect.payerName = "";
        quickPayLandingVm.collect.amountError = "";
        quickPayLandingVm.collect.qrAmountError = "";

        //show verify button if more than 3 char with @
        quickPayLandingVm.collect.qp_vpa_upiId_valid = false;
        if (quickPayLandingVm.collect.upi_id) {
          if (quickPayLandingVm.collect.upi_id.length > 2) {
            quickPayLandingVm.collect.qp_vpa_upiId_valid = /^[-.a-zA-Z0-9\u2014\u2013]+@[a-zA-Z]+$/.test(quickPayLandingVm.collect.upi_id);
          }
        }
      }

      else {
        

        quickPayLandingVm.verifyUpiIdError = "";
        quickPayLandingVm.qp_vpa_amount = "";
        quickPayLandingVm.qp_vpa_remark = "";
        quickPayLandingVm.amountError = "";
        quickPayLandingVm.qrAmountError = "";
       

        //show verify button if more than 3 char with @
        quickPayLandingVm.qp_vpa_upiId_valid = false;
        quickPayLandingVm.qp_vpa_upiId_varifyAct = false;

        if (quickPayLandingVm.qp_vpa_upiId) {
          if (quickPayLandingVm.qp_vpa_upiId.length > 2) {
            quickPayLandingVm.qp_vpa_upiId_valid = /^[-.a-zA-Z0-9\u2014\u2013]+@+$/.test(quickPayLandingVm.qp_vpa_upiId);
            quickPayLandingVm.qp_vpa_upiId_validSign = /^[0-9]+$/.test(quickPayLandingVm.qp_vpa_upiId);
            console.log("quickPayLandingVm.qp_vpa_upiId_validSign", quickPayLandingVm.qp_vpa_upiId_validSign);

      
              if (quickPayLandingVm.qp_vpa_upiId.indexOf('@') > -1){
                  quickPayLandingVm.qp_vpa_upiId_varifyAct = true;
                }
            
            

            if (quickPayLandingVm.qp_vpa_upiId_valid) {
                quickPayLandingVm.bankUpiHide = true;
            } else {
              quickPayLandingVm.bankUpiHide = false;
            }

          }

          //for clear payee name when user edit or change vpa
          if(quickPayLandingVm.payeeName && quickPayLandingVm.qp_vpa_upiId && quickPayLandingVm.isEditVpaField){
              quickPayLandingVm.payeeName = '';
          }

         

          //for 8 number
          //check if upi is numeric
          quickPayLandingVm.isNumericUPI = /^-?\d+$/.test(quickPayLandingVm.qp_vpa_upiId);
          if(quickPayLandingVm.isNumericUPI){
            if (quickPayLandingVm.qp_vpa_upiId.length > 7) {
                quickPayLandingVm.qp_vpa_upiId_varifyAct = true;
            } else {
              quickPayLandingVm.qp_vpa_upiId_varifyAct = false;
            }
          }
     
        }
      }

    }

    //for bind bank name 
    quickPayLandingVm.bindUPI = function (bankName) {
      if (quickPayLandingVm.qp_vpa_upiId_valid) {
        var validBank = bankName;
        quickPayLandingVm.qp_vpa_upiId = quickPayLandingVm.qp_vpa_upiId.concat(validBank);
        quickPayLandingVm.qp_vpa_upiId_varifyAct = true;

      } else {
        quickPayLandingVm.bankUpiHide = false;
      }
    }

    /*********** Pay To VPA END ************/

    /********** Pay To QR code START ************/
    quickPayLandingVm.getParameterByName = function (name, url) {
      if (!url) url = window.location.href;
      name = name.replace(/[\[\]]/g, "\\$&");
      var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
      if (!results) return null;
      if (!results[2]) return '';
      if (name == 'am') {
        if (results[2].search("E") !== -1 || results[2].search("e") !== -1) {
          return results[2];
        }
      }
      return decodeURIComponent(results[2].replace(/\+/g, " "));
    }


    quickPayLandingVm.scanQRFav = function (fav_id) {
      quickPayLandingVm.contact_active = false;
      quickPayLandingVm.vpa_active = false;
      quickPayLandingVm.scan_active = true;
      quickPayLandingVm.beneficiary_active = false;
      quickPayLandingVm.qp_qr_amount = '';
      quickPayLandingVm.qp_qr_remark = '';
      quickPayLandingVm.qp_qr_upiId = fav_id.lastTransactionType;
      quickPayLandingVm.qp_qr_amount = fav_id.beneficiaryTransferAmount;
      $scope.payToScanQRModal.show();
    }

    function setQRDetails(barcodeData) {
      quickPayLandingVm.qp_qr_amount = '';
      quickPayLandingVm.qp_qr_remark = '';
      try {
        if (quickPayLandingVm.getParameterByName('am', barcodeData)) {
          var amt = Number(quickPayLandingVm.getParameterByName('am', barcodeData).substring(0, 10));
          var format = /[ `!@#$%^&*()_+\-=\[\]{};':"\\|,<>\/?~]/;
          
          if (!format.test(amt)) {
            quickPayLandingVm.qp_qr_amount = parseFloat(amt).toFixed(2);
          }
          else {
            $scope.closepayToScanQRModalFun();
            utilityService.showErrorMessage("Invalid QR Code");

          }
        }
        if (quickPayLandingVm.getParameterByName('tn', barcodeData)) {
          var remarks = quickPayLandingVm.getParameterByName('tn', barcodeData);
          var format = /[`!$%^&*+\-=\[\]{}':"\\|,<>\/?~]/;
          if (!format.test(remarks)) {
            quickPayLandingVm.qp_qr_remark = quickPayLandingVm.getParameterByName('tn', barcodeData);
          }

          else {
            $scope.closepayToScanQRModalFun();
            utilityService.showErrorMessage("Invalid QR Code");

          }
        }
        if (quickPayLandingVm.getParameterByName('cu', barcodeData))
          quickPayLandingVm.currencyCode = quickPayLandingVm.getParameterByName('cu', barcodeData);
        if (quickPayLandingVm.getParameterByName('tr', barcodeData))
          quickPayLandingVm.ref_id = quickPayLandingVm.getParameterByName('tr', barcodeData);
        if (quickPayLandingVm.getParameterByName('mc', barcodeData))
          quickPayLandingVm.merchantCatCode = quickPayLandingVm.getParameterByName('mc', barcodeData);
        if (quickPayLandingVm.getParameterByName('mam', barcodeData))
          quickPayLandingVm.minAmount = quickPayLandingVm.getParameterByName('mam', barcodeData);
        if (quickPayLandingVm.getParameterByName('url', barcodeData))
          quickPayLandingVm.ref_url = quickPayLandingVm.getParameterByName('url', barcodeData);
        if (quickPayLandingVm.getParameterByName('tid', barcodeData))
          quickPayLandingVm.tid = quickPayLandingVm.getParameterByName('tid', barcodeData);

        quickPayLandingVm.contact_active = false;
        quickPayLandingVm.vpa_active = false;
        quickPayLandingVm.scan_active = true;
        quickPayLandingVm.beneficiary_active = false;

      } catch (e) {
        console.log(e);
      }
    }
    quickPayLandingVm.scanQR = function () {
      bhimUpiService.getNativeData(constantConfig.upiConstant.scanqrcode, {}, "YQP").then(function (data) {
        var barcodeData = '';
        if (device.platform.toLowerCase() == 'android') {
          barcodeData = data.scanResult;
        } else {
          barcodeData = data;
        }


        $scope.payToScanQRModal.show();

        quickPayLandingVm.qp_qr_upiId = quickPayLandingVm.getParameterByName('pa', barcodeData);


        if (!quickPayLandingVm.qp_qr_upiId) {
          utilityService.showBhimUpiAlert("alert", "Invalid QR");
          return false;
        }
        utilityService.showSpinner();
        var json = JSON.stringify({
          "addInfo": {
            "addInfo10": constantConfig.upiConstant.addInfo10,
            "addInfo9": constantConfig.upiConstant.addInfo9
          },
          "payeeType": {
            "virtualAddress": quickPayLandingVm.qp_qr_upiId.toString()
          },
          "requestInfo": {
            "pspId": constantConfig.upiConstant.pspId,
            "pspRefNo": generateRandomString(27)
          },
          "vAReqType": constantConfig.upiConstant.vAReqType_T
        });


        bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (responseData) {
          var checkVpaResponse = JSON.parse(responseData);
          if (checkVpaResponse.status == 'VN') {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "This QR code data doesn't exist. Kindly check the image.");
          } else if (checkVpaResponse.status == 'VE') {
            quickPayLandingVm.payeeDetails = {

              name: checkVpaResponse.payeeType.name || "",

            }
            utilityService.hideSpinner();
          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("error", "Invalid QR");
          }
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });

        if (barcodeData.indexOf("upi://pay?") == 0) {
          if (quickPayLandingVm.qp_qr_upiId) {

            setQRDetails(barcodeData);
          }
          else {
            $scope.closepayToScanQRModalFun();
            utilityService.showErrorMessage("Invalid QR Code");
          }
        } else {
          bhimUpiService.getQRCode(barcodeData).then(function (res) {

            if (res.validStatus == 0) {
              if (res.isQRValid == true) {
                $scope.closepayToScanQRModalFun();
                utilityService.showBhimUpiAlert("error", quickPayLandingVm.YQP_MERCHANT_QR_ERR);
              } else {
                $scope.closepayToScanQRModalFun();
                utilityService.showBhimUpiAlert("error", "Invalid QR Code");
              }
            } else {
              setQRDetails(barcodeData);
              
            }
          }, function (error) {
            $scope.closepayToScanQRModalFun();
            utilityService.showBhimUpiAlert("error", error.responseMessage);
          });
         
        }
      }, function (error) {
        utilityService.showBhimUpiAlert("error", error);
      });
    }
    /********** Pay To QR code END ************/

    /********** Collect Request START */
    quickPayLandingVm.redirectToCollectBhimUpi = function (type) {
      utilityService.showSpinner();
      if (!localStorage.getItem("appGenId")) {
        bhimUpiService.getNativeData("generateAppGenId", {}, "YQP").then(function (data) {
          if (device.platform.toLowerCase() == 'android') {
            bhimUpiService.appGenId = data.appGenId;
          } else {
            bhimUpiService.appGenId = data;
          }
          quickPayLandingVm.redirectToCollectRequest(type);
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
      } else {
        bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId"), "YQP").then(function (data) {
          quickPayLandingVm.redirectToCollectRequest(type);
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
      }
    }

    quickPayLandingVm.redirectToCollectRequest = function (type) {
      if (device.platform.toLowerCase() == 'android') {
        utilityService.showSpinner();
        var json = JSON.stringify({});
        bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json, "YQP").then(function (data) {
          if (data.permission === 'Allowed') {
            quickPayLandingVm.redirectToCollectReqJourney(type);
          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
          }
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
      } else if (device.platform.toLowerCase() == 'windows') {
        ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
      } else {
        utilityService.showSpinner();
        var json = JSON.stringify({
          "pspId": constantConfig.upiConstant.pspId,
          "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
        });
        bhimUpiService.getNativeData(constantConfig.upiConstant.initializeIOSsdk, json, "YQP").then(function (data) {
          if (data !== "S") {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("error", data);
            return false;
          }
          utilityService.showSpinner();
          var json = JSON.stringify({
            "addInfo": {
              "addInfo10": constantConfig.upiConstant.addInfo10,
              "addInfo9": constantConfig.upiConstant.addInfo9
            },
            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "updateFlag": constantConfig.upiConstant.updateFlag,
            "smsSent": "false"
          });
          bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json, "YQP").then(function (data) {
            $rootScope.checkDeviceInfo = JSON.parse(data);
            if ($rootScope.checkDeviceInfo.status == 'S') {
              if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                quickPayLandingVm.getUPIProfile(type);
              } else {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", quickPayLandingVm.YQP_NOT_REG_UPI);
              }
            } else {
              utilityService.hideSpinner();
              utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
            }
          }, function (msg) {
            utilityService.hideSpinner();
            quickPayLandingVm.showVpaErrorMessage(msg);
          });
        }, function (msg) {
          utilityService.hideSpinner();
          quickPayLandingVm.showVpaErrorMessage(msg);
        });
      }
    }

    quickPayLandingVm.redirectToCollectReqJourney = function (type) {
      /*Sim card Info fetching - Start*/
      function simInfosuccessCallback(result) {
        if (result !== undefined && result != null && result != '') {
          if (result.cards && result.cards.length > 0) {
            customerInfoService.simCardInfo = result;

            utilityService.showSpinner();
            var json = JSON.stringify({
              "addInfo": {
                "addInfo10": constantConfig.upiConstant.addInfo10,
                "addInfo9": constantConfig.upiConstant.addInfo9
              },
              "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
              "requestInfo": {
                "pspId": constantConfig.upiConstant.pspId,
                "pspRefNo": generateRandomString(27)
              },
              "updateFlag": constantConfig.upiConstant.updateFlag,
              "smsSent": false
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json, "YQP").then(function (data) {
              $rootScope.checkDeviceInfo = JSON.parse(data);
              if ($rootScope.checkDeviceInfo.status == 'S') {
                if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                  quickPayLandingVm.getUPIProfile(type);
                } else {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("error", quickPayLandingVm.YQP_NOT_REG_UPI);
                }
              } else {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
              }
            }, function (msg) {
              utilityService.hideSpinner();
              quickPayLandingVm.showVpaErrorMessage(msg);
            });

          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
          }
        } else {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
        }
      }

      function HasPerminionSuccessCallback(result) {
        if (result) {
          window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
        } else {
          requestReadPermission();
        }
      }

      function errorCallback(error) {
        var elementSimInfo = document.getElementById('ErrorInfo');
        elementSimInfo.innerHTML = error;
      }

      function requestSuccessCallback(result) {
        if (result) {
          hasReadPermission();
        }
      }
      // Android only: check permission
      function hasReadPermission() {
        window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
      }
      // Android only: request permission
      function requestReadPermission() {
        window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
      }
      hasReadPermission();
      /*Sim card Info fetching - End*/
    }
    /********** Collect Request END */

    /********** Common UPI code START ***********/
    quickPayLandingVm.redirectToBhimUpi = function (paymentType, fav_id) {
      utilityService.showSpinner();           
      if (!localStorage.getItem("appGenId")) {
        bhimUpiService.getNativeData("generateAppGenId", {}, "YQP").then(function (data) {
          if (device.platform.toLowerCase() == 'android') {
            bhimUpiService.appGenId = data.appGenId;
          } else {
            bhimUpiService.appGenId = data;
          }
          quickPayLandingVm.redirectToBhimUpiFlow(paymentType, fav_id);
        }, function (msg) {
          utilityService.hideSpinner();          
          if (paymentType !== 'pending') {
            utilityService.showBhimUpiAlert("error", msg);
          }
        });
      } else {
        bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId"), "YQP").then(function (data) {
          quickPayLandingVm.redirectToBhimUpiFlow(paymentType, fav_id);
        }, function (msg) {
          utilityService.hideSpinner();         
          if (paymentType !== 'pending') {
            utilityService.showBhimUpiAlert("error", msg);
          }
        });
      }
    }

    quickPayLandingVm.redirectToBhimUpiFlow = function (paymentType, fav_id) {
      if (device.platform.toLowerCase() == 'android') {
        utilityService.showSpinner();        
        var json = JSON.stringify({});
        bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json, "YQP").then(function (data) {
          if (data.permission === 'Allowed') {
            quickPayLandingVm.redirectToBhimUpiJourney(paymentType, fav_id);
          } else {
            utilityService.hideSpinner();            
            utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
          }
        }, function (msg) {
          utilityService.hideSpinner();          
          if (paymentType !== 'pending') {
            utilityService.showBhimUpiAlert("error", msg);
          }
        });
      } else if (device.platform.toLowerCase() == 'windows') {
        ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
      } else {
        utilityService.showSpinner();        
        var json = JSON.stringify({
          "pspId": constantConfig.upiConstant.pspId,
          "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
        });
        bhimUpiService.getNativeData(constantConfig.upiConstant.initializeIOSsdk, json, "YQP").then(function (data) {
          if (data !== "S") {
            utilityService.hideSpinner();           
            if (paymentType !== 'pending') {
              utilityService.showBhimUpiAlert("error", data);
            }
            return false;
          }
          utilityService.showSpinner();          
          var json = JSON.stringify({
            "addInfo": {
              "addInfo10": constantConfig.upiConstant.addInfo10,
              "addInfo9": constantConfig.upiConstant.addInfo9
            },
            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "updateFlag": constantConfig.upiConstant.updateFlag,
            "smsSent": "false"
          });
          bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json, "YQP").then(function (data) {
            $rootScope.checkDeviceInfo = JSON.parse(data);
            if ($rootScope.checkDeviceInfo.status == 'S') {
              if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                quickPayLandingVm.getUPIProfile(paymentType, fav_id);
              } else {
                utilityService.hideSpinner();                
                if (paymentType !== 'pending') {
                   $state.go('menu.createNewVpaLogin');  // need to change here
                }
              }
            } else {
              utilityService.hideSpinner();             
              if (paymentType !== 'pending') {
                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
              }
            }
          }, function (msg) {
            utilityService.hideSpinner();           
            if (paymentType !== 'pending') {
              quickPayLandingVm.showVpaErrorMessage(msg);
            }
          });
        }, function (msg) {
          utilityService.hideSpinner();          
          if (paymentType !== 'pending') {
            quickPayLandingVm.showVpaErrorMessage(msg);
          }
        });
      }
    }

    quickPayLandingVm.redirectToBhimUpiJourney = function (paymentType, fav_id) {
      /*Sim card Info fetching - Start*/
      function simInfosuccessCallback(result) {
        if (result !== undefined && result != null && result != '') {
          if (result.cards && result.cards.length > 0) {
            customerInfoService.simCardInfo = result;
            utilityService.showSpinner();           
            var json = JSON.stringify({
              "addInfo": {
                "addInfo10": constantConfig.upiConstant.addInfo10,
                "addInfo9": constantConfig.upiConstant.addInfo9
              },
              "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
              "requestInfo": {
                "pspId": constantConfig.upiConstant.pspId,
                "pspRefNo": generateRandomString(27)
              },
              "updateFlag": constantConfig.upiConstant.updateFlag,
              "smsSent": false
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json, "YQP").then(function (data) {
              $rootScope.checkDeviceInfo = JSON.parse(data);
              if ($rootScope.checkDeviceInfo.status == 'S') {
                if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                  quickPayLandingVm.getUPIProfile(paymentType, fav_id);
                } else {
                  utilityService.hideSpinner();                
                  if (paymentType !== 'pending') {
                    
                     $state.go('menu.createNewVpaLogin');
                  }
                }
              } else {
                utilityService.hideSpinner();                
                if (paymentType !== 'pending') {
                  utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                }
              }
            }, function (msg) {
              utilityService.hideSpinner();             
              if (paymentType !== 'pending') {
                quickPayLandingVm.showVpaErrorMessage(msg);
              }
            });

          } else {
            utilityService.hideSpinner();           
            if (paymentType !== 'pending') {
              utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
            }
          }
        } else {
          utilityService.hideSpinner();          
          if (paymentType !== 'pending') {
            utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
          }
        }
      }

      function HasPerminionSuccessCallback(result) {
        if (result) {
          window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
        } else {
          requestReadPermission();
        }
      }

      function errorCallback(error) {
        var elementSimInfo = document.getElementById('ErrorInfo');
        elementSimInfo.innerHTML = error;
      }

      function requestSuccessCallback(result) {
        if (result) {
          hasReadPermission();
        }
      }
      // Android only: check permission
      function hasReadPermission() {
        window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
      }
      // Android only: request permission
      function requestReadPermission() {
        window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
      }
      hasReadPermission();
      /*Sim card Info fetching - End*/
    }

    quickPayLandingVm.getUPIProfile = function (paymentType, fav_id) {
      utilityService.showSpinner();     
      var json = JSON.stringify({
        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "updateFlag": constantConfig.upiConstant.updateFlag
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json, "YQP").then(function (data) {
        utilityService.hideSpinner();      
        var getProfileResponse = JSON.parse(data);
        console.log("getProfileResponse", getProfileResponse);
        if (getProfileResponse.status == "S") {
          quickPayLandingVm.getProfileResponse = getProfileResponse;
          quickPayService.getProfileResponse = quickPayLandingVm.getProfileResponse;
          for (var i = 0; i < getProfileResponse.vpaAccountDetails.length; i++) {
            if (getProfileResponse.vpaAccountDetails[i].defVPAStatus) {
              quickPayLandingVm.remitterVPA = getProfileResponse.vpaAccountDetails[i].virtualAddress;
              for (var j = 0; j < getProfileResponse.vpaAccountDetails[i].accountInfo.length; j++) {
                if (getProfileResponse.vpaAccountDetails[i].accountInfo[j].preferredFlag == 'T') {
                  quickPayLandingVm.remitterAccountObj = getProfileResponse.vpaAccountDetails[i].accountInfo[j];
                }
              }
            }
          }
          if (paymentType == 'pending') {
            
            quickPayLandingVm.getPendingRequestsViaSDK();
          }
          if (paymentType == 'collect_scan') {
            quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
            quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;
            quickPayLandingVm.collect_contact_active = false;
            quickPayLandingVm.collect_vpa_active = false;
            quickPayLandingVm.collect_scan_active = true;

          }
          if (paymentType == 'collect_vpa') {
            quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
            quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;
            quickPayLandingVm.collect_contact_active = false;
            quickPayLandingVm.collect_vpa_active = true;
            quickPayLandingVm.collect_scan_active = false;

          }
          if (paymentType == 'collect_contact') {
            quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
            quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;
            quickPayLandingVm.collectVerifyUpiId('contact_vpa');
          }
          if (paymentType == 'contact_vpa') {
            quickPayLandingVm.verifyUpiIdContact('contact_vpa');
          }
          if (paymentType == 'vpa') {
            quickPayLandingVm.contact_active = false;
            quickPayLandingVm.vpa_active = true;
            quickPayLandingVm.scan_active = false;
            quickPayLandingVm.beneficiary_active = false;
            quickPayService.mySubTab = 'vpa';
            quickPayLandingVm.qp_vpa_upiId = "";
            //payment via favourites start
            if (fav_id) {
              quickPayLandingVm.qp_vpa_upiId = fav_id.lastTransactionType;
              quickPayLandingVm.qp_vpa_amount = fav_id.beneficiaryTransferAmount;
              quickPayLandingVm.verifyUpiId('VPA');
            }
            //payment via favourites end
          }
          if (paymentType == 'scan') {
            
            if (fav_id) {
              quickPayLandingVm.scanQRFav(fav_id);
            }
            else {
              quickPayLandingVm.scanQR();
            }
          }

        } else {
          if (paymentType !== 'pending') {
            utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
          }
        }
      }, function (msg) {
          utilityService.hideSpinner();
        if (paymentType !== 'pending') {
          quickPayLandingVm.showVpaErrorMessage(msg);
        }
      });
    }

    quickPayLandingVm.showVpaErrorMessage = function (errorCode) {
      switch (errorCode) {
        case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
          break;

        case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
          break;

        case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
          break;

        case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
          break;

        case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
          break;

        case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
          break;

        case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
          break;

        default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
      }
    };
    quickPayLandingVm.displayVpaErrorMessage = function (errorCode) {
      switch (errorCode) {
        case -1: return constantConfig.upiConstant.minusOne;
          break;

        case -2: return constantConfig.upiConstant.minusTwo;
          break;

        case -3: return constantConfig.upiConstant.minusThree;
          break;

        case -4: return constantConfig.upiConstant.minusFour;
          break;

        case -5: return constantConfig.upiConstant.minusFive;
          break;

        case -6: return constantConfig.upiConstant.minusSix;
          break;

        case -7: return constantConfig.upiConstant.minusSeven;
          break;

        default: return constantConfig.upiConstant.someWentWrong;
      }
    };
    /********** Common UPI code END ***********/

   

    function onLoadFunctionCalls() {
      utilityService.showSpinner();
      
      $translate(['YQP_PAY_CONTACT', 'YQP_PAY_BENEFICIARY', 'INVAID_BEN_AMT_MSG', 'INVAID_AMT_MSG_GRT', 'INVAID_AMT_MSG_LESS_1', 'YQP_BIO_LOGIN_DISC', 'YQP_INSUFFICIENT_BAL','YQP_ACCNT_NOT_TRANSACTIONAL', 'YQP_NOT_REG_UPI', 'YQP_MERCHANT_QR_ERR']).then(function (translations) {
        quickPayLandingVm.pay_to_contact_txt = translations['YQP_PAY_CONTACT'];
        quickPayLandingVm.pay_to_beneficiary_txt = translations['YQP_PAY_BENEFICIARY'];
        quickPayLandingVm.INVAID_AMT_MSG_GRT = translations['INVAID_AMT_MSG_GRT'];
        quickPayLandingVm.INVAID_AMT_MSG_LESS_1 = translations['INVAID_AMT_MSG_LESS_1'];
        quickPayLandingVm.INVAID_BEN_AMT_MSG = translations['INVAID_BEN_AMT_MSG'];
        quickPayLandingVm.YQP_BIO_LOGIN_DISC = translations['YQP_BIO_LOGIN_DISC'];
        quickPayLandingVm.YQP_INSUFFICIENT_BAL = translations['YQP_INSUFFICIENT_BAL'];
        quickPayLandingVm.YQP_ACCNT_NOT_TRANSACTIONAL = translations['YQP_ACCNT_NOT_TRANSACTIONAL'];
        quickPayLandingVm.YQP_MIN_AMNT_ERROR = translations['INVAID_AMT_MSG_LESS_1'];
        quickPayLandingVm.YQP_NOT_REG_UPI = translations['YQP_NOT_REG_UPI'];
        quickPayLandingVm.YQP_MERCHANT_QR_ERR = translations['YQP_MERCHANT_QR_ERR'];
      });
      $translate(['YQP_BIO_AUTH_CUM_ERROR'], { amount: parseInt(quickPayService.yqpBiometricLimit) }).then(function (translations) {
        quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR = translations['YQP_BIO_AUTH_CUM_ERROR'];
      });
      $translate(['INVAID_AMT_MSG'], { amount: $filter('INR')(parseInt(quickPayService.yqpVpaLimit)) }).then(function (translations) {
        quickPayLandingVm.INVAID_AMT_MSG = translations['INVAID_AMT_MSG'];
      });
      $translate(['INVAID_COLLECT_AMT_MSG'], { amount: $filter('INR')(parseInt(quickPayService.yqpRaiseRequestLimit)) }).then(function (translations) {
        quickPayLandingVm.INVAID_COLLECT_AMT_MSG = translations['INVAID_COLLECT_AMT_MSG'];
      });

      
       quickPayService.addFavLoader = false;
        quickPayService.requestSent = quickPayService.requestSent + 1;
        quickPayLandingVm.getFavorites();

     //get all beneficiary data from success 
     
      //If user has choose the pay option from transaction list
      if (quickPayService.payFromTransList) {
          quickPayLandingVm.payViaTransaction(quickPayService.payFromTransListData);
      }

       //transaction details show in next page  and 
      if ((quickPayService.fav_id && quickPayService.payFromTransList) 
          || (quickPayService.fav_id && quickPayService.paytoFavClick) 
          || (quickPayService.fav_id && quickPayService.frequentlClick)) {
                                                                                                               
          if(quickPayService.fav_id.beneficiaryType == 'VPA_Contact'){
                  quickPayLandingVm.payToContact.favUPIAddr = quickPayService.fav_id.lastTransactionType;
                    quickPayLandingVm.payToContact.name = quickPayService.fav_id.beneficiaryName;
                    quickPayLandingVm.beneficiaryType = quickPayService.fav_id.beneficiaryType;
                    quickPayLandingVm.qp_vpa_upiId = quickPayService.fav_id.lastTransactionType;

                    //only for favorite list
                    if(quickPayService.paytoFavClick){
                         quickPayLandingVm.payToContact.amount = quickPayService.fav_id.beneficiaryTransferAmount;
                    }
            }else{
                    quickPayLandingVm.favUPIAddr = quickPayService.fav_id.lastTransactionType;
                    quickPayLandingVm.payeeName = quickPayService.fav_id.beneficiaryName;
                    quickPayLandingVm.beneficiaryType = quickPayService.fav_id.beneficiaryType;
                    quickPayLandingVm.qp_vpa_upiId = quickPayService.fav_id.lastTransactionType;

                    //only for favorite list
                    if(quickPayService.paytoFavClick){
                         quickPayLandingVm.qp_vpa_amount = quickPayService.fav_id.beneficiaryTransferAmount;
                    }
            }

            //reset all transactions
            if(quickPayService.payFromTransList){
              quickPayService.payFromTransList = false;
            }

            if(quickPayService.paytoFavClick){
                quickPayService.paytoFavClick = false;
            }

            if(quickPayService.frequentlClick){
                quickPayService.frequentlClick = false;
            }
        }

      //If user has choose the pay option from pending request
      if (quickPayService.payFromCollectRequest) {
        quickPayService.payFromCollectRequest = false;
        quickPayLandingVm.payViaCollectRequest(quickPayService.payFromCollectRequestData);
      }

      if (quickPayService.preAuthType == 'mpin' || quickPayService.preAuthType == 'userName') {
        if (!getAccountDetailsService.accountOverviewData) {
          homeScreenService.isCustCalled = true;
          quickPayService.requestSent = quickPayService.requestSent + 1;
          quickPayService.customerAccountInfoLoader = false;
          quickPayService.getCustomerInfo().then(function (data) {
            if (!utilityService.isUndefined(data)) {
              getAccountDetailsService.accountOverviewData = data;
              customerInfoService.customerInfo = data.customerInformation;
            }
            homeScreenService.isCustCalled = false;
            quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
            quickPayService.requestReceived = quickPayService.requestReceived + 1;
            quickPayLandingVm.hideOnLoadSpinner();

          }, function (error) {
            homeScreenService.isCustCalled = false;
            $rootScope.profileImageUrl = 'img/profile_placeholder.svg';
            quickPayService.requestReceived = quickPayService.requestReceived + 1;
            quickPayLandingVm.hideOnLoadSpinner();
          });
        } else {          
          quickPayLandingVm.hideOnLoadSpinner();
          quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;

        }
      }         
    }

    quickPayLandingVm.hideOnLoadSpinner = function () {
      if (quickPayService.requestSent == quickPayService.requestReceived) {
        utilityService.hideSpinner();
        quickPayService.customerAccountInfoLoader = true;
        quickPayService.userWhiteListedLoader = true;
        quickPayService.addFavLoader = true;
        quickPayService.requestSent = 0;
        quickPayService.requestReceived = 0;
        //call pending request service
        if (quickPayService.pendingLists.length > 0) {
          quickPayLandingVm.pendingLists = quickPayService.pendingLists;

        }
        else if (!quickPayService.pendingCallInitiated) {
          quickPayLandingVm.getPendingRequestsViaAdapter();
        }              
      }
    }

    quickPayLandingVm.goToUserLogin = function () {
      $state.go('menu.prehomeLoginRevamp');
    }

    quickPayLandingVm.goToPendingReq = function () {
      //go to pending request
      
      if (quickPayService.pendingCallInitiated) {
        $ionicPopup.show({
          title: null,
          cssClass: 'my-custom-popup',
          template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="CHECK_PROF_PWD_FLG_MSG"></div>',
          buttons: [{
            text: 'OK',
            type: 'button-assertive'
          }]
        });
      }
      else {
        $state.go('menu.quickPayPendingReq');
      }
    }

    
    // for go to upi detail page - 
    quickPayLandingVm.payByUpiId = function () {
      quickPayLandingVm.isEditVpaField = false;
      quickPayLandingVm.setPaymentMethod('vpa');
      $scope.payToUPIModal.hide();
      if (loggedInUserService.launchPageTxn) {
        $state.go('menu.payToUPIDetails');
        angular.element(document.body).removeClass('modal-open');
      }
    }


      //tab change functionality 
    quickPayLandingVm.setPaymentMethod = function (type, fav_id) {

      
        quickPayLandingVm.forCheckTransactionPage = true;
        quickPayService.forCheckTransactionPage = quickPayLandingVm.forCheckTransactionPage;
        quickPayLandingVm.amountDisabled = false;
        quickPayLandingVm.disableContactFields = false;

        if ( type == 'contact') {
         
          quickPayLandingVm.contact_active = true;
          quickPayLandingVm.vpa_active = false;
          quickPayLandingVm.beneficiary_active = false;

          quickPayService.contact_active = quickPayLandingVm.contact_active;
          console.log("con_active", quickPayService.contact_active)
          quickPayService.vpa_active = quickPayLandingVm.vpa_active;
          quickPayService.myTab = type;
          console.log("quickPayService.myTabcont", quickPayService.myTab);
          quickPayLandingVm.classForPay = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
          quickPayLandingVm.classForRequest = 'tab-item tabs-style div-bottom roboto-regular';


            //for check fav id and redirect to pay to contact detail page for transaction
            if (fav_id && quickPayLandingVm.activeTransactionMode) {
                quickPayService.payToContactData.payment_type = type;
                quickPayService.activeTransactionMode = quickPayLandingVm.activeTransactionMode; 
                quickPayLandingVm.fav_id = fav_id;
                quickPayService.fav_id = quickPayLandingVm.fav_id;
                $state.go('menu.payToContactDetails');
              }
          }else if (type == 'beneficiary') {
              quickPayLandingVm.contact_active = false;
              quickPayLandingVm.vpa_active = false;
              quickPayLandingVm.scan_active = false;
              quickPayLandingVm.beneficiary_active = true;
              

            if (loggedInUserService.qpayType != "paybank") {
                quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails = {};
            }

           

          }else {
            
            quickPayLandingVm.contact_active = false;
            quickPayLandingVm.vpa_active = true;
            quickPayLandingVm.beneficiary_active = false;
            quickPayService.contact_active = quickPayLandingVm.contact_active;
            quickPayService.vpa_active = quickPayLandingVm.vpa_active;
            quickPayService.myTab = type;
            console.log("quickPayService.myTabvpa", quickPayService.myTab);
            quickPayService.payToContactData.payment_type = type;
            quickPayLandingVm.classForPay = 'tab-item tabs-style div-bottom roboto-regular';
            quickPayLandingVm.classForRequest = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
            quickPayLandingVm.resetVpaFields();

             if (!$rootScope.checkDeviceInfo || !quickPayService.getProfileResponse) {
                  quickPayLandingVm.redirectToBhimUpi();
                }

            //for check fav id and redirect to upi detail page
              if (fav_id) {
                    quickPayService.payToContactData.payment_type = type;
                    quickPayService.payment_type = type;
                    quickPayService.fav_id = fav_id;
                    quickPayService.secondaryAuthFav = fav_id;
                if(fav_id.beneficiaryType == 'VPA_Contact'){
                    $state.go('menu.payToContactUPIDetails');
                }else{
                  $state.go('menu.payToUPIDetails');
                }
              }
            }
        }


    //paty to contact function using mapper and account
    quickPayLandingVm.payToContactFun = function ($event) {

      var cust_info = quickPayService.customerInfo;
      var accNo = $filter('cardmask')(quickPayService.customerInfo.customerInformation.accountNumber, 'X', 4);
      quickPayLandingVm.payToContact.amountError = "";
      quickPayService.cust_infoDet = cust_info;

      if (quickPayLandingVm.payToContact.beneficiaryError) {
            quickPayLandingVm.payToContact.beneficiaryErrorTxt = "Please enter mobile number.";
      }else if (!quickPayLandingVm.payToContact.amount || quickPayLandingVm.payToContact.amount == "" || quickPayLandingVm.payToContact.amount == undefined) {
            quickPayLandingVm.payToContact.amountError = "Please enter amount";
      }else if (quickPayService.payToContactData.payment_type == 'account' && (parseInt(quickPayLandingVm.payToContact.amount) > parseInt(quickPayService.yqpBeneficiaryLimit) 
            || parseInt(quickPayLandingVm.payToContact.amount) < 1)) {
            $translate(['INVAID_BEN_AMT_MSG'], { amount: $filter('INR')(parseInt(quickPayService.yqpBeneficiaryLimit)) }).then(function (translations) {
            quickPayLandingVm.INVAID_BEN_AMT_MSG = translations['INVAID_BEN_AMT_MSG'];
            quickPayLandingVm.payToContact.amountError = quickPayLandingVm.INVAID_BEN_AMT_MSG;
          });
      }else if (quickPayService.payToContactData.payment_type == 'account' && (accNo != "" && (accNo == quickPayService.payToContactData.account_number))) {
            utilityService.showErrorMessage("Please select different TO and FROM account.");
      }else if (quickPayService.payToContactData.payment_type == 'vpa' && (parseInt(quickPayLandingVm.payToContact.amount) > parseInt(quickPayService.yqpVpaLimit) 
            || parseInt(quickPayLandingVm.payToContact.amount) < 1)) {
            if (parseInt(quickPayLandingVm.payToContact.amount) < 1) {
              quickPayLandingVm.payToContact.amountError = quickPayLandingVm.INVAID_AMT_MSG_LESS_1;
            } else if (parseInt(quickPayLandingVm.payToContact.amount) > parseInt(quickPayService.yqpVpaLimit)) {
              quickPayLandingVm.payToContact.amountError = quickPayLandingVm.INVAID_AMT_MSG_GRT;
            }
            else{
              quickPayLandingVm.payToContact.amountError = quickPayLandingVm.INVAID_AMT_MSG;
            }
      }else {

            quickPayService.payToContactData.amount = quickPayLandingVm.payToContact.amount;
            quickPayService.payToContactData.remark = quickPayLandingVm.payToContact.remark;
            var action = "";

            if (quickPayService.payToContactData.payment_type == 'account') {

                //for payer account details for pass below values to success page for show transaction details
                quickPayService.payerAccntDetails = {};
                quickPayService.payerAccntDetails.balance = quickPayService.accountBalance;
                quickPayService.payerAccntDetails.accType = quickPayService.accType;
                quickPayService.payerAccntDetails.accountNumber = quickPayService.accountNumber;
                console.log("payerAccntDetails", quickPayService.payerAccntDetails);

                //check account is transactional or not
                if(!quickPayService.isTransactional || quickPayService.unableFetchAccountMOPTransactional){
                    quickPayLandingVm.payToContact.amountError = quickPayLandingVm.YQP_ACCNT_NOT_TRANSACTIONAL;
                   return true;
                }

              if (parseFloat(quickPayLandingVm.payToContact.amount) > parseFloat(quickPayService.accountBalance)) {
                  quickPayLandingVm.payToContact.amountError = quickPayLandingVm.YQP_INSUFFICIENT_BAL;
              } else {
                  action = 'pay_to_contact';

                  if (quickPayService.preAuthType == 'mpin' || quickPayService.preAuthType == 'userName') {
                      if(parseInt(quickPayLandingVm.payToContact.amount) < 1){
                          quickPayLandingVm.payToContact.amountError = quickPayLandingVm.YQP_MIN_AMNT_ERROR;
                      }
                  
                    //new service call
                    var params = { "amount": quickPayService.payToContactData.amount }
                    quickPayService.validateTransaction(params).then(function (data) {
                      goToPayByAccountFlow(action, data);
                    }, function (error) {
                      utilityService.showErrorMessage(error.responseMessage);
                    });
              } else {
                  
                    if (quickPayService.customerInfo.yqpBiometricAmt !== null) {
                        if (parseInt(quickPayService.customerInfo.yqpBiometricAmt) >= 0) {
                          var checkAmount = parseInt(quickPayService.yqpBiometricLimit) - parseInt(quickPayService.customerInfo.yqpBiometricAmt);
                          
                          if(parseInt(quickPayLandingVm.payToContact.amount) < 1){
                              quickPayLandingVm.payToContact.amountError = quickPayLandingVm.YQP_MIN_AMNT_ERROR;
                          }

                          if (parseInt(quickPayService.payToContactData.amount) > checkAmount) {
                            //Inserted as part of login revamp journey                
                            loggedInUserService.productClicked = "payContact_secondAuthentication";
                            loggedInUserService.limitCheckPayContact = $event;
                            quickPayService.payToContactData.beneficiaryError = quickPayLandingVm.payToContact.beneficiaryError;
                            $state.go('menu.prehomeLoginRevamp', { action: action });
                          }
                          else {
                            //check otp limit
                            var params = { "amount": quickPayService.payToContactData.amount }
                            quickPayService.validateTransaction(params).then(function (data) {
                              goToPayByAccountFlow(action, data);
                            }, function (error) {
                              utilityService.showErrorMessage(error.responseMessage);
                            });
                          }
                        }
                    }
                      else {
                        var checkAmount = quickPayService.yqpBiometricLimit;
                        if (parseInt(quickPayService.payToContactData.amount) > checkAmount) {
                          //Inserted as part of login revamp journey                
                          loggedInUserService.productClicked = "payContact_secondAuthentication";
                          loggedInUserService.limitCheckPayContact = $event;
                          quickPayService.payToContactData.beneficiaryError = quickPayLandingVm.payToContact.beneficiaryError;
                          $state.go('menu.prehomeLoginRevamp', { action: action });
                        }
                        else {
                          //check otp limit
                          var params = { "amount": quickPayService.payToContactData.amount }
                          quickPayService.validateTransaction(params).then(function (data) {
                            goToPayByAccountFlow(action, data);
                          }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                          });
                        }
                      }
                  
                         
                }

              }
            }
            else {
              //pay by VPA
              if (quickPayService.preAuthType == 'biometric') {
                
                  if (quickPayService.customerInfo.yqpBiometricAmt !== null) {
                    if (parseInt(quickPayService.customerInfo.yqpBiometricAmt) >= 0) {
                      var checkAmount = parseInt(quickPayService.yqpBiometricLimit) - parseInt(quickPayService.customerInfo.yqpBiometricAmt);
                      if (parseInt(quickPayLandingVm.payToContact.amount) > checkAmount) {
                        //Inserted as part of login revamp journey  
                        loggedInUserService.productClicked = "payContact_secondAuthentication";
                        loggedInUserService.limitCheckPayContact = $event;
                        quickPayService.payToContactData.beneficiaryError = quickPayLandingVm.payToContact.beneficiaryError;
      
                        //show error message
                        var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
                        var ok_btn = "OK";
                        var onTapgo = 'menu.prehomeLoginRevamp';  //Inserted as part of login revamp journey  
                        var onTapCancel = '';
                        var cancel_btn = 'Cancel';
                        quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
                        return true;
                      }
                    }
                  }
                  else {
                    var checkAmount = quickPayService.yqpBiometricLimit;
                    if (parseInt(quickPayLandingVm.payToContact.amount) > checkAmount) {
                      //Inserted as part of login revamp journey  
                      loggedInUserService.productClicked = "payContact_secondAuthentication";
                      loggedInUserService.limitCheckPayContact = $event;
                      quickPayService.payToContactData.beneficiaryError = quickPayLandingVm.payToContact.beneficiaryError;
      
                      //show error message
                      var message = quickPayLandingVm.YQP_BIO_AUTH_CUM_ERROR;
                      var ok_btn = "OK";
                      var onTapgo = 'menu.prehomeLoginRevamp';  //Inserted as part of login revamp journey  
                      var onTapCancel = '';
                      var cancel_btn = 'Cancel';
                      quickPayService.showAlertPopup("", message, onTapgo, onTapCancel, ok_btn, cancel_btn, $scope);
                      return true;
                    }
                  }
                          
              }

              //check minimum amount
              
              if((!quickPayLandingVm.payToContact.amount) || parseInt(quickPayLandingVm.payToContact.amount) < 1 || parseInt(quickPayLandingVm.payToContact.amount) > parseInt(quickPayService.yqpVpaLimit)){
                  quickPayLandingVm.payToContactError = true;
                  return true;
                }
              
              //pay function
              if(quickPayLandingVm.merchantInfo){
                quickPayLandingVm.payToVpaByContact();
              }else{
                quickPayLandingVm.payToVpaByContactFavTran();
              }
            }
      }
    }


    //set contact functionality for contact modal when click on number or name then set details in the landing page 
    quickPayLandingVm.setContactDetails = function (type, isPopup, phoneNumber, viaTranFre) {
      quickPayLandingVm.payToContact.numberError = "";
      quickPayLandingVm.payToContact.beneficiaryError = false;
      var mobNoFrDirOrOthers = quickPayService.contactSearchText;

      if(phoneNumber){
          quickPayLandingVm.mobileArray = phoneNumber.phone;
         
          if(phoneNumber.name == ''){
            quickPayLandingVm.contactSearchText = quickPayLandingVm.mobileArray[0];
          }else{
            quickPayLandingVm.contactSearchText = phoneNumber.name;
          }
      }
      

      if (type == '1') {
          var number = phoneNumbers.value.replace(/[^\d]/g, '');
          quickPayLandingVm.payToContact.mobile_number = number;
          quickPayService.payToContactData.mobile_number = quickPayLandingVm.payToContact.mobile_number;
       }else {
          if (quickPayLandingVm.mobileArray) {
              var mobileNo = quickPayLandingVm.mobileArray[0].replace(/[^\d]/g, '');
              var mobileNoSlice;

                if (mobileNo.length == '12') {
                  mobileNoSlice = mobileNo.slice(2);
                }else if(mobileNo.length == '11'){
                  mobileNoSlice = mobileNo.slice(1);
                } else {
                  mobileNoSlice = mobileNo;
                }

              quickPayService.payToContactData.mobile_number = mobileNoSlice;
              quickPayLandingVm.payToContact.mobile_number = mobileNoSlice;
              
          } else {
              quickPayService.payToContactData.mobile_number = mobNoFrDirOrOthers;
              quickPayLandingVm.payToContact.mobile_number = mobNoFrDirOrOthers;
              
          }
          quickPayService.payToContactData.mobile_number = quickPayLandingVm.payToContact.mobile_number;
          
      }


      if (quickPayService.payToContactData.mobile_number.length != '10') {
        quickPayLandingVm.payToContact.beneficiaryError = true;
        quickPayLandingVm.payToContact.beneficiaryErrorTxt = "Please enter 10 digit valid mobile number."
      }
      else {
        //timeout given as modal was not closing before service call     
        $timeout(function () {
          var params = { "mobileNumber": quickPayService.payToContactData.mobile_number };
          quickPayService.getContactDetailsByMapper(params).then(function (data) {
          console.log("data", data);
          quickPayService.responseMessage = data.responseMessage;

            if(data.data){
               quickPayLandingVm.bankResponse = data.data;
                quickPayService.bankResponse = quickPayLandingVm.bankResponse;
                quickPayLandingVm.accntDetails = quickPayLandingVm.bankResponse.accntDetails;
            }

            //amount check while pay to favorite
            if(quickPayService.payToContact.amount && quickPayLandingVm.paytoFavClick){
               quickPayLandingVm.payToContact.amount = quickPayService.payToContact.amount;
               quickPayService.paytoFavClick = quickPayLandingVm.paytoFavClick;
            }

            
           if (quickPayLandingVm.accntDetails && quickPayLandingVm.accntDetails.length > 0) {
            
              quickPayLandingVm.payToContact.name = quickPayLandingVm.bankResponse.customerName;
              quickPayService.payToContactData.name = quickPayLandingVm.payToContact.name;
              console.log("quickPayLandingVm.accntDetails", quickPayLandingVm.payToContact.name);
              quickPayLandingVm.payToContact.account_number = quickPayLandingVm.accntDetails[0].accountNumber;
              quickPayService.payToContactData.account_number = quickPayLandingVm.accntDetails[0].accountNumber;

              quickPayService.payToContactData.payment_type = 'account';
              quickPayLandingVm.payToContact.payment_type = 'account';
              quickPayService.contact_active = quickPayLandingVm.contact_active;

                  $scope.payToContactModal.hide();
                  $state.go('menu.payToContactDetails');
                  if (loggedInUserService.launchPageTxn) {
                    
                    angular.element(document.body).removeClass('modal-open');
                  }

            
             
            }else {
              
              quickPayService.payToContactData.payment_type = 'VPA_Contact';
              quickPayLandingVm.payToContact.payment_type = 'VPA_Contact';


               if (!$rootScope.checkDeviceInfo || !quickPayService.getProfileResponse) {
                  quickPayLandingVm.redirectToBhimUpi();
                }

              quickPayLandingVm.verifyUpiIdContact('VPA_Contact');
              quickPayService.contact_active = quickPayLandingVm.contact_active;
            }
          }, function (error) {
            quickPayLandingVm.payToContact.beneficiaryError = true;
            quickPayLandingVm.payToContact.beneficiaryErrorTxt = "";
            utilityService.showErrorMessage(error.responseMessage);
            quickPayLandingVm.payToContact.mobile_number = "";
            quickPayLandingVm.contactSearchText = "";
            quickPayLandingVm.showContactButtonFlag = false;
          });

        }, 500);
      }
    };

    //for verify mapper number using contact 
    quickPayLandingVm.verifyUpiIdContact = function (paymentType) {
      var mapperTextNew = '@mapper.npci';
      var jsonMapperUpi;
 
       if (quickPayLandingVm.payToContact.mobile_number) {
          quickPayService.payToContactData.upi_id = quickPayLandingVm.payToContact.mobile_number.concat(mapperTextNew);
        }


        utilityService.showSpinner();
        if (utilityService.isAndroidPlatform()) {
            jsonMapperUpi = JSON.stringify({
           
            "payeeType": {
              "virtualAddress": quickPayService.payToContactData.upi_id.toString(), 
            },
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "vAReqType": constantConfig.upiConstant.vAReqType_T
          });
        }else{
          jsonMapperUpi = JSON.stringify({
            "addInfo": {
              "addInfo10": constantConfig.upiConstant.addInfo10,
              "addInfo9": constantConfig.upiConstant.addInfo9
            },
            "payeeType": {
              "virtualAddress": quickPayService.payToContactData.upi_id.toString(), 
            },
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "vAReqType": constantConfig.upiConstant.vAReqType_T
          });
        }
        


      bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, jsonMapperUpi, "YQP").then(function (data) {
        utilityService.hideSpinner();
        var checkVpaConResponse = JSON.parse(data);
          quickPayService.checkVpaConResponse = checkVpaConResponse;

        if (checkVpaConResponse.status == 'VE') {
            quickPayLandingVm.payeeType = checkVpaConResponse.payeeType;
            quickPayService.payToContactData.name = checkVpaConResponse.payeeType.name;
            quickPayLandingVm.payToContact.name = checkVpaConResponse.payeeType.name;
            console.log("checkVpaConResponse.status == 'VE'", quickPayService.payToContactData.name);
            quickPayService.payToContactData.merchantInfo = checkVpaConResponse.payeeType.merchantInfo;
            quickPayService.fromPaytoContactNumb = true;
            quickPayService.payToContactData.payment_type = paymentType;

            if (quickPayService.payToContact.merchantInfo) {
                  quickPayLandingVm.contact_upi_id = quickPayService.payToContactData.upi_id;
              } 
          

            if (quickPayService.contact_active) {
                $scope.payToContactModal.hide();
                $state.go('menu.payToContactUPIDetails');
                if (loggedInUserService.launchPageTxn) {
                  
                  angular.element(document.body).removeClass('modal-open');
                }
              }

        }else if (checkVpaConResponse.status == 'VN') {

            var closeYqpPop = $ionicPopup.alert({
              template: '<div class="popup-padding font-dark-grey yqpPayLng"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter yqpMsgSection"><span class="popUp-msg-color roboto-medium ypqMsg1">' + 'We couldn’t find any SBI account or UPI ID mapped to this phone number' + '</span></div><div class="textAlignCenter marBtm20"><span class="popUp-msg-color ypqMsg2">' + 'You can still send money using following options' + '</span></div></div></div>',
              scope: $scope,
              cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup yqpMainPopup',
              buttons: [

                {
                  text: "Try with another UPI ID or Number",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();
                    if (quickPayLandingVm.contact_active) {
                      quickPayService.contact_active = quickPayLandingVm.contact_active;
                      $state.go("menu.payToContactLanding");
                    }
                    if (loggedInUserService.launchPageTxn) {
                      
                      angular.element(document.body).removeClass('modal-open');
                    }
                  }
                },

                {
                  text: "Bank Account",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();
                    $state.go("menu.quickPayLanding");
                    if (loggedInUserService.launchPageTxn) {
                     
                      angular.element(document.body).removeClass('modal-open');
                    }

                  }
                },
                {
                  text: "",
                  type: 'button-positive',
                  onTap: function () {
                    closeYqpPop.close();
                  }
                }

              ],
            });

          } else if (checkVpaConResponse.status == 'F') {
            $ionicPopup.alert({
              template: '<div class="popup-padding font-dark-grey yqpPayLng"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter yqpMsgSection"></div><div class="textAlignCenter marBtm20"><span class="popUp-msg-color ypqMsg2">' + checkVpaConResponse.statusDesc + '</span></div></div></div>',
              scope: $scope,
              cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup yqpFailedStatus',
              buttons: [
                {
                  text: "OK",
                  type: 'button-positive',
                  onTap: function () {
                    $scope.payToContactModal.hide();
                    $state.go("menu.payToContactLanding");
                    if (loggedInUserService.launchPageTxn) {
                      
                      angular.element(document.body).removeClass('modal-open');
                    }
                  }
                }

              ],
            });
          }else {
            quickPayLandingVm.payToContact.beneficiaryError = true;
            quickPayLandingVm.payToContact.beneficiaryErrorTxt = checkVpaConResponse.statusDesc;
        }
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayLandingVm.payToContact.beneficiaryError = true;
        quickPayLandingVm.payToContact.beneficiaryErrorTxt = msg;
      });
    }

     
    //for pay function using contact - mapper 
    quickPayLandingVm.payToVpaByContact = function () {

      //for transaction details
      quickPayLandingVm.userProfileDet.selectedAccount = quickPayLandingVm.selectedAccount;
      quickPayLandingVm.userProfileDet.selectedVpa = quickPayLandingVm.selectedVpa;
      quickPayLandingVm.userProfileDet.name = quickPayLandingVm.userInfo.name;
      
      quickPayService.userProfileDet = quickPayLandingVm.userProfileDet;
      console.log("quickPayService.userProfileDet", quickPayService.userProfileDet);

      quickPayService.payToContactData.transactionNote = quickPayLandingVm.payToContact.remark;
      quickPayService.payToContactData.accountId = quickPayLandingVm.remitterAccountObj.accId;
      quickPayService.payToContactData.payerVirtualAddress = quickPayLandingVm.remitterVPA;

      utilityService.showSpinner();
      var jsonUpiMapperPay = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "accountInfo": {
          "accountBalance": "",
          "accountName": "",
          "accId": quickPayLandingVm.remitterAccountObj.accId,
          "maskedAccountNumber": quickPayLandingVm.selectedAccount.maskedAccountNumber,
          "aepsFlag": "",
          "atmFType": "",
          "atmLength": quickPayLandingVm.selectedAccount.bankId,
          "bankCode": quickPayLandingVm.selectedAccount.bankCode,
          "bankId": quickPayLandingVm.selectedAccount.bankId,
          "bankName": quickPayLandingVm.selectedAccount.bankName,
          "checkedAccount": quickPayLandingVm.selectedAccount.checkedAccount ? quickPayLandingVm.selectedAccount.checkedAccount : "",
          "formatType": quickPayLandingVm.selectedAccount.formatType,
          "ifscCode": quickPayLandingVm.selectedAccount.ifscCode,
          "iin": "",
          "otpFType": "",
          "otpLength": quickPayLandingVm.selectedAccount.otpLength,
          "preferredFlag": "",
          "refUrl": "",
          "uPinFType": quickPayLandingVm.selectedAccount.uPinFType,
          "mpinFlag": quickPayLandingVm.selectedAccount.mpinFlag,
          "uPinLength": quickPayLandingVm.selectedAccount.uPinLength,
          "mobileNo": $rootScope.checkDeviceInfo.deviceInfo.mobileNo ? $rootScope.checkDeviceInfo.deviceInfo.mobileNo.toString() : ""
        },
        "amount": Number(quickPayService.payToContactData.amount).toFixed(2),
        "expiryTime": 0,
        "cmId": quickPayLandingVm.merchantInfo.cmid,
        "initMode": "00",
        "npciTranId": generateRandomString(30),
        "payeeType": {
          "name": quickPayService.payToContactData.name,
          "virtualAddress": quickPayLandingVm.payToContact.favUPIAddr.toString(),
          "vpaType": "VA"
        },
        "payerType": {
          "accountId": quickPayLandingVm.remitterAccountObj.accId,
          "virtualAddress": quickPayLandingVm.remitterVPA
        },
        "ref_id": generateRandomString(30),
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "tid": generateRandomString(30),
        "transactionNote": (quickPayLandingVm.payToContact.remark || ""),
        "upiTransRefNo": 0
      });

      


       bhimUpiService.getNativeData(constantConfig.upiConstant.getUpiFundTransfer, jsonUpiMapperPay, "YQP").then(function (data) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = JSON.parse(data).apiResp;
        if (JSON.parse(data).apiResp.status == 'S') {
          utilityService.setCsatJournies("fundTransfer");
          quickPayService.paymentResponse.payeeName = quickPayService.payToContactData.payeeName;
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: true });
        } else {
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });

        }
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = {};
        quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
        var errorMsg = "Confirmation on status of this transaction is pending. Please check status of the transaction from transaction history before retrying.";
        if (msg == ". UPI1006 : Connection Lost, please try again.")
          utilityService.showAlertPopUp('error', errorMsg, "", "", "", "");
        else
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });

        
      });
    }


    //pay to contact for mapper - using favorite or transactions
     quickPayLandingVm.payToVpaByContactFavTran = function () {

       //for transaction details
      quickPayLandingVm.userProfileDet.selectedAccount = quickPayLandingVm.selectedAccount;
      quickPayLandingVm.userProfileDet.selectedVpa = quickPayLandingVm.selectedVpa;
      quickPayLandingVm.userProfileDet.name = quickPayLandingVm.userInfo.name;
      
      quickPayService.userProfileDet = quickPayLandingVm.userProfileDet;
      console.log("quickPayService.userProfileDet", quickPayService.userProfileDet);

      quickPayService.payToContactData.transactionNote = quickPayLandingVm.payToContact.remark;
      quickPayService.payToContactData.accountId = quickPayLandingVm.remitterAccountObj.accId;
      quickPayService.payToContactData.payerVirtualAddress = quickPayLandingVm.remitterVPA;

      utilityService.showSpinner();
      var jsonConVpa = {
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "amount": Number(quickPayService.payToContactData.amount),
        "expiryTime": 0,
        "payeeType": {
          "name": quickPayLandingVm.payToContact.name,
          "virtualAddress": quickPayLandingVm.payToContact.favUPIAddr.toString(),
          "vpaType": "VA"
        },
        "payerType": {
          "accountId": quickPayService.payToContactData.accountId,
          "virtualAddress": quickPayLandingVm.remitterVPA
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "transactionNote": (quickPayLandingVm.payToContact.remark || ""),
        "upiTransRefNo": 0
      };

      jsonConVpa = JSON.stringify(jsonConVpa);


       bhimUpiService.getNativeData(constantConfig.upiConstant.onPayInitiation, jsonConVpa, "YQP").then(function (data) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = JSON.parse(data).apiResp;
        if (JSON.parse(data).apiResp.status == 'S') {
          utilityService.setCsatJournies("fundTransfer");
          quickPayService.paymentResponse.payeeName = quickPayService.payToContactData.payeeName;
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: true });
        } else {
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });

        }
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = {};
        quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
        var errorMsg = "Confirmation on status of this transaction is pending. Please check status of the transaction from transaction history before retrying.";
        if (msg == ". UPI1006 : Connection Lost, please try again.")
          utilityService.showAlertPopUp('error', errorMsg, "", "", "", "");
        else
          $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });

        
      });
    }

    
    //for open pay
    quickPayLandingVm.openPayToCollectContactModal = function () {
      quickPayLandingVm.payToCollectContact = {};
      quickPayService.payToCollectContactData = {};
      quickPayLandingVm.splitPaymentIds = [];
      quickPayLandingVm.isContactSelected = false;
      quickPayLandingVm.isExistingContact = false;
      $scope.collectReqContactModal.show();
      if (quickPayService.receiveMoneyFrequentContact.length > 0) {
        quickPayLandingVm.receiveMoneyFrequentContact = quickPayService.receiveMoneyFrequentContact;
      }
      else {
        quickPayService.getFrequentCollectRequestList().then(function (data) {
          quickPayLandingVm.receiveMoneyFrequentContact = data.recieveMoneyDetails;
        }, function (error) {
          utilityService.showErrorMessage(error.responseMessage);
        });
      }

    }

    quickPayLandingVm.openPayToContactModal = function () {
      if (!quickPayLandingVm.disableContactFields) {
        
        if(loggedInUserService.qpayType != "paycontact"){
          quickPayService.payToContactData = {};
        }        
        if (quickPayService.payToContactFrequent.length > 0) {
          
          quickPayLandingVm.payToContactFrequent = quickPayService.payToContactFrequent;
        }
        else {
          var params = { "methodName": "getFrequentContactList" };
          if (loggedInUserService.launchPageTxn) {
            quickPayService.addFavLoader = false;
            quickPayService.requestSent = quickPayService.requestSent + 1;
          } else {
            quickPayService.addFavLoader = true;
          }
          quickPayService.addTofavorite(params).then(function (data) {
            if (!utilityService.isUndefined(data)) {
              quickPayService.payToContactFrequent = data.beneficiaryList;
            }
            quickPayLandingVm.payToContactFrequent = quickPayService.payToContactFrequent;
            
            if (!quickPayService.addFavLoader) {
              quickPayService.requestReceived = quickPayService.requestReceived + 1;   
              quickPayLandingVm.hideOnLoadSpinner();             
            }
          }, function (error) {
            
            if (!quickPayService.addFavLoader) {
              quickPayService.requestReceived = quickPayService.requestReceived + 1;   
              quickPayLandingVm.hideOnLoadSpinner();             
            }           
          });
        }
      }
    }


    quickPayLandingVm.close = function (index, type) {
       quickPayLandingVm.popUp.close();

        if (type == 'collect') {
          var mobile = quickPayLandingVm.contactLists[index].value.replace(/[^\d]/g, '');
          quickPayLandingVm.collectContactSearchText = mobile.slice(-10);
          quickPayLandingVm.showCollectContactButtonFlag = true;
        }
        else {
          var mobile = quickPayLandingVm.contactLists[index].value.replace(/[^\d]/g, '');
          quickPayLandingVm.contactSearchText = mobile.slice(-10);
          quickPayLandingVm.showContactButtonFlag = true;
          quickPayLandingVm.setContactDetails('2', true);
        }
      }


    //for get contact list from directory - for pay to contact
    quickPayLandingVm.getContactList = function () {
      quickPayLandingVm.showContactButtonFlag = false;

      navigator.contacts.pickContact(function (contact) {
        if (contact.phoneNumbers.length > 0) {
            if (contact.phoneNumbers.length == 1) {
              var mobile = contact.phoneNumbers[0].value.replace(/[^\d]/g, '');
              quickPayLandingVm.contactSearchText = mobile.slice(-10);
              quickPayService.contactSearchText = quickPayLandingVm.contactSearchText;
              quickPayLandingVm.showContactButtonFlag = true;
              quickPayLandingVm.setContactDetails('2', true);
            }
            else {

              quickPayLandingVm.contactLists = contact.phoneNumbers;
              quickPayLandingVm.popUpTemplate = quickPayService.accountListPopupTemplate("contact.phoneNumbers", "quickPayLandingVm");

              quickPayLandingVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/quickPay/contactModal.html',
                scope: $scope
              });
              
            }
        }
        $scope.$apply();
      }, function (err) {
          console.log(err);
      });

    }



    quickPayLandingVm.openInfo = function ($event) {

      quickPayLandingVm.leftStyle = "right : 7px";
      if (utilityService.isIOSPlatform()) {
        quickPayLandingVm.topStyle = "margin-top : -66px;";
      }
      else {
        quickPayLandingVm.topStyle = "margin-top : -88px;";
      }
      quickPayLandingVm.template = '<ion-popover-view class="quickpay loginnewarrow hmbr-info hmbr-info-popnew popOverGL" id="runtimeHeight" style="{{quickPayLandingVm.topStyle}}">' + '<div class="edu-arrow-downnew" style="{{quickPayLandingVm.leftStyle}}"></div>' +
        '<ion-content class="  nfs-popover">' +
        '<div id="renderHeight" class="text-left padding-left-10 padding-top-5 padding-right-10 font-size-12">' +
        '<div class="roboto-regular font-sixe-12 color3f3f3f" translate="YQP_PAYTOCONT_AMOUNT_INFO"></div>' +
        '</div>' + '</ion-content>' + '</ion-popover-view>';
      $scope.popoverOpenInfo = $ionicPopover.fromTemplate(quickPayLandingVm.template, {
        scope: $scope
      });
      $scope.popoverOpenInfo.show($event);

    }

    quickPayLandingVm.closeInfo = function () {
      $scope.popoverOpenInfo.hide();
    }


    quickPayLandingVm.openPayToBeneficiaryModal = function () {
      if (!quickPayService.payToBeneficiaryData.existingBeneficiaries) {
        if (loggedInUserService.launchPageTxn) {
          quickPayService.addFavLoader = false;
          quickPayService.requestSent = quickPayService.requestSent + 1;
        } else {
          quickPayService.addFavLoader = true;
        }
        quickPayService.getBeneficiaryList().then(function (data) {
          if (!utilityService.isUndefined(data)) {
            quickPayService.payToBeneficiaryData.existingBeneficiaries = data;
          }
          quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
          if (quickPayService.payToBeneficiaryData.existingBeneficiaries.frequentBeneficiaryList != undefined) {
            quickPayLandingVm.favListByAccounts = quickPayService.payToBeneficiaryData.existingBeneficiaries.frequentBeneficiaryList.beneficiaryList;
          }
          $scope.openPayToBeneficiaryModalFun();
          if (!quickPayService.addFavLoader) {
            quickPayService.requestReceived = quickPayService.requestReceived + 1;   
            quickPayLandingVm.hideOnLoadSpinner();             
          }
        }, function (error) {
          if (!quickPayService.addFavLoader) {
            quickPayService.requestReceived = quickPayService.requestReceived + 1;   
            quickPayLandingVm.hideOnLoadSpinner();             
          }
          utilityService.showErrorMessage(error.responseMessage);
        });
      }
      else {
        quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
        if (quickPayService.payToBeneficiaryData.existingBeneficiaries.frequentBeneficiaryList != undefined) {
          quickPayLandingVm.favListByAccounts = quickPayService.payToBeneficiaryData.existingBeneficiaries.frequentBeneficiaryList.beneficiaryList;
        }
        $scope.openPayToBeneficiaryModalFun();
      }
    }


    //for open pay to contact modal fun
    $scope.openPayToContactModalFun = function () {
      $scope.payToContactModal.show();
    };
   
    //for open pay to beneficiary modal
    $scope.openPayToBeneficiaryModalFun = function () {
      $scope.payToBeneficiaryModal.show();
    };

    //close modal functionality contact
    $scope.closePayToContactModalFun = function () {
      $scope.payToContactModal.hide();
      quickPayLandingVm.contactSearchText = '';
      quickPayLandingVm.payToContact.beneficiaryErrorTxt = '';
      quickPayLandingVm.showDivContacts = false;
      if (loggedInUserService.launchPageTxn) {
        $state.go('menu.payToContactLanding');
        angular.element(document.body).removeClass('modal-open');
      }
    };

    //for close upi modal fun
    $scope.closeUPIModalFun = function () {
      $scope.payToUPIModal.hide();
      quickPayLandingVm.qp_vpa_upiId = '';
      quickPayLandingVm.bankUpiHide = false;
      quickPayLandingVm.payeeName = "";
      quickPayLandingVm.verifyUpiIdError = '';
      if (loggedInUserService.launchPageTxn) {
        $state.go('menu.payToContactLanding');
        angular.element(document.body).removeClass('modal-open');
      }
    };

    //for close pay to beneficiary modal fun 
    $scope.closePayToBeneficiaryModalFun = function () {
      $scope.payToBeneficiaryModal.hide();
      if (loggedInUserService.launchPageTxn) {
        $state.go('menu.prehomeLoginRevamp');
        angular.element(document.body).removeClass('modal-open');
        angular.element(document.body).removeClass('popover-open');
      }
    };


    $ionicModal.fromTemplateUrl('pages/quickPay/payToScanQRModal.html', {
      scope: $scope,
      animation: 'slide-in-up',
      hardwareBackButtonClose: false
    }).then(function (modal) {
      $scope.payToScanQRModal = modal;
    });

    $scope.openpayToScanQRModalFun = function () {
      $scope.payToScanQRModal.show();
    };

    $scope.closepayToScanQRModalFun = function () {
      $scope.payToScanQRModal.hide();
      quickPayLandingVm.classForPay = 'tab-item tabs-style div-bottom bor-bot-active';
      quickPayLandingVm.classForRequest = 'tab-item tabs-style div-bottom';
      
    };

    $ionicModal.fromTemplateUrl('pages/quickPay/collectQRModal.html', {
      scope: $scope,
      animation: 'slide-in-up',
      hardwareBackButtonClose: false
    }).then(function (modal) {
      $scope.collectQRModal = modal;
    });

    $scope.openCollectQRModalFun = function () {
      $scope.collectQRModal.show();
    };

    $scope.closeCollectQRModalFun = function () {
      $scope.collectQRModal.hide();
    };

    quickPayLandingVm.clearSearch = function () {
      quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
      quickPayLandingVm.searchText = "";
    }

    quickPayLandingVm.setBeneficiaryDetails = function (acc, type) {
      quickPayLandingVm.selectedBeneficiaryAccountDetails = acc;
      quickPayLandingVm.payToBeneficiary.beneficiaryName = acc.benName;
      quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails = quickPayLandingVm.selectedBeneficiaryAccountDetails;
      //type = 1 then no need to hide modal user came via favourite list
      if (type && type == 1) {
        console.log(type);
      }
      else {
        $scope.payToBeneficiaryModal.hide();
        if (loggedInUserService.launchPageTxn) {
          loggedInUserService.launchPageTxn = false;
          angular.element(document.body).removeClass('modal-open');
          angular.element(document.body).removeClass('popover-open');
        }
      }

    }


    quickPayLandingVm.setBeneficiaryDetailsFreq = function (acc, type) {
      acc.beneficiaryTransferAmount = "";
      $scope.payToBeneficiaryModal.hide();
      if (loggedInUserService.launchPageTxn) {
        loggedInUserService.launchPageTxn = false;
        angular.element(document.body).removeClass('modal-open');
        angular.element(document.body).removeClass('popover-open');
      }
      if (!quickPayService.payToBeneficiaryData.existingBeneficiaries) {
        quickPayService.getBeneficiaryList().then(function (data) {
          if (!utilityService.isUndefined(data)) {
            quickPayService.payToBeneficiaryData.existingBeneficiaries = data;
          }
          quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
          getExistingBeneficiaryDetail(acc);
        }, function (error) {
          utilityService.showErrorMessage(error.responseMessage);
        });
      }
      else {
        quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
        getExistingBeneficiaryDetail(acc);
      }
    }


    quickPayLandingVm.payToBeneficiary = function ($event) {
      var cust_info = quickPayService.customerInfo;
      quickPayLandingVm.payToBeneficiary.amountError = "";
      quickPayLandingVm.payToBeneficiary.beneficiaryError = "";
      if (!quickPayLandingVm.payToBeneficiary.beneficiaryName || quickPayLandingVm.payToBeneficiary.beneficiaryName == "") {
        quickPayLandingVm.payToBeneficiary.beneficiaryError = "Please enter beneficiary details.";
      }
      else if (!quickPayLandingVm.payToBeneficiary.amount || quickPayLandingVm.payToBeneficiary.amount == "" || quickPayLandingVm.payToBeneficiary.amount == undefined) {
        quickPayLandingVm.payToBeneficiary.amountError = "Please enter amount";
      }
      else if (parseFloat(quickPayLandingVm.payToBeneficiary.amount) < 1) {
        quickPayLandingVm.payToBeneficiary.amountError = quickPayLandingVm.INVAID_AMT_MSG_LESS_1;
      }
      else if ((quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '1' || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '2') && parseInt(quickPayLandingVm.payToBeneficiary.amount) > parseInt(quickPayService.yqpBeneficiaryLimit)) {
        $translate(['INVAID_BEN_AMT_MSG'], { amount: $filter('INR')(parseInt(quickPayService.yqpBeneficiaryLimit)) }).then(function (translations) {
          quickPayLandingVm.INVAID_BEN_AMT_MSG = translations['INVAID_BEN_AMT_MSG'];
          quickPayLandingVm.payToBeneficiary.amountError = quickPayLandingVm.INVAID_BEN_AMT_MSG;

        });

      }
      else if (!(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '2' || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '1') && parseInt(quickPayLandingVm.payToBeneficiary.amount) > parseInt(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.maxLimit)) {
        $translate(['MAX_BEN_AMT_MSG'], { amount: $filter('INR')(parseInt(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.maxLimit)) }).then(function (translations) {
          quickPayLandingVm.MAX_BEN_AMT_MSG = translations['MAX_BEN_AMT_MSG'];
          quickPayLandingVm.payToBeneficiary.amountError = quickPayLandingVm.MAX_BEN_AMT_MSG;
        });

      }
      else if (parseFloat(quickPayLandingVm.payToBeneficiary.amount) > parseFloat(cust_info.customerInformation.balance)) {
        quickPayLandingVm.payToBeneficiary.amountError = quickPayLandingVm.YQP_INSUFFICIENT_BAL;
      }
      else {

        quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount = quickPayLandingVm.payToBeneficiary.amount;
        quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark = quickPayLandingVm.payToBeneficiary.remark;
        var action = "";

        if (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '1') {
          action = 'pay_to_new_sbi';
        }
        else if (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type == '2') {
          action = 'pay_to_new_other';
        }
        else {
          action = 'pay_to_existing_beneficiary';
        }
        if (quickPayService.preAuthType == 'mpin' || quickPayService.preAuthType == 'userName') {
          //new service call
          var params = { "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount }
          quickPayService.validateTransaction(params).then(function (data) {
            goToPayByAccountFlow(action, data);
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });


        } else {
          
            if (quickPayService.customerInfo.yqpBiometricAmt !== null) {
              if (parseInt(quickPayService.customerInfo.yqpBiometricAmt) >= 0) {
                var checkAmount = parseInt(quickPayService.yqpBiometricLimit) - parseInt(quickPayService.customerInfo.yqpBiometricAmt);
                if (parseInt(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount) > checkAmount) {
  
                  //Inserted as part of login revamp journey                
                  loggedInUserService.productClicked = "payBank_secondAuthentication";
                  loggedInUserService.limitCheckPayBank = $event;
                  $state.go('menu.prehomeLoginRevamp', { action: action });
                }
                else {
                  //check otp limit
                  var params = { "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount }
                  quickPayService.validateTransaction(params).then(function (data) {
                    goToPayByAccountFlow(action, data);
                  }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                  });
                }
              }
  
            }
            else {
              var checkAmount = quickPayService.yqpBiometricLimit;
              if (parseInt(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount) > checkAmount) {
  
                //Inserted as part of login revamp journey                
                loggedInUserService.productClicked = "payBank_secondAuthentication";
                loggedInUserService.limitCheckPayBank = $event;
                $state.go('menu.prehomeLoginRevamp', { action: action });
              }
              else {
                //check otp limit
                var params = { "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount }
                quickPayService.validateTransaction(params).then(function (data) {
                  goToPayByAccountFlow(action, data);
                }, function (error) {
                  utilityService.showErrorMessage(error.responseMessage);
                });
              }
            }
    
        }
      }
    }

    
    
       function goToPayByAccountFlow(action, data) {
      if (action == 'pay_to_existing_beneficiary') {

        if (data.yqpOtpFlag) {
         
          quickPayService.getOtp().then(function (data) {
            $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_existing_beneficiary' });
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });
        }
        else {
          payToExistingBeneficiary();
        }
        //}

      }
      else if (action == 'pay_to_new_sbi') {
        
        //check if to and from account number are same
        var accNo = $filter('cardmask')(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number, 'X', 4);
        if (quickPayService.customerInfo.customerInformation.accountNumber != "" && (quickPayService.customerInfo.customerInformation.accountNumber == accNo)) {
          utilityService.showErrorMessage("Please select different TO and FROM account.");
        }
        else {
          if (data.yqpOtpFlag) {
            quickPayService.getOtp().then(function (data) {
              $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_new_sbi' });
            }, function (error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
          }
          else {
            payToNewSbiBeneficiary();
          }
        }

      } else if (action == 'pay_to_new_other') {
        

        if (data.yqpOtpFlag) {
          quickPayService.getOtp().then(function (data) {
            $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_new_other' });
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });
        }
        else {
          payToNewOtherBeneficiary();
        }


      }
      else if (action == 'pay_to_contact') {
        
        if (quickPayService.payToContactData.payment_type == 'account') {
          if (data.yqpOtpFlag) {
            quickPayService.getOtp().then(function (data) {
              $state.go('menu.quickPayOTP', { goBackToState: 'menu.quickPayLanding', action: 'pay_to_contact' });
            }, function (error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
          }
          else {
            payToContact();
          }
        }
        else {
          if(quickPayLandingVm.merchantInfo){
            quickPayLandingVm.payToVpaByContact();
          }else{
            quickPayLandingVm.payToVpaByContactFavTran();
          }
        }
      }
      else {
        console.log("payacntflow");
      }
    }


    function payToExistingBeneficiary() {
      var params = {

        "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
        "inbUserId": "",
        "accountTypeCode": "",
        "benMMID": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benMMID,
        "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName,
        "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benIFSCCode,
        "isStaffFlag": "",
        "intCategory": "",
        "benType": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benType,
        "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName,
        "intraBankFlag": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.intraBankFlag,
        "isOwnAccntFlag": "",
        "remAccntNo": "",
        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo,
        "benStatus": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benStatus,
        "debitNriflag": "",
        "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
        "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benNickName + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.benAccntNo + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
      };
      quickPayService.postTxn(params).then(function (response) {
        quickPayService.paymentResponse = response;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_existing_beneficiary', isSuccess: true });
      }, function (error) {
        quickPayService.paymentResponse = error;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_existing_beneficiary', isSuccess: false });
        
      });
    }
    function payToContact() {
      var params = { "amount": quickPayService.payToContactData.amount, "payRequestId": quickPayService.payRequestId };
      quickPayService.payToContact(params).then(function (data) {
        quickPayService.paymentResponse = data;
        quickPayService.pendingLists = [];
        quickPayService.payRequestId = "";
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: true });
      }, function (error) {
        quickPayService.paymentResponse = error;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_contact', isSuccess: false });
        
      });
    }
    function payToNewSbiBeneficiary() {
      var params = {

        "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
        "inbUserId": "",
        "accountTypeCode": "",
        "benMMID": "",
        "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
        "benIfscCode": "",
        "isStaffFlag": "",
        "intCategory": "",
        "benType": "account",
        "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
        "intraBankFlag": "Y",
        "isOwnAccntFlag": "",
        "remAccntNo": "",
        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
        "benStatus": "New",
        "debitNriflag": "",
        "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
        "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
      };
      quickPayService.postTxn(params).then(function (response) {
        quickPayService.paymentResponse = response;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_sbi', isSuccess: true });
      }, function (error) {
        quickPayService.paymentResponse = error;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_sbi', isSuccess: false });
        
      });
    }
    function payToNewOtherBeneficiary() {
      var params = {

        "amount": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount,
        "inbUserId": "",
        "accountTypeCode": "",
        "benMMID": "",
        "benNickName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
        "benIfscCode": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.ifsc,
        "isStaffFlag": "",
        "intCategory": "",
        "benType": "account",
        "benName": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name,
        "intraBankFlag": "N",
        "isOwnAccntFlag": "",
        "remAccntNo": "",
        "benAccntNo": quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number,
        "benStatus": "New",
        "debitNriflag": "",
        "remark": (quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == undefined || quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark == null) ? "" : quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.remark,
        "yqpValidateReq": (cryptoService.getSHA512EncryptedData(quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.recipient_name + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_number + quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.amount)).toString()
      };
      quickPayService.postTxn(params).then(function (response) {
        quickPayService.paymentResponse = response;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_other', isSuccess: true });
      }, function (error) {
        quickPayService.paymentResponse = error;
        $state.go('menu.quickPaymentSuccess', { action: 'pay_to_new_other', isSuccess: false });
        
      });
    }


    quickPayLandingVm.changeAccType = function () {
      quickPayLandingVm.pay_to_beneficiary.sbi = {};
      quickPayLandingVm.pay_to_beneficiary.other = {};
    }
    quickPayLandingVm.validate = function () {
      if (quickPayLandingVm.pay_to_beneficiary.account_type == '1') {
        quickPayLandingVm.pay_to_beneficiary.sbi.error = false;
        quickPayLandingVm.pay_to_beneficiary.sbi.recipient_name_error = "";
        quickPayLandingVm.pay_to_beneficiary.sbi.account_number_error = "";
        quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number_error = "";
        if (!quickPayLandingVm.pay_to_beneficiary.sbi.recipient_name || quickPayLandingVm.pay_to_beneficiary.sbi.recipient_name == '') {
          quickPayLandingVm.pay_to_beneficiary.sbi.error = true;
          quickPayLandingVm.pay_to_beneficiary.sbi.recipient_name_error = "Please enter recipient name."
        }
        if (!quickPayLandingVm.pay_to_beneficiary.sbi.account_number || quickPayLandingVm.pay_to_beneficiary.sbi.account_number == '') {
          quickPayLandingVm.pay_to_beneficiary.sbi.error = true;
          quickPayLandingVm.pay_to_beneficiary.sbi.account_number_error = "Please enter account number."
        }
        if (!quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number || quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number == '') {
          quickPayLandingVm.pay_to_beneficiary.sbi.error = true;
          quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number_error = "Please re-enter account number."
        }
        if (quickPayLandingVm.pay_to_beneficiary.sbi.account_number != quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number) {
          quickPayLandingVm.pay_to_beneficiary.sbi.error = true;
          quickPayLandingVm.pay_to_beneficiary.sbi.re_account_number_error = "Account number should be same at both place."
        }
      }
      else {
        quickPayLandingVm.pay_to_beneficiary.other.error = false;
        quickPayLandingVm.pay_to_beneficiary.other.recipient_name_error = "";
        quickPayLandingVm.pay_to_beneficiary.other.account_number_error = "";
        quickPayLandingVm.pay_to_beneficiary.other.re_account_number_error = "";
        quickPayLandingVm.pay_to_beneficiary.other.ifsc_error = "";
        if (!quickPayLandingVm.pay_to_beneficiary.other.recipient_name || quickPayLandingVm.pay_to_beneficiary.other.recipient_name == '') {
          quickPayLandingVm.pay_to_beneficiary.other.error = true;
          quickPayLandingVm.pay_to_beneficiary.other.recipient_name_error = "Please enter recipient name."
        }
        if (!quickPayLandingVm.pay_to_beneficiary.other.account_number || quickPayLandingVm.pay_to_beneficiary.other.account_number == '') {
          quickPayLandingVm.pay_to_beneficiary.other.error = true;
          quickPayLandingVm.pay_to_beneficiary.other.account_number_error = "Please enter account number."
        }
        if (!quickPayLandingVm.pay_to_beneficiary.other.re_account_number || quickPayLandingVm.pay_to_beneficiary.other.re_account_number == '') {
          quickPayLandingVm.pay_to_beneficiary.other.error = true;
          quickPayLandingVm.pay_to_beneficiary.other.re_account_number_error = "Please re-enter account number."
        }
        if (!quickPayLandingVm.pay_to_beneficiary.other.ifsc || quickPayLandingVm.pay_to_beneficiary.other.ifsc == '') {
          quickPayLandingVm.pay_to_beneficiary.other.error = true;
          quickPayLandingVm.pay_to_beneficiary.other.ifsc_error = "Please enter IFSC."
        }
        if (quickPayLandingVm.pay_to_beneficiary.other.account_number != quickPayLandingVm.pay_to_beneficiary.other.re_account_number) {
          quickPayLandingVm.pay_to_beneficiary.other.error = true;
          quickPayLandingVm.pay_to_beneficiary.other.re_account_number_error = "Account number should be same at both place."
        }
      }
    }
    quickPayLandingVm.validateTxn = function () {
      quickPayLandingVm.validate();
      if (quickPayLandingVm.pay_to_beneficiary.account_type == '1') {
        if (!quickPayLandingVm.pay_to_beneficiary.sbi.error) {
          quickPayLandingVm.payToBeneficiary.beneficiaryName = quickPayLandingVm.pay_to_beneficiary.sbi.recipient_name;
          quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails = quickPayLandingVm.pay_to_beneficiary.sbi;
          quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type = quickPayLandingVm.pay_to_beneficiary.account_type;
          $scope.payToBeneficiaryModal.hide();
          if (loggedInUserService.launchPageTxn) {
            loggedInUserService.launchPageTxn = false;
            angular.element(document.body).removeClass('modal-open');
            angular.element(document.body).removeClass('popover-open');
          }
        }
      }
      else {
        if (!quickPayLandingVm.pay_to_beneficiary.other.error) {
          quickPayLandingVm.payToBeneficiary.beneficiaryName = quickPayLandingVm.pay_to_beneficiary.other.recipient_name;
          quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails = quickPayLandingVm.pay_to_beneficiary.other;
          quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.account_type = quickPayLandingVm.pay_to_beneficiary.account_type;
          quickPayService.payToBeneficiaryData.selectedBeneficiaryAccountDetails.ifsc = quickPayLandingVm.pay_to_beneficiary.other.ifsc;
          $scope.payToBeneficiaryModal.hide();
          if (loggedInUserService.launchPageTxn) {
            loggedInUserService.launchPageTxn = false;
            angular.element(document.body).removeClass('modal-open');
            angular.element(document.body).removeClass('popover-open');
          }
        }
      }
    }

    //DELETE FAVORITE LIST
    quickPayLandingVm.deleteFavorites = function (ben_id) {
      if (ben_id) {
        var params = {
          "methodName": "deleteFavourite",
          "beneficiaryList": [
            {
              "beneficiaryId": ben_id
            }
          ]
        };
        quickPayService.addFavLoader = true;
        quickPayService.addTofavorite(params).then(function (data) {
          quickPayLandingVm.editFavFlag = false;
          quickPayLandingVm.getFavorites();
        }, function (error) {
          console.log(error);
        });
      }
    }

    //GET FAVORITE LIST
    quickPayLandingVm.getFavorites = function () {
      var params = { "methodName": "getBeneficiary" };
      quickPayService.addTofavorite(params).then(function (data) {
        if (!utilityService.isUndefined(data)) {
          quickPayService.favLists = data.beneficiaryList;
          quickPayLandingVm.favLists = quickPayService.favLists;

              quickPayLandingVm.newFavForPayToCon = [];
              quickPayLandingVm.newFavForAccnt = [];
              quickPayLandingVm.newFavForOther = [];
              
                for (var l = 0; l < quickPayLandingVm.favLists.length; l++) {
                    if(quickPayLandingVm.favLists[l].beneficiaryType == "VPA" || quickPayLandingVm.favLists[l].beneficiaryType == "Contact" 
                        || quickPayLandingVm.favLists[l].beneficiaryType == "VPA_Contact") {
                        quickPayLandingVm.newFavForPayToCon.push(quickPayLandingVm.favLists[l]);
                    }else if(quickPayLandingVm.favLists[l].beneficiaryType == "Account"){
                        quickPayLandingVm.newFavForAccnt.push(quickPayLandingVm.favLists[l]);
                    }else{
                        quickPayLandingVm.newFavForOther.push(quickPayLandingVm.favLists[l]);
                    }   
                }

                quickPayService.newFavForPayToCon = quickPayLandingVm.newFavForPayToCon;
                quickPayService.newFavForAccnt = quickPayLandingVm.newFavForAccnt;
                quickPayService.newFavForOther = quickPayLandingVm.newFavForOther;

                console.log("quickPayLandingVm.newFavForPayToCon", quickPayLandingVm.newFavForPayToCon);
                console.log("quickPayLandingVm.favLists", quickPayLandingVm.favLists);
        }
        if (!quickPayService.addFavLoader) {
          quickPayService.requestReceived = quickPayService.requestReceived + 1;
          quickPayLandingVm.hideOnLoadSpinner();
        }
      }, function (error) {
               
        if (!quickPayService.addFavLoader) {
          quickPayService.requestReceived = quickPayService.requestReceived + 1;
          quickPayLandingVm.hideOnLoadSpinner();
        }
      });
    }

    //GO TO TRANSACTION SECTION
    quickPayLandingVm.goToTransaction = function () {
      $state.go('menu.quickPayTransactions');
    }

   // EDIT SECTION FOR FAVORITE
    quickPayLandingVm.editFavorites = function (value) {
      if (value == 'true')
        quickPayLandingVm.editFavFlag = true;
      else
        quickPayLandingVm.editFavFlag = false;
    }
    $scope.$on('$destroy', function () {
      $scope.payToContactModal.remove();
      $scope.payToBeneficiaryModal.remove();
      $scope.payToScanQRModal.remove();

    });



    // ON PAGE LOAD
    $scope.$on('$ionicView.loaded', function () {
      initPage();
    });
    quickPayLandingVm.payTofavorites = function (index) {
      var beneficiaryData = index;
      
      quickPayLandingVm.disableContactFields = false;
      quickPayService.paytoFavClick = true;

      if (beneficiaryData.beneficiaryType == 'Account') {
        if (!quickPayService.payToBeneficiaryData.existingBeneficiaries) {
          quickPayService.getBeneficiaryList().then(function (data) {
            if (!utilityService.isUndefined(data)) {
              quickPayService.payToBeneficiaryData.existingBeneficiaries = data;
            }
            quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
            getExistingBeneficiaryDetail(beneficiaryData);
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });
        }
        else {
          quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
          getExistingBeneficiaryDetail(beneficiaryData);
        }
      }
      else if (beneficiaryData.beneficiaryType == 'Contact') {
        $ionicScrollDelegate.scrollTop();
        quickPayLandingVm.contactSearchText = beneficiaryData.lastTransactionType;
        quickPayService.contactSearchText = quickPayLandingVm.contactSearchText;
        quickPayLandingVm.payToContact.amount = beneficiaryData.beneficiaryTransferAmount;
        quickPayService.payToContact.amount = quickPayLandingVm.payToContact.amount;
        quickPayLandingVm.setPaymentMethod('contact');
        quickPayLandingVm.setContactDetails('2', false);
      }
      else if (beneficiaryData.beneficiaryType == 'QR') {
        quickPayLandingVm.setPaymentMethod('scan', beneficiaryData);
      }
      else if (beneficiaryData.beneficiaryType == 'VPA' || beneficiaryData.beneficiaryType == 'VPA_Contact' || beneficiaryData.beneficiaryType == 'vpa') {
        quickPayService.isFavIdAval = true;
        quickPayLandingVm.setPaymentMethod('vpa', beneficiaryData);
        $ionicScrollDelegate.scrollTop();
      }
     
    }


    // PAY TO VIA TRANSACTION
    quickPayLandingVm.payViaTransaction = function (beneficiaryData) {

      if (beneficiaryData.beneficiaryType == 'Account') {
        if (!quickPayService.payToBeneficiaryData.existingBeneficiaries) {
          quickPayService.getBeneficiaryList().then(function (data) {
            if (!utilityService.isUndefined(data)) {
              quickPayService.payToBeneficiaryData.existingBeneficiaries = data;
            }
            quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
           
            getExistingBeneficiaryDetail(beneficiaryData);
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });
        }
        else {
          quickPayLandingVm.existingBeneficiariesLists = quickPayService.payToBeneficiaryData.existingBeneficiaries;
          getExistingBeneficiaryDetail(beneficiaryData);
        }
      }
      else if (beneficiaryData.beneficiaryType == 'Contact') {
        $ionicScrollDelegate.scrollTop();
        quickPayLandingVm.activeTransactionMode = true;
        quickPayLandingVm.contactSearchText = beneficiaryData.lastTransactionType;
        quickPayService.contactSearchText = quickPayLandingVm.contactSearchText;
        
        quickPayLandingVm.setPaymentMethod('contact');
        quickPayLandingVm.setContactDetails('2', false);
      }
      else if (beneficiaryData.beneficiaryType == 'QR') {
        quickPayLandingVm.setPaymentMethod('scan', beneficiaryData);
      }
      else if (beneficiaryData.beneficiaryType == 'vpa' || beneficiaryData.beneficiaryType == 'VPA'|| beneficiaryData.beneficiaryType == 'VPA_Contact') {
        quickPayLandingVm.setPaymentMethod('vpa', beneficiaryData);
        $ionicScrollDelegate.scrollTop();
      }
      
    }
    quickPayLandingVm.setPayToContactFreqDetails = function (beneficiaryData) {
      $ionicScrollDelegate.scrollTop();
      quickPayLandingVm.contactSearchText = beneficiaryData.lastTransactionType;
      quickPayLandingVm.setPaymentMethod('contact');
      quickPayLandingVm.setContactDetails('2', true);

    }
    function getExistingBeneficiaryDetail(beneficiaryData) {

      if (quickPayLandingVm.existingBeneficiariesLists.beneficiaryList.otherAccounts.length > 0) {
        var isAccountExists = -1;
        quickPayLandingVm.existingBeneficiariesLists.beneficiaryList.otherAccounts.some(function (obj, i) {
          return obj.benAccntNo == beneficiaryData.lastTransactionType ? isAccountExists = i : false;
        });
        if (isAccountExists !== -1) {
          $ionicScrollDelegate.scrollTop();
          //set payment tab
          
          //set payment sub tab
         
          //set amount
          quickPayLandingVm.payToBeneficiary.amount = beneficiaryData.beneficiaryTransferAmount;
          //set beneficiary details
          quickPayLandingVm.setBeneficiaryDetails(quickPayLandingVm.existingBeneficiariesLists.beneficiaryList.otherAccounts[isAccountExists], 1);
        } else {
          $ionicScrollDelegate.scrollTop();
          //set payment tab
         
          //set payment sub tab
         
          quickPayLandingVm.payToBeneficiary.amount = beneficiaryData.beneficiaryTransferAmount;
          var addBenData = [];
          addBenData.amount = beneficiaryData.beneficiaryTransferAmount;
          addBenData.account_number = beneficiaryData.lastTransactionType;
          addBenData.ifsc = (beneficiaryData.beneficiaryIfscCode == undefined || beneficiaryData.beneficiaryIfscCode == null) ? "" : beneficiaryData.beneficiaryIfscCode;
          addBenData.recipient_name = beneficiaryData.beneficiaryName;
          addBenData.benName = beneficiaryData.beneficiaryName;
          addBenData.benNickName = beneficiaryData.beneficiaryName;
          addBenData.benType = beneficiaryData.beneficiaryType;
          addBenData.intraBankFlag = addBenData.ifsc == '' ? "Y" : "N";
          addBenData.account_type = addBenData.ifsc == '' ? "1" : "2";

          quickPayLandingVm.setBeneficiaryDetails(addBenData, 1);
        }

      } else {
        $ionicScrollDelegate.scrollTop();
        //set payment tab
       
        //set payment sub tab
      
        quickPayLandingVm.payToBeneficiary.amount = beneficiaryData.beneficiaryTransferAmount;
        var addBenData = [];
        addBenData.amount = beneficiaryData.beneficiaryTransferAmount;
        addBenData.account_number = beneficiaryData.lastTransactionType;
        addBenData.ifsc = (beneficiaryData.beneficiaryIfscCode == undefined || beneficiaryData.beneficiaryIfscCode == null) ? "" : beneficiaryData.beneficiaryIfscCode;
        addBenData.recipient_name = beneficiaryData.beneficiaryName;
        addBenData.benName = beneficiaryData.beneficiaryName;
        addBenData.benNickName = beneficiaryData.beneficiaryName;
        addBenData.benType = beneficiaryData.beneficiaryType;
        addBenData.intraBankFlag = addBenData.ifsc == '' ? "Y" : "N";
        addBenData.account_type = addBenData.ifsc == '' ? "1" : "2";

        quickPayLandingVm.setBeneficiaryDetails(addBenData, 1);
      }
    }
    quickPayLandingVm.approveCollect = function () {
      var collectRequestdata = quickPayService.payFromCollectRequestData;
      if (collectRequestdata.payeeVa == quickPayLandingVm.qp_vpa_upiId) {

        utilityService.showSpinner();
        var json = JSON.stringify({
          "addInfo": {
            "addInfo10": constantConfig.upiConstant.addInfo10,
            "addInfo9": constantConfig.upiConstant.addInfo9
          },
          "approvalStatus": "A",
          "expiryTime": 0,
          "npciTranId": collectRequestdata.txnId,
          "payerType": {
            "accountId": quickPayLandingVm.remitterAccountObj.accId,
            "virtualAddress": quickPayLandingVm.remitterVPA
          },
          "requestInfo": {
            "pspId": constantConfig.upiConstant.pspId,
            "pspRefNo": generateRandomString(27)
          },
          "upiTransRefNo": collectRequestdata.upiTrnRefNo
        });
        bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectApprove, json, "YQP").then(function (data) {
          var collectApproveResp = JSON.parse(data).apiResp;
          quickPayService.paymentResponse = collectApproveResp;
          utilityService.hideSpinner();
          if (collectApproveResp.status == 'S') {
            utilityService.setCsatJournies("fundTransfer");
            $state.go('menu.quickPaymentSuccess', { action: 'VPA', isSuccess: true });
          } else {
            $state.go('menu.quickPaymentSuccess', { action: 'VPA', isSuccess: false });
          }
        }, function (msg) {
          utilityService.hideSpinner();
          quickPayService.paymentResponse = {};
          quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
          $state.go('menu.quickPaymentSuccess', { action: 'VPA', isSuccess: false });
        });
      }
      else {
        utilityService.showBhimUpiAlert("error", 'Invalid VPA ID');
      }
    }
    quickPayLandingVm.payViaCollectRequest = function (collectRequestdata) {
      quickPayLandingVm.amountDisabled = true;
      quickPayLandingVm.disableContactFields = true;
      if (collectRequestdata.type === "contact") {
        $ionicScrollDelegate.scrollTop();
        quickPayLandingVm.payToContact.name = ""; quickPayLandingVm.payToContact.account_number = "";
        console.log("collectRequestdata.type === 'contact'", quickPayLandingVm.payToContact.name);
        quickPayLandingVm.payToContact.beneficiaryError = "";
        quickPayLandingVm.payToContact.beneficiaryError = false;

        quickPayLandingVm.contactSearchText = collectRequestdata.mobileNo;
        quickPayLandingVm.payToContact.amount = collectRequestdata.txnAmount;
        quickPayLandingVm.payToContact.remark = collectRequestdata.txnNote == undefined ? "" : collectRequestdata.txnNote;

        quickPayLandingVm.contact_active = true;
        quickPayLandingVm.vpa_active = false;
        quickPayLandingVm.scan_active = false;
        quickPayLandingVm.beneficiary_active = false;
        quickPayService.mySubTab = 'contact';

        quickPayLandingVm.setContactDetails('2', false);


      } else {
        quickPayLandingVm.qp_vpa_upiId = "";
        quickPayLandingVm.resetVpaFields();
        quickPayLandingVm.qp_vpa_upiId = collectRequestdata.payeeVa;
        quickPayLandingVm.payeeName = collectRequestdata.payeeName;
        quickPayLandingVm.qp_vpa_amount = collectRequestdata.txnAmount;
        quickPayLandingVm.qp_vpa_remark = collectRequestdata.txnNote;

        quickPayLandingVm.contact_active = false;
        quickPayLandingVm.vpa_active = true;
        quickPayLandingVm.scan_active = false;
        quickPayLandingVm.beneficiary_active = false;
        quickPayService.mySubTab = 'vpa';


        quickPayLandingVm.getUPIProfile();
      }
    }

    /** Collect Request code starts */


    $ionicModal.fromTemplateUrl('pages/quickPay/collectReqContactModal.html', {
      scope: $scope,
      animation: 'slide-in-up',
      hardwareBackButtonClose: false
    }).then(function (modal) {
      $scope.collectReqContactModal = modal;
    });

    $scope.opencollectReqContactModalFun = function () {
      $scope.collectReqContactModal.show();
    };

    $scope.closecollectReqContactModalFun = function () {
      $scope.collectReqContactModal.hide();
    };

    quickPayLandingVm.setCollectReqMethod = function (collectType) {
      quickPayLandingVm.splitPaymentIds = [];
      if (collectType == 'collect_vpa') {
        quickPayLandingVm.payToCollectVPA = {};
        quickPayService.payToCollectVPAData = {};
        quickPayLandingVm.collect = {};
        quickPayLandingVm.resetVpaFields('collect');
        if (!$rootScope.checkDeviceInfo || !quickPayLandingVm.getProfileResponse) {
          quickPayLandingVm.redirectToCollectBhimUpi(collectType);
        } else {
          quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
          quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;
          quickPayLandingVm.collect_contact_active = false;
          quickPayLandingVm.collect_vpa_active = true;
          quickPayLandingVm.collect_scan_active = false;
        }
      }
      if (collectType == 'collect_contact') {
        quickPayLandingVm.collect_contact_active = true;
        quickPayLandingVm.collect_vpa_active = false;
        quickPayLandingVm.collect_scan_active = false;
      }
      if (collectType == 'collect_scan') {
        quickPayLandingVm.payToCollectQR = {};
        quickPayService.payToCollectScanData = {};
        if (!$rootScope.checkDeviceInfo || !quickPayLandingVm.getProfileResponse) {
          quickPayLandingVm.redirectToCollectBhimUpi(collectType);
        } else {
          quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
          quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;
          quickPayLandingVm.collect_contact_active = false;
          quickPayLandingVm.collect_vpa_active = false;
          quickPayLandingVm.collect_scan_active = true;
        }
      }
    }


    quickPayLandingVm.getCollectContactList = function () {
      quickPayLandingVm.showCollectContactButtonFlag = false;
      quickPayLandingVm.isExistingContact = false;
      quickPayLandingVm.payToCollectContact = {};
      
      navigator.contacts.pickContact(function (contact) {
        if (contact.phoneNumbers.length > 0) {
          quickPayLandingVm.isExistingContact = true;
          if (contact.phoneNumbers.length == 1) {
            var mobile = contact.phoneNumbers[0].value.replace(/[^\d]/g, '');
            quickPayLandingVm.collectContactSearchText = mobile.slice(-10);
            quickPayLandingVm.showCollectContactButtonFlag = true;

            quickPayLandingVm.payToCollectContact.name = contact.displayName;
          }
          else {

            quickPayLandingVm.contactLists = contact.phoneNumbers;
            quickPayLandingVm.payToCollectContact.name = contact.displayName;
            quickPayLandingVm.popUp = $ionicPopup.show({
              title: '',
              cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
              templateUrl: 'pages/quickPay/collectContactModal.html',
              scope: $scope
            });
          }
        }
        $scope.$apply();
      }, function (err) {
        //utilityService.showBhimUpiAlert("error", err);
      });
    }

    quickPayLandingVm.numberChanged = function () {
      quickPayLandingVm.isExistingContact = false;
    }
    
    quickPayLandingVm.setCollectContactDetails = function (type, phoneNumber, contactDetails) {
      quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "";
      quickPayLandingVm.payToCollectContact.beneficiaryError = false;
      if (type == 'contact') {
        quickPayLandingVm.collectContactSearchText = phoneNumber;
      }
      if (quickPayLandingVm.collectContactSearchText.length != 10) {
        quickPayLandingVm.payToCollectContact.beneficiaryError = true;
        quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "Please enter 10 digit valid mobile number.";
        
      }
      quickPayLandingVm.payToCollectContact.mobile_number = quickPayLandingVm.collectContactSearchText;
      quickPayService.payToCollectContactData.mobile_number = quickPayLandingVm.payToCollectContact.mobile_number;
      $scope.collectReqContactModal.hide();
      //timeout given as modal was not closing before service call     
      var hashedMobileNumber = (cryptoService.getSHA512EncryptedData(quickPayService.payToCollectContactData.mobile_number + "/getReceiveMoney")).toString();
      $timeout(function () {
        var params = {
          "mobileList": [
            {
              "mobileNumber": quickPayService.payToCollectContactData.mobile_number,
              "validateReq": hashedMobileNumber
            }
          ]
        };
        quickPayService.getReceiveMoney(params).then(function (data) {
          if (data.customerDetails && data.customerDetails.length > 0) {
            var details = data.customerDetails[0];
            if (details.accntDetails && details.accntDetails.length > 0) {
              quickPayLandingVm.payToCollectContact.name = details.customerName;
              quickPayService.payToCollectContactData.name = quickPayLandingVm.payToContact.name;
              console.log("quickPayService.payToCollectContactData.name", quickPayLandingVm.payToContact.name);
              quickPayLandingVm.payToCollectContact.account_number = details.accntDetails[0].accountNumber;
              quickPayService.payToCollectContactData.payment_type = 'account';
              quickPayLandingVm.payToCollectContact.payment_type = 'account';
              quickPayService.payToCollectContactData.account_number = quickPayLandingVm.payToCollectContact.account_number;
            }
            else if (details.vpaAccountDetails && details.vpaAccountDetails.length > 0) {
              quickPayService.payToCollectContactData.payment_type = 'vpa';
              quickPayLandingVm.payToCollectContact.payment_type = 'vpa';
              quickPayService.payToCollectContactData.upi_id = details.vpaAccountDetails[0].virtualAddress;
              //quickPayLandingVm.payToCollectContact.name = quickPayService.payToCollectContactData.upi_id ? quickPayService.payToCollectContactData.upi_id : "";
              quickPayLandingVm.splitPaymentIds.push(details.vpaAccountDetails[0].virtualAddress);
              quickPayService.splitPaymentIds = quickPayLandingVm.splitPaymentIds;
              //go to pay by vpa flow
              quickPayLandingVm.isContactSelected = true;
              quickPayLandingVm.payToCollectContact.amount = quickPayLandingVm.requestAmount;
              quickPayLandingVm.payToCollectContact.remark = quickPayLandingVm.requestRemark;
              quickPayService.payerAccObj = quickPayLandingVm.remitterAccountObj;
              quickPayService.payeeVPA = quickPayLandingVm.remitterVPA;

              if (!$rootScope.checkDeviceInfo || !quickPayLandingVm.getProfileResponse) {
                quickPayLandingVm.redirectToBhimUpi('collect_contact');
              } else {
                quickPayLandingVm.collectVerifyUpiId('contact_vpa');
              }

            }
            else {
              quickPayLandingVm.payToCollectContact.beneficiaryError = true;
              quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "It appears that no account or sbi vpa is linked to this mobile no. Please use Pay to Beneficiary or VPA";

            }
          }
          else {
            quickPayLandingVm.payToCollectContact.beneficiaryError = true;
            quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "It appears that no account or sbi vpa is linked to this mobile no. Please use Pay to Beneficiary or VPA";
          }
        }, function (error) {
          quickPayLandingVm.payToCollectContact.beneficiaryError = true;
          quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "";
          quickPayLandingVm.payToCollectContact.mobile_number = "";
          utilityService.showErrorMessage(error.responseMessage);
        });
      }, 500);
    };

    quickPayLandingVm.collectVerifyUpiId = function (paymentType) {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "payeeType": {
          "virtualAddress": paymentType == 'vpa' ? quickPayLandingVm.collect.upi_id.toString() : quickPayLandingVm.splitPaymentIds[0].toString()
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "vAReqType": constantConfig.upiConstant.vAReqType_T
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json, "YQP").then(function (data) {
        utilityService.hideSpinner();
        var checkVpaResponse = JSON.parse(data);
        if (checkVpaResponse.status == 'VE') {
          if (paymentType == 'vpa') {
            quickPayLandingVm.collect.payerName = checkVpaResponse.payeeType.name;
            quickPayLandingVm.splitPaymentIds.push(quickPayLandingVm.collect.upi_id);
            quickPayService.splitPaymentIds = quickPayLandingVm.splitPaymentIds;
          }
          else {
            //in case of contact vpa
            quickPayLandingVm.payToCollectContact.payerName = checkVpaResponse.payeeType.name;
            quickPayLandingVm.payToCollectContact.name = checkVpaResponse.payeeType.name;

          }
        } else {
          quickPayLandingVm.collect.verifyUpiIdError = checkVpaResponse.statusDesc;
        }
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayLandingVm.collect.verifyUpiIdError = quickPayLandingVm.displayVpaErrorMessage(msg);

      });
    }


    quickPayLandingVm.changeCollectContact = function () {
      quickPayService.payToCollectContactData = {};
      quickPayLandingVm.splitPaymentIds = [];
      quickPayLandingVm.isContactSelected = false;
      quickPayLandingVm.isExistingContact = false;
    }

    quickPayLandingVm.sendCollectRequest = function (collectType) {
      if (collectType == 'vpa') {
        quickPayLandingVm.payToCollectVPA.amountError = "";
        quickPayService.payToCollectVPAData.amount = quickPayLandingVm.payToCollectVPA.amount;
        quickPayService.payToCollectVPAData.payerName = quickPayLandingVm.collect.payerName;
        quickPayService.payToCollectVPAData.remark = quickPayLandingVm.payToCollectVPA.remark;
        if (!quickPayService.payToCollectVPAData.amount || quickPayService.payToCollectVPAData.amount < 1 || quickPayService.payToCollectVPAData.amount > parseInt(quickPayService.yqpRaiseRequestLimit)) {
          quickPayLandingVm.payToCollectVPA.amountError = quickPayLandingVm.INVAID_COLLECT_AMT_MSG;
          return true;
        }
        else {
          sendCollectRequest(collectType, quickPayService.payToCollectVPAData);
        }

      } else if (collectType == 'contact') {
        if (quickPayLandingVm.payToCollectContact == undefined) {
          quickPayLandingVm.payToCollectContact = {};
        }
        quickPayService.payToCollectContactData.amount = quickPayLandingVm.payToCollectContact.amount;
        var accNo = $filter('cardmask')(quickPayService.customerInfo.customerInformation.accountNumber, 'X', 4);
        quickPayLandingVm.payToCollectContact.beneficiaryError = false;
        quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "";
        quickPayLandingVm.payToCollectContact.amountError = false;
        quickPayLandingVm.payToCollectContact.amountErrorTxt = "";

        if (quickPayLandingVm.payToCollectContact.mobile_number == undefined || quickPayLandingVm.payToCollectContact.mobile_number == null || quickPayLandingVm.payToCollectContact.mobile_number == "") {
          quickPayLandingVm.payToCollectContact.beneficiaryError = true;
          quickPayLandingVm.payToCollectContact.beneficiaryErrorTxt = "Please enter mobile number.";
        }
        else if (quickPayService.payToCollectContactData.payment_type == 'account' && (accNo != "" && (accNo == quickPayLandingVm.payToCollectContact.account_number))) {
          utilityService.showErrorMessage("Please select different TO and FROM account.");
        }
        else if (!quickPayService.payToCollectContactData.amount || parseInt(quickPayService.payToCollectContactData.amount) < 1 || parseInt(quickPayService.payToCollectContactData.amount) > parseInt(quickPayService.yqpRaiseRequestLimit)) {
          quickPayLandingVm.payToCollectContact.amountError = true;
          quickPayLandingVm.payToCollectContact.amountErrorTxt = quickPayLandingVm.INVAID_COLLECT_AMT_MSG;
        }
        else if (quickPayService.payToCollectContactData.payment_type == 'account' && parseInt(quickPayService.receiveMoneyCount) > 9) {
          utilityService.showErrorMessage("You have reached the maximum request limit for the day, please try tomorrow");
        }
        else if (quickPayService.payToCollectContactData.payment_type == 'account' && (parseInt(quickPayService.receiveMoneyAmountLimit) + parseInt(quickPayService.payToCollectContactData.amount)) > parseInt(quickPayService.yqpRaiseRequestLimit)) {
          utilityService.showErrorMessage("You have exceeded the daily limit of raising receive money request");
        }
        else {
          quickPayService.payToCollectContactData.amount = quickPayLandingVm.payToCollectContact.amount;
          quickPayService.payToCollectContactData.payerName = quickPayLandingVm.payToCollectContact.payerName;
          quickPayService.payToCollectContactData.payerDisplayName = quickPayLandingVm.payToCollectContact.name;
          quickPayService.payToCollectContactData.remark = quickPayLandingVm.payToCollectContact.remark;

          var params = {
            "customerDetails": [{
              "phnNumber": quickPayLandingVm.payToCollectContact.mobile_number,
              "amount": quickPayLandingVm.payToCollectContact.amount,
              "comment": quickPayLandingVm.payToCollectContact.remark
            }]
          }

          if (quickPayService.payToCollectContactData.payment_type == 'account') {
            quickPayService.saveCollectRequestDetails(params).then(function (data) {
              quickPayService.paymentResponse = data;
              $state.go('menu.quickPaymentSuccess', { action: 'collect_via_contact', isSuccess: true });
            }, function (error) {
              quickPayService.paymentResponse = error;
              $state.go('menu.quickPaymentSuccess', { action: 'collect_via_contact', isSuccess: false });
             
            });
          } else {
            
            sendCollectRequest('contact', quickPayService.payToCollectContactData);

          }
        }
      }
      else {
        quickPayLandingVm.payToCollectQR.amountError = "";
        quickPayService.payToCollectScanData.amount = quickPayLandingVm.payToCollectQR.amount;
        quickPayService.payToCollectScanData.remark = quickPayLandingVm.payToCollectQR.remark || "";

        if (!quickPayService.payToCollectScanData.amount || quickPayService.payToCollectScanData.amount < 1 || quickPayService.payToCollectScanData.amount > parseInt(quickPayService.yqpRaiseRequestLimit)) {
          quickPayLandingVm.payToCollectQR.amountError = quickPayLandingVm.INVAID_COLLECT_AMT_MSG;
          return true;
        }

        $scope.openCollectQRModalFun();
        //generate QR image
        $timeout(function () {
          quickPayLandingVm.generateQrImage();
        }, 300);
      }
    }
    function sendCollectRequest(collectType, data) {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "amount": data.amount,
        "expiryTime": 4320,
        "payeeType": {
          "accountId": quickPayService.payerAccObj.accId,
          "virtualAddress": quickPayService.payeeVPA,
          "vpaType": "VA"
        },
        "payerType": {
          "name": data.payerName || '',
          "virtualAddress": quickPayService.splitPaymentIds[0]
        },
        "transactionNote": data.remark || "",
        "upiTransRefNo": 0
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.onCollectInitiation, json, "YQP").then(function (data) {
        var collectResponse = JSON.parse(data).apiResp;
        quickPayService.paymentResponse = collectResponse;
        utilityService.hideSpinner();
        if (collectResponse.status == 'S') {
          quickPayService.payerVPA = collectType == 'contact' ? quickPayService.splitPaymentIds[0] : quickPayLandingVm.collect.payerName;
          if (collectType == 'contact')
            $state.go('menu.quickPaymentSuccess', { action: 'collect_via_contact', isSuccess: true });
          else {
            $state.go('menu.quickPaymentSuccess', { action: 'collect_via_vpa', isSuccess: true });
          }

        } else {
          if (collectType == 'contact')
            $state.go('menu.quickPaymentSuccess', { action: 'collect_via_contact', isSuccess: false });
          else {
            $state.go('menu.quickPaymentSuccess', { action: 'collect_via_vpa', isSuccess: false });
          }
        }
      }, function (msg) {
        utilityService.hideSpinner();
        quickPayService.paymentResponse = {};
        quickPayService.paymentResponse.responseMsg = quickPayLandingVm.displayVpaErrorMessage(msg);
        if (collectType == 'contact')
          $state.go('menu.quickPaymentSuccess', { action: 'collect_via_contact', isSuccess: false });
        else {
          $state.go('menu.quickPaymentSuccess', { action: 'collect_via_vpa', isSuccess: false });
        }
      });
    }
    /** Collect Request code ends */
    quickPayLandingVm.toggleGroup = function (group) {
      if (quickPayLandingVm.isGroupShown(group)) {
        quickPayLandingVm.shownGroup = null;
      } else {
        quickPayLandingVm.shownGroup = group;
      }
    };
    quickPayLandingVm.isGroupShown = function (group) {
      return quickPayLandingVm.shownGroup === group;
    };
    quickPayLandingVm.getCategoryList = function () {
      var params = {};
      quickPayService.getCategoryList().then(function (data) {
        quickPayService.billCategoryLists = data;
        quickPayLandingVm.billCategoryLists = quickPayService.billCategoryLists;

      }, function (error) {
        console.log(error);
      });
    }

    quickPayLandingVm.shareQrCode = function (share) {
      if (device.platform.toLowerCase() == 'ios') {
        var myBaseString = quickPayLandingVm.vpaImage;
        var block = myBaseString.split(";");
        var dataType = block[0].split(":")[1];
        var myBase64 = block[1].split(",")[1];

        var successCallback = function (data) {

        }
        var failureCallback = function (error) {

        }
        cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", "shareImage", [myBase64]);
      } else {
        if (quickPayLandingVm.vpaImage) {
          var params = {
            data: quickPayLandingVm.vpaImage,
            format: 'JPG',
            quality: 80,
            mediaScanner: true
          };

          var myBaseString = quickPayLandingVm.vpaImage;
          var block = myBaseString.split(";");
          var dataType = block[0].split(":")[1];
          var myBase64 = block[1].split(",")[1];
          var displayTime = function () {
            var str = "";

            var currentTime = new Date();
            var hours = currentTime.getHours();
            var minutes = currentTime.getMinutes();
            var seconds = currentTime.getSeconds();

            if (minutes < 10) {
              minutes = "0" + minutes;
            }
            if (seconds < 10) {
              seconds = "0" + seconds;
            }
            str += hours + ":" + minutes + " ";
            if (hours > 11) {
              str += "PM";
            } else {
              str += "AM";
            }
            return str;
          };
          var contentType = "image/png";
          var folderpath = cordova.file.externalRootDirectory;
          var filename = "UPI ID - " + quickPayService.payeeVPA + ".png";
          quickPayLandingVm.savebase64AsImageFile(folderpath, filename, myBase64, contentType, share);
        } else {
          utilityService.showBhimUpiAlert("error", "Kindly select the UPI ID");
        }
      }
    }
    quickPayLandingVm.downloadOrShare = function (share) {
      if (share) {
        var options = {
          message: 'QR code - ', // not supported on some apps (i.e. Facebook, Instagram)
          subject: 'YONO QR Code : ' + quickPayService.payeeVPA, // Subject. for email
          files: [quickPayLandingVm.popupFolderpath], // an array of filenames either locally or remotely
          url: quickPayService.payeeVPA,
          chooserTitle: 'Share YONO QR code' // Android only, you can override the default share sheet title
        };

        var onSuccess = function (result) {
          console.log(result);
        };
        var onError = function (msg) {
          console.log(msg);
        }
        window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
      } else if (!share) {
        var message = 'QR code downloaded successfully.';
        quickPayService.showAlertPopup('success', message, '', '', 'OK', '', $scope);
      }
    }
    quickPayLandingVm.savebase64AsImageFile = function (folderpath, filename, content, contentType, share) {
      var DataBlob = quickPayLandingVm.b64toBlob(content, contentType);
      if (device.version == 10) {
        folderpath = cordova.file.externalDataDirectory;
        window.resolveLocalFileSystemURL(folderpath, function (dir) {
          quickPayLandingVm.popupFolderpath = dir.nativeURL + filename;
          dir.getFile(filename, { create: true }, function (file) {
            file.createWriter(function (fileWriter) {
              fileWriter.write(DataBlob);
              quickPayLandingVm.downloadOrShare(share);
            }, function () {
              utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
            });
          });
        });
      }
      else {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
          fileSystem.root.getDirectory("Download", { create: true, exclusive: false }, function (dir) {
            quickPayLandingVm.popupFolderpath = dir.nativeURL + filename;
            dir.getFile(filename, { create: true }, function (file) {
              file.createWriter(function (fileWriter) {
                fileWriter.write(DataBlob);
                quickPayLandingVm.downloadOrShare(share);
              }, function () {
                utilityService.showBhimUpiAlert("error", 'Unable to save file in path ' + folderpath);
              });
            });
          });
        });
      }
    };

    quickPayLandingVm.b64toBlob = function (b64Data, contentType, sliceSize) {
      contentType = contentType || '';
      sliceSize = sliceSize || 512;
      var byteCharacters = atob(b64Data);
      var byteArrays = [];

      //Check PDF SIZE
      if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
        utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
        return;
      }

      for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
        var slice = byteCharacters.slice(offset, offset + sliceSize);
        var byteNumbers = new Array(slice.length);
        for (var i = 0; i < slice.length; i++) {
          byteNumbers[i] = slice.charCodeAt(i);
        }
        var byteArray = new Uint8Array(byteNumbers);
        byteArrays.push(byteArray);
      }
      var blob = new Blob(byteArrays, { type: contentType });
      return blob;
    };

    quickPayLandingVm.getPendingRequestsViaAdapter = function () {
      quickPayService.pendingCallInitiated = true;
      quickPayService.showPendingError = false;
      quickPayService.pendingLists = [];
      quickPayService.getPendingCollectRequestList().then(function (data) {
        quickPayService.pendingCallInitiated = false;
        
        if (data) {
          if (data.recieveMoneyDetails) {
            quickPayService.pendingLists = [];
            for (var i = 0; i < data.recieveMoneyDetails.length; i++) {
              if (data.recieveMoneyDetails[i].dateTime) {
                var tempDate = moment(data.recieveMoneyDetails[i].dateTime, 'DD/MM/YYYY HH:mm:ss').format("YYYY/MM/DD hh:mm a");
                data.recieveMoneyDetails[i].dateTime = tempDate;
              }
              var temp = {
                "payeeName": data.recieveMoneyDetails[i].requesterName,
                "txnAmount": data.recieveMoneyDetails[i].amount,
                "reqDate": data.recieveMoneyDetails[i].dateTime,
                "txnNote": (data.recieveMoneyDetails[i].comment == null || data.recieveMoneyDetails[i].comment == undefined) ? "" : data.recieveMoneyDetails[i].comment,
                "requesterCifNo": data.recieveMoneyDetails[i].requesterCifNo,
                "status": data.recieveMoneyDetails[i].status,
                "receiverCifNo": data.recieveMoneyDetails[i].receiverCifNo,
                "receiverName": data.recieveMoneyDetails[i].receiverName,
                "payRequestId": data.recieveMoneyDetails[i].payRequestId,
                "mobileNo": data.recieveMoneyDetails[i].lastTransactionType == null ? "" : data.recieveMoneyDetails[i].lastTransactionType,
                "receiverPhnNumber": data.recieveMoneyDetails[i].phnNumber,
                "type": "contact"
              }
              quickPayService.pendingLists.push(temp);
              quickPayService.pendingLists = $filter('orderBy')(quickPayService.pendingLists, '-reqDate');
              quickPayService.pendingLists = $filter('limitTo')(quickPayService.pendingLists, 10);
              quickPayLandingVm.pendingLists = quickPayService.pendingLists;
            }
          }
          if (data.totalCollectReqCount) {
            quickPayService.receiveMoneyCount = data.totalCollectReqCount;
          }
          else {
            quickPayService.receiveMoneyCount = 0;
          }
          if (data.totalAmountRequest) {
            quickPayService.receiveMoneyAmountLimit = data.totalAmountRequest;
          }
          else {
            quickPayService.receiveMoneyAmountLimit = 0;
          }
        }
        quickPayLandingVm.pendingLists = quickPayService.pendingLists;
        if (!$rootScope.checkDeviceInfo || !quickPayLandingVm.getProfileResponse) {
          quickPayLandingVm.redirectToBhimUpi('pending');
        } else {
          quickPayLandingVm.getPendingRequestsViaSDK();
        }
      }, function (error) {
        quickPayService.pendingCallInitiated = false;
        if (!quickPayService.pendingLists && quickPayService.pendingLists.length <= 0)
          quickPayService.showPendingError = true;
        if (!$rootScope.checkDeviceInfo || !quickPayLandingVm.getProfileResponse) {
          quickPayLandingVm.redirectToBhimUpi('pending');
        } else {
          quickPayLandingVm.getPendingRequestsViaSDK();
        }
      });
    }
    quickPayLandingVm.getPendingRequestsViaSDK = function () {     
      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "updateFlag": constantConfig.upiConstant.updateFlag
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.getcollectList, json, "YQP").then(function (data) {
        var pendingRequestsResp = JSON.parse(data);
        utilityService.hideSpinner();       
        if (pendingRequestsResp.status == 'S') {

          if (pendingRequestsResp.collectList && pendingRequestsResp.collectList.length > 0) {
            quickPayService.pendingLists = [];
            for (var i = 0; i < pendingRequestsResp.collectList.length; i++) {
              if (pendingRequestsResp.collectList[i]) {
                pendingRequestsResp.collectList[i].type = 'vpa';
                quickPayService.pendingLists.push(pendingRequestsResp.collectList[i]);
              }
            }
            quickPayService.pendingLists = $filter('orderBy')(quickPayService.pendingLists, '-reqDate');
            quickPayService.pendingLists = $filter('limitTo')(quickPayService.pendingLists, 10);
            quickPayLandingVm.pendingLists = quickPayService.pendingLists;

          }


        } else {
          quickPayService.showPendingError = true;
          
        }
      }, function (msg) {
        quickPayService.showPendingError = true;
        
      });
    }
    quickPayLandingVm.generateQrImage = function () {
      var userName = quickPayService.customerInfo.customerInformation.customerName;
      userName = userName.replace(/[^a-zA-Z. ]/g, "");
      userName = userName.substring(0, 50);
      var amount = quickPayService.payToCollectScanData.amount ? quickPayService.payToCollectScanData.amount : "";
      var transactionNote = quickPayService.payToCollectScanData.remark ? quickPayService.payToCollectScanData.remark : "";
      var qrCodeGenerate = new QRious({
        element: document.getElementById('qrCanvasYQP'),
        value: "upi://pay?pa=" + quickPayService.payeeVPA + "&pn=" + userName + "&am=" + amount + "&tn=" + transactionNote,
        mime: 'image/png',
        size: 160
      });
      quickPayLandingVm.vpaImage = qrCodeGenerate.toDataURL('[mime type]');
    }
    window.addEventListener('native.keyboardshow', function () {
      document.body.classList.add('keyboard-open');
    });
    quickPayLandingVm.goToYonoHome = function () {
      $state.go('menu.homeScreen');
    }

    return this;
  }
]);


